#include <tree_sitter/parser.h>

#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"

#define LANGUAGE_VERSION 3
#define STATE_COUNT 1466
#define SYMBOL_COUNT 115
#define TOKEN_COUNT 73
#define EXTERNAL_TOKEN_COUNT 9
#define MAX_RENAME_SEQUENCE_LENGTH 7

enum {
  sym__simple_heredoc = 1,
  sym__heredoc_beginning = 2,
  sym__heredoc_middle = 3,
  sym__heredoc_end = 4,
  sym_file_descriptor = 5,
  sym__empty_value = 6,
  sym__concat = 7,
  sym_variable_name = 8,
  anon_sym_for = 9,
  anon_sym_in = 10,
  anon_sym_while = 11,
  anon_sym_do = 12,
  anon_sym_done = 13,
  anon_sym_if = 14,
  anon_sym_then = 15,
  anon_sym_fi = 16,
  anon_sym_elif = 17,
  anon_sym_else = 18,
  anon_sym_case = 19,
  anon_sym_esac = 20,
  anon_sym_PIPE = 21,
  anon_sym_RPAREN = 22,
  anon_sym_SEMI_SEMI = 23,
  anon_sym_function = 24,
  anon_sym_LPAREN = 25,
  anon_sym_LBRACE = 26,
  anon_sym_RBRACE = 27,
  anon_sym_PIPE_AMP = 28,
  anon_sym_AMP_AMP = 29,
  anon_sym_PIPE_PIPE = 30,
  anon_sym_LBRACK = 31,
  anon_sym_RBRACK = 32,
  anon_sym_LBRACK_LBRACK = 33,
  anon_sym_RBRACK_RBRACK = 34,
  anon_sym_EQ = 35,
  anon_sym_LT = 36,
  anon_sym_GT = 37,
  anon_sym_GT_GT = 38,
  anon_sym_AMP_GT = 39,
  anon_sym_AMP_GT_GT = 40,
  anon_sym_LT_AMP = 41,
  anon_sym_GT_AMP = 42,
  anon_sym_LT_LT = 43,
  anon_sym_LT_LT_DASH = 44,
  anon_sym_DQUOTE = 45,
  aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH = 46,
  sym_raw_string = 47,
  anon_sym_DOLLAR = 48,
  anon_sym_DOLLAR_LBRACE = 49,
  anon_sym_POUND = 50,
  anon_sym_AT = 51,
  anon_sym_COLON = 52,
  anon_sym_COLON_QMARK = 53,
  anon_sym_COLON_DASH = 54,
  anon_sym_PERCENT = 55,
  anon_sym_SLASH = 56,
  anon_sym_DOLLAR_LPAREN = 57,
  anon_sym_BQUOTE = 58,
  anon_sym_LT_LPAREN = 59,
  anon_sym_GT_LPAREN = 60,
  sym_word = 61,
  sym_comment = 62,
  sym_simple_variable_name = 63,
  anon_sym_STAR = 64,
  anon_sym_QMARK = 65,
  anon_sym_DASH = 66,
  anon_sym_BANG = 67,
  anon_sym_0 = 68,
  anon_sym__ = 69,
  anon_sym_SEMI = 70,
  anon_sym_LF = 71,
  anon_sym_AMP = 72,
  sym_program = 73,
  sym__terminated_statement = 74,
  sym_for_statement = 75,
  sym_while_statement = 76,
  sym_do_group = 77,
  sym_if_statement = 78,
  sym_elif_clause = 79,
  sym_else_clause = 80,
  sym_case_statement = 81,
  sym_case_item = 82,
  sym_function_definition = 83,
  sym_compound_statement = 84,
  sym_subshell = 85,
  sym_pipeline = 86,
  sym_list = 87,
  sym_bracket_command = 88,
  sym_command = 89,
  sym_command_name = 90,
  sym_environment_variable_assignment = 91,
  sym_subscript = 92,
  sym_file_redirect = 93,
  sym_heredoc_redirect = 94,
  sym_heredoc = 95,
  sym_concatenation = 96,
  sym_string = 97,
  sym_array = 98,
  sym_simple_expansion = 99,
  sym_expansion = 100,
  sym_command_substitution = 101,
  sym_process_substitution = 102,
  sym_special_variable_name = 103,
  aux_sym_program_repeat1 = 104,
  aux_sym_for_statement_repeat1 = 105,
  aux_sym_if_statement_repeat1 = 106,
  aux_sym_case_statement_repeat1 = 107,
  aux_sym_case_item_repeat1 = 108,
  aux_sym_command_repeat1 = 109,
  aux_sym_command_repeat2 = 110,
  aux_sym_heredoc_repeat1 = 111,
  aux_sym_concatenation_repeat1 = 112,
  aux_sym_string_repeat1 = 113,
  aux_sym_array_repeat1 = 114,
  rename_sym_1 = 115,
  rename_sym_variable_name = 116,
};

static const char *ts_symbol_names[] = {
  [sym__simple_heredoc] = "_simple_heredoc",
  [sym__heredoc_beginning] = "_heredoc_beginning",
  [sym__heredoc_middle] = "_heredoc_middle",
  [sym__heredoc_end] = "_heredoc_end",
  [sym_file_descriptor] = "file_descriptor",
  [sym__empty_value] = "_empty_value",
  [sym__concat] = "_concat",
  [sym_variable_name] = "variable_name",
  [ts_builtin_sym_end] = "END",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_done] = "done",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_fi] = "fi",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_case] = "case",
  [anon_sym_esac] = "esac",
  [anon_sym_PIPE] = "|",
  [anon_sym_RPAREN] = ")",
  [anon_sym_SEMI_SEMI] = ";;",
  [anon_sym_function] = "function",
  [anon_sym_LPAREN] = "(",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_PIPE_AMP] = "|&",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym_EQ] = "=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AMP_GT] = "&>",
  [anon_sym_AMP_GT_GT] = "&>>",
  [anon_sym_LT_AMP] = "<&",
  [anon_sym_GT_AMP] = ">&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_LT_LT_DASH] = "<<-",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = "/[^\"`$]+/",
  [sym_raw_string] = "raw_string",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_POUND] = "#",
  [anon_sym_AT] = "@",
  [anon_sym_COLON] = ":",
  [anon_sym_COLON_QMARK] = ":?",
  [anon_sym_COLON_DASH] = ":-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_SLASH] = "/",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_LT_LPAREN] = "<(",
  [anon_sym_GT_LPAREN] = ">(",
  [sym_word] = "word",
  [sym_comment] = "comment",
  [sym_simple_variable_name] = "simple_variable_name",
  [anon_sym_STAR] = "*",
  [anon_sym_QMARK] = "?",
  [anon_sym_DASH] = "-",
  [anon_sym_BANG] = "!",
  [anon_sym_0] = "0",
  [anon_sym__] = "_",
  [anon_sym_SEMI] = ";",
  [anon_sym_LF] = "\n",
  [anon_sym_AMP] = "&",
  [sym_program] = "program",
  [sym__terminated_statement] = "_terminated_statement",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_group] = "do_group",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_case_statement] = "case_statement",
  [sym_case_item] = "case_item",
  [sym_function_definition] = "function_definition",
  [sym_compound_statement] = "compound_statement",
  [sym_subshell] = "subshell",
  [sym_pipeline] = "pipeline",
  [sym_list] = "list",
  [sym_bracket_command] = "bracket_command",
  [sym_command] = "command",
  [sym_command_name] = "command_name",
  [sym_environment_variable_assignment] = "environment_variable_assignment",
  [sym_subscript] = "subscript",
  [sym_file_redirect] = "file_redirect",
  [sym_heredoc_redirect] = "heredoc_redirect",
  [sym_heredoc] = "heredoc",
  [sym_concatenation] = "concatenation",
  [sym_string] = "string",
  [sym_array] = "array",
  [sym_simple_expansion] = "simple_expansion",
  [sym_expansion] = "expansion",
  [sym_command_substitution] = "command_substitution",
  [sym_process_substitution] = "process_substitution",
  [sym_special_variable_name] = "special_variable_name",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_case_item_repeat1] = "case_item_repeat1",
  [aux_sym_command_repeat1] = "command_repeat1",
  [aux_sym_command_repeat2] = "command_repeat2",
  [aux_sym_heredoc_repeat1] = "heredoc_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [rename_sym_1] = "",
  [rename_sym_variable_name] = "variable_name",
};

static const TSSymbolMetadata ts_symbol_metadata[SYMBOL_COUNT] = {
  [sym__simple_heredoc] = {
    .visible = false,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym__heredoc_beginning] = {
    .visible = false,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym__heredoc_middle] = {
    .visible = false,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym__heredoc_end] = {
    .visible = false,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_file_descriptor] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym__empty_value] = {
    .visible = false,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_variable_name] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_done] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_fi] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_esac] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_SEMI_SEMI] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_PIPE_AMP] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_AMP_GT] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_AMP_GT_GT] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_LT_AMP] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_GT_AMP] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_LT_LT_DASH] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = {
    .visible = false,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [sym_raw_string] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_COLON_QMARK] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_COLON_DASH] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_LT_LPAREN] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_GT_LPAREN] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [sym_word] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
    .structural = false,
    .extra = true,
  },
  [sym_simple_variable_name] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym__terminated_statement] = {
    .visible = false,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_do_group] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_case_item] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_pipeline] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_bracket_command] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_command_name] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_environment_variable_assignment] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_file_redirect] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_heredoc_redirect] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_heredoc] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_simple_expansion] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_expansion] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_command_substitution] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_process_substitution] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [sym_special_variable_name] = {
    .visible = true,
    .named = true,
    .structural = true,
    .extra = false,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [aux_sym_case_item_repeat1] = {
    .visible = false,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [aux_sym_command_repeat1] = {
    .visible = false,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [aux_sym_command_repeat2] = {
    .visible = false,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [aux_sym_heredoc_repeat1] = {
    .visible = false,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
    .structural = true,
    .extra = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
    .structural = true,
    .extra = false,
  },
};

static TSSymbol ts_rename_sequences[7][MAX_RENAME_SEQUENCE_LENGTH] = {
  [1] = {
    [1] = rename_sym_variable_name,
  },
  [2] = {
    [1] = rename_sym_variable_name,
  },
  [3] = {
    [2] = rename_sym_variable_name,
  },
  [4] = {
    [1] = rename_sym_variable_name,
  },
  [5] = {
    [1] = rename_sym_variable_name,
  },
  [6] = {
    [2] = rename_sym_variable_name,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '*')
        ADVANCE(12);
      if (lookahead == '-')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(23);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '?')
        ADVANCE(28);
      if (lookahead == '@')
        ADVANCE(29);
      if (lookahead == '[')
        ADVANCE(30);
      if (lookahead == '\\')
        SKIP(31);
      if (lookahead == ']')
        ADVANCE(32);
      if (lookahead == '_')
        ADVANCE(34);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == 'c')
        ADVANCE(36);
      if (lookahead == 'd')
        ADVANCE(40);
      if (lookahead == 'e')
        ADVANCE(44);
      if (lookahead == 'f')
        ADVANCE(53);
      if (lookahead == 'i')
        ADVANCE(64);
      if (lookahead == 't')
        ADVANCE(67);
      if (lookahead == 'w')
        ADVANCE(71);
      if (lookahead == '{')
        ADVANCE(76);
      if (lookahead == '|')
        ADVANCE(77);
      if (lookahead == '}')
        ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 8:
      if (lookahead == '\'')
        ADVANCE(9);
      if (lookahead != 0)
        ADVANCE(8);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(sym_raw_string);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_0);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(17);
      if (lookahead == '?')
        ADVANCE(18);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(21);
      if (lookahead == '(')
        ADVANCE(22);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_LT_AMP);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_LT_LPAREN);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(25);
      if (lookahead == '(')
        ADVANCE(26);
      if (lookahead == '>')
        ADVANCE(27);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_GT_AMP);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_GT_LPAREN);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 31:
      if (lookahead == '\n')
        SKIP(0);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == ']')
        ADVANCE(33);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 36:
      if (lookahead == 'a')
        ADVANCE(37);
      END_STATE();
    case 37:
      if (lookahead == 's')
        ADVANCE(38);
      END_STATE();
    case 38:
      if (lookahead == 'e')
        ADVANCE(39);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 40:
      if (lookahead == 'o')
        ADVANCE(41);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'n')
        ADVANCE(42);
      END_STATE();
    case 42:
      if (lookahead == 'e')
        ADVANCE(43);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_done);
      END_STATE();
    case 44:
      if (lookahead == 'l')
        ADVANCE(45);
      if (lookahead == 's')
        ADVANCE(50);
      END_STATE();
    case 45:
      if (lookahead == 'i')
        ADVANCE(46);
      if (lookahead == 's')
        ADVANCE(48);
      END_STATE();
    case 46:
      if (lookahead == 'f')
        ADVANCE(47);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 48:
      if (lookahead == 'e')
        ADVANCE(49);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 50:
      if (lookahead == 'a')
        ADVANCE(51);
      END_STATE();
    case 51:
      if (lookahead == 'c')
        ADVANCE(52);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_esac);
      END_STATE();
    case 53:
      if (lookahead == 'i')
        ADVANCE(54);
      if (lookahead == 'o')
        ADVANCE(55);
      if (lookahead == 'u')
        ADVANCE(57);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_fi);
      END_STATE();
    case 55:
      if (lookahead == 'r')
        ADVANCE(56);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 57:
      if (lookahead == 'n')
        ADVANCE(58);
      END_STATE();
    case 58:
      if (lookahead == 'c')
        ADVANCE(59);
      END_STATE();
    case 59:
      if (lookahead == 't')
        ADVANCE(60);
      END_STATE();
    case 60:
      if (lookahead == 'i')
        ADVANCE(61);
      END_STATE();
    case 61:
      if (lookahead == 'o')
        ADVANCE(62);
      END_STATE();
    case 62:
      if (lookahead == 'n')
        ADVANCE(63);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 64:
      if (lookahead == 'f')
        ADVANCE(65);
      if (lookahead == 'n')
        ADVANCE(66);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 67:
      if (lookahead == 'h')
        ADVANCE(68);
      END_STATE();
    case 68:
      if (lookahead == 'e')
        ADVANCE(69);
      END_STATE();
    case 69:
      if (lookahead == 'n')
        ADVANCE(70);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 71:
      if (lookahead == 'h')
        ADVANCE(72);
      END_STATE();
    case 72:
      if (lookahead == 'i')
        ADVANCE(73);
      END_STATE();
    case 73:
      if (lookahead == 'l')
        ADVANCE(74);
      END_STATE();
    case 74:
      if (lookahead == 'e')
        ADVANCE(75);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 79:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(84);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(91);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'f')
        ADVANCE(96);
      if (lookahead == 'i')
        ADVANCE(106);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(79);
      if ((lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(80);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(82);
      if (lookahead == '{')
        ADVANCE(83);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 84:
      if (lookahead == '>')
        ADVANCE(85);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_AMP_GT);
      if (lookahead == '>')
        ADVANCE(86);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_AMP_GT_GT);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[')
        ADVANCE(88);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 89:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 91:
      if (lookahead == '\n')
        SKIP(79);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'a')
        ADVANCE(93);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != 'a' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 's')
        ADVANCE(94);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'e')
        ADVANCE(95);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_case);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'o')
        ADVANCE(97);
      if (lookahead == 'u')
        ADVANCE(99);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'r')
        ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'n')
        ADVANCE(100);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'c')
        ADVANCE(101);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 't')
        ADVANCE(102);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'i')
        ADVANCE(103);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'o')
        ADVANCE(104);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'n')
        ADVANCE(105);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_function);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'f')
        ADVANCE(107);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_if);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'h')
        ADVANCE(109);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'i')
        ADVANCE(110);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'l')
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'e')
        ADVANCE(112);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_while);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 113:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(84);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '\\')
        SKIP(116);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(113);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(21);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(25);
      if (lookahead == '>')
        ADVANCE(27);
      END_STATE();
    case 116:
      if (lookahead == '\n')
        SKIP(113);
      END_STATE();
    case 117:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '=')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(30);
      if (lookahead == '\\')
        SKIP(118);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(117);
      END_STATE();
    case 118:
      if (lookahead == '\n')
        SKIP(117);
      END_STATE();
    case 119:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '\\')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(119);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 120:
      if (lookahead == '\n')
        SKIP(119);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 121:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(84);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(122);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'f')
        ADVANCE(96);
      if (lookahead == 'i')
        ADVANCE(106);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(121);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 122:
      if (lookahead == '\n')
        SKIP(121);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 123:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '<')
        ADVANCE(124);
      if (lookahead == '>')
        ADVANCE(125);
      if (lookahead == '\\')
        ADVANCE(126);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(123);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 124:
      if (lookahead == '(')
        ADVANCE(22);
      END_STATE();
    case 125:
      if (lookahead == '(')
        ADVANCE(26);
      END_STATE();
    case 126:
      if (lookahead == '\n')
        SKIP(123);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 127:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(128);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '\\')
        ADVANCE(130);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(131);
      if (lookahead != 0)
        ADVANCE(129);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(129);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(128);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(129);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(131);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(129);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '#')
        ADVANCE(128);
      if (lookahead == '\\')
        ADVANCE(130);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(131);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(129);
      END_STATE();
    case 132:
      if (lookahead == '\n')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(134);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == ';')
        ADVANCE(136);
      if (lookahead == '<')
        ADVANCE(138);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '\\')
        ADVANCE(141);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '|')
        ADVANCE(142);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(132);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(90);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '>')
        ADVANCE(85);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (lookahead == ';')
        ADVANCE(137);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_SEMI_SEMI);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(21);
      if (lookahead == '(')
        ADVANCE(22);
      if (lookahead == '<')
        ADVANCE(139);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '-')
        ADVANCE(140);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      END_STATE();
    case 141:
      if (lookahead == '\n')
        SKIP(132);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == '|')
        ADVANCE(144);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(90);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_PIPE_AMP);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 145:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '*')
        ADVANCE(12);
      if (lookahead == '-')
        ADVANCE(13);
      if (lookahead == '0')
        ADVANCE(146);
      if (lookahead == '?')
        ADVANCE(28);
      if (lookahead == '@')
        ADVANCE(29);
      if (lookahead == '\\')
        SKIP(148);
      if (lookahead == '_')
        ADVANCE(149);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(145);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(147);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(147);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_simple_variable_name);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(147);
      END_STATE();
    case 148:
      if (lookahead == '\n')
        SKIP(145);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(147);
      END_STATE();
    case 150:
      if (lookahead == '\n')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(134);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == ';')
        ADVANCE(136);
      if (lookahead == '<')
        ADVANCE(138);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '\\')
        ADVANCE(151);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '|')
        ADVANCE(142);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(150);
      if (lookahead != 0 &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(90);
      END_STATE();
    case 151:
      if (lookahead == '\n')
        SKIP(150);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 152:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '\\')
        SKIP(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(152);
      END_STATE();
    case 153:
      if (lookahead == '\n')
        SKIP(152);
      END_STATE();
    case 154:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(84);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ';')
        ADVANCE(155);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(156);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(157);
      if (lookahead == 'e')
        ADVANCE(161);
      if (lookahead == 'f')
        ADVANCE(167);
      if (lookahead == 'i')
        ADVANCE(106);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '}')
        ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(154);
      if ((lookahead < '&' || lookahead > ')') &&
          lookahead != '{')
        ADVANCE(90);
      END_STATE();
    case 155:
      if (lookahead == ';')
        ADVANCE(137);
      END_STATE();
    case 156:
      if (lookahead == '\n')
        SKIP(154);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'o')
        ADVANCE(158);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'n')
        ADVANCE(159);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'e')
        ADVANCE(160);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_done);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'l')
        ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'i')
        ADVANCE(163);
      if (lookahead == 's')
        ADVANCE(165);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'f')
        ADVANCE(164);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_elif);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'e')
        ADVANCE(166);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'i')
        ADVANCE(168);
      if (lookahead == 'o')
        ADVANCE(97);
      if (lookahead == 'u')
        ADVANCE(99);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_fi);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 169:
      if (lookahead == '\n')
        ADVANCE(133);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(170);
      if (lookahead == ';')
        ADVANCE(136);
      if (lookahead == '\\')
        SKIP(171);
      if (lookahead == '|')
        ADVANCE(172);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(169);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(135);
      END_STATE();
    case 171:
      if (lookahead == '\n')
        SKIP(169);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(143);
      if (lookahead == '|')
        ADVANCE(173);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 174:
      if (lookahead == '\n')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(134);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ';')
        ADVANCE(136);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '\\')
        ADVANCE(175);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '|')
        ADVANCE(142);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(174);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(90);
      END_STATE();
    case 175:
      if (lookahead == '\n')
        SKIP(174);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 176:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '=')
        ADVANCE(23);
      if (lookahead == '\\')
        SKIP(177);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(176);
      END_STATE();
    case 177:
      if (lookahead == '\n')
        SKIP(176);
      END_STATE();
    case 178:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(84);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '\\')
        ADVANCE(179);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(178);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 179:
      if (lookahead == '\n')
        SKIP(178);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 180:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '<')
        ADVANCE(124);
      if (lookahead == '>')
        ADVANCE(125);
      if (lookahead == '\\')
        ADVANCE(181);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(180);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 181:
      if (lookahead == '\n')
        SKIP(180);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 182:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '\\')
        SKIP(183);
      if (lookahead == 'i')
        ADVANCE(184);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(182);
      END_STATE();
    case 183:
      if (lookahead == '\n')
        SKIP(182);
      END_STATE();
    case 184:
      if (lookahead == 'n')
        ADVANCE(66);
      END_STATE();
    case 185:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '\\')
        SKIP(186);
      if (lookahead == 'd')
        ADVANCE(187);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(185);
      END_STATE();
    case 186:
      if (lookahead == '\n')
        SKIP(185);
      END_STATE();
    case 187:
      if (lookahead == 'o')
        ADVANCE(188);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 189:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '\\')
        SKIP(190);
      if (lookahead == 't')
        ADVANCE(67);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(189);
      END_STATE();
    case 190:
      if (lookahead == '\n')
        SKIP(189);
      END_STATE();
    case 191:
      if (lookahead == '\n')
        ADVANCE(133);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == ';')
        ADVANCE(136);
      if (lookahead == '\\')
        SKIP(192);
      if (lookahead == 'i')
        ADVANCE(184);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(191);
      END_STATE();
    case 192:
      if (lookahead == '\n')
        SKIP(191);
      END_STATE();
    case 193:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '\\')
        SKIP(194);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(193);
      END_STATE();
    case 194:
      if (lookahead == '\n')
        SKIP(193);
      END_STATE();
    case 195:
      if (lookahead == '\n')
        ADVANCE(133);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(170);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == ';')
        ADVANCE(136);
      if (lookahead == '\\')
        SKIP(196);
      if (lookahead == '|')
        ADVANCE(172);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(195);
      END_STATE();
    case 196:
      if (lookahead == '\n')
        SKIP(195);
      END_STATE();
    case 197:
      if (lookahead == '\n')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(134);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == ';')
        ADVANCE(136);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '\\')
        ADVANCE(198);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '|')
        ADVANCE(142);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(197);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(90);
      END_STATE();
    case 198:
      if (lookahead == '\n')
        SKIP(197);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 199:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '<')
        ADVANCE(124);
      if (lookahead == '>')
        ADVANCE(125);
      if (lookahead == '\\')
        ADVANCE(200);
      if (lookahead == ']')
        ADVANCE(201);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(199);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 200:
      if (lookahead == '\n')
        SKIP(199);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == ']')
        ADVANCE(202);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 203:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '<')
        ADVANCE(124);
      if (lookahead == '>')
        ADVANCE(125);
      if (lookahead == '\\')
        ADVANCE(204);
      if (lookahead == ']')
        ADVANCE(205);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(203);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 204:
      if (lookahead == '\n')
        SKIP(203);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 206:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '<')
        ADVANCE(124);
      if (lookahead == '>')
        ADVANCE(125);
      if (lookahead == '\\')
        ADVANCE(207);
      if (lookahead == ']')
        ADVANCE(208);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(206);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 207:
      if (lookahead == '\n')
        SKIP(206);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == ']')
        ADVANCE(202);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 209:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == '=')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(30);
      if (lookahead == '\\')
        SKIP(210);
      if (lookahead == '}')
        ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(209);
      END_STATE();
    case 210:
      if (lookahead == '\n')
        SKIP(209);
      END_STATE();
    case 211:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '*')
        ADVANCE(12);
      if (lookahead == '-')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(146);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == '=')
        ADVANCE(23);
      if (lookahead == '?')
        ADVANCE(28);
      if (lookahead == '@')
        ADVANCE(29);
      if (lookahead == '[')
        ADVANCE(30);
      if (lookahead == '\\')
        SKIP(212);
      if (lookahead == '_')
        ADVANCE(149);
      if (lookahead == '}')
        ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(211);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(147);
      END_STATE();
    case 212:
      if (lookahead == '\n')
        SKIP(211);
      END_STATE();
    case 213:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(214);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '<')
        ADVANCE(138);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '\\')
        ADVANCE(215);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '|')
        ADVANCE(142);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(213);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(90);
      END_STATE();
    case 214:
      if (lookahead == '&')
        ADVANCE(135);
      if (lookahead == '>')
        ADVANCE(85);
      END_STATE();
    case 215:
      if (lookahead == '\n')
        SKIP(213);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 216:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(214);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '<')
        ADVANCE(138);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '\\')
        ADVANCE(217);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '|')
        ADVANCE(142);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(216);
      if (lookahead != 0 &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(90);
      END_STATE();
    case 217:
      if (lookahead == '\n')
        SKIP(216);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 218:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(219);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '\\')
        SKIP(220);
      if (lookahead == '|')
        ADVANCE(172);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(218);
      END_STATE();
    case 219:
      if (lookahead == '&')
        ADVANCE(135);
      END_STATE();
    case 220:
      if (lookahead == '\n')
        SKIP(218);
      END_STATE();
    case 221:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(214);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '\\')
        ADVANCE(222);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '|')
        ADVANCE(142);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(221);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(90);
      END_STATE();
    case 222:
      if (lookahead == '\n')
        SKIP(221);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 223:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(219);
      if (lookahead == '\\')
        SKIP(224);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '|')
        ADVANCE(172);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(223);
      END_STATE();
    case 224:
      if (lookahead == '\n')
        SKIP(223);
      END_STATE();
    case 225:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(214);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '<')
        ADVANCE(138);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '\\')
        ADVANCE(226);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '|')
        ADVANCE(142);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(225);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(90);
      END_STATE();
    case 226:
      if (lookahead == '\n')
        SKIP(225);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 227:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(214);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '\\')
        ADVANCE(228);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '|')
        ADVANCE(142);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(227);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(90);
      END_STATE();
    case 228:
      if (lookahead == '\n')
        SKIP(227);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 229:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '\\')
        SKIP(230);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(229);
      END_STATE();
    case 230:
      if (lookahead == '\n')
        SKIP(229);
      END_STATE();
    case 231:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '\\')
        SKIP(232);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(231);
      END_STATE();
    case 232:
      if (lookahead == '\n')
        SKIP(231);
      END_STATE();
    case 233:
      if (lookahead == '\n')
        ADVANCE(133);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(134);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == ';')
        ADVANCE(136);
      if (lookahead == '<')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '\\')
        SKIP(235);
      if (lookahead == '|')
        ADVANCE(172);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(233);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(21);
      if (lookahead == '<')
        ADVANCE(139);
      END_STATE();
    case 235:
      if (lookahead == '\n')
        SKIP(233);
      END_STATE();
    case 236:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '\\')
        SKIP(237);
      if (lookahead == ']')
        ADVANCE(238);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(236);
      END_STATE();
    case 237:
      if (lookahead == '\n')
        SKIP(236);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 239:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '\\')
        ADVANCE(240);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(239);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 240:
      if (lookahead == '\n')
        SKIP(239);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 241:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(84);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(242);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(157);
      if (lookahead == 'f')
        ADVANCE(96);
      if (lookahead == 'i')
        ADVANCE(106);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(241);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 242:
      if (lookahead == '\n')
        SKIP(241);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 243:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '\\')
        SKIP(244);
      if (lookahead == 'd')
        ADVANCE(187);
      if (lookahead == 't')
        ADVANCE(67);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(243);
      END_STATE();
    case 244:
      if (lookahead == '\n')
        SKIP(243);
      END_STATE();
    case 245:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(84);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(246);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'e')
        ADVANCE(161);
      if (lookahead == 'f')
        ADVANCE(167);
      if (lookahead == 'i')
        ADVANCE(106);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(245);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 246:
      if (lookahead == '\n')
        SKIP(245);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 247:
      if (lookahead == '\n')
        ADVANCE(133);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == ';')
        ADVANCE(136);
      if (lookahead == '\\')
        SKIP(248);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(247);
      END_STATE();
    case 248:
      if (lookahead == '\n')
        SKIP(247);
      END_STATE();
    case 249:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(84);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(250);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'f')
        ADVANCE(96);
      if (lookahead == 'i')
        ADVANCE(106);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(249);
      if (lookahead != 0 &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 250:
      if (lookahead == '\n')
        SKIP(249);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 251:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '<')
        ADVANCE(124);
      if (lookahead == '>')
        ADVANCE(125);
      if (lookahead == '\\')
        ADVANCE(252);
      if (lookahead == ']')
        ADVANCE(201);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '}')
        ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(251);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{')
        ADVANCE(90);
      END_STATE();
    case 252:
      if (lookahead == '\n')
        SKIP(251);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 253:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(30);
      if (lookahead == '\\')
        SKIP(254);
      if (lookahead == '}')
        ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(253);
      END_STATE();
    case 254:
      if (lookahead == '\n')
        SKIP(253);
      END_STATE();
    case 255:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '@')
        ADVANCE(29);
      if (lookahead == '\\')
        SKIP(256);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(255);
      END_STATE();
    case 256:
      if (lookahead == '\n')
        SKIP(255);
      END_STATE();
    case 257:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(214);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '<')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '\\')
        SKIP(258);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '|')
        ADVANCE(172);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(257);
      END_STATE();
    case 258:
      if (lookahead == '\n')
        SKIP(257);
      END_STATE();
    case 259:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '\\')
        SKIP(260);
      if (lookahead == '{')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(259);
      END_STATE();
    case 260:
      if (lookahead == '\n')
        SKIP(259);
      END_STATE();
    case 261:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(262);
      if (lookahead == '\\')
        SKIP(263);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(261);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '{')
        ADVANCE(83);
      END_STATE();
    case 263:
      if (lookahead == '\n')
        SKIP(261);
      END_STATE();
    case 264:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '\\')
        SKIP(265);
      if (lookahead == ']')
        ADVANCE(238);
      if (lookahead == '|')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(264);
      END_STATE();
    case 265:
      if (lookahead == '\n')
        SKIP(264);
      END_STATE();
    case 266:
      if (lookahead == '\n')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ';')
        ADVANCE(136);
      if (lookahead == '<')
        ADVANCE(124);
      if (lookahead == '>')
        ADVANCE(125);
      if (lookahead == '\\')
        ADVANCE(267);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(266);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 267:
      if (lookahead == '\n')
        SKIP(266);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 268:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(84);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(269);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'f')
        ADVANCE(167);
      if (lookahead == 'i')
        ADVANCE(106);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(268);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 269:
      if (lookahead == '\n')
        SKIP(268);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 270:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '\\')
        SKIP(271);
      if (lookahead == 'e')
        ADVANCE(272);
      if (lookahead == 'f')
        ADVANCE(273);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(270);
      END_STATE();
    case 271:
      if (lookahead == '\n')
        SKIP(270);
      END_STATE();
    case 272:
      if (lookahead == 'l')
        ADVANCE(45);
      END_STATE();
    case 273:
      if (lookahead == 'i')
        ADVANCE(54);
      END_STATE();
    case 274:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '\\')
        SKIP(275);
      if (lookahead == 'f')
        ADVANCE(273);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(274);
      END_STATE();
    case 275:
      if (lookahead == '\n')
        SKIP(274);
      END_STATE();
    case 276:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '<')
        ADVANCE(124);
      if (lookahead == '>')
        ADVANCE(125);
      if (lookahead == '\\')
        ADVANCE(277);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == 'e')
        ADVANCE(278);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(276);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 277:
      if (lookahead == '\n')
        SKIP(276);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 's')
        ADVANCE(279);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'a')
        ADVANCE(280);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != 'a' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'c')
        ADVANCE(281);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 282:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '\\')
        SKIP(283);
      if (lookahead == '}')
        ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(282);
      END_STATE();
    case 283:
      if (lookahead == '\n')
        SKIP(282);
      END_STATE();
    case 284:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(219);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '\\')
        SKIP(285);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '|')
        ADVANCE(172);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(284);
      END_STATE();
    case 285:
      if (lookahead == '\n')
        SKIP(284);
      END_STATE();
    case 286:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(84);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(287);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'f')
        ADVANCE(96);
      if (lookahead == 'i')
        ADVANCE(106);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '}')
        ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(286);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{')
        ADVANCE(90);
      END_STATE();
    case 287:
      if (lookahead == '\n')
        SKIP(286);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 288:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '\\')
        SKIP(289);
      if (lookahead == '|')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(288);
      END_STATE();
    case 289:
      if (lookahead == '\n')
        SKIP(288);
      END_STATE();
    case 290:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(84);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ';')
        ADVANCE(155);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(291);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'f')
        ADVANCE(96);
      if (lookahead == 'i')
        ADVANCE(106);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(290);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 291:
      if (lookahead == '\n')
        SKIP(290);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 292:
      if (lookahead == '\n')
        ADVANCE(133);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(170);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == ';')
        ADVANCE(136);
      if (lookahead == '\\')
        SKIP(293);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '|')
        ADVANCE(172);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(292);
      END_STATE();
    case 293:
      if (lookahead == '\n')
        SKIP(292);
      END_STATE();
    case 294:
      if (lookahead == '\n')
        ADVANCE(295);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(128);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(296);
      if (lookahead == '\'')
        ADVANCE(300);
      if (lookahead == '(')
        ADVANCE(301);
      if (lookahead == ')')
        ADVANCE(302);
      if (lookahead == ';')
        ADVANCE(303);
      if (lookahead == '<')
        ADVANCE(305);
      if (lookahead == '>')
        ADVANCE(310);
      if (lookahead == '[')
        ADVANCE(314);
      if (lookahead == '\\')
        ADVANCE(318);
      if (lookahead == ']')
        ADVANCE(320);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == 'c')
        ADVANCE(322);
      if (lookahead == 'f')
        ADVANCE(326);
      if (lookahead == 'i')
        ADVANCE(336);
      if (lookahead == 'w')
        ADVANCE(339);
      if (lookahead == '{')
        ADVANCE(344);
      if (lookahead == '|')
        ADVANCE(345);
      if (lookahead == '}')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(319);
      if (lookahead != 0)
        ADVANCE(317);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(295);
      if (lookahead == '#')
        ADVANCE(128);
      if (lookahead == '&')
        ADVANCE(296);
      if (lookahead == '\'')
        ADVANCE(300);
      if (lookahead == '(')
        ADVANCE(301);
      if (lookahead == ')')
        ADVANCE(302);
      if (lookahead == ';')
        ADVANCE(303);
      if (lookahead == '<')
        ADVANCE(305);
      if (lookahead == '>')
        ADVANCE(310);
      if (lookahead == '[')
        ADVANCE(314);
      if (lookahead == '\\')
        ADVANCE(318);
      if (lookahead == ']')
        ADVANCE(320);
      if (lookahead == 'c')
        ADVANCE(322);
      if (lookahead == 'f')
        ADVANCE(326);
      if (lookahead == 'i')
        ADVANCE(336);
      if (lookahead == 'w')
        ADVANCE(339);
      if (lookahead == '{')
        ADVANCE(344);
      if (lookahead == '|')
        ADVANCE(345);
      if (lookahead == '}')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(319);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(297);
      if (lookahead == '>')
        ADVANCE(298);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(129);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(129);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_AMP_GT);
      if (lookahead == '>')
        ADVANCE(299);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(129);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_AMP_GT_GT);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(129);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\'')
        ADVANCE(129);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(8);
      if (lookahead != 0)
        ADVANCE(300);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(129);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(129);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (lookahead == ';')
        ADVANCE(304);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(129);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_SEMI_SEMI);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(129);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(306);
      if (lookahead == '(')
        ADVANCE(307);
      if (lookahead == '<')
        ADVANCE(308);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(129);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(anon_sym_LT_AMP);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(129);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_LT_LPAREN);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(129);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '-')
        ADVANCE(309);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(129);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(129);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(311);
      if (lookahead == '(')
        ADVANCE(312);
      if (lookahead == '>')
        ADVANCE(313);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(129);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_GT_AMP);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(129);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_GT_LPAREN);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(129);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(129);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[')
        ADVANCE(315);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(90);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(129);
      if (lookahead != 0)
        ADVANCE(317);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(319);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(129);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(90);
      if (lookahead != 0)
        ADVANCE(317);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(295);
      if (lookahead == '#')
        ADVANCE(128);
      if (lookahead == '&')
        ADVANCE(296);
      if (lookahead == '\'')
        ADVANCE(300);
      if (lookahead == '(')
        ADVANCE(301);
      if (lookahead == ')')
        ADVANCE(302);
      if (lookahead == ';')
        ADVANCE(303);
      if (lookahead == '<')
        ADVANCE(305);
      if (lookahead == '>')
        ADVANCE(310);
      if (lookahead == '[')
        ADVANCE(314);
      if (lookahead == '\\')
        ADVANCE(318);
      if (lookahead == ']')
        ADVANCE(320);
      if (lookahead == 'c')
        ADVANCE(322);
      if (lookahead == 'f')
        ADVANCE(326);
      if (lookahead == 'i')
        ADVANCE(336);
      if (lookahead == 'w')
        ADVANCE(339);
      if (lookahead == '{')
        ADVANCE(344);
      if (lookahead == '|')
        ADVANCE(345);
      if (lookahead == '}')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(319);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == ']')
        ADVANCE(321);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == 'a')
        ADVANCE(323);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`' &&
          lookahead != 'a')
        ADVANCE(317);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == 's')
        ADVANCE(324);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == 'e')
        ADVANCE(325);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(anon_sym_case);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == 'o')
        ADVANCE(327);
      if (lookahead == 'u')
        ADVANCE(329);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == 'r')
        ADVANCE(328);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == 'n')
        ADVANCE(330);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == 'c')
        ADVANCE(331);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == 't')
        ADVANCE(332);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == 'i')
        ADVANCE(333);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == 'o')
        ADVANCE(334);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == 'n')
        ADVANCE(335);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(anon_sym_function);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == 'f')
        ADVANCE(337);
      if (lookahead == 'n')
        ADVANCE(338);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(anon_sym_if);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == 'h')
        ADVANCE(340);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == 'i')
        ADVANCE(341);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == 'l')
        ADVANCE(342);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == 'e')
        ADVANCE(343);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(anon_sym_while);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(129);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(346);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '|')
        ADVANCE(347);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('\'' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          ('{' <= lookahead && lookahead <= '}'))
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(anon_sym_PIPE_AMP);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(129);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(129);
      END_STATE();
    case 349:
      if (lookahead == '\n')
        ADVANCE(350);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(128);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(296);
      if (lookahead == '\'')
        ADVANCE(300);
      if (lookahead == ')')
        ADVANCE(302);
      if (lookahead == ';')
        ADVANCE(303);
      if (lookahead == '<')
        ADVANCE(305);
      if (lookahead == '>')
        ADVANCE(310);
      if (lookahead == '\\')
        ADVANCE(351);
      if (lookahead == ']')
        ADVANCE(320);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == 'i')
        ADVANCE(353);
      if (lookahead == '|')
        ADVANCE(345);
      if (lookahead == '}')
        ADVANCE(348);
      if (lookahead == '(' ||
          lookahead == '{')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(352);
      if (lookahead != 0)
        ADVANCE(317);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(350);
      if (lookahead == '#')
        ADVANCE(128);
      if (lookahead == '&')
        ADVANCE(296);
      if (lookahead == '\'')
        ADVANCE(300);
      if (lookahead == ')')
        ADVANCE(302);
      if (lookahead == ';')
        ADVANCE(303);
      if (lookahead == '<')
        ADVANCE(305);
      if (lookahead == '>')
        ADVANCE(310);
      if (lookahead == '\\')
        ADVANCE(351);
      if (lookahead == ']')
        ADVANCE(320);
      if (lookahead == 'i')
        ADVANCE(353);
      if (lookahead == '|')
        ADVANCE(345);
      if (lookahead == '}')
        ADVANCE(348);
      if (lookahead == '(' ||
          lookahead == '{')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(352);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(352);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(129);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(90);
      if (lookahead != 0)
        ADVANCE(317);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(350);
      if (lookahead == '#')
        ADVANCE(128);
      if (lookahead == '&')
        ADVANCE(296);
      if (lookahead == '\'')
        ADVANCE(300);
      if (lookahead == ')')
        ADVANCE(302);
      if (lookahead == ';')
        ADVANCE(303);
      if (lookahead == '<')
        ADVANCE(305);
      if (lookahead == '>')
        ADVANCE(310);
      if (lookahead == '\\')
        ADVANCE(351);
      if (lookahead == ']')
        ADVANCE(320);
      if (lookahead == 'i')
        ADVANCE(353);
      if (lookahead == '|')
        ADVANCE(345);
      if (lookahead == '}')
        ADVANCE(348);
      if (lookahead == '(' ||
          lookahead == '{')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(352);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == 'n')
        ADVANCE(338);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 354:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '<')
        ADVANCE(124);
      if (lookahead == '>')
        ADVANCE(125);
      if (lookahead == '@')
        ADVANCE(355);
      if (lookahead == '\\')
        ADVANCE(356);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(354);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 356:
      if (lookahead == '\n')
        SKIP(354);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 357:
      if (lookahead == '\n')
        ADVANCE(133);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(170);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == ';')
        ADVANCE(136);
      if (lookahead == '=')
        ADVANCE(23);
      if (lookahead == '\\')
        SKIP(358);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '|')
        ADVANCE(172);
      if (lookahead == '}')
        ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(357);
      END_STATE();
    case 358:
      if (lookahead == '\n')
        SKIP(357);
      END_STATE();
    case 359:
      if (lookahead == '\n')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(134);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == ';')
        ADVANCE(136);
      if (lookahead == '<')
        ADVANCE(138);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '\\')
        ADVANCE(360);
      if (lookahead == ']')
        ADVANCE(201);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == 'i')
        ADVANCE(361);
      if (lookahead == '|')
        ADVANCE(142);
      if (lookahead == '}')
        ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(359);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(90);
      END_STATE();
    case 360:
      if (lookahead == '\n')
        SKIP(359);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'n')
        ADVANCE(362);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 363:
      if (lookahead == '\n')
        ADVANCE(364);
      if (lookahead == '!')
        ADVANCE(365);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(366);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '%')
        ADVANCE(367);
      if (lookahead == '&')
        ADVANCE(296);
      if (lookahead == '\'')
        ADVANCE(300);
      if (lookahead == ')')
        ADVANCE(302);
      if (lookahead == '*')
        ADVANCE(368);
      if (lookahead == '-')
        ADVANCE(369);
      if (lookahead == '/')
        ADVANCE(370);
      if (lookahead == '0')
        ADVANCE(371);
      if (lookahead == ':')
        ADVANCE(373);
      if (lookahead == ';')
        ADVANCE(303);
      if (lookahead == '<')
        ADVANCE(305);
      if (lookahead == '=')
        ADVANCE(376);
      if (lookahead == '>')
        ADVANCE(310);
      if (lookahead == '?')
        ADVANCE(377);
      if (lookahead == '@')
        ADVANCE(378);
      if (lookahead == '[')
        ADVANCE(379);
      if (lookahead == '\\')
        ADVANCE(380);
      if (lookahead == ']')
        ADVANCE(320);
      if (lookahead == '_')
        ADVANCE(382);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == 'i')
        ADVANCE(383);
      if (lookahead == '|')
        ADVANCE(345);
      if (lookahead == '}')
        ADVANCE(348);
      if (lookahead == '(' ||
          lookahead == '{')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(381);
      if (('1' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(372);
      if (lookahead != 0)
        ADVANCE(317);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(364);
      if (lookahead == '!')
        ADVANCE(365);
      if (lookahead == '#')
        ADVANCE(366);
      if (lookahead == '%')
        ADVANCE(367);
      if (lookahead == '&')
        ADVANCE(296);
      if (lookahead == '\'')
        ADVANCE(300);
      if (lookahead == ')')
        ADVANCE(302);
      if (lookahead == '*')
        ADVANCE(368);
      if (lookahead == '-')
        ADVANCE(369);
      if (lookahead == '/')
        ADVANCE(370);
      if (lookahead == '0')
        ADVANCE(371);
      if (lookahead == ':')
        ADVANCE(373);
      if (lookahead == ';')
        ADVANCE(303);
      if (lookahead == '<')
        ADVANCE(305);
      if (lookahead == '=')
        ADVANCE(376);
      if (lookahead == '>')
        ADVANCE(310);
      if (lookahead == '?')
        ADVANCE(377);
      if (lookahead == '@')
        ADVANCE(378);
      if (lookahead == '[')
        ADVANCE(379);
      if (lookahead == '\\')
        ADVANCE(380);
      if (lookahead == ']')
        ADVANCE(320);
      if (lookahead == '_')
        ADVANCE(382);
      if (lookahead == 'i')
        ADVANCE(383);
      if (lookahead == '|')
        ADVANCE(345);
      if (lookahead == '}')
        ADVANCE(348);
      if (lookahead == '(' ||
          lookahead == '{')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(381);
      if (('1' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(372);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '*') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(317);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == '\n')
        ADVANCE(129);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(128);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(anon_sym_0);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(372);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '_' || lookahead > '{'))
        ADVANCE(317);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(372);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '_' || lookahead > '{'))
        ADVANCE(317);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(374);
      if (lookahead == '?')
        ADVANCE(375);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(381);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(129);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(90);
      if (lookahead != 0)
        ADVANCE(317);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(364);
      if (lookahead == '!')
        ADVANCE(365);
      if (lookahead == '#')
        ADVANCE(366);
      if (lookahead == '%')
        ADVANCE(367);
      if (lookahead == '&')
        ADVANCE(296);
      if (lookahead == '\'')
        ADVANCE(300);
      if (lookahead == ')')
        ADVANCE(302);
      if (lookahead == '*')
        ADVANCE(368);
      if (lookahead == '-')
        ADVANCE(369);
      if (lookahead == '/')
        ADVANCE(370);
      if (lookahead == '0')
        ADVANCE(371);
      if (lookahead == ':')
        ADVANCE(373);
      if (lookahead == ';')
        ADVANCE(303);
      if (lookahead == '<')
        ADVANCE(305);
      if (lookahead == '=')
        ADVANCE(376);
      if (lookahead == '>')
        ADVANCE(310);
      if (lookahead == '?')
        ADVANCE(377);
      if (lookahead == '@')
        ADVANCE(378);
      if (lookahead == '[')
        ADVANCE(379);
      if (lookahead == '\\')
        ADVANCE(380);
      if (lookahead == ']')
        ADVANCE(320);
      if (lookahead == '_')
        ADVANCE(382);
      if (lookahead == 'i')
        ADVANCE(383);
      if (lookahead == '|')
        ADVANCE(345);
      if (lookahead == '}')
        ADVANCE(348);
      if (lookahead == '(' ||
          lookahead == '{')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(381);
      if (('1' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(372);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '*') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(317);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(372);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '_' || lookahead > '{'))
        ADVANCE(317);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == 'n')
        ADVANCE(384);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(372);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '_' || lookahead > '{'))
        ADVANCE(317);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '#' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(129);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(372);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '_' || lookahead > '{'))
        ADVANCE(317);
      END_STATE();
    case 385:
      if (lookahead == '\n')
        ADVANCE(386);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(128);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '%')
        ADVANCE(367);
      if (lookahead == '&')
        ADVANCE(296);
      if (lookahead == '\'')
        ADVANCE(300);
      if (lookahead == ')')
        ADVANCE(302);
      if (lookahead == '/')
        ADVANCE(370);
      if (lookahead == ':')
        ADVANCE(373);
      if (lookahead == ';')
        ADVANCE(303);
      if (lookahead == '<')
        ADVANCE(305);
      if (lookahead == '=')
        ADVANCE(376);
      if (lookahead == '>')
        ADVANCE(310);
      if (lookahead == '[')
        ADVANCE(379);
      if (lookahead == '\\')
        ADVANCE(387);
      if (lookahead == ']')
        ADVANCE(320);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == 'i')
        ADVANCE(353);
      if (lookahead == '|')
        ADVANCE(345);
      if (lookahead == '}')
        ADVANCE(348);
      if (lookahead == '(' ||
          lookahead == '{')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(388);
      if (lookahead != 0)
        ADVANCE(317);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(386);
      if (lookahead == '#')
        ADVANCE(128);
      if (lookahead == '%')
        ADVANCE(367);
      if (lookahead == '&')
        ADVANCE(296);
      if (lookahead == '\'')
        ADVANCE(300);
      if (lookahead == ')')
        ADVANCE(302);
      if (lookahead == '/')
        ADVANCE(370);
      if (lookahead == ':')
        ADVANCE(373);
      if (lookahead == ';')
        ADVANCE(303);
      if (lookahead == '<')
        ADVANCE(305);
      if (lookahead == '=')
        ADVANCE(376);
      if (lookahead == '>')
        ADVANCE(310);
      if (lookahead == '[')
        ADVANCE(379);
      if (lookahead == '\\')
        ADVANCE(387);
      if (lookahead == ']')
        ADVANCE(320);
      if (lookahead == 'i')
        ADVANCE(353);
      if (lookahead == '|')
        ADVANCE(345);
      if (lookahead == '}')
        ADVANCE(348);
      if (lookahead == '(' ||
          lookahead == '{')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(388);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > ')') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(388);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(129);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(90);
      if (lookahead != 0)
        ADVANCE(317);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(386);
      if (lookahead == '#')
        ADVANCE(128);
      if (lookahead == '%')
        ADVANCE(367);
      if (lookahead == '&')
        ADVANCE(296);
      if (lookahead == '\'')
        ADVANCE(300);
      if (lookahead == ')')
        ADVANCE(302);
      if (lookahead == '/')
        ADVANCE(370);
      if (lookahead == ':')
        ADVANCE(373);
      if (lookahead == ';')
        ADVANCE(303);
      if (lookahead == '<')
        ADVANCE(305);
      if (lookahead == '=')
        ADVANCE(376);
      if (lookahead == '>')
        ADVANCE(310);
      if (lookahead == '[')
        ADVANCE(379);
      if (lookahead == '\\')
        ADVANCE(387);
      if (lookahead == ']')
        ADVANCE(320);
      if (lookahead == 'i')
        ADVANCE(353);
      if (lookahead == '|')
        ADVANCE(345);
      if (lookahead == '}')
        ADVANCE(348);
      if (lookahead == '(' ||
          lookahead == '{')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(388);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > ')') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 389:
      if (lookahead == '\n')
        ADVANCE(390);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(128);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(296);
      if (lookahead == '\'')
        ADVANCE(300);
      if (lookahead == '(')
        ADVANCE(301);
      if (lookahead == ')')
        ADVANCE(302);
      if (lookahead == ';')
        ADVANCE(303);
      if (lookahead == '<')
        ADVANCE(305);
      if (lookahead == '>')
        ADVANCE(310);
      if (lookahead == '[')
        ADVANCE(314);
      if (lookahead == '\\')
        ADVANCE(391);
      if (lookahead == ']')
        ADVANCE(320);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == 'c')
        ADVANCE(322);
      if (lookahead == 'f')
        ADVANCE(326);
      if (lookahead == 'i')
        ADVANCE(336);
      if (lookahead == 'w')
        ADVANCE(339);
      if (lookahead == '{')
        ADVANCE(129);
      if (lookahead == '|')
        ADVANCE(345);
      if (lookahead == '}')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(392);
      if (lookahead != 0)
        ADVANCE(317);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(390);
      if (lookahead == '#')
        ADVANCE(128);
      if (lookahead == '&')
        ADVANCE(296);
      if (lookahead == '\'')
        ADVANCE(300);
      if (lookahead == '(')
        ADVANCE(301);
      if (lookahead == ')')
        ADVANCE(302);
      if (lookahead == ';')
        ADVANCE(303);
      if (lookahead == '<')
        ADVANCE(305);
      if (lookahead == '>')
        ADVANCE(310);
      if (lookahead == '[')
        ADVANCE(314);
      if (lookahead == '\\')
        ADVANCE(391);
      if (lookahead == ']')
        ADVANCE(320);
      if (lookahead == 'c')
        ADVANCE(322);
      if (lookahead == 'f')
        ADVANCE(326);
      if (lookahead == 'i')
        ADVANCE(336);
      if (lookahead == 'w')
        ADVANCE(339);
      if (lookahead == '{')
        ADVANCE(129);
      if (lookahead == '|')
        ADVANCE(345);
      if (lookahead == '}')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(392);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(392);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(129);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(90);
      if (lookahead != 0)
        ADVANCE(317);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(390);
      if (lookahead == '#')
        ADVANCE(128);
      if (lookahead == '&')
        ADVANCE(296);
      if (lookahead == '\'')
        ADVANCE(300);
      if (lookahead == '(')
        ADVANCE(301);
      if (lookahead == ')')
        ADVANCE(302);
      if (lookahead == ';')
        ADVANCE(303);
      if (lookahead == '<')
        ADVANCE(305);
      if (lookahead == '>')
        ADVANCE(310);
      if (lookahead == '[')
        ADVANCE(314);
      if (lookahead == '\\')
        ADVANCE(391);
      if (lookahead == ']')
        ADVANCE(320);
      if (lookahead == 'c')
        ADVANCE(322);
      if (lookahead == 'f')
        ADVANCE(326);
      if (lookahead == 'i')
        ADVANCE(336);
      if (lookahead == 'w')
        ADVANCE(339);
      if (lookahead == '{')
        ADVANCE(129);
      if (lookahead == '|')
        ADVANCE(345);
      if (lookahead == '}')
        ADVANCE(348);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(392);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(317);
      END_STATE();
    case 393:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(84);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == ';')
        ADVANCE(155);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(394);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(395);
      if (lookahead == 'e')
        ADVANCE(397);
      if (lookahead == 'f')
        ADVANCE(167);
      if (lookahead == 'i')
        ADVANCE(398);
      if (lookahead == 't')
        ADVANCE(399);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '}')
        ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(393);
      if (lookahead != '{')
        ADVANCE(90);
      END_STATE();
    case 394:
      if (lookahead == '\n')
        SKIP(393);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'o')
        ADVANCE(396);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'n')
        ADVANCE(159);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'l')
        ADVANCE(162);
      if (lookahead == 's')
        ADVANCE(279);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'f')
        ADVANCE(107);
      if (lookahead == 'n')
        ADVANCE(362);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'h')
        ADVANCE(400);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'e')
        ADVANCE(401);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == 'n')
        ADVANCE(402);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(anon_sym_then);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(90);
      END_STATE();
    case 403:
      if (lookahead == '\n')
        ADVANCE(133);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(134);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == ';')
        ADVANCE(136);
      if (lookahead == '<')
        ADVANCE(234);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '\\')
        SKIP(404);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '|')
        ADVANCE(172);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(403);
      END_STATE();
    case 404:
      if (lookahead == '\n')
        SKIP(403);
      END_STATE();
    case 405:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(84);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ';')
        ADVANCE(155);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(406);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(395);
      if (lookahead == 'e')
        ADVANCE(161);
      if (lookahead == 'f')
        ADVANCE(167);
      if (lookahead == 'i')
        ADVANCE(106);
      if (lookahead == 't')
        ADVANCE(399);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '}')
        ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(405);
      if ((lookahead < '&' || lookahead > ')') &&
          lookahead != '{')
        ADVANCE(90);
      END_STATE();
    case 406:
      if (lookahead == '\n')
        SKIP(405);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 407:
      if (lookahead == '\n')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(134);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == ';')
        ADVANCE(136);
      if (lookahead == '<')
        ADVANCE(138);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '\\')
        ADVANCE(408);
      if (lookahead == ']')
        ADVANCE(201);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '|')
        ADVANCE(142);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(407);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(90);
      END_STATE();
    case 408:
      if (lookahead == '\n')
        SKIP(407);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 409:
      if (lookahead == '\n')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(134);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == ';')
        ADVANCE(136);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '\\')
        ADVANCE(410);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '{')
        ADVANCE(76);
      if (lookahead == '|')
        ADVANCE(142);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(409);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(90);
      END_STATE();
    case 410:
      if (lookahead == '\n')
        SKIP(409);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 411:
      if (lookahead == '\n')
        ADVANCE(133);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(134);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == ';')
        ADVANCE(136);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '\\')
        ADVANCE(412);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == '|')
        ADVANCE(142);
      if (lookahead == '}')
        ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(411);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(90);
      END_STATE();
    case 412:
      if (lookahead == '\n')
        SKIP(411);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 413:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(84);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == ';')
        ADVANCE(155);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(414);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(395);
      if (lookahead == 'e')
        ADVANCE(161);
      if (lookahead == 'f')
        ADVANCE(167);
      if (lookahead == 'i')
        ADVANCE(106);
      if (lookahead == 't')
        ADVANCE(399);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '}')
        ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(413);
      if (lookahead != '{')
        ADVANCE(90);
      END_STATE();
    case 414:
      if (lookahead == '\n')
        SKIP(413);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    case 415:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(81);
      if (lookahead == '&')
        ADVANCE(84);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == ';')
        ADVANCE(155);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '>')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(416);
      if (lookahead == '`')
        ADVANCE(35);
      if (lookahead == 'c')
        ADVANCE(92);
      if (lookahead == 'd')
        ADVANCE(157);
      if (lookahead == 'e')
        ADVANCE(161);
      if (lookahead == 'f')
        ADVANCE(167);
      if (lookahead == 'i')
        ADVANCE(106);
      if (lookahead == 'w')
        ADVANCE(108);
      if (lookahead == '}')
        ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(415);
      if (lookahead != '{')
        ADVANCE(90);
      END_STATE();
    case 416:
      if (lookahead == '\n')
        SKIP(415);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(90);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 79, .external_lex_state = 2},
  [2] = {.lex_state = 113},
  [3] = {.lex_state = 117},
  [4] = {.lex_state = 119},
  [5] = {.lex_state = 121, .external_lex_state = 2},
  [6] = {.lex_state = 121, .external_lex_state = 2},
  [7] = {.lex_state = 123},
  [8] = {.lex_state = 119},
  [9] = {.lex_state = 121, .external_lex_state = 2},
  [10] = {.lex_state = 123},
  [11] = {.lex_state = 123},
  [12] = {.lex_state = 123},
  [13] = {.lex_state = 127},
  [14] = {.lex_state = 132, .external_lex_state = 3},
  [15] = {.lex_state = 145},
  [16] = {.lex_state = 145},
  [17] = {.lex_state = 121, .external_lex_state = 2},
  [18] = {.lex_state = 121, .external_lex_state = 2},
  [19] = {.lex_state = 121, .external_lex_state = 2},
  [20] = {.lex_state = 150, .external_lex_state = 3},
  [21] = {.lex_state = 152},
  [22] = {.lex_state = 154, .external_lex_state = 2},
  [23] = {.lex_state = 169, .external_lex_state = 4},
  [24] = {.lex_state = 132, .external_lex_state = 5},
  [25] = {.lex_state = 174, .external_lex_state = 6},
  [26] = {.lex_state = 176},
  [27] = {.lex_state = 178, .external_lex_state = 2},
  [28] = {.lex_state = 132, .external_lex_state = 5},
  [29] = {.lex_state = 79, .external_lex_state = 2},
  [30] = {.lex_state = 178, .external_lex_state = 2},
  [31] = {.lex_state = 123},
  [32] = {.lex_state = 123},
  [33] = {.lex_state = 180, .external_lex_state = 7},
  [34] = {.lex_state = 182},
  [35] = {.lex_state = 185},
  [36] = {.lex_state = 169, .external_lex_state = 4},
  [37] = {.lex_state = 174, .external_lex_state = 6},
  [38] = {.lex_state = 189},
  [39] = {.lex_state = 127},
  [40] = {.lex_state = 191, .external_lex_state = 8},
  [41] = {.lex_state = 145},
  [42] = {.lex_state = 145},
  [43] = {.lex_state = 121, .external_lex_state = 2},
  [44] = {.lex_state = 121, .external_lex_state = 2},
  [45] = {.lex_state = 121, .external_lex_state = 2},
  [46] = {.lex_state = 191, .external_lex_state = 4},
  [47] = {.lex_state = 193},
  [48] = {.lex_state = 195, .external_lex_state = 4},
  [49] = {.lex_state = 197, .external_lex_state = 6},
  [50] = {.lex_state = 121, .external_lex_state = 2},
  [51] = {.lex_state = 127},
  [52] = {.lex_state = 199, .external_lex_state = 9},
  [53] = {.lex_state = 145},
  [54] = {.lex_state = 145},
  [55] = {.lex_state = 121, .external_lex_state = 2},
  [56] = {.lex_state = 121, .external_lex_state = 2},
  [57] = {.lex_state = 121, .external_lex_state = 2},
  [58] = {.lex_state = 199},
  [59] = {.lex_state = 203},
  [60] = {.lex_state = 206},
  [61] = {.lex_state = 127},
  [62] = {.lex_state = 178, .external_lex_state = 10},
  [63] = {.lex_state = 145},
  [64] = {.lex_state = 145},
  [65] = {.lex_state = 121, .external_lex_state = 2},
  [66] = {.lex_state = 121, .external_lex_state = 2},
  [67] = {.lex_state = 121, .external_lex_state = 2},
  [68] = {.lex_state = 178, .external_lex_state = 2},
  [69] = {.lex_state = 132, .external_lex_state = 3},
  [70] = {.lex_state = 127},
  [71] = {.lex_state = 145},
  [72] = {.lex_state = 145},
  [73] = {.lex_state = 121, .external_lex_state = 2},
  [74] = {.lex_state = 121, .external_lex_state = 2},
  [75] = {.lex_state = 127},
  [76] = {.lex_state = 123},
  [77] = {.lex_state = 132, .external_lex_state = 3},
  [78] = {.lex_state = 132, .external_lex_state = 3},
  [79] = {.lex_state = 132, .external_lex_state = 3},
  [80] = {.lex_state = 132, .external_lex_state = 3},
  [81] = {.lex_state = 209},
  [82] = {.lex_state = 211},
  [83] = {.lex_state = 209},
  [84] = {.lex_state = 209},
  [85] = {.lex_state = 117},
  [86] = {.lex_state = 119},
  [87] = {.lex_state = 121, .external_lex_state = 2},
  [88] = {.lex_state = 121, .external_lex_state = 2},
  [89] = {.lex_state = 123},
  [90] = {.lex_state = 119},
  [91] = {.lex_state = 121, .external_lex_state = 2},
  [92] = {.lex_state = 123},
  [93] = {.lex_state = 123},
  [94] = {.lex_state = 127},
  [95] = {.lex_state = 213, .external_lex_state = 11},
  [96] = {.lex_state = 145},
  [97] = {.lex_state = 145},
  [98] = {.lex_state = 121, .external_lex_state = 2},
  [99] = {.lex_state = 121, .external_lex_state = 2},
  [100] = {.lex_state = 121, .external_lex_state = 2},
  [101] = {.lex_state = 216, .external_lex_state = 11},
  [102] = {.lex_state = 218},
  [103] = {.lex_state = 213, .external_lex_state = 12},
  [104] = {.lex_state = 221, .external_lex_state = 2},
  [105] = {.lex_state = 176},
  [106] = {.lex_state = 213, .external_lex_state = 12},
  [107] = {.lex_state = 178, .external_lex_state = 2},
  [108] = {.lex_state = 223},
  [109] = {.lex_state = 225, .external_lex_state = 12},
  [110] = {.lex_state = 227, .external_lex_state = 2},
  [111] = {.lex_state = 178, .external_lex_state = 2},
  [112] = {.lex_state = 218},
  [113] = {.lex_state = 221, .external_lex_state = 2},
  [114] = {.lex_state = 229},
  [115] = {.lex_state = 121, .external_lex_state = 2},
  [116] = {.lex_state = 154, .external_lex_state = 2},
  [117] = {.lex_state = 121, .external_lex_state = 2},
  [118] = {.lex_state = 113},
  [119] = {.lex_state = 123},
  [120] = {.lex_state = 231, .external_lex_state = 13},
  [121] = {.lex_state = 132, .external_lex_state = 3},
  [122] = {.lex_state = 233, .external_lex_state = 5},
  [123] = {.lex_state = 132, .external_lex_state = 5},
  [124] = {.lex_state = 132, .external_lex_state = 5},
  [125] = {.lex_state = 233, .external_lex_state = 5},
  [126] = {.lex_state = 154, .external_lex_state = 2},
  [127] = {.lex_state = 132, .external_lex_state = 5},
  [128] = {.lex_state = 178, .external_lex_state = 2},
  [129] = {.lex_state = 178, .external_lex_state = 10},
  [130] = {.lex_state = 178, .external_lex_state = 2},
  [131] = {.lex_state = 127},
  [132] = {.lex_state = 236, .external_lex_state = 9},
  [133] = {.lex_state = 145},
  [134] = {.lex_state = 145},
  [135] = {.lex_state = 121, .external_lex_state = 2},
  [136] = {.lex_state = 121, .external_lex_state = 2},
  [137] = {.lex_state = 121, .external_lex_state = 2},
  [138] = {.lex_state = 236},
  [139] = {.lex_state = 197, .external_lex_state = 6},
  [140] = {.lex_state = 239},
  [141] = {.lex_state = 127},
  [142] = {.lex_state = 197, .external_lex_state = 14},
  [143] = {.lex_state = 145},
  [144] = {.lex_state = 145},
  [145] = {.lex_state = 121, .external_lex_state = 2},
  [146] = {.lex_state = 121, .external_lex_state = 2},
  [147] = {.lex_state = 121, .external_lex_state = 2},
  [148] = {.lex_state = 123},
  [149] = {.lex_state = 241, .external_lex_state = 2},
  [150] = {.lex_state = 195, .external_lex_state = 4},
  [151] = {.lex_state = 243},
  [152] = {.lex_state = 245, .external_lex_state = 2},
  [153] = {.lex_state = 191, .external_lex_state = 8},
  [154] = {.lex_state = 127},
  [155] = {.lex_state = 123},
  [156] = {.lex_state = 247, .external_lex_state = 4},
  [157] = {.lex_state = 182},
  [158] = {.lex_state = 191, .external_lex_state = 8},
  [159] = {.lex_state = 191, .external_lex_state = 8},
  [160] = {.lex_state = 191, .external_lex_state = 8},
  [161] = {.lex_state = 191, .external_lex_state = 8},
  [162] = {.lex_state = 211},
  [163] = {.lex_state = 209},
  [164] = {.lex_state = 209},
  [165] = {.lex_state = 218},
  [166] = {.lex_state = 221, .external_lex_state = 2},
  [167] = {.lex_state = 223},
  [168] = {.lex_state = 227, .external_lex_state = 2},
  [169] = {.lex_state = 218},
  [170] = {.lex_state = 221, .external_lex_state = 2},
  [171] = {.lex_state = 229},
  [172] = {.lex_state = 195, .external_lex_state = 4},
  [173] = {.lex_state = 249, .external_lex_state = 2},
  [174] = {.lex_state = 195, .external_lex_state = 4},
  [175] = {.lex_state = 197, .external_lex_state = 6},
  [176] = {.lex_state = 251, .external_lex_state = 9},
  [177] = {.lex_state = 127},
  [178] = {.lex_state = 123},
  [179] = {.lex_state = 251, .external_lex_state = 9},
  [180] = {.lex_state = 251, .external_lex_state = 9},
  [181] = {.lex_state = 251, .external_lex_state = 9},
  [182] = {.lex_state = 251, .external_lex_state = 9},
  [183] = {.lex_state = 211},
  [184] = {.lex_state = 209},
  [185] = {.lex_state = 209},
  [186] = {.lex_state = 218},
  [187] = {.lex_state = 221, .external_lex_state = 2},
  [188] = {.lex_state = 223},
  [189] = {.lex_state = 227, .external_lex_state = 2},
  [190] = {.lex_state = 218},
  [191] = {.lex_state = 221, .external_lex_state = 2},
  [192] = {.lex_state = 195, .external_lex_state = 4},
  [193] = {.lex_state = 199, .external_lex_state = 9},
  [194] = {.lex_state = 199},
  [195] = {.lex_state = 221, .external_lex_state = 10},
  [196] = {.lex_state = 127},
  [197] = {.lex_state = 123},
  [198] = {.lex_state = 221, .external_lex_state = 10},
  [199] = {.lex_state = 221, .external_lex_state = 10},
  [200] = {.lex_state = 221, .external_lex_state = 10},
  [201] = {.lex_state = 221, .external_lex_state = 10},
  [202] = {.lex_state = 211},
  [203] = {.lex_state = 209},
  [204] = {.lex_state = 209},
  [205] = {.lex_state = 218},
  [206] = {.lex_state = 221, .external_lex_state = 2},
  [207] = {.lex_state = 223},
  [208] = {.lex_state = 227, .external_lex_state = 2},
  [209] = {.lex_state = 218},
  [210] = {.lex_state = 221, .external_lex_state = 2},
  [211] = {.lex_state = 127},
  [212] = {.lex_state = 127},
  [213] = {.lex_state = 127},
  [214] = {.lex_state = 211},
  [215] = {.lex_state = 209},
  [216] = {.lex_state = 209},
  [217] = {.lex_state = 218},
  [218] = {.lex_state = 221, .external_lex_state = 2},
  [219] = {.lex_state = 223},
  [220] = {.lex_state = 227, .external_lex_state = 2},
  [221] = {.lex_state = 132, .external_lex_state = 3},
  [222] = {.lex_state = 127},
  [223] = {.lex_state = 132, .external_lex_state = 3},
  [224] = {.lex_state = 123},
  [225] = {.lex_state = 253},
  [226] = {.lex_state = 253},
  [227] = {.lex_state = 132, .external_lex_state = 3},
  [228] = {.lex_state = 255},
  [229] = {.lex_state = 123},
  [230] = {.lex_state = 132, .external_lex_state = 3},
  [231] = {.lex_state = 255},
  [232] = {.lex_state = 123},
  [233] = {.lex_state = 180, .external_lex_state = 7},
  [234] = {.lex_state = 182},
  [235] = {.lex_state = 185},
  [236] = {.lex_state = 189},
  [237] = {.lex_state = 191, .external_lex_state = 8},
  [238] = {.lex_state = 191, .external_lex_state = 4},
  [239] = {.lex_state = 193},
  [240] = {.lex_state = 195, .external_lex_state = 4},
  [241] = {.lex_state = 197, .external_lex_state = 6},
  [242] = {.lex_state = 121, .external_lex_state = 2},
  [243] = {.lex_state = 203},
  [244] = {.lex_state = 206},
  [245] = {.lex_state = 213, .external_lex_state = 11},
  [246] = {.lex_state = 127},
  [247] = {.lex_state = 123},
  [248] = {.lex_state = 213, .external_lex_state = 11},
  [249] = {.lex_state = 213, .external_lex_state = 11},
  [250] = {.lex_state = 213, .external_lex_state = 11},
  [251] = {.lex_state = 213, .external_lex_state = 11},
  [252] = {.lex_state = 211},
  [253] = {.lex_state = 209},
  [254] = {.lex_state = 209},
  [255] = {.lex_state = 218},
  [256] = {.lex_state = 221, .external_lex_state = 2},
  [257] = {.lex_state = 223},
  [258] = {.lex_state = 227, .external_lex_state = 2},
  [259] = {.lex_state = 218},
  [260] = {.lex_state = 221, .external_lex_state = 2},
  [261] = {.lex_state = 229},
  [262] = {.lex_state = 121, .external_lex_state = 2},
  [263] = {.lex_state = 132, .external_lex_state = 3},
  [264] = {.lex_state = 121, .external_lex_state = 2},
  [265] = {.lex_state = 113},
  [266] = {.lex_state = 123},
  [267] = {.lex_state = 231, .external_lex_state = 13},
  [268] = {.lex_state = 213, .external_lex_state = 11},
  [269] = {.lex_state = 257, .external_lex_state = 12},
  [270] = {.lex_state = 213, .external_lex_state = 12},
  [271] = {.lex_state = 213, .external_lex_state = 12},
  [272] = {.lex_state = 257, .external_lex_state = 12},
  [273] = {.lex_state = 213, .external_lex_state = 12},
  [274] = {.lex_state = 121, .external_lex_state = 2},
  [275] = {.lex_state = 121, .external_lex_state = 2},
  [276] = {.lex_state = 225, .external_lex_state = 12},
  [277] = {.lex_state = 225, .external_lex_state = 12},
  [278] = {.lex_state = 132, .external_lex_state = 3},
  [279] = {.lex_state = 259},
  [280] = {.lex_state = 195, .external_lex_state = 4},
  [281] = {.lex_state = 197, .external_lex_state = 6},
  [282] = {.lex_state = 195, .external_lex_state = 4},
  [283] = {.lex_state = 197, .external_lex_state = 6},
  [284] = {.lex_state = 123},
  [285] = {.lex_state = 127},
  [286] = {.lex_state = 233, .external_lex_state = 3},
  [287] = {.lex_state = 145},
  [288] = {.lex_state = 145},
  [289] = {.lex_state = 121, .external_lex_state = 2},
  [290] = {.lex_state = 121, .external_lex_state = 2},
  [291] = {.lex_state = 121, .external_lex_state = 2},
  [292] = {.lex_state = 233, .external_lex_state = 5},
  [293] = {.lex_state = 233, .external_lex_state = 5},
  [294] = {.lex_state = 261, .external_lex_state = 15},
  [295] = {.lex_state = 233, .external_lex_state = 5},
  [296] = {.lex_state = 132, .external_lex_state = 3},
  [297] = {.lex_state = 132, .external_lex_state = 5},
  [298] = {.lex_state = 233, .external_lex_state = 5},
  [299] = {.lex_state = 233, .external_lex_state = 5},
  [300] = {.lex_state = 132, .external_lex_state = 5},
  [301] = {.lex_state = 264, .external_lex_state = 9},
  [302] = {.lex_state = 127},
  [303] = {.lex_state = 123},
  [304] = {.lex_state = 176},
  [305] = {.lex_state = 264, .external_lex_state = 9},
  [306] = {.lex_state = 264, .external_lex_state = 9},
  [307] = {.lex_state = 264, .external_lex_state = 9},
  [308] = {.lex_state = 264, .external_lex_state = 9},
  [309] = {.lex_state = 211},
  [310] = {.lex_state = 209},
  [311] = {.lex_state = 209},
  [312] = {.lex_state = 218},
  [313] = {.lex_state = 221, .external_lex_state = 2},
  [314] = {.lex_state = 223},
  [315] = {.lex_state = 227, .external_lex_state = 2},
  [316] = {.lex_state = 218},
  [317] = {.lex_state = 221, .external_lex_state = 2},
  [318] = {.lex_state = 197, .external_lex_state = 6},
  [319] = {.lex_state = 239},
  [320] = {.lex_state = 239},
  [321] = {.lex_state = 197, .external_lex_state = 14},
  [322] = {.lex_state = 127},
  [323] = {.lex_state = 123},
  [324] = {.lex_state = 197, .external_lex_state = 14},
  [325] = {.lex_state = 197, .external_lex_state = 14},
  [326] = {.lex_state = 197, .external_lex_state = 14},
  [327] = {.lex_state = 197, .external_lex_state = 14},
  [328] = {.lex_state = 211},
  [329] = {.lex_state = 209},
  [330] = {.lex_state = 209},
  [331] = {.lex_state = 218},
  [332] = {.lex_state = 221, .external_lex_state = 2},
  [333] = {.lex_state = 223},
  [334] = {.lex_state = 227, .external_lex_state = 2},
  [335] = {.lex_state = 218},
  [336] = {.lex_state = 221, .external_lex_state = 2},
  [337] = {.lex_state = 127},
  [338] = {.lex_state = 266, .external_lex_state = 8},
  [339] = {.lex_state = 145},
  [340] = {.lex_state = 145},
  [341] = {.lex_state = 121, .external_lex_state = 2},
  [342] = {.lex_state = 121, .external_lex_state = 2},
  [343] = {.lex_state = 121, .external_lex_state = 2},
  [344] = {.lex_state = 266, .external_lex_state = 4},
  [345] = {.lex_state = 266, .external_lex_state = 4},
  [346] = {.lex_state = 195, .external_lex_state = 4},
  [347] = {.lex_state = 241, .external_lex_state = 2},
  [348] = {.lex_state = 195, .external_lex_state = 4},
  [349] = {.lex_state = 121, .external_lex_state = 2},
  [350] = {.lex_state = 268, .external_lex_state = 2},
  [351] = {.lex_state = 270},
  [352] = {.lex_state = 274},
  [353] = {.lex_state = 245, .external_lex_state = 2},
  [354] = {.lex_state = 270},
  [355] = {.lex_state = 191, .external_lex_state = 8},
  [356] = {.lex_state = 191, .external_lex_state = 8},
  [357] = {.lex_state = 276},
  [358] = {.lex_state = 247, .external_lex_state = 4},
  [359] = {.lex_state = 123},
  [360] = {.lex_state = 253},
  [361] = {.lex_state = 253},
  [362] = {.lex_state = 191, .external_lex_state = 8},
  [363] = {.lex_state = 255},
  [364] = {.lex_state = 123},
  [365] = {.lex_state = 191, .external_lex_state = 8},
  [366] = {.lex_state = 255},
  [367] = {.lex_state = 123},
  [368] = {.lex_state = 191, .external_lex_state = 8},
  [369] = {.lex_state = 191, .external_lex_state = 8},
  [370] = {.lex_state = 259},
  [371] = {.lex_state = 195, .external_lex_state = 4},
  [372] = {.lex_state = 249, .external_lex_state = 2},
  [373] = {.lex_state = 251, .external_lex_state = 9},
  [374] = {.lex_state = 251, .external_lex_state = 9},
  [375] = {.lex_state = 123},
  [376] = {.lex_state = 253},
  [377] = {.lex_state = 253},
  [378] = {.lex_state = 251, .external_lex_state = 9},
  [379] = {.lex_state = 255},
  [380] = {.lex_state = 123},
  [381] = {.lex_state = 251, .external_lex_state = 9},
  [382] = {.lex_state = 255},
  [383] = {.lex_state = 123},
  [384] = {.lex_state = 251, .external_lex_state = 9},
  [385] = {.lex_state = 251, .external_lex_state = 9},
  [386] = {.lex_state = 221, .external_lex_state = 10},
  [387] = {.lex_state = 221, .external_lex_state = 10},
  [388] = {.lex_state = 123},
  [389] = {.lex_state = 253},
  [390] = {.lex_state = 253},
  [391] = {.lex_state = 221, .external_lex_state = 10},
  [392] = {.lex_state = 255},
  [393] = {.lex_state = 123},
  [394] = {.lex_state = 221, .external_lex_state = 10},
  [395] = {.lex_state = 255},
  [396] = {.lex_state = 123},
  [397] = {.lex_state = 221, .external_lex_state = 10},
  [398] = {.lex_state = 221, .external_lex_state = 10},
  [399] = {.lex_state = 253},
  [400] = {.lex_state = 253},
  [401] = {.lex_state = 127},
  [402] = {.lex_state = 255},
  [403] = {.lex_state = 123},
  [404] = {.lex_state = 127},
  [405] = {.lex_state = 255},
  [406] = {.lex_state = 123},
  [407] = {.lex_state = 127},
  [408] = {.lex_state = 132, .external_lex_state = 3},
  [409] = {.lex_state = 132, .external_lex_state = 3},
  [410] = {.lex_state = 255},
  [411] = {.lex_state = 132, .external_lex_state = 3},
  [412] = {.lex_state = 255},
  [413] = {.lex_state = 236},
  [414] = {.lex_state = 282, .external_lex_state = 9},
  [415] = {.lex_state = 282},
  [416] = {.lex_state = 236},
  [417] = {.lex_state = 282, .external_lex_state = 9},
  [418] = {.lex_state = 282},
  [419] = {.lex_state = 221, .external_lex_state = 2},
  [420] = {.lex_state = 239},
  [421] = {.lex_state = 221, .external_lex_state = 10},
  [422] = {.lex_state = 123},
  [423] = {.lex_state = 241, .external_lex_state = 2},
  [424] = {.lex_state = 284},
  [425] = {.lex_state = 245, .external_lex_state = 2},
  [426] = {.lex_state = 247, .external_lex_state = 4},
  [427] = {.lex_state = 182},
  [428] = {.lex_state = 229},
  [429] = {.lex_state = 284},
  [430] = {.lex_state = 249, .external_lex_state = 2},
  [431] = {.lex_state = 195, .external_lex_state = 4},
  [432] = {.lex_state = 197, .external_lex_state = 6},
  [433] = {.lex_state = 284},
  [434] = {.lex_state = 213, .external_lex_state = 11},
  [435] = {.lex_state = 213, .external_lex_state = 11},
  [436] = {.lex_state = 123},
  [437] = {.lex_state = 253},
  [438] = {.lex_state = 253},
  [439] = {.lex_state = 213, .external_lex_state = 11},
  [440] = {.lex_state = 255},
  [441] = {.lex_state = 123},
  [442] = {.lex_state = 213, .external_lex_state = 11},
  [443] = {.lex_state = 255},
  [444] = {.lex_state = 123},
  [445] = {.lex_state = 213, .external_lex_state = 11},
  [446] = {.lex_state = 213, .external_lex_state = 11},
  [447] = {.lex_state = 259},
  [448] = {.lex_state = 284},
  [449] = {.lex_state = 221, .external_lex_state = 2},
  [450] = {.lex_state = 218},
  [451] = {.lex_state = 221, .external_lex_state = 2},
  [452] = {.lex_state = 123},
  [453] = {.lex_state = 127},
  [454] = {.lex_state = 257, .external_lex_state = 11},
  [455] = {.lex_state = 145},
  [456] = {.lex_state = 145},
  [457] = {.lex_state = 121, .external_lex_state = 2},
  [458] = {.lex_state = 121, .external_lex_state = 2},
  [459] = {.lex_state = 121, .external_lex_state = 2},
  [460] = {.lex_state = 257, .external_lex_state = 12},
  [461] = {.lex_state = 257, .external_lex_state = 12},
  [462] = {.lex_state = 261, .external_lex_state = 15},
  [463] = {.lex_state = 257, .external_lex_state = 12},
  [464] = {.lex_state = 213, .external_lex_state = 11},
  [465] = {.lex_state = 213, .external_lex_state = 12},
  [466] = {.lex_state = 257, .external_lex_state = 12},
  [467] = {.lex_state = 257, .external_lex_state = 12},
  [468] = {.lex_state = 213, .external_lex_state = 12},
  [469] = {.lex_state = 227, .external_lex_state = 2},
  [470] = {.lex_state = 223},
  [471] = {.lex_state = 227, .external_lex_state = 2},
  [472] = {.lex_state = 225, .external_lex_state = 12},
  [473] = {.lex_state = 286, .external_lex_state = 2},
  [474] = {.lex_state = 195, .external_lex_state = 4},
  [475] = {.lex_state = 233, .external_lex_state = 3},
  [476] = {.lex_state = 233, .external_lex_state = 5},
  [477] = {.lex_state = 233, .external_lex_state = 3},
  [478] = {.lex_state = 127},
  [479] = {.lex_state = 123},
  [480] = {.lex_state = 233, .external_lex_state = 3},
  [481] = {.lex_state = 233, .external_lex_state = 3},
  [482] = {.lex_state = 233, .external_lex_state = 3},
  [483] = {.lex_state = 233, .external_lex_state = 3},
  [484] = {.lex_state = 211},
  [485] = {.lex_state = 209},
  [486] = {.lex_state = 209},
  [487] = {.lex_state = 218},
  [488] = {.lex_state = 221, .external_lex_state = 2},
  [489] = {.lex_state = 223},
  [490] = {.lex_state = 227, .external_lex_state = 2},
  [491] = {.lex_state = 218},
  [492] = {.lex_state = 221, .external_lex_state = 2},
  [493] = {.lex_state = 261, .external_lex_state = 15},
  [494] = {.lex_state = 233, .external_lex_state = 5},
  [495] = {.lex_state = 145},
  [496] = {.lex_state = 145},
  [497] = {.lex_state = 261, .external_lex_state = 15},
  [498] = {.lex_state = 233, .external_lex_state = 5},
  [499] = {.lex_state = 264, .external_lex_state = 9},
  [500] = {.lex_state = 264, .external_lex_state = 9},
  [501] = {.lex_state = 123},
  [502] = {.lex_state = 253},
  [503] = {.lex_state = 253},
  [504] = {.lex_state = 264, .external_lex_state = 9},
  [505] = {.lex_state = 255},
  [506] = {.lex_state = 123},
  [507] = {.lex_state = 264, .external_lex_state = 9},
  [508] = {.lex_state = 255},
  [509] = {.lex_state = 123},
  [510] = {.lex_state = 264, .external_lex_state = 9},
  [511] = {.lex_state = 264, .external_lex_state = 9},
  [512] = {.lex_state = 197, .external_lex_state = 6},
  [513] = {.lex_state = 239},
  [514] = {.lex_state = 197, .external_lex_state = 14},
  [515] = {.lex_state = 197, .external_lex_state = 14},
  [516] = {.lex_state = 123},
  [517] = {.lex_state = 253},
  [518] = {.lex_state = 253},
  [519] = {.lex_state = 197, .external_lex_state = 14},
  [520] = {.lex_state = 255},
  [521] = {.lex_state = 123},
  [522] = {.lex_state = 197, .external_lex_state = 14},
  [523] = {.lex_state = 255},
  [524] = {.lex_state = 123},
  [525] = {.lex_state = 197, .external_lex_state = 14},
  [526] = {.lex_state = 197, .external_lex_state = 14},
  [527] = {.lex_state = 266, .external_lex_state = 8},
  [528] = {.lex_state = 127},
  [529] = {.lex_state = 123},
  [530] = {.lex_state = 266, .external_lex_state = 8},
  [531] = {.lex_state = 266, .external_lex_state = 8},
  [532] = {.lex_state = 266, .external_lex_state = 8},
  [533] = {.lex_state = 266, .external_lex_state = 8},
  [534] = {.lex_state = 211},
  [535] = {.lex_state = 209},
  [536] = {.lex_state = 209},
  [537] = {.lex_state = 218},
  [538] = {.lex_state = 221, .external_lex_state = 2},
  [539] = {.lex_state = 223},
  [540] = {.lex_state = 227, .external_lex_state = 2},
  [541] = {.lex_state = 218},
  [542] = {.lex_state = 221, .external_lex_state = 2},
  [543] = {.lex_state = 185},
  [544] = {.lex_state = 266, .external_lex_state = 8},
  [545] = {.lex_state = 266, .external_lex_state = 4},
  [546] = {.lex_state = 195, .external_lex_state = 4},
  [547] = {.lex_state = 189},
  [548] = {.lex_state = 268, .external_lex_state = 2},
  [549] = {.lex_state = 195, .external_lex_state = 4},
  [550] = {.lex_state = 274},
  [551] = {.lex_state = 270},
  [552] = {.lex_state = 270},
  [553] = {.lex_state = 195, .external_lex_state = 4},
  [554] = {.lex_state = 288, .external_lex_state = 9},
  [555] = {.lex_state = 276},
  [556] = {.lex_state = 288},
  [557] = {.lex_state = 276},
  [558] = {.lex_state = 276},
  [559] = {.lex_state = 191, .external_lex_state = 8},
  [560] = {.lex_state = 191, .external_lex_state = 8},
  [561] = {.lex_state = 255},
  [562] = {.lex_state = 191, .external_lex_state = 8},
  [563] = {.lex_state = 255},
  [564] = {.lex_state = 236},
  [565] = {.lex_state = 282, .external_lex_state = 9},
  [566] = {.lex_state = 282},
  [567] = {.lex_state = 236},
  [568] = {.lex_state = 282, .external_lex_state = 9},
  [569] = {.lex_state = 282},
  [570] = {.lex_state = 195, .external_lex_state = 4},
  [571] = {.lex_state = 195, .external_lex_state = 4},
  [572] = {.lex_state = 251, .external_lex_state = 9},
  [573] = {.lex_state = 251, .external_lex_state = 9},
  [574] = {.lex_state = 255},
  [575] = {.lex_state = 251, .external_lex_state = 9},
  [576] = {.lex_state = 255},
  [577] = {.lex_state = 236},
  [578] = {.lex_state = 282, .external_lex_state = 9},
  [579] = {.lex_state = 282},
  [580] = {.lex_state = 236},
  [581] = {.lex_state = 282, .external_lex_state = 9},
  [582] = {.lex_state = 282},
  [583] = {.lex_state = 221, .external_lex_state = 10},
  [584] = {.lex_state = 221, .external_lex_state = 10},
  [585] = {.lex_state = 255},
  [586] = {.lex_state = 221, .external_lex_state = 10},
  [587] = {.lex_state = 255},
  [588] = {.lex_state = 236},
  [589] = {.lex_state = 282, .external_lex_state = 9},
  [590] = {.lex_state = 282},
  [591] = {.lex_state = 236},
  [592] = {.lex_state = 282, .external_lex_state = 9},
  [593] = {.lex_state = 282},
  [594] = {.lex_state = 127},
  [595] = {.lex_state = 255},
  [596] = {.lex_state = 127},
  [597] = {.lex_state = 255},
  [598] = {.lex_state = 236},
  [599] = {.lex_state = 282, .external_lex_state = 9},
  [600] = {.lex_state = 282},
  [601] = {.lex_state = 236},
  [602] = {.lex_state = 282, .external_lex_state = 9},
  [603] = {.lex_state = 282},
  [604] = {.lex_state = 236},
  [605] = {.lex_state = 236},
  [606] = {.lex_state = 282},
  [607] = {.lex_state = 132, .external_lex_state = 3},
  [608] = {.lex_state = 282},
  [609] = {.lex_state = 132, .external_lex_state = 3},
  [610] = {.lex_state = 221, .external_lex_state = 2},
  [611] = {.lex_state = 239},
  [612] = {.lex_state = 266, .external_lex_state = 4},
  [613] = {.lex_state = 284},
  [614] = {.lex_state = 241, .external_lex_state = 2},
  [615] = {.lex_state = 284},
  [616] = {.lex_state = 274},
  [617] = {.lex_state = 245, .external_lex_state = 2},
  [618] = {.lex_state = 270},
  [619] = {.lex_state = 276},
  [620] = {.lex_state = 247, .external_lex_state = 4},
  [621] = {.lex_state = 259},
  [622] = {.lex_state = 284},
  [623] = {.lex_state = 249, .external_lex_state = 2},
  [624] = {.lex_state = 213, .external_lex_state = 11},
  [625] = {.lex_state = 213, .external_lex_state = 11},
  [626] = {.lex_state = 255},
  [627] = {.lex_state = 213, .external_lex_state = 11},
  [628] = {.lex_state = 255},
  [629] = {.lex_state = 236},
  [630] = {.lex_state = 282, .external_lex_state = 9},
  [631] = {.lex_state = 282},
  [632] = {.lex_state = 236},
  [633] = {.lex_state = 282, .external_lex_state = 9},
  [634] = {.lex_state = 282},
  [635] = {.lex_state = 286, .external_lex_state = 2},
  [636] = {.lex_state = 284},
  [637] = {.lex_state = 257, .external_lex_state = 11},
  [638] = {.lex_state = 257, .external_lex_state = 12},
  [639] = {.lex_state = 257, .external_lex_state = 11},
  [640] = {.lex_state = 127},
  [641] = {.lex_state = 123},
  [642] = {.lex_state = 257, .external_lex_state = 11},
  [643] = {.lex_state = 257, .external_lex_state = 11},
  [644] = {.lex_state = 257, .external_lex_state = 11},
  [645] = {.lex_state = 257, .external_lex_state = 11},
  [646] = {.lex_state = 211},
  [647] = {.lex_state = 209},
  [648] = {.lex_state = 209},
  [649] = {.lex_state = 218},
  [650] = {.lex_state = 221, .external_lex_state = 2},
  [651] = {.lex_state = 223},
  [652] = {.lex_state = 227, .external_lex_state = 2},
  [653] = {.lex_state = 218},
  [654] = {.lex_state = 221, .external_lex_state = 2},
  [655] = {.lex_state = 257, .external_lex_state = 12},
  [656] = {.lex_state = 261, .external_lex_state = 15},
  [657] = {.lex_state = 257, .external_lex_state = 12},
  [658] = {.lex_state = 195, .external_lex_state = 4},
  [659] = {.lex_state = 286, .external_lex_state = 2},
  [660] = {.lex_state = 233, .external_lex_state = 3},
  [661] = {.lex_state = 233, .external_lex_state = 3},
  [662] = {.lex_state = 123},
  [663] = {.lex_state = 253},
  [664] = {.lex_state = 253},
  [665] = {.lex_state = 233, .external_lex_state = 3},
  [666] = {.lex_state = 255},
  [667] = {.lex_state = 123},
  [668] = {.lex_state = 233, .external_lex_state = 3},
  [669] = {.lex_state = 255},
  [670] = {.lex_state = 123},
  [671] = {.lex_state = 233, .external_lex_state = 3},
  [672] = {.lex_state = 233, .external_lex_state = 3},
  [673] = {.lex_state = 261, .external_lex_state = 15},
  [674] = {.lex_state = 261, .external_lex_state = 15},
  [675] = {.lex_state = 261, .external_lex_state = 15},
  [676] = {.lex_state = 211},
  [677] = {.lex_state = 209},
  [678] = {.lex_state = 209},
  [679] = {.lex_state = 261, .external_lex_state = 15},
  [680] = {.lex_state = 233, .external_lex_state = 5},
  [681] = {.lex_state = 264, .external_lex_state = 9},
  [682] = {.lex_state = 264, .external_lex_state = 9},
  [683] = {.lex_state = 255},
  [684] = {.lex_state = 264, .external_lex_state = 9},
  [685] = {.lex_state = 255},
  [686] = {.lex_state = 236},
  [687] = {.lex_state = 282, .external_lex_state = 9},
  [688] = {.lex_state = 282},
  [689] = {.lex_state = 236},
  [690] = {.lex_state = 282, .external_lex_state = 9},
  [691] = {.lex_state = 282},
  [692] = {.lex_state = 197, .external_lex_state = 14},
  [693] = {.lex_state = 197, .external_lex_state = 14},
  [694] = {.lex_state = 255},
  [695] = {.lex_state = 197, .external_lex_state = 14},
  [696] = {.lex_state = 255},
  [697] = {.lex_state = 236},
  [698] = {.lex_state = 282, .external_lex_state = 9},
  [699] = {.lex_state = 282},
  [700] = {.lex_state = 236},
  [701] = {.lex_state = 282, .external_lex_state = 9},
  [702] = {.lex_state = 282},
  [703] = {.lex_state = 266, .external_lex_state = 8},
  [704] = {.lex_state = 266, .external_lex_state = 8},
  [705] = {.lex_state = 123},
  [706] = {.lex_state = 253},
  [707] = {.lex_state = 253},
  [708] = {.lex_state = 266, .external_lex_state = 8},
  [709] = {.lex_state = 255},
  [710] = {.lex_state = 123},
  [711] = {.lex_state = 266, .external_lex_state = 8},
  [712] = {.lex_state = 255},
  [713] = {.lex_state = 123},
  [714] = {.lex_state = 266, .external_lex_state = 8},
  [715] = {.lex_state = 266, .external_lex_state = 8},
  [716] = {.lex_state = 195, .external_lex_state = 4},
  [717] = {.lex_state = 245, .external_lex_state = 2},
  [718] = {.lex_state = 195, .external_lex_state = 4},
  [719] = {.lex_state = 274},
  [720] = {.lex_state = 123},
  [721] = {.lex_state = 290, .external_lex_state = 2},
  [722] = {.lex_state = 288},
  [723] = {.lex_state = 195, .external_lex_state = 4},
  [724] = {.lex_state = 276},
  [725] = {.lex_state = 276},
  [726] = {.lex_state = 236},
  [727] = {.lex_state = 236},
  [728] = {.lex_state = 282},
  [729] = {.lex_state = 191, .external_lex_state = 8},
  [730] = {.lex_state = 282},
  [731] = {.lex_state = 191, .external_lex_state = 8},
  [732] = {.lex_state = 236},
  [733] = {.lex_state = 236},
  [734] = {.lex_state = 282},
  [735] = {.lex_state = 251, .external_lex_state = 9},
  [736] = {.lex_state = 282},
  [737] = {.lex_state = 251, .external_lex_state = 9},
  [738] = {.lex_state = 236},
  [739] = {.lex_state = 236},
  [740] = {.lex_state = 282},
  [741] = {.lex_state = 221, .external_lex_state = 10},
  [742] = {.lex_state = 282},
  [743] = {.lex_state = 221, .external_lex_state = 10},
  [744] = {.lex_state = 236},
  [745] = {.lex_state = 236},
  [746] = {.lex_state = 282},
  [747] = {.lex_state = 127},
  [748] = {.lex_state = 282},
  [749] = {.lex_state = 127},
  [750] = {.lex_state = 282},
  [751] = {.lex_state = 282},
  [752] = {.lex_state = 132, .external_lex_state = 3},
  [753] = {.lex_state = 132, .external_lex_state = 3},
  [754] = {.lex_state = 221, .external_lex_state = 2},
  [755] = {.lex_state = 185},
  [756] = {.lex_state = 284},
  [757] = {.lex_state = 284},
  [758] = {.lex_state = 274},
  [759] = {.lex_state = 270},
  [760] = {.lex_state = 284},
  [761] = {.lex_state = 276},
  [762] = {.lex_state = 276},
  [763] = {.lex_state = 284},
  [764] = {.lex_state = 284},
  [765] = {.lex_state = 236},
  [766] = {.lex_state = 236},
  [767] = {.lex_state = 282},
  [768] = {.lex_state = 213, .external_lex_state = 11},
  [769] = {.lex_state = 282},
  [770] = {.lex_state = 213, .external_lex_state = 11},
  [771] = {.lex_state = 284},
  [772] = {.lex_state = 286, .external_lex_state = 2},
  [773] = {.lex_state = 257, .external_lex_state = 11},
  [774] = {.lex_state = 257, .external_lex_state = 11},
  [775] = {.lex_state = 123},
  [776] = {.lex_state = 253},
  [777] = {.lex_state = 253},
  [778] = {.lex_state = 257, .external_lex_state = 11},
  [779] = {.lex_state = 255},
  [780] = {.lex_state = 123},
  [781] = {.lex_state = 257, .external_lex_state = 11},
  [782] = {.lex_state = 255},
  [783] = {.lex_state = 123},
  [784] = {.lex_state = 257, .external_lex_state = 11},
  [785] = {.lex_state = 257, .external_lex_state = 11},
  [786] = {.lex_state = 257, .external_lex_state = 12},
  [787] = {.lex_state = 195, .external_lex_state = 4},
  [788] = {.lex_state = 233, .external_lex_state = 3},
  [789] = {.lex_state = 233, .external_lex_state = 3},
  [790] = {.lex_state = 255},
  [791] = {.lex_state = 233, .external_lex_state = 3},
  [792] = {.lex_state = 255},
  [793] = {.lex_state = 236},
  [794] = {.lex_state = 282, .external_lex_state = 9},
  [795] = {.lex_state = 282},
  [796] = {.lex_state = 236},
  [797] = {.lex_state = 282, .external_lex_state = 9},
  [798] = {.lex_state = 282},
  [799] = {.lex_state = 253},
  [800] = {.lex_state = 253},
  [801] = {.lex_state = 261, .external_lex_state = 15},
  [802] = {.lex_state = 255},
  [803] = {.lex_state = 123},
  [804] = {.lex_state = 261, .external_lex_state = 15},
  [805] = {.lex_state = 255},
  [806] = {.lex_state = 123},
  [807] = {.lex_state = 236},
  [808] = {.lex_state = 236},
  [809] = {.lex_state = 282},
  [810] = {.lex_state = 264, .external_lex_state = 9},
  [811] = {.lex_state = 282},
  [812] = {.lex_state = 264, .external_lex_state = 9},
  [813] = {.lex_state = 236},
  [814] = {.lex_state = 236},
  [815] = {.lex_state = 282},
  [816] = {.lex_state = 197, .external_lex_state = 14},
  [817] = {.lex_state = 282},
  [818] = {.lex_state = 197, .external_lex_state = 14},
  [819] = {.lex_state = 266, .external_lex_state = 8},
  [820] = {.lex_state = 266, .external_lex_state = 8},
  [821] = {.lex_state = 255},
  [822] = {.lex_state = 266, .external_lex_state = 8},
  [823] = {.lex_state = 255},
  [824] = {.lex_state = 236},
  [825] = {.lex_state = 282, .external_lex_state = 9},
  [826] = {.lex_state = 282},
  [827] = {.lex_state = 236},
  [828] = {.lex_state = 282, .external_lex_state = 9},
  [829] = {.lex_state = 282},
  [830] = {.lex_state = 245, .external_lex_state = 2},
  [831] = {.lex_state = 195, .external_lex_state = 4},
  [832] = {.lex_state = 288, .external_lex_state = 9},
  [833] = {.lex_state = 288},
  [834] = {.lex_state = 276},
  [835] = {.lex_state = 290, .external_lex_state = 2},
  [836] = {.lex_state = 123},
  [837] = {.lex_state = 290, .external_lex_state = 2},
  [838] = {.lex_state = 195, .external_lex_state = 4},
  [839] = {.lex_state = 282},
  [840] = {.lex_state = 282},
  [841] = {.lex_state = 191, .external_lex_state = 8},
  [842] = {.lex_state = 191, .external_lex_state = 8},
  [843] = {.lex_state = 282},
  [844] = {.lex_state = 282},
  [845] = {.lex_state = 251, .external_lex_state = 9},
  [846] = {.lex_state = 251, .external_lex_state = 9},
  [847] = {.lex_state = 282},
  [848] = {.lex_state = 282},
  [849] = {.lex_state = 221, .external_lex_state = 10},
  [850] = {.lex_state = 221, .external_lex_state = 10},
  [851] = {.lex_state = 282},
  [852] = {.lex_state = 282},
  [853] = {.lex_state = 127},
  [854] = {.lex_state = 127},
  [855] = {.lex_state = 132, .external_lex_state = 3},
  [856] = {.lex_state = 132, .external_lex_state = 3},
  [857] = {.lex_state = 284},
  [858] = {.lex_state = 284},
  [859] = {.lex_state = 274},
  [860] = {.lex_state = 284},
  [861] = {.lex_state = 276},
  [862] = {.lex_state = 282},
  [863] = {.lex_state = 282},
  [864] = {.lex_state = 213, .external_lex_state = 11},
  [865] = {.lex_state = 213, .external_lex_state = 11},
  [866] = {.lex_state = 284},
  [867] = {.lex_state = 257, .external_lex_state = 11},
  [868] = {.lex_state = 257, .external_lex_state = 11},
  [869] = {.lex_state = 255},
  [870] = {.lex_state = 257, .external_lex_state = 11},
  [871] = {.lex_state = 255},
  [872] = {.lex_state = 236},
  [873] = {.lex_state = 282, .external_lex_state = 9},
  [874] = {.lex_state = 282},
  [875] = {.lex_state = 236},
  [876] = {.lex_state = 282, .external_lex_state = 9},
  [877] = {.lex_state = 282},
  [878] = {.lex_state = 236},
  [879] = {.lex_state = 236},
  [880] = {.lex_state = 282},
  [881] = {.lex_state = 233, .external_lex_state = 3},
  [882] = {.lex_state = 282},
  [883] = {.lex_state = 233, .external_lex_state = 3},
  [884] = {.lex_state = 261, .external_lex_state = 15},
  [885] = {.lex_state = 255},
  [886] = {.lex_state = 261, .external_lex_state = 15},
  [887] = {.lex_state = 255},
  [888] = {.lex_state = 236},
  [889] = {.lex_state = 282, .external_lex_state = 9},
  [890] = {.lex_state = 282},
  [891] = {.lex_state = 236},
  [892] = {.lex_state = 282, .external_lex_state = 9},
  [893] = {.lex_state = 282},
  [894] = {.lex_state = 282},
  [895] = {.lex_state = 282},
  [896] = {.lex_state = 264, .external_lex_state = 9},
  [897] = {.lex_state = 264, .external_lex_state = 9},
  [898] = {.lex_state = 282},
  [899] = {.lex_state = 282},
  [900] = {.lex_state = 197, .external_lex_state = 14},
  [901] = {.lex_state = 197, .external_lex_state = 14},
  [902] = {.lex_state = 236},
  [903] = {.lex_state = 236},
  [904] = {.lex_state = 282},
  [905] = {.lex_state = 266, .external_lex_state = 8},
  [906] = {.lex_state = 282},
  [907] = {.lex_state = 266, .external_lex_state = 8},
  [908] = {.lex_state = 276},
  [909] = {.lex_state = 288, .external_lex_state = 9},
  [910] = {.lex_state = 288},
  [911] = {.lex_state = 290, .external_lex_state = 2},
  [912] = {.lex_state = 191, .external_lex_state = 8},
  [913] = {.lex_state = 191, .external_lex_state = 8},
  [914] = {.lex_state = 251, .external_lex_state = 9},
  [915] = {.lex_state = 251, .external_lex_state = 9},
  [916] = {.lex_state = 221, .external_lex_state = 10},
  [917] = {.lex_state = 221, .external_lex_state = 10},
  [918] = {.lex_state = 127},
  [919] = {.lex_state = 127},
  [920] = {.lex_state = 284},
  [921] = {.lex_state = 284},
  [922] = {.lex_state = 213, .external_lex_state = 11},
  [923] = {.lex_state = 213, .external_lex_state = 11},
  [924] = {.lex_state = 236},
  [925] = {.lex_state = 236},
  [926] = {.lex_state = 282},
  [927] = {.lex_state = 257, .external_lex_state = 11},
  [928] = {.lex_state = 282},
  [929] = {.lex_state = 257, .external_lex_state = 11},
  [930] = {.lex_state = 282},
  [931] = {.lex_state = 282},
  [932] = {.lex_state = 233, .external_lex_state = 3},
  [933] = {.lex_state = 233, .external_lex_state = 3},
  [934] = {.lex_state = 236},
  [935] = {.lex_state = 236},
  [936] = {.lex_state = 282},
  [937] = {.lex_state = 261, .external_lex_state = 15},
  [938] = {.lex_state = 282},
  [939] = {.lex_state = 261, .external_lex_state = 15},
  [940] = {.lex_state = 264, .external_lex_state = 9},
  [941] = {.lex_state = 264, .external_lex_state = 9},
  [942] = {.lex_state = 197, .external_lex_state = 14},
  [943] = {.lex_state = 197, .external_lex_state = 14},
  [944] = {.lex_state = 282},
  [945] = {.lex_state = 282},
  [946] = {.lex_state = 266, .external_lex_state = 8},
  [947] = {.lex_state = 266, .external_lex_state = 8},
  [948] = {.lex_state = 276},
  [949] = {.lex_state = 282},
  [950] = {.lex_state = 282},
  [951] = {.lex_state = 257, .external_lex_state = 11},
  [952] = {.lex_state = 257, .external_lex_state = 11},
  [953] = {.lex_state = 233, .external_lex_state = 3},
  [954] = {.lex_state = 233, .external_lex_state = 3},
  [955] = {.lex_state = 282},
  [956] = {.lex_state = 282},
  [957] = {.lex_state = 261, .external_lex_state = 15},
  [958] = {.lex_state = 261, .external_lex_state = 15},
  [959] = {.lex_state = 266, .external_lex_state = 8},
  [960] = {.lex_state = 266, .external_lex_state = 8},
  [961] = {.lex_state = 257, .external_lex_state = 11},
  [962] = {.lex_state = 257, .external_lex_state = 11},
  [963] = {.lex_state = 261, .external_lex_state = 15},
  [964] = {.lex_state = 261, .external_lex_state = 15},
  [965] = {.lex_state = 119},
  [966] = {.lex_state = 266, .external_lex_state = 4},
  [967] = {.lex_state = 121, .external_lex_state = 2},
  [968] = {.lex_state = 241, .external_lex_state = 2},
  [969] = {.lex_state = 292, .external_lex_state = 4},
  [970] = {.lex_state = 121, .external_lex_state = 2},
  [971] = {.lex_state = 245, .external_lex_state = 2},
  [972] = {.lex_state = 292, .external_lex_state = 4},
  [973] = {.lex_state = 123},
  [974] = {.lex_state = 292, .external_lex_state = 4},
  [975] = {.lex_state = 121, .external_lex_state = 2},
  [976] = {.lex_state = 294, .external_lex_state = 14},
  [977] = {.lex_state = 119},
  [978] = {.lex_state = 249, .external_lex_state = 2},
  [979] = {.lex_state = 286, .external_lex_state = 2},
  [980] = {.lex_state = 349, .external_lex_state = 16},
  [981] = {.lex_state = 354},
  [982] = {.lex_state = 357, .external_lex_state = 4},
  [983] = {.lex_state = 292, .external_lex_state = 4},
  [984] = {.lex_state = 180, .external_lex_state = 7},
  [985] = {.lex_state = 123},
  [986] = {.lex_state = 349, .external_lex_state = 14},
  [987] = {.lex_state = 359, .external_lex_state = 14},
  [988] = {.lex_state = 363, .external_lex_state = 16},
  [989] = {.lex_state = 363, .external_lex_state = 16},
  [990] = {.lex_state = 385, .external_lex_state = 16},
  [991] = {.lex_state = 123},
  [992] = {.lex_state = 389, .external_lex_state = 14},
  [993] = {.lex_state = 121, .external_lex_state = 2},
  [994] = {.lex_state = 385, .external_lex_state = 16},
  [995] = {.lex_state = 393, .external_lex_state = 2},
  [996] = {.lex_state = 403, .external_lex_state = 5},
  [997] = {.lex_state = 261, .external_lex_state = 15},
  [998] = {.lex_state = 261, .external_lex_state = 15},
  [999] = {.lex_state = 403, .external_lex_state = 5},
  [1000] = {.lex_state = 113},
  [1001] = {.lex_state = 123},
  [1002] = {.lex_state = 405, .external_lex_state = 2},
  [1003] = {.lex_state = 292, .external_lex_state = 4},
  [1004] = {.lex_state = 292, .external_lex_state = 4},
  [1005] = {.lex_state = 270},
  [1006] = {.lex_state = 274},
  [1007] = {.lex_state = 276},
  [1008] = {.lex_state = 292, .external_lex_state = 4},
  [1009] = {.lex_state = 132, .external_lex_state = 5},
  [1010] = {.lex_state = 197, .external_lex_state = 6},
  [1011] = {.lex_state = 132, .external_lex_state = 6},
  [1012] = {.lex_state = 403, .external_lex_state = 5},
  [1013] = {.lex_state = 403, .external_lex_state = 5},
  [1014] = {.lex_state = 359, .external_lex_state = 6},
  [1015] = {.lex_state = 349, .external_lex_state = 16},
  [1016] = {.lex_state = 349, .external_lex_state = 14},
  [1017] = {.lex_state = 385, .external_lex_state = 16},
  [1018] = {.lex_state = 154, .external_lex_state = 2},
  [1019] = {.lex_state = 407, .external_lex_state = 5},
  [1020] = {.lex_state = 270},
  [1021] = {.lex_state = 276},
  [1022] = {.lex_state = 178, .external_lex_state = 2},
  [1023] = {.lex_state = 403, .external_lex_state = 5},
  [1024] = {.lex_state = 261, .external_lex_state = 15},
  [1025] = {.lex_state = 359, .external_lex_state = 14},
  [1026] = {.lex_state = 127},
  [1027] = {.lex_state = 182},
  [1028] = {.lex_state = 276},
  [1029] = {.lex_state = 266, .external_lex_state = 4},
  [1030] = {.lex_state = 185},
  [1031] = {.lex_state = 292, .external_lex_state = 4},
  [1032] = {.lex_state = 241, .external_lex_state = 2},
  [1033] = {.lex_state = 189},
  [1034] = {.lex_state = 292, .external_lex_state = 4},
  [1035] = {.lex_state = 274},
  [1036] = {.lex_state = 245, .external_lex_state = 2},
  [1037] = {.lex_state = 270},
  [1038] = {.lex_state = 191, .external_lex_state = 8},
  [1039] = {.lex_state = 191, .external_lex_state = 4},
  [1040] = {.lex_state = 121, .external_lex_state = 2},
  [1041] = {.lex_state = 123},
  [1042] = {.lex_state = 123},
  [1043] = {.lex_state = 132, .external_lex_state = 3},
  [1044] = {.lex_state = 150, .external_lex_state = 3},
  [1045] = {.lex_state = 292, .external_lex_state = 4},
  [1046] = {.lex_state = 132, .external_lex_state = 5},
  [1047] = {.lex_state = 197, .external_lex_state = 6},
  [1048] = {.lex_state = 132, .external_lex_state = 5},
  [1049] = {.lex_state = 276},
  [1050] = {.lex_state = 290, .external_lex_state = 2},
  [1051] = {.lex_state = 193},
  [1052] = {.lex_state = 409, .external_lex_state = 6},
  [1053] = {.lex_state = 150, .external_lex_state = 3},
  [1054] = {.lex_state = 195, .external_lex_state = 4},
  [1055] = {.lex_state = 197, .external_lex_state = 6},
  [1056] = {.lex_state = 121, .external_lex_state = 2},
  [1057] = {.lex_state = 292, .external_lex_state = 4},
  [1058] = {.lex_state = 286, .external_lex_state = 2},
  [1059] = {.lex_state = 203, .external_lex_state = 9},
  [1060] = {.lex_state = 236},
  [1061] = {.lex_state = 203},
  [1062] = {.lex_state = 203},
  [1063] = {.lex_state = 349, .external_lex_state = 16},
  [1064] = {.lex_state = 127},
  [1065] = {.lex_state = 411, .external_lex_state = 14},
  [1066] = {.lex_state = 145},
  [1067] = {.lex_state = 145},
  [1068] = {.lex_state = 121, .external_lex_state = 2},
  [1069] = {.lex_state = 121, .external_lex_state = 2},
  [1070] = {.lex_state = 121, .external_lex_state = 2},
  [1071] = {.lex_state = 411, .external_lex_state = 6},
  [1072] = {.lex_state = 127},
  [1073] = {.lex_state = 132, .external_lex_state = 14},
  [1074] = {.lex_state = 145},
  [1075] = {.lex_state = 145},
  [1076] = {.lex_state = 121, .external_lex_state = 2},
  [1077] = {.lex_state = 121, .external_lex_state = 2},
  [1078] = {.lex_state = 121, .external_lex_state = 2},
  [1079] = {.lex_state = 132, .external_lex_state = 6},
  [1080] = {.lex_state = 359, .external_lex_state = 14},
  [1081] = {.lex_state = 123},
  [1082] = {.lex_state = 247, .external_lex_state = 4},
  [1083] = {.lex_state = 182},
  [1084] = {.lex_state = 349, .external_lex_state = 16},
  [1085] = {.lex_state = 349, .external_lex_state = 16},
  [1086] = {.lex_state = 349, .external_lex_state = 16},
  [1087] = {.lex_state = 349, .external_lex_state = 16},
  [1088] = {.lex_state = 253},
  [1089] = {.lex_state = 253},
  [1090] = {.lex_state = 282},
  [1091] = {.lex_state = 282, .external_lex_state = 9},
  [1092] = {.lex_state = 282},
  [1093] = {.lex_state = 223},
  [1094] = {.lex_state = 227, .external_lex_state = 2},
  [1095] = {.lex_state = 218},
  [1096] = {.lex_state = 221, .external_lex_state = 2},
  [1097] = {.lex_state = 247, .external_lex_state = 4},
  [1098] = {.lex_state = 292, .external_lex_state = 4},
  [1099] = {.lex_state = 292, .external_lex_state = 4},
  [1100] = {.lex_state = 292, .external_lex_state = 4},
  [1101] = {.lex_state = 403, .external_lex_state = 5},
  [1102] = {.lex_state = 123},
  [1103] = {.lex_state = 127},
  [1104] = {.lex_state = 359, .external_lex_state = 14},
  [1105] = {.lex_state = 145},
  [1106] = {.lex_state = 145},
  [1107] = {.lex_state = 121, .external_lex_state = 2},
  [1108] = {.lex_state = 121, .external_lex_state = 2},
  [1109] = {.lex_state = 292, .external_lex_state = 4},
  [1110] = {.lex_state = 121, .external_lex_state = 2},
  [1111] = {.lex_state = 349, .external_lex_state = 14},
  [1112] = {.lex_state = 413, .external_lex_state = 2},
  [1113] = {.lex_state = 121, .external_lex_state = 2},
  [1114] = {.lex_state = 349, .external_lex_state = 14},
  [1115] = {.lex_state = 292, .external_lex_state = 4},
  [1116] = {.lex_state = 113},
  [1117] = {.lex_state = 123},
  [1118] = {.lex_state = 231, .external_lex_state = 13},
  [1119] = {.lex_state = 403, .external_lex_state = 5},
  [1120] = {.lex_state = 132, .external_lex_state = 5},
  [1121] = {.lex_state = 403, .external_lex_state = 5},
  [1122] = {.lex_state = 349, .external_lex_state = 16},
  [1123] = {.lex_state = 255},
  [1124] = {.lex_state = 123},
  [1125] = {.lex_state = 292, .external_lex_state = 4},
  [1126] = {.lex_state = 292, .external_lex_state = 4},
  [1127] = {.lex_state = 276},
  [1128] = {.lex_state = 292, .external_lex_state = 4},
  [1129] = {.lex_state = 195, .external_lex_state = 4},
  [1130] = {.lex_state = 274},
  [1131] = {.lex_state = 197, .external_lex_state = 6},
  [1132] = {.lex_state = 270},
  [1133] = {.lex_state = 185},
  [1134] = {.lex_state = 127},
  [1135] = {.lex_state = 407, .external_lex_state = 3},
  [1136] = {.lex_state = 145},
  [1137] = {.lex_state = 145},
  [1138] = {.lex_state = 121, .external_lex_state = 2},
  [1139] = {.lex_state = 121, .external_lex_state = 2},
  [1140] = {.lex_state = 121, .external_lex_state = 2},
  [1141] = {.lex_state = 407, .external_lex_state = 5},
  [1142] = {.lex_state = 403, .external_lex_state = 5},
  [1143] = {.lex_state = 292, .external_lex_state = 4},
  [1144] = {.lex_state = 274},
  [1145] = {.lex_state = 292, .external_lex_state = 4},
  [1146] = {.lex_state = 132, .external_lex_state = 5},
  [1147] = {.lex_state = 403, .external_lex_state = 5},
  [1148] = {.lex_state = 403, .external_lex_state = 5},
  [1149] = {.lex_state = 123},
  [1150] = {.lex_state = 359, .external_lex_state = 14},
  [1151] = {.lex_state = 123},
  [1152] = {.lex_state = 245, .external_lex_state = 2},
  [1153] = {.lex_state = 206},
  [1154] = {.lex_state = 229},
  [1155] = {.lex_state = 132, .external_lex_state = 5},
  [1156] = {.lex_state = 403, .external_lex_state = 5},
  [1157] = {.lex_state = 229},
  [1158] = {.lex_state = 292, .external_lex_state = 4},
  [1159] = {.lex_state = 249, .external_lex_state = 2},
  [1160] = {.lex_state = 411, .external_lex_state = 14},
  [1161] = {.lex_state = 127},
  [1162] = {.lex_state = 123},
  [1163] = {.lex_state = 411, .external_lex_state = 14},
  [1164] = {.lex_state = 411, .external_lex_state = 14},
  [1165] = {.lex_state = 411, .external_lex_state = 14},
  [1166] = {.lex_state = 411, .external_lex_state = 14},
  [1167] = {.lex_state = 211},
  [1168] = {.lex_state = 209},
  [1169] = {.lex_state = 209},
  [1170] = {.lex_state = 218},
  [1171] = {.lex_state = 221, .external_lex_state = 2},
  [1172] = {.lex_state = 223},
  [1173] = {.lex_state = 227, .external_lex_state = 2},
  [1174] = {.lex_state = 218},
  [1175] = {.lex_state = 221, .external_lex_state = 2},
  [1176] = {.lex_state = 132, .external_lex_state = 14},
  [1177] = {.lex_state = 127},
  [1178] = {.lex_state = 123},
  [1179] = {.lex_state = 132, .external_lex_state = 14},
  [1180] = {.lex_state = 132, .external_lex_state = 14},
  [1181] = {.lex_state = 132, .external_lex_state = 14},
  [1182] = {.lex_state = 132, .external_lex_state = 14},
  [1183] = {.lex_state = 211},
  [1184] = {.lex_state = 209},
  [1185] = {.lex_state = 209},
  [1186] = {.lex_state = 218},
  [1187] = {.lex_state = 221, .external_lex_state = 2},
  [1188] = {.lex_state = 223},
  [1189] = {.lex_state = 227, .external_lex_state = 2},
  [1190] = {.lex_state = 218},
  [1191] = {.lex_state = 221, .external_lex_state = 2},
  [1192] = {.lex_state = 359, .external_lex_state = 14},
  [1193] = {.lex_state = 276},
  [1194] = {.lex_state = 349, .external_lex_state = 16},
  [1195] = {.lex_state = 255},
  [1196] = {.lex_state = 349, .external_lex_state = 16},
  [1197] = {.lex_state = 255},
  [1198] = {.lex_state = 359, .external_lex_state = 14},
  [1199] = {.lex_state = 276},
  [1200] = {.lex_state = 132, .external_lex_state = 14},
  [1201] = {.lex_state = 132, .external_lex_state = 6},
  [1202] = {.lex_state = 359, .external_lex_state = 14},
  [1203] = {.lex_state = 359, .external_lex_state = 14},
  [1204] = {.lex_state = 359, .external_lex_state = 14},
  [1205] = {.lex_state = 211},
  [1206] = {.lex_state = 209},
  [1207] = {.lex_state = 209},
  [1208] = {.lex_state = 218},
  [1209] = {.lex_state = 221, .external_lex_state = 2},
  [1210] = {.lex_state = 223},
  [1211] = {.lex_state = 227, .external_lex_state = 2},
  [1212] = {.lex_state = 150, .external_lex_state = 3},
  [1213] = {.lex_state = 292, .external_lex_state = 4},
  [1214] = {.lex_state = 197, .external_lex_state = 6},
  [1215] = {.lex_state = 123},
  [1216] = {.lex_state = 127},
  [1217] = {.lex_state = 403, .external_lex_state = 3},
  [1218] = {.lex_state = 145},
  [1219] = {.lex_state = 145},
  [1220] = {.lex_state = 121, .external_lex_state = 2},
  [1221] = {.lex_state = 121, .external_lex_state = 2},
  [1222] = {.lex_state = 121, .external_lex_state = 2},
  [1223] = {.lex_state = 403, .external_lex_state = 5},
  [1224] = {.lex_state = 236},
  [1225] = {.lex_state = 282, .external_lex_state = 9},
  [1226] = {.lex_state = 282},
  [1227] = {.lex_state = 292, .external_lex_state = 4},
  [1228] = {.lex_state = 415, .external_lex_state = 2},
  [1229] = {.lex_state = 292, .external_lex_state = 4},
  [1230] = {.lex_state = 274},
  [1231] = {.lex_state = 407, .external_lex_state = 3},
  [1232] = {.lex_state = 127},
  [1233] = {.lex_state = 123},
  [1234] = {.lex_state = 407, .external_lex_state = 3},
  [1235] = {.lex_state = 407, .external_lex_state = 3},
  [1236] = {.lex_state = 407, .external_lex_state = 3},
  [1237] = {.lex_state = 407, .external_lex_state = 3},
  [1238] = {.lex_state = 211},
  [1239] = {.lex_state = 209},
  [1240] = {.lex_state = 209},
  [1241] = {.lex_state = 218},
  [1242] = {.lex_state = 221, .external_lex_state = 2},
  [1243] = {.lex_state = 223},
  [1244] = {.lex_state = 227, .external_lex_state = 2},
  [1245] = {.lex_state = 218},
  [1246] = {.lex_state = 221, .external_lex_state = 2},
  [1247] = {.lex_state = 292, .external_lex_state = 4},
  [1248] = {.lex_state = 132, .external_lex_state = 5},
  [1249] = {.lex_state = 403, .external_lex_state = 5},
  [1250] = {.lex_state = 359, .external_lex_state = 14},
  [1251] = {.lex_state = 245, .external_lex_state = 2},
  [1252] = {.lex_state = 259},
  [1253] = {.lex_state = 259},
  [1254] = {.lex_state = 411, .external_lex_state = 14},
  [1255] = {.lex_state = 411, .external_lex_state = 14},
  [1256] = {.lex_state = 123},
  [1257] = {.lex_state = 253},
  [1258] = {.lex_state = 253},
  [1259] = {.lex_state = 411, .external_lex_state = 14},
  [1260] = {.lex_state = 255},
  [1261] = {.lex_state = 123},
  [1262] = {.lex_state = 411, .external_lex_state = 14},
  [1263] = {.lex_state = 255},
  [1264] = {.lex_state = 123},
  [1265] = {.lex_state = 411, .external_lex_state = 14},
  [1266] = {.lex_state = 411, .external_lex_state = 14},
  [1267] = {.lex_state = 132, .external_lex_state = 14},
  [1268] = {.lex_state = 132, .external_lex_state = 14},
  [1269] = {.lex_state = 123},
  [1270] = {.lex_state = 253},
  [1271] = {.lex_state = 253},
  [1272] = {.lex_state = 132, .external_lex_state = 14},
  [1273] = {.lex_state = 255},
  [1274] = {.lex_state = 123},
  [1275] = {.lex_state = 132, .external_lex_state = 14},
  [1276] = {.lex_state = 255},
  [1277] = {.lex_state = 123},
  [1278] = {.lex_state = 132, .external_lex_state = 14},
  [1279] = {.lex_state = 132, .external_lex_state = 14},
  [1280] = {.lex_state = 292, .external_lex_state = 4},
  [1281] = {.lex_state = 276},
  [1282] = {.lex_state = 236},
  [1283] = {.lex_state = 236},
  [1284] = {.lex_state = 292, .external_lex_state = 4},
  [1285] = {.lex_state = 276},
  [1286] = {.lex_state = 253},
  [1287] = {.lex_state = 253},
  [1288] = {.lex_state = 359, .external_lex_state = 14},
  [1289] = {.lex_state = 255},
  [1290] = {.lex_state = 123},
  [1291] = {.lex_state = 359, .external_lex_state = 14},
  [1292] = {.lex_state = 255},
  [1293] = {.lex_state = 123},
  [1294] = {.lex_state = 359, .external_lex_state = 14},
  [1295] = {.lex_state = 403, .external_lex_state = 3},
  [1296] = {.lex_state = 403, .external_lex_state = 5},
  [1297] = {.lex_state = 403, .external_lex_state = 3},
  [1298] = {.lex_state = 127},
  [1299] = {.lex_state = 123},
  [1300] = {.lex_state = 403, .external_lex_state = 3},
  [1301] = {.lex_state = 403, .external_lex_state = 3},
  [1302] = {.lex_state = 403, .external_lex_state = 3},
  [1303] = {.lex_state = 403, .external_lex_state = 3},
  [1304] = {.lex_state = 211},
  [1305] = {.lex_state = 209},
  [1306] = {.lex_state = 209},
  [1307] = {.lex_state = 218},
  [1308] = {.lex_state = 221, .external_lex_state = 2},
  [1309] = {.lex_state = 223},
  [1310] = {.lex_state = 227, .external_lex_state = 2},
  [1311] = {.lex_state = 218},
  [1312] = {.lex_state = 221, .external_lex_state = 2},
  [1313] = {.lex_state = 282},
  [1314] = {.lex_state = 349, .external_lex_state = 16},
  [1315] = {.lex_state = 292, .external_lex_state = 4},
  [1316] = {.lex_state = 292, .external_lex_state = 4},
  [1317] = {.lex_state = 407, .external_lex_state = 3},
  [1318] = {.lex_state = 407, .external_lex_state = 3},
  [1319] = {.lex_state = 123},
  [1320] = {.lex_state = 253},
  [1321] = {.lex_state = 253},
  [1322] = {.lex_state = 407, .external_lex_state = 3},
  [1323] = {.lex_state = 255},
  [1324] = {.lex_state = 123},
  [1325] = {.lex_state = 407, .external_lex_state = 3},
  [1326] = {.lex_state = 255},
  [1327] = {.lex_state = 123},
  [1328] = {.lex_state = 407, .external_lex_state = 3},
  [1329] = {.lex_state = 407, .external_lex_state = 3},
  [1330] = {.lex_state = 403, .external_lex_state = 5},
  [1331] = {.lex_state = 292, .external_lex_state = 4},
  [1332] = {.lex_state = 292, .external_lex_state = 4},
  [1333] = {.lex_state = 411, .external_lex_state = 14},
  [1334] = {.lex_state = 411, .external_lex_state = 14},
  [1335] = {.lex_state = 255},
  [1336] = {.lex_state = 411, .external_lex_state = 14},
  [1337] = {.lex_state = 255},
  [1338] = {.lex_state = 236},
  [1339] = {.lex_state = 282, .external_lex_state = 9},
  [1340] = {.lex_state = 282},
  [1341] = {.lex_state = 236},
  [1342] = {.lex_state = 282, .external_lex_state = 9},
  [1343] = {.lex_state = 282},
  [1344] = {.lex_state = 132, .external_lex_state = 14},
  [1345] = {.lex_state = 132, .external_lex_state = 14},
  [1346] = {.lex_state = 255},
  [1347] = {.lex_state = 132, .external_lex_state = 14},
  [1348] = {.lex_state = 255},
  [1349] = {.lex_state = 236},
  [1350] = {.lex_state = 282, .external_lex_state = 9},
  [1351] = {.lex_state = 282},
  [1352] = {.lex_state = 236},
  [1353] = {.lex_state = 282, .external_lex_state = 9},
  [1354] = {.lex_state = 282},
  [1355] = {.lex_state = 282},
  [1356] = {.lex_state = 282},
  [1357] = {.lex_state = 292, .external_lex_state = 4},
  [1358] = {.lex_state = 359, .external_lex_state = 14},
  [1359] = {.lex_state = 255},
  [1360] = {.lex_state = 359, .external_lex_state = 14},
  [1361] = {.lex_state = 255},
  [1362] = {.lex_state = 236},
  [1363] = {.lex_state = 282, .external_lex_state = 9},
  [1364] = {.lex_state = 282},
  [1365] = {.lex_state = 236},
  [1366] = {.lex_state = 282, .external_lex_state = 9},
  [1367] = {.lex_state = 282},
  [1368] = {.lex_state = 403, .external_lex_state = 3},
  [1369] = {.lex_state = 403, .external_lex_state = 3},
  [1370] = {.lex_state = 123},
  [1371] = {.lex_state = 253},
  [1372] = {.lex_state = 253},
  [1373] = {.lex_state = 403, .external_lex_state = 3},
  [1374] = {.lex_state = 255},
  [1375] = {.lex_state = 123},
  [1376] = {.lex_state = 403, .external_lex_state = 3},
  [1377] = {.lex_state = 255},
  [1378] = {.lex_state = 123},
  [1379] = {.lex_state = 403, .external_lex_state = 3},
  [1380] = {.lex_state = 403, .external_lex_state = 3},
  [1381] = {.lex_state = 349, .external_lex_state = 16},
  [1382] = {.lex_state = 407, .external_lex_state = 3},
  [1383] = {.lex_state = 407, .external_lex_state = 3},
  [1384] = {.lex_state = 255},
  [1385] = {.lex_state = 407, .external_lex_state = 3},
  [1386] = {.lex_state = 255},
  [1387] = {.lex_state = 236},
  [1388] = {.lex_state = 282, .external_lex_state = 9},
  [1389] = {.lex_state = 282},
  [1390] = {.lex_state = 236},
  [1391] = {.lex_state = 282, .external_lex_state = 9},
  [1392] = {.lex_state = 282},
  [1393] = {.lex_state = 236},
  [1394] = {.lex_state = 236},
  [1395] = {.lex_state = 282},
  [1396] = {.lex_state = 411, .external_lex_state = 14},
  [1397] = {.lex_state = 282},
  [1398] = {.lex_state = 411, .external_lex_state = 14},
  [1399] = {.lex_state = 236},
  [1400] = {.lex_state = 236},
  [1401] = {.lex_state = 282},
  [1402] = {.lex_state = 132, .external_lex_state = 14},
  [1403] = {.lex_state = 282},
  [1404] = {.lex_state = 132, .external_lex_state = 14},
  [1405] = {.lex_state = 349, .external_lex_state = 16},
  [1406] = {.lex_state = 349, .external_lex_state = 16},
  [1407] = {.lex_state = 236},
  [1408] = {.lex_state = 236},
  [1409] = {.lex_state = 282},
  [1410] = {.lex_state = 359, .external_lex_state = 14},
  [1411] = {.lex_state = 282},
  [1412] = {.lex_state = 359, .external_lex_state = 14},
  [1413] = {.lex_state = 403, .external_lex_state = 3},
  [1414] = {.lex_state = 403, .external_lex_state = 3},
  [1415] = {.lex_state = 255},
  [1416] = {.lex_state = 403, .external_lex_state = 3},
  [1417] = {.lex_state = 255},
  [1418] = {.lex_state = 236},
  [1419] = {.lex_state = 282, .external_lex_state = 9},
  [1420] = {.lex_state = 282},
  [1421] = {.lex_state = 236},
  [1422] = {.lex_state = 282, .external_lex_state = 9},
  [1423] = {.lex_state = 282},
  [1424] = {.lex_state = 236},
  [1425] = {.lex_state = 236},
  [1426] = {.lex_state = 282},
  [1427] = {.lex_state = 407, .external_lex_state = 3},
  [1428] = {.lex_state = 282},
  [1429] = {.lex_state = 407, .external_lex_state = 3},
  [1430] = {.lex_state = 282},
  [1431] = {.lex_state = 282},
  [1432] = {.lex_state = 411, .external_lex_state = 14},
  [1433] = {.lex_state = 411, .external_lex_state = 14},
  [1434] = {.lex_state = 282},
  [1435] = {.lex_state = 282},
  [1436] = {.lex_state = 132, .external_lex_state = 14},
  [1437] = {.lex_state = 132, .external_lex_state = 14},
  [1438] = {.lex_state = 282},
  [1439] = {.lex_state = 282},
  [1440] = {.lex_state = 359, .external_lex_state = 14},
  [1441] = {.lex_state = 359, .external_lex_state = 14},
  [1442] = {.lex_state = 236},
  [1443] = {.lex_state = 236},
  [1444] = {.lex_state = 282},
  [1445] = {.lex_state = 403, .external_lex_state = 3},
  [1446] = {.lex_state = 282},
  [1447] = {.lex_state = 403, .external_lex_state = 3},
  [1448] = {.lex_state = 282},
  [1449] = {.lex_state = 282},
  [1450] = {.lex_state = 407, .external_lex_state = 3},
  [1451] = {.lex_state = 407, .external_lex_state = 3},
  [1452] = {.lex_state = 411, .external_lex_state = 14},
  [1453] = {.lex_state = 411, .external_lex_state = 14},
  [1454] = {.lex_state = 132, .external_lex_state = 14},
  [1455] = {.lex_state = 132, .external_lex_state = 14},
  [1456] = {.lex_state = 359, .external_lex_state = 14},
  [1457] = {.lex_state = 359, .external_lex_state = 14},
  [1458] = {.lex_state = 282},
  [1459] = {.lex_state = 282},
  [1460] = {.lex_state = 403, .external_lex_state = 3},
  [1461] = {.lex_state = 403, .external_lex_state = 3},
  [1462] = {.lex_state = 407, .external_lex_state = 3},
  [1463] = {.lex_state = 407, .external_lex_state = 3},
  [1464] = {.lex_state = 403, .external_lex_state = 3},
  [1465] = {.lex_state = 403, .external_lex_state = 3},
};

enum {
  ts_external_token__simple_heredoc,
  ts_external_token__heredoc_beginning,
  ts_external_token__heredoc_middle,
  ts_external_token__heredoc_end,
  ts_external_token_file_descriptor,
  ts_external_token__empty_value,
  ts_external_token__concat,
  ts_external_token_variable_name,
  ts_external_token_LF,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__simple_heredoc] = sym__simple_heredoc,
  [ts_external_token__heredoc_beginning] = sym__heredoc_beginning,
  [ts_external_token__heredoc_middle] = sym__heredoc_middle,
  [ts_external_token__heredoc_end] = sym__heredoc_end,
  [ts_external_token_file_descriptor] = sym_file_descriptor,
  [ts_external_token__empty_value] = sym__empty_value,
  [ts_external_token__concat] = sym__concat,
  [ts_external_token_variable_name] = sym_variable_name,
  [ts_external_token_LF] = anon_sym_LF,
};

static bool ts_external_scanner_states[17][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__simple_heredoc] = true,
    [ts_external_token__heredoc_beginning] = true,
    [ts_external_token__heredoc_middle] = true,
    [ts_external_token__heredoc_end] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__empty_value] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
  },
  [2] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
  },
  [3] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [4] = {
    [ts_external_token_LF] = true,
  },
  [5] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LF] = true,
  },
  [6] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [7] = {
    [ts_external_token__empty_value] = true,
  },
  [8] = {
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [9] = {
    [ts_external_token__concat] = true,
  },
  [10] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
  },
  [11] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
  },
  [12] = {
    [ts_external_token_file_descriptor] = true,
  },
  [13] = {
    [ts_external_token__simple_heredoc] = true,
    [ts_external_token__heredoc_beginning] = true,
  },
  [14] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [15] = {
    [ts_external_token__heredoc_middle] = true,
    [ts_external_token__heredoc_end] = true,
  },
  [16] = {
    [ts_external_token__heredoc_middle] = true,
    [ts_external_token__heredoc_end] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_program] = STATE(21),
    [sym__terminated_statement] = STATE(1002),
    [sym_for_statement] = STATE(1003),
    [sym_while_statement] = STATE(1003),
    [sym_do_group] = STATE(1004),
    [sym_if_statement] = STATE(1003),
    [sym_elif_clause] = STATE(1005),
    [sym_else_clause] = STATE(1006),
    [sym_case_statement] = STATE(1003),
    [sym_case_item] = STATE(1007),
    [sym_function_definition] = STATE(1003),
    [sym_compound_statement] = STATE(1008),
    [sym_subshell] = STATE(1003),
    [sym_pipeline] = STATE(1003),
    [sym_list] = STATE(1003),
    [sym_bracket_command] = STATE(1003),
    [sym_command] = STATE(1003),
    [sym_command_name] = STATE(1009),
    [sym_environment_variable_assignment] = STATE(1010),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(1011),
    [sym_heredoc_redirect] = STATE(1012),
    [sym_heredoc] = STATE(1013),
    [sym_concatenation] = STATE(1014),
    [sym_string] = STATE(987),
    [sym_array] = STATE(139),
    [sym_simple_expansion] = STATE(1015),
    [sym_expansion] = STATE(1015),
    [sym_command_substitution] = STATE(1016),
    [sym_process_substitution] = STATE(987),
    [sym_special_variable_name] = STATE(1017),
    [aux_sym_program_repeat1] = STATE(1018),
    [aux_sym_for_statement_repeat1] = STATE(1019),
    [aux_sym_if_statement_repeat1] = STATE(1020),
    [aux_sym_case_statement_repeat1] = STATE(1021),
    [aux_sym_case_item_repeat1] = STATE(722),
    [aux_sym_command_repeat1] = STATE(1022),
    [aux_sym_command_repeat2] = STATE(1023),
    [aux_sym_heredoc_repeat1] = STATE(1024),
    [aux_sym_concatenation_repeat1] = STATE(1025),
    [aux_sym_string_repeat1] = STATE(1026),
    [aux_sym_array_repeat1] = STATE(320),
    [sym__simple_heredoc] = ACTIONS(1),
    [sym__heredoc_beginning] = ACTIONS(3),
    [sym__heredoc_middle] = ACTIONS(5),
    [sym__heredoc_end] = ACTIONS(7),
    [sym_file_descriptor] = ACTIONS(9),
    [sym__empty_value] = ACTIONS(11),
    [sym__concat] = ACTIONS(13),
    [sym_variable_name] = ACTIONS(15),
    [ts_builtin_sym_end] = ACTIONS(17),
    [anon_sym_for] = ACTIONS(19),
    [anon_sym_in] = ACTIONS(21),
    [anon_sym_while] = ACTIONS(23),
    [anon_sym_do] = ACTIONS(25),
    [anon_sym_done] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_then] = ACTIONS(31),
    [anon_sym_fi] = ACTIONS(33),
    [anon_sym_elif] = ACTIONS(35),
    [anon_sym_else] = ACTIONS(37),
    [anon_sym_case] = ACTIONS(39),
    [anon_sym_esac] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(45),
    [anon_sym_function] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_RBRACK] = ACTIONS(57),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(59),
    [anon_sym_EQ] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_GT] = ACTIONS(63),
    [anon_sym_GT_GT] = ACTIONS(65),
    [anon_sym_LT_AMP] = ACTIONS(65),
    [anon_sym_GT_AMP] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_DOLLAR] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [anon_sym_AT] = ACTIONS(75),
    [anon_sym_COLON] = ACTIONS(77),
    [anon_sym_COLON_QMARK] = ACTIONS(79),
    [anon_sym_COLON_DASH] = ACTIONS(79),
    [anon_sym_PERCENT] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(79),
    [anon_sym_BQUOTE] = ACTIONS(81),
    [anon_sym_LT_LPAREN] = ACTIONS(83),
    [anon_sym_GT_LPAREN] = ACTIONS(83),
    [sym_comment] = ACTIONS(85),
    [anon_sym_STAR] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_BANG] = ACTIONS(87),
    [anon_sym_0] = ACTIONS(87),
    [anon_sym__] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(89),
  },
  [1] = {
    [sym_program] = STATE(21),
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(29),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [ts_builtin_sym_end] = ACTIONS(95),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [2] = {
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_GT] = ACTIONS(135),
    [anon_sym_AMP_GT_GT] = ACTIONS(137),
    [anon_sym_LT_AMP] = ACTIONS(137),
    [anon_sym_GT_AMP] = ACTIONS(137),
    [sym_comment] = ACTIONS(133),
  },
  [3] = {
    [anon_sym_LBRACK] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(141),
    [sym_comment] = ACTIONS(133),
  },
  [4] = {
    [sym_word] = ACTIONS(143),
    [sym_comment] = ACTIONS(133),
  },
  [5] = {
    [sym__terminated_statement] = STATE(35),
    [sym_for_statement] = STATE(36),
    [sym_while_statement] = STATE(36),
    [sym_if_statement] = STATE(36),
    [sym_case_statement] = STATE(36),
    [sym_function_definition] = STATE(36),
    [sym_subshell] = STATE(36),
    [sym_pipeline] = STATE(36),
    [sym_list] = STATE(36),
    [sym_bracket_command] = STATE(36),
    [sym_command] = STATE(36),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(37),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [6] = {
    [sym__terminated_statement] = STATE(38),
    [sym_for_statement] = STATE(36),
    [sym_while_statement] = STATE(36),
    [sym_if_statement] = STATE(36),
    [sym_case_statement] = STATE(36),
    [sym_function_definition] = STATE(36),
    [sym_subshell] = STATE(36),
    [sym_pipeline] = STATE(36),
    [sym_list] = STATE(36),
    [sym_bracket_command] = STATE(36),
    [sym_command] = STATE(36),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(37),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [7] = {
    [sym_concatenation] = STATE(46),
    [sym_string] = STATE(40),
    [sym_simple_expansion] = STATE(40),
    [sym_expansion] = STATE(40),
    [sym_command_substitution] = STATE(40),
    [sym_process_substitution] = STATE(40),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(147),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_LT_LPAREN] = ACTIONS(157),
    [anon_sym_GT_LPAREN] = ACTIONS(157),
    [sym_word] = ACTIONS(159),
    [sym_comment] = ACTIONS(133),
  },
  [8] = {
    [sym_word] = ACTIONS(161),
    [sym_comment] = ACTIONS(133),
  },
  [9] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(48),
    [sym_while_statement] = STATE(48),
    [sym_if_statement] = STATE(48),
    [sym_case_statement] = STATE(48),
    [sym_function_definition] = STATE(48),
    [sym_subshell] = STATE(48),
    [sym_pipeline] = STATE(48),
    [sym_list] = STATE(48),
    [sym_bracket_command] = STATE(48),
    [sym_command] = STATE(48),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(49),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(50),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [10] = {
    [sym_concatenation] = STATE(58),
    [sym_string] = STATE(52),
    [sym_simple_expansion] = STATE(52),
    [sym_expansion] = STATE(52),
    [sym_command_substitution] = STATE(52),
    [sym_process_substitution] = STATE(52),
    [aux_sym_for_statement_repeat1] = STATE(59),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(177),
    [sym_comment] = ACTIONS(133),
  },
  [11] = {
    [sym_concatenation] = STATE(58),
    [sym_string] = STATE(52),
    [sym_simple_expansion] = STATE(52),
    [sym_expansion] = STATE(52),
    [sym_command_substitution] = STATE(52),
    [sym_process_substitution] = STATE(52),
    [aux_sym_for_statement_repeat1] = STATE(60),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(177),
    [sym_comment] = ACTIONS(133),
  },
  [12] = {
    [sym_concatenation] = STATE(68),
    [sym_string] = STATE(62),
    [sym_simple_expansion] = STATE(62),
    [sym_expansion] = STATE(62),
    [sym_command_substitution] = STATE(62),
    [sym_process_substitution] = STATE(62),
    [anon_sym_DQUOTE] = ACTIONS(179),
    [sym_raw_string] = ACTIONS(181),
    [anon_sym_DOLLAR] = ACTIONS(183),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(185),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(189),
    [anon_sym_LT_LPAREN] = ACTIONS(191),
    [anon_sym_GT_LPAREN] = ACTIONS(191),
    [sym_word] = ACTIONS(193),
    [sym_comment] = ACTIONS(133),
  },
  [13] = {
    [sym_simple_expansion] = STATE(70),
    [sym_expansion] = STATE(70),
    [sym_command_substitution] = STATE(70),
    [aux_sym_string_repeat1] = STATE(75),
    [anon_sym_DQUOTE] = ACTIONS(195),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(197),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [14] = {
    [aux_sym_concatenation_repeat1] = STATE(77),
    [sym_file_descriptor] = ACTIONS(207),
    [sym__concat] = ACTIONS(209),
    [anon_sym_PIPE] = ACTIONS(211),
    [anon_sym_RPAREN] = ACTIONS(211),
    [anon_sym_SEMI_SEMI] = ACTIONS(211),
    [anon_sym_PIPE_AMP] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(211),
    [anon_sym_GT_GT] = ACTIONS(211),
    [anon_sym_AMP_GT] = ACTIONS(211),
    [anon_sym_AMP_GT_GT] = ACTIONS(211),
    [anon_sym_LT_AMP] = ACTIONS(211),
    [anon_sym_GT_AMP] = ACTIONS(211),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(211),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_LT_LPAREN] = ACTIONS(211),
    [anon_sym_GT_LPAREN] = ACTIONS(211),
    [sym_word] = ACTIONS(211),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_LF] = ACTIONS(211),
    [anon_sym_AMP] = ACTIONS(211),
  },
  [15] = {
    [sym_special_variable_name] = STATE(80),
    [anon_sym_DOLLAR] = ACTIONS(213),
    [anon_sym_POUND] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(213),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(213),
    [anon_sym_0] = ACTIONS(215),
    [anon_sym__] = ACTIONS(215),
  },
  [16] = {
    [sym_special_variable_name] = STATE(84),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(219),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(223),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [17] = {
    [sym_for_statement] = STATE(102),
    [sym_while_statement] = STATE(102),
    [sym_if_statement] = STATE(102),
    [sym_case_statement] = STATE(102),
    [sym_function_definition] = STATE(102),
    [sym_subshell] = STATE(102),
    [sym_pipeline] = STATE(102),
    [sym_list] = STATE(102),
    [sym_bracket_command] = STATE(102),
    [sym_command] = STATE(102),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(104),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [18] = {
    [sym_for_statement] = STATE(108),
    [sym_while_statement] = STATE(108),
    [sym_if_statement] = STATE(108),
    [sym_case_statement] = STATE(108),
    [sym_function_definition] = STATE(108),
    [sym_subshell] = STATE(108),
    [sym_pipeline] = STATE(108),
    [sym_list] = STATE(108),
    [sym_bracket_command] = STATE(108),
    [sym_command] = STATE(108),
    [sym_command_name] = STATE(109),
    [sym_environment_variable_assignment] = STATE(110),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [19] = {
    [sym_for_statement] = STATE(112),
    [sym_while_statement] = STATE(112),
    [sym_if_statement] = STATE(112),
    [sym_case_statement] = STATE(112),
    [sym_function_definition] = STATE(112),
    [sym_subshell] = STATE(112),
    [sym_pipeline] = STATE(112),
    [sym_list] = STATE(112),
    [sym_bracket_command] = STATE(112),
    [sym_command] = STATE(112),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(113),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [20] = {
    [aux_sym_concatenation_repeat1] = STATE(77),
    [sym_file_descriptor] = ACTIONS(207),
    [sym__concat] = ACTIONS(209),
    [anon_sym_PIPE] = ACTIONS(211),
    [anon_sym_RPAREN] = ACTIONS(211),
    [anon_sym_SEMI_SEMI] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(261),
    [anon_sym_PIPE_AMP] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(211),
    [anon_sym_GT_GT] = ACTIONS(211),
    [anon_sym_AMP_GT] = ACTIONS(211),
    [anon_sym_AMP_GT_GT] = ACTIONS(211),
    [anon_sym_LT_AMP] = ACTIONS(211),
    [anon_sym_GT_AMP] = ACTIONS(211),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(211),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_LT_LPAREN] = ACTIONS(211),
    [anon_sym_GT_LPAREN] = ACTIONS(211),
    [sym_word] = ACTIONS(211),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_LF] = ACTIONS(211),
    [anon_sym_AMP] = ACTIONS(211),
  },
  [21] = {
    [ts_builtin_sym_end] = ACTIONS(263),
    [sym_comment] = ACTIONS(133),
  },
  [22] = {
    [sym_file_descriptor] = ACTIONS(265),
    [sym_variable_name] = ACTIONS(265),
    [ts_builtin_sym_end] = ACTIONS(265),
    [anon_sym_for] = ACTIONS(267),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_done] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(267),
    [anon_sym_fi] = ACTIONS(267),
    [anon_sym_elif] = ACTIONS(267),
    [anon_sym_else] = ACTIONS(267),
    [anon_sym_case] = ACTIONS(267),
    [anon_sym_SEMI_SEMI] = ACTIONS(265),
    [anon_sym_function] = ACTIONS(267),
    [anon_sym_LPAREN] = ACTIONS(265),
    [anon_sym_RBRACE] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(267),
    [anon_sym_LT] = ACTIONS(267),
    [anon_sym_GT] = ACTIONS(267),
    [anon_sym_GT_GT] = ACTIONS(265),
    [anon_sym_AMP_GT] = ACTIONS(267),
    [anon_sym_AMP_GT_GT] = ACTIONS(265),
    [anon_sym_LT_AMP] = ACTIONS(265),
    [anon_sym_GT_AMP] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(265),
    [sym_raw_string] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(267),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(265),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(265),
    [anon_sym_LT_LPAREN] = ACTIONS(265),
    [anon_sym_GT_LPAREN] = ACTIONS(265),
    [sym_word] = ACTIONS(269),
    [sym_comment] = ACTIONS(133),
  },
  [23] = {
    [anon_sym_PIPE] = ACTIONS(271),
    [anon_sym_SEMI_SEMI] = ACTIONS(273),
    [anon_sym_PIPE_AMP] = ACTIONS(271),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(273),
    [anon_sym_LF] = ACTIONS(273),
    [anon_sym_AMP] = ACTIONS(273),
  },
  [24] = {
    [sym_file_redirect] = STATE(122),
    [sym_heredoc_redirect] = STATE(122),
    [sym_concatenation] = STATE(123),
    [sym_string] = STATE(121),
    [sym_simple_expansion] = STATE(121),
    [sym_expansion] = STATE(121),
    [sym_command_substitution] = STATE(121),
    [sym_process_substitution] = STATE(121),
    [aux_sym_for_statement_repeat1] = STATE(124),
    [aux_sym_command_repeat2] = STATE(125),
    [sym_file_descriptor] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_SEMI_SEMI] = ACTIONS(279),
    [anon_sym_PIPE_AMP] = ACTIONS(279),
    [anon_sym_AMP_AMP] = ACTIONS(279),
    [anon_sym_PIPE_PIPE] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(281),
    [anon_sym_GT] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(281),
    [anon_sym_AMP_GT] = ACTIONS(281),
    [anon_sym_AMP_GT_GT] = ACTIONS(281),
    [anon_sym_LT_AMP] = ACTIONS(281),
    [anon_sym_GT_AMP] = ACTIONS(281),
    [anon_sym_LT_LT] = ACTIONS(283),
    [anon_sym_LT_LT_DASH] = ACTIONS(283),
    [anon_sym_DQUOTE] = ACTIONS(285),
    [sym_raw_string] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(291),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_LT_LPAREN] = ACTIONS(297),
    [anon_sym_GT_LPAREN] = ACTIONS(297),
    [sym_word] = ACTIONS(287),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_AMP] = ACTIONS(279),
  },
  [25] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(271),
    [anon_sym_SEMI_SEMI] = ACTIONS(273),
    [anon_sym_PIPE_AMP] = ACTIONS(271),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_LT] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(301),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_AMP_GT] = ACTIONS(301),
    [anon_sym_AMP_GT_GT] = ACTIONS(301),
    [anon_sym_LT_AMP] = ACTIONS(301),
    [anon_sym_GT_AMP] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(301),
    [sym_raw_string] = ACTIONS(301),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(301),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(301),
    [anon_sym_GT_LPAREN] = ACTIONS(301),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(273),
    [anon_sym_LF] = ACTIONS(273),
    [anon_sym_AMP] = ACTIONS(273),
  },
  [26] = {
    [anon_sym_EQ] = ACTIONS(141),
    [sym_comment] = ACTIONS(133),
  },
  [27] = {
    [sym_file_descriptor] = ACTIONS(303),
    [sym_variable_name] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(305),
    [anon_sym_GT] = ACTIONS(305),
    [anon_sym_GT_GT] = ACTIONS(303),
    [anon_sym_AMP_GT] = ACTIONS(305),
    [anon_sym_AMP_GT_GT] = ACTIONS(303),
    [anon_sym_LT_AMP] = ACTIONS(303),
    [anon_sym_GT_AMP] = ACTIONS(303),
    [anon_sym_DQUOTE] = ACTIONS(303),
    [sym_raw_string] = ACTIONS(303),
    [anon_sym_DOLLAR] = ACTIONS(305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(303),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(303),
    [anon_sym_BQUOTE] = ACTIONS(303),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_word] = ACTIONS(305),
    [sym_comment] = ACTIONS(133),
  },
  [28] = {
    [sym_file_descriptor] = ACTIONS(207),
    [anon_sym_PIPE] = ACTIONS(211),
    [anon_sym_RPAREN] = ACTIONS(211),
    [anon_sym_SEMI_SEMI] = ACTIONS(211),
    [anon_sym_PIPE_AMP] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(211),
    [anon_sym_GT_GT] = ACTIONS(211),
    [anon_sym_AMP_GT] = ACTIONS(211),
    [anon_sym_AMP_GT_GT] = ACTIONS(211),
    [anon_sym_LT_AMP] = ACTIONS(211),
    [anon_sym_GT_AMP] = ACTIONS(211),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(211),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_LT_LPAREN] = ACTIONS(211),
    [anon_sym_GT_LPAREN] = ACTIONS(211),
    [sym_word] = ACTIONS(211),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_LF] = ACTIONS(211),
    [anon_sym_AMP] = ACTIONS(211),
  },
  [29] = {
    [sym__terminated_statement] = STATE(126),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [ts_builtin_sym_end] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [30] = {
    [sym_command_name] = STATE(127),
    [sym_environment_variable_assignment] = STATE(128),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(128),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(309),
    [sym_comment] = ACTIONS(133),
  },
  [31] = {
    [sym_concatenation] = STATE(130),
    [sym_string] = STATE(129),
    [sym_simple_expansion] = STATE(129),
    [sym_expansion] = STATE(129),
    [sym_command_substitution] = STATE(129),
    [sym_process_substitution] = STATE(129),
    [anon_sym_DQUOTE] = ACTIONS(179),
    [sym_raw_string] = ACTIONS(311),
    [anon_sym_DOLLAR] = ACTIONS(183),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(185),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(189),
    [anon_sym_LT_LPAREN] = ACTIONS(191),
    [anon_sym_GT_LPAREN] = ACTIONS(191),
    [sym_word] = ACTIONS(313),
    [sym_comment] = ACTIONS(133),
  },
  [32] = {
    [sym_concatenation] = STATE(138),
    [sym_string] = STATE(132),
    [sym_simple_expansion] = STATE(132),
    [sym_expansion] = STATE(132),
    [sym_command_substitution] = STATE(132),
    [sym_process_substitution] = STATE(132),
    [anon_sym_DQUOTE] = ACTIONS(315),
    [sym_raw_string] = ACTIONS(317),
    [anon_sym_DOLLAR] = ACTIONS(319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(327),
    [anon_sym_GT_LPAREN] = ACTIONS(327),
    [sym_word] = ACTIONS(329),
    [sym_comment] = ACTIONS(133),
  },
  [33] = {
    [sym_concatenation] = STATE(139),
    [sym_string] = STATE(142),
    [sym_array] = STATE(139),
    [sym_simple_expansion] = STATE(142),
    [sym_expansion] = STATE(142),
    [sym_command_substitution] = STATE(142),
    [sym_process_substitution] = STATE(142),
    [sym__empty_value] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(337),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(341),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_LT_LPAREN] = ACTIONS(347),
    [anon_sym_GT_LPAREN] = ACTIONS(347),
    [sym_word] = ACTIONS(349),
    [sym_comment] = ACTIONS(133),
  },
  [34] = {
    [anon_sym_in] = ACTIONS(351),
    [sym_comment] = ACTIONS(133),
  },
  [35] = {
    [sym_do_group] = STATE(150),
    [anon_sym_do] = ACTIONS(353),
    [sym_comment] = ACTIONS(133),
  },
  [36] = {
    [anon_sym_PIPE] = ACTIONS(271),
    [anon_sym_SEMI_SEMI] = ACTIONS(355),
    [anon_sym_PIPE_AMP] = ACTIONS(271),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(355),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [37] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(271),
    [anon_sym_SEMI_SEMI] = ACTIONS(355),
    [anon_sym_PIPE_AMP] = ACTIONS(271),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_LT] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(301),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_AMP_GT] = ACTIONS(301),
    [anon_sym_AMP_GT_GT] = ACTIONS(301),
    [anon_sym_LT_AMP] = ACTIONS(301),
    [anon_sym_GT_AMP] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(301),
    [sym_raw_string] = ACTIONS(301),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(301),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(301),
    [anon_sym_GT_LPAREN] = ACTIONS(301),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(355),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [38] = {
    [anon_sym_then] = ACTIONS(357),
    [sym_comment] = ACTIONS(133),
  },
  [39] = {
    [sym_simple_expansion] = STATE(70),
    [sym_expansion] = STATE(70),
    [sym_command_substitution] = STATE(70),
    [aux_sym_string_repeat1] = STATE(154),
    [anon_sym_DQUOTE] = ACTIONS(359),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(197),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [40] = {
    [aux_sym_concatenation_repeat1] = STATE(158),
    [sym__concat] = ACTIONS(361),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_SEMI_SEMI] = ACTIONS(365),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_LF] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(365),
  },
  [41] = {
    [sym_special_variable_name] = STATE(161),
    [anon_sym_DOLLAR] = ACTIONS(367),
    [anon_sym_POUND] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(367),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(371),
    [anon_sym_STAR] = ACTIONS(367),
    [anon_sym_QMARK] = ACTIONS(367),
    [anon_sym_DASH] = ACTIONS(367),
    [anon_sym_BANG] = ACTIONS(367),
    [anon_sym_0] = ACTIONS(369),
    [anon_sym__] = ACTIONS(369),
  },
  [42] = {
    [sym_special_variable_name] = STATE(164),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(373),
    [anon_sym_AT] = ACTIONS(219),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [43] = {
    [sym_for_statement] = STATE(165),
    [sym_while_statement] = STATE(165),
    [sym_if_statement] = STATE(165),
    [sym_case_statement] = STATE(165),
    [sym_function_definition] = STATE(165),
    [sym_subshell] = STATE(165),
    [sym_pipeline] = STATE(165),
    [sym_list] = STATE(165),
    [sym_bracket_command] = STATE(165),
    [sym_command] = STATE(165),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(166),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [44] = {
    [sym_for_statement] = STATE(167),
    [sym_while_statement] = STATE(167),
    [sym_if_statement] = STATE(167),
    [sym_case_statement] = STATE(167),
    [sym_function_definition] = STATE(167),
    [sym_subshell] = STATE(167),
    [sym_pipeline] = STATE(167),
    [sym_list] = STATE(167),
    [sym_bracket_command] = STATE(167),
    [sym_command] = STATE(167),
    [sym_command_name] = STATE(109),
    [sym_environment_variable_assignment] = STATE(168),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [45] = {
    [sym_for_statement] = STATE(169),
    [sym_while_statement] = STATE(169),
    [sym_if_statement] = STATE(169),
    [sym_case_statement] = STATE(169),
    [sym_function_definition] = STATE(169),
    [sym_subshell] = STATE(169),
    [sym_pipeline] = STATE(169),
    [sym_list] = STATE(169),
    [sym_bracket_command] = STATE(169),
    [sym_command] = STATE(169),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(170),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [46] = {
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_SEMI_SEMI] = ACTIONS(365),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(365),
    [anon_sym_LF] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(365),
  },
  [47] = {
    [anon_sym_LPAREN] = ACTIONS(377),
    [sym_comment] = ACTIONS(133),
  },
  [48] = {
    [anon_sym_PIPE] = ACTIONS(271),
    [anon_sym_RPAREN] = ACTIONS(379),
    [anon_sym_SEMI_SEMI] = ACTIONS(381),
    [anon_sym_PIPE_AMP] = ACTIONS(271),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(381),
    [anon_sym_LF] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
  },
  [49] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(271),
    [anon_sym_RPAREN] = ACTIONS(379),
    [anon_sym_SEMI_SEMI] = ACTIONS(381),
    [anon_sym_PIPE_AMP] = ACTIONS(271),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_LT] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(301),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_AMP_GT] = ACTIONS(301),
    [anon_sym_AMP_GT_GT] = ACTIONS(301),
    [anon_sym_LT_AMP] = ACTIONS(301),
    [anon_sym_GT_AMP] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(301),
    [sym_raw_string] = ACTIONS(301),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(301),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(301),
    [anon_sym_GT_LPAREN] = ACTIONS(301),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(381),
    [anon_sym_LF] = ACTIONS(381),
    [anon_sym_AMP] = ACTIONS(381),
  },
  [50] = {
    [sym__terminated_statement] = STATE(126),
    [sym_for_statement] = STATE(174),
    [sym_while_statement] = STATE(174),
    [sym_if_statement] = STATE(174),
    [sym_case_statement] = STATE(174),
    [sym_function_definition] = STATE(174),
    [sym_subshell] = STATE(174),
    [sym_pipeline] = STATE(174),
    [sym_list] = STATE(174),
    [sym_bracket_command] = STATE(174),
    [sym_command] = STATE(174),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(175),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [51] = {
    [sym_simple_expansion] = STATE(70),
    [sym_expansion] = STATE(70),
    [sym_command_substitution] = STATE(70),
    [aux_sym_string_repeat1] = STATE(177),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(197),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [52] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACK] = ACTIONS(387),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(387),
    [anon_sym_DQUOTE] = ACTIONS(389),
    [sym_raw_string] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(389),
    [anon_sym_BQUOTE] = ACTIONS(389),
    [anon_sym_LT_LPAREN] = ACTIONS(389),
    [anon_sym_GT_LPAREN] = ACTIONS(389),
    [sym_word] = ACTIONS(391),
    [sym_comment] = ACTIONS(133),
  },
  [53] = {
    [sym_special_variable_name] = STATE(182),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_POUND] = ACTIONS(395),
    [anon_sym_AT] = ACTIONS(393),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(393),
    [anon_sym_DASH] = ACTIONS(393),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_0] = ACTIONS(395),
    [anon_sym__] = ACTIONS(395),
  },
  [54] = {
    [sym_special_variable_name] = STATE(185),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(399),
    [anon_sym_AT] = ACTIONS(219),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(401),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [55] = {
    [sym_for_statement] = STATE(186),
    [sym_while_statement] = STATE(186),
    [sym_if_statement] = STATE(186),
    [sym_case_statement] = STATE(186),
    [sym_function_definition] = STATE(186),
    [sym_subshell] = STATE(186),
    [sym_pipeline] = STATE(186),
    [sym_list] = STATE(186),
    [sym_bracket_command] = STATE(186),
    [sym_command] = STATE(186),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(187),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [56] = {
    [sym_for_statement] = STATE(188),
    [sym_while_statement] = STATE(188),
    [sym_if_statement] = STATE(188),
    [sym_case_statement] = STATE(188),
    [sym_function_definition] = STATE(188),
    [sym_subshell] = STATE(188),
    [sym_pipeline] = STATE(188),
    [sym_list] = STATE(188),
    [sym_bracket_command] = STATE(188),
    [sym_command] = STATE(188),
    [sym_command_name] = STATE(109),
    [sym_environment_variable_assignment] = STATE(189),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [57] = {
    [sym_for_statement] = STATE(190),
    [sym_while_statement] = STATE(190),
    [sym_if_statement] = STATE(190),
    [sym_case_statement] = STATE(190),
    [sym_function_definition] = STATE(190),
    [sym_subshell] = STATE(190),
    [sym_pipeline] = STATE(190),
    [sym_list] = STATE(190),
    [sym_bracket_command] = STATE(190),
    [sym_command] = STATE(190),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(191),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [58] = {
    [anon_sym_RBRACK] = ACTIONS(387),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(387),
    [anon_sym_DQUOTE] = ACTIONS(389),
    [sym_raw_string] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(389),
    [anon_sym_BQUOTE] = ACTIONS(389),
    [anon_sym_LT_LPAREN] = ACTIONS(389),
    [anon_sym_GT_LPAREN] = ACTIONS(389),
    [sym_word] = ACTIONS(391),
    [sym_comment] = ACTIONS(133),
  },
  [59] = {
    [sym_concatenation] = STATE(194),
    [sym_string] = STATE(193),
    [sym_simple_expansion] = STATE(193),
    [sym_expansion] = STATE(193),
    [sym_command_substitution] = STATE(193),
    [sym_process_substitution] = STATE(193),
    [anon_sym_RBRACK] = ACTIONS(403),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(405),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(407),
    [sym_comment] = ACTIONS(133),
  },
  [60] = {
    [sym_concatenation] = STATE(194),
    [sym_string] = STATE(193),
    [sym_simple_expansion] = STATE(193),
    [sym_expansion] = STATE(193),
    [sym_command_substitution] = STATE(193),
    [sym_process_substitution] = STATE(193),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(403),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(405),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(407),
    [sym_comment] = ACTIONS(133),
  },
  [61] = {
    [sym_simple_expansion] = STATE(70),
    [sym_expansion] = STATE(70),
    [sym_command_substitution] = STATE(70),
    [aux_sym_string_repeat1] = STATE(196),
    [anon_sym_DQUOTE] = ACTIONS(409),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(197),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [62] = {
    [aux_sym_concatenation_repeat1] = STATE(198),
    [sym_file_descriptor] = ACTIONS(411),
    [sym__concat] = ACTIONS(413),
    [sym_variable_name] = ACTIONS(411),
    [anon_sym_LT] = ACTIONS(415),
    [anon_sym_GT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_AMP_GT] = ACTIONS(415),
    [anon_sym_AMP_GT_GT] = ACTIONS(411),
    [anon_sym_LT_AMP] = ACTIONS(411),
    [anon_sym_GT_AMP] = ACTIONS(411),
    [anon_sym_DQUOTE] = ACTIONS(411),
    [sym_raw_string] = ACTIONS(411),
    [anon_sym_DOLLAR] = ACTIONS(415),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(411),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(411),
    [anon_sym_BQUOTE] = ACTIONS(411),
    [anon_sym_LT_LPAREN] = ACTIONS(411),
    [anon_sym_GT_LPAREN] = ACTIONS(411),
    [sym_word] = ACTIONS(415),
    [sym_comment] = ACTIONS(133),
  },
  [63] = {
    [sym_special_variable_name] = STATE(201),
    [anon_sym_DOLLAR] = ACTIONS(417),
    [anon_sym_POUND] = ACTIONS(419),
    [anon_sym_AT] = ACTIONS(417),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(417),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_BANG] = ACTIONS(417),
    [anon_sym_0] = ACTIONS(419),
    [anon_sym__] = ACTIONS(419),
  },
  [64] = {
    [sym_special_variable_name] = STATE(204),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(423),
    [anon_sym_AT] = ACTIONS(219),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [65] = {
    [sym_for_statement] = STATE(205),
    [sym_while_statement] = STATE(205),
    [sym_if_statement] = STATE(205),
    [sym_case_statement] = STATE(205),
    [sym_function_definition] = STATE(205),
    [sym_subshell] = STATE(205),
    [sym_pipeline] = STATE(205),
    [sym_list] = STATE(205),
    [sym_bracket_command] = STATE(205),
    [sym_command] = STATE(205),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(206),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [66] = {
    [sym_for_statement] = STATE(207),
    [sym_while_statement] = STATE(207),
    [sym_if_statement] = STATE(207),
    [sym_case_statement] = STATE(207),
    [sym_function_definition] = STATE(207),
    [sym_subshell] = STATE(207),
    [sym_pipeline] = STATE(207),
    [sym_list] = STATE(207),
    [sym_bracket_command] = STATE(207),
    [sym_command] = STATE(207),
    [sym_command_name] = STATE(109),
    [sym_environment_variable_assignment] = STATE(208),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [67] = {
    [sym_for_statement] = STATE(209),
    [sym_while_statement] = STATE(209),
    [sym_if_statement] = STATE(209),
    [sym_case_statement] = STATE(209),
    [sym_function_definition] = STATE(209),
    [sym_subshell] = STATE(209),
    [sym_pipeline] = STATE(209),
    [sym_list] = STATE(209),
    [sym_bracket_command] = STATE(209),
    [sym_command] = STATE(209),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(210),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [68] = {
    [sym_file_descriptor] = ACTIONS(411),
    [sym_variable_name] = ACTIONS(411),
    [anon_sym_LT] = ACTIONS(415),
    [anon_sym_GT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_AMP_GT] = ACTIONS(415),
    [anon_sym_AMP_GT_GT] = ACTIONS(411),
    [anon_sym_LT_AMP] = ACTIONS(411),
    [anon_sym_GT_AMP] = ACTIONS(411),
    [anon_sym_DQUOTE] = ACTIONS(411),
    [sym_raw_string] = ACTIONS(411),
    [anon_sym_DOLLAR] = ACTIONS(415),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(411),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(411),
    [anon_sym_BQUOTE] = ACTIONS(411),
    [anon_sym_LT_LPAREN] = ACTIONS(411),
    [anon_sym_GT_LPAREN] = ACTIONS(411),
    [sym_word] = ACTIONS(415),
    [sym_comment] = ACTIONS(133),
  },
  [69] = {
    [sym_file_descriptor] = ACTIONS(427),
    [sym__concat] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(429),
    [anon_sym_SEMI_SEMI] = ACTIONS(429),
    [anon_sym_PIPE_AMP] = ACTIONS(429),
    [anon_sym_AMP_AMP] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_GT] = ACTIONS(429),
    [anon_sym_AMP_GT] = ACTIONS(429),
    [anon_sym_AMP_GT_GT] = ACTIONS(429),
    [anon_sym_LT_AMP] = ACTIONS(429),
    [anon_sym_GT_AMP] = ACTIONS(429),
    [anon_sym_LT_LT] = ACTIONS(429),
    [anon_sym_LT_LT_DASH] = ACTIONS(429),
    [anon_sym_DQUOTE] = ACTIONS(429),
    [sym_raw_string] = ACTIONS(429),
    [anon_sym_DOLLAR] = ACTIONS(429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(429),
    [anon_sym_BQUOTE] = ACTIONS(429),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [sym_word] = ACTIONS(429),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(429),
    [anon_sym_LF] = ACTIONS(429),
    [anon_sym_AMP] = ACTIONS(429),
  },
  [70] = {
    [anon_sym_DQUOTE] = ACTIONS(431),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(431),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_BQUOTE] = ACTIONS(431),
    [sym_comment] = ACTIONS(85),
  },
  [71] = {
    [sym_special_variable_name] = STATE(213),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [anon_sym_POUND] = ACTIONS(437),
    [anon_sym_AT] = ACTIONS(435),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(439),
    [anon_sym_STAR] = ACTIONS(435),
    [anon_sym_QMARK] = ACTIONS(435),
    [anon_sym_DASH] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(435),
    [anon_sym_0] = ACTIONS(437),
    [anon_sym__] = ACTIONS(437),
  },
  [72] = {
    [sym_special_variable_name] = STATE(216),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(441),
    [anon_sym_AT] = ACTIONS(219),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [73] = {
    [sym_for_statement] = STATE(217),
    [sym_while_statement] = STATE(217),
    [sym_if_statement] = STATE(217),
    [sym_case_statement] = STATE(217),
    [sym_function_definition] = STATE(217),
    [sym_subshell] = STATE(217),
    [sym_pipeline] = STATE(217),
    [sym_list] = STATE(217),
    [sym_bracket_command] = STATE(217),
    [sym_command] = STATE(217),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(218),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [74] = {
    [sym_for_statement] = STATE(219),
    [sym_while_statement] = STATE(219),
    [sym_if_statement] = STATE(219),
    [sym_case_statement] = STATE(219),
    [sym_function_definition] = STATE(219),
    [sym_subshell] = STATE(219),
    [sym_pipeline] = STATE(219),
    [sym_list] = STATE(219),
    [sym_bracket_command] = STATE(219),
    [sym_command] = STATE(219),
    [sym_command_name] = STATE(109),
    [sym_environment_variable_assignment] = STATE(220),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [75] = {
    [sym_simple_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [anon_sym_DQUOTE] = ACTIONS(445),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(447),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [76] = {
    [sym_string] = STATE(223),
    [sym_simple_expansion] = STATE(223),
    [sym_expansion] = STATE(223),
    [sym_command_substitution] = STATE(223),
    [sym_process_substitution] = STATE(223),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(449),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(451),
    [sym_comment] = ACTIONS(133),
  },
  [77] = {
    [sym_file_descriptor] = ACTIONS(453),
    [sym__concat] = ACTIONS(455),
    [anon_sym_PIPE] = ACTIONS(457),
    [anon_sym_RPAREN] = ACTIONS(457),
    [anon_sym_SEMI_SEMI] = ACTIONS(457),
    [anon_sym_PIPE_AMP] = ACTIONS(457),
    [anon_sym_AMP_AMP] = ACTIONS(457),
    [anon_sym_PIPE_PIPE] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(457),
    [anon_sym_AMP_GT] = ACTIONS(457),
    [anon_sym_AMP_GT_GT] = ACTIONS(457),
    [anon_sym_LT_AMP] = ACTIONS(457),
    [anon_sym_GT_AMP] = ACTIONS(457),
    [anon_sym_LT_LT] = ACTIONS(457),
    [anon_sym_LT_LT_DASH] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(457),
    [sym_raw_string] = ACTIONS(457),
    [anon_sym_DOLLAR] = ACTIONS(457),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(457),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(457),
    [anon_sym_BQUOTE] = ACTIONS(457),
    [anon_sym_LT_LPAREN] = ACTIONS(457),
    [anon_sym_GT_LPAREN] = ACTIONS(457),
    [sym_word] = ACTIONS(457),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(457),
    [anon_sym_LF] = ACTIONS(457),
    [anon_sym_AMP] = ACTIONS(457),
  },
  [78] = {
    [sym_file_descriptor] = ACTIONS(459),
    [sym__concat] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(461),
    [anon_sym_RPAREN] = ACTIONS(461),
    [anon_sym_SEMI_SEMI] = ACTIONS(461),
    [anon_sym_PIPE_AMP] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(461),
    [anon_sym_AMP_GT] = ACTIONS(461),
    [anon_sym_AMP_GT_GT] = ACTIONS(461),
    [anon_sym_LT_AMP] = ACTIONS(461),
    [anon_sym_GT_AMP] = ACTIONS(461),
    [anon_sym_LT_LT] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_DQUOTE] = ACTIONS(461),
    [sym_raw_string] = ACTIONS(461),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(461),
    [anon_sym_BQUOTE] = ACTIONS(461),
    [anon_sym_LT_LPAREN] = ACTIONS(461),
    [anon_sym_GT_LPAREN] = ACTIONS(461),
    [sym_word] = ACTIONS(461),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_LF] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(461),
  },
  [79] = {
    [sym_file_descriptor] = ACTIONS(463),
    [sym__concat] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_SEMI_SEMI] = ACTIONS(465),
    [anon_sym_PIPE_AMP] = ACTIONS(465),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE_PIPE] = ACTIONS(465),
    [anon_sym_LT] = ACTIONS(465),
    [anon_sym_GT] = ACTIONS(465),
    [anon_sym_GT_GT] = ACTIONS(465),
    [anon_sym_AMP_GT] = ACTIONS(465),
    [anon_sym_AMP_GT_GT] = ACTIONS(465),
    [anon_sym_LT_AMP] = ACTIONS(465),
    [anon_sym_GT_AMP] = ACTIONS(465),
    [anon_sym_LT_LT] = ACTIONS(465),
    [anon_sym_LT_LT_DASH] = ACTIONS(465),
    [anon_sym_DQUOTE] = ACTIONS(465),
    [sym_raw_string] = ACTIONS(465),
    [anon_sym_DOLLAR] = ACTIONS(465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(465),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(465),
    [anon_sym_BQUOTE] = ACTIONS(465),
    [anon_sym_LT_LPAREN] = ACTIONS(465),
    [anon_sym_GT_LPAREN] = ACTIONS(465),
    [sym_word] = ACTIONS(465),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(465),
    [anon_sym_LF] = ACTIONS(465),
    [anon_sym_AMP] = ACTIONS(465),
  },
  [80] = {
    [sym_file_descriptor] = ACTIONS(467),
    [sym__concat] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_RPAREN] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
  },
  [81] = {
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_COLON] = ACTIONS(471),
    [anon_sym_COLON_QMARK] = ACTIONS(459),
    [anon_sym_COLON_DASH] = ACTIONS(459),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [sym_comment] = ACTIONS(133),
  },
  [82] = {
    [sym_special_variable_name] = STATE(226),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(225),
    [anon_sym_AT] = ACTIONS(219),
    [anon_sym_COLON] = ACTIONS(471),
    [anon_sym_COLON_QMARK] = ACTIONS(459),
    [anon_sym_COLON_DASH] = ACTIONS(459),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [83] = {
    [anon_sym_RBRACE] = ACTIONS(475),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_EQ] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(481),
    [anon_sym_COLON_QMARK] = ACTIONS(479),
    [anon_sym_COLON_DASH] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(479),
    [anon_sym_SLASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(133),
  },
  [84] = {
    [anon_sym_RBRACE] = ACTIONS(483),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_EQ] = ACTIONS(487),
    [anon_sym_COLON] = ACTIONS(489),
    [anon_sym_COLON_QMARK] = ACTIONS(487),
    [anon_sym_COLON_DASH] = ACTIONS(487),
    [anon_sym_PERCENT] = ACTIONS(487),
    [anon_sym_SLASH] = ACTIONS(487),
    [sym_comment] = ACTIONS(133),
  },
  [85] = {
    [anon_sym_LBRACK] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(491),
    [sym_comment] = ACTIONS(133),
  },
  [86] = {
    [sym_word] = ACTIONS(493),
    [sym_comment] = ACTIONS(133),
  },
  [87] = {
    [sym__terminated_statement] = STATE(235),
    [sym_for_statement] = STATE(36),
    [sym_while_statement] = STATE(36),
    [sym_if_statement] = STATE(36),
    [sym_case_statement] = STATE(36),
    [sym_function_definition] = STATE(36),
    [sym_subshell] = STATE(36),
    [sym_pipeline] = STATE(36),
    [sym_list] = STATE(36),
    [sym_bracket_command] = STATE(36),
    [sym_command] = STATE(36),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(37),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [88] = {
    [sym__terminated_statement] = STATE(236),
    [sym_for_statement] = STATE(36),
    [sym_while_statement] = STATE(36),
    [sym_if_statement] = STATE(36),
    [sym_case_statement] = STATE(36),
    [sym_function_definition] = STATE(36),
    [sym_subshell] = STATE(36),
    [sym_pipeline] = STATE(36),
    [sym_list] = STATE(36),
    [sym_bracket_command] = STATE(36),
    [sym_command] = STATE(36),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(37),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [89] = {
    [sym_concatenation] = STATE(238),
    [sym_string] = STATE(237),
    [sym_simple_expansion] = STATE(237),
    [sym_expansion] = STATE(237),
    [sym_command_substitution] = STATE(237),
    [sym_process_substitution] = STATE(237),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(495),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_LT_LPAREN] = ACTIONS(157),
    [anon_sym_GT_LPAREN] = ACTIONS(157),
    [sym_word] = ACTIONS(497),
    [sym_comment] = ACTIONS(133),
  },
  [90] = {
    [sym_word] = ACTIONS(499),
    [sym_comment] = ACTIONS(133),
  },
  [91] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(240),
    [sym_while_statement] = STATE(240),
    [sym_if_statement] = STATE(240),
    [sym_case_statement] = STATE(240),
    [sym_function_definition] = STATE(240),
    [sym_subshell] = STATE(240),
    [sym_pipeline] = STATE(240),
    [sym_list] = STATE(240),
    [sym_bracket_command] = STATE(240),
    [sym_command] = STATE(240),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(241),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(242),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [92] = {
    [sym_concatenation] = STATE(58),
    [sym_string] = STATE(52),
    [sym_simple_expansion] = STATE(52),
    [sym_expansion] = STATE(52),
    [sym_command_substitution] = STATE(52),
    [sym_process_substitution] = STATE(52),
    [aux_sym_for_statement_repeat1] = STATE(243),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(177),
    [sym_comment] = ACTIONS(133),
  },
  [93] = {
    [sym_concatenation] = STATE(58),
    [sym_string] = STATE(52),
    [sym_simple_expansion] = STATE(52),
    [sym_expansion] = STATE(52),
    [sym_command_substitution] = STATE(52),
    [sym_process_substitution] = STATE(52),
    [aux_sym_for_statement_repeat1] = STATE(244),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(177),
    [sym_comment] = ACTIONS(133),
  },
  [94] = {
    [sym_simple_expansion] = STATE(70),
    [sym_expansion] = STATE(70),
    [sym_command_substitution] = STATE(70),
    [aux_sym_string_repeat1] = STATE(246),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(197),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [95] = {
    [aux_sym_concatenation_repeat1] = STATE(248),
    [sym_file_descriptor] = ACTIONS(207),
    [sym__concat] = ACTIONS(503),
    [anon_sym_PIPE] = ACTIONS(505),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_PIPE_AMP] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(505),
    [anon_sym_GT] = ACTIONS(505),
    [anon_sym_GT_GT] = ACTIONS(207),
    [anon_sym_AMP_GT] = ACTIONS(505),
    [anon_sym_AMP_GT_GT] = ACTIONS(207),
    [anon_sym_LT_AMP] = ACTIONS(207),
    [anon_sym_GT_AMP] = ACTIONS(207),
    [anon_sym_LT_LT] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [sym_raw_string] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(207),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(207),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [anon_sym_LT_LPAREN] = ACTIONS(207),
    [anon_sym_GT_LPAREN] = ACTIONS(207),
    [sym_word] = ACTIONS(211),
    [sym_comment] = ACTIONS(133),
  },
  [96] = {
    [sym_special_variable_name] = STATE(251),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [anon_sym_POUND] = ACTIONS(509),
    [anon_sym_AT] = ACTIONS(507),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(511),
    [anon_sym_STAR] = ACTIONS(507),
    [anon_sym_QMARK] = ACTIONS(507),
    [anon_sym_DASH] = ACTIONS(507),
    [anon_sym_BANG] = ACTIONS(507),
    [anon_sym_0] = ACTIONS(509),
    [anon_sym__] = ACTIONS(509),
  },
  [97] = {
    [sym_special_variable_name] = STATE(254),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(513),
    [anon_sym_AT] = ACTIONS(219),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [98] = {
    [sym_for_statement] = STATE(255),
    [sym_while_statement] = STATE(255),
    [sym_if_statement] = STATE(255),
    [sym_case_statement] = STATE(255),
    [sym_function_definition] = STATE(255),
    [sym_subshell] = STATE(255),
    [sym_pipeline] = STATE(255),
    [sym_list] = STATE(255),
    [sym_bracket_command] = STATE(255),
    [sym_command] = STATE(255),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(256),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [99] = {
    [sym_for_statement] = STATE(257),
    [sym_while_statement] = STATE(257),
    [sym_if_statement] = STATE(257),
    [sym_case_statement] = STATE(257),
    [sym_function_definition] = STATE(257),
    [sym_subshell] = STATE(257),
    [sym_pipeline] = STATE(257),
    [sym_list] = STATE(257),
    [sym_bracket_command] = STATE(257),
    [sym_command] = STATE(257),
    [sym_command_name] = STATE(109),
    [sym_environment_variable_assignment] = STATE(258),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [100] = {
    [sym_for_statement] = STATE(259),
    [sym_while_statement] = STATE(259),
    [sym_if_statement] = STATE(259),
    [sym_case_statement] = STATE(259),
    [sym_function_definition] = STATE(259),
    [sym_subshell] = STATE(259),
    [sym_pipeline] = STATE(259),
    [sym_list] = STATE(259),
    [sym_bracket_command] = STATE(259),
    [sym_command] = STATE(259),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(260),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [101] = {
    [aux_sym_concatenation_repeat1] = STATE(248),
    [sym_file_descriptor] = ACTIONS(207),
    [sym__concat] = ACTIONS(503),
    [anon_sym_PIPE] = ACTIONS(505),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(517),
    [anon_sym_PIPE_AMP] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(505),
    [anon_sym_GT] = ACTIONS(505),
    [anon_sym_GT_GT] = ACTIONS(207),
    [anon_sym_AMP_GT] = ACTIONS(505),
    [anon_sym_AMP_GT_GT] = ACTIONS(207),
    [anon_sym_LT_AMP] = ACTIONS(207),
    [anon_sym_GT_AMP] = ACTIONS(207),
    [anon_sym_LT_LT] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [sym_raw_string] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(207),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(207),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [anon_sym_LT_LPAREN] = ACTIONS(207),
    [anon_sym_GT_LPAREN] = ACTIONS(207),
    [sym_word] = ACTIONS(211),
    [sym_comment] = ACTIONS(133),
  },
  [102] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(521),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [103] = {
    [sym_file_redirect] = STATE(269),
    [sym_heredoc_redirect] = STATE(269),
    [sym_concatenation] = STATE(270),
    [sym_string] = STATE(268),
    [sym_simple_expansion] = STATE(268),
    [sym_expansion] = STATE(268),
    [sym_command_substitution] = STATE(268),
    [sym_process_substitution] = STATE(268),
    [aux_sym_for_statement_repeat1] = STATE(271),
    [aux_sym_command_repeat2] = STATE(272),
    [sym_file_descriptor] = ACTIONS(527),
    [anon_sym_PIPE] = ACTIONS(529),
    [anon_sym_RPAREN] = ACTIONS(531),
    [anon_sym_PIPE_AMP] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_GT] = ACTIONS(535),
    [anon_sym_AMP_GT] = ACTIONS(533),
    [anon_sym_AMP_GT_GT] = ACTIONS(535),
    [anon_sym_LT_AMP] = ACTIONS(535),
    [anon_sym_GT_AMP] = ACTIONS(535),
    [anon_sym_LT_LT] = ACTIONS(537),
    [anon_sym_LT_LT_DASH] = ACTIONS(539),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(541),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(543),
    [sym_comment] = ACTIONS(133),
  },
  [104] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(521),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [105] = {
    [anon_sym_EQ] = ACTIONS(491),
    [sym_comment] = ACTIONS(133),
  },
  [106] = {
    [sym_file_descriptor] = ACTIONS(207),
    [anon_sym_PIPE] = ACTIONS(505),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_PIPE_AMP] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(505),
    [anon_sym_GT] = ACTIONS(505),
    [anon_sym_GT_GT] = ACTIONS(207),
    [anon_sym_AMP_GT] = ACTIONS(505),
    [anon_sym_AMP_GT_GT] = ACTIONS(207),
    [anon_sym_LT_AMP] = ACTIONS(207),
    [anon_sym_GT_AMP] = ACTIONS(207),
    [anon_sym_LT_LT] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [sym_raw_string] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(207),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(207),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [anon_sym_LT_LPAREN] = ACTIONS(207),
    [anon_sym_GT_LPAREN] = ACTIONS(207),
    [sym_word] = ACTIONS(211),
    [sym_comment] = ACTIONS(133),
  },
  [107] = {
    [sym_command_name] = STATE(273),
    [sym_environment_variable_assignment] = STATE(128),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(128),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(549),
    [sym_comment] = ACTIONS(133),
  },
  [108] = {
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(521),
    [sym_comment] = ACTIONS(133),
  },
  [109] = {
    [sym_file_redirect] = STATE(269),
    [sym_heredoc_redirect] = STATE(269),
    [sym_concatenation] = STATE(270),
    [sym_string] = STATE(268),
    [sym_simple_expansion] = STATE(268),
    [sym_expansion] = STATE(268),
    [sym_command_substitution] = STATE(268),
    [sym_process_substitution] = STATE(268),
    [aux_sym_for_statement_repeat1] = STATE(276),
    [aux_sym_command_repeat2] = STATE(272),
    [sym_file_descriptor] = ACTIONS(527),
    [anon_sym_PIPE] = ACTIONS(529),
    [anon_sym_PIPE_AMP] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_GT] = ACTIONS(535),
    [anon_sym_AMP_GT] = ACTIONS(533),
    [anon_sym_AMP_GT_GT] = ACTIONS(535),
    [anon_sym_LT_AMP] = ACTIONS(535),
    [anon_sym_GT_AMP] = ACTIONS(535),
    [anon_sym_LT_LT] = ACTIONS(537),
    [anon_sym_LT_LT_DASH] = ACTIONS(539),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(541),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(531),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(543),
    [sym_comment] = ACTIONS(133),
  },
  [110] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(521),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [111] = {
    [sym_command_name] = STATE(277),
    [sym_environment_variable_assignment] = STATE(128),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(128),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(549),
    [sym_comment] = ACTIONS(133),
  },
  [112] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [113] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [114] = {
    [anon_sym_RPAREN] = ACTIONS(561),
    [sym_comment] = ACTIONS(133),
  },
  [115] = {
    [sym_for_statement] = STATE(280),
    [sym_while_statement] = STATE(280),
    [sym_if_statement] = STATE(280),
    [sym_case_statement] = STATE(280),
    [sym_function_definition] = STATE(280),
    [sym_subshell] = STATE(280),
    [sym_pipeline] = STATE(280),
    [sym_list] = STATE(280),
    [sym_bracket_command] = STATE(280),
    [sym_command] = STATE(280),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(281),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [116] = {
    [sym_file_descriptor] = ACTIONS(563),
    [sym_variable_name] = ACTIONS(563),
    [ts_builtin_sym_end] = ACTIONS(563),
    [anon_sym_for] = ACTIONS(565),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_done] = ACTIONS(565),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_fi] = ACTIONS(565),
    [anon_sym_elif] = ACTIONS(565),
    [anon_sym_else] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(565),
    [anon_sym_SEMI_SEMI] = ACTIONS(563),
    [anon_sym_function] = ACTIONS(565),
    [anon_sym_LPAREN] = ACTIONS(563),
    [anon_sym_RBRACE] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(565),
    [anon_sym_GT] = ACTIONS(565),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_AMP_GT] = ACTIONS(565),
    [anon_sym_AMP_GT_GT] = ACTIONS(563),
    [anon_sym_LT_AMP] = ACTIONS(563),
    [anon_sym_GT_AMP] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(563),
    [sym_raw_string] = ACTIONS(563),
    [anon_sym_DOLLAR] = ACTIONS(565),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(563),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(563),
    [anon_sym_BQUOTE] = ACTIONS(563),
    [anon_sym_LT_LPAREN] = ACTIONS(563),
    [anon_sym_GT_LPAREN] = ACTIONS(563),
    [sym_word] = ACTIONS(567),
    [sym_comment] = ACTIONS(133),
  },
  [117] = {
    [sym_for_statement] = STATE(282),
    [sym_while_statement] = STATE(282),
    [sym_if_statement] = STATE(282),
    [sym_case_statement] = STATE(282),
    [sym_function_definition] = STATE(282),
    [sym_subshell] = STATE(282),
    [sym_pipeline] = STATE(282),
    [sym_list] = STATE(282),
    [sym_bracket_command] = STATE(282),
    [sym_command] = STATE(282),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(283),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [118] = {
    [anon_sym_LT] = ACTIONS(569),
    [anon_sym_GT] = ACTIONS(569),
    [anon_sym_GT_GT] = ACTIONS(571),
    [anon_sym_AMP_GT] = ACTIONS(569),
    [anon_sym_AMP_GT_GT] = ACTIONS(571),
    [anon_sym_LT_AMP] = ACTIONS(571),
    [anon_sym_GT_AMP] = ACTIONS(571),
    [sym_comment] = ACTIONS(133),
  },
  [119] = {
    [sym_concatenation] = STATE(292),
    [sym_string] = STATE(286),
    [sym_simple_expansion] = STATE(286),
    [sym_expansion] = STATE(286),
    [sym_command_substitution] = STATE(286),
    [sym_process_substitution] = STATE(286),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [sym_raw_string] = ACTIONS(575),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(579),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(581),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_LT_LPAREN] = ACTIONS(585),
    [anon_sym_GT_LPAREN] = ACTIONS(585),
    [sym_word] = ACTIONS(587),
    [sym_comment] = ACTIONS(133),
  },
  [120] = {
    [sym_heredoc] = STATE(295),
    [sym__simple_heredoc] = ACTIONS(589),
    [sym__heredoc_beginning] = ACTIONS(591),
    [sym_comment] = ACTIONS(133),
  },
  [121] = {
    [aux_sym_concatenation_repeat1] = STATE(77),
    [sym_file_descriptor] = ACTIONS(389),
    [sym__concat] = ACTIONS(209),
    [anon_sym_PIPE] = ACTIONS(391),
    [anon_sym_RPAREN] = ACTIONS(391),
    [anon_sym_SEMI_SEMI] = ACTIONS(391),
    [anon_sym_PIPE_AMP] = ACTIONS(391),
    [anon_sym_AMP_AMP] = ACTIONS(391),
    [anon_sym_PIPE_PIPE] = ACTIONS(391),
    [anon_sym_LT] = ACTIONS(391),
    [anon_sym_GT] = ACTIONS(391),
    [anon_sym_GT_GT] = ACTIONS(391),
    [anon_sym_AMP_GT] = ACTIONS(391),
    [anon_sym_AMP_GT_GT] = ACTIONS(391),
    [anon_sym_LT_AMP] = ACTIONS(391),
    [anon_sym_GT_AMP] = ACTIONS(391),
    [anon_sym_LT_LT] = ACTIONS(391),
    [anon_sym_LT_LT_DASH] = ACTIONS(391),
    [anon_sym_DQUOTE] = ACTIONS(391),
    [sym_raw_string] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(391),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(391),
    [anon_sym_BQUOTE] = ACTIONS(391),
    [anon_sym_LT_LPAREN] = ACTIONS(391),
    [anon_sym_GT_LPAREN] = ACTIONS(391),
    [sym_word] = ACTIONS(391),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(391),
    [anon_sym_LF] = ACTIONS(391),
    [anon_sym_AMP] = ACTIONS(391),
  },
  [122] = {
    [sym_file_descriptor] = ACTIONS(593),
    [anon_sym_PIPE] = ACTIONS(595),
    [anon_sym_RPAREN] = ACTIONS(595),
    [anon_sym_SEMI_SEMI] = ACTIONS(595),
    [anon_sym_PIPE_AMP] = ACTIONS(595),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(595),
    [anon_sym_GT] = ACTIONS(595),
    [anon_sym_GT_GT] = ACTIONS(595),
    [anon_sym_AMP_GT] = ACTIONS(595),
    [anon_sym_AMP_GT_GT] = ACTIONS(595),
    [anon_sym_LT_AMP] = ACTIONS(595),
    [anon_sym_GT_AMP] = ACTIONS(595),
    [anon_sym_LT_LT] = ACTIONS(595),
    [anon_sym_LT_LT_DASH] = ACTIONS(595),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(595),
    [anon_sym_LF] = ACTIONS(595),
    [anon_sym_AMP] = ACTIONS(595),
  },
  [123] = {
    [sym_file_descriptor] = ACTIONS(389),
    [anon_sym_PIPE] = ACTIONS(391),
    [anon_sym_RPAREN] = ACTIONS(391),
    [anon_sym_SEMI_SEMI] = ACTIONS(391),
    [anon_sym_PIPE_AMP] = ACTIONS(391),
    [anon_sym_AMP_AMP] = ACTIONS(391),
    [anon_sym_PIPE_PIPE] = ACTIONS(391),
    [anon_sym_LT] = ACTIONS(391),
    [anon_sym_GT] = ACTIONS(391),
    [anon_sym_GT_GT] = ACTIONS(391),
    [anon_sym_AMP_GT] = ACTIONS(391),
    [anon_sym_AMP_GT_GT] = ACTIONS(391),
    [anon_sym_LT_AMP] = ACTIONS(391),
    [anon_sym_GT_AMP] = ACTIONS(391),
    [anon_sym_LT_LT] = ACTIONS(391),
    [anon_sym_LT_LT_DASH] = ACTIONS(391),
    [anon_sym_DQUOTE] = ACTIONS(391),
    [sym_raw_string] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(391),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(391),
    [anon_sym_BQUOTE] = ACTIONS(391),
    [anon_sym_LT_LPAREN] = ACTIONS(391),
    [anon_sym_GT_LPAREN] = ACTIONS(391),
    [sym_word] = ACTIONS(391),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(391),
    [anon_sym_LF] = ACTIONS(391),
    [anon_sym_AMP] = ACTIONS(391),
  },
  [124] = {
    [sym_file_redirect] = STATE(122),
    [sym_heredoc_redirect] = STATE(122),
    [sym_concatenation] = STATE(297),
    [sym_string] = STATE(296),
    [sym_simple_expansion] = STATE(296),
    [sym_expansion] = STATE(296),
    [sym_command_substitution] = STATE(296),
    [sym_process_substitution] = STATE(296),
    [aux_sym_command_repeat2] = STATE(298),
    [sym_file_descriptor] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(597),
    [anon_sym_RPAREN] = ACTIONS(597),
    [anon_sym_SEMI_SEMI] = ACTIONS(597),
    [anon_sym_PIPE_AMP] = ACTIONS(597),
    [anon_sym_AMP_AMP] = ACTIONS(597),
    [anon_sym_PIPE_PIPE] = ACTIONS(597),
    [anon_sym_LT] = ACTIONS(281),
    [anon_sym_GT] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(281),
    [anon_sym_AMP_GT] = ACTIONS(281),
    [anon_sym_AMP_GT_GT] = ACTIONS(281),
    [anon_sym_LT_AMP] = ACTIONS(281),
    [anon_sym_GT_AMP] = ACTIONS(281),
    [anon_sym_LT_LT] = ACTIONS(283),
    [anon_sym_LT_LT_DASH] = ACTIONS(283),
    [anon_sym_DQUOTE] = ACTIONS(285),
    [sym_raw_string] = ACTIONS(599),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(291),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_LT_LPAREN] = ACTIONS(297),
    [anon_sym_GT_LPAREN] = ACTIONS(297),
    [sym_word] = ACTIONS(599),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(597),
    [anon_sym_LF] = ACTIONS(597),
    [anon_sym_AMP] = ACTIONS(597),
  },
  [125] = {
    [sym_file_redirect] = STATE(299),
    [sym_heredoc_redirect] = STATE(299),
    [sym_file_descriptor] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(601),
    [anon_sym_RPAREN] = ACTIONS(601),
    [anon_sym_SEMI_SEMI] = ACTIONS(601),
    [anon_sym_PIPE_AMP] = ACTIONS(601),
    [anon_sym_AMP_AMP] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(601),
    [anon_sym_LT] = ACTIONS(281),
    [anon_sym_GT] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(281),
    [anon_sym_AMP_GT] = ACTIONS(281),
    [anon_sym_AMP_GT_GT] = ACTIONS(281),
    [anon_sym_LT_AMP] = ACTIONS(281),
    [anon_sym_GT_AMP] = ACTIONS(281),
    [anon_sym_LT_LT] = ACTIONS(283),
    [anon_sym_LT_LT_DASH] = ACTIONS(283),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(601),
    [anon_sym_LF] = ACTIONS(601),
    [anon_sym_AMP] = ACTIONS(601),
  },
  [126] = {
    [sym_file_descriptor] = ACTIONS(603),
    [sym_variable_name] = ACTIONS(603),
    [ts_builtin_sym_end] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(605),
    [anon_sym_while] = ACTIONS(605),
    [anon_sym_done] = ACTIONS(605),
    [anon_sym_if] = ACTIONS(605),
    [anon_sym_fi] = ACTIONS(605),
    [anon_sym_elif] = ACTIONS(605),
    [anon_sym_else] = ACTIONS(605),
    [anon_sym_case] = ACTIONS(605),
    [anon_sym_SEMI_SEMI] = ACTIONS(603),
    [anon_sym_function] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(603),
    [anon_sym_RBRACE] = ACTIONS(603),
    [anon_sym_LBRACK] = ACTIONS(605),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(605),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_GT] = ACTIONS(605),
    [anon_sym_GT_GT] = ACTIONS(603),
    [anon_sym_AMP_GT] = ACTIONS(605),
    [anon_sym_AMP_GT_GT] = ACTIONS(603),
    [anon_sym_LT_AMP] = ACTIONS(603),
    [anon_sym_GT_AMP] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [sym_raw_string] = ACTIONS(603),
    [anon_sym_DOLLAR] = ACTIONS(605),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(603),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(603),
    [anon_sym_BQUOTE] = ACTIONS(603),
    [anon_sym_LT_LPAREN] = ACTIONS(603),
    [anon_sym_GT_LPAREN] = ACTIONS(603),
    [sym_word] = ACTIONS(607),
    [sym_comment] = ACTIONS(133),
  },
  [127] = {
    [sym_file_redirect] = STATE(122),
    [sym_heredoc_redirect] = STATE(122),
    [sym_concatenation] = STATE(123),
    [sym_string] = STATE(121),
    [sym_simple_expansion] = STATE(121),
    [sym_expansion] = STATE(121),
    [sym_command_substitution] = STATE(121),
    [sym_process_substitution] = STATE(121),
    [aux_sym_for_statement_repeat1] = STATE(300),
    [aux_sym_command_repeat2] = STATE(298),
    [sym_file_descriptor] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(597),
    [anon_sym_RPAREN] = ACTIONS(597),
    [anon_sym_SEMI_SEMI] = ACTIONS(597),
    [anon_sym_PIPE_AMP] = ACTIONS(597),
    [anon_sym_AMP_AMP] = ACTIONS(597),
    [anon_sym_PIPE_PIPE] = ACTIONS(597),
    [anon_sym_LT] = ACTIONS(281),
    [anon_sym_GT] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(281),
    [anon_sym_AMP_GT] = ACTIONS(281),
    [anon_sym_AMP_GT_GT] = ACTIONS(281),
    [anon_sym_LT_AMP] = ACTIONS(281),
    [anon_sym_GT_AMP] = ACTIONS(281),
    [anon_sym_LT_LT] = ACTIONS(283),
    [anon_sym_LT_LT_DASH] = ACTIONS(283),
    [anon_sym_DQUOTE] = ACTIONS(285),
    [sym_raw_string] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(291),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_LT_LPAREN] = ACTIONS(297),
    [anon_sym_GT_LPAREN] = ACTIONS(297),
    [sym_word] = ACTIONS(287),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(597),
    [anon_sym_LF] = ACTIONS(597),
    [anon_sym_AMP] = ACTIONS(597),
  },
  [128] = {
    [sym_file_descriptor] = ACTIONS(609),
    [sym_variable_name] = ACTIONS(609),
    [anon_sym_LT] = ACTIONS(611),
    [anon_sym_GT] = ACTIONS(611),
    [anon_sym_GT_GT] = ACTIONS(609),
    [anon_sym_AMP_GT] = ACTIONS(611),
    [anon_sym_AMP_GT_GT] = ACTIONS(609),
    [anon_sym_LT_AMP] = ACTIONS(609),
    [anon_sym_GT_AMP] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(609),
    [sym_raw_string] = ACTIONS(609),
    [anon_sym_DOLLAR] = ACTIONS(611),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(609),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(609),
    [anon_sym_LT_LPAREN] = ACTIONS(609),
    [anon_sym_GT_LPAREN] = ACTIONS(609),
    [sym_word] = ACTIONS(611),
    [sym_comment] = ACTIONS(133),
  },
  [129] = {
    [aux_sym_concatenation_repeat1] = STATE(198),
    [sym_file_descriptor] = ACTIONS(613),
    [sym__concat] = ACTIONS(413),
    [sym_variable_name] = ACTIONS(613),
    [anon_sym_LT] = ACTIONS(615),
    [anon_sym_GT] = ACTIONS(615),
    [anon_sym_GT_GT] = ACTIONS(613),
    [anon_sym_AMP_GT] = ACTIONS(615),
    [anon_sym_AMP_GT_GT] = ACTIONS(613),
    [anon_sym_LT_AMP] = ACTIONS(613),
    [anon_sym_GT_AMP] = ACTIONS(613),
    [anon_sym_DQUOTE] = ACTIONS(613),
    [sym_raw_string] = ACTIONS(613),
    [anon_sym_DOLLAR] = ACTIONS(615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(613),
    [anon_sym_BQUOTE] = ACTIONS(613),
    [anon_sym_LT_LPAREN] = ACTIONS(613),
    [anon_sym_GT_LPAREN] = ACTIONS(613),
    [sym_word] = ACTIONS(615),
    [sym_comment] = ACTIONS(133),
  },
  [130] = {
    [sym_file_descriptor] = ACTIONS(613),
    [sym_variable_name] = ACTIONS(613),
    [anon_sym_LT] = ACTIONS(615),
    [anon_sym_GT] = ACTIONS(615),
    [anon_sym_GT_GT] = ACTIONS(613),
    [anon_sym_AMP_GT] = ACTIONS(615),
    [anon_sym_AMP_GT_GT] = ACTIONS(613),
    [anon_sym_LT_AMP] = ACTIONS(613),
    [anon_sym_GT_AMP] = ACTIONS(613),
    [anon_sym_DQUOTE] = ACTIONS(613),
    [sym_raw_string] = ACTIONS(613),
    [anon_sym_DOLLAR] = ACTIONS(615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(613),
    [anon_sym_BQUOTE] = ACTIONS(613),
    [anon_sym_LT_LPAREN] = ACTIONS(613),
    [anon_sym_GT_LPAREN] = ACTIONS(613),
    [sym_word] = ACTIONS(615),
    [sym_comment] = ACTIONS(133),
  },
  [131] = {
    [sym_simple_expansion] = STATE(70),
    [sym_expansion] = STATE(70),
    [sym_command_substitution] = STATE(70),
    [aux_sym_string_repeat1] = STATE(302),
    [anon_sym_DQUOTE] = ACTIONS(617),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(197),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [132] = {
    [aux_sym_concatenation_repeat1] = STATE(305),
    [sym__concat] = ACTIONS(619),
    [anon_sym_RBRACK] = ACTIONS(621),
    [sym_comment] = ACTIONS(133),
  },
  [133] = {
    [sym_special_variable_name] = STATE(308),
    [anon_sym_DOLLAR] = ACTIONS(623),
    [anon_sym_POUND] = ACTIONS(625),
    [anon_sym_AT] = ACTIONS(623),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(627),
    [anon_sym_STAR] = ACTIONS(623),
    [anon_sym_QMARK] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(623),
    [anon_sym_BANG] = ACTIONS(623),
    [anon_sym_0] = ACTIONS(625),
    [anon_sym__] = ACTIONS(625),
  },
  [134] = {
    [sym_special_variable_name] = STATE(311),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(629),
    [anon_sym_AT] = ACTIONS(219),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(631),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [135] = {
    [sym_for_statement] = STATE(312),
    [sym_while_statement] = STATE(312),
    [sym_if_statement] = STATE(312),
    [sym_case_statement] = STATE(312),
    [sym_function_definition] = STATE(312),
    [sym_subshell] = STATE(312),
    [sym_pipeline] = STATE(312),
    [sym_list] = STATE(312),
    [sym_bracket_command] = STATE(312),
    [sym_command] = STATE(312),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(313),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [136] = {
    [sym_for_statement] = STATE(314),
    [sym_while_statement] = STATE(314),
    [sym_if_statement] = STATE(314),
    [sym_case_statement] = STATE(314),
    [sym_function_definition] = STATE(314),
    [sym_subshell] = STATE(314),
    [sym_pipeline] = STATE(314),
    [sym_list] = STATE(314),
    [sym_bracket_command] = STATE(314),
    [sym_command] = STATE(314),
    [sym_command_name] = STATE(109),
    [sym_environment_variable_assignment] = STATE(315),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [137] = {
    [sym_for_statement] = STATE(316),
    [sym_while_statement] = STATE(316),
    [sym_if_statement] = STATE(316),
    [sym_case_statement] = STATE(316),
    [sym_function_definition] = STATE(316),
    [sym_subshell] = STATE(316),
    [sym_pipeline] = STATE(316),
    [sym_list] = STATE(316),
    [sym_bracket_command] = STATE(316),
    [sym_command] = STATE(316),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(317),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [138] = {
    [anon_sym_RBRACK] = ACTIONS(621),
    [sym_comment] = ACTIONS(133),
  },
  [139] = {
    [sym_file_descriptor] = ACTIONS(633),
    [sym_variable_name] = ACTIONS(633),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_RPAREN] = ACTIONS(635),
    [anon_sym_SEMI_SEMI] = ACTIONS(635),
    [anon_sym_PIPE_AMP] = ACTIONS(635),
    [anon_sym_AMP_AMP] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_GT_GT] = ACTIONS(635),
    [anon_sym_AMP_GT] = ACTIONS(635),
    [anon_sym_AMP_GT_GT] = ACTIONS(635),
    [anon_sym_LT_AMP] = ACTIONS(635),
    [anon_sym_GT_AMP] = ACTIONS(635),
    [anon_sym_DQUOTE] = ACTIONS(635),
    [sym_raw_string] = ACTIONS(635),
    [anon_sym_DOLLAR] = ACTIONS(635),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(635),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [anon_sym_LT_LPAREN] = ACTIONS(635),
    [anon_sym_GT_LPAREN] = ACTIONS(635),
    [sym_word] = ACTIONS(635),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(635),
    [anon_sym_LF] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
  },
  [140] = {
    [aux_sym_array_repeat1] = STATE(320),
    [anon_sym_RPAREN] = ACTIONS(637),
    [sym_word] = ACTIONS(639),
    [sym_comment] = ACTIONS(133),
  },
  [141] = {
    [sym_simple_expansion] = STATE(70),
    [sym_expansion] = STATE(70),
    [sym_command_substitution] = STATE(70),
    [aux_sym_string_repeat1] = STATE(322),
    [anon_sym_DQUOTE] = ACTIONS(641),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(197),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [142] = {
    [aux_sym_concatenation_repeat1] = STATE(324),
    [sym_file_descriptor] = ACTIONS(633),
    [sym__concat] = ACTIONS(643),
    [sym_variable_name] = ACTIONS(633),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_RPAREN] = ACTIONS(635),
    [anon_sym_SEMI_SEMI] = ACTIONS(635),
    [anon_sym_PIPE_AMP] = ACTIONS(635),
    [anon_sym_AMP_AMP] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_GT_GT] = ACTIONS(635),
    [anon_sym_AMP_GT] = ACTIONS(635),
    [anon_sym_AMP_GT_GT] = ACTIONS(635),
    [anon_sym_LT_AMP] = ACTIONS(635),
    [anon_sym_GT_AMP] = ACTIONS(635),
    [anon_sym_DQUOTE] = ACTIONS(635),
    [sym_raw_string] = ACTIONS(635),
    [anon_sym_DOLLAR] = ACTIONS(635),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(635),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [anon_sym_LT_LPAREN] = ACTIONS(635),
    [anon_sym_GT_LPAREN] = ACTIONS(635),
    [sym_word] = ACTIONS(635),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(635),
    [anon_sym_LF] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
  },
  [143] = {
    [sym_special_variable_name] = STATE(327),
    [anon_sym_DOLLAR] = ACTIONS(645),
    [anon_sym_POUND] = ACTIONS(647),
    [anon_sym_AT] = ACTIONS(645),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(645),
    [anon_sym_QMARK] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(645),
    [anon_sym_0] = ACTIONS(647),
    [anon_sym__] = ACTIONS(647),
  },
  [144] = {
    [sym_special_variable_name] = STATE(330),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(651),
    [anon_sym_AT] = ACTIONS(219),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(653),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [145] = {
    [sym_for_statement] = STATE(331),
    [sym_while_statement] = STATE(331),
    [sym_if_statement] = STATE(331),
    [sym_case_statement] = STATE(331),
    [sym_function_definition] = STATE(331),
    [sym_subshell] = STATE(331),
    [sym_pipeline] = STATE(331),
    [sym_list] = STATE(331),
    [sym_bracket_command] = STATE(331),
    [sym_command] = STATE(331),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(332),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [146] = {
    [sym_for_statement] = STATE(333),
    [sym_while_statement] = STATE(333),
    [sym_if_statement] = STATE(333),
    [sym_case_statement] = STATE(333),
    [sym_function_definition] = STATE(333),
    [sym_subshell] = STATE(333),
    [sym_pipeline] = STATE(333),
    [sym_list] = STATE(333),
    [sym_bracket_command] = STATE(333),
    [sym_command] = STATE(333),
    [sym_command_name] = STATE(109),
    [sym_environment_variable_assignment] = STATE(334),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [147] = {
    [sym_for_statement] = STATE(335),
    [sym_while_statement] = STATE(335),
    [sym_if_statement] = STATE(335),
    [sym_case_statement] = STATE(335),
    [sym_function_definition] = STATE(335),
    [sym_subshell] = STATE(335),
    [sym_pipeline] = STATE(335),
    [sym_list] = STATE(335),
    [sym_bracket_command] = STATE(335),
    [sym_command] = STATE(335),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(336),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [148] = {
    [sym_concatenation] = STATE(344),
    [sym_string] = STATE(338),
    [sym_simple_expansion] = STATE(338),
    [sym_expansion] = STATE(338),
    [sym_command_substitution] = STATE(338),
    [sym_process_substitution] = STATE(338),
    [aux_sym_for_statement_repeat1] = STATE(345),
    [anon_sym_DQUOTE] = ACTIONS(655),
    [sym_raw_string] = ACTIONS(657),
    [anon_sym_DOLLAR] = ACTIONS(659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(661),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(663),
    [anon_sym_BQUOTE] = ACTIONS(665),
    [anon_sym_LT_LPAREN] = ACTIONS(667),
    [anon_sym_GT_LPAREN] = ACTIONS(667),
    [sym_word] = ACTIONS(669),
    [sym_comment] = ACTIONS(133),
  },
  [149] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(347),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_done] = ACTIONS(671),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [150] = {
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(673),
    [anon_sym_SEMI_SEMI] = ACTIONS(673),
    [anon_sym_PIPE_AMP] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(673),
    [anon_sym_PIPE_PIPE] = ACTIONS(673),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(673),
    [anon_sym_LF] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
  },
  [151] = {
    [anon_sym_do] = ACTIONS(563),
    [anon_sym_then] = ACTIONS(563),
    [sym_comment] = ACTIONS(133),
  },
  [152] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_elif_clause] = STATE(351),
    [sym_else_clause] = STATE(352),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(353),
    [aux_sym_if_statement_repeat1] = STATE(354),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_fi] = ACTIONS(675),
    [anon_sym_elif] = ACTIONS(677),
    [anon_sym_else] = ACTIONS(679),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [153] = {
    [sym__concat] = ACTIONS(427),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_SEMI_SEMI] = ACTIONS(429),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(429),
    [anon_sym_LF] = ACTIONS(429),
    [anon_sym_AMP] = ACTIONS(429),
  },
  [154] = {
    [sym_simple_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [anon_sym_DQUOTE] = ACTIONS(681),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(447),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [155] = {
    [sym_string] = STATE(356),
    [sym_simple_expansion] = STATE(356),
    [sym_expansion] = STATE(356),
    [sym_command_substitution] = STATE(356),
    [sym_process_substitution] = STATE(356),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_LT_LPAREN] = ACTIONS(157),
    [anon_sym_GT_LPAREN] = ACTIONS(157),
    [sym_word] = ACTIONS(685),
    [sym_comment] = ACTIONS(133),
  },
  [156] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(687),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(687),
    [anon_sym_LF] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(687),
  },
  [157] = {
    [anon_sym_in] = ACTIONS(689),
    [sym_comment] = ACTIONS(133),
  },
  [158] = {
    [sym__concat] = ACTIONS(691),
    [anon_sym_in] = ACTIONS(457),
    [anon_sym_SEMI_SEMI] = ACTIONS(457),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(457),
    [anon_sym_LF] = ACTIONS(457),
    [anon_sym_AMP] = ACTIONS(457),
  },
  [159] = {
    [sym__concat] = ACTIONS(459),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_SEMI_SEMI] = ACTIONS(461),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_LF] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(461),
  },
  [160] = {
    [sym__concat] = ACTIONS(463),
    [anon_sym_in] = ACTIONS(465),
    [anon_sym_SEMI_SEMI] = ACTIONS(465),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(465),
    [anon_sym_LF] = ACTIONS(465),
    [anon_sym_AMP] = ACTIONS(465),
  },
  [161] = {
    [sym__concat] = ACTIONS(467),
    [anon_sym_in] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
  },
  [162] = {
    [sym_special_variable_name] = STATE(361),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(225),
    [anon_sym_AT] = ACTIONS(219),
    [anon_sym_COLON] = ACTIONS(471),
    [anon_sym_COLON_QMARK] = ACTIONS(459),
    [anon_sym_COLON_DASH] = ACTIONS(459),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(693),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [163] = {
    [anon_sym_RBRACE] = ACTIONS(695),
    [anon_sym_LBRACK] = ACTIONS(697),
    [anon_sym_EQ] = ACTIONS(699),
    [anon_sym_COLON] = ACTIONS(701),
    [anon_sym_COLON_QMARK] = ACTIONS(699),
    [anon_sym_COLON_DASH] = ACTIONS(699),
    [anon_sym_PERCENT] = ACTIONS(699),
    [anon_sym_SLASH] = ACTIONS(699),
    [sym_comment] = ACTIONS(133),
  },
  [164] = {
    [anon_sym_RBRACE] = ACTIONS(703),
    [anon_sym_LBRACK] = ACTIONS(705),
    [anon_sym_EQ] = ACTIONS(707),
    [anon_sym_COLON] = ACTIONS(709),
    [anon_sym_COLON_QMARK] = ACTIONS(707),
    [anon_sym_COLON_DASH] = ACTIONS(707),
    [anon_sym_PERCENT] = ACTIONS(707),
    [anon_sym_SLASH] = ACTIONS(707),
    [sym_comment] = ACTIONS(133),
  },
  [165] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(711),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [166] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(711),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [167] = {
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(711),
    [sym_comment] = ACTIONS(133),
  },
  [168] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(711),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [169] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(713),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [170] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(713),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [171] = {
    [anon_sym_RPAREN] = ACTIONS(715),
    [sym_comment] = ACTIONS(133),
  },
  [172] = {
    [anon_sym_PIPE] = ACTIONS(717),
    [anon_sym_RPAREN] = ACTIONS(717),
    [anon_sym_SEMI_SEMI] = ACTIONS(717),
    [anon_sym_PIPE_AMP] = ACTIONS(717),
    [anon_sym_AMP_AMP] = ACTIONS(717),
    [anon_sym_PIPE_PIPE] = ACTIONS(717),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(717),
    [anon_sym_LF] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
  },
  [173] = {
    [sym_file_descriptor] = ACTIONS(563),
    [sym_variable_name] = ACTIONS(563),
    [anon_sym_for] = ACTIONS(565),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(719),
    [anon_sym_function] = ACTIONS(565),
    [anon_sym_LPAREN] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(565),
    [anon_sym_GT] = ACTIONS(565),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_AMP_GT] = ACTIONS(565),
    [anon_sym_AMP_GT_GT] = ACTIONS(563),
    [anon_sym_LT_AMP] = ACTIONS(563),
    [anon_sym_GT_AMP] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(563),
    [sym_raw_string] = ACTIONS(563),
    [anon_sym_DOLLAR] = ACTIONS(565),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(563),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(563),
    [anon_sym_BQUOTE] = ACTIONS(563),
    [anon_sym_LT_LPAREN] = ACTIONS(563),
    [anon_sym_GT_LPAREN] = ACTIONS(563),
    [sym_word] = ACTIONS(567),
    [sym_comment] = ACTIONS(133),
  },
  [174] = {
    [anon_sym_PIPE] = ACTIONS(271),
    [anon_sym_RPAREN] = ACTIONS(721),
    [anon_sym_SEMI_SEMI] = ACTIONS(723),
    [anon_sym_PIPE_AMP] = ACTIONS(271),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(723),
    [anon_sym_LF] = ACTIONS(723),
    [anon_sym_AMP] = ACTIONS(723),
  },
  [175] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(271),
    [anon_sym_RPAREN] = ACTIONS(721),
    [anon_sym_SEMI_SEMI] = ACTIONS(723),
    [anon_sym_PIPE_AMP] = ACTIONS(271),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_LT] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(301),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_AMP_GT] = ACTIONS(301),
    [anon_sym_AMP_GT_GT] = ACTIONS(301),
    [anon_sym_LT_AMP] = ACTIONS(301),
    [anon_sym_GT_AMP] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(301),
    [sym_raw_string] = ACTIONS(301),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(301),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(301),
    [anon_sym_GT_LPAREN] = ACTIONS(301),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(723),
    [anon_sym_LF] = ACTIONS(723),
    [anon_sym_AMP] = ACTIONS(723),
  },
  [176] = {
    [sym__concat] = ACTIONS(427),
    [anon_sym_RBRACE] = ACTIONS(427),
    [anon_sym_RBRACK] = ACTIONS(725),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(725),
    [anon_sym_DQUOTE] = ACTIONS(427),
    [sym_raw_string] = ACTIONS(427),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(427),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(427),
    [anon_sym_BQUOTE] = ACTIONS(427),
    [anon_sym_LT_LPAREN] = ACTIONS(427),
    [anon_sym_GT_LPAREN] = ACTIONS(427),
    [sym_word] = ACTIONS(429),
    [sym_comment] = ACTIONS(133),
  },
  [177] = {
    [sym_simple_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [anon_sym_DQUOTE] = ACTIONS(727),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(447),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [178] = {
    [sym_string] = STATE(374),
    [sym_simple_expansion] = STATE(374),
    [sym_expansion] = STATE(374),
    [sym_command_substitution] = STATE(374),
    [sym_process_substitution] = STATE(374),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(729),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(731),
    [sym_comment] = ACTIONS(133),
  },
  [179] = {
    [sym__concat] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(735),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(453),
    [sym_raw_string] = ACTIONS(453),
    [anon_sym_DOLLAR] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(453),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(453),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_LT_LPAREN] = ACTIONS(453),
    [anon_sym_GT_LPAREN] = ACTIONS(453),
    [sym_word] = ACTIONS(457),
    [sym_comment] = ACTIONS(133),
  },
  [180] = {
    [sym__concat] = ACTIONS(459),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_RBRACK] = ACTIONS(471),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(471),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [sym_raw_string] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(459),
    [anon_sym_BQUOTE] = ACTIONS(459),
    [anon_sym_LT_LPAREN] = ACTIONS(459),
    [anon_sym_GT_LPAREN] = ACTIONS(459),
    [sym_word] = ACTIONS(461),
    [sym_comment] = ACTIONS(133),
  },
  [181] = {
    [sym__concat] = ACTIONS(463),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_RBRACK] = ACTIONS(737),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(463),
    [sym_raw_string] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(463),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(463),
    [anon_sym_BQUOTE] = ACTIONS(463),
    [anon_sym_LT_LPAREN] = ACTIONS(463),
    [anon_sym_GT_LPAREN] = ACTIONS(463),
    [sym_word] = ACTIONS(465),
    [sym_comment] = ACTIONS(133),
  },
  [182] = {
    [sym__concat] = ACTIONS(467),
    [anon_sym_RBRACE] = ACTIONS(467),
    [anon_sym_RBRACK] = ACTIONS(739),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(739),
    [anon_sym_DQUOTE] = ACTIONS(467),
    [sym_raw_string] = ACTIONS(467),
    [anon_sym_DOLLAR] = ACTIONS(739),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(467),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(467),
    [anon_sym_BQUOTE] = ACTIONS(467),
    [anon_sym_LT_LPAREN] = ACTIONS(467),
    [anon_sym_GT_LPAREN] = ACTIONS(467),
    [sym_word] = ACTIONS(469),
    [sym_comment] = ACTIONS(133),
  },
  [183] = {
    [sym_special_variable_name] = STATE(377),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(225),
    [anon_sym_AT] = ACTIONS(219),
    [anon_sym_COLON] = ACTIONS(471),
    [anon_sym_COLON_QMARK] = ACTIONS(459),
    [anon_sym_COLON_DASH] = ACTIONS(459),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [184] = {
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_EQ] = ACTIONS(747),
    [anon_sym_COLON] = ACTIONS(749),
    [anon_sym_COLON_QMARK] = ACTIONS(747),
    [anon_sym_COLON_DASH] = ACTIONS(747),
    [anon_sym_PERCENT] = ACTIONS(747),
    [anon_sym_SLASH] = ACTIONS(747),
    [sym_comment] = ACTIONS(133),
  },
  [185] = {
    [anon_sym_RBRACE] = ACTIONS(751),
    [anon_sym_LBRACK] = ACTIONS(753),
    [anon_sym_EQ] = ACTIONS(755),
    [anon_sym_COLON] = ACTIONS(757),
    [anon_sym_COLON_QMARK] = ACTIONS(755),
    [anon_sym_COLON_DASH] = ACTIONS(755),
    [anon_sym_PERCENT] = ACTIONS(755),
    [anon_sym_SLASH] = ACTIONS(755),
    [sym_comment] = ACTIONS(133),
  },
  [186] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(759),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [187] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(759),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [188] = {
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(759),
    [sym_comment] = ACTIONS(133),
  },
  [189] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(759),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [190] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(761),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [191] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(761),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [192] = {
    [anon_sym_PIPE] = ACTIONS(763),
    [anon_sym_RPAREN] = ACTIONS(763),
    [anon_sym_SEMI_SEMI] = ACTIONS(763),
    [anon_sym_PIPE_AMP] = ACTIONS(763),
    [anon_sym_AMP_AMP] = ACTIONS(763),
    [anon_sym_PIPE_PIPE] = ACTIONS(763),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(763),
    [anon_sym_LF] = ACTIONS(763),
    [anon_sym_AMP] = ACTIONS(763),
  },
  [193] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACK] = ACTIONS(765),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [sym_raw_string] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(767),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LT_LPAREN] = ACTIONS(767),
    [anon_sym_GT_LPAREN] = ACTIONS(767),
    [sym_word] = ACTIONS(769),
    [sym_comment] = ACTIONS(133),
  },
  [194] = {
    [anon_sym_RBRACK] = ACTIONS(765),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [sym_raw_string] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(767),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LT_LPAREN] = ACTIONS(767),
    [anon_sym_GT_LPAREN] = ACTIONS(767),
    [sym_word] = ACTIONS(769),
    [sym_comment] = ACTIONS(133),
  },
  [195] = {
    [sym_file_descriptor] = ACTIONS(427),
    [sym__concat] = ACTIONS(427),
    [sym_variable_name] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(427),
    [anon_sym_PIPE_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_LT] = ACTIONS(725),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_AMP_GT] = ACTIONS(725),
    [anon_sym_AMP_GT_GT] = ACTIONS(427),
    [anon_sym_LT_AMP] = ACTIONS(427),
    [anon_sym_GT_AMP] = ACTIONS(427),
    [anon_sym_DQUOTE] = ACTIONS(427),
    [sym_raw_string] = ACTIONS(427),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(427),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(427),
    [anon_sym_BQUOTE] = ACTIONS(427),
    [anon_sym_LT_LPAREN] = ACTIONS(427),
    [anon_sym_GT_LPAREN] = ACTIONS(427),
    [sym_word] = ACTIONS(429),
    [sym_comment] = ACTIONS(133),
  },
  [196] = {
    [sym_simple_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(447),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [197] = {
    [sym_string] = STATE(387),
    [sym_simple_expansion] = STATE(387),
    [sym_expansion] = STATE(387),
    [sym_command_substitution] = STATE(387),
    [sym_process_substitution] = STATE(387),
    [anon_sym_DQUOTE] = ACTIONS(179),
    [sym_raw_string] = ACTIONS(773),
    [anon_sym_DOLLAR] = ACTIONS(183),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(185),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(189),
    [anon_sym_LT_LPAREN] = ACTIONS(191),
    [anon_sym_GT_LPAREN] = ACTIONS(191),
    [sym_word] = ACTIONS(775),
    [sym_comment] = ACTIONS(133),
  },
  [198] = {
    [sym_file_descriptor] = ACTIONS(453),
    [sym__concat] = ACTIONS(777),
    [sym_variable_name] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_PIPE_AMP] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(453),
    [anon_sym_AMP_GT] = ACTIONS(735),
    [anon_sym_AMP_GT_GT] = ACTIONS(453),
    [anon_sym_LT_AMP] = ACTIONS(453),
    [anon_sym_GT_AMP] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(453),
    [sym_raw_string] = ACTIONS(453),
    [anon_sym_DOLLAR] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(453),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(453),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_LT_LPAREN] = ACTIONS(453),
    [anon_sym_GT_LPAREN] = ACTIONS(453),
    [sym_word] = ACTIONS(457),
    [sym_comment] = ACTIONS(133),
  },
  [199] = {
    [sym_file_descriptor] = ACTIONS(459),
    [sym__concat] = ACTIONS(459),
    [sym_variable_name] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_RPAREN] = ACTIONS(459),
    [anon_sym_PIPE_AMP] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_GT_GT] = ACTIONS(459),
    [anon_sym_AMP_GT] = ACTIONS(471),
    [anon_sym_AMP_GT_GT] = ACTIONS(459),
    [anon_sym_LT_AMP] = ACTIONS(459),
    [anon_sym_GT_AMP] = ACTIONS(459),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [sym_raw_string] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(459),
    [anon_sym_BQUOTE] = ACTIONS(459),
    [anon_sym_LT_LPAREN] = ACTIONS(459),
    [anon_sym_GT_LPAREN] = ACTIONS(459),
    [sym_word] = ACTIONS(461),
    [sym_comment] = ACTIONS(133),
  },
  [200] = {
    [sym_file_descriptor] = ACTIONS(463),
    [sym__concat] = ACTIONS(463),
    [sym_variable_name] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(463),
    [anon_sym_PIPE_AMP] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(463),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(463),
    [anon_sym_LT_AMP] = ACTIONS(463),
    [anon_sym_GT_AMP] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(463),
    [sym_raw_string] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(463),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(463),
    [anon_sym_BQUOTE] = ACTIONS(463),
    [anon_sym_LT_LPAREN] = ACTIONS(463),
    [anon_sym_GT_LPAREN] = ACTIONS(463),
    [sym_word] = ACTIONS(465),
    [sym_comment] = ACTIONS(133),
  },
  [201] = {
    [sym_file_descriptor] = ACTIONS(467),
    [sym__concat] = ACTIONS(467),
    [sym_variable_name] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(739),
    [anon_sym_RPAREN] = ACTIONS(467),
    [anon_sym_PIPE_AMP] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [anon_sym_LT] = ACTIONS(739),
    [anon_sym_GT] = ACTIONS(739),
    [anon_sym_GT_GT] = ACTIONS(467),
    [anon_sym_AMP_GT] = ACTIONS(739),
    [anon_sym_AMP_GT_GT] = ACTIONS(467),
    [anon_sym_LT_AMP] = ACTIONS(467),
    [anon_sym_GT_AMP] = ACTIONS(467),
    [anon_sym_DQUOTE] = ACTIONS(467),
    [sym_raw_string] = ACTIONS(467),
    [anon_sym_DOLLAR] = ACTIONS(739),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(467),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(467),
    [anon_sym_BQUOTE] = ACTIONS(467),
    [anon_sym_LT_LPAREN] = ACTIONS(467),
    [anon_sym_GT_LPAREN] = ACTIONS(467),
    [sym_word] = ACTIONS(469),
    [sym_comment] = ACTIONS(133),
  },
  [202] = {
    [sym_special_variable_name] = STATE(390),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(225),
    [anon_sym_AT] = ACTIONS(219),
    [anon_sym_COLON] = ACTIONS(471),
    [anon_sym_COLON_QMARK] = ACTIONS(459),
    [anon_sym_COLON_DASH] = ACTIONS(459),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(779),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [203] = {
    [anon_sym_RBRACE] = ACTIONS(781),
    [anon_sym_LBRACK] = ACTIONS(783),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_COLON] = ACTIONS(787),
    [anon_sym_COLON_QMARK] = ACTIONS(785),
    [anon_sym_COLON_DASH] = ACTIONS(785),
    [anon_sym_PERCENT] = ACTIONS(785),
    [anon_sym_SLASH] = ACTIONS(785),
    [sym_comment] = ACTIONS(133),
  },
  [204] = {
    [anon_sym_RBRACE] = ACTIONS(789),
    [anon_sym_LBRACK] = ACTIONS(791),
    [anon_sym_EQ] = ACTIONS(793),
    [anon_sym_COLON] = ACTIONS(795),
    [anon_sym_COLON_QMARK] = ACTIONS(793),
    [anon_sym_COLON_DASH] = ACTIONS(793),
    [anon_sym_PERCENT] = ACTIONS(793),
    [anon_sym_SLASH] = ACTIONS(793),
    [sym_comment] = ACTIONS(133),
  },
  [205] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(797),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [206] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(797),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [207] = {
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(797),
    [sym_comment] = ACTIONS(133),
  },
  [208] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(797),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [209] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(799),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [210] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(799),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [211] = {
    [anon_sym_DQUOTE] = ACTIONS(461),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(471),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(461),
    [anon_sym_BQUOTE] = ACTIONS(461),
    [sym_comment] = ACTIONS(85),
  },
  [212] = {
    [anon_sym_DQUOTE] = ACTIONS(465),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(465),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(465),
    [anon_sym_BQUOTE] = ACTIONS(465),
    [sym_comment] = ACTIONS(85),
  },
  [213] = {
    [anon_sym_DQUOTE] = ACTIONS(469),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [sym_comment] = ACTIONS(85),
  },
  [214] = {
    [sym_special_variable_name] = STATE(400),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(225),
    [anon_sym_AT] = ACTIONS(219),
    [anon_sym_COLON] = ACTIONS(471),
    [anon_sym_COLON_QMARK] = ACTIONS(459),
    [anon_sym_COLON_DASH] = ACTIONS(459),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [215] = {
    [anon_sym_RBRACE] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(805),
    [anon_sym_EQ] = ACTIONS(807),
    [anon_sym_COLON] = ACTIONS(809),
    [anon_sym_COLON_QMARK] = ACTIONS(807),
    [anon_sym_COLON_DASH] = ACTIONS(807),
    [anon_sym_PERCENT] = ACTIONS(807),
    [anon_sym_SLASH] = ACTIONS(807),
    [sym_comment] = ACTIONS(133),
  },
  [216] = {
    [anon_sym_RBRACE] = ACTIONS(811),
    [anon_sym_LBRACK] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_COLON_QMARK] = ACTIONS(815),
    [anon_sym_COLON_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(815),
    [sym_comment] = ACTIONS(133),
  },
  [217] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(819),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [218] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(819),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [219] = {
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(133),
  },
  [220] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(819),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [221] = {
    [sym_file_descriptor] = ACTIONS(821),
    [sym__concat] = ACTIONS(821),
    [anon_sym_PIPE] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(823),
    [anon_sym_SEMI_SEMI] = ACTIONS(823),
    [anon_sym_PIPE_AMP] = ACTIONS(823),
    [anon_sym_AMP_AMP] = ACTIONS(823),
    [anon_sym_PIPE_PIPE] = ACTIONS(823),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(823),
    [anon_sym_GT_GT] = ACTIONS(823),
    [anon_sym_AMP_GT] = ACTIONS(823),
    [anon_sym_AMP_GT_GT] = ACTIONS(823),
    [anon_sym_LT_AMP] = ACTIONS(823),
    [anon_sym_GT_AMP] = ACTIONS(823),
    [anon_sym_LT_LT] = ACTIONS(823),
    [anon_sym_LT_LT_DASH] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(823),
    [sym_raw_string] = ACTIONS(823),
    [anon_sym_DOLLAR] = ACTIONS(823),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(823),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(823),
    [anon_sym_BQUOTE] = ACTIONS(823),
    [anon_sym_LT_LPAREN] = ACTIONS(823),
    [anon_sym_GT_LPAREN] = ACTIONS(823),
    [sym_word] = ACTIONS(823),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_LF] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
  },
  [222] = {
    [anon_sym_DQUOTE] = ACTIONS(825),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(825),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(825),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(825),
    [anon_sym_BQUOTE] = ACTIONS(825),
    [sym_comment] = ACTIONS(85),
  },
  [223] = {
    [sym_file_descriptor] = ACTIONS(829),
    [sym__concat] = ACTIONS(829),
    [anon_sym_PIPE] = ACTIONS(831),
    [anon_sym_RPAREN] = ACTIONS(831),
    [anon_sym_SEMI_SEMI] = ACTIONS(831),
    [anon_sym_PIPE_AMP] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(831),
    [anon_sym_GT_GT] = ACTIONS(831),
    [anon_sym_AMP_GT] = ACTIONS(831),
    [anon_sym_AMP_GT_GT] = ACTIONS(831),
    [anon_sym_LT_AMP] = ACTIONS(831),
    [anon_sym_GT_AMP] = ACTIONS(831),
    [anon_sym_LT_LT] = ACTIONS(831),
    [anon_sym_LT_LT_DASH] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(831),
    [sym_raw_string] = ACTIONS(831),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(831),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(831),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [anon_sym_LT_LPAREN] = ACTIONS(831),
    [anon_sym_GT_LPAREN] = ACTIONS(831),
    [sym_word] = ACTIONS(831),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(831),
    [anon_sym_LF] = ACTIONS(831),
    [anon_sym_AMP] = ACTIONS(831),
  },
  [224] = {
    [sym_string] = STATE(408),
    [sym_simple_expansion] = STATE(408),
    [sym_expansion] = STATE(408),
    [sym_command_substitution] = STATE(408),
    [sym_process_substitution] = STATE(408),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(833),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(835),
    [sym_comment] = ACTIONS(133),
  },
  [225] = {
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(839),
    [sym_comment] = ACTIONS(133),
  },
  [226] = {
    [anon_sym_RBRACE] = ACTIONS(841),
    [anon_sym_LBRACK] = ACTIONS(843),
    [sym_comment] = ACTIONS(133),
  },
  [227] = {
    [sym_file_descriptor] = ACTIONS(845),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(847),
    [anon_sym_SEMI_SEMI] = ACTIONS(847),
    [anon_sym_PIPE_AMP] = ACTIONS(847),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_PIPE_PIPE] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(847),
    [anon_sym_AMP_GT] = ACTIONS(847),
    [anon_sym_AMP_GT_GT] = ACTIONS(847),
    [anon_sym_LT_AMP] = ACTIONS(847),
    [anon_sym_GT_AMP] = ACTIONS(847),
    [anon_sym_LT_LT] = ACTIONS(847),
    [anon_sym_LT_LT_DASH] = ACTIONS(847),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [sym_raw_string] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(847),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(847),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(847),
    [anon_sym_GT_LPAREN] = ACTIONS(847),
    [sym_word] = ACTIONS(847),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(847),
    [anon_sym_LF] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(847),
  },
  [228] = {
    [anon_sym_AT] = ACTIONS(849),
    [sym_comment] = ACTIONS(133),
  },
  [229] = {
    [sym_concatenation] = STATE(415),
    [sym_string] = STATE(414),
    [sym_simple_expansion] = STATE(414),
    [sym_expansion] = STATE(414),
    [sym_command_substitution] = STATE(414),
    [sym_process_substitution] = STATE(414),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(851),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(853),
    [sym_comment] = ACTIONS(133),
  },
  [230] = {
    [sym_file_descriptor] = ACTIONS(855),
    [sym__concat] = ACTIONS(855),
    [anon_sym_PIPE] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [anon_sym_PIPE_AMP] = ACTIONS(857),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_AMP_GT] = ACTIONS(857),
    [anon_sym_AMP_GT_GT] = ACTIONS(857),
    [anon_sym_LT_AMP] = ACTIONS(857),
    [anon_sym_GT_AMP] = ACTIONS(857),
    [anon_sym_LT_LT] = ACTIONS(857),
    [anon_sym_LT_LT_DASH] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(857),
    [sym_raw_string] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(857),
    [anon_sym_LT_LPAREN] = ACTIONS(857),
    [anon_sym_GT_LPAREN] = ACTIONS(857),
    [sym_word] = ACTIONS(857),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
  },
  [231] = {
    [anon_sym_AT] = ACTIONS(859),
    [sym_comment] = ACTIONS(133),
  },
  [232] = {
    [sym_concatenation] = STATE(418),
    [sym_string] = STATE(417),
    [sym_simple_expansion] = STATE(417),
    [sym_expansion] = STATE(417),
    [sym_command_substitution] = STATE(417),
    [sym_process_substitution] = STATE(417),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(863),
    [sym_comment] = ACTIONS(133),
  },
  [233] = {
    [sym_concatenation] = STATE(419),
    [sym_string] = STATE(421),
    [sym_array] = STATE(419),
    [sym_simple_expansion] = STATE(421),
    [sym_expansion] = STATE(421),
    [sym_command_substitution] = STATE(421),
    [sym_process_substitution] = STATE(421),
    [sym__empty_value] = ACTIONS(865),
    [anon_sym_LPAREN] = ACTIONS(867),
    [anon_sym_DQUOTE] = ACTIONS(179),
    [sym_raw_string] = ACTIONS(869),
    [anon_sym_DOLLAR] = ACTIONS(183),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(185),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(189),
    [anon_sym_LT_LPAREN] = ACTIONS(191),
    [anon_sym_GT_LPAREN] = ACTIONS(191),
    [sym_word] = ACTIONS(871),
    [sym_comment] = ACTIONS(133),
  },
  [234] = {
    [anon_sym_in] = ACTIONS(873),
    [sym_comment] = ACTIONS(133),
  },
  [235] = {
    [sym_do_group] = STATE(424),
    [anon_sym_do] = ACTIONS(875),
    [sym_comment] = ACTIONS(133),
  },
  [236] = {
    [anon_sym_then] = ACTIONS(877),
    [sym_comment] = ACTIONS(133),
  },
  [237] = {
    [aux_sym_concatenation_repeat1] = STATE(158),
    [sym__concat] = ACTIONS(361),
    [anon_sym_in] = ACTIONS(879),
    [anon_sym_SEMI_SEMI] = ACTIONS(881),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_LF] = ACTIONS(881),
    [anon_sym_AMP] = ACTIONS(881),
  },
  [238] = {
    [anon_sym_in] = ACTIONS(879),
    [anon_sym_SEMI_SEMI] = ACTIONS(881),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_LF] = ACTIONS(881),
    [anon_sym_AMP] = ACTIONS(881),
  },
  [239] = {
    [anon_sym_LPAREN] = ACTIONS(883),
    [sym_comment] = ACTIONS(133),
  },
  [240] = {
    [anon_sym_PIPE] = ACTIONS(271),
    [anon_sym_RPAREN] = ACTIONS(885),
    [anon_sym_SEMI_SEMI] = ACTIONS(887),
    [anon_sym_PIPE_AMP] = ACTIONS(271),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_LF] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(887),
  },
  [241] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(271),
    [anon_sym_RPAREN] = ACTIONS(885),
    [anon_sym_SEMI_SEMI] = ACTIONS(887),
    [anon_sym_PIPE_AMP] = ACTIONS(271),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_LT] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(301),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_AMP_GT] = ACTIONS(301),
    [anon_sym_AMP_GT_GT] = ACTIONS(301),
    [anon_sym_LT_AMP] = ACTIONS(301),
    [anon_sym_GT_AMP] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(301),
    [sym_raw_string] = ACTIONS(301),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(301),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(301),
    [anon_sym_GT_LPAREN] = ACTIONS(301),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_LF] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(887),
  },
  [242] = {
    [sym__terminated_statement] = STATE(126),
    [sym_for_statement] = STATE(431),
    [sym_while_statement] = STATE(431),
    [sym_if_statement] = STATE(431),
    [sym_case_statement] = STATE(431),
    [sym_function_definition] = STATE(431),
    [sym_subshell] = STATE(431),
    [sym_pipeline] = STATE(431),
    [sym_list] = STATE(431),
    [sym_bracket_command] = STATE(431),
    [sym_command] = STATE(431),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(432),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [243] = {
    [sym_concatenation] = STATE(194),
    [sym_string] = STATE(193),
    [sym_simple_expansion] = STATE(193),
    [sym_expansion] = STATE(193),
    [sym_command_substitution] = STATE(193),
    [sym_process_substitution] = STATE(193),
    [anon_sym_RBRACK] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(405),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(407),
    [sym_comment] = ACTIONS(133),
  },
  [244] = {
    [sym_concatenation] = STATE(194),
    [sym_string] = STATE(193),
    [sym_simple_expansion] = STATE(193),
    [sym_expansion] = STATE(193),
    [sym_command_substitution] = STATE(193),
    [sym_process_substitution] = STATE(193),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(405),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(407),
    [sym_comment] = ACTIONS(133),
  },
  [245] = {
    [sym_file_descriptor] = ACTIONS(427),
    [sym__concat] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(427),
    [anon_sym_PIPE_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_LT] = ACTIONS(725),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_AMP_GT] = ACTIONS(725),
    [anon_sym_AMP_GT_GT] = ACTIONS(427),
    [anon_sym_LT_AMP] = ACTIONS(427),
    [anon_sym_GT_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(725),
    [anon_sym_LT_LT_DASH] = ACTIONS(427),
    [anon_sym_DQUOTE] = ACTIONS(427),
    [sym_raw_string] = ACTIONS(427),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(427),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(427),
    [anon_sym_BQUOTE] = ACTIONS(427),
    [anon_sym_LT_LPAREN] = ACTIONS(427),
    [anon_sym_GT_LPAREN] = ACTIONS(427),
    [sym_word] = ACTIONS(429),
    [sym_comment] = ACTIONS(133),
  },
  [246] = {
    [sym_simple_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [anon_sym_DQUOTE] = ACTIONS(891),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(447),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [247] = {
    [sym_string] = STATE(435),
    [sym_simple_expansion] = STATE(435),
    [sym_expansion] = STATE(435),
    [sym_command_substitution] = STATE(435),
    [sym_process_substitution] = STATE(435),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(893),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(895),
    [sym_comment] = ACTIONS(133),
  },
  [248] = {
    [sym_file_descriptor] = ACTIONS(453),
    [sym__concat] = ACTIONS(897),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_PIPE_AMP] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(453),
    [anon_sym_AMP_GT] = ACTIONS(735),
    [anon_sym_AMP_GT_GT] = ACTIONS(453),
    [anon_sym_LT_AMP] = ACTIONS(453),
    [anon_sym_GT_AMP] = ACTIONS(453),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(453),
    [sym_raw_string] = ACTIONS(453),
    [anon_sym_DOLLAR] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(453),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(453),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_LT_LPAREN] = ACTIONS(453),
    [anon_sym_GT_LPAREN] = ACTIONS(453),
    [sym_word] = ACTIONS(457),
    [sym_comment] = ACTIONS(133),
  },
  [249] = {
    [sym_file_descriptor] = ACTIONS(459),
    [sym__concat] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_RPAREN] = ACTIONS(459),
    [anon_sym_PIPE_AMP] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_GT_GT] = ACTIONS(459),
    [anon_sym_AMP_GT] = ACTIONS(471),
    [anon_sym_AMP_GT_GT] = ACTIONS(459),
    [anon_sym_LT_AMP] = ACTIONS(459),
    [anon_sym_GT_AMP] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(459),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [sym_raw_string] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(459),
    [anon_sym_BQUOTE] = ACTIONS(459),
    [anon_sym_LT_LPAREN] = ACTIONS(459),
    [anon_sym_GT_LPAREN] = ACTIONS(459),
    [sym_word] = ACTIONS(461),
    [sym_comment] = ACTIONS(133),
  },
  [250] = {
    [sym_file_descriptor] = ACTIONS(463),
    [sym__concat] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(463),
    [anon_sym_PIPE_AMP] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(463),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(463),
    [anon_sym_LT_AMP] = ACTIONS(463),
    [anon_sym_GT_AMP] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_LT_LT_DASH] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(463),
    [sym_raw_string] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(463),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(463),
    [anon_sym_BQUOTE] = ACTIONS(463),
    [anon_sym_LT_LPAREN] = ACTIONS(463),
    [anon_sym_GT_LPAREN] = ACTIONS(463),
    [sym_word] = ACTIONS(465),
    [sym_comment] = ACTIONS(133),
  },
  [251] = {
    [sym_file_descriptor] = ACTIONS(467),
    [sym__concat] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(739),
    [anon_sym_RPAREN] = ACTIONS(467),
    [anon_sym_PIPE_AMP] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [anon_sym_LT] = ACTIONS(739),
    [anon_sym_GT] = ACTIONS(739),
    [anon_sym_GT_GT] = ACTIONS(467),
    [anon_sym_AMP_GT] = ACTIONS(739),
    [anon_sym_AMP_GT_GT] = ACTIONS(467),
    [anon_sym_LT_AMP] = ACTIONS(467),
    [anon_sym_GT_AMP] = ACTIONS(467),
    [anon_sym_LT_LT] = ACTIONS(739),
    [anon_sym_LT_LT_DASH] = ACTIONS(467),
    [anon_sym_DQUOTE] = ACTIONS(467),
    [sym_raw_string] = ACTIONS(467),
    [anon_sym_DOLLAR] = ACTIONS(739),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(467),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(467),
    [anon_sym_BQUOTE] = ACTIONS(467),
    [anon_sym_LT_LPAREN] = ACTIONS(467),
    [anon_sym_GT_LPAREN] = ACTIONS(467),
    [sym_word] = ACTIONS(469),
    [sym_comment] = ACTIONS(133),
  },
  [252] = {
    [sym_special_variable_name] = STATE(438),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(225),
    [anon_sym_AT] = ACTIONS(219),
    [anon_sym_COLON] = ACTIONS(471),
    [anon_sym_COLON_QMARK] = ACTIONS(459),
    [anon_sym_COLON_DASH] = ACTIONS(459),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(899),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [253] = {
    [anon_sym_RBRACE] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(903),
    [anon_sym_EQ] = ACTIONS(905),
    [anon_sym_COLON] = ACTIONS(907),
    [anon_sym_COLON_QMARK] = ACTIONS(905),
    [anon_sym_COLON_DASH] = ACTIONS(905),
    [anon_sym_PERCENT] = ACTIONS(905),
    [anon_sym_SLASH] = ACTIONS(905),
    [sym_comment] = ACTIONS(133),
  },
  [254] = {
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_EQ] = ACTIONS(913),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_COLON_QMARK] = ACTIONS(913),
    [anon_sym_COLON_DASH] = ACTIONS(913),
    [anon_sym_PERCENT] = ACTIONS(913),
    [anon_sym_SLASH] = ACTIONS(913),
    [sym_comment] = ACTIONS(133),
  },
  [255] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(917),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [256] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(917),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [257] = {
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(917),
    [sym_comment] = ACTIONS(133),
  },
  [258] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(917),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [259] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [260] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [261] = {
    [anon_sym_RPAREN] = ACTIONS(921),
    [sym_comment] = ACTIONS(133),
  },
  [262] = {
    [sym_for_statement] = STATE(448),
    [sym_while_statement] = STATE(448),
    [sym_if_statement] = STATE(448),
    [sym_case_statement] = STATE(448),
    [sym_function_definition] = STATE(448),
    [sym_subshell] = STATE(448),
    [sym_pipeline] = STATE(448),
    [sym_list] = STATE(448),
    [sym_bracket_command] = STATE(448),
    [sym_command] = STATE(448),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(449),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [263] = {
    [sym_file_descriptor] = ACTIONS(923),
    [sym__concat] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_RPAREN] = ACTIONS(925),
    [anon_sym_SEMI_SEMI] = ACTIONS(925),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(925),
    [anon_sym_PIPE_PIPE] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_GT] = ACTIONS(925),
    [anon_sym_AMP_GT] = ACTIONS(925),
    [anon_sym_AMP_GT_GT] = ACTIONS(925),
    [anon_sym_LT_AMP] = ACTIONS(925),
    [anon_sym_GT_AMP] = ACTIONS(925),
    [anon_sym_LT_LT] = ACTIONS(925),
    [anon_sym_LT_LT_DASH] = ACTIONS(925),
    [anon_sym_DQUOTE] = ACTIONS(925),
    [sym_raw_string] = ACTIONS(925),
    [anon_sym_DOLLAR] = ACTIONS(925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(925),
    [anon_sym_BQUOTE] = ACTIONS(925),
    [anon_sym_LT_LPAREN] = ACTIONS(925),
    [anon_sym_GT_LPAREN] = ACTIONS(925),
    [sym_word] = ACTIONS(925),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(925),
    [anon_sym_LF] = ACTIONS(925),
    [anon_sym_AMP] = ACTIONS(925),
  },
  [264] = {
    [sym_for_statement] = STATE(450),
    [sym_while_statement] = STATE(450),
    [sym_if_statement] = STATE(450),
    [sym_case_statement] = STATE(450),
    [sym_function_definition] = STATE(450),
    [sym_subshell] = STATE(450),
    [sym_pipeline] = STATE(450),
    [sym_list] = STATE(450),
    [sym_bracket_command] = STATE(450),
    [sym_command] = STATE(450),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(451),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [265] = {
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_GT] = ACTIONS(927),
    [anon_sym_GT_GT] = ACTIONS(929),
    [anon_sym_AMP_GT] = ACTIONS(927),
    [anon_sym_AMP_GT_GT] = ACTIONS(929),
    [anon_sym_LT_AMP] = ACTIONS(929),
    [anon_sym_GT_AMP] = ACTIONS(929),
    [sym_comment] = ACTIONS(133),
  },
  [266] = {
    [sym_concatenation] = STATE(460),
    [sym_string] = STATE(454),
    [sym_simple_expansion] = STATE(454),
    [sym_expansion] = STATE(454),
    [sym_command_substitution] = STATE(454),
    [sym_process_substitution] = STATE(454),
    [anon_sym_DQUOTE] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(933),
    [anon_sym_DOLLAR] = ACTIONS(935),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(937),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(941),
    [anon_sym_LT_LPAREN] = ACTIONS(943),
    [anon_sym_GT_LPAREN] = ACTIONS(943),
    [sym_word] = ACTIONS(945),
    [sym_comment] = ACTIONS(133),
  },
  [267] = {
    [sym_heredoc] = STATE(463),
    [sym__simple_heredoc] = ACTIONS(947),
    [sym__heredoc_beginning] = ACTIONS(949),
    [sym_comment] = ACTIONS(133),
  },
  [268] = {
    [aux_sym_concatenation_repeat1] = STATE(248),
    [sym_file_descriptor] = ACTIONS(389),
    [sym__concat] = ACTIONS(503),
    [anon_sym_PIPE] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(389),
    [anon_sym_PIPE_AMP] = ACTIONS(389),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(389),
    [anon_sym_AMP_GT] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(389),
    [anon_sym_LT_AMP] = ACTIONS(389),
    [anon_sym_GT_AMP] = ACTIONS(389),
    [anon_sym_LT_LT] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(389),
    [anon_sym_DQUOTE] = ACTIONS(389),
    [sym_raw_string] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(389),
    [anon_sym_BQUOTE] = ACTIONS(389),
    [anon_sym_LT_LPAREN] = ACTIONS(389),
    [anon_sym_GT_LPAREN] = ACTIONS(389),
    [sym_word] = ACTIONS(391),
    [sym_comment] = ACTIONS(133),
  },
  [269] = {
    [sym_file_descriptor] = ACTIONS(593),
    [anon_sym_PIPE] = ACTIONS(951),
    [anon_sym_RPAREN] = ACTIONS(593),
    [anon_sym_PIPE_AMP] = ACTIONS(593),
    [anon_sym_AMP_AMP] = ACTIONS(593),
    [anon_sym_PIPE_PIPE] = ACTIONS(593),
    [anon_sym_LT] = ACTIONS(951),
    [anon_sym_GT] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(593),
    [anon_sym_AMP_GT] = ACTIONS(951),
    [anon_sym_AMP_GT_GT] = ACTIONS(593),
    [anon_sym_LT_AMP] = ACTIONS(593),
    [anon_sym_GT_AMP] = ACTIONS(593),
    [anon_sym_LT_LT] = ACTIONS(951),
    [anon_sym_LT_LT_DASH] = ACTIONS(593),
    [anon_sym_BQUOTE] = ACTIONS(593),
    [sym_comment] = ACTIONS(133),
  },
  [270] = {
    [sym_file_descriptor] = ACTIONS(389),
    [anon_sym_PIPE] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(389),
    [anon_sym_PIPE_AMP] = ACTIONS(389),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(389),
    [anon_sym_AMP_GT] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(389),
    [anon_sym_LT_AMP] = ACTIONS(389),
    [anon_sym_GT_AMP] = ACTIONS(389),
    [anon_sym_LT_LT] = ACTIONS(387),
    [anon_sym_LT_LT_DASH] = ACTIONS(389),
    [anon_sym_DQUOTE] = ACTIONS(389),
    [sym_raw_string] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(389),
    [anon_sym_BQUOTE] = ACTIONS(389),
    [anon_sym_LT_LPAREN] = ACTIONS(389),
    [anon_sym_GT_LPAREN] = ACTIONS(389),
    [sym_word] = ACTIONS(391),
    [sym_comment] = ACTIONS(133),
  },
  [271] = {
    [sym_file_redirect] = STATE(269),
    [sym_heredoc_redirect] = STATE(269),
    [sym_concatenation] = STATE(465),
    [sym_string] = STATE(464),
    [sym_simple_expansion] = STATE(464),
    [sym_expansion] = STATE(464),
    [sym_command_substitution] = STATE(464),
    [sym_process_substitution] = STATE(464),
    [aux_sym_command_repeat2] = STATE(466),
    [sym_file_descriptor] = ACTIONS(527),
    [anon_sym_PIPE] = ACTIONS(953),
    [anon_sym_RPAREN] = ACTIONS(955),
    [anon_sym_PIPE_AMP] = ACTIONS(955),
    [anon_sym_AMP_AMP] = ACTIONS(955),
    [anon_sym_PIPE_PIPE] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_GT] = ACTIONS(535),
    [anon_sym_AMP_GT] = ACTIONS(533),
    [anon_sym_AMP_GT_GT] = ACTIONS(535),
    [anon_sym_LT_AMP] = ACTIONS(535),
    [anon_sym_GT_AMP] = ACTIONS(535),
    [anon_sym_LT_LT] = ACTIONS(537),
    [anon_sym_LT_LT_DASH] = ACTIONS(539),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(959),
    [sym_comment] = ACTIONS(133),
  },
  [272] = {
    [sym_file_redirect] = STATE(467),
    [sym_heredoc_redirect] = STATE(467),
    [sym_file_descriptor] = ACTIONS(527),
    [anon_sym_PIPE] = ACTIONS(961),
    [anon_sym_RPAREN] = ACTIONS(963),
    [anon_sym_PIPE_AMP] = ACTIONS(963),
    [anon_sym_AMP_AMP] = ACTIONS(963),
    [anon_sym_PIPE_PIPE] = ACTIONS(963),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_GT] = ACTIONS(535),
    [anon_sym_AMP_GT] = ACTIONS(533),
    [anon_sym_AMP_GT_GT] = ACTIONS(535),
    [anon_sym_LT_AMP] = ACTIONS(535),
    [anon_sym_GT_AMP] = ACTIONS(535),
    [anon_sym_LT_LT] = ACTIONS(537),
    [anon_sym_LT_LT_DASH] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(963),
    [sym_comment] = ACTIONS(133),
  },
  [273] = {
    [sym_file_redirect] = STATE(269),
    [sym_heredoc_redirect] = STATE(269),
    [sym_concatenation] = STATE(270),
    [sym_string] = STATE(268),
    [sym_simple_expansion] = STATE(268),
    [sym_expansion] = STATE(268),
    [sym_command_substitution] = STATE(268),
    [sym_process_substitution] = STATE(268),
    [aux_sym_for_statement_repeat1] = STATE(468),
    [aux_sym_command_repeat2] = STATE(466),
    [sym_file_descriptor] = ACTIONS(527),
    [anon_sym_PIPE] = ACTIONS(953),
    [anon_sym_RPAREN] = ACTIONS(955),
    [anon_sym_PIPE_AMP] = ACTIONS(955),
    [anon_sym_AMP_AMP] = ACTIONS(955),
    [anon_sym_PIPE_PIPE] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_GT] = ACTIONS(535),
    [anon_sym_AMP_GT] = ACTIONS(533),
    [anon_sym_AMP_GT_GT] = ACTIONS(535),
    [anon_sym_LT_AMP] = ACTIONS(535),
    [anon_sym_GT_AMP] = ACTIONS(535),
    [anon_sym_LT_LT] = ACTIONS(537),
    [anon_sym_LT_LT_DASH] = ACTIONS(539),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(541),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(543),
    [sym_comment] = ACTIONS(133),
  },
  [274] = {
    [sym_for_statement] = STATE(448),
    [sym_while_statement] = STATE(448),
    [sym_if_statement] = STATE(448),
    [sym_case_statement] = STATE(448),
    [sym_function_definition] = STATE(448),
    [sym_subshell] = STATE(448),
    [sym_pipeline] = STATE(448),
    [sym_list] = STATE(448),
    [sym_bracket_command] = STATE(448),
    [sym_command] = STATE(448),
    [sym_command_name] = STATE(109),
    [sym_environment_variable_assignment] = STATE(469),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [275] = {
    [sym_for_statement] = STATE(470),
    [sym_while_statement] = STATE(470),
    [sym_if_statement] = STATE(470),
    [sym_case_statement] = STATE(470),
    [sym_function_definition] = STATE(470),
    [sym_subshell] = STATE(470),
    [sym_pipeline] = STATE(470),
    [sym_list] = STATE(470),
    [sym_bracket_command] = STATE(470),
    [sym_command] = STATE(470),
    [sym_command_name] = STATE(109),
    [sym_environment_variable_assignment] = STATE(471),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [276] = {
    [sym_file_redirect] = STATE(269),
    [sym_heredoc_redirect] = STATE(269),
    [sym_concatenation] = STATE(465),
    [sym_string] = STATE(464),
    [sym_simple_expansion] = STATE(464),
    [sym_expansion] = STATE(464),
    [sym_command_substitution] = STATE(464),
    [sym_process_substitution] = STATE(464),
    [aux_sym_command_repeat2] = STATE(466),
    [sym_file_descriptor] = ACTIONS(527),
    [anon_sym_PIPE] = ACTIONS(953),
    [anon_sym_PIPE_AMP] = ACTIONS(955),
    [anon_sym_AMP_AMP] = ACTIONS(955),
    [anon_sym_PIPE_PIPE] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_GT] = ACTIONS(535),
    [anon_sym_AMP_GT] = ACTIONS(533),
    [anon_sym_AMP_GT_GT] = ACTIONS(535),
    [anon_sym_LT_AMP] = ACTIONS(535),
    [anon_sym_GT_AMP] = ACTIONS(535),
    [anon_sym_LT_LT] = ACTIONS(537),
    [anon_sym_LT_LT_DASH] = ACTIONS(539),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(955),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(959),
    [sym_comment] = ACTIONS(133),
  },
  [277] = {
    [sym_file_redirect] = STATE(269),
    [sym_heredoc_redirect] = STATE(269),
    [sym_concatenation] = STATE(270),
    [sym_string] = STATE(268),
    [sym_simple_expansion] = STATE(268),
    [sym_expansion] = STATE(268),
    [sym_command_substitution] = STATE(268),
    [sym_process_substitution] = STATE(268),
    [aux_sym_for_statement_repeat1] = STATE(472),
    [aux_sym_command_repeat2] = STATE(466),
    [sym_file_descriptor] = ACTIONS(527),
    [anon_sym_PIPE] = ACTIONS(953),
    [anon_sym_PIPE_AMP] = ACTIONS(955),
    [anon_sym_AMP_AMP] = ACTIONS(955),
    [anon_sym_PIPE_PIPE] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_GT] = ACTIONS(535),
    [anon_sym_AMP_GT] = ACTIONS(533),
    [anon_sym_AMP_GT_GT] = ACTIONS(535),
    [anon_sym_LT_AMP] = ACTIONS(535),
    [anon_sym_GT_AMP] = ACTIONS(535),
    [anon_sym_LT_LT] = ACTIONS(537),
    [anon_sym_LT_LT_DASH] = ACTIONS(539),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(541),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(955),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(543),
    [sym_comment] = ACTIONS(133),
  },
  [278] = {
    [sym_file_descriptor] = ACTIONS(965),
    [sym__concat] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(967),
    [anon_sym_RPAREN] = ACTIONS(967),
    [anon_sym_SEMI_SEMI] = ACTIONS(967),
    [anon_sym_PIPE_AMP] = ACTIONS(967),
    [anon_sym_AMP_AMP] = ACTIONS(967),
    [anon_sym_PIPE_PIPE] = ACTIONS(967),
    [anon_sym_LT] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(967),
    [anon_sym_GT_GT] = ACTIONS(967),
    [anon_sym_AMP_GT] = ACTIONS(967),
    [anon_sym_AMP_GT_GT] = ACTIONS(967),
    [anon_sym_LT_AMP] = ACTIONS(967),
    [anon_sym_GT_AMP] = ACTIONS(967),
    [anon_sym_LT_LT] = ACTIONS(967),
    [anon_sym_LT_LT_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(967),
    [sym_raw_string] = ACTIONS(967),
    [anon_sym_DOLLAR] = ACTIONS(967),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(967),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(967),
    [anon_sym_BQUOTE] = ACTIONS(967),
    [anon_sym_LT_LPAREN] = ACTIONS(967),
    [anon_sym_GT_LPAREN] = ACTIONS(967),
    [sym_word] = ACTIONS(967),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_LF] = ACTIONS(967),
    [anon_sym_AMP] = ACTIONS(967),
  },
  [279] = {
    [sym_compound_statement] = STATE(474),
    [anon_sym_LBRACE] = ACTIONS(969),
    [sym_comment] = ACTIONS(133),
  },
  [280] = {
    [anon_sym_PIPE] = ACTIONS(971),
    [anon_sym_RPAREN] = ACTIONS(971),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(971),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(971),
  },
  [281] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(971),
    [anon_sym_RPAREN] = ACTIONS(971),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(301),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_AMP_GT] = ACTIONS(301),
    [anon_sym_AMP_GT_GT] = ACTIONS(301),
    [anon_sym_LT_AMP] = ACTIONS(301),
    [anon_sym_GT_AMP] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(301),
    [sym_raw_string] = ACTIONS(301),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(301),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(301),
    [anon_sym_GT_LPAREN] = ACTIONS(301),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(971),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(971),
  },
  [282] = {
    [anon_sym_PIPE] = ACTIONS(271),
    [anon_sym_RPAREN] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(973),
    [anon_sym_PIPE_AMP] = ACTIONS(271),
    [anon_sym_AMP_AMP] = ACTIONS(973),
    [anon_sym_PIPE_PIPE] = ACTIONS(973),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_LF] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [283] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(271),
    [anon_sym_RPAREN] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(973),
    [anon_sym_PIPE_AMP] = ACTIONS(271),
    [anon_sym_AMP_AMP] = ACTIONS(973),
    [anon_sym_PIPE_PIPE] = ACTIONS(973),
    [anon_sym_LT] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(301),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_AMP_GT] = ACTIONS(301),
    [anon_sym_AMP_GT_GT] = ACTIONS(301),
    [anon_sym_LT_AMP] = ACTIONS(301),
    [anon_sym_GT_AMP] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(301),
    [sym_raw_string] = ACTIONS(301),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(301),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(301),
    [anon_sym_GT_LPAREN] = ACTIONS(301),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_LF] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [284] = {
    [sym_concatenation] = STATE(476),
    [sym_string] = STATE(475),
    [sym_simple_expansion] = STATE(475),
    [sym_expansion] = STATE(475),
    [sym_command_substitution] = STATE(475),
    [sym_process_substitution] = STATE(475),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [sym_raw_string] = ACTIONS(975),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(579),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(581),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_LT_LPAREN] = ACTIONS(585),
    [anon_sym_GT_LPAREN] = ACTIONS(585),
    [sym_word] = ACTIONS(977),
    [sym_comment] = ACTIONS(133),
  },
  [285] = {
    [sym_simple_expansion] = STATE(70),
    [sym_expansion] = STATE(70),
    [sym_command_substitution] = STATE(70),
    [aux_sym_string_repeat1] = STATE(478),
    [anon_sym_DQUOTE] = ACTIONS(979),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(197),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [286] = {
    [aux_sym_concatenation_repeat1] = STATE(480),
    [sym_file_descriptor] = ACTIONS(411),
    [sym__concat] = ACTIONS(981),
    [anon_sym_PIPE] = ACTIONS(983),
    [anon_sym_RPAREN] = ACTIONS(983),
    [anon_sym_SEMI_SEMI] = ACTIONS(983),
    [anon_sym_PIPE_AMP] = ACTIONS(983),
    [anon_sym_AMP_AMP] = ACTIONS(983),
    [anon_sym_PIPE_PIPE] = ACTIONS(983),
    [anon_sym_LT] = ACTIONS(983),
    [anon_sym_GT] = ACTIONS(983),
    [anon_sym_GT_GT] = ACTIONS(983),
    [anon_sym_AMP_GT] = ACTIONS(983),
    [anon_sym_AMP_GT_GT] = ACTIONS(983),
    [anon_sym_LT_AMP] = ACTIONS(983),
    [anon_sym_GT_AMP] = ACTIONS(983),
    [anon_sym_LT_LT] = ACTIONS(983),
    [anon_sym_LT_LT_DASH] = ACTIONS(983),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_LF] = ACTIONS(983),
    [anon_sym_AMP] = ACTIONS(983),
  },
  [287] = {
    [sym_special_variable_name] = STATE(483),
    [anon_sym_DOLLAR] = ACTIONS(985),
    [anon_sym_POUND] = ACTIONS(987),
    [anon_sym_AT] = ACTIONS(985),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(989),
    [anon_sym_STAR] = ACTIONS(985),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_0] = ACTIONS(987),
    [anon_sym__] = ACTIONS(987),
  },
  [288] = {
    [sym_special_variable_name] = STATE(486),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(991),
    [anon_sym_AT] = ACTIONS(219),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(993),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [289] = {
    [sym_for_statement] = STATE(487),
    [sym_while_statement] = STATE(487),
    [sym_if_statement] = STATE(487),
    [sym_case_statement] = STATE(487),
    [sym_function_definition] = STATE(487),
    [sym_subshell] = STATE(487),
    [sym_pipeline] = STATE(487),
    [sym_list] = STATE(487),
    [sym_bracket_command] = STATE(487),
    [sym_command] = STATE(487),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(488),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [290] = {
    [sym_for_statement] = STATE(489),
    [sym_while_statement] = STATE(489),
    [sym_if_statement] = STATE(489),
    [sym_case_statement] = STATE(489),
    [sym_function_definition] = STATE(489),
    [sym_subshell] = STATE(489),
    [sym_pipeline] = STATE(489),
    [sym_list] = STATE(489),
    [sym_bracket_command] = STATE(489),
    [sym_command] = STATE(489),
    [sym_command_name] = STATE(109),
    [sym_environment_variable_assignment] = STATE(490),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [291] = {
    [sym_for_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_case_statement] = STATE(491),
    [sym_function_definition] = STATE(491),
    [sym_subshell] = STATE(491),
    [sym_pipeline] = STATE(491),
    [sym_list] = STATE(491),
    [sym_bracket_command] = STATE(491),
    [sym_command] = STATE(491),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(492),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [292] = {
    [sym_file_descriptor] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(983),
    [anon_sym_RPAREN] = ACTIONS(983),
    [anon_sym_SEMI_SEMI] = ACTIONS(983),
    [anon_sym_PIPE_AMP] = ACTIONS(983),
    [anon_sym_AMP_AMP] = ACTIONS(983),
    [anon_sym_PIPE_PIPE] = ACTIONS(983),
    [anon_sym_LT] = ACTIONS(983),
    [anon_sym_GT] = ACTIONS(983),
    [anon_sym_GT_GT] = ACTIONS(983),
    [anon_sym_AMP_GT] = ACTIONS(983),
    [anon_sym_AMP_GT_GT] = ACTIONS(983),
    [anon_sym_LT_AMP] = ACTIONS(983),
    [anon_sym_GT_AMP] = ACTIONS(983),
    [anon_sym_LT_LT] = ACTIONS(983),
    [anon_sym_LT_LT_DASH] = ACTIONS(983),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_LF] = ACTIONS(983),
    [anon_sym_AMP] = ACTIONS(983),
  },
  [293] = {
    [sym_file_descriptor] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_SEMI_SEMI] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_AMP_GT] = ACTIONS(997),
    [anon_sym_AMP_GT_GT] = ACTIONS(997),
    [anon_sym_LT_AMP] = ACTIONS(997),
    [anon_sym_GT_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_LT_LT_DASH] = ACTIONS(997),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(997),
  },
  [294] = {
    [sym_simple_expansion] = STATE(493),
    [sym_expansion] = STATE(493),
    [aux_sym_heredoc_repeat1] = STATE(497),
    [sym__heredoc_middle] = ACTIONS(999),
    [sym__heredoc_end] = ACTIONS(1001),
    [anon_sym_DOLLAR] = ACTIONS(1003),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1005),
    [sym_comment] = ACTIONS(133),
  },
  [295] = {
    [sym_file_descriptor] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(1009),
    [anon_sym_RPAREN] = ACTIONS(1009),
    [anon_sym_SEMI_SEMI] = ACTIONS(1009),
    [anon_sym_PIPE_AMP] = ACTIONS(1009),
    [anon_sym_AMP_AMP] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE] = ACTIONS(1009),
    [anon_sym_LT] = ACTIONS(1009),
    [anon_sym_GT] = ACTIONS(1009),
    [anon_sym_GT_GT] = ACTIONS(1009),
    [anon_sym_AMP_GT] = ACTIONS(1009),
    [anon_sym_AMP_GT_GT] = ACTIONS(1009),
    [anon_sym_LT_AMP] = ACTIONS(1009),
    [anon_sym_GT_AMP] = ACTIONS(1009),
    [anon_sym_LT_LT] = ACTIONS(1009),
    [anon_sym_LT_LT_DASH] = ACTIONS(1009),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1009),
    [anon_sym_LF] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1009),
  },
  [296] = {
    [aux_sym_concatenation_repeat1] = STATE(77),
    [sym_file_descriptor] = ACTIONS(767),
    [sym__concat] = ACTIONS(209),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_RPAREN] = ACTIONS(769),
    [anon_sym_SEMI_SEMI] = ACTIONS(769),
    [anon_sym_PIPE_AMP] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_AMP_GT] = ACTIONS(769),
    [anon_sym_AMP_GT_GT] = ACTIONS(769),
    [anon_sym_LT_AMP] = ACTIONS(769),
    [anon_sym_GT_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_LT_LT_DASH] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(769),
    [sym_raw_string] = ACTIONS(769),
    [anon_sym_DOLLAR] = ACTIONS(769),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(769),
    [anon_sym_BQUOTE] = ACTIONS(769),
    [anon_sym_LT_LPAREN] = ACTIONS(769),
    [anon_sym_GT_LPAREN] = ACTIONS(769),
    [sym_word] = ACTIONS(769),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(769),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
  },
  [297] = {
    [sym_file_descriptor] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_RPAREN] = ACTIONS(769),
    [anon_sym_SEMI_SEMI] = ACTIONS(769),
    [anon_sym_PIPE_AMP] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_AMP_GT] = ACTIONS(769),
    [anon_sym_AMP_GT_GT] = ACTIONS(769),
    [anon_sym_LT_AMP] = ACTIONS(769),
    [anon_sym_GT_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_LT_LT_DASH] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(769),
    [sym_raw_string] = ACTIONS(769),
    [anon_sym_DOLLAR] = ACTIONS(769),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(769),
    [anon_sym_BQUOTE] = ACTIONS(769),
    [anon_sym_LT_LPAREN] = ACTIONS(769),
    [anon_sym_GT_LPAREN] = ACTIONS(769),
    [sym_word] = ACTIONS(769),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(769),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
  },
  [298] = {
    [sym_file_redirect] = STATE(299),
    [sym_heredoc_redirect] = STATE(299),
    [sym_file_descriptor] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(1011),
    [anon_sym_RPAREN] = ACTIONS(1011),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(281),
    [anon_sym_GT] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(281),
    [anon_sym_AMP_GT] = ACTIONS(281),
    [anon_sym_AMP_GT_GT] = ACTIONS(281),
    [anon_sym_LT_AMP] = ACTIONS(281),
    [anon_sym_GT_AMP] = ACTIONS(281),
    [anon_sym_LT_LT] = ACTIONS(283),
    [anon_sym_LT_LT_DASH] = ACTIONS(283),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1011),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1011),
  },
  [299] = {
    [sym_file_descriptor] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_RPAREN] = ACTIONS(1015),
    [anon_sym_SEMI_SEMI] = ACTIONS(1015),
    [anon_sym_PIPE_AMP] = ACTIONS(1015),
    [anon_sym_AMP_AMP] = ACTIONS(1015),
    [anon_sym_PIPE_PIPE] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1015),
    [anon_sym_GT] = ACTIONS(1015),
    [anon_sym_GT_GT] = ACTIONS(1015),
    [anon_sym_AMP_GT] = ACTIONS(1015),
    [anon_sym_AMP_GT_GT] = ACTIONS(1015),
    [anon_sym_LT_AMP] = ACTIONS(1015),
    [anon_sym_GT_AMP] = ACTIONS(1015),
    [anon_sym_LT_LT] = ACTIONS(1015),
    [anon_sym_LT_LT_DASH] = ACTIONS(1015),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1015),
    [anon_sym_LF] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1015),
  },
  [300] = {
    [sym_file_redirect] = STATE(122),
    [sym_heredoc_redirect] = STATE(122),
    [sym_concatenation] = STATE(297),
    [sym_string] = STATE(296),
    [sym_simple_expansion] = STATE(296),
    [sym_expansion] = STATE(296),
    [sym_command_substitution] = STATE(296),
    [sym_process_substitution] = STATE(296),
    [aux_sym_command_repeat2] = STATE(498),
    [sym_file_descriptor] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(1017),
    [anon_sym_RPAREN] = ACTIONS(1017),
    [anon_sym_SEMI_SEMI] = ACTIONS(1017),
    [anon_sym_PIPE_AMP] = ACTIONS(1017),
    [anon_sym_AMP_AMP] = ACTIONS(1017),
    [anon_sym_PIPE_PIPE] = ACTIONS(1017),
    [anon_sym_LT] = ACTIONS(281),
    [anon_sym_GT] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(281),
    [anon_sym_AMP_GT] = ACTIONS(281),
    [anon_sym_AMP_GT_GT] = ACTIONS(281),
    [anon_sym_LT_AMP] = ACTIONS(281),
    [anon_sym_GT_AMP] = ACTIONS(281),
    [anon_sym_LT_LT] = ACTIONS(283),
    [anon_sym_LT_LT_DASH] = ACTIONS(283),
    [anon_sym_DQUOTE] = ACTIONS(285),
    [sym_raw_string] = ACTIONS(599),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(291),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_LT_LPAREN] = ACTIONS(297),
    [anon_sym_GT_LPAREN] = ACTIONS(297),
    [sym_word] = ACTIONS(599),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1017),
    [anon_sym_LF] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(1017),
  },
  [301] = {
    [sym__concat] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_RPAREN] = ACTIONS(427),
    [anon_sym_RBRACK] = ACTIONS(427),
    [sym_comment] = ACTIONS(133),
  },
  [302] = {
    [sym_simple_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [anon_sym_DQUOTE] = ACTIONS(1019),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(447),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [303] = {
    [sym_string] = STATE(500),
    [sym_simple_expansion] = STATE(500),
    [sym_expansion] = STATE(500),
    [sym_command_substitution] = STATE(500),
    [sym_process_substitution] = STATE(500),
    [anon_sym_DQUOTE] = ACTIONS(315),
    [sym_raw_string] = ACTIONS(1021),
    [anon_sym_DOLLAR] = ACTIONS(319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(327),
    [anon_sym_GT_LPAREN] = ACTIONS(327),
    [sym_word] = ACTIONS(1023),
    [sym_comment] = ACTIONS(133),
  },
  [304] = {
    [anon_sym_EQ] = ACTIONS(1025),
    [sym_comment] = ACTIONS(133),
  },
  [305] = {
    [sym__concat] = ACTIONS(1027),
    [anon_sym_PIPE] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [sym_comment] = ACTIONS(133),
  },
  [306] = {
    [sym__concat] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [anon_sym_RPAREN] = ACTIONS(459),
    [anon_sym_RBRACK] = ACTIONS(459),
    [sym_comment] = ACTIONS(133),
  },
  [307] = {
    [sym__concat] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(463),
    [anon_sym_RBRACK] = ACTIONS(463),
    [sym_comment] = ACTIONS(133),
  },
  [308] = {
    [sym__concat] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_RPAREN] = ACTIONS(467),
    [anon_sym_RBRACK] = ACTIONS(467),
    [sym_comment] = ACTIONS(133),
  },
  [309] = {
    [sym_special_variable_name] = STATE(503),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(225),
    [anon_sym_AT] = ACTIONS(219),
    [anon_sym_COLON] = ACTIONS(471),
    [anon_sym_COLON_QMARK] = ACTIONS(459),
    [anon_sym_COLON_DASH] = ACTIONS(459),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(1029),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [310] = {
    [anon_sym_RBRACE] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_EQ] = ACTIONS(1035),
    [anon_sym_COLON] = ACTIONS(1037),
    [anon_sym_COLON_QMARK] = ACTIONS(1035),
    [anon_sym_COLON_DASH] = ACTIONS(1035),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1035),
    [sym_comment] = ACTIONS(133),
  },
  [311] = {
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(1041),
    [anon_sym_EQ] = ACTIONS(1043),
    [anon_sym_COLON] = ACTIONS(1045),
    [anon_sym_COLON_QMARK] = ACTIONS(1043),
    [anon_sym_COLON_DASH] = ACTIONS(1043),
    [anon_sym_PERCENT] = ACTIONS(1043),
    [anon_sym_SLASH] = ACTIONS(1043),
    [sym_comment] = ACTIONS(133),
  },
  [312] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(1047),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [313] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(1047),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [314] = {
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(1047),
    [sym_comment] = ACTIONS(133),
  },
  [315] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(1047),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [316] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [317] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(1049),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [318] = {
    [sym_file_descriptor] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_word] = ACTIONS(1053),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [319] = {
    [anon_sym_RPAREN] = ACTIONS(1055),
    [sym_word] = ACTIONS(1057),
    [sym_comment] = ACTIONS(133),
  },
  [320] = {
    [anon_sym_RPAREN] = ACTIONS(1059),
    [sym_word] = ACTIONS(1061),
    [sym_comment] = ACTIONS(133),
  },
  [321] = {
    [sym_file_descriptor] = ACTIONS(427),
    [sym__concat] = ACTIONS(427),
    [sym_variable_name] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(429),
    [anon_sym_SEMI_SEMI] = ACTIONS(429),
    [anon_sym_PIPE_AMP] = ACTIONS(429),
    [anon_sym_AMP_AMP] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_GT] = ACTIONS(429),
    [anon_sym_AMP_GT] = ACTIONS(429),
    [anon_sym_AMP_GT_GT] = ACTIONS(429),
    [anon_sym_LT_AMP] = ACTIONS(429),
    [anon_sym_GT_AMP] = ACTIONS(429),
    [anon_sym_DQUOTE] = ACTIONS(429),
    [sym_raw_string] = ACTIONS(429),
    [anon_sym_DOLLAR] = ACTIONS(429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(429),
    [anon_sym_BQUOTE] = ACTIONS(429),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [sym_word] = ACTIONS(429),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(429),
    [anon_sym_LF] = ACTIONS(429),
    [anon_sym_AMP] = ACTIONS(429),
  },
  [322] = {
    [sym_simple_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(447),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [323] = {
    [sym_string] = STATE(515),
    [sym_simple_expansion] = STATE(515),
    [sym_expansion] = STATE(515),
    [sym_command_substitution] = STATE(515),
    [sym_process_substitution] = STATE(515),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(341),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_LT_LPAREN] = ACTIONS(347),
    [anon_sym_GT_LPAREN] = ACTIONS(347),
    [sym_word] = ACTIONS(1067),
    [sym_comment] = ACTIONS(133),
  },
  [324] = {
    [sym_file_descriptor] = ACTIONS(453),
    [sym__concat] = ACTIONS(1069),
    [sym_variable_name] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(457),
    [anon_sym_RPAREN] = ACTIONS(457),
    [anon_sym_SEMI_SEMI] = ACTIONS(457),
    [anon_sym_PIPE_AMP] = ACTIONS(457),
    [anon_sym_AMP_AMP] = ACTIONS(457),
    [anon_sym_PIPE_PIPE] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(457),
    [anon_sym_AMP_GT] = ACTIONS(457),
    [anon_sym_AMP_GT_GT] = ACTIONS(457),
    [anon_sym_LT_AMP] = ACTIONS(457),
    [anon_sym_GT_AMP] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(457),
    [sym_raw_string] = ACTIONS(457),
    [anon_sym_DOLLAR] = ACTIONS(457),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(457),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(457),
    [anon_sym_BQUOTE] = ACTIONS(457),
    [anon_sym_LT_LPAREN] = ACTIONS(457),
    [anon_sym_GT_LPAREN] = ACTIONS(457),
    [sym_word] = ACTIONS(457),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(457),
    [anon_sym_LF] = ACTIONS(457),
    [anon_sym_AMP] = ACTIONS(457),
  },
  [325] = {
    [sym_file_descriptor] = ACTIONS(459),
    [sym__concat] = ACTIONS(459),
    [sym_variable_name] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(461),
    [anon_sym_RPAREN] = ACTIONS(461),
    [anon_sym_SEMI_SEMI] = ACTIONS(461),
    [anon_sym_PIPE_AMP] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(461),
    [anon_sym_AMP_GT] = ACTIONS(461),
    [anon_sym_AMP_GT_GT] = ACTIONS(461),
    [anon_sym_LT_AMP] = ACTIONS(461),
    [anon_sym_GT_AMP] = ACTIONS(461),
    [anon_sym_DQUOTE] = ACTIONS(461),
    [sym_raw_string] = ACTIONS(461),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(461),
    [anon_sym_BQUOTE] = ACTIONS(461),
    [anon_sym_LT_LPAREN] = ACTIONS(461),
    [anon_sym_GT_LPAREN] = ACTIONS(461),
    [sym_word] = ACTIONS(461),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_LF] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(461),
  },
  [326] = {
    [sym_file_descriptor] = ACTIONS(463),
    [sym__concat] = ACTIONS(463),
    [sym_variable_name] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_SEMI_SEMI] = ACTIONS(465),
    [anon_sym_PIPE_AMP] = ACTIONS(465),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE_PIPE] = ACTIONS(465),
    [anon_sym_LT] = ACTIONS(465),
    [anon_sym_GT] = ACTIONS(465),
    [anon_sym_GT_GT] = ACTIONS(465),
    [anon_sym_AMP_GT] = ACTIONS(465),
    [anon_sym_AMP_GT_GT] = ACTIONS(465),
    [anon_sym_LT_AMP] = ACTIONS(465),
    [anon_sym_GT_AMP] = ACTIONS(465),
    [anon_sym_DQUOTE] = ACTIONS(465),
    [sym_raw_string] = ACTIONS(465),
    [anon_sym_DOLLAR] = ACTIONS(465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(465),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(465),
    [anon_sym_BQUOTE] = ACTIONS(465),
    [anon_sym_LT_LPAREN] = ACTIONS(465),
    [anon_sym_GT_LPAREN] = ACTIONS(465),
    [sym_word] = ACTIONS(465),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(465),
    [anon_sym_LF] = ACTIONS(465),
    [anon_sym_AMP] = ACTIONS(465),
  },
  [327] = {
    [sym_file_descriptor] = ACTIONS(467),
    [sym__concat] = ACTIONS(467),
    [sym_variable_name] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_RPAREN] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
  },
  [328] = {
    [sym_special_variable_name] = STATE(518),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(225),
    [anon_sym_AT] = ACTIONS(219),
    [anon_sym_COLON] = ACTIONS(471),
    [anon_sym_COLON_QMARK] = ACTIONS(459),
    [anon_sym_COLON_DASH] = ACTIONS(459),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(1071),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [329] = {
    [anon_sym_RBRACE] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(1075),
    [anon_sym_EQ] = ACTIONS(1077),
    [anon_sym_COLON] = ACTIONS(1079),
    [anon_sym_COLON_QMARK] = ACTIONS(1077),
    [anon_sym_COLON_DASH] = ACTIONS(1077),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_SLASH] = ACTIONS(1077),
    [sym_comment] = ACTIONS(133),
  },
  [330] = {
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1083),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_COLON] = ACTIONS(1087),
    [anon_sym_COLON_QMARK] = ACTIONS(1085),
    [anon_sym_COLON_DASH] = ACTIONS(1085),
    [anon_sym_PERCENT] = ACTIONS(1085),
    [anon_sym_SLASH] = ACTIONS(1085),
    [sym_comment] = ACTIONS(133),
  },
  [331] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [332] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [333] = {
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [sym_comment] = ACTIONS(133),
  },
  [334] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [335] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [336] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(1091),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [337] = {
    [sym_simple_expansion] = STATE(70),
    [sym_expansion] = STATE(70),
    [sym_command_substitution] = STATE(70),
    [aux_sym_string_repeat1] = STATE(528),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(197),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [338] = {
    [aux_sym_concatenation_repeat1] = STATE(530),
    [sym__concat] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(391),
    [anon_sym_DQUOTE] = ACTIONS(391),
    [sym_raw_string] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(391),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(391),
    [anon_sym_BQUOTE] = ACTIONS(391),
    [anon_sym_LT_LPAREN] = ACTIONS(391),
    [anon_sym_GT_LPAREN] = ACTIONS(391),
    [sym_word] = ACTIONS(391),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(391),
    [anon_sym_LF] = ACTIONS(391),
    [anon_sym_AMP] = ACTIONS(391),
  },
  [339] = {
    [sym_special_variable_name] = STATE(533),
    [anon_sym_DOLLAR] = ACTIONS(1097),
    [anon_sym_POUND] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(1097),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1097),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_0] = ACTIONS(1099),
    [anon_sym__] = ACTIONS(1099),
  },
  [340] = {
    [sym_special_variable_name] = STATE(536),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(219),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(1105),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [341] = {
    [sym_for_statement] = STATE(537),
    [sym_while_statement] = STATE(537),
    [sym_if_statement] = STATE(537),
    [sym_case_statement] = STATE(537),
    [sym_function_definition] = STATE(537),
    [sym_subshell] = STATE(537),
    [sym_pipeline] = STATE(537),
    [sym_list] = STATE(537),
    [sym_bracket_command] = STATE(537),
    [sym_command] = STATE(537),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(538),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [342] = {
    [sym_for_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_function_definition] = STATE(539),
    [sym_subshell] = STATE(539),
    [sym_pipeline] = STATE(539),
    [sym_list] = STATE(539),
    [sym_bracket_command] = STATE(539),
    [sym_command] = STATE(539),
    [sym_command_name] = STATE(109),
    [sym_environment_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [343] = {
    [sym_for_statement] = STATE(541),
    [sym_while_statement] = STATE(541),
    [sym_if_statement] = STATE(541),
    [sym_case_statement] = STATE(541),
    [sym_function_definition] = STATE(541),
    [sym_subshell] = STATE(541),
    [sym_pipeline] = STATE(541),
    [sym_list] = STATE(541),
    [sym_bracket_command] = STATE(541),
    [sym_command] = STATE(541),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(542),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [344] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(391),
    [anon_sym_DQUOTE] = ACTIONS(391),
    [sym_raw_string] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(391),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(391),
    [anon_sym_BQUOTE] = ACTIONS(391),
    [anon_sym_LT_LPAREN] = ACTIONS(391),
    [anon_sym_GT_LPAREN] = ACTIONS(391),
    [sym_word] = ACTIONS(391),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(391),
    [anon_sym_LF] = ACTIONS(391),
    [anon_sym_AMP] = ACTIONS(391),
  },
  [345] = {
    [sym_concatenation] = STATE(545),
    [sym_string] = STATE(544),
    [sym_simple_expansion] = STATE(544),
    [sym_expansion] = STATE(544),
    [sym_command_substitution] = STATE(544),
    [sym_process_substitution] = STATE(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1111),
    [anon_sym_DOLLAR] = ACTIONS(1113),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1115),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_LT_LPAREN] = ACTIONS(1121),
    [anon_sym_GT_LPAREN] = ACTIONS(1121),
    [sym_word] = ACTIONS(1111),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [346] = {
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(1123),
    [anon_sym_SEMI_SEMI] = ACTIONS(1123),
    [anon_sym_PIPE_AMP] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LF] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1123),
  },
  [347] = {
    [sym__terminated_statement] = STATE(126),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_done] = ACTIONS(1125),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [348] = {
    [anon_sym_PIPE] = ACTIONS(1127),
    [anon_sym_RPAREN] = ACTIONS(1127),
    [anon_sym_SEMI_SEMI] = ACTIONS(1127),
    [anon_sym_PIPE_AMP] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_LF] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1127),
  },
  [349] = {
    [sym__terminated_statement] = STATE(547),
    [sym_for_statement] = STATE(36),
    [sym_while_statement] = STATE(36),
    [sym_if_statement] = STATE(36),
    [sym_case_statement] = STATE(36),
    [sym_function_definition] = STATE(36),
    [sym_subshell] = STATE(36),
    [sym_pipeline] = STATE(36),
    [sym_list] = STATE(36),
    [sym_bracket_command] = STATE(36),
    [sym_command] = STATE(36),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(37),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [350] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(548),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_fi] = ACTIONS(1129),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [351] = {
    [anon_sym_fi] = ACTIONS(1131),
    [anon_sym_elif] = ACTIONS(1131),
    [anon_sym_else] = ACTIONS(1131),
    [sym_comment] = ACTIONS(133),
  },
  [352] = {
    [anon_sym_fi] = ACTIONS(1133),
    [sym_comment] = ACTIONS(133),
  },
  [353] = {
    [sym__terminated_statement] = STATE(126),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_elif_clause] = STATE(351),
    [sym_else_clause] = STATE(550),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_if_statement_repeat1] = STATE(551),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_fi] = ACTIONS(1135),
    [anon_sym_elif] = ACTIONS(677),
    [anon_sym_else] = ACTIONS(679),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [354] = {
    [sym_elif_clause] = STATE(552),
    [sym_else_clause] = STATE(550),
    [anon_sym_fi] = ACTIONS(1133),
    [anon_sym_elif] = ACTIONS(1137),
    [anon_sym_else] = ACTIONS(1139),
    [sym_comment] = ACTIONS(133),
  },
  [355] = {
    [sym__concat] = ACTIONS(821),
    [anon_sym_in] = ACTIONS(823),
    [anon_sym_SEMI_SEMI] = ACTIONS(823),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_LF] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
  },
  [356] = {
    [sym__concat] = ACTIONS(829),
    [anon_sym_in] = ACTIONS(831),
    [anon_sym_SEMI_SEMI] = ACTIONS(831),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(831),
    [anon_sym_LF] = ACTIONS(831),
    [anon_sym_AMP] = ACTIONS(831),
  },
  [357] = {
    [sym_case_item] = STATE(555),
    [sym_concatenation] = STATE(556),
    [sym_string] = STATE(554),
    [sym_simple_expansion] = STATE(554),
    [sym_expansion] = STATE(554),
    [sym_command_substitution] = STATE(554),
    [sym_process_substitution] = STATE(554),
    [aux_sym_case_statement_repeat1] = STATE(557),
    [anon_sym_esac] = ACTIONS(1141),
    [anon_sym_DQUOTE] = ACTIONS(315),
    [sym_raw_string] = ACTIONS(1143),
    [anon_sym_DOLLAR] = ACTIONS(319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(327),
    [anon_sym_GT_LPAREN] = ACTIONS(327),
    [sym_word] = ACTIONS(1145),
    [sym_comment] = ACTIONS(133),
  },
  [358] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1147),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1147),
    [anon_sym_LF] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
  },
  [359] = {
    [sym_string] = STATE(559),
    [sym_simple_expansion] = STATE(559),
    [sym_expansion] = STATE(559),
    [sym_command_substitution] = STATE(559),
    [sym_process_substitution] = STATE(559),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(1149),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_LT_LPAREN] = ACTIONS(157),
    [anon_sym_GT_LPAREN] = ACTIONS(157),
    [sym_word] = ACTIONS(1151),
    [sym_comment] = ACTIONS(133),
  },
  [360] = {
    [anon_sym_RBRACE] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [sym_comment] = ACTIONS(133),
  },
  [361] = {
    [anon_sym_RBRACE] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1159),
    [sym_comment] = ACTIONS(133),
  },
  [362] = {
    [sym__concat] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_SEMI_SEMI] = ACTIONS(847),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(847),
    [anon_sym_LF] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(847),
  },
  [363] = {
    [anon_sym_AT] = ACTIONS(1161),
    [sym_comment] = ACTIONS(133),
  },
  [364] = {
    [sym_concatenation] = STATE(566),
    [sym_string] = STATE(565),
    [sym_simple_expansion] = STATE(565),
    [sym_expansion] = STATE(565),
    [sym_command_substitution] = STATE(565),
    [sym_process_substitution] = STATE(565),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(1163),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(1165),
    [sym_comment] = ACTIONS(133),
  },
  [365] = {
    [sym__concat] = ACTIONS(855),
    [anon_sym_in] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
  },
  [366] = {
    [anon_sym_AT] = ACTIONS(1167),
    [sym_comment] = ACTIONS(133),
  },
  [367] = {
    [sym_concatenation] = STATE(569),
    [sym_string] = STATE(568),
    [sym_simple_expansion] = STATE(568),
    [sym_expansion] = STATE(568),
    [sym_command_substitution] = STATE(568),
    [sym_process_substitution] = STATE(568),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(1169),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(1171),
    [sym_comment] = ACTIONS(133),
  },
  [368] = {
    [sym__concat] = ACTIONS(923),
    [anon_sym_in] = ACTIONS(925),
    [anon_sym_SEMI_SEMI] = ACTIONS(925),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(925),
    [anon_sym_LF] = ACTIONS(925),
    [anon_sym_AMP] = ACTIONS(925),
  },
  [369] = {
    [sym__concat] = ACTIONS(965),
    [anon_sym_in] = ACTIONS(967),
    [anon_sym_SEMI_SEMI] = ACTIONS(967),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_LF] = ACTIONS(967),
    [anon_sym_AMP] = ACTIONS(967),
  },
  [370] = {
    [sym_compound_statement] = STATE(570),
    [anon_sym_LBRACE] = ACTIONS(969),
    [sym_comment] = ACTIONS(133),
  },
  [371] = {
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_RPAREN] = ACTIONS(1173),
    [anon_sym_SEMI_SEMI] = ACTIONS(1173),
    [anon_sym_PIPE_AMP] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1173),
    [anon_sym_PIPE_PIPE] = ACTIONS(1173),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1173),
    [anon_sym_LF] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1173),
  },
  [372] = {
    [sym_file_descriptor] = ACTIONS(563),
    [sym_variable_name] = ACTIONS(563),
    [anon_sym_for] = ACTIONS(565),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(1175),
    [anon_sym_function] = ACTIONS(565),
    [anon_sym_LPAREN] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(565),
    [anon_sym_GT] = ACTIONS(565),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_AMP_GT] = ACTIONS(565),
    [anon_sym_AMP_GT_GT] = ACTIONS(563),
    [anon_sym_LT_AMP] = ACTIONS(563),
    [anon_sym_GT_AMP] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(563),
    [sym_raw_string] = ACTIONS(563),
    [anon_sym_DOLLAR] = ACTIONS(565),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(563),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(563),
    [anon_sym_BQUOTE] = ACTIONS(563),
    [anon_sym_LT_LPAREN] = ACTIONS(563),
    [anon_sym_GT_LPAREN] = ACTIONS(563),
    [sym_word] = ACTIONS(567),
    [sym_comment] = ACTIONS(133),
  },
  [373] = {
    [sym__concat] = ACTIONS(821),
    [anon_sym_RBRACE] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1177),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1177),
    [anon_sym_DQUOTE] = ACTIONS(821),
    [sym_raw_string] = ACTIONS(821),
    [anon_sym_DOLLAR] = ACTIONS(1177),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(821),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(821),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(821),
    [anon_sym_GT_LPAREN] = ACTIONS(821),
    [sym_word] = ACTIONS(823),
    [sym_comment] = ACTIONS(133),
  },
  [374] = {
    [sym__concat] = ACTIONS(829),
    [anon_sym_RBRACE] = ACTIONS(829),
    [anon_sym_RBRACK] = ACTIONS(1179),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(829),
    [sym_raw_string] = ACTIONS(829),
    [anon_sym_DOLLAR] = ACTIONS(1179),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(829),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(829),
    [anon_sym_BQUOTE] = ACTIONS(829),
    [anon_sym_LT_LPAREN] = ACTIONS(829),
    [anon_sym_GT_LPAREN] = ACTIONS(829),
    [sym_word] = ACTIONS(831),
    [sym_comment] = ACTIONS(133),
  },
  [375] = {
    [sym_string] = STATE(572),
    [sym_simple_expansion] = STATE(572),
    [sym_expansion] = STATE(572),
    [sym_command_substitution] = STATE(572),
    [sym_process_substitution] = STATE(572),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(1181),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(1183),
    [sym_comment] = ACTIONS(133),
  },
  [376] = {
    [anon_sym_RBRACE] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(1187),
    [sym_comment] = ACTIONS(133),
  },
  [377] = {
    [anon_sym_RBRACE] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(1191),
    [sym_comment] = ACTIONS(133),
  },
  [378] = {
    [sym__concat] = ACTIONS(845),
    [anon_sym_RBRACE] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(1193),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1193),
    [anon_sym_DQUOTE] = ACTIONS(845),
    [sym_raw_string] = ACTIONS(845),
    [anon_sym_DOLLAR] = ACTIONS(1193),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(845),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(845),
    [anon_sym_LT_LPAREN] = ACTIONS(845),
    [anon_sym_GT_LPAREN] = ACTIONS(845),
    [sym_word] = ACTIONS(847),
    [sym_comment] = ACTIONS(133),
  },
  [379] = {
    [anon_sym_AT] = ACTIONS(1195),
    [sym_comment] = ACTIONS(133),
  },
  [380] = {
    [sym_concatenation] = STATE(579),
    [sym_string] = STATE(578),
    [sym_simple_expansion] = STATE(578),
    [sym_expansion] = STATE(578),
    [sym_command_substitution] = STATE(578),
    [sym_process_substitution] = STATE(578),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(1197),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(1199),
    [sym_comment] = ACTIONS(133),
  },
  [381] = {
    [sym__concat] = ACTIONS(855),
    [anon_sym_RBRACE] = ACTIONS(855),
    [anon_sym_RBRACK] = ACTIONS(1201),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(855),
    [sym_raw_string] = ACTIONS(855),
    [anon_sym_DOLLAR] = ACTIONS(1201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(855),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [anon_sym_LT_LPAREN] = ACTIONS(855),
    [anon_sym_GT_LPAREN] = ACTIONS(855),
    [sym_word] = ACTIONS(857),
    [sym_comment] = ACTIONS(133),
  },
  [382] = {
    [anon_sym_AT] = ACTIONS(1203),
    [sym_comment] = ACTIONS(133),
  },
  [383] = {
    [sym_concatenation] = STATE(582),
    [sym_string] = STATE(581),
    [sym_simple_expansion] = STATE(581),
    [sym_expansion] = STATE(581),
    [sym_command_substitution] = STATE(581),
    [sym_process_substitution] = STATE(581),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(1205),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(1207),
    [sym_comment] = ACTIONS(133),
  },
  [384] = {
    [sym__concat] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1209),
    [anon_sym_DQUOTE] = ACTIONS(923),
    [sym_raw_string] = ACTIONS(923),
    [anon_sym_DOLLAR] = ACTIONS(1209),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(923),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(923),
    [anon_sym_BQUOTE] = ACTIONS(923),
    [anon_sym_LT_LPAREN] = ACTIONS(923),
    [anon_sym_GT_LPAREN] = ACTIONS(923),
    [sym_word] = ACTIONS(925),
    [sym_comment] = ACTIONS(133),
  },
  [385] = {
    [sym__concat] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(965),
    [anon_sym_RBRACK] = ACTIONS(1211),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(965),
    [sym_raw_string] = ACTIONS(965),
    [anon_sym_DOLLAR] = ACTIONS(1211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(965),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(965),
    [anon_sym_BQUOTE] = ACTIONS(965),
    [anon_sym_LT_LPAREN] = ACTIONS(965),
    [anon_sym_GT_LPAREN] = ACTIONS(965),
    [sym_word] = ACTIONS(967),
    [sym_comment] = ACTIONS(133),
  },
  [386] = {
    [sym_file_descriptor] = ACTIONS(821),
    [sym__concat] = ACTIONS(821),
    [sym_variable_name] = ACTIONS(821),
    [anon_sym_PIPE] = ACTIONS(1177),
    [anon_sym_RPAREN] = ACTIONS(821),
    [anon_sym_PIPE_AMP] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(821),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_LT] = ACTIONS(1177),
    [anon_sym_GT] = ACTIONS(1177),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_GT] = ACTIONS(1177),
    [anon_sym_AMP_GT_GT] = ACTIONS(821),
    [anon_sym_LT_AMP] = ACTIONS(821),
    [anon_sym_GT_AMP] = ACTIONS(821),
    [anon_sym_DQUOTE] = ACTIONS(821),
    [sym_raw_string] = ACTIONS(821),
    [anon_sym_DOLLAR] = ACTIONS(1177),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(821),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(821),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(821),
    [anon_sym_GT_LPAREN] = ACTIONS(821),
    [sym_word] = ACTIONS(823),
    [sym_comment] = ACTIONS(133),
  },
  [387] = {
    [sym_file_descriptor] = ACTIONS(829),
    [sym__concat] = ACTIONS(829),
    [sym_variable_name] = ACTIONS(829),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_RPAREN] = ACTIONS(829),
    [anon_sym_PIPE_AMP] = ACTIONS(829),
    [anon_sym_AMP_AMP] = ACTIONS(829),
    [anon_sym_PIPE_PIPE] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(1179),
    [anon_sym_GT] = ACTIONS(1179),
    [anon_sym_GT_GT] = ACTIONS(829),
    [anon_sym_AMP_GT] = ACTIONS(1179),
    [anon_sym_AMP_GT_GT] = ACTIONS(829),
    [anon_sym_LT_AMP] = ACTIONS(829),
    [anon_sym_GT_AMP] = ACTIONS(829),
    [anon_sym_DQUOTE] = ACTIONS(829),
    [sym_raw_string] = ACTIONS(829),
    [anon_sym_DOLLAR] = ACTIONS(1179),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(829),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(829),
    [anon_sym_BQUOTE] = ACTIONS(829),
    [anon_sym_LT_LPAREN] = ACTIONS(829),
    [anon_sym_GT_LPAREN] = ACTIONS(829),
    [sym_word] = ACTIONS(831),
    [sym_comment] = ACTIONS(133),
  },
  [388] = {
    [sym_string] = STATE(583),
    [sym_simple_expansion] = STATE(583),
    [sym_expansion] = STATE(583),
    [sym_command_substitution] = STATE(583),
    [sym_process_substitution] = STATE(583),
    [anon_sym_DQUOTE] = ACTIONS(179),
    [sym_raw_string] = ACTIONS(1213),
    [anon_sym_DOLLAR] = ACTIONS(183),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(185),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(189),
    [anon_sym_LT_LPAREN] = ACTIONS(191),
    [anon_sym_GT_LPAREN] = ACTIONS(191),
    [sym_word] = ACTIONS(1215),
    [sym_comment] = ACTIONS(133),
  },
  [389] = {
    [anon_sym_RBRACE] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(1219),
    [sym_comment] = ACTIONS(133),
  },
  [390] = {
    [anon_sym_RBRACE] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [sym_comment] = ACTIONS(133),
  },
  [391] = {
    [sym_file_descriptor] = ACTIONS(845),
    [sym__concat] = ACTIONS(845),
    [sym_variable_name] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(1193),
    [anon_sym_RPAREN] = ACTIONS(845),
    [anon_sym_PIPE_AMP] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(845),
    [anon_sym_PIPE_PIPE] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_GT_GT] = ACTIONS(845),
    [anon_sym_AMP_GT] = ACTIONS(1193),
    [anon_sym_AMP_GT_GT] = ACTIONS(845),
    [anon_sym_LT_AMP] = ACTIONS(845),
    [anon_sym_GT_AMP] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(845),
    [sym_raw_string] = ACTIONS(845),
    [anon_sym_DOLLAR] = ACTIONS(1193),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(845),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(845),
    [anon_sym_LT_LPAREN] = ACTIONS(845),
    [anon_sym_GT_LPAREN] = ACTIONS(845),
    [sym_word] = ACTIONS(847),
    [sym_comment] = ACTIONS(133),
  },
  [392] = {
    [anon_sym_AT] = ACTIONS(1225),
    [sym_comment] = ACTIONS(133),
  },
  [393] = {
    [sym_concatenation] = STATE(590),
    [sym_string] = STATE(589),
    [sym_simple_expansion] = STATE(589),
    [sym_expansion] = STATE(589),
    [sym_command_substitution] = STATE(589),
    [sym_process_substitution] = STATE(589),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(1227),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(1229),
    [sym_comment] = ACTIONS(133),
  },
  [394] = {
    [sym_file_descriptor] = ACTIONS(855),
    [sym__concat] = ACTIONS(855),
    [sym_variable_name] = ACTIONS(855),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_RPAREN] = ACTIONS(855),
    [anon_sym_PIPE_AMP] = ACTIONS(855),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_PIPE_PIPE] = ACTIONS(1201),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_GT_GT] = ACTIONS(855),
    [anon_sym_AMP_GT] = ACTIONS(1201),
    [anon_sym_AMP_GT_GT] = ACTIONS(855),
    [anon_sym_LT_AMP] = ACTIONS(855),
    [anon_sym_GT_AMP] = ACTIONS(855),
    [anon_sym_DQUOTE] = ACTIONS(855),
    [sym_raw_string] = ACTIONS(855),
    [anon_sym_DOLLAR] = ACTIONS(1201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(855),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [anon_sym_LT_LPAREN] = ACTIONS(855),
    [anon_sym_GT_LPAREN] = ACTIONS(855),
    [sym_word] = ACTIONS(857),
    [sym_comment] = ACTIONS(133),
  },
  [395] = {
    [anon_sym_AT] = ACTIONS(1231),
    [sym_comment] = ACTIONS(133),
  },
  [396] = {
    [sym_concatenation] = STATE(593),
    [sym_string] = STATE(592),
    [sym_simple_expansion] = STATE(592),
    [sym_expansion] = STATE(592),
    [sym_command_substitution] = STATE(592),
    [sym_process_substitution] = STATE(592),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(1233),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(1235),
    [sym_comment] = ACTIONS(133),
  },
  [397] = {
    [sym_file_descriptor] = ACTIONS(923),
    [sym__concat] = ACTIONS(923),
    [sym_variable_name] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(923),
    [anon_sym_AMP_AMP] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1209),
    [anon_sym_GT] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_AMP_GT] = ACTIONS(1209),
    [anon_sym_AMP_GT_GT] = ACTIONS(923),
    [anon_sym_LT_AMP] = ACTIONS(923),
    [anon_sym_GT_AMP] = ACTIONS(923),
    [anon_sym_DQUOTE] = ACTIONS(923),
    [sym_raw_string] = ACTIONS(923),
    [anon_sym_DOLLAR] = ACTIONS(1209),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(923),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(923),
    [anon_sym_BQUOTE] = ACTIONS(923),
    [anon_sym_LT_LPAREN] = ACTIONS(923),
    [anon_sym_GT_LPAREN] = ACTIONS(923),
    [sym_word] = ACTIONS(925),
    [sym_comment] = ACTIONS(133),
  },
  [398] = {
    [sym_file_descriptor] = ACTIONS(965),
    [sym__concat] = ACTIONS(965),
    [sym_variable_name] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(1211),
    [anon_sym_RPAREN] = ACTIONS(965),
    [anon_sym_PIPE_AMP] = ACTIONS(965),
    [anon_sym_AMP_AMP] = ACTIONS(965),
    [anon_sym_PIPE_PIPE] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_GT] = ACTIONS(1211),
    [anon_sym_GT_GT] = ACTIONS(965),
    [anon_sym_AMP_GT] = ACTIONS(1211),
    [anon_sym_AMP_GT_GT] = ACTIONS(965),
    [anon_sym_LT_AMP] = ACTIONS(965),
    [anon_sym_GT_AMP] = ACTIONS(965),
    [anon_sym_DQUOTE] = ACTIONS(965),
    [sym_raw_string] = ACTIONS(965),
    [anon_sym_DOLLAR] = ACTIONS(1211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(965),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(965),
    [anon_sym_BQUOTE] = ACTIONS(965),
    [anon_sym_LT_LPAREN] = ACTIONS(965),
    [anon_sym_GT_LPAREN] = ACTIONS(965),
    [sym_word] = ACTIONS(967),
    [sym_comment] = ACTIONS(133),
  },
  [399] = {
    [anon_sym_RBRACE] = ACTIONS(1237),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [sym_comment] = ACTIONS(133),
  },
  [400] = {
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1243),
    [sym_comment] = ACTIONS(133),
  },
  [401] = {
    [anon_sym_DQUOTE] = ACTIONS(847),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(1193),
    [anon_sym_DOLLAR] = ACTIONS(847),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(847),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [sym_comment] = ACTIONS(85),
  },
  [402] = {
    [anon_sym_AT] = ACTIONS(1245),
    [sym_comment] = ACTIONS(133),
  },
  [403] = {
    [sym_concatenation] = STATE(600),
    [sym_string] = STATE(599),
    [sym_simple_expansion] = STATE(599),
    [sym_expansion] = STATE(599),
    [sym_command_substitution] = STATE(599),
    [sym_process_substitution] = STATE(599),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(1247),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(1249),
    [sym_comment] = ACTIONS(133),
  },
  [404] = {
    [anon_sym_DQUOTE] = ACTIONS(857),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(1201),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(857),
    [sym_comment] = ACTIONS(85),
  },
  [405] = {
    [anon_sym_AT] = ACTIONS(1251),
    [sym_comment] = ACTIONS(133),
  },
  [406] = {
    [sym_concatenation] = STATE(603),
    [sym_string] = STATE(602),
    [sym_simple_expansion] = STATE(602),
    [sym_expansion] = STATE(602),
    [sym_command_substitution] = STATE(602),
    [sym_process_substitution] = STATE(602),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(1253),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(1255),
    [sym_comment] = ACTIONS(133),
  },
  [407] = {
    [anon_sym_DQUOTE] = ACTIONS(925),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(1209),
    [anon_sym_DOLLAR] = ACTIONS(925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(925),
    [anon_sym_BQUOTE] = ACTIONS(925),
    [sym_comment] = ACTIONS(85),
  },
  [408] = {
    [sym_file_descriptor] = ACTIONS(1257),
    [sym__concat] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1259),
    [anon_sym_RPAREN] = ACTIONS(1259),
    [anon_sym_SEMI_SEMI] = ACTIONS(1259),
    [anon_sym_PIPE_AMP] = ACTIONS(1259),
    [anon_sym_AMP_AMP] = ACTIONS(1259),
    [anon_sym_PIPE_PIPE] = ACTIONS(1259),
    [anon_sym_LT] = ACTIONS(1259),
    [anon_sym_GT] = ACTIONS(1259),
    [anon_sym_GT_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT_GT] = ACTIONS(1259),
    [anon_sym_LT_AMP] = ACTIONS(1259),
    [anon_sym_GT_AMP] = ACTIONS(1259),
    [anon_sym_LT_LT] = ACTIONS(1259),
    [anon_sym_LT_LT_DASH] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1259),
    [sym_raw_string] = ACTIONS(1259),
    [anon_sym_DOLLAR] = ACTIONS(1259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1259),
    [anon_sym_BQUOTE] = ACTIONS(1259),
    [anon_sym_LT_LPAREN] = ACTIONS(1259),
    [anon_sym_GT_LPAREN] = ACTIONS(1259),
    [sym_word] = ACTIONS(1259),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_LF] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1259),
  },
  [409] = {
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE_AMP] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1263),
    [anon_sym_LT_AMP] = ACTIONS(1263),
    [anon_sym_GT_AMP] = ACTIONS(1263),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1263),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1263),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1263),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [anon_sym_LT_LPAREN] = ACTIONS(1263),
    [anon_sym_GT_LPAREN] = ACTIONS(1263),
    [sym_word] = ACTIONS(1263),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [410] = {
    [anon_sym_AT] = ACTIONS(1265),
    [sym_comment] = ACTIONS(133),
  },
  [411] = {
    [sym_file_descriptor] = ACTIONS(1267),
    [sym__concat] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_RPAREN] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE_AMP] = ACTIONS(1269),
    [anon_sym_AMP_AMP] = ACTIONS(1269),
    [anon_sym_PIPE_PIPE] = ACTIONS(1269),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1269),
    [anon_sym_LT_AMP] = ACTIONS(1269),
    [anon_sym_GT_AMP] = ACTIONS(1269),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1269),
    [sym_raw_string] = ACTIONS(1269),
    [anon_sym_DOLLAR] = ACTIONS(1269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1269),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1269),
    [anon_sym_BQUOTE] = ACTIONS(1269),
    [anon_sym_LT_LPAREN] = ACTIONS(1269),
    [anon_sym_GT_LPAREN] = ACTIONS(1269),
    [sym_word] = ACTIONS(1269),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_LF] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [412] = {
    [anon_sym_AT] = ACTIONS(1271),
    [sym_comment] = ACTIONS(133),
  },
  [413] = {
    [anon_sym_RBRACK] = ACTIONS(1273),
    [sym_comment] = ACTIONS(133),
  },
  [414] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(1275),
    [sym_comment] = ACTIONS(133),
  },
  [415] = {
    [anon_sym_RBRACE] = ACTIONS(1275),
    [sym_comment] = ACTIONS(133),
  },
  [416] = {
    [anon_sym_RBRACK] = ACTIONS(1277),
    [sym_comment] = ACTIONS(133),
  },
  [417] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(1279),
    [sym_comment] = ACTIONS(133),
  },
  [418] = {
    [anon_sym_RBRACE] = ACTIONS(1279),
    [sym_comment] = ACTIONS(133),
  },
  [419] = {
    [sym_file_descriptor] = ACTIONS(633),
    [sym_variable_name] = ACTIONS(633),
    [anon_sym_PIPE] = ACTIONS(1281),
    [anon_sym_RPAREN] = ACTIONS(633),
    [anon_sym_PIPE_AMP] = ACTIONS(633),
    [anon_sym_AMP_AMP] = ACTIONS(633),
    [anon_sym_PIPE_PIPE] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1281),
    [anon_sym_GT] = ACTIONS(1281),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_AMP_GT] = ACTIONS(1281),
    [anon_sym_AMP_GT_GT] = ACTIONS(633),
    [anon_sym_LT_AMP] = ACTIONS(633),
    [anon_sym_GT_AMP] = ACTIONS(633),
    [anon_sym_DQUOTE] = ACTIONS(633),
    [sym_raw_string] = ACTIONS(633),
    [anon_sym_DOLLAR] = ACTIONS(1281),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(633),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(633),
    [anon_sym_BQUOTE] = ACTIONS(633),
    [anon_sym_LT_LPAREN] = ACTIONS(633),
    [anon_sym_GT_LPAREN] = ACTIONS(633),
    [sym_word] = ACTIONS(635),
    [sym_comment] = ACTIONS(133),
  },
  [420] = {
    [aux_sym_array_repeat1] = STATE(611),
    [anon_sym_RPAREN] = ACTIONS(1283),
    [sym_word] = ACTIONS(639),
    [sym_comment] = ACTIONS(133),
  },
  [421] = {
    [aux_sym_concatenation_repeat1] = STATE(198),
    [sym_file_descriptor] = ACTIONS(633),
    [sym__concat] = ACTIONS(413),
    [sym_variable_name] = ACTIONS(633),
    [anon_sym_PIPE] = ACTIONS(1281),
    [anon_sym_RPAREN] = ACTIONS(633),
    [anon_sym_PIPE_AMP] = ACTIONS(633),
    [anon_sym_AMP_AMP] = ACTIONS(633),
    [anon_sym_PIPE_PIPE] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1281),
    [anon_sym_GT] = ACTIONS(1281),
    [anon_sym_GT_GT] = ACTIONS(633),
    [anon_sym_AMP_GT] = ACTIONS(1281),
    [anon_sym_AMP_GT_GT] = ACTIONS(633),
    [anon_sym_LT_AMP] = ACTIONS(633),
    [anon_sym_GT_AMP] = ACTIONS(633),
    [anon_sym_DQUOTE] = ACTIONS(633),
    [sym_raw_string] = ACTIONS(633),
    [anon_sym_DOLLAR] = ACTIONS(1281),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(633),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(633),
    [anon_sym_BQUOTE] = ACTIONS(633),
    [anon_sym_LT_LPAREN] = ACTIONS(633),
    [anon_sym_GT_LPAREN] = ACTIONS(633),
    [sym_word] = ACTIONS(635),
    [sym_comment] = ACTIONS(133),
  },
  [422] = {
    [sym_concatenation] = STATE(344),
    [sym_string] = STATE(338),
    [sym_simple_expansion] = STATE(338),
    [sym_expansion] = STATE(338),
    [sym_command_substitution] = STATE(338),
    [sym_process_substitution] = STATE(338),
    [aux_sym_for_statement_repeat1] = STATE(612),
    [anon_sym_DQUOTE] = ACTIONS(655),
    [sym_raw_string] = ACTIONS(657),
    [anon_sym_DOLLAR] = ACTIONS(659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(661),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(663),
    [anon_sym_BQUOTE] = ACTIONS(665),
    [anon_sym_LT_LPAREN] = ACTIONS(667),
    [anon_sym_GT_LPAREN] = ACTIONS(667),
    [sym_word] = ACTIONS(669),
    [sym_comment] = ACTIONS(133),
  },
  [423] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(614),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_done] = ACTIONS(1285),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [424] = {
    [anon_sym_PIPE] = ACTIONS(1287),
    [anon_sym_RPAREN] = ACTIONS(1289),
    [anon_sym_PIPE_AMP] = ACTIONS(1289),
    [anon_sym_AMP_AMP] = ACTIONS(1289),
    [anon_sym_PIPE_PIPE] = ACTIONS(1289),
    [anon_sym_BQUOTE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(133),
  },
  [425] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_elif_clause] = STATE(351),
    [sym_else_clause] = STATE(616),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(617),
    [aux_sym_if_statement_repeat1] = STATE(618),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_fi] = ACTIONS(1291),
    [anon_sym_elif] = ACTIONS(677),
    [anon_sym_else] = ACTIONS(679),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [426] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1293),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1293),
    [anon_sym_LF] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1293),
  },
  [427] = {
    [anon_sym_in] = ACTIONS(1295),
    [sym_comment] = ACTIONS(133),
  },
  [428] = {
    [anon_sym_RPAREN] = ACTIONS(1297),
    [sym_comment] = ACTIONS(133),
  },
  [429] = {
    [anon_sym_PIPE] = ACTIONS(1299),
    [anon_sym_RPAREN] = ACTIONS(1301),
    [anon_sym_PIPE_AMP] = ACTIONS(1301),
    [anon_sym_AMP_AMP] = ACTIONS(1301),
    [anon_sym_PIPE_PIPE] = ACTIONS(1301),
    [anon_sym_BQUOTE] = ACTIONS(1301),
    [sym_comment] = ACTIONS(133),
  },
  [430] = {
    [sym_file_descriptor] = ACTIONS(563),
    [sym_variable_name] = ACTIONS(563),
    [anon_sym_for] = ACTIONS(565),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(565),
    [anon_sym_LPAREN] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(565),
    [anon_sym_GT] = ACTIONS(565),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_AMP_GT] = ACTIONS(565),
    [anon_sym_AMP_GT_GT] = ACTIONS(563),
    [anon_sym_LT_AMP] = ACTIONS(563),
    [anon_sym_GT_AMP] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(563),
    [sym_raw_string] = ACTIONS(563),
    [anon_sym_DOLLAR] = ACTIONS(565),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(563),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(563),
    [anon_sym_BQUOTE] = ACTIONS(563),
    [anon_sym_LT_LPAREN] = ACTIONS(563),
    [anon_sym_GT_LPAREN] = ACTIONS(563),
    [sym_word] = ACTIONS(567),
    [sym_comment] = ACTIONS(133),
  },
  [431] = {
    [anon_sym_PIPE] = ACTIONS(271),
    [anon_sym_RPAREN] = ACTIONS(1305),
    [anon_sym_SEMI_SEMI] = ACTIONS(1307),
    [anon_sym_PIPE_AMP] = ACTIONS(271),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1307),
    [anon_sym_LF] = ACTIONS(1307),
    [anon_sym_AMP] = ACTIONS(1307),
  },
  [432] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(271),
    [anon_sym_RPAREN] = ACTIONS(1305),
    [anon_sym_SEMI_SEMI] = ACTIONS(1307),
    [anon_sym_PIPE_AMP] = ACTIONS(271),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_LT] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(301),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_AMP_GT] = ACTIONS(301),
    [anon_sym_AMP_GT_GT] = ACTIONS(301),
    [anon_sym_LT_AMP] = ACTIONS(301),
    [anon_sym_GT_AMP] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(301),
    [sym_raw_string] = ACTIONS(301),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(301),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(301),
    [anon_sym_GT_LPAREN] = ACTIONS(301),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1307),
    [anon_sym_LF] = ACTIONS(1307),
    [anon_sym_AMP] = ACTIONS(1307),
  },
  [433] = {
    [anon_sym_PIPE] = ACTIONS(1309),
    [anon_sym_RPAREN] = ACTIONS(1311),
    [anon_sym_PIPE_AMP] = ACTIONS(1311),
    [anon_sym_AMP_AMP] = ACTIONS(1311),
    [anon_sym_PIPE_PIPE] = ACTIONS(1311),
    [anon_sym_BQUOTE] = ACTIONS(1311),
    [sym_comment] = ACTIONS(133),
  },
  [434] = {
    [sym_file_descriptor] = ACTIONS(821),
    [sym__concat] = ACTIONS(821),
    [anon_sym_PIPE] = ACTIONS(1177),
    [anon_sym_RPAREN] = ACTIONS(821),
    [anon_sym_PIPE_AMP] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(821),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_LT] = ACTIONS(1177),
    [anon_sym_GT] = ACTIONS(1177),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_GT] = ACTIONS(1177),
    [anon_sym_AMP_GT_GT] = ACTIONS(821),
    [anon_sym_LT_AMP] = ACTIONS(821),
    [anon_sym_GT_AMP] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(1177),
    [anon_sym_LT_LT_DASH] = ACTIONS(821),
    [anon_sym_DQUOTE] = ACTIONS(821),
    [sym_raw_string] = ACTIONS(821),
    [anon_sym_DOLLAR] = ACTIONS(1177),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(821),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(821),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(821),
    [anon_sym_GT_LPAREN] = ACTIONS(821),
    [sym_word] = ACTIONS(823),
    [sym_comment] = ACTIONS(133),
  },
  [435] = {
    [sym_file_descriptor] = ACTIONS(829),
    [sym__concat] = ACTIONS(829),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_RPAREN] = ACTIONS(829),
    [anon_sym_PIPE_AMP] = ACTIONS(829),
    [anon_sym_AMP_AMP] = ACTIONS(829),
    [anon_sym_PIPE_PIPE] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(1179),
    [anon_sym_GT] = ACTIONS(1179),
    [anon_sym_GT_GT] = ACTIONS(829),
    [anon_sym_AMP_GT] = ACTIONS(1179),
    [anon_sym_AMP_GT_GT] = ACTIONS(829),
    [anon_sym_LT_AMP] = ACTIONS(829),
    [anon_sym_GT_AMP] = ACTIONS(829),
    [anon_sym_LT_LT] = ACTIONS(1179),
    [anon_sym_LT_LT_DASH] = ACTIONS(829),
    [anon_sym_DQUOTE] = ACTIONS(829),
    [sym_raw_string] = ACTIONS(829),
    [anon_sym_DOLLAR] = ACTIONS(1179),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(829),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(829),
    [anon_sym_BQUOTE] = ACTIONS(829),
    [anon_sym_LT_LPAREN] = ACTIONS(829),
    [anon_sym_GT_LPAREN] = ACTIONS(829),
    [sym_word] = ACTIONS(831),
    [sym_comment] = ACTIONS(133),
  },
  [436] = {
    [sym_string] = STATE(624),
    [sym_simple_expansion] = STATE(624),
    [sym_expansion] = STATE(624),
    [sym_command_substitution] = STATE(624),
    [sym_process_substitution] = STATE(624),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(1313),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(1315),
    [sym_comment] = ACTIONS(133),
  },
  [437] = {
    [anon_sym_RBRACE] = ACTIONS(1317),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [sym_comment] = ACTIONS(133),
  },
  [438] = {
    [anon_sym_RBRACE] = ACTIONS(1321),
    [anon_sym_LBRACK] = ACTIONS(1323),
    [sym_comment] = ACTIONS(133),
  },
  [439] = {
    [sym_file_descriptor] = ACTIONS(845),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(1193),
    [anon_sym_RPAREN] = ACTIONS(845),
    [anon_sym_PIPE_AMP] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(845),
    [anon_sym_PIPE_PIPE] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_GT_GT] = ACTIONS(845),
    [anon_sym_AMP_GT] = ACTIONS(1193),
    [anon_sym_AMP_GT_GT] = ACTIONS(845),
    [anon_sym_LT_AMP] = ACTIONS(845),
    [anon_sym_GT_AMP] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(1193),
    [anon_sym_LT_LT_DASH] = ACTIONS(845),
    [anon_sym_DQUOTE] = ACTIONS(845),
    [sym_raw_string] = ACTIONS(845),
    [anon_sym_DOLLAR] = ACTIONS(1193),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(845),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(845),
    [anon_sym_LT_LPAREN] = ACTIONS(845),
    [anon_sym_GT_LPAREN] = ACTIONS(845),
    [sym_word] = ACTIONS(847),
    [sym_comment] = ACTIONS(133),
  },
  [440] = {
    [anon_sym_AT] = ACTIONS(1325),
    [sym_comment] = ACTIONS(133),
  },
  [441] = {
    [sym_concatenation] = STATE(631),
    [sym_string] = STATE(630),
    [sym_simple_expansion] = STATE(630),
    [sym_expansion] = STATE(630),
    [sym_command_substitution] = STATE(630),
    [sym_process_substitution] = STATE(630),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(1327),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(1329),
    [sym_comment] = ACTIONS(133),
  },
  [442] = {
    [sym_file_descriptor] = ACTIONS(855),
    [sym__concat] = ACTIONS(855),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_RPAREN] = ACTIONS(855),
    [anon_sym_PIPE_AMP] = ACTIONS(855),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_PIPE_PIPE] = ACTIONS(1201),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_GT_GT] = ACTIONS(855),
    [anon_sym_AMP_GT] = ACTIONS(1201),
    [anon_sym_AMP_GT_GT] = ACTIONS(855),
    [anon_sym_LT_AMP] = ACTIONS(855),
    [anon_sym_GT_AMP] = ACTIONS(855),
    [anon_sym_LT_LT] = ACTIONS(1201),
    [anon_sym_LT_LT_DASH] = ACTIONS(855),
    [anon_sym_DQUOTE] = ACTIONS(855),
    [sym_raw_string] = ACTIONS(855),
    [anon_sym_DOLLAR] = ACTIONS(1201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(855),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [anon_sym_LT_LPAREN] = ACTIONS(855),
    [anon_sym_GT_LPAREN] = ACTIONS(855),
    [sym_word] = ACTIONS(857),
    [sym_comment] = ACTIONS(133),
  },
  [443] = {
    [anon_sym_AT] = ACTIONS(1331),
    [sym_comment] = ACTIONS(133),
  },
  [444] = {
    [sym_concatenation] = STATE(634),
    [sym_string] = STATE(633),
    [sym_simple_expansion] = STATE(633),
    [sym_expansion] = STATE(633),
    [sym_command_substitution] = STATE(633),
    [sym_process_substitution] = STATE(633),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(1333),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(1335),
    [sym_comment] = ACTIONS(133),
  },
  [445] = {
    [sym_file_descriptor] = ACTIONS(923),
    [sym__concat] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(923),
    [anon_sym_AMP_AMP] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1209),
    [anon_sym_GT] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_AMP_GT] = ACTIONS(1209),
    [anon_sym_AMP_GT_GT] = ACTIONS(923),
    [anon_sym_LT_AMP] = ACTIONS(923),
    [anon_sym_GT_AMP] = ACTIONS(923),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_LT_LT_DASH] = ACTIONS(923),
    [anon_sym_DQUOTE] = ACTIONS(923),
    [sym_raw_string] = ACTIONS(923),
    [anon_sym_DOLLAR] = ACTIONS(1209),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(923),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(923),
    [anon_sym_BQUOTE] = ACTIONS(923),
    [anon_sym_LT_LPAREN] = ACTIONS(923),
    [anon_sym_GT_LPAREN] = ACTIONS(923),
    [sym_word] = ACTIONS(925),
    [sym_comment] = ACTIONS(133),
  },
  [446] = {
    [sym_file_descriptor] = ACTIONS(965),
    [sym__concat] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(1211),
    [anon_sym_RPAREN] = ACTIONS(965),
    [anon_sym_PIPE_AMP] = ACTIONS(965),
    [anon_sym_AMP_AMP] = ACTIONS(965),
    [anon_sym_PIPE_PIPE] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_GT] = ACTIONS(1211),
    [anon_sym_GT_GT] = ACTIONS(965),
    [anon_sym_AMP_GT] = ACTIONS(1211),
    [anon_sym_AMP_GT_GT] = ACTIONS(965),
    [anon_sym_LT_AMP] = ACTIONS(965),
    [anon_sym_GT_AMP] = ACTIONS(965),
    [anon_sym_LT_LT] = ACTIONS(1211),
    [anon_sym_LT_LT_DASH] = ACTIONS(965),
    [anon_sym_DQUOTE] = ACTIONS(965),
    [sym_raw_string] = ACTIONS(965),
    [anon_sym_DOLLAR] = ACTIONS(1211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(965),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(965),
    [anon_sym_BQUOTE] = ACTIONS(965),
    [anon_sym_LT_LPAREN] = ACTIONS(965),
    [anon_sym_GT_LPAREN] = ACTIONS(965),
    [sym_word] = ACTIONS(967),
    [sym_comment] = ACTIONS(133),
  },
  [447] = {
    [sym_compound_statement] = STATE(636),
    [anon_sym_LBRACE] = ACTIONS(1337),
    [sym_comment] = ACTIONS(133),
  },
  [448] = {
    [anon_sym_PIPE] = ACTIONS(1339),
    [anon_sym_RPAREN] = ACTIONS(1341),
    [anon_sym_PIPE_AMP] = ACTIONS(1341),
    [anon_sym_AMP_AMP] = ACTIONS(1341),
    [anon_sym_PIPE_PIPE] = ACTIONS(1341),
    [anon_sym_BQUOTE] = ACTIONS(1341),
    [sym_comment] = ACTIONS(133),
  },
  [449] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(1339),
    [anon_sym_RPAREN] = ACTIONS(1341),
    [anon_sym_PIPE_AMP] = ACTIONS(1341),
    [anon_sym_AMP_AMP] = ACTIONS(1341),
    [anon_sym_PIPE_PIPE] = ACTIONS(1339),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [450] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(1343),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(1343),
    [anon_sym_PIPE_PIPE] = ACTIONS(1343),
    [sym_comment] = ACTIONS(133),
  },
  [451] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(1343),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(1343),
    [anon_sym_PIPE_PIPE] = ACTIONS(1345),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [452] = {
    [sym_concatenation] = STATE(638),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [anon_sym_DQUOTE] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(1347),
    [anon_sym_DOLLAR] = ACTIONS(935),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(937),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(941),
    [anon_sym_LT_LPAREN] = ACTIONS(943),
    [anon_sym_GT_LPAREN] = ACTIONS(943),
    [sym_word] = ACTIONS(1349),
    [sym_comment] = ACTIONS(133),
  },
  [453] = {
    [sym_simple_expansion] = STATE(70),
    [sym_expansion] = STATE(70),
    [sym_command_substitution] = STATE(70),
    [aux_sym_string_repeat1] = STATE(640),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(197),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [454] = {
    [aux_sym_concatenation_repeat1] = STATE(642),
    [sym_file_descriptor] = ACTIONS(411),
    [sym__concat] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(415),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_PIPE_AMP] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_LT] = ACTIONS(415),
    [anon_sym_GT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_AMP_GT] = ACTIONS(415),
    [anon_sym_AMP_GT_GT] = ACTIONS(411),
    [anon_sym_LT_AMP] = ACTIONS(411),
    [anon_sym_GT_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(411),
    [anon_sym_BQUOTE] = ACTIONS(411),
    [sym_comment] = ACTIONS(133),
  },
  [455] = {
    [sym_special_variable_name] = STATE(645),
    [anon_sym_DOLLAR] = ACTIONS(1355),
    [anon_sym_POUND] = ACTIONS(1357),
    [anon_sym_AT] = ACTIONS(1355),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(1359),
    [anon_sym_STAR] = ACTIONS(1355),
    [anon_sym_QMARK] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_0] = ACTIONS(1357),
    [anon_sym__] = ACTIONS(1357),
  },
  [456] = {
    [sym_special_variable_name] = STATE(648),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(1361),
    [anon_sym_AT] = ACTIONS(219),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [457] = {
    [sym_for_statement] = STATE(649),
    [sym_while_statement] = STATE(649),
    [sym_if_statement] = STATE(649),
    [sym_case_statement] = STATE(649),
    [sym_function_definition] = STATE(649),
    [sym_subshell] = STATE(649),
    [sym_pipeline] = STATE(649),
    [sym_list] = STATE(649),
    [sym_bracket_command] = STATE(649),
    [sym_command] = STATE(649),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(650),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [458] = {
    [sym_for_statement] = STATE(651),
    [sym_while_statement] = STATE(651),
    [sym_if_statement] = STATE(651),
    [sym_case_statement] = STATE(651),
    [sym_function_definition] = STATE(651),
    [sym_subshell] = STATE(651),
    [sym_pipeline] = STATE(651),
    [sym_list] = STATE(651),
    [sym_bracket_command] = STATE(651),
    [sym_command] = STATE(651),
    [sym_command_name] = STATE(109),
    [sym_environment_variable_assignment] = STATE(652),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [459] = {
    [sym_for_statement] = STATE(653),
    [sym_while_statement] = STATE(653),
    [sym_if_statement] = STATE(653),
    [sym_case_statement] = STATE(653),
    [sym_function_definition] = STATE(653),
    [sym_subshell] = STATE(653),
    [sym_pipeline] = STATE(653),
    [sym_list] = STATE(653),
    [sym_bracket_command] = STATE(653),
    [sym_command] = STATE(653),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(654),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [460] = {
    [sym_file_descriptor] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(415),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_PIPE_AMP] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_LT] = ACTIONS(415),
    [anon_sym_GT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_AMP_GT] = ACTIONS(415),
    [anon_sym_AMP_GT_GT] = ACTIONS(411),
    [anon_sym_LT_AMP] = ACTIONS(411),
    [anon_sym_GT_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(411),
    [anon_sym_BQUOTE] = ACTIONS(411),
    [sym_comment] = ACTIONS(133),
  },
  [461] = {
    [sym_file_descriptor] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(1365),
    [anon_sym_RPAREN] = ACTIONS(995),
    [anon_sym_PIPE_AMP] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_AMP_GT] = ACTIONS(1365),
    [anon_sym_AMP_GT_GT] = ACTIONS(995),
    [anon_sym_LT_AMP] = ACTIONS(995),
    [anon_sym_GT_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(1365),
    [anon_sym_LT_LT_DASH] = ACTIONS(995),
    [anon_sym_BQUOTE] = ACTIONS(995),
    [sym_comment] = ACTIONS(133),
  },
  [462] = {
    [sym_simple_expansion] = STATE(493),
    [sym_expansion] = STATE(493),
    [aux_sym_heredoc_repeat1] = STATE(656),
    [sym__heredoc_middle] = ACTIONS(999),
    [sym__heredoc_end] = ACTIONS(1367),
    [anon_sym_DOLLAR] = ACTIONS(1003),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1005),
    [sym_comment] = ACTIONS(133),
  },
  [463] = {
    [sym_file_descriptor] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(1369),
    [anon_sym_RPAREN] = ACTIONS(1007),
    [anon_sym_PIPE_AMP] = ACTIONS(1007),
    [anon_sym_AMP_AMP] = ACTIONS(1007),
    [anon_sym_PIPE_PIPE] = ACTIONS(1007),
    [anon_sym_LT] = ACTIONS(1369),
    [anon_sym_GT] = ACTIONS(1369),
    [anon_sym_GT_GT] = ACTIONS(1007),
    [anon_sym_AMP_GT] = ACTIONS(1369),
    [anon_sym_AMP_GT_GT] = ACTIONS(1007),
    [anon_sym_LT_AMP] = ACTIONS(1007),
    [anon_sym_GT_AMP] = ACTIONS(1007),
    [anon_sym_LT_LT] = ACTIONS(1369),
    [anon_sym_LT_LT_DASH] = ACTIONS(1007),
    [anon_sym_BQUOTE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(133),
  },
  [464] = {
    [aux_sym_concatenation_repeat1] = STATE(248),
    [sym_file_descriptor] = ACTIONS(767),
    [sym__concat] = ACTIONS(503),
    [anon_sym_PIPE] = ACTIONS(765),
    [anon_sym_RPAREN] = ACTIONS(767),
    [anon_sym_PIPE_AMP] = ACTIONS(767),
    [anon_sym_AMP_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(765),
    [anon_sym_GT_GT] = ACTIONS(767),
    [anon_sym_AMP_GT] = ACTIONS(765),
    [anon_sym_AMP_GT_GT] = ACTIONS(767),
    [anon_sym_LT_AMP] = ACTIONS(767),
    [anon_sym_GT_AMP] = ACTIONS(767),
    [anon_sym_LT_LT] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(767),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [sym_raw_string] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(767),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LT_LPAREN] = ACTIONS(767),
    [anon_sym_GT_LPAREN] = ACTIONS(767),
    [sym_word] = ACTIONS(769),
    [sym_comment] = ACTIONS(133),
  },
  [465] = {
    [sym_file_descriptor] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(765),
    [anon_sym_RPAREN] = ACTIONS(767),
    [anon_sym_PIPE_AMP] = ACTIONS(767),
    [anon_sym_AMP_AMP] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(765),
    [anon_sym_GT_GT] = ACTIONS(767),
    [anon_sym_AMP_GT] = ACTIONS(765),
    [anon_sym_AMP_GT_GT] = ACTIONS(767),
    [anon_sym_LT_AMP] = ACTIONS(767),
    [anon_sym_GT_AMP] = ACTIONS(767),
    [anon_sym_LT_LT] = ACTIONS(765),
    [anon_sym_LT_LT_DASH] = ACTIONS(767),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [sym_raw_string] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(767),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LT_LPAREN] = ACTIONS(767),
    [anon_sym_GT_LPAREN] = ACTIONS(767),
    [sym_word] = ACTIONS(769),
    [sym_comment] = ACTIONS(133),
  },
  [466] = {
    [sym_file_redirect] = STATE(467),
    [sym_heredoc_redirect] = STATE(467),
    [sym_file_descriptor] = ACTIONS(527),
    [anon_sym_PIPE] = ACTIONS(1371),
    [anon_sym_RPAREN] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_GT] = ACTIONS(535),
    [anon_sym_AMP_GT] = ACTIONS(533),
    [anon_sym_AMP_GT_GT] = ACTIONS(535),
    [anon_sym_LT_AMP] = ACTIONS(535),
    [anon_sym_GT_AMP] = ACTIONS(535),
    [anon_sym_LT_LT] = ACTIONS(537),
    [anon_sym_LT_LT_DASH] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(133),
  },
  [467] = {
    [sym_file_descriptor] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_RPAREN] = ACTIONS(1013),
    [anon_sym_PIPE_AMP] = ACTIONS(1013),
    [anon_sym_AMP_AMP] = ACTIONS(1013),
    [anon_sym_PIPE_PIPE] = ACTIONS(1013),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1013),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1013),
    [anon_sym_LT_AMP] = ACTIONS(1013),
    [anon_sym_GT_AMP] = ACTIONS(1013),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1013),
    [anon_sym_BQUOTE] = ACTIONS(1013),
    [sym_comment] = ACTIONS(133),
  },
  [468] = {
    [sym_file_redirect] = STATE(269),
    [sym_heredoc_redirect] = STATE(269),
    [sym_concatenation] = STATE(465),
    [sym_string] = STATE(464),
    [sym_simple_expansion] = STATE(464),
    [sym_expansion] = STATE(464),
    [sym_command_substitution] = STATE(464),
    [sym_process_substitution] = STATE(464),
    [aux_sym_command_repeat2] = STATE(657),
    [sym_file_descriptor] = ACTIONS(527),
    [anon_sym_PIPE] = ACTIONS(1377),
    [anon_sym_RPAREN] = ACTIONS(1379),
    [anon_sym_PIPE_AMP] = ACTIONS(1379),
    [anon_sym_AMP_AMP] = ACTIONS(1379),
    [anon_sym_PIPE_PIPE] = ACTIONS(1377),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_GT] = ACTIONS(535),
    [anon_sym_AMP_GT] = ACTIONS(533),
    [anon_sym_AMP_GT_GT] = ACTIONS(535),
    [anon_sym_LT_AMP] = ACTIONS(535),
    [anon_sym_GT_AMP] = ACTIONS(535),
    [anon_sym_LT_LT] = ACTIONS(537),
    [anon_sym_LT_LT_DASH] = ACTIONS(539),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(959),
    [sym_comment] = ACTIONS(133),
  },
  [469] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(1339),
    [anon_sym_PIPE_AMP] = ACTIONS(1341),
    [anon_sym_AMP_AMP] = ACTIONS(1341),
    [anon_sym_PIPE_PIPE] = ACTIONS(1339),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(1341),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [470] = {
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(1343),
    [anon_sym_PIPE_PIPE] = ACTIONS(1343),
    [anon_sym_BQUOTE] = ACTIONS(1343),
    [sym_comment] = ACTIONS(133),
  },
  [471] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(1343),
    [anon_sym_PIPE_PIPE] = ACTIONS(1345),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [472] = {
    [sym_file_redirect] = STATE(269),
    [sym_heredoc_redirect] = STATE(269),
    [sym_concatenation] = STATE(465),
    [sym_string] = STATE(464),
    [sym_simple_expansion] = STATE(464),
    [sym_expansion] = STATE(464),
    [sym_command_substitution] = STATE(464),
    [sym_process_substitution] = STATE(464),
    [aux_sym_command_repeat2] = STATE(657),
    [sym_file_descriptor] = ACTIONS(527),
    [anon_sym_PIPE] = ACTIONS(1377),
    [anon_sym_PIPE_AMP] = ACTIONS(1379),
    [anon_sym_AMP_AMP] = ACTIONS(1379),
    [anon_sym_PIPE_PIPE] = ACTIONS(1377),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_GT] = ACTIONS(535),
    [anon_sym_AMP_GT] = ACTIONS(533),
    [anon_sym_AMP_GT_GT] = ACTIONS(535),
    [anon_sym_LT_AMP] = ACTIONS(535),
    [anon_sym_GT_AMP] = ACTIONS(535),
    [anon_sym_LT_LT] = ACTIONS(537),
    [anon_sym_LT_LT_DASH] = ACTIONS(539),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(1379),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(959),
    [sym_comment] = ACTIONS(133),
  },
  [473] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(659),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [474] = {
    [anon_sym_PIPE] = ACTIONS(1383),
    [anon_sym_RPAREN] = ACTIONS(1383),
    [anon_sym_SEMI_SEMI] = ACTIONS(1383),
    [anon_sym_PIPE_AMP] = ACTIONS(1383),
    [anon_sym_AMP_AMP] = ACTIONS(1383),
    [anon_sym_PIPE_PIPE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1383),
    [anon_sym_LF] = ACTIONS(1383),
    [anon_sym_AMP] = ACTIONS(1383),
  },
  [475] = {
    [aux_sym_concatenation_repeat1] = STATE(480),
    [sym_file_descriptor] = ACTIONS(613),
    [sym__concat] = ACTIONS(981),
    [anon_sym_PIPE] = ACTIONS(1385),
    [anon_sym_RPAREN] = ACTIONS(1385),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1385),
    [anon_sym_GT] = ACTIONS(1385),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1385),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1385),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1385),
  },
  [476] = {
    [sym_file_descriptor] = ACTIONS(613),
    [anon_sym_PIPE] = ACTIONS(1385),
    [anon_sym_RPAREN] = ACTIONS(1385),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1385),
    [anon_sym_GT] = ACTIONS(1385),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1385),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1385),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1385),
  },
  [477] = {
    [sym_file_descriptor] = ACTIONS(427),
    [sym__concat] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(429),
    [anon_sym_SEMI_SEMI] = ACTIONS(429),
    [anon_sym_PIPE_AMP] = ACTIONS(429),
    [anon_sym_AMP_AMP] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_GT] = ACTIONS(429),
    [anon_sym_AMP_GT] = ACTIONS(429),
    [anon_sym_AMP_GT_GT] = ACTIONS(429),
    [anon_sym_LT_AMP] = ACTIONS(429),
    [anon_sym_GT_AMP] = ACTIONS(429),
    [anon_sym_LT_LT] = ACTIONS(429),
    [anon_sym_LT_LT_DASH] = ACTIONS(429),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(429),
    [anon_sym_LF] = ACTIONS(429),
    [anon_sym_AMP] = ACTIONS(429),
  },
  [478] = {
    [sym_simple_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [anon_sym_DQUOTE] = ACTIONS(1387),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(447),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [479] = {
    [sym_string] = STATE(661),
    [sym_simple_expansion] = STATE(661),
    [sym_expansion] = STATE(661),
    [sym_command_substitution] = STATE(661),
    [sym_process_substitution] = STATE(661),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [sym_raw_string] = ACTIONS(1389),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(579),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(581),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_LT_LPAREN] = ACTIONS(585),
    [anon_sym_GT_LPAREN] = ACTIONS(585),
    [sym_word] = ACTIONS(1391),
    [sym_comment] = ACTIONS(133),
  },
  [480] = {
    [sym_file_descriptor] = ACTIONS(453),
    [sym__concat] = ACTIONS(1393),
    [anon_sym_PIPE] = ACTIONS(457),
    [anon_sym_RPAREN] = ACTIONS(457),
    [anon_sym_SEMI_SEMI] = ACTIONS(457),
    [anon_sym_PIPE_AMP] = ACTIONS(457),
    [anon_sym_AMP_AMP] = ACTIONS(457),
    [anon_sym_PIPE_PIPE] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(457),
    [anon_sym_AMP_GT] = ACTIONS(457),
    [anon_sym_AMP_GT_GT] = ACTIONS(457),
    [anon_sym_LT_AMP] = ACTIONS(457),
    [anon_sym_GT_AMP] = ACTIONS(457),
    [anon_sym_LT_LT] = ACTIONS(457),
    [anon_sym_LT_LT_DASH] = ACTIONS(457),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(457),
    [anon_sym_LF] = ACTIONS(457),
    [anon_sym_AMP] = ACTIONS(457),
  },
  [481] = {
    [sym_file_descriptor] = ACTIONS(459),
    [sym__concat] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(461),
    [anon_sym_RPAREN] = ACTIONS(461),
    [anon_sym_SEMI_SEMI] = ACTIONS(461),
    [anon_sym_PIPE_AMP] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(461),
    [anon_sym_AMP_GT] = ACTIONS(461),
    [anon_sym_AMP_GT_GT] = ACTIONS(461),
    [anon_sym_LT_AMP] = ACTIONS(461),
    [anon_sym_GT_AMP] = ACTIONS(461),
    [anon_sym_LT_LT] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_LF] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(461),
  },
  [482] = {
    [sym_file_descriptor] = ACTIONS(463),
    [sym__concat] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_SEMI_SEMI] = ACTIONS(465),
    [anon_sym_PIPE_AMP] = ACTIONS(465),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE_PIPE] = ACTIONS(465),
    [anon_sym_LT] = ACTIONS(465),
    [anon_sym_GT] = ACTIONS(465),
    [anon_sym_GT_GT] = ACTIONS(465),
    [anon_sym_AMP_GT] = ACTIONS(465),
    [anon_sym_AMP_GT_GT] = ACTIONS(465),
    [anon_sym_LT_AMP] = ACTIONS(465),
    [anon_sym_GT_AMP] = ACTIONS(465),
    [anon_sym_LT_LT] = ACTIONS(465),
    [anon_sym_LT_LT_DASH] = ACTIONS(465),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(465),
    [anon_sym_LF] = ACTIONS(465),
    [anon_sym_AMP] = ACTIONS(465),
  },
  [483] = {
    [sym_file_descriptor] = ACTIONS(467),
    [sym__concat] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_RPAREN] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
  },
  [484] = {
    [sym_special_variable_name] = STATE(664),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(225),
    [anon_sym_AT] = ACTIONS(219),
    [anon_sym_COLON] = ACTIONS(471),
    [anon_sym_COLON_QMARK] = ACTIONS(459),
    [anon_sym_COLON_DASH] = ACTIONS(459),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [485] = {
    [anon_sym_RBRACE] = ACTIONS(1397),
    [anon_sym_LBRACK] = ACTIONS(1399),
    [anon_sym_EQ] = ACTIONS(1401),
    [anon_sym_COLON] = ACTIONS(1403),
    [anon_sym_COLON_QMARK] = ACTIONS(1401),
    [anon_sym_COLON_DASH] = ACTIONS(1401),
    [anon_sym_PERCENT] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1401),
    [sym_comment] = ACTIONS(133),
  },
  [486] = {
    [anon_sym_RBRACE] = ACTIONS(1405),
    [anon_sym_LBRACK] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_COLON] = ACTIONS(1411),
    [anon_sym_COLON_QMARK] = ACTIONS(1409),
    [anon_sym_COLON_DASH] = ACTIONS(1409),
    [anon_sym_PERCENT] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1409),
    [sym_comment] = ACTIONS(133),
  },
  [487] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(1413),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [488] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(1413),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [489] = {
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(1413),
    [sym_comment] = ACTIONS(133),
  },
  [490] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(1413),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [491] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(1415),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [492] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(1415),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [493] = {
    [sym__heredoc_middle] = ACTIONS(1417),
    [sym__heredoc_end] = ACTIONS(1417),
    [anon_sym_DOLLAR] = ACTIONS(1419),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1417),
    [sym_comment] = ACTIONS(133),
  },
  [494] = {
    [sym_file_descriptor] = ACTIONS(1421),
    [anon_sym_PIPE] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(1423),
    [anon_sym_SEMI_SEMI] = ACTIONS(1423),
    [anon_sym_PIPE_AMP] = ACTIONS(1423),
    [anon_sym_AMP_AMP] = ACTIONS(1423),
    [anon_sym_PIPE_PIPE] = ACTIONS(1423),
    [anon_sym_LT] = ACTIONS(1423),
    [anon_sym_GT] = ACTIONS(1423),
    [anon_sym_GT_GT] = ACTIONS(1423),
    [anon_sym_AMP_GT] = ACTIONS(1423),
    [anon_sym_AMP_GT_GT] = ACTIONS(1423),
    [anon_sym_LT_AMP] = ACTIONS(1423),
    [anon_sym_GT_AMP] = ACTIONS(1423),
    [anon_sym_LT_LT] = ACTIONS(1423),
    [anon_sym_LT_LT_DASH] = ACTIONS(1423),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1423),
    [anon_sym_LF] = ACTIONS(1423),
    [anon_sym_AMP] = ACTIONS(1423),
  },
  [495] = {
    [sym_special_variable_name] = STATE(675),
    [anon_sym_DOLLAR] = ACTIONS(1425),
    [anon_sym_POUND] = ACTIONS(1427),
    [anon_sym_AT] = ACTIONS(1425),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(1429),
    [anon_sym_STAR] = ACTIONS(1425),
    [anon_sym_QMARK] = ACTIONS(1425),
    [anon_sym_DASH] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1425),
    [anon_sym_0] = ACTIONS(1427),
    [anon_sym__] = ACTIONS(1427),
  },
  [496] = {
    [sym_special_variable_name] = STATE(678),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(1431),
    [anon_sym_AT] = ACTIONS(219),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(1433),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [497] = {
    [sym_simple_expansion] = STATE(679),
    [sym_expansion] = STATE(679),
    [sym__heredoc_middle] = ACTIONS(1435),
    [sym__heredoc_end] = ACTIONS(1437),
    [anon_sym_DOLLAR] = ACTIONS(1003),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1005),
    [sym_comment] = ACTIONS(133),
  },
  [498] = {
    [sym_file_redirect] = STATE(299),
    [sym_heredoc_redirect] = STATE(299),
    [sym_file_descriptor] = ACTIONS(277),
    [anon_sym_PIPE] = ACTIONS(1439),
    [anon_sym_RPAREN] = ACTIONS(1439),
    [anon_sym_SEMI_SEMI] = ACTIONS(1439),
    [anon_sym_PIPE_AMP] = ACTIONS(1439),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_PIPE_PIPE] = ACTIONS(1439),
    [anon_sym_LT] = ACTIONS(281),
    [anon_sym_GT] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(281),
    [anon_sym_AMP_GT] = ACTIONS(281),
    [anon_sym_AMP_GT_GT] = ACTIONS(281),
    [anon_sym_LT_AMP] = ACTIONS(281),
    [anon_sym_GT_AMP] = ACTIONS(281),
    [anon_sym_LT_LT] = ACTIONS(283),
    [anon_sym_LT_LT_DASH] = ACTIONS(283),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1439),
    [anon_sym_LF] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
  },
  [499] = {
    [sym__concat] = ACTIONS(821),
    [anon_sym_PIPE] = ACTIONS(821),
    [anon_sym_RPAREN] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(821),
    [sym_comment] = ACTIONS(133),
  },
  [500] = {
    [sym__concat] = ACTIONS(829),
    [anon_sym_PIPE] = ACTIONS(829),
    [anon_sym_RPAREN] = ACTIONS(829),
    [anon_sym_RBRACK] = ACTIONS(829),
    [sym_comment] = ACTIONS(133),
  },
  [501] = {
    [sym_string] = STATE(681),
    [sym_simple_expansion] = STATE(681),
    [sym_expansion] = STATE(681),
    [sym_command_substitution] = STATE(681),
    [sym_process_substitution] = STATE(681),
    [anon_sym_DQUOTE] = ACTIONS(315),
    [sym_raw_string] = ACTIONS(1441),
    [anon_sym_DOLLAR] = ACTIONS(319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(327),
    [anon_sym_GT_LPAREN] = ACTIONS(327),
    [sym_word] = ACTIONS(1443),
    [sym_comment] = ACTIONS(133),
  },
  [502] = {
    [anon_sym_RBRACE] = ACTIONS(1445),
    [anon_sym_LBRACK] = ACTIONS(1447),
    [sym_comment] = ACTIONS(133),
  },
  [503] = {
    [anon_sym_RBRACE] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [sym_comment] = ACTIONS(133),
  },
  [504] = {
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(845),
    [anon_sym_RBRACK] = ACTIONS(845),
    [sym_comment] = ACTIONS(133),
  },
  [505] = {
    [anon_sym_AT] = ACTIONS(1453),
    [sym_comment] = ACTIONS(133),
  },
  [506] = {
    [sym_concatenation] = STATE(688),
    [sym_string] = STATE(687),
    [sym_simple_expansion] = STATE(687),
    [sym_expansion] = STATE(687),
    [sym_command_substitution] = STATE(687),
    [sym_process_substitution] = STATE(687),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(1455),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(1457),
    [sym_comment] = ACTIONS(133),
  },
  [507] = {
    [sym__concat] = ACTIONS(855),
    [anon_sym_PIPE] = ACTIONS(855),
    [anon_sym_RPAREN] = ACTIONS(855),
    [anon_sym_RBRACK] = ACTIONS(855),
    [sym_comment] = ACTIONS(133),
  },
  [508] = {
    [anon_sym_AT] = ACTIONS(1459),
    [sym_comment] = ACTIONS(133),
  },
  [509] = {
    [sym_concatenation] = STATE(691),
    [sym_string] = STATE(690),
    [sym_simple_expansion] = STATE(690),
    [sym_expansion] = STATE(690),
    [sym_command_substitution] = STATE(690),
    [sym_process_substitution] = STATE(690),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(1461),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(1463),
    [sym_comment] = ACTIONS(133),
  },
  [510] = {
    [sym__concat] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(923),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_RBRACK] = ACTIONS(923),
    [sym_comment] = ACTIONS(133),
  },
  [511] = {
    [sym__concat] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(965),
    [anon_sym_RPAREN] = ACTIONS(965),
    [anon_sym_RBRACK] = ACTIONS(965),
    [sym_comment] = ACTIONS(133),
  },
  [512] = {
    [sym_file_descriptor] = ACTIONS(1465),
    [sym_variable_name] = ACTIONS(1465),
    [anon_sym_PIPE] = ACTIONS(1467),
    [anon_sym_RPAREN] = ACTIONS(1467),
    [anon_sym_SEMI_SEMI] = ACTIONS(1467),
    [anon_sym_PIPE_AMP] = ACTIONS(1467),
    [anon_sym_AMP_AMP] = ACTIONS(1467),
    [anon_sym_PIPE_PIPE] = ACTIONS(1467),
    [anon_sym_LT] = ACTIONS(1467),
    [anon_sym_GT] = ACTIONS(1467),
    [anon_sym_GT_GT] = ACTIONS(1467),
    [anon_sym_AMP_GT] = ACTIONS(1467),
    [anon_sym_AMP_GT_GT] = ACTIONS(1467),
    [anon_sym_LT_AMP] = ACTIONS(1467),
    [anon_sym_GT_AMP] = ACTIONS(1467),
    [anon_sym_DQUOTE] = ACTIONS(1467),
    [sym_raw_string] = ACTIONS(1467),
    [anon_sym_DOLLAR] = ACTIONS(1467),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1467),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1467),
    [anon_sym_BQUOTE] = ACTIONS(1467),
    [anon_sym_LT_LPAREN] = ACTIONS(1467),
    [anon_sym_GT_LPAREN] = ACTIONS(1467),
    [sym_word] = ACTIONS(1467),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1467),
    [anon_sym_LF] = ACTIONS(1467),
    [anon_sym_AMP] = ACTIONS(1467),
  },
  [513] = {
    [anon_sym_RPAREN] = ACTIONS(1469),
    [sym_word] = ACTIONS(1471),
    [sym_comment] = ACTIONS(133),
  },
  [514] = {
    [sym_file_descriptor] = ACTIONS(821),
    [sym__concat] = ACTIONS(821),
    [sym_variable_name] = ACTIONS(821),
    [anon_sym_PIPE] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(823),
    [anon_sym_SEMI_SEMI] = ACTIONS(823),
    [anon_sym_PIPE_AMP] = ACTIONS(823),
    [anon_sym_AMP_AMP] = ACTIONS(823),
    [anon_sym_PIPE_PIPE] = ACTIONS(823),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(823),
    [anon_sym_GT_GT] = ACTIONS(823),
    [anon_sym_AMP_GT] = ACTIONS(823),
    [anon_sym_AMP_GT_GT] = ACTIONS(823),
    [anon_sym_LT_AMP] = ACTIONS(823),
    [anon_sym_GT_AMP] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(823),
    [sym_raw_string] = ACTIONS(823),
    [anon_sym_DOLLAR] = ACTIONS(823),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(823),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(823),
    [anon_sym_BQUOTE] = ACTIONS(823),
    [anon_sym_LT_LPAREN] = ACTIONS(823),
    [anon_sym_GT_LPAREN] = ACTIONS(823),
    [sym_word] = ACTIONS(823),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_LF] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
  },
  [515] = {
    [sym_file_descriptor] = ACTIONS(829),
    [sym__concat] = ACTIONS(829),
    [sym_variable_name] = ACTIONS(829),
    [anon_sym_PIPE] = ACTIONS(831),
    [anon_sym_RPAREN] = ACTIONS(831),
    [anon_sym_SEMI_SEMI] = ACTIONS(831),
    [anon_sym_PIPE_AMP] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(831),
    [anon_sym_GT_GT] = ACTIONS(831),
    [anon_sym_AMP_GT] = ACTIONS(831),
    [anon_sym_AMP_GT_GT] = ACTIONS(831),
    [anon_sym_LT_AMP] = ACTIONS(831),
    [anon_sym_GT_AMP] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(831),
    [sym_raw_string] = ACTIONS(831),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(831),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(831),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [anon_sym_LT_LPAREN] = ACTIONS(831),
    [anon_sym_GT_LPAREN] = ACTIONS(831),
    [sym_word] = ACTIONS(831),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(831),
    [anon_sym_LF] = ACTIONS(831),
    [anon_sym_AMP] = ACTIONS(831),
  },
  [516] = {
    [sym_string] = STATE(692),
    [sym_simple_expansion] = STATE(692),
    [sym_expansion] = STATE(692),
    [sym_command_substitution] = STATE(692),
    [sym_process_substitution] = STATE(692),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(1473),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(341),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_LT_LPAREN] = ACTIONS(347),
    [anon_sym_GT_LPAREN] = ACTIONS(347),
    [sym_word] = ACTIONS(1475),
    [sym_comment] = ACTIONS(133),
  },
  [517] = {
    [anon_sym_RBRACE] = ACTIONS(1477),
    [anon_sym_LBRACK] = ACTIONS(1479),
    [sym_comment] = ACTIONS(133),
  },
  [518] = {
    [anon_sym_RBRACE] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [sym_comment] = ACTIONS(133),
  },
  [519] = {
    [sym_file_descriptor] = ACTIONS(845),
    [sym__concat] = ACTIONS(845),
    [sym_variable_name] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(847),
    [anon_sym_SEMI_SEMI] = ACTIONS(847),
    [anon_sym_PIPE_AMP] = ACTIONS(847),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_PIPE_PIPE] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(847),
    [anon_sym_AMP_GT] = ACTIONS(847),
    [anon_sym_AMP_GT_GT] = ACTIONS(847),
    [anon_sym_LT_AMP] = ACTIONS(847),
    [anon_sym_GT_AMP] = ACTIONS(847),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [sym_raw_string] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(847),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(847),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(847),
    [anon_sym_GT_LPAREN] = ACTIONS(847),
    [sym_word] = ACTIONS(847),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(847),
    [anon_sym_LF] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(847),
  },
  [520] = {
    [anon_sym_AT] = ACTIONS(1485),
    [sym_comment] = ACTIONS(133),
  },
  [521] = {
    [sym_concatenation] = STATE(699),
    [sym_string] = STATE(698),
    [sym_simple_expansion] = STATE(698),
    [sym_expansion] = STATE(698),
    [sym_command_substitution] = STATE(698),
    [sym_process_substitution] = STATE(698),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(1487),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(1489),
    [sym_comment] = ACTIONS(133),
  },
  [522] = {
    [sym_file_descriptor] = ACTIONS(855),
    [sym__concat] = ACTIONS(855),
    [sym_variable_name] = ACTIONS(855),
    [anon_sym_PIPE] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [anon_sym_PIPE_AMP] = ACTIONS(857),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_AMP_GT] = ACTIONS(857),
    [anon_sym_AMP_GT_GT] = ACTIONS(857),
    [anon_sym_LT_AMP] = ACTIONS(857),
    [anon_sym_GT_AMP] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(857),
    [sym_raw_string] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(857),
    [anon_sym_LT_LPAREN] = ACTIONS(857),
    [anon_sym_GT_LPAREN] = ACTIONS(857),
    [sym_word] = ACTIONS(857),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
  },
  [523] = {
    [anon_sym_AT] = ACTIONS(1491),
    [sym_comment] = ACTIONS(133),
  },
  [524] = {
    [sym_concatenation] = STATE(702),
    [sym_string] = STATE(701),
    [sym_simple_expansion] = STATE(701),
    [sym_expansion] = STATE(701),
    [sym_command_substitution] = STATE(701),
    [sym_process_substitution] = STATE(701),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(1493),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(1495),
    [sym_comment] = ACTIONS(133),
  },
  [525] = {
    [sym_file_descriptor] = ACTIONS(923),
    [sym__concat] = ACTIONS(923),
    [sym_variable_name] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_RPAREN] = ACTIONS(925),
    [anon_sym_SEMI_SEMI] = ACTIONS(925),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(925),
    [anon_sym_PIPE_PIPE] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_GT] = ACTIONS(925),
    [anon_sym_AMP_GT] = ACTIONS(925),
    [anon_sym_AMP_GT_GT] = ACTIONS(925),
    [anon_sym_LT_AMP] = ACTIONS(925),
    [anon_sym_GT_AMP] = ACTIONS(925),
    [anon_sym_DQUOTE] = ACTIONS(925),
    [sym_raw_string] = ACTIONS(925),
    [anon_sym_DOLLAR] = ACTIONS(925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(925),
    [anon_sym_BQUOTE] = ACTIONS(925),
    [anon_sym_LT_LPAREN] = ACTIONS(925),
    [anon_sym_GT_LPAREN] = ACTIONS(925),
    [sym_word] = ACTIONS(925),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(925),
    [anon_sym_LF] = ACTIONS(925),
    [anon_sym_AMP] = ACTIONS(925),
  },
  [526] = {
    [sym_file_descriptor] = ACTIONS(965),
    [sym__concat] = ACTIONS(965),
    [sym_variable_name] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(967),
    [anon_sym_RPAREN] = ACTIONS(967),
    [anon_sym_SEMI_SEMI] = ACTIONS(967),
    [anon_sym_PIPE_AMP] = ACTIONS(967),
    [anon_sym_AMP_AMP] = ACTIONS(967),
    [anon_sym_PIPE_PIPE] = ACTIONS(967),
    [anon_sym_LT] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(967),
    [anon_sym_GT_GT] = ACTIONS(967),
    [anon_sym_AMP_GT] = ACTIONS(967),
    [anon_sym_AMP_GT_GT] = ACTIONS(967),
    [anon_sym_LT_AMP] = ACTIONS(967),
    [anon_sym_GT_AMP] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(967),
    [sym_raw_string] = ACTIONS(967),
    [anon_sym_DOLLAR] = ACTIONS(967),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(967),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(967),
    [anon_sym_BQUOTE] = ACTIONS(967),
    [anon_sym_LT_LPAREN] = ACTIONS(967),
    [anon_sym_GT_LPAREN] = ACTIONS(967),
    [sym_word] = ACTIONS(967),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_LF] = ACTIONS(967),
    [anon_sym_AMP] = ACTIONS(967),
  },
  [527] = {
    [sym__concat] = ACTIONS(427),
    [anon_sym_SEMI_SEMI] = ACTIONS(429),
    [anon_sym_DQUOTE] = ACTIONS(429),
    [sym_raw_string] = ACTIONS(429),
    [anon_sym_DOLLAR] = ACTIONS(429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(429),
    [anon_sym_BQUOTE] = ACTIONS(429),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [sym_word] = ACTIONS(429),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(429),
    [anon_sym_LF] = ACTIONS(429),
    [anon_sym_AMP] = ACTIONS(429),
  },
  [528] = {
    [sym_simple_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [anon_sym_DQUOTE] = ACTIONS(1497),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(447),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [529] = {
    [sym_string] = STATE(704),
    [sym_simple_expansion] = STATE(704),
    [sym_expansion] = STATE(704),
    [sym_command_substitution] = STATE(704),
    [sym_process_substitution] = STATE(704),
    [anon_sym_DQUOTE] = ACTIONS(655),
    [sym_raw_string] = ACTIONS(1499),
    [anon_sym_DOLLAR] = ACTIONS(659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(661),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(663),
    [anon_sym_BQUOTE] = ACTIONS(665),
    [anon_sym_LT_LPAREN] = ACTIONS(667),
    [anon_sym_GT_LPAREN] = ACTIONS(667),
    [sym_word] = ACTIONS(1501),
    [sym_comment] = ACTIONS(133),
  },
  [530] = {
    [sym__concat] = ACTIONS(1503),
    [anon_sym_SEMI_SEMI] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(457),
    [sym_raw_string] = ACTIONS(457),
    [anon_sym_DOLLAR] = ACTIONS(457),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(457),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(457),
    [anon_sym_BQUOTE] = ACTIONS(457),
    [anon_sym_LT_LPAREN] = ACTIONS(457),
    [anon_sym_GT_LPAREN] = ACTIONS(457),
    [sym_word] = ACTIONS(457),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(457),
    [anon_sym_LF] = ACTIONS(457),
    [anon_sym_AMP] = ACTIONS(457),
  },
  [531] = {
    [sym__concat] = ACTIONS(459),
    [anon_sym_SEMI_SEMI] = ACTIONS(461),
    [anon_sym_DQUOTE] = ACTIONS(461),
    [sym_raw_string] = ACTIONS(461),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(461),
    [anon_sym_BQUOTE] = ACTIONS(461),
    [anon_sym_LT_LPAREN] = ACTIONS(461),
    [anon_sym_GT_LPAREN] = ACTIONS(461),
    [sym_word] = ACTIONS(461),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_LF] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(461),
  },
  [532] = {
    [sym__concat] = ACTIONS(463),
    [anon_sym_SEMI_SEMI] = ACTIONS(465),
    [anon_sym_DQUOTE] = ACTIONS(465),
    [sym_raw_string] = ACTIONS(465),
    [anon_sym_DOLLAR] = ACTIONS(465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(465),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(465),
    [anon_sym_BQUOTE] = ACTIONS(465),
    [anon_sym_LT_LPAREN] = ACTIONS(465),
    [anon_sym_GT_LPAREN] = ACTIONS(465),
    [sym_word] = ACTIONS(465),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(465),
    [anon_sym_LF] = ACTIONS(465),
    [anon_sym_AMP] = ACTIONS(465),
  },
  [533] = {
    [sym__concat] = ACTIONS(467),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
  },
  [534] = {
    [sym_special_variable_name] = STATE(707),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(225),
    [anon_sym_AT] = ACTIONS(219),
    [anon_sym_COLON] = ACTIONS(471),
    [anon_sym_COLON_QMARK] = ACTIONS(459),
    [anon_sym_COLON_DASH] = ACTIONS(459),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(1505),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [535] = {
    [anon_sym_RBRACE] = ACTIONS(1507),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_EQ] = ACTIONS(1511),
    [anon_sym_COLON] = ACTIONS(1513),
    [anon_sym_COLON_QMARK] = ACTIONS(1511),
    [anon_sym_COLON_DASH] = ACTIONS(1511),
    [anon_sym_PERCENT] = ACTIONS(1511),
    [anon_sym_SLASH] = ACTIONS(1511),
    [sym_comment] = ACTIONS(133),
  },
  [536] = {
    [anon_sym_RBRACE] = ACTIONS(1515),
    [anon_sym_LBRACK] = ACTIONS(1517),
    [anon_sym_EQ] = ACTIONS(1519),
    [anon_sym_COLON] = ACTIONS(1521),
    [anon_sym_COLON_QMARK] = ACTIONS(1519),
    [anon_sym_COLON_DASH] = ACTIONS(1519),
    [anon_sym_PERCENT] = ACTIONS(1519),
    [anon_sym_SLASH] = ACTIONS(1519),
    [sym_comment] = ACTIONS(133),
  },
  [537] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(1523),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [538] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(1523),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [539] = {
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(1523),
    [sym_comment] = ACTIONS(133),
  },
  [540] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(1523),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [541] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(1525),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [542] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(1525),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [543] = {
    [sym_do_group] = STATE(716),
    [anon_sym_do] = ACTIONS(353),
    [sym_comment] = ACTIONS(133),
  },
  [544] = {
    [aux_sym_concatenation_repeat1] = STATE(530),
    [sym__concat] = ACTIONS(1095),
    [anon_sym_SEMI_SEMI] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(769),
    [sym_raw_string] = ACTIONS(769),
    [anon_sym_DOLLAR] = ACTIONS(769),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(769),
    [anon_sym_BQUOTE] = ACTIONS(769),
    [anon_sym_LT_LPAREN] = ACTIONS(769),
    [anon_sym_GT_LPAREN] = ACTIONS(769),
    [sym_word] = ACTIONS(769),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(769),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
  },
  [545] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(769),
    [sym_raw_string] = ACTIONS(769),
    [anon_sym_DOLLAR] = ACTIONS(769),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(769),
    [anon_sym_BQUOTE] = ACTIONS(769),
    [anon_sym_LT_LPAREN] = ACTIONS(769),
    [anon_sym_GT_LPAREN] = ACTIONS(769),
    [sym_word] = ACTIONS(769),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(769),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
  },
  [546] = {
    [anon_sym_PIPE] = ACTIONS(1527),
    [anon_sym_RPAREN] = ACTIONS(1527),
    [anon_sym_SEMI_SEMI] = ACTIONS(1527),
    [anon_sym_PIPE_AMP] = ACTIONS(1527),
    [anon_sym_AMP_AMP] = ACTIONS(1527),
    [anon_sym_PIPE_PIPE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1527),
    [anon_sym_LF] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
  },
  [547] = {
    [anon_sym_then] = ACTIONS(1529),
    [sym_comment] = ACTIONS(133),
  },
  [548] = {
    [sym__terminated_statement] = STATE(126),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_fi] = ACTIONS(1531),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [549] = {
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_RPAREN] = ACTIONS(1533),
    [anon_sym_SEMI_SEMI] = ACTIONS(1533),
    [anon_sym_PIPE_AMP] = ACTIONS(1533),
    [anon_sym_AMP_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1533),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1533),
    [anon_sym_LF] = ACTIONS(1533),
    [anon_sym_AMP] = ACTIONS(1533),
  },
  [550] = {
    [anon_sym_fi] = ACTIONS(1535),
    [sym_comment] = ACTIONS(133),
  },
  [551] = {
    [sym_elif_clause] = STATE(552),
    [sym_else_clause] = STATE(719),
    [anon_sym_fi] = ACTIONS(1535),
    [anon_sym_elif] = ACTIONS(1137),
    [anon_sym_else] = ACTIONS(1139),
    [sym_comment] = ACTIONS(133),
  },
  [552] = {
    [anon_sym_fi] = ACTIONS(1537),
    [anon_sym_elif] = ACTIONS(1537),
    [anon_sym_else] = ACTIONS(1537),
    [sym_comment] = ACTIONS(133),
  },
  [553] = {
    [anon_sym_PIPE] = ACTIONS(1539),
    [anon_sym_RPAREN] = ACTIONS(1539),
    [anon_sym_SEMI_SEMI] = ACTIONS(1539),
    [anon_sym_PIPE_AMP] = ACTIONS(1539),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1539),
    [anon_sym_LF] = ACTIONS(1539),
    [anon_sym_AMP] = ACTIONS(1539),
  },
  [554] = {
    [aux_sym_case_item_repeat1] = STATE(722),
    [aux_sym_concatenation_repeat1] = STATE(305),
    [sym__concat] = ACTIONS(619),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_RPAREN] = ACTIONS(1543),
    [sym_comment] = ACTIONS(133),
  },
  [555] = {
    [anon_sym_esac] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [sym_raw_string] = ACTIONS(1547),
    [anon_sym_DOLLAR] = ACTIONS(1545),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1547),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1547),
    [anon_sym_BQUOTE] = ACTIONS(1547),
    [anon_sym_LT_LPAREN] = ACTIONS(1547),
    [anon_sym_GT_LPAREN] = ACTIONS(1547),
    [sym_word] = ACTIONS(1549),
    [sym_comment] = ACTIONS(133),
  },
  [556] = {
    [aux_sym_case_item_repeat1] = STATE(722),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_RPAREN] = ACTIONS(1543),
    [sym_comment] = ACTIONS(133),
  },
  [557] = {
    [sym_case_item] = STATE(724),
    [sym_concatenation] = STATE(556),
    [sym_string] = STATE(554),
    [sym_simple_expansion] = STATE(554),
    [sym_expansion] = STATE(554),
    [sym_command_substitution] = STATE(554),
    [sym_process_substitution] = STATE(554),
    [anon_sym_esac] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(315),
    [sym_raw_string] = ACTIONS(1143),
    [anon_sym_DOLLAR] = ACTIONS(319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(327),
    [anon_sym_GT_LPAREN] = ACTIONS(327),
    [sym_word] = ACTIONS(1145),
    [sym_comment] = ACTIONS(133),
  },
  [558] = {
    [sym_case_item] = STATE(555),
    [sym_concatenation] = STATE(556),
    [sym_string] = STATE(554),
    [sym_simple_expansion] = STATE(554),
    [sym_expansion] = STATE(554),
    [sym_command_substitution] = STATE(554),
    [sym_process_substitution] = STATE(554),
    [aux_sym_case_statement_repeat1] = STATE(725),
    [anon_sym_esac] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(315),
    [sym_raw_string] = ACTIONS(1143),
    [anon_sym_DOLLAR] = ACTIONS(319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(327),
    [anon_sym_GT_LPAREN] = ACTIONS(327),
    [sym_word] = ACTIONS(1145),
    [sym_comment] = ACTIONS(133),
  },
  [559] = {
    [sym__concat] = ACTIONS(1257),
    [anon_sym_in] = ACTIONS(1259),
    [anon_sym_SEMI_SEMI] = ACTIONS(1259),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_LF] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1259),
  },
  [560] = {
    [sym__concat] = ACTIONS(1261),
    [anon_sym_in] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1263),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [561] = {
    [anon_sym_AT] = ACTIONS(1553),
    [sym_comment] = ACTIONS(133),
  },
  [562] = {
    [sym__concat] = ACTIONS(1267),
    [anon_sym_in] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1269),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_LF] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [563] = {
    [anon_sym_AT] = ACTIONS(1555),
    [sym_comment] = ACTIONS(133),
  },
  [564] = {
    [anon_sym_RBRACK] = ACTIONS(1557),
    [sym_comment] = ACTIONS(133),
  },
  [565] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(1559),
    [sym_comment] = ACTIONS(133),
  },
  [566] = {
    [anon_sym_RBRACE] = ACTIONS(1559),
    [sym_comment] = ACTIONS(133),
  },
  [567] = {
    [anon_sym_RBRACK] = ACTIONS(1561),
    [sym_comment] = ACTIONS(133),
  },
  [568] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(1563),
    [sym_comment] = ACTIONS(133),
  },
  [569] = {
    [anon_sym_RBRACE] = ACTIONS(1563),
    [sym_comment] = ACTIONS(133),
  },
  [570] = {
    [anon_sym_PIPE] = ACTIONS(1565),
    [anon_sym_RPAREN] = ACTIONS(1565),
    [anon_sym_SEMI_SEMI] = ACTIONS(1565),
    [anon_sym_PIPE_AMP] = ACTIONS(1565),
    [anon_sym_AMP_AMP] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE] = ACTIONS(1565),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1565),
    [anon_sym_LF] = ACTIONS(1565),
    [anon_sym_AMP] = ACTIONS(1565),
  },
  [571] = {
    [anon_sym_PIPE] = ACTIONS(1567),
    [anon_sym_RPAREN] = ACTIONS(1567),
    [anon_sym_SEMI_SEMI] = ACTIONS(1567),
    [anon_sym_PIPE_AMP] = ACTIONS(1567),
    [anon_sym_AMP_AMP] = ACTIONS(1567),
    [anon_sym_PIPE_PIPE] = ACTIONS(1567),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1567),
    [anon_sym_LF] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
  },
  [572] = {
    [sym__concat] = ACTIONS(1257),
    [anon_sym_RBRACE] = ACTIONS(1257),
    [anon_sym_RBRACK] = ACTIONS(1569),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1569),
    [anon_sym_DQUOTE] = ACTIONS(1257),
    [sym_raw_string] = ACTIONS(1257),
    [anon_sym_DOLLAR] = ACTIONS(1569),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1257),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1257),
    [anon_sym_BQUOTE] = ACTIONS(1257),
    [anon_sym_LT_LPAREN] = ACTIONS(1257),
    [anon_sym_GT_LPAREN] = ACTIONS(1257),
    [sym_word] = ACTIONS(1259),
    [sym_comment] = ACTIONS(133),
  },
  [573] = {
    [sym__concat] = ACTIONS(1261),
    [anon_sym_RBRACE] = ACTIONS(1261),
    [anon_sym_RBRACK] = ACTIONS(1571),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1571),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1571),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [sym_word] = ACTIONS(1263),
    [sym_comment] = ACTIONS(133),
  },
  [574] = {
    [anon_sym_AT] = ACTIONS(1573),
    [sym_comment] = ACTIONS(133),
  },
  [575] = {
    [sym__concat] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(1267),
    [anon_sym_RBRACK] = ACTIONS(1575),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(1267),
    [sym_raw_string] = ACTIONS(1267),
    [anon_sym_DOLLAR] = ACTIONS(1575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1267),
    [anon_sym_BQUOTE] = ACTIONS(1267),
    [anon_sym_LT_LPAREN] = ACTIONS(1267),
    [anon_sym_GT_LPAREN] = ACTIONS(1267),
    [sym_word] = ACTIONS(1269),
    [sym_comment] = ACTIONS(133),
  },
  [576] = {
    [anon_sym_AT] = ACTIONS(1577),
    [sym_comment] = ACTIONS(133),
  },
  [577] = {
    [anon_sym_RBRACK] = ACTIONS(1579),
    [sym_comment] = ACTIONS(133),
  },
  [578] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(1581),
    [sym_comment] = ACTIONS(133),
  },
  [579] = {
    [anon_sym_RBRACE] = ACTIONS(1581),
    [sym_comment] = ACTIONS(133),
  },
  [580] = {
    [anon_sym_RBRACK] = ACTIONS(1583),
    [sym_comment] = ACTIONS(133),
  },
  [581] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(1585),
    [sym_comment] = ACTIONS(133),
  },
  [582] = {
    [anon_sym_RBRACE] = ACTIONS(1585),
    [sym_comment] = ACTIONS(133),
  },
  [583] = {
    [sym_file_descriptor] = ACTIONS(1257),
    [sym__concat] = ACTIONS(1257),
    [sym_variable_name] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1569),
    [anon_sym_RPAREN] = ACTIONS(1257),
    [anon_sym_PIPE_AMP] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1569),
    [anon_sym_LT] = ACTIONS(1569),
    [anon_sym_GT] = ACTIONS(1569),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_AMP_GT] = ACTIONS(1569),
    [anon_sym_AMP_GT_GT] = ACTIONS(1257),
    [anon_sym_LT_AMP] = ACTIONS(1257),
    [anon_sym_GT_AMP] = ACTIONS(1257),
    [anon_sym_DQUOTE] = ACTIONS(1257),
    [sym_raw_string] = ACTIONS(1257),
    [anon_sym_DOLLAR] = ACTIONS(1569),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1257),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1257),
    [anon_sym_BQUOTE] = ACTIONS(1257),
    [anon_sym_LT_LPAREN] = ACTIONS(1257),
    [anon_sym_GT_LPAREN] = ACTIONS(1257),
    [sym_word] = ACTIONS(1259),
    [sym_comment] = ACTIONS(133),
  },
  [584] = {
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1261),
    [sym_variable_name] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1571),
    [anon_sym_RPAREN] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1571),
    [anon_sym_LT] = ACTIONS(1571),
    [anon_sym_GT] = ACTIONS(1571),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1571),
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1571),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [sym_word] = ACTIONS(1263),
    [sym_comment] = ACTIONS(133),
  },
  [585] = {
    [anon_sym_AT] = ACTIONS(1587),
    [sym_comment] = ACTIONS(133),
  },
  [586] = {
    [sym_file_descriptor] = ACTIONS(1267),
    [sym__concat] = ACTIONS(1267),
    [sym_variable_name] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1575),
    [anon_sym_RPAREN] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1575),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT] = ACTIONS(1575),
    [anon_sym_AMP_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_AMP] = ACTIONS(1267),
    [anon_sym_GT_AMP] = ACTIONS(1267),
    [anon_sym_DQUOTE] = ACTIONS(1267),
    [sym_raw_string] = ACTIONS(1267),
    [anon_sym_DOLLAR] = ACTIONS(1575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1267),
    [anon_sym_BQUOTE] = ACTIONS(1267),
    [anon_sym_LT_LPAREN] = ACTIONS(1267),
    [anon_sym_GT_LPAREN] = ACTIONS(1267),
    [sym_word] = ACTIONS(1269),
    [sym_comment] = ACTIONS(133),
  },
  [587] = {
    [anon_sym_AT] = ACTIONS(1589),
    [sym_comment] = ACTIONS(133),
  },
  [588] = {
    [anon_sym_RBRACK] = ACTIONS(1591),
    [sym_comment] = ACTIONS(133),
  },
  [589] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(1593),
    [sym_comment] = ACTIONS(133),
  },
  [590] = {
    [anon_sym_RBRACE] = ACTIONS(1593),
    [sym_comment] = ACTIONS(133),
  },
  [591] = {
    [anon_sym_RBRACK] = ACTIONS(1595),
    [sym_comment] = ACTIONS(133),
  },
  [592] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [sym_comment] = ACTIONS(133),
  },
  [593] = {
    [anon_sym_RBRACE] = ACTIONS(1597),
    [sym_comment] = ACTIONS(133),
  },
  [594] = {
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(1571),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1263),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1263),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [sym_comment] = ACTIONS(85),
  },
  [595] = {
    [anon_sym_AT] = ACTIONS(1599),
    [sym_comment] = ACTIONS(133),
  },
  [596] = {
    [anon_sym_DQUOTE] = ACTIONS(1269),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(1575),
    [anon_sym_DOLLAR] = ACTIONS(1269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1269),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1269),
    [anon_sym_BQUOTE] = ACTIONS(1269),
    [sym_comment] = ACTIONS(85),
  },
  [597] = {
    [anon_sym_AT] = ACTIONS(1601),
    [sym_comment] = ACTIONS(133),
  },
  [598] = {
    [anon_sym_RBRACK] = ACTIONS(1603),
    [sym_comment] = ACTIONS(133),
  },
  [599] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(1605),
    [sym_comment] = ACTIONS(133),
  },
  [600] = {
    [anon_sym_RBRACE] = ACTIONS(1605),
    [sym_comment] = ACTIONS(133),
  },
  [601] = {
    [anon_sym_RBRACK] = ACTIONS(1607),
    [sym_comment] = ACTIONS(133),
  },
  [602] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(1609),
    [sym_comment] = ACTIONS(133),
  },
  [603] = {
    [anon_sym_RBRACE] = ACTIONS(1609),
    [sym_comment] = ACTIONS(133),
  },
  [604] = {
    [anon_sym_RBRACK] = ACTIONS(1611),
    [sym_comment] = ACTIONS(133),
  },
  [605] = {
    [anon_sym_RBRACK] = ACTIONS(1613),
    [sym_comment] = ACTIONS(133),
  },
  [606] = {
    [anon_sym_RBRACE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(133),
  },
  [607] = {
    [sym_file_descriptor] = ACTIONS(1617),
    [sym__concat] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1619),
    [anon_sym_RPAREN] = ACTIONS(1619),
    [anon_sym_SEMI_SEMI] = ACTIONS(1619),
    [anon_sym_PIPE_AMP] = ACTIONS(1619),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE_PIPE] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(1619),
    [anon_sym_GT_GT] = ACTIONS(1619),
    [anon_sym_AMP_GT] = ACTIONS(1619),
    [anon_sym_AMP_GT_GT] = ACTIONS(1619),
    [anon_sym_LT_AMP] = ACTIONS(1619),
    [anon_sym_GT_AMP] = ACTIONS(1619),
    [anon_sym_LT_LT] = ACTIONS(1619),
    [anon_sym_LT_LT_DASH] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1619),
    [sym_raw_string] = ACTIONS(1619),
    [anon_sym_DOLLAR] = ACTIONS(1619),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1619),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1619),
    [anon_sym_BQUOTE] = ACTIONS(1619),
    [anon_sym_LT_LPAREN] = ACTIONS(1619),
    [anon_sym_GT_LPAREN] = ACTIONS(1619),
    [sym_word] = ACTIONS(1619),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1619),
    [anon_sym_LF] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
  },
  [608] = {
    [anon_sym_RBRACE] = ACTIONS(1621),
    [sym_comment] = ACTIONS(133),
  },
  [609] = {
    [sym_file_descriptor] = ACTIONS(1623),
    [sym__concat] = ACTIONS(1623),
    [anon_sym_PIPE] = ACTIONS(1625),
    [anon_sym_RPAREN] = ACTIONS(1625),
    [anon_sym_SEMI_SEMI] = ACTIONS(1625),
    [anon_sym_PIPE_AMP] = ACTIONS(1625),
    [anon_sym_AMP_AMP] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1625),
    [anon_sym_GT] = ACTIONS(1625),
    [anon_sym_GT_GT] = ACTIONS(1625),
    [anon_sym_AMP_GT] = ACTIONS(1625),
    [anon_sym_AMP_GT_GT] = ACTIONS(1625),
    [anon_sym_LT_AMP] = ACTIONS(1625),
    [anon_sym_GT_AMP] = ACTIONS(1625),
    [anon_sym_LT_LT] = ACTIONS(1625),
    [anon_sym_LT_LT_DASH] = ACTIONS(1625),
    [anon_sym_DQUOTE] = ACTIONS(1625),
    [sym_raw_string] = ACTIONS(1625),
    [anon_sym_DOLLAR] = ACTIONS(1625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1625),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1625),
    [anon_sym_BQUOTE] = ACTIONS(1625),
    [anon_sym_LT_LPAREN] = ACTIONS(1625),
    [anon_sym_GT_LPAREN] = ACTIONS(1625),
    [sym_word] = ACTIONS(1625),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_LF] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
  },
  [610] = {
    [sym_file_descriptor] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1627),
    [anon_sym_RPAREN] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1627),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1627),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1051),
    [anon_sym_BQUOTE] = ACTIONS(1051),
    [anon_sym_LT_LPAREN] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1051),
    [sym_word] = ACTIONS(1053),
    [sym_comment] = ACTIONS(133),
  },
  [611] = {
    [anon_sym_RPAREN] = ACTIONS(1629),
    [sym_word] = ACTIONS(1061),
    [sym_comment] = ACTIONS(133),
  },
  [612] = {
    [sym_concatenation] = STATE(545),
    [sym_string] = STATE(544),
    [sym_simple_expansion] = STATE(544),
    [sym_expansion] = STATE(544),
    [sym_command_substitution] = STATE(544),
    [sym_process_substitution] = STATE(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(1631),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1111),
    [anon_sym_DOLLAR] = ACTIONS(1113),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1115),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_LT_LPAREN] = ACTIONS(1121),
    [anon_sym_GT_LPAREN] = ACTIONS(1121),
    [sym_word] = ACTIONS(1111),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1631),
    [anon_sym_LF] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
  },
  [613] = {
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_RPAREN] = ACTIONS(1635),
    [anon_sym_PIPE_AMP] = ACTIONS(1635),
    [anon_sym_AMP_AMP] = ACTIONS(1635),
    [anon_sym_PIPE_PIPE] = ACTIONS(1635),
    [anon_sym_BQUOTE] = ACTIONS(1635),
    [sym_comment] = ACTIONS(133),
  },
  [614] = {
    [sym__terminated_statement] = STATE(126),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_done] = ACTIONS(1637),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [615] = {
    [anon_sym_PIPE] = ACTIONS(1639),
    [anon_sym_RPAREN] = ACTIONS(1641),
    [anon_sym_PIPE_AMP] = ACTIONS(1641),
    [anon_sym_AMP_AMP] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(1641),
    [anon_sym_BQUOTE] = ACTIONS(1641),
    [sym_comment] = ACTIONS(133),
  },
  [616] = {
    [anon_sym_fi] = ACTIONS(1643),
    [sym_comment] = ACTIONS(133),
  },
  [617] = {
    [sym__terminated_statement] = STATE(126),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_elif_clause] = STATE(351),
    [sym_else_clause] = STATE(758),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_if_statement_repeat1] = STATE(759),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_fi] = ACTIONS(1645),
    [anon_sym_elif] = ACTIONS(677),
    [anon_sym_else] = ACTIONS(679),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [618] = {
    [sym_elif_clause] = STATE(552),
    [sym_else_clause] = STATE(758),
    [anon_sym_fi] = ACTIONS(1643),
    [anon_sym_elif] = ACTIONS(1137),
    [anon_sym_else] = ACTIONS(1139),
    [sym_comment] = ACTIONS(133),
  },
  [619] = {
    [sym_case_item] = STATE(555),
    [sym_concatenation] = STATE(556),
    [sym_string] = STATE(554),
    [sym_simple_expansion] = STATE(554),
    [sym_expansion] = STATE(554),
    [sym_command_substitution] = STATE(554),
    [sym_process_substitution] = STATE(554),
    [aux_sym_case_statement_repeat1] = STATE(761),
    [anon_sym_esac] = ACTIONS(1647),
    [anon_sym_DQUOTE] = ACTIONS(315),
    [sym_raw_string] = ACTIONS(1143),
    [anon_sym_DOLLAR] = ACTIONS(319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(327),
    [anon_sym_GT_LPAREN] = ACTIONS(327),
    [sym_word] = ACTIONS(1145),
    [sym_comment] = ACTIONS(133),
  },
  [620] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1649),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1649),
    [anon_sym_LF] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
  },
  [621] = {
    [sym_compound_statement] = STATE(763),
    [anon_sym_LBRACE] = ACTIONS(1337),
    [sym_comment] = ACTIONS(133),
  },
  [622] = {
    [anon_sym_PIPE] = ACTIONS(1651),
    [anon_sym_RPAREN] = ACTIONS(1653),
    [anon_sym_PIPE_AMP] = ACTIONS(1653),
    [anon_sym_AMP_AMP] = ACTIONS(1653),
    [anon_sym_PIPE_PIPE] = ACTIONS(1653),
    [anon_sym_BQUOTE] = ACTIONS(1653),
    [sym_comment] = ACTIONS(133),
  },
  [623] = {
    [sym_file_descriptor] = ACTIONS(563),
    [sym_variable_name] = ACTIONS(563),
    [anon_sym_for] = ACTIONS(565),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(1655),
    [anon_sym_function] = ACTIONS(565),
    [anon_sym_LPAREN] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(565),
    [anon_sym_GT] = ACTIONS(565),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_AMP_GT] = ACTIONS(565),
    [anon_sym_AMP_GT_GT] = ACTIONS(563),
    [anon_sym_LT_AMP] = ACTIONS(563),
    [anon_sym_GT_AMP] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(563),
    [sym_raw_string] = ACTIONS(563),
    [anon_sym_DOLLAR] = ACTIONS(565),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(563),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(563),
    [anon_sym_BQUOTE] = ACTIONS(563),
    [anon_sym_LT_LPAREN] = ACTIONS(563),
    [anon_sym_GT_LPAREN] = ACTIONS(563),
    [sym_word] = ACTIONS(567),
    [sym_comment] = ACTIONS(133),
  },
  [624] = {
    [sym_file_descriptor] = ACTIONS(1257),
    [sym__concat] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1569),
    [anon_sym_RPAREN] = ACTIONS(1257),
    [anon_sym_PIPE_AMP] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1569),
    [anon_sym_LT] = ACTIONS(1569),
    [anon_sym_GT] = ACTIONS(1569),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_AMP_GT] = ACTIONS(1569),
    [anon_sym_AMP_GT_GT] = ACTIONS(1257),
    [anon_sym_LT_AMP] = ACTIONS(1257),
    [anon_sym_GT_AMP] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(1569),
    [anon_sym_LT_LT_DASH] = ACTIONS(1257),
    [anon_sym_DQUOTE] = ACTIONS(1257),
    [sym_raw_string] = ACTIONS(1257),
    [anon_sym_DOLLAR] = ACTIONS(1569),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1257),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1257),
    [anon_sym_BQUOTE] = ACTIONS(1257),
    [anon_sym_LT_LPAREN] = ACTIONS(1257),
    [anon_sym_GT_LPAREN] = ACTIONS(1257),
    [sym_word] = ACTIONS(1259),
    [sym_comment] = ACTIONS(133),
  },
  [625] = {
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1571),
    [anon_sym_RPAREN] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1571),
    [anon_sym_LT] = ACTIONS(1571),
    [anon_sym_GT] = ACTIONS(1571),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1571),
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1571),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1571),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [sym_word] = ACTIONS(1263),
    [sym_comment] = ACTIONS(133),
  },
  [626] = {
    [anon_sym_AT] = ACTIONS(1657),
    [sym_comment] = ACTIONS(133),
  },
  [627] = {
    [sym_file_descriptor] = ACTIONS(1267),
    [sym__concat] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1575),
    [anon_sym_RPAREN] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1575),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT] = ACTIONS(1575),
    [anon_sym_AMP_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_AMP] = ACTIONS(1267),
    [anon_sym_GT_AMP] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1575),
    [anon_sym_LT_LT_DASH] = ACTIONS(1267),
    [anon_sym_DQUOTE] = ACTIONS(1267),
    [sym_raw_string] = ACTIONS(1267),
    [anon_sym_DOLLAR] = ACTIONS(1575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1267),
    [anon_sym_BQUOTE] = ACTIONS(1267),
    [anon_sym_LT_LPAREN] = ACTIONS(1267),
    [anon_sym_GT_LPAREN] = ACTIONS(1267),
    [sym_word] = ACTIONS(1269),
    [sym_comment] = ACTIONS(133),
  },
  [628] = {
    [anon_sym_AT] = ACTIONS(1659),
    [sym_comment] = ACTIONS(133),
  },
  [629] = {
    [anon_sym_RBRACK] = ACTIONS(1661),
    [sym_comment] = ACTIONS(133),
  },
  [630] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(1663),
    [sym_comment] = ACTIONS(133),
  },
  [631] = {
    [anon_sym_RBRACE] = ACTIONS(1663),
    [sym_comment] = ACTIONS(133),
  },
  [632] = {
    [anon_sym_RBRACK] = ACTIONS(1665),
    [sym_comment] = ACTIONS(133),
  },
  [633] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(1667),
    [sym_comment] = ACTIONS(133),
  },
  [634] = {
    [anon_sym_RBRACE] = ACTIONS(1667),
    [sym_comment] = ACTIONS(133),
  },
  [635] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(772),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1669),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [636] = {
    [anon_sym_PIPE] = ACTIONS(1671),
    [anon_sym_RPAREN] = ACTIONS(1673),
    [anon_sym_PIPE_AMP] = ACTIONS(1673),
    [anon_sym_AMP_AMP] = ACTIONS(1673),
    [anon_sym_PIPE_PIPE] = ACTIONS(1673),
    [anon_sym_BQUOTE] = ACTIONS(1673),
    [sym_comment] = ACTIONS(133),
  },
  [637] = {
    [aux_sym_concatenation_repeat1] = STATE(642),
    [sym_file_descriptor] = ACTIONS(613),
    [sym__concat] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(615),
    [anon_sym_RPAREN] = ACTIONS(613),
    [anon_sym_PIPE_AMP] = ACTIONS(613),
    [anon_sym_AMP_AMP] = ACTIONS(613),
    [anon_sym_PIPE_PIPE] = ACTIONS(613),
    [anon_sym_LT] = ACTIONS(615),
    [anon_sym_GT] = ACTIONS(615),
    [anon_sym_GT_GT] = ACTIONS(613),
    [anon_sym_AMP_GT] = ACTIONS(615),
    [anon_sym_AMP_GT_GT] = ACTIONS(613),
    [anon_sym_LT_AMP] = ACTIONS(613),
    [anon_sym_GT_AMP] = ACTIONS(613),
    [anon_sym_LT_LT] = ACTIONS(615),
    [anon_sym_LT_LT_DASH] = ACTIONS(613),
    [anon_sym_BQUOTE] = ACTIONS(613),
    [sym_comment] = ACTIONS(133),
  },
  [638] = {
    [sym_file_descriptor] = ACTIONS(613),
    [anon_sym_PIPE] = ACTIONS(615),
    [anon_sym_RPAREN] = ACTIONS(613),
    [anon_sym_PIPE_AMP] = ACTIONS(613),
    [anon_sym_AMP_AMP] = ACTIONS(613),
    [anon_sym_PIPE_PIPE] = ACTIONS(613),
    [anon_sym_LT] = ACTIONS(615),
    [anon_sym_GT] = ACTIONS(615),
    [anon_sym_GT_GT] = ACTIONS(613),
    [anon_sym_AMP_GT] = ACTIONS(615),
    [anon_sym_AMP_GT_GT] = ACTIONS(613),
    [anon_sym_LT_AMP] = ACTIONS(613),
    [anon_sym_GT_AMP] = ACTIONS(613),
    [anon_sym_LT_LT] = ACTIONS(615),
    [anon_sym_LT_LT_DASH] = ACTIONS(613),
    [anon_sym_BQUOTE] = ACTIONS(613),
    [sym_comment] = ACTIONS(133),
  },
  [639] = {
    [sym_file_descriptor] = ACTIONS(427),
    [sym__concat] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(427),
    [anon_sym_PIPE_AMP] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_LT] = ACTIONS(725),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_AMP_GT] = ACTIONS(725),
    [anon_sym_AMP_GT_GT] = ACTIONS(427),
    [anon_sym_LT_AMP] = ACTIONS(427),
    [anon_sym_GT_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(725),
    [anon_sym_LT_LT_DASH] = ACTIONS(427),
    [anon_sym_BQUOTE] = ACTIONS(427),
    [sym_comment] = ACTIONS(133),
  },
  [640] = {
    [sym_simple_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [anon_sym_DQUOTE] = ACTIONS(1675),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(447),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [641] = {
    [sym_string] = STATE(774),
    [sym_simple_expansion] = STATE(774),
    [sym_expansion] = STATE(774),
    [sym_command_substitution] = STATE(774),
    [sym_process_substitution] = STATE(774),
    [anon_sym_DQUOTE] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(1677),
    [anon_sym_DOLLAR] = ACTIONS(935),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(937),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(941),
    [anon_sym_LT_LPAREN] = ACTIONS(943),
    [anon_sym_GT_LPAREN] = ACTIONS(943),
    [sym_word] = ACTIONS(1679),
    [sym_comment] = ACTIONS(133),
  },
  [642] = {
    [sym_file_descriptor] = ACTIONS(453),
    [sym__concat] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(735),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_PIPE_AMP] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(735),
    [anon_sym_GT] = ACTIONS(735),
    [anon_sym_GT_GT] = ACTIONS(453),
    [anon_sym_AMP_GT] = ACTIONS(735),
    [anon_sym_AMP_GT_GT] = ACTIONS(453),
    [anon_sym_LT_AMP] = ACTIONS(453),
    [anon_sym_GT_AMP] = ACTIONS(453),
    [anon_sym_LT_LT] = ACTIONS(735),
    [anon_sym_LT_LT_DASH] = ACTIONS(453),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_comment] = ACTIONS(133),
  },
  [643] = {
    [sym_file_descriptor] = ACTIONS(459),
    [sym__concat] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_RPAREN] = ACTIONS(459),
    [anon_sym_PIPE_AMP] = ACTIONS(459),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_GT_GT] = ACTIONS(459),
    [anon_sym_AMP_GT] = ACTIONS(471),
    [anon_sym_AMP_GT_GT] = ACTIONS(459),
    [anon_sym_LT_AMP] = ACTIONS(459),
    [anon_sym_GT_AMP] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_LT_LT_DASH] = ACTIONS(459),
    [anon_sym_BQUOTE] = ACTIONS(459),
    [sym_comment] = ACTIONS(133),
  },
  [644] = {
    [sym_file_descriptor] = ACTIONS(463),
    [sym__concat] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(463),
    [anon_sym_PIPE_AMP] = ACTIONS(463),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(463),
    [anon_sym_AMP_GT] = ACTIONS(737),
    [anon_sym_AMP_GT_GT] = ACTIONS(463),
    [anon_sym_LT_AMP] = ACTIONS(463),
    [anon_sym_GT_AMP] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_LT_LT_DASH] = ACTIONS(463),
    [anon_sym_BQUOTE] = ACTIONS(463),
    [sym_comment] = ACTIONS(133),
  },
  [645] = {
    [sym_file_descriptor] = ACTIONS(467),
    [sym__concat] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(739),
    [anon_sym_RPAREN] = ACTIONS(467),
    [anon_sym_PIPE_AMP] = ACTIONS(467),
    [anon_sym_AMP_AMP] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(739),
    [anon_sym_GT] = ACTIONS(739),
    [anon_sym_GT_GT] = ACTIONS(467),
    [anon_sym_AMP_GT] = ACTIONS(739),
    [anon_sym_AMP_GT_GT] = ACTIONS(467),
    [anon_sym_LT_AMP] = ACTIONS(467),
    [anon_sym_GT_AMP] = ACTIONS(467),
    [anon_sym_LT_LT] = ACTIONS(739),
    [anon_sym_LT_LT_DASH] = ACTIONS(467),
    [anon_sym_BQUOTE] = ACTIONS(467),
    [sym_comment] = ACTIONS(133),
  },
  [646] = {
    [sym_special_variable_name] = STATE(777),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(225),
    [anon_sym_AT] = ACTIONS(219),
    [anon_sym_COLON] = ACTIONS(471),
    [anon_sym_COLON_QMARK] = ACTIONS(459),
    [anon_sym_COLON_DASH] = ACTIONS(459),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(1683),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [647] = {
    [anon_sym_RBRACE] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1689),
    [anon_sym_COLON] = ACTIONS(1691),
    [anon_sym_COLON_QMARK] = ACTIONS(1689),
    [anon_sym_COLON_DASH] = ACTIONS(1689),
    [anon_sym_PERCENT] = ACTIONS(1689),
    [anon_sym_SLASH] = ACTIONS(1689),
    [sym_comment] = ACTIONS(133),
  },
  [648] = {
    [anon_sym_RBRACE] = ACTIONS(1693),
    [anon_sym_LBRACK] = ACTIONS(1695),
    [anon_sym_EQ] = ACTIONS(1697),
    [anon_sym_COLON] = ACTIONS(1699),
    [anon_sym_COLON_QMARK] = ACTIONS(1697),
    [anon_sym_COLON_DASH] = ACTIONS(1697),
    [anon_sym_PERCENT] = ACTIONS(1697),
    [anon_sym_SLASH] = ACTIONS(1697),
    [sym_comment] = ACTIONS(133),
  },
  [649] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(1701),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [650] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(1701),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [651] = {
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(1701),
    [sym_comment] = ACTIONS(133),
  },
  [652] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(1701),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [653] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [654] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [655] = {
    [sym_file_descriptor] = ACTIONS(1421),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_RPAREN] = ACTIONS(1421),
    [anon_sym_PIPE_AMP] = ACTIONS(1421),
    [anon_sym_AMP_AMP] = ACTIONS(1421),
    [anon_sym_PIPE_PIPE] = ACTIONS(1421),
    [anon_sym_LT] = ACTIONS(1705),
    [anon_sym_GT] = ACTIONS(1705),
    [anon_sym_GT_GT] = ACTIONS(1421),
    [anon_sym_AMP_GT] = ACTIONS(1705),
    [anon_sym_AMP_GT_GT] = ACTIONS(1421),
    [anon_sym_LT_AMP] = ACTIONS(1421),
    [anon_sym_GT_AMP] = ACTIONS(1421),
    [anon_sym_LT_LT] = ACTIONS(1705),
    [anon_sym_LT_LT_DASH] = ACTIONS(1421),
    [anon_sym_BQUOTE] = ACTIONS(1421),
    [sym_comment] = ACTIONS(133),
  },
  [656] = {
    [sym_simple_expansion] = STATE(679),
    [sym_expansion] = STATE(679),
    [sym__heredoc_middle] = ACTIONS(1435),
    [sym__heredoc_end] = ACTIONS(1707),
    [anon_sym_DOLLAR] = ACTIONS(1003),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1005),
    [sym_comment] = ACTIONS(133),
  },
  [657] = {
    [sym_file_redirect] = STATE(467),
    [sym_heredoc_redirect] = STATE(467),
    [sym_file_descriptor] = ACTIONS(527),
    [anon_sym_PIPE] = ACTIONS(1709),
    [anon_sym_RPAREN] = ACTIONS(1711),
    [anon_sym_PIPE_AMP] = ACTIONS(1711),
    [anon_sym_AMP_AMP] = ACTIONS(1711),
    [anon_sym_PIPE_PIPE] = ACTIONS(1711),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_GT_GT] = ACTIONS(535),
    [anon_sym_AMP_GT] = ACTIONS(533),
    [anon_sym_AMP_GT_GT] = ACTIONS(535),
    [anon_sym_LT_AMP] = ACTIONS(535),
    [anon_sym_GT_AMP] = ACTIONS(535),
    [anon_sym_LT_LT] = ACTIONS(537),
    [anon_sym_LT_LT_DASH] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [sym_comment] = ACTIONS(133),
  },
  [658] = {
    [anon_sym_PIPE] = ACTIONS(1713),
    [anon_sym_RPAREN] = ACTIONS(1713),
    [anon_sym_SEMI_SEMI] = ACTIONS(1713),
    [anon_sym_PIPE_AMP] = ACTIONS(1713),
    [anon_sym_AMP_AMP] = ACTIONS(1713),
    [anon_sym_PIPE_PIPE] = ACTIONS(1713),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1713),
    [anon_sym_LF] = ACTIONS(1713),
    [anon_sym_AMP] = ACTIONS(1713),
  },
  [659] = {
    [sym__terminated_statement] = STATE(126),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1715),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [660] = {
    [sym_file_descriptor] = ACTIONS(821),
    [sym__concat] = ACTIONS(821),
    [anon_sym_PIPE] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(823),
    [anon_sym_SEMI_SEMI] = ACTIONS(823),
    [anon_sym_PIPE_AMP] = ACTIONS(823),
    [anon_sym_AMP_AMP] = ACTIONS(823),
    [anon_sym_PIPE_PIPE] = ACTIONS(823),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(823),
    [anon_sym_GT_GT] = ACTIONS(823),
    [anon_sym_AMP_GT] = ACTIONS(823),
    [anon_sym_AMP_GT_GT] = ACTIONS(823),
    [anon_sym_LT_AMP] = ACTIONS(823),
    [anon_sym_GT_AMP] = ACTIONS(823),
    [anon_sym_LT_LT] = ACTIONS(823),
    [anon_sym_LT_LT_DASH] = ACTIONS(823),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_LF] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
  },
  [661] = {
    [sym_file_descriptor] = ACTIONS(829),
    [sym__concat] = ACTIONS(829),
    [anon_sym_PIPE] = ACTIONS(831),
    [anon_sym_RPAREN] = ACTIONS(831),
    [anon_sym_SEMI_SEMI] = ACTIONS(831),
    [anon_sym_PIPE_AMP] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(831),
    [anon_sym_GT_GT] = ACTIONS(831),
    [anon_sym_AMP_GT] = ACTIONS(831),
    [anon_sym_AMP_GT_GT] = ACTIONS(831),
    [anon_sym_LT_AMP] = ACTIONS(831),
    [anon_sym_GT_AMP] = ACTIONS(831),
    [anon_sym_LT_LT] = ACTIONS(831),
    [anon_sym_LT_LT_DASH] = ACTIONS(831),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(831),
    [anon_sym_LF] = ACTIONS(831),
    [anon_sym_AMP] = ACTIONS(831),
  },
  [662] = {
    [sym_string] = STATE(788),
    [sym_simple_expansion] = STATE(788),
    [sym_expansion] = STATE(788),
    [sym_command_substitution] = STATE(788),
    [sym_process_substitution] = STATE(788),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [sym_raw_string] = ACTIONS(1717),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(579),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(581),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_LT_LPAREN] = ACTIONS(585),
    [anon_sym_GT_LPAREN] = ACTIONS(585),
    [sym_word] = ACTIONS(1719),
    [sym_comment] = ACTIONS(133),
  },
  [663] = {
    [anon_sym_RBRACE] = ACTIONS(1721),
    [anon_sym_LBRACK] = ACTIONS(1723),
    [sym_comment] = ACTIONS(133),
  },
  [664] = {
    [anon_sym_RBRACE] = ACTIONS(1725),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [sym_comment] = ACTIONS(133),
  },
  [665] = {
    [sym_file_descriptor] = ACTIONS(845),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(847),
    [anon_sym_SEMI_SEMI] = ACTIONS(847),
    [anon_sym_PIPE_AMP] = ACTIONS(847),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_PIPE_PIPE] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(847),
    [anon_sym_AMP_GT] = ACTIONS(847),
    [anon_sym_AMP_GT_GT] = ACTIONS(847),
    [anon_sym_LT_AMP] = ACTIONS(847),
    [anon_sym_GT_AMP] = ACTIONS(847),
    [anon_sym_LT_LT] = ACTIONS(847),
    [anon_sym_LT_LT_DASH] = ACTIONS(847),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(847),
    [anon_sym_LF] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(847),
  },
  [666] = {
    [anon_sym_AT] = ACTIONS(1729),
    [sym_comment] = ACTIONS(133),
  },
  [667] = {
    [sym_concatenation] = STATE(795),
    [sym_string] = STATE(794),
    [sym_simple_expansion] = STATE(794),
    [sym_expansion] = STATE(794),
    [sym_command_substitution] = STATE(794),
    [sym_process_substitution] = STATE(794),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(1733),
    [sym_comment] = ACTIONS(133),
  },
  [668] = {
    [sym_file_descriptor] = ACTIONS(855),
    [sym__concat] = ACTIONS(855),
    [anon_sym_PIPE] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [anon_sym_PIPE_AMP] = ACTIONS(857),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_AMP_GT] = ACTIONS(857),
    [anon_sym_AMP_GT_GT] = ACTIONS(857),
    [anon_sym_LT_AMP] = ACTIONS(857),
    [anon_sym_GT_AMP] = ACTIONS(857),
    [anon_sym_LT_LT] = ACTIONS(857),
    [anon_sym_LT_LT_DASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
  },
  [669] = {
    [anon_sym_AT] = ACTIONS(1735),
    [sym_comment] = ACTIONS(133),
  },
  [670] = {
    [sym_concatenation] = STATE(798),
    [sym_string] = STATE(797),
    [sym_simple_expansion] = STATE(797),
    [sym_expansion] = STATE(797),
    [sym_command_substitution] = STATE(797),
    [sym_process_substitution] = STATE(797),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(1737),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(1739),
    [sym_comment] = ACTIONS(133),
  },
  [671] = {
    [sym_file_descriptor] = ACTIONS(923),
    [sym__concat] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_RPAREN] = ACTIONS(925),
    [anon_sym_SEMI_SEMI] = ACTIONS(925),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(925),
    [anon_sym_PIPE_PIPE] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_GT] = ACTIONS(925),
    [anon_sym_AMP_GT] = ACTIONS(925),
    [anon_sym_AMP_GT_GT] = ACTIONS(925),
    [anon_sym_LT_AMP] = ACTIONS(925),
    [anon_sym_GT_AMP] = ACTIONS(925),
    [anon_sym_LT_LT] = ACTIONS(925),
    [anon_sym_LT_LT_DASH] = ACTIONS(925),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(925),
    [anon_sym_LF] = ACTIONS(925),
    [anon_sym_AMP] = ACTIONS(925),
  },
  [672] = {
    [sym_file_descriptor] = ACTIONS(965),
    [sym__concat] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(967),
    [anon_sym_RPAREN] = ACTIONS(967),
    [anon_sym_SEMI_SEMI] = ACTIONS(967),
    [anon_sym_PIPE_AMP] = ACTIONS(967),
    [anon_sym_AMP_AMP] = ACTIONS(967),
    [anon_sym_PIPE_PIPE] = ACTIONS(967),
    [anon_sym_LT] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(967),
    [anon_sym_GT_GT] = ACTIONS(967),
    [anon_sym_AMP_GT] = ACTIONS(967),
    [anon_sym_AMP_GT_GT] = ACTIONS(967),
    [anon_sym_LT_AMP] = ACTIONS(967),
    [anon_sym_GT_AMP] = ACTIONS(967),
    [anon_sym_LT_LT] = ACTIONS(967),
    [anon_sym_LT_LT_DASH] = ACTIONS(967),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_LF] = ACTIONS(967),
    [anon_sym_AMP] = ACTIONS(967),
  },
  [673] = {
    [sym__heredoc_middle] = ACTIONS(459),
    [sym__heredoc_end] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(459),
    [sym_comment] = ACTIONS(133),
  },
  [674] = {
    [sym__heredoc_middle] = ACTIONS(463),
    [sym__heredoc_end] = ACTIONS(463),
    [anon_sym_DOLLAR] = ACTIONS(737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(463),
    [sym_comment] = ACTIONS(133),
  },
  [675] = {
    [sym__heredoc_middle] = ACTIONS(467),
    [sym__heredoc_end] = ACTIONS(467),
    [anon_sym_DOLLAR] = ACTIONS(739),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(467),
    [sym_comment] = ACTIONS(133),
  },
  [676] = {
    [sym_special_variable_name] = STATE(800),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(225),
    [anon_sym_AT] = ACTIONS(219),
    [anon_sym_COLON] = ACTIONS(471),
    [anon_sym_COLON_QMARK] = ACTIONS(459),
    [anon_sym_COLON_DASH] = ACTIONS(459),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(1741),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [677] = {
    [anon_sym_RBRACE] = ACTIONS(1743),
    [anon_sym_LBRACK] = ACTIONS(1745),
    [anon_sym_EQ] = ACTIONS(1747),
    [anon_sym_COLON] = ACTIONS(1749),
    [anon_sym_COLON_QMARK] = ACTIONS(1747),
    [anon_sym_COLON_DASH] = ACTIONS(1747),
    [anon_sym_PERCENT] = ACTIONS(1747),
    [anon_sym_SLASH] = ACTIONS(1747),
    [sym_comment] = ACTIONS(133),
  },
  [678] = {
    [anon_sym_RBRACE] = ACTIONS(1751),
    [anon_sym_LBRACK] = ACTIONS(1753),
    [anon_sym_EQ] = ACTIONS(1755),
    [anon_sym_COLON] = ACTIONS(1757),
    [anon_sym_COLON_QMARK] = ACTIONS(1755),
    [anon_sym_COLON_DASH] = ACTIONS(1755),
    [anon_sym_PERCENT] = ACTIONS(1755),
    [anon_sym_SLASH] = ACTIONS(1755),
    [sym_comment] = ACTIONS(133),
  },
  [679] = {
    [sym__heredoc_middle] = ACTIONS(1759),
    [sym__heredoc_end] = ACTIONS(1759),
    [anon_sym_DOLLAR] = ACTIONS(1761),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1759),
    [sym_comment] = ACTIONS(133),
  },
  [680] = {
    [sym_file_descriptor] = ACTIONS(1763),
    [anon_sym_PIPE] = ACTIONS(1765),
    [anon_sym_RPAREN] = ACTIONS(1765),
    [anon_sym_SEMI_SEMI] = ACTIONS(1765),
    [anon_sym_PIPE_AMP] = ACTIONS(1765),
    [anon_sym_AMP_AMP] = ACTIONS(1765),
    [anon_sym_PIPE_PIPE] = ACTIONS(1765),
    [anon_sym_LT] = ACTIONS(1765),
    [anon_sym_GT] = ACTIONS(1765),
    [anon_sym_GT_GT] = ACTIONS(1765),
    [anon_sym_AMP_GT] = ACTIONS(1765),
    [anon_sym_AMP_GT_GT] = ACTIONS(1765),
    [anon_sym_LT_AMP] = ACTIONS(1765),
    [anon_sym_GT_AMP] = ACTIONS(1765),
    [anon_sym_LT_LT] = ACTIONS(1765),
    [anon_sym_LT_LT_DASH] = ACTIONS(1765),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1765),
    [anon_sym_LF] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
  },
  [681] = {
    [sym__concat] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_RPAREN] = ACTIONS(1257),
    [anon_sym_RBRACK] = ACTIONS(1257),
    [sym_comment] = ACTIONS(133),
  },
  [682] = {
    [sym__concat] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1261),
    [anon_sym_RPAREN] = ACTIONS(1261),
    [anon_sym_RBRACK] = ACTIONS(1261),
    [sym_comment] = ACTIONS(133),
  },
  [683] = {
    [anon_sym_AT] = ACTIONS(1767),
    [sym_comment] = ACTIONS(133),
  },
  [684] = {
    [sym__concat] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_RPAREN] = ACTIONS(1267),
    [anon_sym_RBRACK] = ACTIONS(1267),
    [sym_comment] = ACTIONS(133),
  },
  [685] = {
    [anon_sym_AT] = ACTIONS(1769),
    [sym_comment] = ACTIONS(133),
  },
  [686] = {
    [anon_sym_RBRACK] = ACTIONS(1771),
    [sym_comment] = ACTIONS(133),
  },
  [687] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(1773),
    [sym_comment] = ACTIONS(133),
  },
  [688] = {
    [anon_sym_RBRACE] = ACTIONS(1773),
    [sym_comment] = ACTIONS(133),
  },
  [689] = {
    [anon_sym_RBRACK] = ACTIONS(1775),
    [sym_comment] = ACTIONS(133),
  },
  [690] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(1777),
    [sym_comment] = ACTIONS(133),
  },
  [691] = {
    [anon_sym_RBRACE] = ACTIONS(1777),
    [sym_comment] = ACTIONS(133),
  },
  [692] = {
    [sym_file_descriptor] = ACTIONS(1257),
    [sym__concat] = ACTIONS(1257),
    [sym_variable_name] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1259),
    [anon_sym_RPAREN] = ACTIONS(1259),
    [anon_sym_SEMI_SEMI] = ACTIONS(1259),
    [anon_sym_PIPE_AMP] = ACTIONS(1259),
    [anon_sym_AMP_AMP] = ACTIONS(1259),
    [anon_sym_PIPE_PIPE] = ACTIONS(1259),
    [anon_sym_LT] = ACTIONS(1259),
    [anon_sym_GT] = ACTIONS(1259),
    [anon_sym_GT_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT_GT] = ACTIONS(1259),
    [anon_sym_LT_AMP] = ACTIONS(1259),
    [anon_sym_GT_AMP] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1259),
    [sym_raw_string] = ACTIONS(1259),
    [anon_sym_DOLLAR] = ACTIONS(1259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1259),
    [anon_sym_BQUOTE] = ACTIONS(1259),
    [anon_sym_LT_LPAREN] = ACTIONS(1259),
    [anon_sym_GT_LPAREN] = ACTIONS(1259),
    [sym_word] = ACTIONS(1259),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_LF] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1259),
  },
  [693] = {
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1261),
    [sym_variable_name] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE_AMP] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1263),
    [anon_sym_LT_AMP] = ACTIONS(1263),
    [anon_sym_GT_AMP] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1263),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1263),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1263),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [anon_sym_LT_LPAREN] = ACTIONS(1263),
    [anon_sym_GT_LPAREN] = ACTIONS(1263),
    [sym_word] = ACTIONS(1263),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [694] = {
    [anon_sym_AT] = ACTIONS(1779),
    [sym_comment] = ACTIONS(133),
  },
  [695] = {
    [sym_file_descriptor] = ACTIONS(1267),
    [sym__concat] = ACTIONS(1267),
    [sym_variable_name] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_RPAREN] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE_AMP] = ACTIONS(1269),
    [anon_sym_AMP_AMP] = ACTIONS(1269),
    [anon_sym_PIPE_PIPE] = ACTIONS(1269),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1269),
    [anon_sym_LT_AMP] = ACTIONS(1269),
    [anon_sym_GT_AMP] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1269),
    [sym_raw_string] = ACTIONS(1269),
    [anon_sym_DOLLAR] = ACTIONS(1269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1269),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1269),
    [anon_sym_BQUOTE] = ACTIONS(1269),
    [anon_sym_LT_LPAREN] = ACTIONS(1269),
    [anon_sym_GT_LPAREN] = ACTIONS(1269),
    [sym_word] = ACTIONS(1269),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_LF] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [696] = {
    [anon_sym_AT] = ACTIONS(1781),
    [sym_comment] = ACTIONS(133),
  },
  [697] = {
    [anon_sym_RBRACK] = ACTIONS(1783),
    [sym_comment] = ACTIONS(133),
  },
  [698] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(1785),
    [sym_comment] = ACTIONS(133),
  },
  [699] = {
    [anon_sym_RBRACE] = ACTIONS(1785),
    [sym_comment] = ACTIONS(133),
  },
  [700] = {
    [anon_sym_RBRACK] = ACTIONS(1787),
    [sym_comment] = ACTIONS(133),
  },
  [701] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(1789),
    [sym_comment] = ACTIONS(133),
  },
  [702] = {
    [anon_sym_RBRACE] = ACTIONS(1789),
    [sym_comment] = ACTIONS(133),
  },
  [703] = {
    [sym__concat] = ACTIONS(821),
    [anon_sym_SEMI_SEMI] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(823),
    [sym_raw_string] = ACTIONS(823),
    [anon_sym_DOLLAR] = ACTIONS(823),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(823),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(823),
    [anon_sym_BQUOTE] = ACTIONS(823),
    [anon_sym_LT_LPAREN] = ACTIONS(823),
    [anon_sym_GT_LPAREN] = ACTIONS(823),
    [sym_word] = ACTIONS(823),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_LF] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
  },
  [704] = {
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI_SEMI] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(831),
    [sym_raw_string] = ACTIONS(831),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(831),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(831),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [anon_sym_LT_LPAREN] = ACTIONS(831),
    [anon_sym_GT_LPAREN] = ACTIONS(831),
    [sym_word] = ACTIONS(831),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(831),
    [anon_sym_LF] = ACTIONS(831),
    [anon_sym_AMP] = ACTIONS(831),
  },
  [705] = {
    [sym_string] = STATE(819),
    [sym_simple_expansion] = STATE(819),
    [sym_expansion] = STATE(819),
    [sym_command_substitution] = STATE(819),
    [sym_process_substitution] = STATE(819),
    [anon_sym_DQUOTE] = ACTIONS(655),
    [sym_raw_string] = ACTIONS(1791),
    [anon_sym_DOLLAR] = ACTIONS(659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(661),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(663),
    [anon_sym_BQUOTE] = ACTIONS(665),
    [anon_sym_LT_LPAREN] = ACTIONS(667),
    [anon_sym_GT_LPAREN] = ACTIONS(667),
    [sym_word] = ACTIONS(1793),
    [sym_comment] = ACTIONS(133),
  },
  [706] = {
    [anon_sym_RBRACE] = ACTIONS(1795),
    [anon_sym_LBRACK] = ACTIONS(1797),
    [sym_comment] = ACTIONS(133),
  },
  [707] = {
    [anon_sym_RBRACE] = ACTIONS(1799),
    [anon_sym_LBRACK] = ACTIONS(1801),
    [sym_comment] = ACTIONS(133),
  },
  [708] = {
    [sym__concat] = ACTIONS(845),
    [anon_sym_SEMI_SEMI] = ACTIONS(847),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [sym_raw_string] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(847),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(847),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(847),
    [anon_sym_GT_LPAREN] = ACTIONS(847),
    [sym_word] = ACTIONS(847),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(847),
    [anon_sym_LF] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(847),
  },
  [709] = {
    [anon_sym_AT] = ACTIONS(1803),
    [sym_comment] = ACTIONS(133),
  },
  [710] = {
    [sym_concatenation] = STATE(826),
    [sym_string] = STATE(825),
    [sym_simple_expansion] = STATE(825),
    [sym_expansion] = STATE(825),
    [sym_command_substitution] = STATE(825),
    [sym_process_substitution] = STATE(825),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(1805),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(1807),
    [sym_comment] = ACTIONS(133),
  },
  [711] = {
    [sym__concat] = ACTIONS(855),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(857),
    [sym_raw_string] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(857),
    [anon_sym_LT_LPAREN] = ACTIONS(857),
    [anon_sym_GT_LPAREN] = ACTIONS(857),
    [sym_word] = ACTIONS(857),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
  },
  [712] = {
    [anon_sym_AT] = ACTIONS(1809),
    [sym_comment] = ACTIONS(133),
  },
  [713] = {
    [sym_concatenation] = STATE(829),
    [sym_string] = STATE(828),
    [sym_simple_expansion] = STATE(828),
    [sym_expansion] = STATE(828),
    [sym_command_substitution] = STATE(828),
    [sym_process_substitution] = STATE(828),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(1811),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(1813),
    [sym_comment] = ACTIONS(133),
  },
  [714] = {
    [sym__concat] = ACTIONS(923),
    [anon_sym_SEMI_SEMI] = ACTIONS(925),
    [anon_sym_DQUOTE] = ACTIONS(925),
    [sym_raw_string] = ACTIONS(925),
    [anon_sym_DOLLAR] = ACTIONS(925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(925),
    [anon_sym_BQUOTE] = ACTIONS(925),
    [anon_sym_LT_LPAREN] = ACTIONS(925),
    [anon_sym_GT_LPAREN] = ACTIONS(925),
    [sym_word] = ACTIONS(925),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(925),
    [anon_sym_LF] = ACTIONS(925),
    [anon_sym_AMP] = ACTIONS(925),
  },
  [715] = {
    [sym__concat] = ACTIONS(965),
    [anon_sym_SEMI_SEMI] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(967),
    [sym_raw_string] = ACTIONS(967),
    [anon_sym_DOLLAR] = ACTIONS(967),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(967),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(967),
    [anon_sym_BQUOTE] = ACTIONS(967),
    [anon_sym_LT_LPAREN] = ACTIONS(967),
    [anon_sym_GT_LPAREN] = ACTIONS(967),
    [sym_word] = ACTIONS(967),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_LF] = ACTIONS(967),
    [anon_sym_AMP] = ACTIONS(967),
  },
  [716] = {
    [anon_sym_PIPE] = ACTIONS(1815),
    [anon_sym_RPAREN] = ACTIONS(1815),
    [anon_sym_SEMI_SEMI] = ACTIONS(1815),
    [anon_sym_PIPE_AMP] = ACTIONS(1815),
    [anon_sym_AMP_AMP] = ACTIONS(1815),
    [anon_sym_PIPE_PIPE] = ACTIONS(1815),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1815),
    [anon_sym_LF] = ACTIONS(1815),
    [anon_sym_AMP] = ACTIONS(1815),
  },
  [717] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(830),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_fi] = ACTIONS(1817),
    [anon_sym_elif] = ACTIONS(1817),
    [anon_sym_else] = ACTIONS(1817),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [718] = {
    [anon_sym_PIPE] = ACTIONS(1819),
    [anon_sym_RPAREN] = ACTIONS(1819),
    [anon_sym_SEMI_SEMI] = ACTIONS(1819),
    [anon_sym_PIPE_AMP] = ACTIONS(1819),
    [anon_sym_AMP_AMP] = ACTIONS(1819),
    [anon_sym_PIPE_PIPE] = ACTIONS(1819),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1819),
    [anon_sym_LF] = ACTIONS(1819),
    [anon_sym_AMP] = ACTIONS(1819),
  },
  [719] = {
    [anon_sym_fi] = ACTIONS(1821),
    [sym_comment] = ACTIONS(133),
  },
  [720] = {
    [sym_concatenation] = STATE(833),
    [sym_string] = STATE(832),
    [sym_simple_expansion] = STATE(832),
    [sym_expansion] = STATE(832),
    [sym_command_substitution] = STATE(832),
    [sym_process_substitution] = STATE(832),
    [anon_sym_DQUOTE] = ACTIONS(315),
    [sym_raw_string] = ACTIONS(1823),
    [anon_sym_DOLLAR] = ACTIONS(319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(327),
    [anon_sym_GT_LPAREN] = ACTIONS(327),
    [sym_word] = ACTIONS(1825),
    [sym_comment] = ACTIONS(133),
  },
  [721] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(835),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1827),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [722] = {
    [anon_sym_PIPE] = ACTIONS(1829),
    [anon_sym_RPAREN] = ACTIONS(1831),
    [sym_comment] = ACTIONS(133),
  },
  [723] = {
    [anon_sym_PIPE] = ACTIONS(1833),
    [anon_sym_RPAREN] = ACTIONS(1833),
    [anon_sym_SEMI_SEMI] = ACTIONS(1833),
    [anon_sym_PIPE_AMP] = ACTIONS(1833),
    [anon_sym_AMP_AMP] = ACTIONS(1833),
    [anon_sym_PIPE_PIPE] = ACTIONS(1833),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1833),
    [anon_sym_LF] = ACTIONS(1833),
    [anon_sym_AMP] = ACTIONS(1833),
  },
  [724] = {
    [anon_sym_esac] = ACTIONS(1835),
    [anon_sym_DQUOTE] = ACTIONS(1837),
    [sym_raw_string] = ACTIONS(1837),
    [anon_sym_DOLLAR] = ACTIONS(1835),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1837),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1837),
    [anon_sym_BQUOTE] = ACTIONS(1837),
    [anon_sym_LT_LPAREN] = ACTIONS(1837),
    [anon_sym_GT_LPAREN] = ACTIONS(1837),
    [sym_word] = ACTIONS(1839),
    [sym_comment] = ACTIONS(133),
  },
  [725] = {
    [sym_case_item] = STATE(724),
    [sym_concatenation] = STATE(556),
    [sym_string] = STATE(554),
    [sym_simple_expansion] = STATE(554),
    [sym_expansion] = STATE(554),
    [sym_command_substitution] = STATE(554),
    [sym_process_substitution] = STATE(554),
    [anon_sym_esac] = ACTIONS(1841),
    [anon_sym_DQUOTE] = ACTIONS(315),
    [sym_raw_string] = ACTIONS(1143),
    [anon_sym_DOLLAR] = ACTIONS(319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(327),
    [anon_sym_GT_LPAREN] = ACTIONS(327),
    [sym_word] = ACTIONS(1145),
    [sym_comment] = ACTIONS(133),
  },
  [726] = {
    [anon_sym_RBRACK] = ACTIONS(1843),
    [sym_comment] = ACTIONS(133),
  },
  [727] = {
    [anon_sym_RBRACK] = ACTIONS(1845),
    [sym_comment] = ACTIONS(133),
  },
  [728] = {
    [anon_sym_RBRACE] = ACTIONS(1847),
    [sym_comment] = ACTIONS(133),
  },
  [729] = {
    [sym__concat] = ACTIONS(1617),
    [anon_sym_in] = ACTIONS(1619),
    [anon_sym_SEMI_SEMI] = ACTIONS(1619),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1619),
    [anon_sym_LF] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
  },
  [730] = {
    [anon_sym_RBRACE] = ACTIONS(1849),
    [sym_comment] = ACTIONS(133),
  },
  [731] = {
    [sym__concat] = ACTIONS(1623),
    [anon_sym_in] = ACTIONS(1625),
    [anon_sym_SEMI_SEMI] = ACTIONS(1625),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_LF] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
  },
  [732] = {
    [anon_sym_RBRACK] = ACTIONS(1851),
    [sym_comment] = ACTIONS(133),
  },
  [733] = {
    [anon_sym_RBRACK] = ACTIONS(1853),
    [sym_comment] = ACTIONS(133),
  },
  [734] = {
    [anon_sym_RBRACE] = ACTIONS(1855),
    [sym_comment] = ACTIONS(133),
  },
  [735] = {
    [sym__concat] = ACTIONS(1617),
    [anon_sym_RBRACE] = ACTIONS(1617),
    [anon_sym_RBRACK] = ACTIONS(1857),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1857),
    [anon_sym_DQUOTE] = ACTIONS(1617),
    [sym_raw_string] = ACTIONS(1617),
    [anon_sym_DOLLAR] = ACTIONS(1857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1617),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1617),
    [anon_sym_BQUOTE] = ACTIONS(1617),
    [anon_sym_LT_LPAREN] = ACTIONS(1617),
    [anon_sym_GT_LPAREN] = ACTIONS(1617),
    [sym_word] = ACTIONS(1619),
    [sym_comment] = ACTIONS(133),
  },
  [736] = {
    [anon_sym_RBRACE] = ACTIONS(1859),
    [sym_comment] = ACTIONS(133),
  },
  [737] = {
    [sym__concat] = ACTIONS(1623),
    [anon_sym_RBRACE] = ACTIONS(1623),
    [anon_sym_RBRACK] = ACTIONS(1861),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1861),
    [anon_sym_DQUOTE] = ACTIONS(1623),
    [sym_raw_string] = ACTIONS(1623),
    [anon_sym_DOLLAR] = ACTIONS(1861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1623),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1623),
    [anon_sym_BQUOTE] = ACTIONS(1623),
    [anon_sym_LT_LPAREN] = ACTIONS(1623),
    [anon_sym_GT_LPAREN] = ACTIONS(1623),
    [sym_word] = ACTIONS(1625),
    [sym_comment] = ACTIONS(133),
  },
  [738] = {
    [anon_sym_RBRACK] = ACTIONS(1863),
    [sym_comment] = ACTIONS(133),
  },
  [739] = {
    [anon_sym_RBRACK] = ACTIONS(1865),
    [sym_comment] = ACTIONS(133),
  },
  [740] = {
    [anon_sym_RBRACE] = ACTIONS(1867),
    [sym_comment] = ACTIONS(133),
  },
  [741] = {
    [sym_file_descriptor] = ACTIONS(1617),
    [sym__concat] = ACTIONS(1617),
    [sym_variable_name] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1857),
    [anon_sym_RPAREN] = ACTIONS(1617),
    [anon_sym_PIPE_AMP] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1857),
    [anon_sym_LT] = ACTIONS(1857),
    [anon_sym_GT] = ACTIONS(1857),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_AMP_GT] = ACTIONS(1857),
    [anon_sym_AMP_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_AMP] = ACTIONS(1617),
    [anon_sym_GT_AMP] = ACTIONS(1617),
    [anon_sym_DQUOTE] = ACTIONS(1617),
    [sym_raw_string] = ACTIONS(1617),
    [anon_sym_DOLLAR] = ACTIONS(1857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1617),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1617),
    [anon_sym_BQUOTE] = ACTIONS(1617),
    [anon_sym_LT_LPAREN] = ACTIONS(1617),
    [anon_sym_GT_LPAREN] = ACTIONS(1617),
    [sym_word] = ACTIONS(1619),
    [sym_comment] = ACTIONS(133),
  },
  [742] = {
    [anon_sym_RBRACE] = ACTIONS(1869),
    [sym_comment] = ACTIONS(133),
  },
  [743] = {
    [sym_file_descriptor] = ACTIONS(1623),
    [sym__concat] = ACTIONS(1623),
    [sym_variable_name] = ACTIONS(1623),
    [anon_sym_PIPE] = ACTIONS(1861),
    [anon_sym_RPAREN] = ACTIONS(1623),
    [anon_sym_PIPE_AMP] = ACTIONS(1623),
    [anon_sym_AMP_AMP] = ACTIONS(1623),
    [anon_sym_PIPE_PIPE] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1861),
    [anon_sym_GT] = ACTIONS(1861),
    [anon_sym_GT_GT] = ACTIONS(1623),
    [anon_sym_AMP_GT] = ACTIONS(1861),
    [anon_sym_AMP_GT_GT] = ACTIONS(1623),
    [anon_sym_LT_AMP] = ACTIONS(1623),
    [anon_sym_GT_AMP] = ACTIONS(1623),
    [anon_sym_DQUOTE] = ACTIONS(1623),
    [sym_raw_string] = ACTIONS(1623),
    [anon_sym_DOLLAR] = ACTIONS(1861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1623),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1623),
    [anon_sym_BQUOTE] = ACTIONS(1623),
    [anon_sym_LT_LPAREN] = ACTIONS(1623),
    [anon_sym_GT_LPAREN] = ACTIONS(1623),
    [sym_word] = ACTIONS(1625),
    [sym_comment] = ACTIONS(133),
  },
  [744] = {
    [anon_sym_RBRACK] = ACTIONS(1871),
    [sym_comment] = ACTIONS(133),
  },
  [745] = {
    [anon_sym_RBRACK] = ACTIONS(1873),
    [sym_comment] = ACTIONS(133),
  },
  [746] = {
    [anon_sym_RBRACE] = ACTIONS(1875),
    [sym_comment] = ACTIONS(133),
  },
  [747] = {
    [anon_sym_DQUOTE] = ACTIONS(1619),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(1857),
    [anon_sym_DOLLAR] = ACTIONS(1619),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1619),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1619),
    [anon_sym_BQUOTE] = ACTIONS(1619),
    [sym_comment] = ACTIONS(85),
  },
  [748] = {
    [anon_sym_RBRACE] = ACTIONS(1877),
    [sym_comment] = ACTIONS(133),
  },
  [749] = {
    [anon_sym_DQUOTE] = ACTIONS(1625),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(1861),
    [anon_sym_DOLLAR] = ACTIONS(1625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1625),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1625),
    [anon_sym_BQUOTE] = ACTIONS(1625),
    [sym_comment] = ACTIONS(85),
  },
  [750] = {
    [anon_sym_RBRACE] = ACTIONS(1879),
    [sym_comment] = ACTIONS(133),
  },
  [751] = {
    [anon_sym_RBRACE] = ACTIONS(1881),
    [sym_comment] = ACTIONS(133),
  },
  [752] = {
    [sym_file_descriptor] = ACTIONS(1883),
    [sym__concat] = ACTIONS(1883),
    [anon_sym_PIPE] = ACTIONS(1885),
    [anon_sym_RPAREN] = ACTIONS(1885),
    [anon_sym_SEMI_SEMI] = ACTIONS(1885),
    [anon_sym_PIPE_AMP] = ACTIONS(1885),
    [anon_sym_AMP_AMP] = ACTIONS(1885),
    [anon_sym_PIPE_PIPE] = ACTIONS(1885),
    [anon_sym_LT] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1885),
    [anon_sym_GT_GT] = ACTIONS(1885),
    [anon_sym_AMP_GT] = ACTIONS(1885),
    [anon_sym_AMP_GT_GT] = ACTIONS(1885),
    [anon_sym_LT_AMP] = ACTIONS(1885),
    [anon_sym_GT_AMP] = ACTIONS(1885),
    [anon_sym_LT_LT] = ACTIONS(1885),
    [anon_sym_LT_LT_DASH] = ACTIONS(1885),
    [anon_sym_DQUOTE] = ACTIONS(1885),
    [sym_raw_string] = ACTIONS(1885),
    [anon_sym_DOLLAR] = ACTIONS(1885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1885),
    [anon_sym_BQUOTE] = ACTIONS(1885),
    [anon_sym_LT_LPAREN] = ACTIONS(1885),
    [anon_sym_GT_LPAREN] = ACTIONS(1885),
    [sym_word] = ACTIONS(1885),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1885),
    [anon_sym_LF] = ACTIONS(1885),
    [anon_sym_AMP] = ACTIONS(1885),
  },
  [753] = {
    [sym_file_descriptor] = ACTIONS(1887),
    [sym__concat] = ACTIONS(1887),
    [anon_sym_PIPE] = ACTIONS(1889),
    [anon_sym_RPAREN] = ACTIONS(1889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1889),
    [anon_sym_PIPE_AMP] = ACTIONS(1889),
    [anon_sym_AMP_AMP] = ACTIONS(1889),
    [anon_sym_PIPE_PIPE] = ACTIONS(1889),
    [anon_sym_LT] = ACTIONS(1889),
    [anon_sym_GT] = ACTIONS(1889),
    [anon_sym_GT_GT] = ACTIONS(1889),
    [anon_sym_AMP_GT] = ACTIONS(1889),
    [anon_sym_AMP_GT_GT] = ACTIONS(1889),
    [anon_sym_LT_AMP] = ACTIONS(1889),
    [anon_sym_GT_AMP] = ACTIONS(1889),
    [anon_sym_LT_LT] = ACTIONS(1889),
    [anon_sym_LT_LT_DASH] = ACTIONS(1889),
    [anon_sym_DQUOTE] = ACTIONS(1889),
    [sym_raw_string] = ACTIONS(1889),
    [anon_sym_DOLLAR] = ACTIONS(1889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1889),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [anon_sym_LT_LPAREN] = ACTIONS(1889),
    [anon_sym_GT_LPAREN] = ACTIONS(1889),
    [sym_word] = ACTIONS(1889),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1889),
    [anon_sym_LF] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
  },
  [754] = {
    [sym_file_descriptor] = ACTIONS(1465),
    [sym_variable_name] = ACTIONS(1465),
    [anon_sym_PIPE] = ACTIONS(1891),
    [anon_sym_RPAREN] = ACTIONS(1465),
    [anon_sym_PIPE_AMP] = ACTIONS(1465),
    [anon_sym_AMP_AMP] = ACTIONS(1465),
    [anon_sym_PIPE_PIPE] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_GT] = ACTIONS(1891),
    [anon_sym_GT_GT] = ACTIONS(1465),
    [anon_sym_AMP_GT] = ACTIONS(1891),
    [anon_sym_AMP_GT_GT] = ACTIONS(1465),
    [anon_sym_LT_AMP] = ACTIONS(1465),
    [anon_sym_GT_AMP] = ACTIONS(1465),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [sym_raw_string] = ACTIONS(1465),
    [anon_sym_DOLLAR] = ACTIONS(1891),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1465),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1465),
    [anon_sym_BQUOTE] = ACTIONS(1465),
    [anon_sym_LT_LPAREN] = ACTIONS(1465),
    [anon_sym_GT_LPAREN] = ACTIONS(1465),
    [sym_word] = ACTIONS(1467),
    [sym_comment] = ACTIONS(133),
  },
  [755] = {
    [sym_do_group] = STATE(857),
    [anon_sym_do] = ACTIONS(875),
    [sym_comment] = ACTIONS(133),
  },
  [756] = {
    [anon_sym_PIPE] = ACTIONS(1893),
    [anon_sym_RPAREN] = ACTIONS(1895),
    [anon_sym_PIPE_AMP] = ACTIONS(1895),
    [anon_sym_AMP_AMP] = ACTIONS(1895),
    [anon_sym_PIPE_PIPE] = ACTIONS(1895),
    [anon_sym_BQUOTE] = ACTIONS(1895),
    [sym_comment] = ACTIONS(133),
  },
  [757] = {
    [anon_sym_PIPE] = ACTIONS(1897),
    [anon_sym_RPAREN] = ACTIONS(1899),
    [anon_sym_PIPE_AMP] = ACTIONS(1899),
    [anon_sym_AMP_AMP] = ACTIONS(1899),
    [anon_sym_PIPE_PIPE] = ACTIONS(1899),
    [anon_sym_BQUOTE] = ACTIONS(1899),
    [sym_comment] = ACTIONS(133),
  },
  [758] = {
    [anon_sym_fi] = ACTIONS(1901),
    [sym_comment] = ACTIONS(133),
  },
  [759] = {
    [sym_elif_clause] = STATE(552),
    [sym_else_clause] = STATE(859),
    [anon_sym_fi] = ACTIONS(1901),
    [anon_sym_elif] = ACTIONS(1137),
    [anon_sym_else] = ACTIONS(1139),
    [sym_comment] = ACTIONS(133),
  },
  [760] = {
    [anon_sym_PIPE] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(1905),
    [anon_sym_PIPE_AMP] = ACTIONS(1905),
    [anon_sym_AMP_AMP] = ACTIONS(1905),
    [anon_sym_PIPE_PIPE] = ACTIONS(1905),
    [anon_sym_BQUOTE] = ACTIONS(1905),
    [sym_comment] = ACTIONS(133),
  },
  [761] = {
    [sym_case_item] = STATE(724),
    [sym_concatenation] = STATE(556),
    [sym_string] = STATE(554),
    [sym_simple_expansion] = STATE(554),
    [sym_expansion] = STATE(554),
    [sym_command_substitution] = STATE(554),
    [sym_process_substitution] = STATE(554),
    [anon_sym_esac] = ACTIONS(1907),
    [anon_sym_DQUOTE] = ACTIONS(315),
    [sym_raw_string] = ACTIONS(1143),
    [anon_sym_DOLLAR] = ACTIONS(319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(327),
    [anon_sym_GT_LPAREN] = ACTIONS(327),
    [sym_word] = ACTIONS(1145),
    [sym_comment] = ACTIONS(133),
  },
  [762] = {
    [sym_case_item] = STATE(555),
    [sym_concatenation] = STATE(556),
    [sym_string] = STATE(554),
    [sym_simple_expansion] = STATE(554),
    [sym_expansion] = STATE(554),
    [sym_command_substitution] = STATE(554),
    [sym_process_substitution] = STATE(554),
    [aux_sym_case_statement_repeat1] = STATE(861),
    [anon_sym_esac] = ACTIONS(1907),
    [anon_sym_DQUOTE] = ACTIONS(315),
    [sym_raw_string] = ACTIONS(1143),
    [anon_sym_DOLLAR] = ACTIONS(319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(327),
    [anon_sym_GT_LPAREN] = ACTIONS(327),
    [sym_word] = ACTIONS(1145),
    [sym_comment] = ACTIONS(133),
  },
  [763] = {
    [anon_sym_PIPE] = ACTIONS(1909),
    [anon_sym_RPAREN] = ACTIONS(1911),
    [anon_sym_PIPE_AMP] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_PIPE_PIPE] = ACTIONS(1911),
    [anon_sym_BQUOTE] = ACTIONS(1911),
    [sym_comment] = ACTIONS(133),
  },
  [764] = {
    [anon_sym_PIPE] = ACTIONS(1913),
    [anon_sym_RPAREN] = ACTIONS(1915),
    [anon_sym_PIPE_AMP] = ACTIONS(1915),
    [anon_sym_AMP_AMP] = ACTIONS(1915),
    [anon_sym_PIPE_PIPE] = ACTIONS(1915),
    [anon_sym_BQUOTE] = ACTIONS(1915),
    [sym_comment] = ACTIONS(133),
  },
  [765] = {
    [anon_sym_RBRACK] = ACTIONS(1917),
    [sym_comment] = ACTIONS(133),
  },
  [766] = {
    [anon_sym_RBRACK] = ACTIONS(1919),
    [sym_comment] = ACTIONS(133),
  },
  [767] = {
    [anon_sym_RBRACE] = ACTIONS(1921),
    [sym_comment] = ACTIONS(133),
  },
  [768] = {
    [sym_file_descriptor] = ACTIONS(1617),
    [sym__concat] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1857),
    [anon_sym_RPAREN] = ACTIONS(1617),
    [anon_sym_PIPE_AMP] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1857),
    [anon_sym_LT] = ACTIONS(1857),
    [anon_sym_GT] = ACTIONS(1857),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_AMP_GT] = ACTIONS(1857),
    [anon_sym_AMP_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_AMP] = ACTIONS(1617),
    [anon_sym_GT_AMP] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1857),
    [anon_sym_LT_LT_DASH] = ACTIONS(1617),
    [anon_sym_DQUOTE] = ACTIONS(1617),
    [sym_raw_string] = ACTIONS(1617),
    [anon_sym_DOLLAR] = ACTIONS(1857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1617),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1617),
    [anon_sym_BQUOTE] = ACTIONS(1617),
    [anon_sym_LT_LPAREN] = ACTIONS(1617),
    [anon_sym_GT_LPAREN] = ACTIONS(1617),
    [sym_word] = ACTIONS(1619),
    [sym_comment] = ACTIONS(133),
  },
  [769] = {
    [anon_sym_RBRACE] = ACTIONS(1923),
    [sym_comment] = ACTIONS(133),
  },
  [770] = {
    [sym_file_descriptor] = ACTIONS(1623),
    [sym__concat] = ACTIONS(1623),
    [anon_sym_PIPE] = ACTIONS(1861),
    [anon_sym_RPAREN] = ACTIONS(1623),
    [anon_sym_PIPE_AMP] = ACTIONS(1623),
    [anon_sym_AMP_AMP] = ACTIONS(1623),
    [anon_sym_PIPE_PIPE] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1861),
    [anon_sym_GT] = ACTIONS(1861),
    [anon_sym_GT_GT] = ACTIONS(1623),
    [anon_sym_AMP_GT] = ACTIONS(1861),
    [anon_sym_AMP_GT_GT] = ACTIONS(1623),
    [anon_sym_LT_AMP] = ACTIONS(1623),
    [anon_sym_GT_AMP] = ACTIONS(1623),
    [anon_sym_LT_LT] = ACTIONS(1861),
    [anon_sym_LT_LT_DASH] = ACTIONS(1623),
    [anon_sym_DQUOTE] = ACTIONS(1623),
    [sym_raw_string] = ACTIONS(1623),
    [anon_sym_DOLLAR] = ACTIONS(1861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1623),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1623),
    [anon_sym_BQUOTE] = ACTIONS(1623),
    [anon_sym_LT_LPAREN] = ACTIONS(1623),
    [anon_sym_GT_LPAREN] = ACTIONS(1623),
    [sym_word] = ACTIONS(1625),
    [sym_comment] = ACTIONS(133),
  },
  [771] = {
    [anon_sym_PIPE] = ACTIONS(1925),
    [anon_sym_RPAREN] = ACTIONS(1927),
    [anon_sym_PIPE_AMP] = ACTIONS(1927),
    [anon_sym_AMP_AMP] = ACTIONS(1927),
    [anon_sym_PIPE_PIPE] = ACTIONS(1927),
    [anon_sym_BQUOTE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(133),
  },
  [772] = {
    [sym__terminated_statement] = STATE(126),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(1929),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [773] = {
    [sym_file_descriptor] = ACTIONS(821),
    [sym__concat] = ACTIONS(821),
    [anon_sym_PIPE] = ACTIONS(1177),
    [anon_sym_RPAREN] = ACTIONS(821),
    [anon_sym_PIPE_AMP] = ACTIONS(821),
    [anon_sym_AMP_AMP] = ACTIONS(821),
    [anon_sym_PIPE_PIPE] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(1177),
    [anon_sym_GT] = ACTIONS(1177),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_AMP_GT] = ACTIONS(1177),
    [anon_sym_AMP_GT_GT] = ACTIONS(821),
    [anon_sym_LT_AMP] = ACTIONS(821),
    [anon_sym_GT_AMP] = ACTIONS(821),
    [anon_sym_LT_LT] = ACTIONS(1177),
    [anon_sym_LT_LT_DASH] = ACTIONS(821),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [sym_comment] = ACTIONS(133),
  },
  [774] = {
    [sym_file_descriptor] = ACTIONS(829),
    [sym__concat] = ACTIONS(829),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_RPAREN] = ACTIONS(829),
    [anon_sym_PIPE_AMP] = ACTIONS(829),
    [anon_sym_AMP_AMP] = ACTIONS(829),
    [anon_sym_PIPE_PIPE] = ACTIONS(829),
    [anon_sym_LT] = ACTIONS(1179),
    [anon_sym_GT] = ACTIONS(1179),
    [anon_sym_GT_GT] = ACTIONS(829),
    [anon_sym_AMP_GT] = ACTIONS(1179),
    [anon_sym_AMP_GT_GT] = ACTIONS(829),
    [anon_sym_LT_AMP] = ACTIONS(829),
    [anon_sym_GT_AMP] = ACTIONS(829),
    [anon_sym_LT_LT] = ACTIONS(1179),
    [anon_sym_LT_LT_DASH] = ACTIONS(829),
    [anon_sym_BQUOTE] = ACTIONS(829),
    [sym_comment] = ACTIONS(133),
  },
  [775] = {
    [sym_string] = STATE(867),
    [sym_simple_expansion] = STATE(867),
    [sym_expansion] = STATE(867),
    [sym_command_substitution] = STATE(867),
    [sym_process_substitution] = STATE(867),
    [anon_sym_DQUOTE] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(1931),
    [anon_sym_DOLLAR] = ACTIONS(935),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(937),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(941),
    [anon_sym_LT_LPAREN] = ACTIONS(943),
    [anon_sym_GT_LPAREN] = ACTIONS(943),
    [sym_word] = ACTIONS(1933),
    [sym_comment] = ACTIONS(133),
  },
  [776] = {
    [anon_sym_RBRACE] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(1937),
    [sym_comment] = ACTIONS(133),
  },
  [777] = {
    [anon_sym_RBRACE] = ACTIONS(1939),
    [anon_sym_LBRACK] = ACTIONS(1941),
    [sym_comment] = ACTIONS(133),
  },
  [778] = {
    [sym_file_descriptor] = ACTIONS(845),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(1193),
    [anon_sym_RPAREN] = ACTIONS(845),
    [anon_sym_PIPE_AMP] = ACTIONS(845),
    [anon_sym_AMP_AMP] = ACTIONS(845),
    [anon_sym_PIPE_PIPE] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_GT_GT] = ACTIONS(845),
    [anon_sym_AMP_GT] = ACTIONS(1193),
    [anon_sym_AMP_GT_GT] = ACTIONS(845),
    [anon_sym_LT_AMP] = ACTIONS(845),
    [anon_sym_GT_AMP] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(1193),
    [anon_sym_LT_LT_DASH] = ACTIONS(845),
    [anon_sym_BQUOTE] = ACTIONS(845),
    [sym_comment] = ACTIONS(133),
  },
  [779] = {
    [anon_sym_AT] = ACTIONS(1943),
    [sym_comment] = ACTIONS(133),
  },
  [780] = {
    [sym_concatenation] = STATE(874),
    [sym_string] = STATE(873),
    [sym_simple_expansion] = STATE(873),
    [sym_expansion] = STATE(873),
    [sym_command_substitution] = STATE(873),
    [sym_process_substitution] = STATE(873),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(1945),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(1947),
    [sym_comment] = ACTIONS(133),
  },
  [781] = {
    [sym_file_descriptor] = ACTIONS(855),
    [sym__concat] = ACTIONS(855),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_RPAREN] = ACTIONS(855),
    [anon_sym_PIPE_AMP] = ACTIONS(855),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_PIPE_PIPE] = ACTIONS(855),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_GT_GT] = ACTIONS(855),
    [anon_sym_AMP_GT] = ACTIONS(1201),
    [anon_sym_AMP_GT_GT] = ACTIONS(855),
    [anon_sym_LT_AMP] = ACTIONS(855),
    [anon_sym_GT_AMP] = ACTIONS(855),
    [anon_sym_LT_LT] = ACTIONS(1201),
    [anon_sym_LT_LT_DASH] = ACTIONS(855),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_comment] = ACTIONS(133),
  },
  [782] = {
    [anon_sym_AT] = ACTIONS(1949),
    [sym_comment] = ACTIONS(133),
  },
  [783] = {
    [sym_concatenation] = STATE(877),
    [sym_string] = STATE(876),
    [sym_simple_expansion] = STATE(876),
    [sym_expansion] = STATE(876),
    [sym_command_substitution] = STATE(876),
    [sym_process_substitution] = STATE(876),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(1951),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(1953),
    [sym_comment] = ACTIONS(133),
  },
  [784] = {
    [sym_file_descriptor] = ACTIONS(923),
    [sym__concat] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_PIPE_AMP] = ACTIONS(923),
    [anon_sym_AMP_AMP] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(923),
    [anon_sym_LT] = ACTIONS(1209),
    [anon_sym_GT] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_AMP_GT] = ACTIONS(1209),
    [anon_sym_AMP_GT_GT] = ACTIONS(923),
    [anon_sym_LT_AMP] = ACTIONS(923),
    [anon_sym_GT_AMP] = ACTIONS(923),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_LT_LT_DASH] = ACTIONS(923),
    [anon_sym_BQUOTE] = ACTIONS(923),
    [sym_comment] = ACTIONS(133),
  },
  [785] = {
    [sym_file_descriptor] = ACTIONS(965),
    [sym__concat] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(1211),
    [anon_sym_RPAREN] = ACTIONS(965),
    [anon_sym_PIPE_AMP] = ACTIONS(965),
    [anon_sym_AMP_AMP] = ACTIONS(965),
    [anon_sym_PIPE_PIPE] = ACTIONS(965),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_GT] = ACTIONS(1211),
    [anon_sym_GT_GT] = ACTIONS(965),
    [anon_sym_AMP_GT] = ACTIONS(1211),
    [anon_sym_AMP_GT_GT] = ACTIONS(965),
    [anon_sym_LT_AMP] = ACTIONS(965),
    [anon_sym_GT_AMP] = ACTIONS(965),
    [anon_sym_LT_LT] = ACTIONS(1211),
    [anon_sym_LT_LT_DASH] = ACTIONS(965),
    [anon_sym_BQUOTE] = ACTIONS(965),
    [sym_comment] = ACTIONS(133),
  },
  [786] = {
    [sym_file_descriptor] = ACTIONS(1763),
    [anon_sym_PIPE] = ACTIONS(1955),
    [anon_sym_RPAREN] = ACTIONS(1763),
    [anon_sym_PIPE_AMP] = ACTIONS(1763),
    [anon_sym_AMP_AMP] = ACTIONS(1763),
    [anon_sym_PIPE_PIPE] = ACTIONS(1763),
    [anon_sym_LT] = ACTIONS(1955),
    [anon_sym_GT] = ACTIONS(1955),
    [anon_sym_GT_GT] = ACTIONS(1763),
    [anon_sym_AMP_GT] = ACTIONS(1955),
    [anon_sym_AMP_GT_GT] = ACTIONS(1763),
    [anon_sym_LT_AMP] = ACTIONS(1763),
    [anon_sym_GT_AMP] = ACTIONS(1763),
    [anon_sym_LT_LT] = ACTIONS(1955),
    [anon_sym_LT_LT_DASH] = ACTIONS(1763),
    [anon_sym_BQUOTE] = ACTIONS(1763),
    [sym_comment] = ACTIONS(133),
  },
  [787] = {
    [anon_sym_PIPE] = ACTIONS(1957),
    [anon_sym_RPAREN] = ACTIONS(1957),
    [anon_sym_SEMI_SEMI] = ACTIONS(1957),
    [anon_sym_PIPE_AMP] = ACTIONS(1957),
    [anon_sym_AMP_AMP] = ACTIONS(1957),
    [anon_sym_PIPE_PIPE] = ACTIONS(1957),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1957),
    [anon_sym_LF] = ACTIONS(1957),
    [anon_sym_AMP] = ACTIONS(1957),
  },
  [788] = {
    [sym_file_descriptor] = ACTIONS(1257),
    [sym__concat] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1259),
    [anon_sym_RPAREN] = ACTIONS(1259),
    [anon_sym_SEMI_SEMI] = ACTIONS(1259),
    [anon_sym_PIPE_AMP] = ACTIONS(1259),
    [anon_sym_AMP_AMP] = ACTIONS(1259),
    [anon_sym_PIPE_PIPE] = ACTIONS(1259),
    [anon_sym_LT] = ACTIONS(1259),
    [anon_sym_GT] = ACTIONS(1259),
    [anon_sym_GT_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT_GT] = ACTIONS(1259),
    [anon_sym_LT_AMP] = ACTIONS(1259),
    [anon_sym_GT_AMP] = ACTIONS(1259),
    [anon_sym_LT_LT] = ACTIONS(1259),
    [anon_sym_LT_LT_DASH] = ACTIONS(1259),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_LF] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1259),
  },
  [789] = {
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE_AMP] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1263),
    [anon_sym_LT_AMP] = ACTIONS(1263),
    [anon_sym_GT_AMP] = ACTIONS(1263),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1263),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [790] = {
    [anon_sym_AT] = ACTIONS(1959),
    [sym_comment] = ACTIONS(133),
  },
  [791] = {
    [sym_file_descriptor] = ACTIONS(1267),
    [sym__concat] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_RPAREN] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE_AMP] = ACTIONS(1269),
    [anon_sym_AMP_AMP] = ACTIONS(1269),
    [anon_sym_PIPE_PIPE] = ACTIONS(1269),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1269),
    [anon_sym_LT_AMP] = ACTIONS(1269),
    [anon_sym_GT_AMP] = ACTIONS(1269),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1269),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_LF] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [792] = {
    [anon_sym_AT] = ACTIONS(1961),
    [sym_comment] = ACTIONS(133),
  },
  [793] = {
    [anon_sym_RBRACK] = ACTIONS(1963),
    [sym_comment] = ACTIONS(133),
  },
  [794] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(1965),
    [sym_comment] = ACTIONS(133),
  },
  [795] = {
    [anon_sym_RBRACE] = ACTIONS(1965),
    [sym_comment] = ACTIONS(133),
  },
  [796] = {
    [anon_sym_RBRACK] = ACTIONS(1967),
    [sym_comment] = ACTIONS(133),
  },
  [797] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(1969),
    [sym_comment] = ACTIONS(133),
  },
  [798] = {
    [anon_sym_RBRACE] = ACTIONS(1969),
    [sym_comment] = ACTIONS(133),
  },
  [799] = {
    [anon_sym_RBRACE] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(1973),
    [sym_comment] = ACTIONS(133),
  },
  [800] = {
    [anon_sym_RBRACE] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [sym_comment] = ACTIONS(133),
  },
  [801] = {
    [sym__heredoc_middle] = ACTIONS(845),
    [sym__heredoc_end] = ACTIONS(845),
    [anon_sym_DOLLAR] = ACTIONS(1193),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(845),
    [sym_comment] = ACTIONS(133),
  },
  [802] = {
    [anon_sym_AT] = ACTIONS(1979),
    [sym_comment] = ACTIONS(133),
  },
  [803] = {
    [sym_concatenation] = STATE(890),
    [sym_string] = STATE(889),
    [sym_simple_expansion] = STATE(889),
    [sym_expansion] = STATE(889),
    [sym_command_substitution] = STATE(889),
    [sym_process_substitution] = STATE(889),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(1981),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(1983),
    [sym_comment] = ACTIONS(133),
  },
  [804] = {
    [sym__heredoc_middle] = ACTIONS(855),
    [sym__heredoc_end] = ACTIONS(855),
    [anon_sym_DOLLAR] = ACTIONS(1201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(855),
    [sym_comment] = ACTIONS(133),
  },
  [805] = {
    [anon_sym_AT] = ACTIONS(1985),
    [sym_comment] = ACTIONS(133),
  },
  [806] = {
    [sym_concatenation] = STATE(893),
    [sym_string] = STATE(892),
    [sym_simple_expansion] = STATE(892),
    [sym_expansion] = STATE(892),
    [sym_command_substitution] = STATE(892),
    [sym_process_substitution] = STATE(892),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(1987),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(1989),
    [sym_comment] = ACTIONS(133),
  },
  [807] = {
    [anon_sym_RBRACK] = ACTIONS(1991),
    [sym_comment] = ACTIONS(133),
  },
  [808] = {
    [anon_sym_RBRACK] = ACTIONS(1993),
    [sym_comment] = ACTIONS(133),
  },
  [809] = {
    [anon_sym_RBRACE] = ACTIONS(1995),
    [sym_comment] = ACTIONS(133),
  },
  [810] = {
    [sym__concat] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_RPAREN] = ACTIONS(1617),
    [anon_sym_RBRACK] = ACTIONS(1617),
    [sym_comment] = ACTIONS(133),
  },
  [811] = {
    [anon_sym_RBRACE] = ACTIONS(1997),
    [sym_comment] = ACTIONS(133),
  },
  [812] = {
    [sym__concat] = ACTIONS(1623),
    [anon_sym_PIPE] = ACTIONS(1623),
    [anon_sym_RPAREN] = ACTIONS(1623),
    [anon_sym_RBRACK] = ACTIONS(1623),
    [sym_comment] = ACTIONS(133),
  },
  [813] = {
    [anon_sym_RBRACK] = ACTIONS(1999),
    [sym_comment] = ACTIONS(133),
  },
  [814] = {
    [anon_sym_RBRACK] = ACTIONS(2001),
    [sym_comment] = ACTIONS(133),
  },
  [815] = {
    [anon_sym_RBRACE] = ACTIONS(2003),
    [sym_comment] = ACTIONS(133),
  },
  [816] = {
    [sym_file_descriptor] = ACTIONS(1617),
    [sym__concat] = ACTIONS(1617),
    [sym_variable_name] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1619),
    [anon_sym_RPAREN] = ACTIONS(1619),
    [anon_sym_SEMI_SEMI] = ACTIONS(1619),
    [anon_sym_PIPE_AMP] = ACTIONS(1619),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE_PIPE] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(1619),
    [anon_sym_GT_GT] = ACTIONS(1619),
    [anon_sym_AMP_GT] = ACTIONS(1619),
    [anon_sym_AMP_GT_GT] = ACTIONS(1619),
    [anon_sym_LT_AMP] = ACTIONS(1619),
    [anon_sym_GT_AMP] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1619),
    [sym_raw_string] = ACTIONS(1619),
    [anon_sym_DOLLAR] = ACTIONS(1619),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1619),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1619),
    [anon_sym_BQUOTE] = ACTIONS(1619),
    [anon_sym_LT_LPAREN] = ACTIONS(1619),
    [anon_sym_GT_LPAREN] = ACTIONS(1619),
    [sym_word] = ACTIONS(1619),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1619),
    [anon_sym_LF] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
  },
  [817] = {
    [anon_sym_RBRACE] = ACTIONS(2005),
    [sym_comment] = ACTIONS(133),
  },
  [818] = {
    [sym_file_descriptor] = ACTIONS(1623),
    [sym__concat] = ACTIONS(1623),
    [sym_variable_name] = ACTIONS(1623),
    [anon_sym_PIPE] = ACTIONS(1625),
    [anon_sym_RPAREN] = ACTIONS(1625),
    [anon_sym_SEMI_SEMI] = ACTIONS(1625),
    [anon_sym_PIPE_AMP] = ACTIONS(1625),
    [anon_sym_AMP_AMP] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1625),
    [anon_sym_GT] = ACTIONS(1625),
    [anon_sym_GT_GT] = ACTIONS(1625),
    [anon_sym_AMP_GT] = ACTIONS(1625),
    [anon_sym_AMP_GT_GT] = ACTIONS(1625),
    [anon_sym_LT_AMP] = ACTIONS(1625),
    [anon_sym_GT_AMP] = ACTIONS(1625),
    [anon_sym_DQUOTE] = ACTIONS(1625),
    [sym_raw_string] = ACTIONS(1625),
    [anon_sym_DOLLAR] = ACTIONS(1625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1625),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1625),
    [anon_sym_BQUOTE] = ACTIONS(1625),
    [anon_sym_LT_LPAREN] = ACTIONS(1625),
    [anon_sym_GT_LPAREN] = ACTIONS(1625),
    [sym_word] = ACTIONS(1625),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_LF] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
  },
  [819] = {
    [sym__concat] = ACTIONS(1257),
    [anon_sym_SEMI_SEMI] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1259),
    [sym_raw_string] = ACTIONS(1259),
    [anon_sym_DOLLAR] = ACTIONS(1259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1259),
    [anon_sym_BQUOTE] = ACTIONS(1259),
    [anon_sym_LT_LPAREN] = ACTIONS(1259),
    [anon_sym_GT_LPAREN] = ACTIONS(1259),
    [sym_word] = ACTIONS(1259),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_LF] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1259),
  },
  [820] = {
    [sym__concat] = ACTIONS(1261),
    [anon_sym_SEMI_SEMI] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1263),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1263),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1263),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [anon_sym_LT_LPAREN] = ACTIONS(1263),
    [anon_sym_GT_LPAREN] = ACTIONS(1263),
    [sym_word] = ACTIONS(1263),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [821] = {
    [anon_sym_AT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(133),
  },
  [822] = {
    [sym__concat] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1269),
    [sym_raw_string] = ACTIONS(1269),
    [anon_sym_DOLLAR] = ACTIONS(1269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1269),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1269),
    [anon_sym_BQUOTE] = ACTIONS(1269),
    [anon_sym_LT_LPAREN] = ACTIONS(1269),
    [anon_sym_GT_LPAREN] = ACTIONS(1269),
    [sym_word] = ACTIONS(1269),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_LF] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [823] = {
    [anon_sym_AT] = ACTIONS(2009),
    [sym_comment] = ACTIONS(133),
  },
  [824] = {
    [anon_sym_RBRACK] = ACTIONS(2011),
    [sym_comment] = ACTIONS(133),
  },
  [825] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(2013),
    [sym_comment] = ACTIONS(133),
  },
  [826] = {
    [anon_sym_RBRACE] = ACTIONS(2013),
    [sym_comment] = ACTIONS(133),
  },
  [827] = {
    [anon_sym_RBRACK] = ACTIONS(2015),
    [sym_comment] = ACTIONS(133),
  },
  [828] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(2017),
    [sym_comment] = ACTIONS(133),
  },
  [829] = {
    [anon_sym_RBRACE] = ACTIONS(2017),
    [sym_comment] = ACTIONS(133),
  },
  [830] = {
    [sym__terminated_statement] = STATE(126),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_fi] = ACTIONS(2019),
    [anon_sym_elif] = ACTIONS(2019),
    [anon_sym_else] = ACTIONS(2019),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [831] = {
    [anon_sym_PIPE] = ACTIONS(2021),
    [anon_sym_RPAREN] = ACTIONS(2021),
    [anon_sym_SEMI_SEMI] = ACTIONS(2021),
    [anon_sym_PIPE_AMP] = ACTIONS(2021),
    [anon_sym_AMP_AMP] = ACTIONS(2021),
    [anon_sym_PIPE_PIPE] = ACTIONS(2021),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2021),
    [anon_sym_LF] = ACTIONS(2021),
    [anon_sym_AMP] = ACTIONS(2021),
  },
  [832] = {
    [aux_sym_concatenation_repeat1] = STATE(305),
    [sym__concat] = ACTIONS(619),
    [anon_sym_PIPE] = ACTIONS(2023),
    [anon_sym_RPAREN] = ACTIONS(2023),
    [sym_comment] = ACTIONS(133),
  },
  [833] = {
    [anon_sym_PIPE] = ACTIONS(2023),
    [anon_sym_RPAREN] = ACTIONS(2023),
    [sym_comment] = ACTIONS(133),
  },
  [834] = {
    [anon_sym_esac] = ACTIONS(2025),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [sym_raw_string] = ACTIONS(2027),
    [anon_sym_DOLLAR] = ACTIONS(2025),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2027),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2027),
    [anon_sym_BQUOTE] = ACTIONS(2027),
    [anon_sym_LT_LPAREN] = ACTIONS(2027),
    [anon_sym_GT_LPAREN] = ACTIONS(2027),
    [sym_word] = ACTIONS(2029),
    [sym_comment] = ACTIONS(133),
  },
  [835] = {
    [sym__terminated_statement] = STATE(126),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_SEMI_SEMI] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [836] = {
    [sym_concatenation] = STATE(910),
    [sym_string] = STATE(909),
    [sym_simple_expansion] = STATE(909),
    [sym_expansion] = STATE(909),
    [sym_command_substitution] = STATE(909),
    [sym_process_substitution] = STATE(909),
    [anon_sym_DQUOTE] = ACTIONS(315),
    [sym_raw_string] = ACTIONS(2033),
    [anon_sym_DOLLAR] = ACTIONS(319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(327),
    [anon_sym_GT_LPAREN] = ACTIONS(327),
    [sym_word] = ACTIONS(2035),
    [sym_comment] = ACTIONS(133),
  },
  [837] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(911),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_SEMI_SEMI] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [838] = {
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_RPAREN] = ACTIONS(2037),
    [anon_sym_SEMI_SEMI] = ACTIONS(2037),
    [anon_sym_PIPE_AMP] = ACTIONS(2037),
    [anon_sym_AMP_AMP] = ACTIONS(2037),
    [anon_sym_PIPE_PIPE] = ACTIONS(2037),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2037),
    [anon_sym_LF] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
  },
  [839] = {
    [anon_sym_RBRACE] = ACTIONS(2039),
    [sym_comment] = ACTIONS(133),
  },
  [840] = {
    [anon_sym_RBRACE] = ACTIONS(2041),
    [sym_comment] = ACTIONS(133),
  },
  [841] = {
    [sym__concat] = ACTIONS(1883),
    [anon_sym_in] = ACTIONS(1885),
    [anon_sym_SEMI_SEMI] = ACTIONS(1885),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1885),
    [anon_sym_LF] = ACTIONS(1885),
    [anon_sym_AMP] = ACTIONS(1885),
  },
  [842] = {
    [sym__concat] = ACTIONS(1887),
    [anon_sym_in] = ACTIONS(1889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1889),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1889),
    [anon_sym_LF] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
  },
  [843] = {
    [anon_sym_RBRACE] = ACTIONS(2043),
    [sym_comment] = ACTIONS(133),
  },
  [844] = {
    [anon_sym_RBRACE] = ACTIONS(2045),
    [sym_comment] = ACTIONS(133),
  },
  [845] = {
    [sym__concat] = ACTIONS(1883),
    [anon_sym_RBRACE] = ACTIONS(1883),
    [anon_sym_RBRACK] = ACTIONS(2047),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(1883),
    [sym_raw_string] = ACTIONS(1883),
    [anon_sym_DOLLAR] = ACTIONS(2047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1883),
    [anon_sym_BQUOTE] = ACTIONS(1883),
    [anon_sym_LT_LPAREN] = ACTIONS(1883),
    [anon_sym_GT_LPAREN] = ACTIONS(1883),
    [sym_word] = ACTIONS(1885),
    [sym_comment] = ACTIONS(133),
  },
  [846] = {
    [sym__concat] = ACTIONS(1887),
    [anon_sym_RBRACE] = ACTIONS(1887),
    [anon_sym_RBRACK] = ACTIONS(2049),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2049),
    [anon_sym_DQUOTE] = ACTIONS(1887),
    [sym_raw_string] = ACTIONS(1887),
    [anon_sym_DOLLAR] = ACTIONS(2049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1887),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1887),
    [anon_sym_BQUOTE] = ACTIONS(1887),
    [anon_sym_LT_LPAREN] = ACTIONS(1887),
    [anon_sym_GT_LPAREN] = ACTIONS(1887),
    [sym_word] = ACTIONS(1889),
    [sym_comment] = ACTIONS(133),
  },
  [847] = {
    [anon_sym_RBRACE] = ACTIONS(2051),
    [sym_comment] = ACTIONS(133),
  },
  [848] = {
    [anon_sym_RBRACE] = ACTIONS(2053),
    [sym_comment] = ACTIONS(133),
  },
  [849] = {
    [sym_file_descriptor] = ACTIONS(1883),
    [sym__concat] = ACTIONS(1883),
    [sym_variable_name] = ACTIONS(1883),
    [anon_sym_PIPE] = ACTIONS(2047),
    [anon_sym_RPAREN] = ACTIONS(1883),
    [anon_sym_PIPE_AMP] = ACTIONS(1883),
    [anon_sym_AMP_AMP] = ACTIONS(1883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2047),
    [anon_sym_LT] = ACTIONS(2047),
    [anon_sym_GT] = ACTIONS(2047),
    [anon_sym_GT_GT] = ACTIONS(1883),
    [anon_sym_AMP_GT] = ACTIONS(2047),
    [anon_sym_AMP_GT_GT] = ACTIONS(1883),
    [anon_sym_LT_AMP] = ACTIONS(1883),
    [anon_sym_GT_AMP] = ACTIONS(1883),
    [anon_sym_DQUOTE] = ACTIONS(1883),
    [sym_raw_string] = ACTIONS(1883),
    [anon_sym_DOLLAR] = ACTIONS(2047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1883),
    [anon_sym_BQUOTE] = ACTIONS(1883),
    [anon_sym_LT_LPAREN] = ACTIONS(1883),
    [anon_sym_GT_LPAREN] = ACTIONS(1883),
    [sym_word] = ACTIONS(1885),
    [sym_comment] = ACTIONS(133),
  },
  [850] = {
    [sym_file_descriptor] = ACTIONS(1887),
    [sym__concat] = ACTIONS(1887),
    [sym_variable_name] = ACTIONS(1887),
    [anon_sym_PIPE] = ACTIONS(2049),
    [anon_sym_RPAREN] = ACTIONS(1887),
    [anon_sym_PIPE_AMP] = ACTIONS(1887),
    [anon_sym_AMP_AMP] = ACTIONS(1887),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_GT_GT] = ACTIONS(1887),
    [anon_sym_AMP_GT] = ACTIONS(2049),
    [anon_sym_AMP_GT_GT] = ACTIONS(1887),
    [anon_sym_LT_AMP] = ACTIONS(1887),
    [anon_sym_GT_AMP] = ACTIONS(1887),
    [anon_sym_DQUOTE] = ACTIONS(1887),
    [sym_raw_string] = ACTIONS(1887),
    [anon_sym_DOLLAR] = ACTIONS(2049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1887),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1887),
    [anon_sym_BQUOTE] = ACTIONS(1887),
    [anon_sym_LT_LPAREN] = ACTIONS(1887),
    [anon_sym_GT_LPAREN] = ACTIONS(1887),
    [sym_word] = ACTIONS(1889),
    [sym_comment] = ACTIONS(133),
  },
  [851] = {
    [anon_sym_RBRACE] = ACTIONS(2055),
    [sym_comment] = ACTIONS(133),
  },
  [852] = {
    [anon_sym_RBRACE] = ACTIONS(2057),
    [sym_comment] = ACTIONS(133),
  },
  [853] = {
    [anon_sym_DQUOTE] = ACTIONS(1885),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2047),
    [anon_sym_DOLLAR] = ACTIONS(1885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1885),
    [anon_sym_BQUOTE] = ACTIONS(1885),
    [sym_comment] = ACTIONS(85),
  },
  [854] = {
    [anon_sym_DQUOTE] = ACTIONS(1889),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2049),
    [anon_sym_DOLLAR] = ACTIONS(1889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1889),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_comment] = ACTIONS(85),
  },
  [855] = {
    [sym_file_descriptor] = ACTIONS(2059),
    [sym__concat] = ACTIONS(2059),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_SEMI_SEMI] = ACTIONS(2061),
    [anon_sym_PIPE_AMP] = ACTIONS(2061),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_AMP_GT] = ACTIONS(2061),
    [anon_sym_AMP_GT_GT] = ACTIONS(2061),
    [anon_sym_LT_AMP] = ACTIONS(2061),
    [anon_sym_GT_AMP] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT_LT_DASH] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(2061),
    [sym_raw_string] = ACTIONS(2061),
    [anon_sym_DOLLAR] = ACTIONS(2061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2061),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [anon_sym_LT_LPAREN] = ACTIONS(2061),
    [anon_sym_GT_LPAREN] = ACTIONS(2061),
    [sym_word] = ACTIONS(2061),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_LF] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
  },
  [856] = {
    [sym_file_descriptor] = ACTIONS(2063),
    [sym__concat] = ACTIONS(2063),
    [anon_sym_PIPE] = ACTIONS(2065),
    [anon_sym_RPAREN] = ACTIONS(2065),
    [anon_sym_SEMI_SEMI] = ACTIONS(2065),
    [anon_sym_PIPE_AMP] = ACTIONS(2065),
    [anon_sym_AMP_AMP] = ACTIONS(2065),
    [anon_sym_PIPE_PIPE] = ACTIONS(2065),
    [anon_sym_LT] = ACTIONS(2065),
    [anon_sym_GT] = ACTIONS(2065),
    [anon_sym_GT_GT] = ACTIONS(2065),
    [anon_sym_AMP_GT] = ACTIONS(2065),
    [anon_sym_AMP_GT_GT] = ACTIONS(2065),
    [anon_sym_LT_AMP] = ACTIONS(2065),
    [anon_sym_GT_AMP] = ACTIONS(2065),
    [anon_sym_LT_LT] = ACTIONS(2065),
    [anon_sym_LT_LT_DASH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2065),
    [sym_raw_string] = ACTIONS(2065),
    [anon_sym_DOLLAR] = ACTIONS(2065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2065),
    [anon_sym_BQUOTE] = ACTIONS(2065),
    [anon_sym_LT_LPAREN] = ACTIONS(2065),
    [anon_sym_GT_LPAREN] = ACTIONS(2065),
    [sym_word] = ACTIONS(2065),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_LF] = ACTIONS(2065),
    [anon_sym_AMP] = ACTIONS(2065),
  },
  [857] = {
    [anon_sym_PIPE] = ACTIONS(2067),
    [anon_sym_RPAREN] = ACTIONS(2069),
    [anon_sym_PIPE_AMP] = ACTIONS(2069),
    [anon_sym_AMP_AMP] = ACTIONS(2069),
    [anon_sym_PIPE_PIPE] = ACTIONS(2069),
    [anon_sym_BQUOTE] = ACTIONS(2069),
    [sym_comment] = ACTIONS(133),
  },
  [858] = {
    [anon_sym_PIPE] = ACTIONS(2071),
    [anon_sym_RPAREN] = ACTIONS(2073),
    [anon_sym_PIPE_AMP] = ACTIONS(2073),
    [anon_sym_AMP_AMP] = ACTIONS(2073),
    [anon_sym_PIPE_PIPE] = ACTIONS(2073),
    [anon_sym_BQUOTE] = ACTIONS(2073),
    [sym_comment] = ACTIONS(133),
  },
  [859] = {
    [anon_sym_fi] = ACTIONS(2075),
    [sym_comment] = ACTIONS(133),
  },
  [860] = {
    [anon_sym_PIPE] = ACTIONS(2077),
    [anon_sym_RPAREN] = ACTIONS(2079),
    [anon_sym_PIPE_AMP] = ACTIONS(2079),
    [anon_sym_AMP_AMP] = ACTIONS(2079),
    [anon_sym_PIPE_PIPE] = ACTIONS(2079),
    [anon_sym_BQUOTE] = ACTIONS(2079),
    [sym_comment] = ACTIONS(133),
  },
  [861] = {
    [sym_case_item] = STATE(724),
    [sym_concatenation] = STATE(556),
    [sym_string] = STATE(554),
    [sym_simple_expansion] = STATE(554),
    [sym_expansion] = STATE(554),
    [sym_command_substitution] = STATE(554),
    [sym_process_substitution] = STATE(554),
    [anon_sym_esac] = ACTIONS(2081),
    [anon_sym_DQUOTE] = ACTIONS(315),
    [sym_raw_string] = ACTIONS(1143),
    [anon_sym_DOLLAR] = ACTIONS(319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(327),
    [anon_sym_GT_LPAREN] = ACTIONS(327),
    [sym_word] = ACTIONS(1145),
    [sym_comment] = ACTIONS(133),
  },
  [862] = {
    [anon_sym_RBRACE] = ACTIONS(2083),
    [sym_comment] = ACTIONS(133),
  },
  [863] = {
    [anon_sym_RBRACE] = ACTIONS(2085),
    [sym_comment] = ACTIONS(133),
  },
  [864] = {
    [sym_file_descriptor] = ACTIONS(1883),
    [sym__concat] = ACTIONS(1883),
    [anon_sym_PIPE] = ACTIONS(2047),
    [anon_sym_RPAREN] = ACTIONS(1883),
    [anon_sym_PIPE_AMP] = ACTIONS(1883),
    [anon_sym_AMP_AMP] = ACTIONS(1883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2047),
    [anon_sym_LT] = ACTIONS(2047),
    [anon_sym_GT] = ACTIONS(2047),
    [anon_sym_GT_GT] = ACTIONS(1883),
    [anon_sym_AMP_GT] = ACTIONS(2047),
    [anon_sym_AMP_GT_GT] = ACTIONS(1883),
    [anon_sym_LT_AMP] = ACTIONS(1883),
    [anon_sym_GT_AMP] = ACTIONS(1883),
    [anon_sym_LT_LT] = ACTIONS(2047),
    [anon_sym_LT_LT_DASH] = ACTIONS(1883),
    [anon_sym_DQUOTE] = ACTIONS(1883),
    [sym_raw_string] = ACTIONS(1883),
    [anon_sym_DOLLAR] = ACTIONS(2047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1883),
    [anon_sym_BQUOTE] = ACTIONS(1883),
    [anon_sym_LT_LPAREN] = ACTIONS(1883),
    [anon_sym_GT_LPAREN] = ACTIONS(1883),
    [sym_word] = ACTIONS(1885),
    [sym_comment] = ACTIONS(133),
  },
  [865] = {
    [sym_file_descriptor] = ACTIONS(1887),
    [sym__concat] = ACTIONS(1887),
    [anon_sym_PIPE] = ACTIONS(2049),
    [anon_sym_RPAREN] = ACTIONS(1887),
    [anon_sym_PIPE_AMP] = ACTIONS(1887),
    [anon_sym_AMP_AMP] = ACTIONS(1887),
    [anon_sym_PIPE_PIPE] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_GT_GT] = ACTIONS(1887),
    [anon_sym_AMP_GT] = ACTIONS(2049),
    [anon_sym_AMP_GT_GT] = ACTIONS(1887),
    [anon_sym_LT_AMP] = ACTIONS(1887),
    [anon_sym_GT_AMP] = ACTIONS(1887),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_LT_LT_DASH] = ACTIONS(1887),
    [anon_sym_DQUOTE] = ACTIONS(1887),
    [sym_raw_string] = ACTIONS(1887),
    [anon_sym_DOLLAR] = ACTIONS(2049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1887),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1887),
    [anon_sym_BQUOTE] = ACTIONS(1887),
    [anon_sym_LT_LPAREN] = ACTIONS(1887),
    [anon_sym_GT_LPAREN] = ACTIONS(1887),
    [sym_word] = ACTIONS(1889),
    [sym_comment] = ACTIONS(133),
  },
  [866] = {
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_RPAREN] = ACTIONS(2089),
    [anon_sym_PIPE_AMP] = ACTIONS(2089),
    [anon_sym_AMP_AMP] = ACTIONS(2089),
    [anon_sym_PIPE_PIPE] = ACTIONS(2089),
    [anon_sym_BQUOTE] = ACTIONS(2089),
    [sym_comment] = ACTIONS(133),
  },
  [867] = {
    [sym_file_descriptor] = ACTIONS(1257),
    [sym__concat] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1569),
    [anon_sym_RPAREN] = ACTIONS(1257),
    [anon_sym_PIPE_AMP] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_LT] = ACTIONS(1569),
    [anon_sym_GT] = ACTIONS(1569),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_AMP_GT] = ACTIONS(1569),
    [anon_sym_AMP_GT_GT] = ACTIONS(1257),
    [anon_sym_LT_AMP] = ACTIONS(1257),
    [anon_sym_GT_AMP] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(1569),
    [anon_sym_LT_LT_DASH] = ACTIONS(1257),
    [anon_sym_BQUOTE] = ACTIONS(1257),
    [sym_comment] = ACTIONS(133),
  },
  [868] = {
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1571),
    [anon_sym_RPAREN] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1571),
    [anon_sym_GT] = ACTIONS(1571),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1571),
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1571),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [sym_comment] = ACTIONS(133),
  },
  [869] = {
    [anon_sym_AT] = ACTIONS(2091),
    [sym_comment] = ACTIONS(133),
  },
  [870] = {
    [sym_file_descriptor] = ACTIONS(1267),
    [sym__concat] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1575),
    [anon_sym_RPAREN] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT] = ACTIONS(1575),
    [anon_sym_AMP_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_AMP] = ACTIONS(1267),
    [anon_sym_GT_AMP] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1575),
    [anon_sym_LT_LT_DASH] = ACTIONS(1267),
    [anon_sym_BQUOTE] = ACTIONS(1267),
    [sym_comment] = ACTIONS(133),
  },
  [871] = {
    [anon_sym_AT] = ACTIONS(2093),
    [sym_comment] = ACTIONS(133),
  },
  [872] = {
    [anon_sym_RBRACK] = ACTIONS(2095),
    [sym_comment] = ACTIONS(133),
  },
  [873] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(2097),
    [sym_comment] = ACTIONS(133),
  },
  [874] = {
    [anon_sym_RBRACE] = ACTIONS(2097),
    [sym_comment] = ACTIONS(133),
  },
  [875] = {
    [anon_sym_RBRACK] = ACTIONS(2099),
    [sym_comment] = ACTIONS(133),
  },
  [876] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(2101),
    [sym_comment] = ACTIONS(133),
  },
  [877] = {
    [anon_sym_RBRACE] = ACTIONS(2101),
    [sym_comment] = ACTIONS(133),
  },
  [878] = {
    [anon_sym_RBRACK] = ACTIONS(2103),
    [sym_comment] = ACTIONS(133),
  },
  [879] = {
    [anon_sym_RBRACK] = ACTIONS(2105),
    [sym_comment] = ACTIONS(133),
  },
  [880] = {
    [anon_sym_RBRACE] = ACTIONS(2107),
    [sym_comment] = ACTIONS(133),
  },
  [881] = {
    [sym_file_descriptor] = ACTIONS(1617),
    [sym__concat] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1619),
    [anon_sym_RPAREN] = ACTIONS(1619),
    [anon_sym_SEMI_SEMI] = ACTIONS(1619),
    [anon_sym_PIPE_AMP] = ACTIONS(1619),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE_PIPE] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(1619),
    [anon_sym_GT_GT] = ACTIONS(1619),
    [anon_sym_AMP_GT] = ACTIONS(1619),
    [anon_sym_AMP_GT_GT] = ACTIONS(1619),
    [anon_sym_LT_AMP] = ACTIONS(1619),
    [anon_sym_GT_AMP] = ACTIONS(1619),
    [anon_sym_LT_LT] = ACTIONS(1619),
    [anon_sym_LT_LT_DASH] = ACTIONS(1619),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1619),
    [anon_sym_LF] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
  },
  [882] = {
    [anon_sym_RBRACE] = ACTIONS(2109),
    [sym_comment] = ACTIONS(133),
  },
  [883] = {
    [sym_file_descriptor] = ACTIONS(1623),
    [sym__concat] = ACTIONS(1623),
    [anon_sym_PIPE] = ACTIONS(1625),
    [anon_sym_RPAREN] = ACTIONS(1625),
    [anon_sym_SEMI_SEMI] = ACTIONS(1625),
    [anon_sym_PIPE_AMP] = ACTIONS(1625),
    [anon_sym_AMP_AMP] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1625),
    [anon_sym_GT] = ACTIONS(1625),
    [anon_sym_GT_GT] = ACTIONS(1625),
    [anon_sym_AMP_GT] = ACTIONS(1625),
    [anon_sym_AMP_GT_GT] = ACTIONS(1625),
    [anon_sym_LT_AMP] = ACTIONS(1625),
    [anon_sym_GT_AMP] = ACTIONS(1625),
    [anon_sym_LT_LT] = ACTIONS(1625),
    [anon_sym_LT_LT_DASH] = ACTIONS(1625),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_LF] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
  },
  [884] = {
    [sym__heredoc_middle] = ACTIONS(1261),
    [sym__heredoc_end] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1571),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [sym_comment] = ACTIONS(133),
  },
  [885] = {
    [anon_sym_AT] = ACTIONS(2111),
    [sym_comment] = ACTIONS(133),
  },
  [886] = {
    [sym__heredoc_middle] = ACTIONS(1267),
    [sym__heredoc_end] = ACTIONS(1267),
    [anon_sym_DOLLAR] = ACTIONS(1575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1267),
    [sym_comment] = ACTIONS(133),
  },
  [887] = {
    [anon_sym_AT] = ACTIONS(2113),
    [sym_comment] = ACTIONS(133),
  },
  [888] = {
    [anon_sym_RBRACK] = ACTIONS(2115),
    [sym_comment] = ACTIONS(133),
  },
  [889] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(2117),
    [sym_comment] = ACTIONS(133),
  },
  [890] = {
    [anon_sym_RBRACE] = ACTIONS(2117),
    [sym_comment] = ACTIONS(133),
  },
  [891] = {
    [anon_sym_RBRACK] = ACTIONS(2119),
    [sym_comment] = ACTIONS(133),
  },
  [892] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(2121),
    [sym_comment] = ACTIONS(133),
  },
  [893] = {
    [anon_sym_RBRACE] = ACTIONS(2121),
    [sym_comment] = ACTIONS(133),
  },
  [894] = {
    [anon_sym_RBRACE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(133),
  },
  [895] = {
    [anon_sym_RBRACE] = ACTIONS(2125),
    [sym_comment] = ACTIONS(133),
  },
  [896] = {
    [sym__concat] = ACTIONS(1883),
    [anon_sym_PIPE] = ACTIONS(1883),
    [anon_sym_RPAREN] = ACTIONS(1883),
    [anon_sym_RBRACK] = ACTIONS(1883),
    [sym_comment] = ACTIONS(133),
  },
  [897] = {
    [sym__concat] = ACTIONS(1887),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_RPAREN] = ACTIONS(1887),
    [anon_sym_RBRACK] = ACTIONS(1887),
    [sym_comment] = ACTIONS(133),
  },
  [898] = {
    [anon_sym_RBRACE] = ACTIONS(2127),
    [sym_comment] = ACTIONS(133),
  },
  [899] = {
    [anon_sym_RBRACE] = ACTIONS(2129),
    [sym_comment] = ACTIONS(133),
  },
  [900] = {
    [sym_file_descriptor] = ACTIONS(1883),
    [sym__concat] = ACTIONS(1883),
    [sym_variable_name] = ACTIONS(1883),
    [anon_sym_PIPE] = ACTIONS(1885),
    [anon_sym_RPAREN] = ACTIONS(1885),
    [anon_sym_SEMI_SEMI] = ACTIONS(1885),
    [anon_sym_PIPE_AMP] = ACTIONS(1885),
    [anon_sym_AMP_AMP] = ACTIONS(1885),
    [anon_sym_PIPE_PIPE] = ACTIONS(1885),
    [anon_sym_LT] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1885),
    [anon_sym_GT_GT] = ACTIONS(1885),
    [anon_sym_AMP_GT] = ACTIONS(1885),
    [anon_sym_AMP_GT_GT] = ACTIONS(1885),
    [anon_sym_LT_AMP] = ACTIONS(1885),
    [anon_sym_GT_AMP] = ACTIONS(1885),
    [anon_sym_DQUOTE] = ACTIONS(1885),
    [sym_raw_string] = ACTIONS(1885),
    [anon_sym_DOLLAR] = ACTIONS(1885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1885),
    [anon_sym_BQUOTE] = ACTIONS(1885),
    [anon_sym_LT_LPAREN] = ACTIONS(1885),
    [anon_sym_GT_LPAREN] = ACTIONS(1885),
    [sym_word] = ACTIONS(1885),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1885),
    [anon_sym_LF] = ACTIONS(1885),
    [anon_sym_AMP] = ACTIONS(1885),
  },
  [901] = {
    [sym_file_descriptor] = ACTIONS(1887),
    [sym__concat] = ACTIONS(1887),
    [sym_variable_name] = ACTIONS(1887),
    [anon_sym_PIPE] = ACTIONS(1889),
    [anon_sym_RPAREN] = ACTIONS(1889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1889),
    [anon_sym_PIPE_AMP] = ACTIONS(1889),
    [anon_sym_AMP_AMP] = ACTIONS(1889),
    [anon_sym_PIPE_PIPE] = ACTIONS(1889),
    [anon_sym_LT] = ACTIONS(1889),
    [anon_sym_GT] = ACTIONS(1889),
    [anon_sym_GT_GT] = ACTIONS(1889),
    [anon_sym_AMP_GT] = ACTIONS(1889),
    [anon_sym_AMP_GT_GT] = ACTIONS(1889),
    [anon_sym_LT_AMP] = ACTIONS(1889),
    [anon_sym_GT_AMP] = ACTIONS(1889),
    [anon_sym_DQUOTE] = ACTIONS(1889),
    [sym_raw_string] = ACTIONS(1889),
    [anon_sym_DOLLAR] = ACTIONS(1889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1889),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [anon_sym_LT_LPAREN] = ACTIONS(1889),
    [anon_sym_GT_LPAREN] = ACTIONS(1889),
    [sym_word] = ACTIONS(1889),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1889),
    [anon_sym_LF] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
  },
  [902] = {
    [anon_sym_RBRACK] = ACTIONS(2131),
    [sym_comment] = ACTIONS(133),
  },
  [903] = {
    [anon_sym_RBRACK] = ACTIONS(2133),
    [sym_comment] = ACTIONS(133),
  },
  [904] = {
    [anon_sym_RBRACE] = ACTIONS(2135),
    [sym_comment] = ACTIONS(133),
  },
  [905] = {
    [sym__concat] = ACTIONS(1617),
    [anon_sym_SEMI_SEMI] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1619),
    [sym_raw_string] = ACTIONS(1619),
    [anon_sym_DOLLAR] = ACTIONS(1619),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1619),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1619),
    [anon_sym_BQUOTE] = ACTIONS(1619),
    [anon_sym_LT_LPAREN] = ACTIONS(1619),
    [anon_sym_GT_LPAREN] = ACTIONS(1619),
    [sym_word] = ACTIONS(1619),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1619),
    [anon_sym_LF] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
  },
  [906] = {
    [anon_sym_RBRACE] = ACTIONS(2137),
    [sym_comment] = ACTIONS(133),
  },
  [907] = {
    [sym__concat] = ACTIONS(1623),
    [anon_sym_SEMI_SEMI] = ACTIONS(1625),
    [anon_sym_DQUOTE] = ACTIONS(1625),
    [sym_raw_string] = ACTIONS(1625),
    [anon_sym_DOLLAR] = ACTIONS(1625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1625),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1625),
    [anon_sym_BQUOTE] = ACTIONS(1625),
    [anon_sym_LT_LPAREN] = ACTIONS(1625),
    [anon_sym_GT_LPAREN] = ACTIONS(1625),
    [sym_word] = ACTIONS(1625),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_LF] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
  },
  [908] = {
    [anon_sym_esac] = ACTIONS(2139),
    [anon_sym_DQUOTE] = ACTIONS(2141),
    [sym_raw_string] = ACTIONS(2141),
    [anon_sym_DOLLAR] = ACTIONS(2139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2141),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2141),
    [anon_sym_BQUOTE] = ACTIONS(2141),
    [anon_sym_LT_LPAREN] = ACTIONS(2141),
    [anon_sym_GT_LPAREN] = ACTIONS(2141),
    [sym_word] = ACTIONS(2143),
    [sym_comment] = ACTIONS(133),
  },
  [909] = {
    [aux_sym_concatenation_repeat1] = STATE(305),
    [sym__concat] = ACTIONS(619),
    [anon_sym_PIPE] = ACTIONS(2145),
    [anon_sym_RPAREN] = ACTIONS(2145),
    [sym_comment] = ACTIONS(133),
  },
  [910] = {
    [anon_sym_PIPE] = ACTIONS(2145),
    [anon_sym_RPAREN] = ACTIONS(2145),
    [sym_comment] = ACTIONS(133),
  },
  [911] = {
    [sym__terminated_statement] = STATE(126),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_SEMI_SEMI] = ACTIONS(2147),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [912] = {
    [sym__concat] = ACTIONS(2059),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_SEMI_SEMI] = ACTIONS(2061),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_LF] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
  },
  [913] = {
    [sym__concat] = ACTIONS(2063),
    [anon_sym_in] = ACTIONS(2065),
    [anon_sym_SEMI_SEMI] = ACTIONS(2065),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_LF] = ACTIONS(2065),
    [anon_sym_AMP] = ACTIONS(2065),
  },
  [914] = {
    [sym__concat] = ACTIONS(2059),
    [anon_sym_RBRACE] = ACTIONS(2059),
    [anon_sym_RBRACK] = ACTIONS(2149),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2149),
    [anon_sym_DQUOTE] = ACTIONS(2059),
    [sym_raw_string] = ACTIONS(2059),
    [anon_sym_DOLLAR] = ACTIONS(2149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2059),
    [anon_sym_BQUOTE] = ACTIONS(2059),
    [anon_sym_LT_LPAREN] = ACTIONS(2059),
    [anon_sym_GT_LPAREN] = ACTIONS(2059),
    [sym_word] = ACTIONS(2061),
    [sym_comment] = ACTIONS(133),
  },
  [915] = {
    [sym__concat] = ACTIONS(2063),
    [anon_sym_RBRACE] = ACTIONS(2063),
    [anon_sym_RBRACK] = ACTIONS(2151),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2151),
    [anon_sym_DQUOTE] = ACTIONS(2063),
    [sym_raw_string] = ACTIONS(2063),
    [anon_sym_DOLLAR] = ACTIONS(2151),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2063),
    [anon_sym_BQUOTE] = ACTIONS(2063),
    [anon_sym_LT_LPAREN] = ACTIONS(2063),
    [anon_sym_GT_LPAREN] = ACTIONS(2063),
    [sym_word] = ACTIONS(2065),
    [sym_comment] = ACTIONS(133),
  },
  [916] = {
    [sym_file_descriptor] = ACTIONS(2059),
    [sym__concat] = ACTIONS(2059),
    [sym_variable_name] = ACTIONS(2059),
    [anon_sym_PIPE] = ACTIONS(2149),
    [anon_sym_RPAREN] = ACTIONS(2059),
    [anon_sym_PIPE_AMP] = ACTIONS(2059),
    [anon_sym_AMP_AMP] = ACTIONS(2059),
    [anon_sym_PIPE_PIPE] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_GT] = ACTIONS(2149),
    [anon_sym_GT_GT] = ACTIONS(2059),
    [anon_sym_AMP_GT] = ACTIONS(2149),
    [anon_sym_AMP_GT_GT] = ACTIONS(2059),
    [anon_sym_LT_AMP] = ACTIONS(2059),
    [anon_sym_GT_AMP] = ACTIONS(2059),
    [anon_sym_DQUOTE] = ACTIONS(2059),
    [sym_raw_string] = ACTIONS(2059),
    [anon_sym_DOLLAR] = ACTIONS(2149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2059),
    [anon_sym_BQUOTE] = ACTIONS(2059),
    [anon_sym_LT_LPAREN] = ACTIONS(2059),
    [anon_sym_GT_LPAREN] = ACTIONS(2059),
    [sym_word] = ACTIONS(2061),
    [sym_comment] = ACTIONS(133),
  },
  [917] = {
    [sym_file_descriptor] = ACTIONS(2063),
    [sym__concat] = ACTIONS(2063),
    [sym_variable_name] = ACTIONS(2063),
    [anon_sym_PIPE] = ACTIONS(2151),
    [anon_sym_RPAREN] = ACTIONS(2063),
    [anon_sym_PIPE_AMP] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2063),
    [anon_sym_PIPE_PIPE] = ACTIONS(2151),
    [anon_sym_LT] = ACTIONS(2151),
    [anon_sym_GT] = ACTIONS(2151),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_AMP_GT] = ACTIONS(2151),
    [anon_sym_AMP_GT_GT] = ACTIONS(2063),
    [anon_sym_LT_AMP] = ACTIONS(2063),
    [anon_sym_GT_AMP] = ACTIONS(2063),
    [anon_sym_DQUOTE] = ACTIONS(2063),
    [sym_raw_string] = ACTIONS(2063),
    [anon_sym_DOLLAR] = ACTIONS(2151),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2063),
    [anon_sym_BQUOTE] = ACTIONS(2063),
    [anon_sym_LT_LPAREN] = ACTIONS(2063),
    [anon_sym_GT_LPAREN] = ACTIONS(2063),
    [sym_word] = ACTIONS(2065),
    [sym_comment] = ACTIONS(133),
  },
  [918] = {
    [anon_sym_DQUOTE] = ACTIONS(2061),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2149),
    [anon_sym_DOLLAR] = ACTIONS(2061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2061),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [sym_comment] = ACTIONS(85),
  },
  [919] = {
    [anon_sym_DQUOTE] = ACTIONS(2065),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2151),
    [anon_sym_DOLLAR] = ACTIONS(2065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2065),
    [anon_sym_BQUOTE] = ACTIONS(2065),
    [sym_comment] = ACTIONS(85),
  },
  [920] = {
    [anon_sym_PIPE] = ACTIONS(2153),
    [anon_sym_RPAREN] = ACTIONS(2155),
    [anon_sym_PIPE_AMP] = ACTIONS(2155),
    [anon_sym_AMP_AMP] = ACTIONS(2155),
    [anon_sym_PIPE_PIPE] = ACTIONS(2155),
    [anon_sym_BQUOTE] = ACTIONS(2155),
    [sym_comment] = ACTIONS(133),
  },
  [921] = {
    [anon_sym_PIPE] = ACTIONS(2157),
    [anon_sym_RPAREN] = ACTIONS(2159),
    [anon_sym_PIPE_AMP] = ACTIONS(2159),
    [anon_sym_AMP_AMP] = ACTIONS(2159),
    [anon_sym_PIPE_PIPE] = ACTIONS(2159),
    [anon_sym_BQUOTE] = ACTIONS(2159),
    [sym_comment] = ACTIONS(133),
  },
  [922] = {
    [sym_file_descriptor] = ACTIONS(2059),
    [sym__concat] = ACTIONS(2059),
    [anon_sym_PIPE] = ACTIONS(2149),
    [anon_sym_RPAREN] = ACTIONS(2059),
    [anon_sym_PIPE_AMP] = ACTIONS(2059),
    [anon_sym_AMP_AMP] = ACTIONS(2059),
    [anon_sym_PIPE_PIPE] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_GT] = ACTIONS(2149),
    [anon_sym_GT_GT] = ACTIONS(2059),
    [anon_sym_AMP_GT] = ACTIONS(2149),
    [anon_sym_AMP_GT_GT] = ACTIONS(2059),
    [anon_sym_LT_AMP] = ACTIONS(2059),
    [anon_sym_GT_AMP] = ACTIONS(2059),
    [anon_sym_LT_LT] = ACTIONS(2149),
    [anon_sym_LT_LT_DASH] = ACTIONS(2059),
    [anon_sym_DQUOTE] = ACTIONS(2059),
    [sym_raw_string] = ACTIONS(2059),
    [anon_sym_DOLLAR] = ACTIONS(2149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2059),
    [anon_sym_BQUOTE] = ACTIONS(2059),
    [anon_sym_LT_LPAREN] = ACTIONS(2059),
    [anon_sym_GT_LPAREN] = ACTIONS(2059),
    [sym_word] = ACTIONS(2061),
    [sym_comment] = ACTIONS(133),
  },
  [923] = {
    [sym_file_descriptor] = ACTIONS(2063),
    [sym__concat] = ACTIONS(2063),
    [anon_sym_PIPE] = ACTIONS(2151),
    [anon_sym_RPAREN] = ACTIONS(2063),
    [anon_sym_PIPE_AMP] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2063),
    [anon_sym_PIPE_PIPE] = ACTIONS(2151),
    [anon_sym_LT] = ACTIONS(2151),
    [anon_sym_GT] = ACTIONS(2151),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_AMP_GT] = ACTIONS(2151),
    [anon_sym_AMP_GT_GT] = ACTIONS(2063),
    [anon_sym_LT_AMP] = ACTIONS(2063),
    [anon_sym_GT_AMP] = ACTIONS(2063),
    [anon_sym_LT_LT] = ACTIONS(2151),
    [anon_sym_LT_LT_DASH] = ACTIONS(2063),
    [anon_sym_DQUOTE] = ACTIONS(2063),
    [sym_raw_string] = ACTIONS(2063),
    [anon_sym_DOLLAR] = ACTIONS(2151),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2063),
    [anon_sym_BQUOTE] = ACTIONS(2063),
    [anon_sym_LT_LPAREN] = ACTIONS(2063),
    [anon_sym_GT_LPAREN] = ACTIONS(2063),
    [sym_word] = ACTIONS(2065),
    [sym_comment] = ACTIONS(133),
  },
  [924] = {
    [anon_sym_RBRACK] = ACTIONS(2161),
    [sym_comment] = ACTIONS(133),
  },
  [925] = {
    [anon_sym_RBRACK] = ACTIONS(2163),
    [sym_comment] = ACTIONS(133),
  },
  [926] = {
    [anon_sym_RBRACE] = ACTIONS(2165),
    [sym_comment] = ACTIONS(133),
  },
  [927] = {
    [sym_file_descriptor] = ACTIONS(1617),
    [sym__concat] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1857),
    [anon_sym_RPAREN] = ACTIONS(1617),
    [anon_sym_PIPE_AMP] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1617),
    [anon_sym_PIPE_PIPE] = ACTIONS(1617),
    [anon_sym_LT] = ACTIONS(1857),
    [anon_sym_GT] = ACTIONS(1857),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_AMP_GT] = ACTIONS(1857),
    [anon_sym_AMP_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_AMP] = ACTIONS(1617),
    [anon_sym_GT_AMP] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1857),
    [anon_sym_LT_LT_DASH] = ACTIONS(1617),
    [anon_sym_BQUOTE] = ACTIONS(1617),
    [sym_comment] = ACTIONS(133),
  },
  [928] = {
    [anon_sym_RBRACE] = ACTIONS(2167),
    [sym_comment] = ACTIONS(133),
  },
  [929] = {
    [sym_file_descriptor] = ACTIONS(1623),
    [sym__concat] = ACTIONS(1623),
    [anon_sym_PIPE] = ACTIONS(1861),
    [anon_sym_RPAREN] = ACTIONS(1623),
    [anon_sym_PIPE_AMP] = ACTIONS(1623),
    [anon_sym_AMP_AMP] = ACTIONS(1623),
    [anon_sym_PIPE_PIPE] = ACTIONS(1623),
    [anon_sym_LT] = ACTIONS(1861),
    [anon_sym_GT] = ACTIONS(1861),
    [anon_sym_GT_GT] = ACTIONS(1623),
    [anon_sym_AMP_GT] = ACTIONS(1861),
    [anon_sym_AMP_GT_GT] = ACTIONS(1623),
    [anon_sym_LT_AMP] = ACTIONS(1623),
    [anon_sym_GT_AMP] = ACTIONS(1623),
    [anon_sym_LT_LT] = ACTIONS(1861),
    [anon_sym_LT_LT_DASH] = ACTIONS(1623),
    [anon_sym_BQUOTE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(133),
  },
  [930] = {
    [anon_sym_RBRACE] = ACTIONS(2169),
    [sym_comment] = ACTIONS(133),
  },
  [931] = {
    [anon_sym_RBRACE] = ACTIONS(2171),
    [sym_comment] = ACTIONS(133),
  },
  [932] = {
    [sym_file_descriptor] = ACTIONS(1883),
    [sym__concat] = ACTIONS(1883),
    [anon_sym_PIPE] = ACTIONS(1885),
    [anon_sym_RPAREN] = ACTIONS(1885),
    [anon_sym_SEMI_SEMI] = ACTIONS(1885),
    [anon_sym_PIPE_AMP] = ACTIONS(1885),
    [anon_sym_AMP_AMP] = ACTIONS(1885),
    [anon_sym_PIPE_PIPE] = ACTIONS(1885),
    [anon_sym_LT] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1885),
    [anon_sym_GT_GT] = ACTIONS(1885),
    [anon_sym_AMP_GT] = ACTIONS(1885),
    [anon_sym_AMP_GT_GT] = ACTIONS(1885),
    [anon_sym_LT_AMP] = ACTIONS(1885),
    [anon_sym_GT_AMP] = ACTIONS(1885),
    [anon_sym_LT_LT] = ACTIONS(1885),
    [anon_sym_LT_LT_DASH] = ACTIONS(1885),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1885),
    [anon_sym_LF] = ACTIONS(1885),
    [anon_sym_AMP] = ACTIONS(1885),
  },
  [933] = {
    [sym_file_descriptor] = ACTIONS(1887),
    [sym__concat] = ACTIONS(1887),
    [anon_sym_PIPE] = ACTIONS(1889),
    [anon_sym_RPAREN] = ACTIONS(1889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1889),
    [anon_sym_PIPE_AMP] = ACTIONS(1889),
    [anon_sym_AMP_AMP] = ACTIONS(1889),
    [anon_sym_PIPE_PIPE] = ACTIONS(1889),
    [anon_sym_LT] = ACTIONS(1889),
    [anon_sym_GT] = ACTIONS(1889),
    [anon_sym_GT_GT] = ACTIONS(1889),
    [anon_sym_AMP_GT] = ACTIONS(1889),
    [anon_sym_AMP_GT_GT] = ACTIONS(1889),
    [anon_sym_LT_AMP] = ACTIONS(1889),
    [anon_sym_GT_AMP] = ACTIONS(1889),
    [anon_sym_LT_LT] = ACTIONS(1889),
    [anon_sym_LT_LT_DASH] = ACTIONS(1889),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1889),
    [anon_sym_LF] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
  },
  [934] = {
    [anon_sym_RBRACK] = ACTIONS(2173),
    [sym_comment] = ACTIONS(133),
  },
  [935] = {
    [anon_sym_RBRACK] = ACTIONS(2175),
    [sym_comment] = ACTIONS(133),
  },
  [936] = {
    [anon_sym_RBRACE] = ACTIONS(2177),
    [sym_comment] = ACTIONS(133),
  },
  [937] = {
    [sym__heredoc_middle] = ACTIONS(1617),
    [sym__heredoc_end] = ACTIONS(1617),
    [anon_sym_DOLLAR] = ACTIONS(1857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1617),
    [sym_comment] = ACTIONS(133),
  },
  [938] = {
    [anon_sym_RBRACE] = ACTIONS(2179),
    [sym_comment] = ACTIONS(133),
  },
  [939] = {
    [sym__heredoc_middle] = ACTIONS(1623),
    [sym__heredoc_end] = ACTIONS(1623),
    [anon_sym_DOLLAR] = ACTIONS(1861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1623),
    [sym_comment] = ACTIONS(133),
  },
  [940] = {
    [sym__concat] = ACTIONS(2059),
    [anon_sym_PIPE] = ACTIONS(2059),
    [anon_sym_RPAREN] = ACTIONS(2059),
    [anon_sym_RBRACK] = ACTIONS(2059),
    [sym_comment] = ACTIONS(133),
  },
  [941] = {
    [sym__concat] = ACTIONS(2063),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_RPAREN] = ACTIONS(2063),
    [anon_sym_RBRACK] = ACTIONS(2063),
    [sym_comment] = ACTIONS(133),
  },
  [942] = {
    [sym_file_descriptor] = ACTIONS(2059),
    [sym__concat] = ACTIONS(2059),
    [sym_variable_name] = ACTIONS(2059),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_SEMI_SEMI] = ACTIONS(2061),
    [anon_sym_PIPE_AMP] = ACTIONS(2061),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_AMP_GT] = ACTIONS(2061),
    [anon_sym_AMP_GT_GT] = ACTIONS(2061),
    [anon_sym_LT_AMP] = ACTIONS(2061),
    [anon_sym_GT_AMP] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(2061),
    [sym_raw_string] = ACTIONS(2061),
    [anon_sym_DOLLAR] = ACTIONS(2061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2061),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [anon_sym_LT_LPAREN] = ACTIONS(2061),
    [anon_sym_GT_LPAREN] = ACTIONS(2061),
    [sym_word] = ACTIONS(2061),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_LF] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
  },
  [943] = {
    [sym_file_descriptor] = ACTIONS(2063),
    [sym__concat] = ACTIONS(2063),
    [sym_variable_name] = ACTIONS(2063),
    [anon_sym_PIPE] = ACTIONS(2065),
    [anon_sym_RPAREN] = ACTIONS(2065),
    [anon_sym_SEMI_SEMI] = ACTIONS(2065),
    [anon_sym_PIPE_AMP] = ACTIONS(2065),
    [anon_sym_AMP_AMP] = ACTIONS(2065),
    [anon_sym_PIPE_PIPE] = ACTIONS(2065),
    [anon_sym_LT] = ACTIONS(2065),
    [anon_sym_GT] = ACTIONS(2065),
    [anon_sym_GT_GT] = ACTIONS(2065),
    [anon_sym_AMP_GT] = ACTIONS(2065),
    [anon_sym_AMP_GT_GT] = ACTIONS(2065),
    [anon_sym_LT_AMP] = ACTIONS(2065),
    [anon_sym_GT_AMP] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2065),
    [sym_raw_string] = ACTIONS(2065),
    [anon_sym_DOLLAR] = ACTIONS(2065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2065),
    [anon_sym_BQUOTE] = ACTIONS(2065),
    [anon_sym_LT_LPAREN] = ACTIONS(2065),
    [anon_sym_GT_LPAREN] = ACTIONS(2065),
    [sym_word] = ACTIONS(2065),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_LF] = ACTIONS(2065),
    [anon_sym_AMP] = ACTIONS(2065),
  },
  [944] = {
    [anon_sym_RBRACE] = ACTIONS(2181),
    [sym_comment] = ACTIONS(133),
  },
  [945] = {
    [anon_sym_RBRACE] = ACTIONS(2183),
    [sym_comment] = ACTIONS(133),
  },
  [946] = {
    [sym__concat] = ACTIONS(1883),
    [anon_sym_SEMI_SEMI] = ACTIONS(1885),
    [anon_sym_DQUOTE] = ACTIONS(1885),
    [sym_raw_string] = ACTIONS(1885),
    [anon_sym_DOLLAR] = ACTIONS(1885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1885),
    [anon_sym_BQUOTE] = ACTIONS(1885),
    [anon_sym_LT_LPAREN] = ACTIONS(1885),
    [anon_sym_GT_LPAREN] = ACTIONS(1885),
    [sym_word] = ACTIONS(1885),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1885),
    [anon_sym_LF] = ACTIONS(1885),
    [anon_sym_AMP] = ACTIONS(1885),
  },
  [947] = {
    [sym__concat] = ACTIONS(1887),
    [anon_sym_SEMI_SEMI] = ACTIONS(1889),
    [anon_sym_DQUOTE] = ACTIONS(1889),
    [sym_raw_string] = ACTIONS(1889),
    [anon_sym_DOLLAR] = ACTIONS(1889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1889),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [anon_sym_LT_LPAREN] = ACTIONS(1889),
    [anon_sym_GT_LPAREN] = ACTIONS(1889),
    [sym_word] = ACTIONS(1889),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1889),
    [anon_sym_LF] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
  },
  [948] = {
    [anon_sym_esac] = ACTIONS(2185),
    [anon_sym_DQUOTE] = ACTIONS(2187),
    [sym_raw_string] = ACTIONS(2187),
    [anon_sym_DOLLAR] = ACTIONS(2185),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2187),
    [anon_sym_BQUOTE] = ACTIONS(2187),
    [anon_sym_LT_LPAREN] = ACTIONS(2187),
    [anon_sym_GT_LPAREN] = ACTIONS(2187),
    [sym_word] = ACTIONS(2189),
    [sym_comment] = ACTIONS(133),
  },
  [949] = {
    [anon_sym_RBRACE] = ACTIONS(2191),
    [sym_comment] = ACTIONS(133),
  },
  [950] = {
    [anon_sym_RBRACE] = ACTIONS(2193),
    [sym_comment] = ACTIONS(133),
  },
  [951] = {
    [sym_file_descriptor] = ACTIONS(1883),
    [sym__concat] = ACTIONS(1883),
    [anon_sym_PIPE] = ACTIONS(2047),
    [anon_sym_RPAREN] = ACTIONS(1883),
    [anon_sym_PIPE_AMP] = ACTIONS(1883),
    [anon_sym_AMP_AMP] = ACTIONS(1883),
    [anon_sym_PIPE_PIPE] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(2047),
    [anon_sym_GT] = ACTIONS(2047),
    [anon_sym_GT_GT] = ACTIONS(1883),
    [anon_sym_AMP_GT] = ACTIONS(2047),
    [anon_sym_AMP_GT_GT] = ACTIONS(1883),
    [anon_sym_LT_AMP] = ACTIONS(1883),
    [anon_sym_GT_AMP] = ACTIONS(1883),
    [anon_sym_LT_LT] = ACTIONS(2047),
    [anon_sym_LT_LT_DASH] = ACTIONS(1883),
    [anon_sym_BQUOTE] = ACTIONS(1883),
    [sym_comment] = ACTIONS(133),
  },
  [952] = {
    [sym_file_descriptor] = ACTIONS(1887),
    [sym__concat] = ACTIONS(1887),
    [anon_sym_PIPE] = ACTIONS(2049),
    [anon_sym_RPAREN] = ACTIONS(1887),
    [anon_sym_PIPE_AMP] = ACTIONS(1887),
    [anon_sym_AMP_AMP] = ACTIONS(1887),
    [anon_sym_PIPE_PIPE] = ACTIONS(1887),
    [anon_sym_LT] = ACTIONS(2049),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_GT_GT] = ACTIONS(1887),
    [anon_sym_AMP_GT] = ACTIONS(2049),
    [anon_sym_AMP_GT_GT] = ACTIONS(1887),
    [anon_sym_LT_AMP] = ACTIONS(1887),
    [anon_sym_GT_AMP] = ACTIONS(1887),
    [anon_sym_LT_LT] = ACTIONS(2049),
    [anon_sym_LT_LT_DASH] = ACTIONS(1887),
    [anon_sym_BQUOTE] = ACTIONS(1887),
    [sym_comment] = ACTIONS(133),
  },
  [953] = {
    [sym_file_descriptor] = ACTIONS(2059),
    [sym__concat] = ACTIONS(2059),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_SEMI_SEMI] = ACTIONS(2061),
    [anon_sym_PIPE_AMP] = ACTIONS(2061),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_AMP_GT] = ACTIONS(2061),
    [anon_sym_AMP_GT_GT] = ACTIONS(2061),
    [anon_sym_LT_AMP] = ACTIONS(2061),
    [anon_sym_GT_AMP] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT_LT_DASH] = ACTIONS(2061),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_LF] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
  },
  [954] = {
    [sym_file_descriptor] = ACTIONS(2063),
    [sym__concat] = ACTIONS(2063),
    [anon_sym_PIPE] = ACTIONS(2065),
    [anon_sym_RPAREN] = ACTIONS(2065),
    [anon_sym_SEMI_SEMI] = ACTIONS(2065),
    [anon_sym_PIPE_AMP] = ACTIONS(2065),
    [anon_sym_AMP_AMP] = ACTIONS(2065),
    [anon_sym_PIPE_PIPE] = ACTIONS(2065),
    [anon_sym_LT] = ACTIONS(2065),
    [anon_sym_GT] = ACTIONS(2065),
    [anon_sym_GT_GT] = ACTIONS(2065),
    [anon_sym_AMP_GT] = ACTIONS(2065),
    [anon_sym_AMP_GT_GT] = ACTIONS(2065),
    [anon_sym_LT_AMP] = ACTIONS(2065),
    [anon_sym_GT_AMP] = ACTIONS(2065),
    [anon_sym_LT_LT] = ACTIONS(2065),
    [anon_sym_LT_LT_DASH] = ACTIONS(2065),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_LF] = ACTIONS(2065),
    [anon_sym_AMP] = ACTIONS(2065),
  },
  [955] = {
    [anon_sym_RBRACE] = ACTIONS(2195),
    [sym_comment] = ACTIONS(133),
  },
  [956] = {
    [anon_sym_RBRACE] = ACTIONS(2197),
    [sym_comment] = ACTIONS(133),
  },
  [957] = {
    [sym__heredoc_middle] = ACTIONS(1883),
    [sym__heredoc_end] = ACTIONS(1883),
    [anon_sym_DOLLAR] = ACTIONS(2047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1883),
    [sym_comment] = ACTIONS(133),
  },
  [958] = {
    [sym__heredoc_middle] = ACTIONS(1887),
    [sym__heredoc_end] = ACTIONS(1887),
    [anon_sym_DOLLAR] = ACTIONS(2049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1887),
    [sym_comment] = ACTIONS(133),
  },
  [959] = {
    [sym__concat] = ACTIONS(2059),
    [anon_sym_SEMI_SEMI] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(2061),
    [sym_raw_string] = ACTIONS(2061),
    [anon_sym_DOLLAR] = ACTIONS(2061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2061),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [anon_sym_LT_LPAREN] = ACTIONS(2061),
    [anon_sym_GT_LPAREN] = ACTIONS(2061),
    [sym_word] = ACTIONS(2061),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_LF] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
  },
  [960] = {
    [sym__concat] = ACTIONS(2063),
    [anon_sym_SEMI_SEMI] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2065),
    [sym_raw_string] = ACTIONS(2065),
    [anon_sym_DOLLAR] = ACTIONS(2065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2065),
    [anon_sym_BQUOTE] = ACTIONS(2065),
    [anon_sym_LT_LPAREN] = ACTIONS(2065),
    [anon_sym_GT_LPAREN] = ACTIONS(2065),
    [sym_word] = ACTIONS(2065),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_LF] = ACTIONS(2065),
    [anon_sym_AMP] = ACTIONS(2065),
  },
  [961] = {
    [sym_file_descriptor] = ACTIONS(2059),
    [sym__concat] = ACTIONS(2059),
    [anon_sym_PIPE] = ACTIONS(2149),
    [anon_sym_RPAREN] = ACTIONS(2059),
    [anon_sym_PIPE_AMP] = ACTIONS(2059),
    [anon_sym_AMP_AMP] = ACTIONS(2059),
    [anon_sym_PIPE_PIPE] = ACTIONS(2059),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_GT] = ACTIONS(2149),
    [anon_sym_GT_GT] = ACTIONS(2059),
    [anon_sym_AMP_GT] = ACTIONS(2149),
    [anon_sym_AMP_GT_GT] = ACTIONS(2059),
    [anon_sym_LT_AMP] = ACTIONS(2059),
    [anon_sym_GT_AMP] = ACTIONS(2059),
    [anon_sym_LT_LT] = ACTIONS(2149),
    [anon_sym_LT_LT_DASH] = ACTIONS(2059),
    [anon_sym_BQUOTE] = ACTIONS(2059),
    [sym_comment] = ACTIONS(133),
  },
  [962] = {
    [sym_file_descriptor] = ACTIONS(2063),
    [sym__concat] = ACTIONS(2063),
    [anon_sym_PIPE] = ACTIONS(2151),
    [anon_sym_RPAREN] = ACTIONS(2063),
    [anon_sym_PIPE_AMP] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2063),
    [anon_sym_PIPE_PIPE] = ACTIONS(2063),
    [anon_sym_LT] = ACTIONS(2151),
    [anon_sym_GT] = ACTIONS(2151),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_AMP_GT] = ACTIONS(2151),
    [anon_sym_AMP_GT_GT] = ACTIONS(2063),
    [anon_sym_LT_AMP] = ACTIONS(2063),
    [anon_sym_GT_AMP] = ACTIONS(2063),
    [anon_sym_LT_LT] = ACTIONS(2151),
    [anon_sym_LT_LT_DASH] = ACTIONS(2063),
    [anon_sym_BQUOTE] = ACTIONS(2063),
    [sym_comment] = ACTIONS(133),
  },
  [963] = {
    [sym__heredoc_middle] = ACTIONS(2059),
    [sym__heredoc_end] = ACTIONS(2059),
    [anon_sym_DOLLAR] = ACTIONS(2149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2059),
    [sym_comment] = ACTIONS(133),
  },
  [964] = {
    [sym__heredoc_middle] = ACTIONS(2063),
    [sym__heredoc_end] = ACTIONS(2063),
    [anon_sym_DOLLAR] = ACTIONS(2151),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2063),
    [sym_comment] = ACTIONS(133),
  },
  [965] = {
    [sym_word] = ACTIONS(2199),
    [sym_comment] = ACTIONS(133),
  },
  [966] = {
    [sym_concatenation] = STATE(344),
    [sym_string] = STATE(338),
    [sym_simple_expansion] = STATE(338),
    [sym_expansion] = STATE(338),
    [sym_command_substitution] = STATE(338),
    [sym_process_substitution] = STATE(338),
    [aux_sym_for_statement_repeat1] = STATE(1029),
    [anon_sym_SEMI_SEMI] = ACTIONS(2201),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(2203),
    [anon_sym_DOLLAR] = ACTIONS(1113),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1115),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_LT_LPAREN] = ACTIONS(1121),
    [anon_sym_GT_LPAREN] = ACTIONS(1121),
    [sym_word] = ACTIONS(2203),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2201),
    [anon_sym_LF] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
  },
  [967] = {
    [sym__terminated_statement] = STATE(1030),
    [sym_for_statement] = STATE(36),
    [sym_while_statement] = STATE(36),
    [sym_if_statement] = STATE(36),
    [sym_case_statement] = STATE(36),
    [sym_function_definition] = STATE(36),
    [sym_subshell] = STATE(36),
    [sym_pipeline] = STATE(36),
    [sym_list] = STATE(36),
    [sym_bracket_command] = STATE(36),
    [sym_command] = STATE(36),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(37),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [968] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1032),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_done] = ACTIONS(2205),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [969] = {
    [anon_sym_PIPE] = ACTIONS(2207),
    [anon_sym_RPAREN] = ACTIONS(2207),
    [anon_sym_SEMI_SEMI] = ACTIONS(2207),
    [anon_sym_PIPE_AMP] = ACTIONS(2207),
    [anon_sym_AMP_AMP] = ACTIONS(2207),
    [anon_sym_PIPE_PIPE] = ACTIONS(2207),
    [anon_sym_BQUOTE] = ACTIONS(2207),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2207),
    [anon_sym_LF] = ACTIONS(2207),
    [anon_sym_AMP] = ACTIONS(2207),
  },
  [970] = {
    [sym__terminated_statement] = STATE(1033),
    [sym_for_statement] = STATE(36),
    [sym_while_statement] = STATE(36),
    [sym_if_statement] = STATE(36),
    [sym_case_statement] = STATE(36),
    [sym_function_definition] = STATE(36),
    [sym_subshell] = STATE(36),
    [sym_pipeline] = STATE(36),
    [sym_list] = STATE(36),
    [sym_bracket_command] = STATE(36),
    [sym_command] = STATE(36),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(37),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [971] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_elif_clause] = STATE(351),
    [sym_else_clause] = STATE(1035),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1036),
    [aux_sym_if_statement_repeat1] = STATE(1037),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_fi] = ACTIONS(2210),
    [anon_sym_elif] = ACTIONS(2213),
    [anon_sym_else] = ACTIONS(2216),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [972] = {
    [anon_sym_PIPE] = ACTIONS(2219),
    [anon_sym_RPAREN] = ACTIONS(2219),
    [anon_sym_SEMI_SEMI] = ACTIONS(2219),
    [anon_sym_PIPE_AMP] = ACTIONS(2219),
    [anon_sym_AMP_AMP] = ACTIONS(2219),
    [anon_sym_PIPE_PIPE] = ACTIONS(2219),
    [anon_sym_BQUOTE] = ACTIONS(2219),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2219),
    [anon_sym_LF] = ACTIONS(2219),
    [anon_sym_AMP] = ACTIONS(2219),
  },
  [973] = {
    [sym_concatenation] = STATE(1039),
    [sym_string] = STATE(1038),
    [sym_simple_expansion] = STATE(1038),
    [sym_expansion] = STATE(1038),
    [sym_command_substitution] = STATE(1038),
    [sym_process_substitution] = STATE(1038),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [sym_raw_string] = ACTIONS(2224),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_LT_LPAREN] = ACTIONS(157),
    [anon_sym_GT_LPAREN] = ACTIONS(157),
    [sym_word] = ACTIONS(2226),
    [sym_comment] = ACTIONS(133),
  },
  [974] = {
    [anon_sym_PIPE] = ACTIONS(2228),
    [anon_sym_RPAREN] = ACTIONS(2228),
    [anon_sym_SEMI_SEMI] = ACTIONS(2228),
    [anon_sym_PIPE_AMP] = ACTIONS(2228),
    [anon_sym_AMP_AMP] = ACTIONS(2228),
    [anon_sym_PIPE_PIPE] = ACTIONS(2228),
    [anon_sym_BQUOTE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym_LF] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2228),
  },
  [975] = {
    [sym_for_statement] = STATE(1045),
    [sym_while_statement] = STATE(1045),
    [sym_if_statement] = STATE(1045),
    [sym_case_statement] = STATE(1045),
    [sym_function_definition] = STATE(1045),
    [sym_subshell] = STATE(1045),
    [sym_pipeline] = STATE(1045),
    [sym_list] = STATE(1045),
    [sym_bracket_command] = STATE(1045),
    [sym_command] = STATE(1045),
    [sym_command_name] = STATE(1046),
    [sym_environment_variable_assignment] = STATE(1047),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(1048),
    [sym_string] = STATE(1043),
    [sym_simple_expansion] = STATE(1043),
    [sym_expansion] = STATE(1043),
    [sym_command_substitution] = STATE(1043),
    [sym_process_substitution] = STATE(1043),
    [aux_sym_command_repeat1] = STATE(1022),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_while] = ACTIONS(2234),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_case] = ACTIONS(2238),
    [anon_sym_function] = ACTIONS(2240),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2244),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2246),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(2250),
    [sym_comment] = ACTIONS(133),
  },
  [976] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_compound_statement] = STATE(1008),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1050),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(2252),
    [sym__concat] = ACTIONS(2258),
    [sym_variable_name] = ACTIONS(2261),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_in] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_PIPE] = ACTIONS(2270),
    [anon_sym_RPAREN] = ACTIONS(2270),
    [anon_sym_SEMI_SEMI] = ACTIONS(2278),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_RBRACE] = ACTIONS(2267),
    [anon_sym_PIPE_AMP] = ACTIONS(2270),
    [anon_sym_AMP_AMP] = ACTIONS(2270),
    [anon_sym_PIPE_PIPE] = ACTIONS(2270),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(2267),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2267),
    [anon_sym_LT] = ACTIONS(2291),
    [anon_sym_GT] = ACTIONS(2291),
    [anon_sym_GT_GT] = ACTIONS(2291),
    [anon_sym_AMP_GT] = ACTIONS(2291),
    [anon_sym_AMP_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_AMP] = ACTIONS(2291),
    [anon_sym_GT_AMP] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2267),
    [anon_sym_LT_LT_DASH] = ACTIONS(2267),
    [anon_sym_DQUOTE] = ACTIONS(2297),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(925),
    [sym_raw_string] = ACTIONS(2303),
    [anon_sym_DOLLAR] = ACTIONS(2309),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2315),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2321),
    [anon_sym_BQUOTE] = ACTIONS(2327),
    [anon_sym_LT_LPAREN] = ACTIONS(2336),
    [anon_sym_GT_LPAREN] = ACTIONS(2336),
    [sym_word] = ACTIONS(2342),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_LF] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(2270),
  },
  [977] = {
    [sym_word] = ACTIONS(2348),
    [sym_comment] = ACTIONS(133),
  },
  [978] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(1054),
    [sym_while_statement] = STATE(1054),
    [sym_if_statement] = STATE(1054),
    [sym_case_statement] = STATE(1054),
    [sym_function_definition] = STATE(1054),
    [sym_subshell] = STATE(1054),
    [sym_pipeline] = STATE(1054),
    [sym_list] = STATE(1054),
    [sym_bracket_command] = STATE(1054),
    [sym_command] = STATE(1054),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(1055),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1056),
    [aux_sym_command_repeat1] = STATE(30),
    [aux_sym_array_repeat1] = STATE(320),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_RPAREN] = ACTIONS(2350),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(2352),
    [sym_comment] = ACTIONS(133),
  },
  [979] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1058),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [980] = {
    [sym__heredoc_middle] = ACTIONS(2356),
    [sym__heredoc_end] = ACTIONS(2356),
    [sym_file_descriptor] = ACTIONS(2356),
    [sym__concat] = ACTIONS(2356),
    [sym_variable_name] = ACTIONS(2356),
    [anon_sym_in] = ACTIONS(2367),
    [anon_sym_PIPE] = ACTIONS(2378),
    [anon_sym_RPAREN] = ACTIONS(2378),
    [anon_sym_SEMI_SEMI] = ACTIONS(2378),
    [anon_sym_RBRACE] = ACTIONS(2367),
    [anon_sym_PIPE_AMP] = ACTIONS(2378),
    [anon_sym_AMP_AMP] = ACTIONS(2378),
    [anon_sym_PIPE_PIPE] = ACTIONS(2378),
    [anon_sym_RBRACK] = ACTIONS(2367),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2367),
    [anon_sym_LT] = ACTIONS(2367),
    [anon_sym_GT] = ACTIONS(2367),
    [anon_sym_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_GT] = ACTIONS(2367),
    [anon_sym_AMP_GT_GT] = ACTIONS(2367),
    [anon_sym_LT_AMP] = ACTIONS(2367),
    [anon_sym_GT_AMP] = ACTIONS(2367),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_LT_LT_DASH] = ACTIONS(2367),
    [anon_sym_DQUOTE] = ACTIONS(2367),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2367),
    [sym_raw_string] = ACTIONS(2367),
    [anon_sym_DOLLAR] = ACTIONS(2367),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2367),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2367),
    [anon_sym_BQUOTE] = ACTIONS(2378),
    [anon_sym_LT_LPAREN] = ACTIONS(2367),
    [anon_sym_GT_LPAREN] = ACTIONS(2367),
    [sym_word] = ACTIONS(2367),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2378),
    [anon_sym_LF] = ACTIONS(2378),
    [anon_sym_AMP] = ACTIONS(2378),
  },
  [981] = {
    [sym_concatenation] = STATE(1061),
    [sym_string] = STATE(1059),
    [sym_simple_expansion] = STATE(1059),
    [sym_expansion] = STATE(1059),
    [sym_command_substitution] = STATE(1059),
    [sym_process_substitution] = STATE(1059),
    [aux_sym_for_statement_repeat1] = STATE(1062),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(2391),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_AT] = ACTIONS(2393),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(2395),
    [sym_comment] = ACTIONS(133),
  },
  [982] = {
    [anon_sym_PIPE] = ACTIONS(763),
    [anon_sym_RPAREN] = ACTIONS(763),
    [anon_sym_SEMI_SEMI] = ACTIONS(763),
    [anon_sym_RBRACE] = ACTIONS(2397),
    [anon_sym_PIPE_AMP] = ACTIONS(763),
    [anon_sym_AMP_AMP] = ACTIONS(763),
    [anon_sym_PIPE_PIPE] = ACTIONS(763),
    [anon_sym_EQ] = ACTIONS(2399),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(763),
    [anon_sym_LF] = ACTIONS(763),
    [anon_sym_AMP] = ACTIONS(763),
  },
  [983] = {
    [anon_sym_PIPE] = ACTIONS(763),
    [anon_sym_RPAREN] = ACTIONS(763),
    [anon_sym_SEMI_SEMI] = ACTIONS(763),
    [anon_sym_PIPE_AMP] = ACTIONS(763),
    [anon_sym_AMP_AMP] = ACTIONS(763),
    [anon_sym_PIPE_PIPE] = ACTIONS(763),
    [anon_sym_BQUOTE] = ACTIONS(763),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(763),
    [anon_sym_LF] = ACTIONS(763),
    [anon_sym_AMP] = ACTIONS(763),
  },
  [984] = {
    [sym_concatenation] = STATE(1071),
    [sym_string] = STATE(1065),
    [sym_array] = STATE(139),
    [sym_simple_expansion] = STATE(1065),
    [sym_expansion] = STATE(1065),
    [sym_command_substitution] = STATE(1065),
    [sym_process_substitution] = STATE(1065),
    [sym__empty_value] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_DQUOTE] = ACTIONS(2401),
    [sym_raw_string] = ACTIONS(2403),
    [anon_sym_DOLLAR] = ACTIONS(2405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2409),
    [anon_sym_BQUOTE] = ACTIONS(2411),
    [anon_sym_LT_LPAREN] = ACTIONS(2413),
    [anon_sym_GT_LPAREN] = ACTIONS(2413),
    [sym_word] = ACTIONS(2415),
    [sym_comment] = ACTIONS(133),
  },
  [985] = {
    [sym_concatenation] = STATE(1079),
    [sym_string] = STATE(1073),
    [sym_simple_expansion] = STATE(1073),
    [sym_expansion] = STATE(1073),
    [sym_command_substitution] = STATE(1073),
    [sym_process_substitution] = STATE(1073),
    [anon_sym_DQUOTE] = ACTIONS(2417),
    [sym_raw_string] = ACTIONS(2419),
    [anon_sym_DOLLAR] = ACTIONS(2421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2423),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2425),
    [anon_sym_BQUOTE] = ACTIONS(2427),
    [anon_sym_LT_LPAREN] = ACTIONS(2429),
    [anon_sym_GT_LPAREN] = ACTIONS(2429),
    [sym_word] = ACTIONS(2431),
    [sym_comment] = ACTIONS(133),
  },
  [986] = {
    [sym_simple_expansion] = STATE(70),
    [sym_expansion] = STATE(70),
    [sym_command_substitution] = STATE(70),
    [aux_sym_string_repeat1] = STATE(1026),
    [sym_file_descriptor] = ACTIONS(2433),
    [sym__concat] = ACTIONS(2433),
    [sym_variable_name] = ACTIONS(2433),
    [anon_sym_in] = ACTIONS(2436),
    [anon_sym_PIPE] = ACTIONS(2436),
    [anon_sym_RPAREN] = ACTIONS(2436),
    [anon_sym_SEMI_SEMI] = ACTIONS(2436),
    [anon_sym_RBRACE] = ACTIONS(2436),
    [anon_sym_PIPE_AMP] = ACTIONS(2436),
    [anon_sym_AMP_AMP] = ACTIONS(2436),
    [anon_sym_PIPE_PIPE] = ACTIONS(2436),
    [anon_sym_RBRACK] = ACTIONS(2436),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2436),
    [anon_sym_LT] = ACTIONS(2436),
    [anon_sym_GT] = ACTIONS(2436),
    [anon_sym_GT_GT] = ACTIONS(2436),
    [anon_sym_AMP_GT] = ACTIONS(2436),
    [anon_sym_AMP_GT_GT] = ACTIONS(2436),
    [anon_sym_LT_AMP] = ACTIONS(2436),
    [anon_sym_GT_AMP] = ACTIONS(2436),
    [anon_sym_LT_LT] = ACTIONS(2436),
    [anon_sym_LT_LT_DASH] = ACTIONS(2436),
    [anon_sym_DQUOTE] = ACTIONS(2439),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2443),
    [sym_raw_string] = ACTIONS(2436),
    [anon_sym_DOLLAR] = ACTIONS(2445),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2453),
    [anon_sym_BQUOTE] = ACTIONS(2457),
    [anon_sym_LT_LPAREN] = ACTIONS(2436),
    [anon_sym_GT_LPAREN] = ACTIONS(2436),
    [sym_word] = ACTIONS(2436),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2436),
    [anon_sym_LF] = ACTIONS(2436),
    [anon_sym_AMP] = ACTIONS(2436),
  },
  [987] = {
    [aux_sym_case_item_repeat1] = STATE(722),
    [aux_sym_concatenation_repeat1] = STATE(1025),
    [sym_file_descriptor] = ACTIONS(2461),
    [sym__concat] = ACTIONS(2470),
    [sym_variable_name] = ACTIONS(2474),
    [anon_sym_in] = ACTIONS(2480),
    [anon_sym_PIPE] = ACTIONS(2484),
    [anon_sym_RPAREN] = ACTIONS(2496),
    [anon_sym_SEMI_SEMI] = ACTIONS(2508),
    [anon_sym_RBRACE] = ACTIONS(2518),
    [anon_sym_PIPE_AMP] = ACTIONS(2522),
    [anon_sym_AMP_AMP] = ACTIONS(2522),
    [anon_sym_PIPE_PIPE] = ACTIONS(2522),
    [anon_sym_RBRACK] = ACTIONS(2531),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2537),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2522),
    [anon_sym_LT_AMP] = ACTIONS(2522),
    [anon_sym_GT_AMP] = ACTIONS(2522),
    [anon_sym_LT_LT] = ACTIONS(2542),
    [anon_sym_LT_LT_DASH] = ACTIONS(2542),
    [anon_sym_DQUOTE] = ACTIONS(2522),
    [sym_raw_string] = ACTIONS(2522),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2522),
    [anon_sym_BQUOTE] = ACTIONS(2522),
    [anon_sym_LT_LPAREN] = ACTIONS(2522),
    [anon_sym_GT_LPAREN] = ACTIONS(2522),
    [sym_word] = ACTIONS(2522),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2508),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2508),
  },
  [988] = {
    [sym_special_variable_name] = STATE(1087),
    [sym__heredoc_middle] = ACTIONS(459),
    [sym__heredoc_end] = ACTIONS(459),
    [sym_file_descriptor] = ACTIONS(459),
    [sym__concat] = ACTIONS(459),
    [sym_variable_name] = ACTIONS(459),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(461),
    [anon_sym_RPAREN] = ACTIONS(461),
    [anon_sym_SEMI_SEMI] = ACTIONS(461),
    [anon_sym_RBRACE] = ACTIONS(461),
    [anon_sym_PIPE_AMP] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(471),
    [anon_sym_RBRACK] = ACTIONS(461),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(461),
    [anon_sym_EQ] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(461),
    [anon_sym_AMP_GT] = ACTIONS(461),
    [anon_sym_AMP_GT_GT] = ACTIONS(461),
    [anon_sym_LT_AMP] = ACTIONS(461),
    [anon_sym_GT_AMP] = ACTIONS(461),
    [anon_sym_LT_LT] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_DQUOTE] = ACTIONS(461),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(461),
    [sym_raw_string] = ACTIONS(461),
    [anon_sym_DOLLAR] = ACTIONS(2550),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(461),
    [anon_sym_POUND] = ACTIONS(2553),
    [anon_sym_AT] = ACTIONS(2553),
    [anon_sym_COLON] = ACTIONS(471),
    [anon_sym_COLON_QMARK] = ACTIONS(471),
    [anon_sym_COLON_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(461),
    [anon_sym_BQUOTE] = ACTIONS(461),
    [anon_sym_LT_LPAREN] = ACTIONS(461),
    [anon_sym_GT_LPAREN] = ACTIONS(461),
    [sym_word] = ACTIONS(461),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(2555),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_QMARK] = ACTIONS(2553),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_BANG] = ACTIONS(2553),
    [anon_sym_0] = ACTIONS(2553),
    [anon_sym__] = ACTIONS(2553),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_LF] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(461),
  },
  [989] = {
    [sym_special_variable_name] = STATE(1089),
    [sym__heredoc_middle] = ACTIONS(459),
    [sym__heredoc_end] = ACTIONS(459),
    [sym_file_descriptor] = ACTIONS(459),
    [sym__concat] = ACTIONS(459),
    [sym_variable_name] = ACTIONS(459),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(461),
    [anon_sym_RPAREN] = ACTIONS(461),
    [anon_sym_SEMI_SEMI] = ACTIONS(461),
    [anon_sym_RBRACE] = ACTIONS(461),
    [anon_sym_PIPE_AMP] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(471),
    [anon_sym_RBRACK] = ACTIONS(461),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(461),
    [anon_sym_EQ] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(461),
    [anon_sym_AMP_GT] = ACTIONS(461),
    [anon_sym_AMP_GT_GT] = ACTIONS(461),
    [anon_sym_LT_AMP] = ACTIONS(461),
    [anon_sym_GT_AMP] = ACTIONS(461),
    [anon_sym_LT_LT] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_DQUOTE] = ACTIONS(461),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(461),
    [sym_raw_string] = ACTIONS(461),
    [anon_sym_DOLLAR] = ACTIONS(2557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(461),
    [anon_sym_POUND] = ACTIONS(225),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_COLON] = ACTIONS(471),
    [anon_sym_COLON_QMARK] = ACTIONS(471),
    [anon_sym_COLON_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(461),
    [anon_sym_BQUOTE] = ACTIONS(461),
    [anon_sym_LT_LPAREN] = ACTIONS(461),
    [anon_sym_GT_LPAREN] = ACTIONS(461),
    [sym_word] = ACTIONS(461),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(225),
    [anon_sym_QMARK] = ACTIONS(225),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_BANG] = ACTIONS(225),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_LF] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(461),
  },
  [990] = {
    [sym__heredoc_middle] = ACTIONS(459),
    [sym__heredoc_end] = ACTIONS(459),
    [sym_file_descriptor] = ACTIONS(459),
    [sym__concat] = ACTIONS(459),
    [sym_variable_name] = ACTIONS(459),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(461),
    [anon_sym_RPAREN] = ACTIONS(461),
    [anon_sym_SEMI_SEMI] = ACTIONS(461),
    [anon_sym_RBRACE] = ACTIONS(461),
    [anon_sym_PIPE_AMP] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(471),
    [anon_sym_RBRACK] = ACTIONS(2562),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(461),
    [anon_sym_EQ] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(461),
    [anon_sym_AMP_GT] = ACTIONS(461),
    [anon_sym_AMP_GT_GT] = ACTIONS(461),
    [anon_sym_LT_AMP] = ACTIONS(461),
    [anon_sym_GT_AMP] = ACTIONS(461),
    [anon_sym_LT_LT] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_DQUOTE] = ACTIONS(461),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(461),
    [sym_raw_string] = ACTIONS(461),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(471),
    [anon_sym_COLON_QMARK] = ACTIONS(471),
    [anon_sym_COLON_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(461),
    [anon_sym_BQUOTE] = ACTIONS(461),
    [anon_sym_LT_LPAREN] = ACTIONS(461),
    [anon_sym_GT_LPAREN] = ACTIONS(461),
    [sym_word] = ACTIONS(461),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_LF] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(461),
  },
  [991] = {
    [sym_concatenation] = STATE(1092),
    [sym_string] = STATE(1091),
    [sym_simple_expansion] = STATE(1091),
    [sym_expansion] = STATE(1091),
    [sym_command_substitution] = STATE(1091),
    [sym_process_substitution] = STATE(1091),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(2565),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(2567),
    [sym_comment] = ACTIONS(133),
  },
  [992] = {
    [sym_for_statement] = STATE(1093),
    [sym_while_statement] = STATE(1093),
    [sym_if_statement] = STATE(1093),
    [sym_case_statement] = STATE(1093),
    [sym_function_definition] = STATE(1093),
    [sym_subshell] = STATE(1093),
    [sym_pipeline] = STATE(1093),
    [sym_list] = STATE(1093),
    [sym_bracket_command] = STATE(1093),
    [sym_command] = STATE(1093),
    [sym_command_name] = STATE(109),
    [sym_environment_variable_assignment] = STATE(1094),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(2569),
    [sym__concat] = ACTIONS(923),
    [sym_variable_name] = ACTIONS(2572),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_in] = ACTIONS(925),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_RPAREN] = ACTIONS(925),
    [anon_sym_SEMI_SEMI] = ACTIONS(925),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(2575),
    [anon_sym_RBRACE] = ACTIONS(925),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(925),
    [anon_sym_PIPE_PIPE] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_RBRACK] = ACTIONS(925),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(2577),
    [anon_sym_GT] = ACTIONS(2577),
    [anon_sym_GT_GT] = ACTIONS(2577),
    [anon_sym_AMP_GT] = ACTIONS(2577),
    [anon_sym_AMP_GT_GT] = ACTIONS(2577),
    [anon_sym_LT_AMP] = ACTIONS(2577),
    [anon_sym_GT_AMP] = ACTIONS(2577),
    [anon_sym_LT_LT] = ACTIONS(925),
    [anon_sym_LT_LT_DASH] = ACTIONS(925),
    [anon_sym_DQUOTE] = ACTIONS(2580),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(925),
    [sym_raw_string] = ACTIONS(2583),
    [anon_sym_DOLLAR] = ACTIONS(2586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2592),
    [anon_sym_BQUOTE] = ACTIONS(2595),
    [anon_sym_LT_LPAREN] = ACTIONS(2598),
    [anon_sym_GT_LPAREN] = ACTIONS(2598),
    [sym_word] = ACTIONS(2601),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(925),
    [anon_sym_LF] = ACTIONS(925),
    [anon_sym_AMP] = ACTIONS(925),
  },
  [993] = {
    [sym_for_statement] = STATE(1095),
    [sym_while_statement] = STATE(1095),
    [sym_if_statement] = STATE(1095),
    [sym_case_statement] = STATE(1095),
    [sym_function_definition] = STATE(1095),
    [sym_subshell] = STATE(1095),
    [sym_pipeline] = STATE(1095),
    [sym_list] = STATE(1095),
    [sym_bracket_command] = STATE(1095),
    [sym_command] = STATE(1095),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(1096),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [994] = {
    [sym__heredoc_middle] = ACTIONS(459),
    [sym__heredoc_end] = ACTIONS(459),
    [sym_file_descriptor] = ACTIONS(459),
    [sym__concat] = ACTIONS(459),
    [sym_variable_name] = ACTIONS(459),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(461),
    [anon_sym_RPAREN] = ACTIONS(461),
    [anon_sym_SEMI_SEMI] = ACTIONS(461),
    [anon_sym_RBRACE] = ACTIONS(461),
    [anon_sym_PIPE_AMP] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(471),
    [anon_sym_RBRACK] = ACTIONS(461),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(461),
    [anon_sym_EQ] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(461),
    [anon_sym_AMP_GT] = ACTIONS(461),
    [anon_sym_AMP_GT_GT] = ACTIONS(461),
    [anon_sym_LT_AMP] = ACTIONS(461),
    [anon_sym_GT_AMP] = ACTIONS(461),
    [anon_sym_LT_LT] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_DQUOTE] = ACTIONS(461),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(461),
    [sym_raw_string] = ACTIONS(461),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(461),
    [anon_sym_COLON] = ACTIONS(471),
    [anon_sym_COLON_QMARK] = ACTIONS(471),
    [anon_sym_COLON_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(461),
    [anon_sym_BQUOTE] = ACTIONS(461),
    [anon_sym_LT_LPAREN] = ACTIONS(461),
    [anon_sym_GT_LPAREN] = ACTIONS(461),
    [sym_word] = ACTIONS(461),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_LF] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(461),
  },
  [995] = {
    [sym_do_group] = STATE(1100),
    [sym_case_item] = STATE(555),
    [sym_concatenation] = STATE(556),
    [sym_string] = STATE(554),
    [sym_simple_expansion] = STATE(554),
    [sym_expansion] = STATE(554),
    [sym_command_substitution] = STATE(554),
    [sym_process_substitution] = STATE(554),
    [aux_sym_case_statement_repeat1] = STATE(1021),
    [sym_file_descriptor] = ACTIONS(563),
    [sym_variable_name] = ACTIONS(563),
    [ts_builtin_sym_end] = ACTIONS(563),
    [anon_sym_for] = ACTIONS(565),
    [anon_sym_in] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_do] = ACTIONS(2606),
    [anon_sym_done] = ACTIONS(565),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_then] = ACTIONS(565),
    [anon_sym_fi] = ACTIONS(565),
    [anon_sym_elif] = ACTIONS(565),
    [anon_sym_else] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(565),
    [anon_sym_esac] = ACTIONS(2609),
    [anon_sym_RPAREN] = ACTIONS(2611),
    [anon_sym_SEMI_SEMI] = ACTIONS(563),
    [anon_sym_function] = ACTIONS(565),
    [anon_sym_LPAREN] = ACTIONS(563),
    [anon_sym_RBRACE] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(565),
    [anon_sym_GT] = ACTIONS(565),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_AMP_GT] = ACTIONS(565),
    [anon_sym_AMP_GT_GT] = ACTIONS(563),
    [anon_sym_LT_AMP] = ACTIONS(563),
    [anon_sym_GT_AMP] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(2613),
    [sym_raw_string] = ACTIONS(2616),
    [anon_sym_DOLLAR] = ACTIONS(2619),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2622),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2625),
    [anon_sym_BQUOTE] = ACTIONS(2628),
    [anon_sym_LT_LPAREN] = ACTIONS(2631),
    [anon_sym_GT_LPAREN] = ACTIONS(2631),
    [sym_word] = ACTIONS(2634),
    [sym_comment] = ACTIONS(133),
  },
  [996] = {
    [sym_file_descriptor] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_SEMI_SEMI] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_AMP_GT] = ACTIONS(997),
    [anon_sym_AMP_GT_GT] = ACTIONS(997),
    [anon_sym_LT_AMP] = ACTIONS(997),
    [anon_sym_GT_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_LT_LT_DASH] = ACTIONS(997),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(997),
  },
  [997] = {
    [sym_simple_expansion] = STATE(493),
    [sym_expansion] = STATE(493),
    [aux_sym_heredoc_repeat1] = STATE(1024),
    [sym__heredoc_middle] = ACTIONS(999),
    [sym__heredoc_end] = ACTIONS(2637),
    [anon_sym_DOLLAR] = ACTIONS(1003),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1005),
    [sym_comment] = ACTIONS(133),
  },
  [998] = {
    [sym__heredoc_middle] = ACTIONS(2639),
    [sym__heredoc_end] = ACTIONS(2639),
    [anon_sym_DOLLAR] = ACTIONS(2642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2639),
    [sym_comment] = ACTIONS(133),
  },
  [999] = {
    [sym_file_descriptor] = ACTIONS(2645),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_RPAREN] = ACTIONS(2648),
    [anon_sym_SEMI_SEMI] = ACTIONS(2648),
    [anon_sym_PIPE_AMP] = ACTIONS(2648),
    [anon_sym_AMP_AMP] = ACTIONS(2648),
    [anon_sym_PIPE_PIPE] = ACTIONS(2648),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_GT] = ACTIONS(2648),
    [anon_sym_AMP_GT] = ACTIONS(2648),
    [anon_sym_AMP_GT_GT] = ACTIONS(2648),
    [anon_sym_LT_AMP] = ACTIONS(2648),
    [anon_sym_GT_AMP] = ACTIONS(2648),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_DASH] = ACTIONS(2648),
    [anon_sym_BQUOTE] = ACTIONS(2648),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2648),
    [anon_sym_LF] = ACTIONS(2648),
    [anon_sym_AMP] = ACTIONS(2648),
  },
  [1000] = {
    [anon_sym_LT] = ACTIONS(2651),
    [anon_sym_GT] = ACTIONS(2651),
    [anon_sym_GT_GT] = ACTIONS(2653),
    [anon_sym_AMP_GT] = ACTIONS(2651),
    [anon_sym_AMP_GT_GT] = ACTIONS(2653),
    [anon_sym_LT_AMP] = ACTIONS(2653),
    [anon_sym_GT_AMP] = ACTIONS(2653),
    [sym_comment] = ACTIONS(133),
  },
  [1001] = {
    [sym_string] = STATE(1104),
    [sym_simple_expansion] = STATE(1104),
    [sym_expansion] = STATE(1104),
    [sym_command_substitution] = STATE(1104),
    [sym_process_substitution] = STATE(1104),
    [anon_sym_DQUOTE] = ACTIONS(2655),
    [sym_raw_string] = ACTIONS(2657),
    [anon_sym_DOLLAR] = ACTIONS(2659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2661),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2663),
    [anon_sym_BQUOTE] = ACTIONS(2665),
    [anon_sym_LT_LPAREN] = ACTIONS(2667),
    [anon_sym_GT_LPAREN] = ACTIONS(2667),
    [sym_word] = ACTIONS(2669),
    [sym_comment] = ACTIONS(133),
  },
  [1002] = {
    [sym_do_group] = STATE(1109),
    [sym_file_descriptor] = ACTIONS(2671),
    [sym_variable_name] = ACTIONS(2671),
    [ts_builtin_sym_end] = ACTIONS(2671),
    [anon_sym_for] = ACTIONS(2674),
    [anon_sym_while] = ACTIONS(2674),
    [anon_sym_do] = ACTIONS(2677),
    [anon_sym_done] = ACTIONS(2674),
    [anon_sym_if] = ACTIONS(2674),
    [anon_sym_then] = ACTIONS(2679),
    [anon_sym_fi] = ACTIONS(2674),
    [anon_sym_elif] = ACTIONS(2674),
    [anon_sym_else] = ACTIONS(2674),
    [anon_sym_case] = ACTIONS(2674),
    [anon_sym_SEMI_SEMI] = ACTIONS(2671),
    [anon_sym_function] = ACTIONS(2674),
    [anon_sym_LPAREN] = ACTIONS(2671),
    [anon_sym_RBRACE] = ACTIONS(2671),
    [anon_sym_LBRACK] = ACTIONS(2674),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2674),
    [anon_sym_LT] = ACTIONS(2674),
    [anon_sym_GT] = ACTIONS(2674),
    [anon_sym_GT_GT] = ACTIONS(2671),
    [anon_sym_AMP_GT] = ACTIONS(2674),
    [anon_sym_AMP_GT_GT] = ACTIONS(2671),
    [anon_sym_LT_AMP] = ACTIONS(2671),
    [anon_sym_GT_AMP] = ACTIONS(2671),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_raw_string] = ACTIONS(2671),
    [anon_sym_DOLLAR] = ACTIONS(2674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2671),
    [anon_sym_BQUOTE] = ACTIONS(2671),
    [anon_sym_LT_LPAREN] = ACTIONS(2671),
    [anon_sym_GT_LPAREN] = ACTIONS(2671),
    [sym_word] = ACTIONS(2681),
    [sym_comment] = ACTIONS(133),
  },
  [1003] = {
    [anon_sym_PIPE] = ACTIONS(2684),
    [anon_sym_RPAREN] = ACTIONS(2688),
    [anon_sym_SEMI_SEMI] = ACTIONS(2692),
    [anon_sym_PIPE_AMP] = ACTIONS(2684),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_PIPE_PIPE] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2692),
    [anon_sym_LF] = ACTIONS(2692),
    [anon_sym_AMP] = ACTIONS(2692),
  },
  [1004] = {
    [anon_sym_PIPE] = ACTIONS(2704),
    [anon_sym_RPAREN] = ACTIONS(2704),
    [anon_sym_SEMI_SEMI] = ACTIONS(2704),
    [anon_sym_PIPE_AMP] = ACTIONS(2704),
    [anon_sym_AMP_AMP] = ACTIONS(2704),
    [anon_sym_PIPE_PIPE] = ACTIONS(2704),
    [anon_sym_BQUOTE] = ACTIONS(2704),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2704),
    [anon_sym_LF] = ACTIONS(2704),
    [anon_sym_AMP] = ACTIONS(2704),
  },
  [1005] = {
    [anon_sym_fi] = ACTIONS(2707),
    [anon_sym_elif] = ACTIONS(2707),
    [anon_sym_else] = ACTIONS(2707),
    [sym_comment] = ACTIONS(133),
  },
  [1006] = {
    [anon_sym_fi] = ACTIONS(2710),
    [sym_comment] = ACTIONS(133),
  },
  [1007] = {
    [anon_sym_esac] = ACTIONS(2712),
    [anon_sym_DQUOTE] = ACTIONS(2715),
    [sym_raw_string] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2712),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2715),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2715),
    [anon_sym_BQUOTE] = ACTIONS(2715),
    [anon_sym_LT_LPAREN] = ACTIONS(2715),
    [anon_sym_GT_LPAREN] = ACTIONS(2715),
    [sym_word] = ACTIONS(2718),
    [sym_comment] = ACTIONS(133),
  },
  [1008] = {
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_RPAREN] = ACTIONS(2721),
    [anon_sym_SEMI_SEMI] = ACTIONS(2721),
    [anon_sym_PIPE_AMP] = ACTIONS(2721),
    [anon_sym_AMP_AMP] = ACTIONS(2721),
    [anon_sym_PIPE_PIPE] = ACTIONS(2721),
    [anon_sym_BQUOTE] = ACTIONS(2721),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym_LF] = ACTIONS(2721),
    [anon_sym_AMP] = ACTIONS(2721),
  },
  [1009] = {
    [sym_file_redirect] = STATE(1119),
    [sym_heredoc_redirect] = STATE(1119),
    [sym_concatenation] = STATE(123),
    [sym_string] = STATE(121),
    [sym_simple_expansion] = STATE(121),
    [sym_expansion] = STATE(121),
    [sym_command_substitution] = STATE(121),
    [sym_process_substitution] = STATE(121),
    [aux_sym_for_statement_repeat1] = STATE(1120),
    [aux_sym_command_repeat2] = STATE(1121),
    [sym_file_descriptor] = ACTIONS(2724),
    [anon_sym_PIPE] = ACTIONS(2726),
    [anon_sym_RPAREN] = ACTIONS(2726),
    [anon_sym_SEMI_SEMI] = ACTIONS(2726),
    [anon_sym_PIPE_AMP] = ACTIONS(2726),
    [anon_sym_AMP_AMP] = ACTIONS(2726),
    [anon_sym_PIPE_PIPE] = ACTIONS(2726),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT_GT] = ACTIONS(2729),
    [anon_sym_LT_AMP] = ACTIONS(2729),
    [anon_sym_GT_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2731),
    [anon_sym_LT_LT_DASH] = ACTIONS(2731),
    [anon_sym_DQUOTE] = ACTIONS(285),
    [sym_raw_string] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(291),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [anon_sym_BQUOTE] = ACTIONS(2733),
    [anon_sym_LT_LPAREN] = ACTIONS(297),
    [anon_sym_GT_LPAREN] = ACTIONS(297),
    [sym_word] = ACTIONS(287),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2726),
    [anon_sym_LF] = ACTIONS(2726),
    [anon_sym_AMP] = ACTIONS(2726),
  },
  [1010] = {
    [sym_file_descriptor] = ACTIONS(2737),
    [sym_variable_name] = ACTIONS(2737),
    [anon_sym_PIPE] = ACTIONS(2684),
    [anon_sym_RPAREN] = ACTIONS(2688),
    [anon_sym_SEMI_SEMI] = ACTIONS(2692),
    [anon_sym_PIPE_AMP] = ACTIONS(2684),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_PIPE_PIPE] = ACTIONS(2696),
    [anon_sym_LT] = ACTIONS(2740),
    [anon_sym_GT] = ACTIONS(2740),
    [anon_sym_GT_GT] = ACTIONS(2740),
    [anon_sym_AMP_GT] = ACTIONS(2740),
    [anon_sym_AMP_GT_GT] = ACTIONS(2740),
    [anon_sym_LT_AMP] = ACTIONS(2740),
    [anon_sym_GT_AMP] = ACTIONS(2740),
    [anon_sym_DQUOTE] = ACTIONS(2740),
    [sym_raw_string] = ACTIONS(2740),
    [anon_sym_DOLLAR] = ACTIONS(2740),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2740),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2740),
    [anon_sym_BQUOTE] = ACTIONS(2743),
    [anon_sym_LT_LPAREN] = ACTIONS(2740),
    [anon_sym_GT_LPAREN] = ACTIONS(2740),
    [sym_word] = ACTIONS(2740),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2692),
    [anon_sym_LF] = ACTIONS(2692),
    [anon_sym_AMP] = ACTIONS(2692),
  },
  [1011] = {
    [sym_file_descriptor] = ACTIONS(2749),
    [sym_variable_name] = ACTIONS(2754),
    [anon_sym_PIPE] = ACTIONS(2757),
    [anon_sym_RPAREN] = ACTIONS(2757),
    [anon_sym_SEMI_SEMI] = ACTIONS(2757),
    [anon_sym_PIPE_AMP] = ACTIONS(2757),
    [anon_sym_AMP_AMP] = ACTIONS(2757),
    [anon_sym_PIPE_PIPE] = ACTIONS(2757),
    [anon_sym_LT] = ACTIONS(2760),
    [anon_sym_GT] = ACTIONS(2760),
    [anon_sym_GT_GT] = ACTIONS(2760),
    [anon_sym_AMP_GT] = ACTIONS(2760),
    [anon_sym_AMP_GT_GT] = ACTIONS(2760),
    [anon_sym_LT_AMP] = ACTIONS(2760),
    [anon_sym_GT_AMP] = ACTIONS(2760),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_LT_LT_DASH] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2765),
    [sym_raw_string] = ACTIONS(2765),
    [anon_sym_DOLLAR] = ACTIONS(2765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2765),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2765),
    [anon_sym_BQUOTE] = ACTIONS(2760),
    [anon_sym_LT_LPAREN] = ACTIONS(2765),
    [anon_sym_GT_LPAREN] = ACTIONS(2765),
    [sym_word] = ACTIONS(2765),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2757),
    [anon_sym_LF] = ACTIONS(2757),
    [anon_sym_AMP] = ACTIONS(2757),
  },
  [1012] = {
    [sym_file_descriptor] = ACTIONS(2768),
    [anon_sym_PIPE] = ACTIONS(2757),
    [anon_sym_RPAREN] = ACTIONS(2757),
    [anon_sym_SEMI_SEMI] = ACTIONS(2757),
    [anon_sym_PIPE_AMP] = ACTIONS(2757),
    [anon_sym_AMP_AMP] = ACTIONS(2757),
    [anon_sym_PIPE_PIPE] = ACTIONS(2757),
    [anon_sym_LT] = ACTIONS(2757),
    [anon_sym_GT] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2757),
    [anon_sym_AMP_GT] = ACTIONS(2757),
    [anon_sym_AMP_GT_GT] = ACTIONS(2757),
    [anon_sym_LT_AMP] = ACTIONS(2757),
    [anon_sym_GT_AMP] = ACTIONS(2757),
    [anon_sym_LT_LT] = ACTIONS(2757),
    [anon_sym_LT_LT_DASH] = ACTIONS(2757),
    [anon_sym_BQUOTE] = ACTIONS(2757),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2757),
    [anon_sym_LF] = ACTIONS(2757),
    [anon_sym_AMP] = ACTIONS(2757),
  },
  [1013] = {
    [sym_file_descriptor] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(1009),
    [anon_sym_RPAREN] = ACTIONS(1009),
    [anon_sym_SEMI_SEMI] = ACTIONS(1009),
    [anon_sym_PIPE_AMP] = ACTIONS(1009),
    [anon_sym_AMP_AMP] = ACTIONS(1009),
    [anon_sym_PIPE_PIPE] = ACTIONS(1009),
    [anon_sym_LT] = ACTIONS(1009),
    [anon_sym_GT] = ACTIONS(1009),
    [anon_sym_GT_GT] = ACTIONS(1009),
    [anon_sym_AMP_GT] = ACTIONS(1009),
    [anon_sym_AMP_GT_GT] = ACTIONS(1009),
    [anon_sym_LT_AMP] = ACTIONS(1009),
    [anon_sym_GT_AMP] = ACTIONS(1009),
    [anon_sym_LT_LT] = ACTIONS(1009),
    [anon_sym_LT_LT_DASH] = ACTIONS(1009),
    [anon_sym_BQUOTE] = ACTIONS(1009),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1009),
    [anon_sym_LF] = ACTIONS(1009),
    [anon_sym_AMP] = ACTIONS(1009),
  },
  [1014] = {
    [aux_sym_case_item_repeat1] = STATE(722),
    [sym_file_descriptor] = ACTIONS(2771),
    [sym_variable_name] = ACTIONS(2778),
    [anon_sym_in] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2784),
    [anon_sym_RPAREN] = ACTIONS(2794),
    [anon_sym_SEMI_SEMI] = ACTIONS(2804),
    [anon_sym_RBRACE] = ACTIONS(2812),
    [anon_sym_PIPE_AMP] = ACTIONS(2814),
    [anon_sym_AMP_AMP] = ACTIONS(2814),
    [anon_sym_PIPE_PIPE] = ACTIONS(2814),
    [anon_sym_RBRACK] = ACTIONS(2821),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2825),
    [anon_sym_LT] = ACTIONS(2814),
    [anon_sym_GT] = ACTIONS(2814),
    [anon_sym_GT_GT] = ACTIONS(2814),
    [anon_sym_AMP_GT] = ACTIONS(2814),
    [anon_sym_AMP_GT_GT] = ACTIONS(2814),
    [anon_sym_LT_AMP] = ACTIONS(2814),
    [anon_sym_GT_AMP] = ACTIONS(2814),
    [anon_sym_LT_LT] = ACTIONS(2828),
    [anon_sym_LT_LT_DASH] = ACTIONS(2828),
    [anon_sym_DQUOTE] = ACTIONS(2814),
    [sym_raw_string] = ACTIONS(2814),
    [anon_sym_DOLLAR] = ACTIONS(2814),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2814),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2814),
    [anon_sym_BQUOTE] = ACTIONS(2814),
    [anon_sym_LT_LPAREN] = ACTIONS(2814),
    [anon_sym_GT_LPAREN] = ACTIONS(2814),
    [sym_word] = ACTIONS(2814),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2804),
    [anon_sym_LF] = ACTIONS(2804),
    [anon_sym_AMP] = ACTIONS(2804),
  },
  [1015] = {
    [aux_sym_case_item_repeat1] = STATE(722),
    [aux_sym_concatenation_repeat1] = STATE(1025),
    [sym__heredoc_middle] = ACTIONS(2639),
    [sym__heredoc_end] = ACTIONS(2639),
    [sym_file_descriptor] = ACTIONS(2461),
    [sym__concat] = ACTIONS(2470),
    [sym_variable_name] = ACTIONS(2474),
    [anon_sym_in] = ACTIONS(2480),
    [anon_sym_PIPE] = ACTIONS(2484),
    [anon_sym_RPAREN] = ACTIONS(2496),
    [anon_sym_SEMI_SEMI] = ACTIONS(2508),
    [anon_sym_RBRACE] = ACTIONS(2518),
    [anon_sym_PIPE_AMP] = ACTIONS(2522),
    [anon_sym_AMP_AMP] = ACTIONS(2522),
    [anon_sym_PIPE_PIPE] = ACTIONS(2522),
    [anon_sym_RBRACK] = ACTIONS(2531),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2537),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2522),
    [anon_sym_LT_AMP] = ACTIONS(2522),
    [anon_sym_GT_AMP] = ACTIONS(2522),
    [anon_sym_LT_LT] = ACTIONS(2542),
    [anon_sym_LT_LT_DASH] = ACTIONS(2542),
    [anon_sym_DQUOTE] = ACTIONS(2834),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2845),
    [sym_raw_string] = ACTIONS(2522),
    [anon_sym_DOLLAR] = ACTIONS(2848),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2848),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2834),
    [anon_sym_BQUOTE] = ACTIONS(2834),
    [anon_sym_LT_LPAREN] = ACTIONS(2522),
    [anon_sym_GT_LPAREN] = ACTIONS(2522),
    [sym_word] = ACTIONS(2522),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2508),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2508),
  },
  [1016] = {
    [aux_sym_case_item_repeat1] = STATE(722),
    [aux_sym_concatenation_repeat1] = STATE(1025),
    [sym_file_descriptor] = ACTIONS(2461),
    [sym__concat] = ACTIONS(2470),
    [sym_variable_name] = ACTIONS(2474),
    [anon_sym_in] = ACTIONS(2480),
    [anon_sym_PIPE] = ACTIONS(2484),
    [anon_sym_RPAREN] = ACTIONS(2496),
    [anon_sym_SEMI_SEMI] = ACTIONS(2508),
    [anon_sym_RBRACE] = ACTIONS(2518),
    [anon_sym_PIPE_AMP] = ACTIONS(2522),
    [anon_sym_AMP_AMP] = ACTIONS(2522),
    [anon_sym_PIPE_PIPE] = ACTIONS(2522),
    [anon_sym_RBRACK] = ACTIONS(2531),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2537),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2522),
    [anon_sym_LT_AMP] = ACTIONS(2522),
    [anon_sym_GT_AMP] = ACTIONS(2522),
    [anon_sym_LT_LT] = ACTIONS(2542),
    [anon_sym_LT_LT_DASH] = ACTIONS(2542),
    [anon_sym_DQUOTE] = ACTIONS(2834),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2845),
    [sym_raw_string] = ACTIONS(2522),
    [anon_sym_DOLLAR] = ACTIONS(2834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2834),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2834),
    [anon_sym_BQUOTE] = ACTIONS(2834),
    [anon_sym_LT_LPAREN] = ACTIONS(2522),
    [anon_sym_GT_LPAREN] = ACTIONS(2522),
    [sym_word] = ACTIONS(2522),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2508),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2508),
  },
  [1017] = {
    [sym__heredoc_middle] = ACTIONS(467),
    [sym__heredoc_end] = ACTIONS(467),
    [sym_file_descriptor] = ACTIONS(467),
    [sym__concat] = ACTIONS(467),
    [sym_variable_name] = ACTIONS(467),
    [anon_sym_in] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_RPAREN] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_RBRACE] = ACTIONS(2861),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(2864),
    [anon_sym_RBRACK] = ACTIONS(469),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(2866),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_COLON] = ACTIONS(2868),
    [anon_sym_COLON_QMARK] = ACTIONS(2868),
    [anon_sym_COLON_DASH] = ACTIONS(2868),
    [anon_sym_PERCENT] = ACTIONS(2868),
    [anon_sym_SLASH] = ACTIONS(2868),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
  },
  [1018] = {
    [sym__terminated_statement] = STATE(126),
    [sym_for_statement] = STATE(1129),
    [sym_while_statement] = STATE(1129),
    [sym_if_statement] = STATE(1129),
    [sym_elif_clause] = STATE(351),
    [sym_else_clause] = STATE(1130),
    [sym_case_statement] = STATE(1129),
    [sym_function_definition] = STATE(1129),
    [sym_subshell] = STATE(1129),
    [sym_pipeline] = STATE(1129),
    [sym_list] = STATE(1129),
    [sym_bracket_command] = STATE(1129),
    [sym_command] = STATE(1129),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(1131),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_if_statement_repeat1] = STATE(1132),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [ts_builtin_sym_end] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_done] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_fi] = ACTIONS(2872),
    [anon_sym_elif] = ACTIONS(2876),
    [anon_sym_else] = ACTIONS(2879),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_SEMI_SEMI] = ACTIONS(2882),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [1019] = {
    [sym_file_redirect] = STATE(1119),
    [sym_heredoc_redirect] = STATE(1119),
    [sym_concatenation] = STATE(1141),
    [sym_string] = STATE(1135),
    [sym_simple_expansion] = STATE(1135),
    [sym_expansion] = STATE(1135),
    [sym_command_substitution] = STATE(1135),
    [sym_process_substitution] = STATE(1135),
    [aux_sym_command_repeat2] = STATE(1142),
    [sym_file_descriptor] = ACTIONS(2724),
    [anon_sym_PIPE] = ACTIONS(2886),
    [anon_sym_RPAREN] = ACTIONS(2886),
    [anon_sym_SEMI_SEMI] = ACTIONS(2889),
    [anon_sym_PIPE_AMP] = ACTIONS(2886),
    [anon_sym_AMP_AMP] = ACTIONS(2886),
    [anon_sym_PIPE_PIPE] = ACTIONS(2886),
    [anon_sym_RBRACK] = ACTIONS(2893),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT_GT] = ACTIONS(2729),
    [anon_sym_LT_AMP] = ACTIONS(2729),
    [anon_sym_GT_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2731),
    [anon_sym_LT_LT_DASH] = ACTIONS(2731),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [sym_raw_string] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2903),
    [anon_sym_BQUOTE] = ACTIONS(2905),
    [anon_sym_LT_LPAREN] = ACTIONS(2909),
    [anon_sym_GT_LPAREN] = ACTIONS(2909),
    [sym_word] = ACTIONS(2897),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2889),
    [anon_sym_LF] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2889),
  },
  [1020] = {
    [sym_elif_clause] = STATE(552),
    [sym_else_clause] = STATE(1144),
    [anon_sym_fi] = ACTIONS(2911),
    [anon_sym_elif] = ACTIONS(1137),
    [anon_sym_else] = ACTIONS(1139),
    [sym_comment] = ACTIONS(133),
  },
  [1021] = {
    [sym_case_item] = STATE(724),
    [sym_concatenation] = STATE(556),
    [sym_string] = STATE(554),
    [sym_simple_expansion] = STATE(554),
    [sym_expansion] = STATE(554),
    [sym_command_substitution] = STATE(554),
    [sym_process_substitution] = STATE(554),
    [anon_sym_esac] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(315),
    [sym_raw_string] = ACTIONS(1143),
    [anon_sym_DOLLAR] = ACTIONS(319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(327),
    [anon_sym_GT_LPAREN] = ACTIONS(327),
    [sym_word] = ACTIONS(1145),
    [sym_comment] = ACTIONS(133),
  },
  [1022] = {
    [sym_command_name] = STATE(1146),
    [sym_environment_variable_assignment] = STATE(128),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(128),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(309),
    [sym_comment] = ACTIONS(133),
  },
  [1023] = {
    [sym_file_redirect] = STATE(1147),
    [sym_heredoc_redirect] = STATE(1147),
    [sym_file_descriptor] = ACTIONS(2724),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_RPAREN] = ACTIONS(2915),
    [anon_sym_SEMI_SEMI] = ACTIONS(2915),
    [anon_sym_PIPE_AMP] = ACTIONS(2915),
    [anon_sym_AMP_AMP] = ACTIONS(2915),
    [anon_sym_PIPE_PIPE] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT_GT] = ACTIONS(2729),
    [anon_sym_LT_AMP] = ACTIONS(2729),
    [anon_sym_GT_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2731),
    [anon_sym_LT_LT_DASH] = ACTIONS(2731),
    [anon_sym_BQUOTE] = ACTIONS(2915),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_LF] = ACTIONS(2915),
    [anon_sym_AMP] = ACTIONS(2915),
  },
  [1024] = {
    [sym_simple_expansion] = STATE(679),
    [sym_expansion] = STATE(679),
    [sym__heredoc_middle] = ACTIONS(1435),
    [sym__heredoc_end] = ACTIONS(2919),
    [anon_sym_DOLLAR] = ACTIONS(1003),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1005),
    [sym_comment] = ACTIONS(133),
  },
  [1025] = {
    [sym_file_descriptor] = ACTIONS(453),
    [sym__concat] = ACTIONS(2921),
    [sym_variable_name] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(457),
    [anon_sym_PIPE] = ACTIONS(457),
    [anon_sym_RPAREN] = ACTIONS(457),
    [anon_sym_SEMI_SEMI] = ACTIONS(457),
    [anon_sym_RBRACE] = ACTIONS(457),
    [anon_sym_PIPE_AMP] = ACTIONS(457),
    [anon_sym_AMP_AMP] = ACTIONS(457),
    [anon_sym_PIPE_PIPE] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(457),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(457),
    [anon_sym_AMP_GT] = ACTIONS(457),
    [anon_sym_AMP_GT_GT] = ACTIONS(457),
    [anon_sym_LT_AMP] = ACTIONS(457),
    [anon_sym_GT_AMP] = ACTIONS(457),
    [anon_sym_LT_LT] = ACTIONS(457),
    [anon_sym_LT_LT_DASH] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(457),
    [sym_raw_string] = ACTIONS(457),
    [anon_sym_DOLLAR] = ACTIONS(457),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(457),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(457),
    [anon_sym_BQUOTE] = ACTIONS(457),
    [anon_sym_LT_LPAREN] = ACTIONS(457),
    [anon_sym_GT_LPAREN] = ACTIONS(457),
    [sym_word] = ACTIONS(457),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(457),
    [anon_sym_LF] = ACTIONS(457),
    [anon_sym_AMP] = ACTIONS(457),
  },
  [1026] = {
    [sym_simple_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [anon_sym_DQUOTE] = ACTIONS(2923),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(447),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [1027] = {
    [anon_sym_in] = ACTIONS(2925),
    [sym_comment] = ACTIONS(133),
  },
  [1028] = {
    [sym_case_item] = STATE(555),
    [sym_concatenation] = STATE(556),
    [sym_string] = STATE(554),
    [sym_simple_expansion] = STATE(554),
    [sym_expansion] = STATE(554),
    [sym_command_substitution] = STATE(554),
    [sym_process_substitution] = STATE(554),
    [aux_sym_case_statement_repeat1] = STATE(1021),
    [anon_sym_esac] = ACTIONS(2609),
    [anon_sym_DQUOTE] = ACTIONS(315),
    [sym_raw_string] = ACTIONS(1143),
    [anon_sym_DOLLAR] = ACTIONS(319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(327),
    [anon_sym_GT_LPAREN] = ACTIONS(327),
    [sym_word] = ACTIONS(1145),
    [sym_comment] = ACTIONS(133),
  },
  [1029] = {
    [sym_concatenation] = STATE(545),
    [sym_string] = STATE(544),
    [sym_simple_expansion] = STATE(544),
    [sym_expansion] = STATE(544),
    [sym_command_substitution] = STATE(544),
    [sym_process_substitution] = STATE(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(2927),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [sym_raw_string] = ACTIONS(1111),
    [anon_sym_DOLLAR] = ACTIONS(1113),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1115),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1117),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_LT_LPAREN] = ACTIONS(1121),
    [anon_sym_GT_LPAREN] = ACTIONS(1121),
    [sym_word] = ACTIONS(1111),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2927),
    [anon_sym_LF] = ACTIONS(2927),
    [anon_sym_AMP] = ACTIONS(2927),
  },
  [1030] = {
    [sym_do_group] = STATE(1109),
    [anon_sym_do] = ACTIONS(2929),
    [sym_comment] = ACTIONS(133),
  },
  [1031] = {
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(1123),
    [anon_sym_SEMI_SEMI] = ACTIONS(1123),
    [anon_sym_PIPE_AMP] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LF] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1123),
  },
  [1032] = {
    [sym__terminated_statement] = STATE(126),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_done] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [1033] = {
    [anon_sym_then] = ACTIONS(2931),
    [sym_comment] = ACTIONS(133),
  },
  [1034] = {
    [anon_sym_PIPE] = ACTIONS(1127),
    [anon_sym_RPAREN] = ACTIONS(1127),
    [anon_sym_SEMI_SEMI] = ACTIONS(1127),
    [anon_sym_PIPE_AMP] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1127),
    [anon_sym_PIPE_PIPE] = ACTIONS(1127),
    [anon_sym_BQUOTE] = ACTIONS(1127),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_LF] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1127),
  },
  [1035] = {
    [anon_sym_fi] = ACTIONS(2933),
    [sym_comment] = ACTIONS(133),
  },
  [1036] = {
    [sym__terminated_statement] = STATE(126),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_elif_clause] = STATE(351),
    [sym_else_clause] = STATE(1130),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_if_statement_repeat1] = STATE(1132),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_fi] = ACTIONS(2935),
    [anon_sym_elif] = ACTIONS(2876),
    [anon_sym_else] = ACTIONS(2879),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [1037] = {
    [sym_elif_clause] = STATE(552),
    [sym_else_clause] = STATE(1130),
    [anon_sym_fi] = ACTIONS(2933),
    [anon_sym_elif] = ACTIONS(1137),
    [anon_sym_else] = ACTIONS(1139),
    [sym_comment] = ACTIONS(133),
  },
  [1038] = {
    [aux_sym_concatenation_repeat1] = STATE(158),
    [sym__concat] = ACTIONS(361),
    [anon_sym_in] = ACTIONS(2782),
    [anon_sym_SEMI_SEMI] = ACTIONS(2938),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2938),
    [anon_sym_LF] = ACTIONS(2938),
    [anon_sym_AMP] = ACTIONS(2938),
  },
  [1039] = {
    [anon_sym_in] = ACTIONS(2782),
    [anon_sym_SEMI_SEMI] = ACTIONS(2938),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2938),
    [anon_sym_LF] = ACTIONS(2938),
    [anon_sym_AMP] = ACTIONS(2938),
  },
  [1040] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(1054),
    [sym_while_statement] = STATE(1054),
    [sym_if_statement] = STATE(1054),
    [sym_case_statement] = STATE(1054),
    [sym_function_definition] = STATE(1054),
    [sym_subshell] = STATE(1054),
    [sym_pipeline] = STATE(1054),
    [sym_list] = STATE(1054),
    [sym_bracket_command] = STATE(1054),
    [sym_command] = STATE(1054),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(1055),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1056),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [1041] = {
    [sym_concatenation] = STATE(58),
    [sym_string] = STATE(52),
    [sym_simple_expansion] = STATE(52),
    [sym_expansion] = STATE(52),
    [sym_command_substitution] = STATE(52),
    [sym_process_substitution] = STATE(52),
    [aux_sym_for_statement_repeat1] = STATE(1062),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(177),
    [sym_comment] = ACTIONS(133),
  },
  [1042] = {
    [sym_concatenation] = STATE(58),
    [sym_string] = STATE(52),
    [sym_simple_expansion] = STATE(52),
    [sym_expansion] = STATE(52),
    [sym_command_substitution] = STATE(52),
    [sym_process_substitution] = STATE(52),
    [aux_sym_for_statement_repeat1] = STATE(1153),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(177),
    [sym_comment] = ACTIONS(133),
  },
  [1043] = {
    [aux_sym_concatenation_repeat1] = STATE(77),
    [sym_file_descriptor] = ACTIONS(207),
    [sym__concat] = ACTIONS(209),
    [anon_sym_PIPE] = ACTIONS(2940),
    [anon_sym_RPAREN] = ACTIONS(2940),
    [anon_sym_SEMI_SEMI] = ACTIONS(211),
    [anon_sym_PIPE_AMP] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(211),
    [anon_sym_GT_GT] = ACTIONS(211),
    [anon_sym_AMP_GT] = ACTIONS(211),
    [anon_sym_AMP_GT_GT] = ACTIONS(211),
    [anon_sym_LT_AMP] = ACTIONS(211),
    [anon_sym_GT_AMP] = ACTIONS(211),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(211),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_LT_LPAREN] = ACTIONS(211),
    [anon_sym_GT_LPAREN] = ACTIONS(211),
    [sym_word] = ACTIONS(211),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_LF] = ACTIONS(211),
    [anon_sym_AMP] = ACTIONS(211),
  },
  [1044] = {
    [aux_sym_concatenation_repeat1] = STATE(77),
    [sym_file_descriptor] = ACTIONS(207),
    [sym__concat] = ACTIONS(209),
    [anon_sym_PIPE] = ACTIONS(2940),
    [anon_sym_RPAREN] = ACTIONS(2940),
    [anon_sym_SEMI_SEMI] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(2944),
    [anon_sym_PIPE_AMP] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(211),
    [anon_sym_GT_GT] = ACTIONS(211),
    [anon_sym_AMP_GT] = ACTIONS(211),
    [anon_sym_AMP_GT_GT] = ACTIONS(211),
    [anon_sym_LT_AMP] = ACTIONS(211),
    [anon_sym_GT_AMP] = ACTIONS(211),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(211),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_LT_LPAREN] = ACTIONS(211),
    [anon_sym_GT_LPAREN] = ACTIONS(211),
    [sym_word] = ACTIONS(211),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_LF] = ACTIONS(211),
    [anon_sym_AMP] = ACTIONS(211),
  },
  [1045] = {
    [anon_sym_PIPE] = ACTIONS(2946),
    [anon_sym_RPAREN] = ACTIONS(971),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2949),
    [anon_sym_PIPE_PIPE] = ACTIONS(2949),
    [anon_sym_BQUOTE] = ACTIONS(971),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(971),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(971),
  },
  [1046] = {
    [sym_file_redirect] = STATE(1119),
    [sym_heredoc_redirect] = STATE(1119),
    [sym_concatenation] = STATE(123),
    [sym_string] = STATE(121),
    [sym_simple_expansion] = STATE(121),
    [sym_expansion] = STATE(121),
    [sym_command_substitution] = STATE(121),
    [sym_process_substitution] = STATE(121),
    [aux_sym_for_statement_repeat1] = STATE(1155),
    [aux_sym_command_repeat2] = STATE(1156),
    [sym_file_descriptor] = ACTIONS(2724),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_SEMI_SEMI] = ACTIONS(279),
    [anon_sym_PIPE_AMP] = ACTIONS(279),
    [anon_sym_AMP_AMP] = ACTIONS(279),
    [anon_sym_PIPE_PIPE] = ACTIONS(279),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT_GT] = ACTIONS(2729),
    [anon_sym_LT_AMP] = ACTIONS(2729),
    [anon_sym_GT_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2731),
    [anon_sym_LT_LT_DASH] = ACTIONS(2731),
    [anon_sym_DQUOTE] = ACTIONS(285),
    [sym_raw_string] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(291),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [anon_sym_BQUOTE] = ACTIONS(2952),
    [anon_sym_LT_LPAREN] = ACTIONS(297),
    [anon_sym_GT_LPAREN] = ACTIONS(297),
    [sym_word] = ACTIONS(287),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_AMP] = ACTIONS(279),
  },
  [1047] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(2946),
    [anon_sym_RPAREN] = ACTIONS(971),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2949),
    [anon_sym_PIPE_PIPE] = ACTIONS(2949),
    [anon_sym_LT] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(301),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_AMP_GT] = ACTIONS(301),
    [anon_sym_AMP_GT_GT] = ACTIONS(301),
    [anon_sym_LT_AMP] = ACTIONS(301),
    [anon_sym_GT_AMP] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(301),
    [sym_raw_string] = ACTIONS(301),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(301),
    [anon_sym_BQUOTE] = ACTIONS(2955),
    [anon_sym_LT_LPAREN] = ACTIONS(301),
    [anon_sym_GT_LPAREN] = ACTIONS(301),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(971),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(971),
  },
  [1048] = {
    [sym_file_descriptor] = ACTIONS(207),
    [anon_sym_PIPE] = ACTIONS(2940),
    [anon_sym_RPAREN] = ACTIONS(2940),
    [anon_sym_SEMI_SEMI] = ACTIONS(211),
    [anon_sym_PIPE_AMP] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(211),
    [anon_sym_GT_GT] = ACTIONS(211),
    [anon_sym_AMP_GT] = ACTIONS(211),
    [anon_sym_AMP_GT_GT] = ACTIONS(211),
    [anon_sym_LT_AMP] = ACTIONS(211),
    [anon_sym_GT_AMP] = ACTIONS(211),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(211),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_LT_LPAREN] = ACTIONS(211),
    [anon_sym_GT_LPAREN] = ACTIONS(211),
    [sym_word] = ACTIONS(211),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_LF] = ACTIONS(211),
    [anon_sym_AMP] = ACTIONS(211),
  },
  [1049] = {
    [anon_sym_esac] = ACTIONS(2958),
    [anon_sym_DQUOTE] = ACTIONS(2961),
    [sym_raw_string] = ACTIONS(2961),
    [anon_sym_DOLLAR] = ACTIONS(2958),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2961),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2961),
    [anon_sym_BQUOTE] = ACTIONS(2961),
    [anon_sym_LT_LPAREN] = ACTIONS(2961),
    [anon_sym_GT_LPAREN] = ACTIONS(2961),
    [sym_word] = ACTIONS(2964),
    [sym_comment] = ACTIONS(133),
  },
  [1050] = {
    [sym__terminated_statement] = STATE(126),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_SEMI_SEMI] = ACTIONS(2882),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [1051] = {
    [anon_sym_LPAREN] = ACTIONS(2967),
    [sym_comment] = ACTIONS(133),
  },
  [1052] = {
    [sym_compound_statement] = STATE(1008),
    [sym_file_descriptor] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(2289),
    [anon_sym_PIPE_AMP] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_DOLLAR] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [sym_word] = ACTIONS(1053),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_LF] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [1053] = {
    [aux_sym_concatenation_repeat1] = STATE(77),
    [sym_file_descriptor] = ACTIONS(207),
    [sym__concat] = ACTIONS(209),
    [anon_sym_PIPE] = ACTIONS(211),
    [anon_sym_RPAREN] = ACTIONS(2969),
    [anon_sym_SEMI_SEMI] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(261),
    [anon_sym_PIPE_AMP] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(211),
    [anon_sym_GT_GT] = ACTIONS(211),
    [anon_sym_AMP_GT] = ACTIONS(211),
    [anon_sym_AMP_GT_GT] = ACTIONS(211),
    [anon_sym_LT_AMP] = ACTIONS(211),
    [anon_sym_GT_AMP] = ACTIONS(211),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(211),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_LT_LPAREN] = ACTIONS(211),
    [anon_sym_GT_LPAREN] = ACTIONS(211),
    [sym_word] = ACTIONS(2969),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_LF] = ACTIONS(211),
    [anon_sym_AMP] = ACTIONS(211),
  },
  [1054] = {
    [anon_sym_PIPE] = ACTIONS(271),
    [anon_sym_RPAREN] = ACTIONS(2972),
    [anon_sym_SEMI_SEMI] = ACTIONS(2974),
    [anon_sym_PIPE_AMP] = ACTIONS(271),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2974),
    [anon_sym_LF] = ACTIONS(2974),
    [anon_sym_AMP] = ACTIONS(2974),
  },
  [1055] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(271),
    [anon_sym_RPAREN] = ACTIONS(2972),
    [anon_sym_SEMI_SEMI] = ACTIONS(2974),
    [anon_sym_PIPE_AMP] = ACTIONS(271),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_LT] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(301),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_AMP_GT] = ACTIONS(301),
    [anon_sym_AMP_GT_GT] = ACTIONS(301),
    [anon_sym_LT_AMP] = ACTIONS(301),
    [anon_sym_GT_AMP] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(301),
    [sym_raw_string] = ACTIONS(301),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(301),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(301),
    [anon_sym_GT_LPAREN] = ACTIONS(301),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2974),
    [anon_sym_LF] = ACTIONS(2974),
    [anon_sym_AMP] = ACTIONS(2974),
  },
  [1056] = {
    [sym__terminated_statement] = STATE(126),
    [sym_for_statement] = STATE(1129),
    [sym_while_statement] = STATE(1129),
    [sym_if_statement] = STATE(1129),
    [sym_case_statement] = STATE(1129),
    [sym_function_definition] = STATE(1129),
    [sym_subshell] = STATE(1129),
    [sym_pipeline] = STATE(1129),
    [sym_list] = STATE(1129),
    [sym_bracket_command] = STATE(1129),
    [sym_command] = STATE(1129),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(1131),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [1057] = {
    [anon_sym_PIPE] = ACTIONS(1713),
    [anon_sym_RPAREN] = ACTIONS(1713),
    [anon_sym_SEMI_SEMI] = ACTIONS(1713),
    [anon_sym_PIPE_AMP] = ACTIONS(1713),
    [anon_sym_AMP_AMP] = ACTIONS(1713),
    [anon_sym_PIPE_PIPE] = ACTIONS(1713),
    [anon_sym_BQUOTE] = ACTIONS(1713),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1713),
    [anon_sym_LF] = ACTIONS(1713),
    [anon_sym_AMP] = ACTIONS(1713),
  },
  [1058] = {
    [sym__terminated_statement] = STATE(126),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [1059] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACK] = ACTIONS(2976),
    [anon_sym_DQUOTE] = ACTIONS(389),
    [sym_raw_string] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(389),
    [anon_sym_BQUOTE] = ACTIONS(389),
    [anon_sym_LT_LPAREN] = ACTIONS(389),
    [anon_sym_GT_LPAREN] = ACTIONS(389),
    [sym_word] = ACTIONS(391),
    [sym_comment] = ACTIONS(133),
  },
  [1060] = {
    [anon_sym_RBRACK] = ACTIONS(2979),
    [sym_comment] = ACTIONS(133),
  },
  [1061] = {
    [anon_sym_RBRACK] = ACTIONS(2976),
    [anon_sym_DQUOTE] = ACTIONS(389),
    [sym_raw_string] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(387),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(389),
    [anon_sym_BQUOTE] = ACTIONS(389),
    [anon_sym_LT_LPAREN] = ACTIONS(389),
    [anon_sym_GT_LPAREN] = ACTIONS(389),
    [sym_word] = ACTIONS(391),
    [sym_comment] = ACTIONS(133),
  },
  [1062] = {
    [sym_concatenation] = STATE(194),
    [sym_string] = STATE(193),
    [sym_simple_expansion] = STATE(193),
    [sym_expansion] = STATE(193),
    [sym_command_substitution] = STATE(193),
    [sym_process_substitution] = STATE(193),
    [anon_sym_RBRACK] = ACTIONS(2981),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(405),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(407),
    [sym_comment] = ACTIONS(133),
  },
  [1063] = {
    [sym__heredoc_middle] = ACTIONS(2983),
    [sym__heredoc_end] = ACTIONS(2983),
    [sym_file_descriptor] = ACTIONS(2983),
    [sym__concat] = ACTIONS(2983),
    [sym_variable_name] = ACTIONS(2983),
    [anon_sym_in] = ACTIONS(2988),
    [anon_sym_PIPE] = ACTIONS(2988),
    [anon_sym_RPAREN] = ACTIONS(2988),
    [anon_sym_SEMI_SEMI] = ACTIONS(2988),
    [anon_sym_RBRACE] = ACTIONS(2988),
    [anon_sym_PIPE_AMP] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_RBRACK] = ACTIONS(2988),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2988),
    [anon_sym_LT] = ACTIONS(2988),
    [anon_sym_GT] = ACTIONS(2988),
    [anon_sym_GT_GT] = ACTIONS(2988),
    [anon_sym_AMP_GT] = ACTIONS(2988),
    [anon_sym_AMP_GT_GT] = ACTIONS(2988),
    [anon_sym_LT_AMP] = ACTIONS(2988),
    [anon_sym_GT_AMP] = ACTIONS(2988),
    [anon_sym_LT_LT] = ACTIONS(2988),
    [anon_sym_LT_LT_DASH] = ACTIONS(2988),
    [anon_sym_DQUOTE] = ACTIONS(2988),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2988),
    [sym_raw_string] = ACTIONS(2988),
    [anon_sym_DOLLAR] = ACTIONS(2988),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2988),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2988),
    [anon_sym_BQUOTE] = ACTIONS(2988),
    [anon_sym_LT_LPAREN] = ACTIONS(2988),
    [anon_sym_GT_LPAREN] = ACTIONS(2988),
    [sym_word] = ACTIONS(2988),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2988),
    [anon_sym_LF] = ACTIONS(2988),
    [anon_sym_AMP] = ACTIONS(2988),
  },
  [1064] = {
    [sym_simple_expansion] = STATE(70),
    [sym_expansion] = STATE(70),
    [sym_command_substitution] = STATE(70),
    [aux_sym_string_repeat1] = STATE(1161),
    [anon_sym_DQUOTE] = ACTIONS(2993),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(197),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [1065] = {
    [aux_sym_concatenation_repeat1] = STATE(1163),
    [sym_file_descriptor] = ACTIONS(633),
    [sym__concat] = ACTIONS(2995),
    [sym_variable_name] = ACTIONS(633),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_RPAREN] = ACTIONS(635),
    [anon_sym_SEMI_SEMI] = ACTIONS(635),
    [anon_sym_RBRACE] = ACTIONS(2812),
    [anon_sym_PIPE_AMP] = ACTIONS(635),
    [anon_sym_AMP_AMP] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_GT_GT] = ACTIONS(635),
    [anon_sym_AMP_GT] = ACTIONS(635),
    [anon_sym_AMP_GT_GT] = ACTIONS(635),
    [anon_sym_LT_AMP] = ACTIONS(635),
    [anon_sym_GT_AMP] = ACTIONS(635),
    [anon_sym_DQUOTE] = ACTIONS(635),
    [sym_raw_string] = ACTIONS(635),
    [anon_sym_DOLLAR] = ACTIONS(635),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(635),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [anon_sym_LT_LPAREN] = ACTIONS(635),
    [anon_sym_GT_LPAREN] = ACTIONS(635),
    [sym_word] = ACTIONS(635),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(635),
    [anon_sym_LF] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
  },
  [1066] = {
    [sym_special_variable_name] = STATE(1166),
    [anon_sym_DOLLAR] = ACTIONS(2997),
    [anon_sym_POUND] = ACTIONS(2999),
    [anon_sym_AT] = ACTIONS(2997),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(3001),
    [anon_sym_STAR] = ACTIONS(2997),
    [anon_sym_QMARK] = ACTIONS(2997),
    [anon_sym_DASH] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2997),
    [anon_sym_0] = ACTIONS(2999),
    [anon_sym__] = ACTIONS(2999),
  },
  [1067] = {
    [sym_special_variable_name] = STATE(1169),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(3003),
    [anon_sym_AT] = ACTIONS(219),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(3005),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [1068] = {
    [sym_for_statement] = STATE(1170),
    [sym_while_statement] = STATE(1170),
    [sym_if_statement] = STATE(1170),
    [sym_case_statement] = STATE(1170),
    [sym_function_definition] = STATE(1170),
    [sym_subshell] = STATE(1170),
    [sym_pipeline] = STATE(1170),
    [sym_list] = STATE(1170),
    [sym_bracket_command] = STATE(1170),
    [sym_command] = STATE(1170),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(1171),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [1069] = {
    [sym_for_statement] = STATE(1172),
    [sym_while_statement] = STATE(1172),
    [sym_if_statement] = STATE(1172),
    [sym_case_statement] = STATE(1172),
    [sym_function_definition] = STATE(1172),
    [sym_subshell] = STATE(1172),
    [sym_pipeline] = STATE(1172),
    [sym_list] = STATE(1172),
    [sym_bracket_command] = STATE(1172),
    [sym_command] = STATE(1172),
    [sym_command_name] = STATE(109),
    [sym_environment_variable_assignment] = STATE(1173),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [1070] = {
    [sym_for_statement] = STATE(1174),
    [sym_while_statement] = STATE(1174),
    [sym_if_statement] = STATE(1174),
    [sym_case_statement] = STATE(1174),
    [sym_function_definition] = STATE(1174),
    [sym_subshell] = STATE(1174),
    [sym_pipeline] = STATE(1174),
    [sym_list] = STATE(1174),
    [sym_bracket_command] = STATE(1174),
    [sym_command] = STATE(1174),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(1175),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [1071] = {
    [sym_file_descriptor] = ACTIONS(633),
    [sym_variable_name] = ACTIONS(633),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_RPAREN] = ACTIONS(635),
    [anon_sym_SEMI_SEMI] = ACTIONS(635),
    [anon_sym_RBRACE] = ACTIONS(2812),
    [anon_sym_PIPE_AMP] = ACTIONS(635),
    [anon_sym_AMP_AMP] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_GT_GT] = ACTIONS(635),
    [anon_sym_AMP_GT] = ACTIONS(635),
    [anon_sym_AMP_GT_GT] = ACTIONS(635),
    [anon_sym_LT_AMP] = ACTIONS(635),
    [anon_sym_GT_AMP] = ACTIONS(635),
    [anon_sym_DQUOTE] = ACTIONS(635),
    [sym_raw_string] = ACTIONS(635),
    [anon_sym_DOLLAR] = ACTIONS(635),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(635),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [anon_sym_LT_LPAREN] = ACTIONS(635),
    [anon_sym_GT_LPAREN] = ACTIONS(635),
    [sym_word] = ACTIONS(635),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(635),
    [anon_sym_LF] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
  },
  [1072] = {
    [sym_simple_expansion] = STATE(70),
    [sym_expansion] = STATE(70),
    [sym_command_substitution] = STATE(70),
    [aux_sym_string_repeat1] = STATE(1177),
    [anon_sym_DQUOTE] = ACTIONS(3007),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(197),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [1073] = {
    [aux_sym_concatenation_repeat1] = STATE(1179),
    [sym_file_descriptor] = ACTIONS(3009),
    [sym__concat] = ACTIONS(3012),
    [sym_variable_name] = ACTIONS(3009),
    [anon_sym_PIPE] = ACTIONS(3014),
    [anon_sym_RPAREN] = ACTIONS(3014),
    [anon_sym_SEMI_SEMI] = ACTIONS(3014),
    [anon_sym_PIPE_AMP] = ACTIONS(3014),
    [anon_sym_AMP_AMP] = ACTIONS(3014),
    [anon_sym_PIPE_PIPE] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(3014),
    [anon_sym_GT] = ACTIONS(3014),
    [anon_sym_GT_GT] = ACTIONS(3014),
    [anon_sym_AMP_GT] = ACTIONS(3014),
    [anon_sym_AMP_GT_GT] = ACTIONS(3014),
    [anon_sym_LT_AMP] = ACTIONS(3014),
    [anon_sym_GT_AMP] = ACTIONS(3014),
    [anon_sym_LT_LT] = ACTIONS(3014),
    [anon_sym_LT_LT_DASH] = ACTIONS(3014),
    [anon_sym_DQUOTE] = ACTIONS(3014),
    [sym_raw_string] = ACTIONS(3014),
    [anon_sym_DOLLAR] = ACTIONS(3014),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3014),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3014),
    [anon_sym_BQUOTE] = ACTIONS(3014),
    [anon_sym_LT_LPAREN] = ACTIONS(3014),
    [anon_sym_GT_LPAREN] = ACTIONS(3014),
    [sym_word] = ACTIONS(3014),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(3014),
    [anon_sym_LF] = ACTIONS(3014),
    [anon_sym_AMP] = ACTIONS(3014),
  },
  [1074] = {
    [sym_special_variable_name] = STATE(1182),
    [anon_sym_DOLLAR] = ACTIONS(3017),
    [anon_sym_POUND] = ACTIONS(3019),
    [anon_sym_AT] = ACTIONS(3017),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(3021),
    [anon_sym_STAR] = ACTIONS(3017),
    [anon_sym_QMARK] = ACTIONS(3017),
    [anon_sym_DASH] = ACTIONS(3017),
    [anon_sym_BANG] = ACTIONS(3017),
    [anon_sym_0] = ACTIONS(3019),
    [anon_sym__] = ACTIONS(3019),
  },
  [1075] = {
    [sym_special_variable_name] = STATE(1185),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(3023),
    [anon_sym_AT] = ACTIONS(219),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(3025),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [1076] = {
    [sym_for_statement] = STATE(1186),
    [sym_while_statement] = STATE(1186),
    [sym_if_statement] = STATE(1186),
    [sym_case_statement] = STATE(1186),
    [sym_function_definition] = STATE(1186),
    [sym_subshell] = STATE(1186),
    [sym_pipeline] = STATE(1186),
    [sym_list] = STATE(1186),
    [sym_bracket_command] = STATE(1186),
    [sym_command] = STATE(1186),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(1187),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [1077] = {
    [sym_for_statement] = STATE(1188),
    [sym_while_statement] = STATE(1188),
    [sym_if_statement] = STATE(1188),
    [sym_case_statement] = STATE(1188),
    [sym_function_definition] = STATE(1188),
    [sym_subshell] = STATE(1188),
    [sym_pipeline] = STATE(1188),
    [sym_list] = STATE(1188),
    [sym_bracket_command] = STATE(1188),
    [sym_command] = STATE(1188),
    [sym_command_name] = STATE(109),
    [sym_environment_variable_assignment] = STATE(1189),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [1078] = {
    [sym_for_statement] = STATE(1190),
    [sym_while_statement] = STATE(1190),
    [sym_if_statement] = STATE(1190),
    [sym_case_statement] = STATE(1190),
    [sym_function_definition] = STATE(1190),
    [sym_subshell] = STATE(1190),
    [sym_pipeline] = STATE(1190),
    [sym_list] = STATE(1190),
    [sym_bracket_command] = STATE(1190),
    [sym_command] = STATE(1190),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(1191),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [1079] = {
    [sym_file_descriptor] = ACTIONS(3009),
    [sym_variable_name] = ACTIONS(3009),
    [anon_sym_PIPE] = ACTIONS(3014),
    [anon_sym_RPAREN] = ACTIONS(3014),
    [anon_sym_SEMI_SEMI] = ACTIONS(3014),
    [anon_sym_PIPE_AMP] = ACTIONS(3014),
    [anon_sym_AMP_AMP] = ACTIONS(3014),
    [anon_sym_PIPE_PIPE] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(3014),
    [anon_sym_GT] = ACTIONS(3014),
    [anon_sym_GT_GT] = ACTIONS(3014),
    [anon_sym_AMP_GT] = ACTIONS(3014),
    [anon_sym_AMP_GT_GT] = ACTIONS(3014),
    [anon_sym_LT_AMP] = ACTIONS(3014),
    [anon_sym_GT_AMP] = ACTIONS(3014),
    [anon_sym_LT_LT] = ACTIONS(3014),
    [anon_sym_LT_LT_DASH] = ACTIONS(3014),
    [anon_sym_DQUOTE] = ACTIONS(3014),
    [sym_raw_string] = ACTIONS(3014),
    [anon_sym_DOLLAR] = ACTIONS(3014),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3014),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3014),
    [anon_sym_BQUOTE] = ACTIONS(3014),
    [anon_sym_LT_LPAREN] = ACTIONS(3014),
    [anon_sym_GT_LPAREN] = ACTIONS(3014),
    [sym_word] = ACTIONS(3014),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(3014),
    [anon_sym_LF] = ACTIONS(3014),
    [anon_sym_AMP] = ACTIONS(3014),
  },
  [1080] = {
    [sym_file_descriptor] = ACTIONS(427),
    [sym__concat] = ACTIONS(427),
    [sym_variable_name] = ACTIONS(427),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(429),
    [anon_sym_SEMI_SEMI] = ACTIONS(429),
    [anon_sym_RBRACE] = ACTIONS(429),
    [anon_sym_PIPE_AMP] = ACTIONS(429),
    [anon_sym_AMP_AMP] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(429),
    [anon_sym_RBRACK] = ACTIONS(429),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_GT] = ACTIONS(429),
    [anon_sym_AMP_GT] = ACTIONS(429),
    [anon_sym_AMP_GT_GT] = ACTIONS(429),
    [anon_sym_LT_AMP] = ACTIONS(429),
    [anon_sym_GT_AMP] = ACTIONS(429),
    [anon_sym_LT_LT] = ACTIONS(429),
    [anon_sym_LT_LT_DASH] = ACTIONS(429),
    [anon_sym_DQUOTE] = ACTIONS(429),
    [sym_raw_string] = ACTIONS(429),
    [anon_sym_DOLLAR] = ACTIONS(429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(429),
    [anon_sym_BQUOTE] = ACTIONS(429),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [sym_word] = ACTIONS(429),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(429),
    [anon_sym_LF] = ACTIONS(429),
    [anon_sym_AMP] = ACTIONS(429),
  },
  [1081] = {
    [sym_string] = STATE(1192),
    [sym_simple_expansion] = STATE(1192),
    [sym_expansion] = STATE(1192),
    [sym_command_substitution] = STATE(1192),
    [sym_process_substitution] = STATE(1192),
    [anon_sym_DQUOTE] = ACTIONS(2655),
    [sym_raw_string] = ACTIONS(3027),
    [anon_sym_DOLLAR] = ACTIONS(2659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2661),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2663),
    [anon_sym_BQUOTE] = ACTIONS(2665),
    [anon_sym_LT_LPAREN] = ACTIONS(2667),
    [anon_sym_GT_LPAREN] = ACTIONS(2667),
    [sym_word] = ACTIONS(3029),
    [sym_comment] = ACTIONS(133),
  },
  [1082] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(3031),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(3031),
    [anon_sym_LF] = ACTIONS(3031),
    [anon_sym_AMP] = ACTIONS(3031),
  },
  [1083] = {
    [anon_sym_in] = ACTIONS(3033),
    [sym_comment] = ACTIONS(133),
  },
  [1084] = {
    [sym__heredoc_middle] = ACTIONS(3035),
    [sym__heredoc_end] = ACTIONS(3035),
    [sym_file_descriptor] = ACTIONS(3035),
    [sym__concat] = ACTIONS(3035),
    [sym_variable_name] = ACTIONS(3035),
    [anon_sym_in] = ACTIONS(3038),
    [anon_sym_PIPE] = ACTIONS(3038),
    [anon_sym_RPAREN] = ACTIONS(3038),
    [anon_sym_SEMI_SEMI] = ACTIONS(3038),
    [anon_sym_RBRACE] = ACTIONS(3038),
    [anon_sym_PIPE_AMP] = ACTIONS(3038),
    [anon_sym_AMP_AMP] = ACTIONS(3038),
    [anon_sym_PIPE_PIPE] = ACTIONS(3038),
    [anon_sym_RBRACK] = ACTIONS(3038),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3038),
    [anon_sym_LT] = ACTIONS(3038),
    [anon_sym_GT] = ACTIONS(3038),
    [anon_sym_GT_GT] = ACTIONS(3038),
    [anon_sym_AMP_GT] = ACTIONS(3038),
    [anon_sym_AMP_GT_GT] = ACTIONS(3038),
    [anon_sym_LT_AMP] = ACTIONS(3038),
    [anon_sym_GT_AMP] = ACTIONS(3038),
    [anon_sym_LT_LT] = ACTIONS(3038),
    [anon_sym_LT_LT_DASH] = ACTIONS(3038),
    [anon_sym_DQUOTE] = ACTIONS(3038),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(3038),
    [sym_raw_string] = ACTIONS(3038),
    [anon_sym_DOLLAR] = ACTIONS(3038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3038),
    [anon_sym_BQUOTE] = ACTIONS(3038),
    [anon_sym_LT_LPAREN] = ACTIONS(3038),
    [anon_sym_GT_LPAREN] = ACTIONS(3038),
    [sym_word] = ACTIONS(3038),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(3038),
    [anon_sym_LF] = ACTIONS(3038),
    [anon_sym_AMP] = ACTIONS(3038),
  },
  [1085] = {
    [sym__heredoc_middle] = ACTIONS(459),
    [sym__heredoc_end] = ACTIONS(459),
    [sym_file_descriptor] = ACTIONS(459),
    [sym__concat] = ACTIONS(459),
    [sym_variable_name] = ACTIONS(459),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(461),
    [anon_sym_RPAREN] = ACTIONS(461),
    [anon_sym_SEMI_SEMI] = ACTIONS(461),
    [anon_sym_RBRACE] = ACTIONS(461),
    [anon_sym_PIPE_AMP] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_RBRACK] = ACTIONS(461),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(461),
    [anon_sym_AMP_GT] = ACTIONS(461),
    [anon_sym_AMP_GT_GT] = ACTIONS(461),
    [anon_sym_LT_AMP] = ACTIONS(461),
    [anon_sym_GT_AMP] = ACTIONS(461),
    [anon_sym_LT_LT] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_DQUOTE] = ACTIONS(461),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(461),
    [sym_raw_string] = ACTIONS(461),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(461),
    [anon_sym_BQUOTE] = ACTIONS(461),
    [anon_sym_LT_LPAREN] = ACTIONS(461),
    [anon_sym_GT_LPAREN] = ACTIONS(461),
    [sym_word] = ACTIONS(461),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_LF] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(461),
  },
  [1086] = {
    [sym__heredoc_middle] = ACTIONS(463),
    [sym__heredoc_end] = ACTIONS(463),
    [sym_file_descriptor] = ACTIONS(463),
    [sym__concat] = ACTIONS(463),
    [sym_variable_name] = ACTIONS(463),
    [anon_sym_in] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_SEMI_SEMI] = ACTIONS(465),
    [anon_sym_RBRACE] = ACTIONS(465),
    [anon_sym_PIPE_AMP] = ACTIONS(465),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE_PIPE] = ACTIONS(465),
    [anon_sym_RBRACK] = ACTIONS(465),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(465),
    [anon_sym_LT] = ACTIONS(465),
    [anon_sym_GT] = ACTIONS(465),
    [anon_sym_GT_GT] = ACTIONS(465),
    [anon_sym_AMP_GT] = ACTIONS(465),
    [anon_sym_AMP_GT_GT] = ACTIONS(465),
    [anon_sym_LT_AMP] = ACTIONS(465),
    [anon_sym_GT_AMP] = ACTIONS(465),
    [anon_sym_LT_LT] = ACTIONS(465),
    [anon_sym_LT_LT_DASH] = ACTIONS(465),
    [anon_sym_DQUOTE] = ACTIONS(465),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(465),
    [sym_raw_string] = ACTIONS(465),
    [anon_sym_DOLLAR] = ACTIONS(465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(465),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(465),
    [anon_sym_BQUOTE] = ACTIONS(465),
    [anon_sym_LT_LPAREN] = ACTIONS(465),
    [anon_sym_GT_LPAREN] = ACTIONS(465),
    [sym_word] = ACTIONS(465),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(465),
    [anon_sym_LF] = ACTIONS(465),
    [anon_sym_AMP] = ACTIONS(465),
  },
  [1087] = {
    [sym__heredoc_middle] = ACTIONS(467),
    [sym__heredoc_end] = ACTIONS(467),
    [sym_file_descriptor] = ACTIONS(467),
    [sym__concat] = ACTIONS(467),
    [sym_variable_name] = ACTIONS(467),
    [anon_sym_in] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_RPAREN] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_RBRACE] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [anon_sym_RBRACK] = ACTIONS(469),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
  },
  [1088] = {
    [anon_sym_RBRACE] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [sym_comment] = ACTIONS(133),
  },
  [1089] = {
    [anon_sym_RBRACE] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [sym_comment] = ACTIONS(133),
  },
  [1090] = {
    [anon_sym_RBRACE] = ACTIONS(3049),
    [sym_comment] = ACTIONS(133),
  },
  [1091] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(3051),
    [sym_comment] = ACTIONS(133),
  },
  [1092] = {
    [anon_sym_RBRACE] = ACTIONS(3051),
    [sym_comment] = ACTIONS(133),
  },
  [1093] = {
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(3053),
    [sym_comment] = ACTIONS(133),
  },
  [1094] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(3055),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [1095] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(3058),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [1096] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(3058),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [1097] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(3060),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(3060),
    [anon_sym_LF] = ACTIONS(3060),
    [anon_sym_AMP] = ACTIONS(3060),
  },
  [1098] = {
    [anon_sym_PIPE] = ACTIONS(3062),
    [anon_sym_RPAREN] = ACTIONS(3062),
    [anon_sym_SEMI_SEMI] = ACTIONS(3062),
    [anon_sym_PIPE_AMP] = ACTIONS(3062),
    [anon_sym_AMP_AMP] = ACTIONS(3062),
    [anon_sym_PIPE_PIPE] = ACTIONS(3062),
    [anon_sym_BQUOTE] = ACTIONS(3062),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(3062),
    [anon_sym_LF] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3062),
  },
  [1099] = {
    [anon_sym_PIPE] = ACTIONS(3065),
    [anon_sym_RPAREN] = ACTIONS(3065),
    [anon_sym_SEMI_SEMI] = ACTIONS(3065),
    [anon_sym_PIPE_AMP] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3065),
    [anon_sym_PIPE_PIPE] = ACTIONS(3065),
    [anon_sym_BQUOTE] = ACTIONS(3065),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym_LF] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3065),
  },
  [1100] = {
    [anon_sym_PIPE] = ACTIONS(1815),
    [anon_sym_RPAREN] = ACTIONS(1815),
    [anon_sym_SEMI_SEMI] = ACTIONS(1815),
    [anon_sym_PIPE_AMP] = ACTIONS(1815),
    [anon_sym_AMP_AMP] = ACTIONS(1815),
    [anon_sym_PIPE_PIPE] = ACTIONS(1815),
    [anon_sym_BQUOTE] = ACTIONS(1815),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1815),
    [anon_sym_LF] = ACTIONS(1815),
    [anon_sym_AMP] = ACTIONS(1815),
  },
  [1101] = {
    [sym_file_descriptor] = ACTIONS(1421),
    [anon_sym_PIPE] = ACTIONS(1423),
    [anon_sym_RPAREN] = ACTIONS(1423),
    [anon_sym_SEMI_SEMI] = ACTIONS(1423),
    [anon_sym_PIPE_AMP] = ACTIONS(1423),
    [anon_sym_AMP_AMP] = ACTIONS(1423),
    [anon_sym_PIPE_PIPE] = ACTIONS(1423),
    [anon_sym_LT] = ACTIONS(1423),
    [anon_sym_GT] = ACTIONS(1423),
    [anon_sym_GT_GT] = ACTIONS(1423),
    [anon_sym_AMP_GT] = ACTIONS(1423),
    [anon_sym_AMP_GT_GT] = ACTIONS(1423),
    [anon_sym_LT_AMP] = ACTIONS(1423),
    [anon_sym_GT_AMP] = ACTIONS(1423),
    [anon_sym_LT_LT] = ACTIONS(1423),
    [anon_sym_LT_LT_DASH] = ACTIONS(1423),
    [anon_sym_BQUOTE] = ACTIONS(1423),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1423),
    [anon_sym_LF] = ACTIONS(1423),
    [anon_sym_AMP] = ACTIONS(1423),
  },
  [1102] = {
    [sym_concatenation] = STATE(1201),
    [sym_string] = STATE(1200),
    [sym_simple_expansion] = STATE(1200),
    [sym_expansion] = STATE(1200),
    [sym_command_substitution] = STATE(1200),
    [sym_process_substitution] = STATE(1200),
    [anon_sym_DQUOTE] = ACTIONS(2417),
    [sym_raw_string] = ACTIONS(3068),
    [anon_sym_DOLLAR] = ACTIONS(2421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2423),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2425),
    [anon_sym_BQUOTE] = ACTIONS(2427),
    [anon_sym_LT_LPAREN] = ACTIONS(2429),
    [anon_sym_GT_LPAREN] = ACTIONS(2429),
    [sym_word] = ACTIONS(3070),
    [sym_comment] = ACTIONS(133),
  },
  [1103] = {
    [sym_simple_expansion] = STATE(70),
    [sym_expansion] = STATE(70),
    [sym_command_substitution] = STATE(70),
    [aux_sym_string_repeat1] = STATE(1026),
    [anon_sym_DQUOTE] = ACTIONS(3072),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(197),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [1104] = {
    [sym_file_descriptor] = ACTIONS(3074),
    [sym__concat] = ACTIONS(3074),
    [sym_variable_name] = ACTIONS(3074),
    [anon_sym_in] = ACTIONS(3077),
    [anon_sym_PIPE] = ACTIONS(3077),
    [anon_sym_RPAREN] = ACTIONS(3077),
    [anon_sym_SEMI_SEMI] = ACTIONS(3077),
    [anon_sym_RBRACE] = ACTIONS(3077),
    [anon_sym_PIPE_AMP] = ACTIONS(3077),
    [anon_sym_AMP_AMP] = ACTIONS(3077),
    [anon_sym_PIPE_PIPE] = ACTIONS(3077),
    [anon_sym_RBRACK] = ACTIONS(3077),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3077),
    [anon_sym_LT] = ACTIONS(3077),
    [anon_sym_GT] = ACTIONS(3077),
    [anon_sym_GT_GT] = ACTIONS(3077),
    [anon_sym_AMP_GT] = ACTIONS(3077),
    [anon_sym_AMP_GT_GT] = ACTIONS(3077),
    [anon_sym_LT_AMP] = ACTIONS(3077),
    [anon_sym_GT_AMP] = ACTIONS(3077),
    [anon_sym_LT_LT] = ACTIONS(3077),
    [anon_sym_LT_LT_DASH] = ACTIONS(3077),
    [anon_sym_DQUOTE] = ACTIONS(3077),
    [sym_raw_string] = ACTIONS(3077),
    [anon_sym_DOLLAR] = ACTIONS(3077),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3077),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3077),
    [anon_sym_BQUOTE] = ACTIONS(3077),
    [anon_sym_LT_LPAREN] = ACTIONS(3077),
    [anon_sym_GT_LPAREN] = ACTIONS(3077),
    [sym_word] = ACTIONS(3077),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(3077),
    [anon_sym_LF] = ACTIONS(3077),
    [anon_sym_AMP] = ACTIONS(3077),
  },
  [1105] = {
    [sym_special_variable_name] = STATE(1204),
    [anon_sym_DOLLAR] = ACTIONS(3080),
    [anon_sym_POUND] = ACTIONS(3082),
    [anon_sym_AT] = ACTIONS(3080),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_QMARK] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3080),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_0] = ACTIONS(3082),
    [anon_sym__] = ACTIONS(3082),
  },
  [1106] = {
    [sym_special_variable_name] = STATE(1207),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(3086),
    [anon_sym_AT] = ACTIONS(219),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(3088),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [1107] = {
    [sym_for_statement] = STATE(1208),
    [sym_while_statement] = STATE(1208),
    [sym_if_statement] = STATE(1208),
    [sym_case_statement] = STATE(1208),
    [sym_function_definition] = STATE(1208),
    [sym_subshell] = STATE(1208),
    [sym_pipeline] = STATE(1208),
    [sym_list] = STATE(1208),
    [sym_bracket_command] = STATE(1208),
    [sym_command] = STATE(1208),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(1209),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [1108] = {
    [sym_for_statement] = STATE(1210),
    [sym_while_statement] = STATE(1210),
    [sym_if_statement] = STATE(1210),
    [sym_case_statement] = STATE(1210),
    [sym_function_definition] = STATE(1210),
    [sym_subshell] = STATE(1210),
    [sym_pipeline] = STATE(1210),
    [sym_list] = STATE(1210),
    [sym_bracket_command] = STATE(1210),
    [sym_command] = STATE(1210),
    [sym_command_name] = STATE(109),
    [sym_environment_variable_assignment] = STATE(1211),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [1109] = {
    [anon_sym_PIPE] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(673),
    [anon_sym_SEMI_SEMI] = ACTIONS(673),
    [anon_sym_PIPE_AMP] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(673),
    [anon_sym_PIPE_PIPE] = ACTIONS(673),
    [anon_sym_BQUOTE] = ACTIONS(673),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(673),
    [anon_sym_LF] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(673),
  },
  [1110] = {
    [sym_for_statement] = STATE(1045),
    [sym_while_statement] = STATE(1045),
    [sym_if_statement] = STATE(1045),
    [sym_case_statement] = STATE(1045),
    [sym_function_definition] = STATE(1045),
    [sym_subshell] = STATE(1045),
    [sym_pipeline] = STATE(1045),
    [sym_list] = STATE(1045),
    [sym_bracket_command] = STATE(1045),
    [sym_command] = STATE(1045),
    [sym_command_name] = STATE(1046),
    [sym_environment_variable_assignment] = STATE(1047),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(1022),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_while] = ACTIONS(2234),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_case] = ACTIONS(2238),
    [anon_sym_function] = ACTIONS(2240),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2244),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2246),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(3090),
    [sym_comment] = ACTIONS(133),
  },
  [1111] = {
    [sym_file_descriptor] = ACTIONS(2258),
    [sym__concat] = ACTIONS(2258),
    [sym_variable_name] = ACTIONS(2258),
    [anon_sym_in] = ACTIONS(2267),
    [anon_sym_PIPE] = ACTIONS(3092),
    [anon_sym_RPAREN] = ACTIONS(3092),
    [anon_sym_SEMI_SEMI] = ACTIONS(3092),
    [anon_sym_RBRACE] = ACTIONS(2267),
    [anon_sym_PIPE_AMP] = ACTIONS(3092),
    [anon_sym_AMP_AMP] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3092),
    [anon_sym_RBRACK] = ACTIONS(2267),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2267),
    [anon_sym_LT] = ACTIONS(2267),
    [anon_sym_GT] = ACTIONS(2267),
    [anon_sym_GT_GT] = ACTIONS(2267),
    [anon_sym_AMP_GT] = ACTIONS(2267),
    [anon_sym_AMP_GT_GT] = ACTIONS(2267),
    [anon_sym_LT_AMP] = ACTIONS(2267),
    [anon_sym_GT_AMP] = ACTIONS(2267),
    [anon_sym_LT_LT] = ACTIONS(2267),
    [anon_sym_LT_LT_DASH] = ACTIONS(2267),
    [anon_sym_DQUOTE] = ACTIONS(2267),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(925),
    [sym_raw_string] = ACTIONS(2267),
    [anon_sym_DOLLAR] = ACTIONS(2267),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2267),
    [anon_sym_BQUOTE] = ACTIONS(3092),
    [anon_sym_LT_LPAREN] = ACTIONS(2267),
    [anon_sym_GT_LPAREN] = ACTIONS(2267),
    [sym_word] = ACTIONS(2267),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym_LF] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3092),
  },
  [1112] = {
    [sym_file_descriptor] = ACTIONS(563),
    [sym_variable_name] = ACTIONS(563),
    [ts_builtin_sym_end] = ACTIONS(563),
    [anon_sym_for] = ACTIONS(565),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_do] = ACTIONS(565),
    [anon_sym_done] = ACTIONS(565),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_then] = ACTIONS(565),
    [anon_sym_fi] = ACTIONS(565),
    [anon_sym_elif] = ACTIONS(565),
    [anon_sym_else] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(2611),
    [anon_sym_SEMI_SEMI] = ACTIONS(563),
    [anon_sym_function] = ACTIONS(565),
    [anon_sym_LPAREN] = ACTIONS(563),
    [anon_sym_RBRACE] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(565),
    [anon_sym_GT] = ACTIONS(565),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_AMP_GT] = ACTIONS(565),
    [anon_sym_AMP_GT_GT] = ACTIONS(563),
    [anon_sym_LT_AMP] = ACTIONS(563),
    [anon_sym_GT_AMP] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(563),
    [sym_raw_string] = ACTIONS(563),
    [anon_sym_DOLLAR] = ACTIONS(565),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(563),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(563),
    [anon_sym_BQUOTE] = ACTIONS(563),
    [anon_sym_LT_LPAREN] = ACTIONS(563),
    [anon_sym_GT_LPAREN] = ACTIONS(563),
    [sym_word] = ACTIONS(567),
    [sym_comment] = ACTIONS(133),
  },
  [1113] = {
    [sym_for_statement] = STATE(1213),
    [sym_while_statement] = STATE(1213),
    [sym_if_statement] = STATE(1213),
    [sym_case_statement] = STATE(1213),
    [sym_function_definition] = STATE(1213),
    [sym_subshell] = STATE(1213),
    [sym_pipeline] = STATE(1213),
    [sym_list] = STATE(1213),
    [sym_bracket_command] = STATE(1213),
    [sym_command] = STATE(1213),
    [sym_command_name] = STATE(1046),
    [sym_environment_variable_assignment] = STATE(1214),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(1022),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_while] = ACTIONS(2234),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_case] = ACTIONS(2238),
    [anon_sym_function] = ACTIONS(2240),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2244),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2246),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(3090),
    [sym_comment] = ACTIONS(133),
  },
  [1114] = {
    [sym_file_descriptor] = ACTIONS(923),
    [sym__concat] = ACTIONS(923),
    [sym_variable_name] = ACTIONS(923),
    [anon_sym_in] = ACTIONS(925),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_RPAREN] = ACTIONS(925),
    [anon_sym_SEMI_SEMI] = ACTIONS(925),
    [anon_sym_RBRACE] = ACTIONS(925),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(925),
    [anon_sym_PIPE_PIPE] = ACTIONS(925),
    [anon_sym_RBRACK] = ACTIONS(925),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_GT] = ACTIONS(925),
    [anon_sym_AMP_GT] = ACTIONS(925),
    [anon_sym_AMP_GT_GT] = ACTIONS(925),
    [anon_sym_LT_AMP] = ACTIONS(925),
    [anon_sym_GT_AMP] = ACTIONS(925),
    [anon_sym_LT_LT] = ACTIONS(925),
    [anon_sym_LT_LT_DASH] = ACTIONS(925),
    [anon_sym_DQUOTE] = ACTIONS(925),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(925),
    [sym_raw_string] = ACTIONS(925),
    [anon_sym_DOLLAR] = ACTIONS(925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(925),
    [anon_sym_BQUOTE] = ACTIONS(925),
    [anon_sym_LT_LPAREN] = ACTIONS(925),
    [anon_sym_GT_LPAREN] = ACTIONS(925),
    [sym_word] = ACTIONS(925),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(925),
    [anon_sym_LF] = ACTIONS(925),
    [anon_sym_AMP] = ACTIONS(925),
  },
  [1115] = {
    [anon_sym_PIPE] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(3097),
    [anon_sym_SEMI_SEMI] = ACTIONS(3097),
    [anon_sym_PIPE_AMP] = ACTIONS(3097),
    [anon_sym_AMP_AMP] = ACTIONS(3097),
    [anon_sym_PIPE_PIPE] = ACTIONS(3097),
    [anon_sym_BQUOTE] = ACTIONS(3097),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(3097),
    [anon_sym_LF] = ACTIONS(3097),
    [anon_sym_AMP] = ACTIONS(3097),
  },
  [1116] = {
    [anon_sym_LT] = ACTIONS(3101),
    [anon_sym_GT] = ACTIONS(3101),
    [anon_sym_GT_GT] = ACTIONS(3103),
    [anon_sym_AMP_GT] = ACTIONS(3101),
    [anon_sym_AMP_GT_GT] = ACTIONS(3103),
    [anon_sym_LT_AMP] = ACTIONS(3103),
    [anon_sym_GT_AMP] = ACTIONS(3103),
    [sym_comment] = ACTIONS(133),
  },
  [1117] = {
    [sym_concatenation] = STATE(1223),
    [sym_string] = STATE(1217),
    [sym_simple_expansion] = STATE(1217),
    [sym_expansion] = STATE(1217),
    [sym_command_substitution] = STATE(1217),
    [sym_process_substitution] = STATE(1217),
    [anon_sym_DQUOTE] = ACTIONS(3105),
    [sym_raw_string] = ACTIONS(3107),
    [anon_sym_DOLLAR] = ACTIONS(3109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3113),
    [anon_sym_BQUOTE] = ACTIONS(3115),
    [anon_sym_LT_LPAREN] = ACTIONS(3117),
    [anon_sym_GT_LPAREN] = ACTIONS(3117),
    [sym_word] = ACTIONS(3119),
    [sym_comment] = ACTIONS(133),
  },
  [1118] = {
    [sym_heredoc] = STATE(1013),
    [sym__simple_heredoc] = ACTIONS(3121),
    [sym__heredoc_beginning] = ACTIONS(3123),
    [sym_comment] = ACTIONS(133),
  },
  [1119] = {
    [sym_file_descriptor] = ACTIONS(593),
    [anon_sym_PIPE] = ACTIONS(595),
    [anon_sym_RPAREN] = ACTIONS(595),
    [anon_sym_SEMI_SEMI] = ACTIONS(595),
    [anon_sym_PIPE_AMP] = ACTIONS(595),
    [anon_sym_AMP_AMP] = ACTIONS(595),
    [anon_sym_PIPE_PIPE] = ACTIONS(595),
    [anon_sym_LT] = ACTIONS(595),
    [anon_sym_GT] = ACTIONS(595),
    [anon_sym_GT_GT] = ACTIONS(595),
    [anon_sym_AMP_GT] = ACTIONS(595),
    [anon_sym_AMP_GT_GT] = ACTIONS(595),
    [anon_sym_LT_AMP] = ACTIONS(595),
    [anon_sym_GT_AMP] = ACTIONS(595),
    [anon_sym_LT_LT] = ACTIONS(595),
    [anon_sym_LT_LT_DASH] = ACTIONS(595),
    [anon_sym_BQUOTE] = ACTIONS(595),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(595),
    [anon_sym_LF] = ACTIONS(595),
    [anon_sym_AMP] = ACTIONS(595),
  },
  [1120] = {
    [sym_file_redirect] = STATE(1119),
    [sym_heredoc_redirect] = STATE(1119),
    [sym_concatenation] = STATE(297),
    [sym_string] = STATE(296),
    [sym_simple_expansion] = STATE(296),
    [sym_expansion] = STATE(296),
    [sym_command_substitution] = STATE(296),
    [sym_process_substitution] = STATE(296),
    [aux_sym_command_repeat2] = STATE(1142),
    [sym_file_descriptor] = ACTIONS(2724),
    [anon_sym_PIPE] = ACTIONS(2886),
    [anon_sym_RPAREN] = ACTIONS(2886),
    [anon_sym_SEMI_SEMI] = ACTIONS(2886),
    [anon_sym_PIPE_AMP] = ACTIONS(2886),
    [anon_sym_AMP_AMP] = ACTIONS(2886),
    [anon_sym_PIPE_PIPE] = ACTIONS(2886),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT_GT] = ACTIONS(2729),
    [anon_sym_LT_AMP] = ACTIONS(2729),
    [anon_sym_GT_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2731),
    [anon_sym_LT_LT_DASH] = ACTIONS(2731),
    [anon_sym_DQUOTE] = ACTIONS(285),
    [sym_raw_string] = ACTIONS(599),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(291),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [anon_sym_BQUOTE] = ACTIONS(3125),
    [anon_sym_LT_LPAREN] = ACTIONS(297),
    [anon_sym_GT_LPAREN] = ACTIONS(297),
    [sym_word] = ACTIONS(599),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2886),
    [anon_sym_LF] = ACTIONS(2886),
    [anon_sym_AMP] = ACTIONS(2886),
  },
  [1121] = {
    [sym_file_redirect] = STATE(1147),
    [sym_heredoc_redirect] = STATE(1147),
    [sym_file_descriptor] = ACTIONS(2724),
    [anon_sym_PIPE] = ACTIONS(3129),
    [anon_sym_RPAREN] = ACTIONS(3129),
    [anon_sym_SEMI_SEMI] = ACTIONS(3129),
    [anon_sym_PIPE_AMP] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT_GT] = ACTIONS(2729),
    [anon_sym_LT_AMP] = ACTIONS(2729),
    [anon_sym_GT_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2731),
    [anon_sym_LT_LT_DASH] = ACTIONS(2731),
    [anon_sym_BQUOTE] = ACTIONS(3129),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(3129),
    [anon_sym_LF] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3129),
  },
  [1122] = {
    [sym__heredoc_middle] = ACTIONS(3132),
    [sym__heredoc_end] = ACTIONS(3132),
    [sym_file_descriptor] = ACTIONS(3132),
    [sym__concat] = ACTIONS(3132),
    [sym_variable_name] = ACTIONS(3132),
    [anon_sym_in] = ACTIONS(3135),
    [anon_sym_PIPE] = ACTIONS(3135),
    [anon_sym_RPAREN] = ACTIONS(3135),
    [anon_sym_SEMI_SEMI] = ACTIONS(3135),
    [anon_sym_RBRACE] = ACTIONS(3135),
    [anon_sym_PIPE_AMP] = ACTIONS(3135),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3135),
    [anon_sym_RBRACK] = ACTIONS(3135),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3135),
    [anon_sym_LT] = ACTIONS(3135),
    [anon_sym_GT] = ACTIONS(3135),
    [anon_sym_GT_GT] = ACTIONS(3135),
    [anon_sym_AMP_GT] = ACTIONS(3135),
    [anon_sym_AMP_GT_GT] = ACTIONS(3135),
    [anon_sym_LT_AMP] = ACTIONS(3135),
    [anon_sym_GT_AMP] = ACTIONS(3135),
    [anon_sym_LT_LT] = ACTIONS(3135),
    [anon_sym_LT_LT_DASH] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(3135),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(3135),
    [sym_raw_string] = ACTIONS(3135),
    [anon_sym_DOLLAR] = ACTIONS(3135),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3135),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3135),
    [anon_sym_BQUOTE] = ACTIONS(3135),
    [anon_sym_LT_LPAREN] = ACTIONS(3135),
    [anon_sym_GT_LPAREN] = ACTIONS(3135),
    [sym_word] = ACTIONS(3135),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(3135),
    [anon_sym_LF] = ACTIONS(3135),
    [anon_sym_AMP] = ACTIONS(3135),
  },
  [1123] = {
    [anon_sym_AT] = ACTIONS(3138),
    [sym_comment] = ACTIONS(133),
  },
  [1124] = {
    [sym_concatenation] = STATE(1226),
    [sym_string] = STATE(1225),
    [sym_simple_expansion] = STATE(1225),
    [sym_expansion] = STATE(1225),
    [sym_command_substitution] = STATE(1225),
    [sym_process_substitution] = STATE(1225),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(3140),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(3142),
    [sym_comment] = ACTIONS(133),
  },
  [1125] = {
    [anon_sym_PIPE] = ACTIONS(1527),
    [anon_sym_RPAREN] = ACTIONS(1527),
    [anon_sym_SEMI_SEMI] = ACTIONS(1527),
    [anon_sym_PIPE_AMP] = ACTIONS(1527),
    [anon_sym_AMP_AMP] = ACTIONS(1527),
    [anon_sym_PIPE_PIPE] = ACTIONS(1527),
    [anon_sym_BQUOTE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1527),
    [anon_sym_LF] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
  },
  [1126] = {
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_RPAREN] = ACTIONS(1533),
    [anon_sym_SEMI_SEMI] = ACTIONS(1533),
    [anon_sym_PIPE_AMP] = ACTIONS(1533),
    [anon_sym_AMP_AMP] = ACTIONS(1533),
    [anon_sym_PIPE_PIPE] = ACTIONS(1533),
    [anon_sym_BQUOTE] = ACTIONS(1533),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1533),
    [anon_sym_LF] = ACTIONS(1533),
    [anon_sym_AMP] = ACTIONS(1533),
  },
  [1127] = {
    [anon_sym_esac] = ACTIONS(3144),
    [anon_sym_DQUOTE] = ACTIONS(3147),
    [sym_raw_string] = ACTIONS(3147),
    [anon_sym_DOLLAR] = ACTIONS(3144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3147),
    [anon_sym_BQUOTE] = ACTIONS(3147),
    [anon_sym_LT_LPAREN] = ACTIONS(3147),
    [anon_sym_GT_LPAREN] = ACTIONS(3147),
    [sym_word] = ACTIONS(3150),
    [sym_comment] = ACTIONS(133),
  },
  [1128] = {
    [anon_sym_PIPE] = ACTIONS(1957),
    [anon_sym_RPAREN] = ACTIONS(1957),
    [anon_sym_SEMI_SEMI] = ACTIONS(1957),
    [anon_sym_PIPE_AMP] = ACTIONS(1957),
    [anon_sym_AMP_AMP] = ACTIONS(1957),
    [anon_sym_PIPE_PIPE] = ACTIONS(1957),
    [anon_sym_BQUOTE] = ACTIONS(1957),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1957),
    [anon_sym_LF] = ACTIONS(1957),
    [anon_sym_AMP] = ACTIONS(1957),
  },
  [1129] = {
    [anon_sym_PIPE] = ACTIONS(271),
    [anon_sym_RPAREN] = ACTIONS(3153),
    [anon_sym_SEMI_SEMI] = ACTIONS(3155),
    [anon_sym_PIPE_AMP] = ACTIONS(271),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(3155),
    [anon_sym_LF] = ACTIONS(3155),
    [anon_sym_AMP] = ACTIONS(3155),
  },
  [1130] = {
    [anon_sym_fi] = ACTIONS(3157),
    [sym_comment] = ACTIONS(133),
  },
  [1131] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(271),
    [anon_sym_RPAREN] = ACTIONS(3153),
    [anon_sym_SEMI_SEMI] = ACTIONS(3155),
    [anon_sym_PIPE_AMP] = ACTIONS(271),
    [anon_sym_AMP_AMP] = ACTIONS(275),
    [anon_sym_PIPE_PIPE] = ACTIONS(275),
    [anon_sym_LT] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(301),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_AMP_GT] = ACTIONS(301),
    [anon_sym_AMP_GT_GT] = ACTIONS(301),
    [anon_sym_LT_AMP] = ACTIONS(301),
    [anon_sym_GT_AMP] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(301),
    [sym_raw_string] = ACTIONS(301),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(301),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(301),
    [anon_sym_GT_LPAREN] = ACTIONS(301),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(3155),
    [anon_sym_LF] = ACTIONS(3155),
    [anon_sym_AMP] = ACTIONS(3155),
  },
  [1132] = {
    [sym_elif_clause] = STATE(552),
    [sym_else_clause] = STATE(1230),
    [anon_sym_fi] = ACTIONS(3157),
    [anon_sym_elif] = ACTIONS(1137),
    [anon_sym_else] = ACTIONS(1139),
    [sym_comment] = ACTIONS(133),
  },
  [1133] = {
    [sym_do_group] = STATE(1100),
    [anon_sym_do] = ACTIONS(2929),
    [sym_comment] = ACTIONS(133),
  },
  [1134] = {
    [sym_simple_expansion] = STATE(70),
    [sym_expansion] = STATE(70),
    [sym_command_substitution] = STATE(70),
    [aux_sym_string_repeat1] = STATE(1232),
    [anon_sym_DQUOTE] = ACTIONS(3159),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(197),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [1135] = {
    [aux_sym_concatenation_repeat1] = STATE(1234),
    [sym_file_descriptor] = ACTIONS(767),
    [sym__concat] = ACTIONS(3161),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_RPAREN] = ACTIONS(769),
    [anon_sym_SEMI_SEMI] = ACTIONS(769),
    [anon_sym_PIPE_AMP] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_RBRACK] = ACTIONS(769),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(769),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_AMP_GT] = ACTIONS(769),
    [anon_sym_AMP_GT_GT] = ACTIONS(769),
    [anon_sym_LT_AMP] = ACTIONS(769),
    [anon_sym_GT_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_LT_LT_DASH] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(769),
    [sym_raw_string] = ACTIONS(769),
    [anon_sym_DOLLAR] = ACTIONS(769),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(769),
    [anon_sym_BQUOTE] = ACTIONS(769),
    [anon_sym_LT_LPAREN] = ACTIONS(769),
    [anon_sym_GT_LPAREN] = ACTIONS(769),
    [sym_word] = ACTIONS(769),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(769),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
  },
  [1136] = {
    [sym_special_variable_name] = STATE(1237),
    [anon_sym_DOLLAR] = ACTIONS(3163),
    [anon_sym_POUND] = ACTIONS(3165),
    [anon_sym_AT] = ACTIONS(3163),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(3167),
    [anon_sym_STAR] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(3163),
    [anon_sym_DASH] = ACTIONS(3163),
    [anon_sym_BANG] = ACTIONS(3163),
    [anon_sym_0] = ACTIONS(3165),
    [anon_sym__] = ACTIONS(3165),
  },
  [1137] = {
    [sym_special_variable_name] = STATE(1240),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(3169),
    [anon_sym_AT] = ACTIONS(219),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [1138] = {
    [sym_for_statement] = STATE(1241),
    [sym_while_statement] = STATE(1241),
    [sym_if_statement] = STATE(1241),
    [sym_case_statement] = STATE(1241),
    [sym_function_definition] = STATE(1241),
    [sym_subshell] = STATE(1241),
    [sym_pipeline] = STATE(1241),
    [sym_list] = STATE(1241),
    [sym_bracket_command] = STATE(1241),
    [sym_command] = STATE(1241),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(1242),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [1139] = {
    [sym_for_statement] = STATE(1243),
    [sym_while_statement] = STATE(1243),
    [sym_if_statement] = STATE(1243),
    [sym_case_statement] = STATE(1243),
    [sym_function_definition] = STATE(1243),
    [sym_subshell] = STATE(1243),
    [sym_pipeline] = STATE(1243),
    [sym_list] = STATE(1243),
    [sym_bracket_command] = STATE(1243),
    [sym_command] = STATE(1243),
    [sym_command_name] = STATE(109),
    [sym_environment_variable_assignment] = STATE(1244),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [1140] = {
    [sym_for_statement] = STATE(1245),
    [sym_while_statement] = STATE(1245),
    [sym_if_statement] = STATE(1245),
    [sym_case_statement] = STATE(1245),
    [sym_function_definition] = STATE(1245),
    [sym_subshell] = STATE(1245),
    [sym_pipeline] = STATE(1245),
    [sym_list] = STATE(1245),
    [sym_bracket_command] = STATE(1245),
    [sym_command] = STATE(1245),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(1246),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [1141] = {
    [sym_file_descriptor] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(769),
    [anon_sym_RPAREN] = ACTIONS(769),
    [anon_sym_SEMI_SEMI] = ACTIONS(769),
    [anon_sym_PIPE_AMP] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_RBRACK] = ACTIONS(769),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(769),
    [anon_sym_LT] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(769),
    [anon_sym_AMP_GT] = ACTIONS(769),
    [anon_sym_AMP_GT_GT] = ACTIONS(769),
    [anon_sym_LT_AMP] = ACTIONS(769),
    [anon_sym_GT_AMP] = ACTIONS(769),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_LT_LT_DASH] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(769),
    [sym_raw_string] = ACTIONS(769),
    [anon_sym_DOLLAR] = ACTIONS(769),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(769),
    [anon_sym_BQUOTE] = ACTIONS(769),
    [anon_sym_LT_LPAREN] = ACTIONS(769),
    [anon_sym_GT_LPAREN] = ACTIONS(769),
    [sym_word] = ACTIONS(769),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(769),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(769),
  },
  [1142] = {
    [sym_file_redirect] = STATE(1147),
    [sym_heredoc_redirect] = STATE(1147),
    [sym_file_descriptor] = ACTIONS(2724),
    [anon_sym_PIPE] = ACTIONS(3173),
    [anon_sym_RPAREN] = ACTIONS(3173),
    [anon_sym_SEMI_SEMI] = ACTIONS(3173),
    [anon_sym_PIPE_AMP] = ACTIONS(3173),
    [anon_sym_AMP_AMP] = ACTIONS(3173),
    [anon_sym_PIPE_PIPE] = ACTIONS(3173),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT_GT] = ACTIONS(2729),
    [anon_sym_LT_AMP] = ACTIONS(2729),
    [anon_sym_GT_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2731),
    [anon_sym_LT_LT_DASH] = ACTIONS(2731),
    [anon_sym_BQUOTE] = ACTIONS(3173),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(3173),
    [anon_sym_LF] = ACTIONS(3173),
    [anon_sym_AMP] = ACTIONS(3173),
  },
  [1143] = {
    [anon_sym_PIPE] = ACTIONS(3176),
    [anon_sym_RPAREN] = ACTIONS(3176),
    [anon_sym_SEMI_SEMI] = ACTIONS(3176),
    [anon_sym_PIPE_AMP] = ACTIONS(3176),
    [anon_sym_AMP_AMP] = ACTIONS(3176),
    [anon_sym_PIPE_PIPE] = ACTIONS(3176),
    [anon_sym_BQUOTE] = ACTIONS(3176),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym_LF] = ACTIONS(3176),
    [anon_sym_AMP] = ACTIONS(3176),
  },
  [1144] = {
    [anon_sym_fi] = ACTIONS(3179),
    [sym_comment] = ACTIONS(133),
  },
  [1145] = {
    [anon_sym_PIPE] = ACTIONS(3181),
    [anon_sym_RPAREN] = ACTIONS(3181),
    [anon_sym_SEMI_SEMI] = ACTIONS(3181),
    [anon_sym_PIPE_AMP] = ACTIONS(3181),
    [anon_sym_AMP_AMP] = ACTIONS(3181),
    [anon_sym_PIPE_PIPE] = ACTIONS(3181),
    [anon_sym_BQUOTE] = ACTIONS(3181),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(3181),
    [anon_sym_LF] = ACTIONS(3181),
    [anon_sym_AMP] = ACTIONS(3181),
  },
  [1146] = {
    [sym_file_redirect] = STATE(1119),
    [sym_heredoc_redirect] = STATE(1119),
    [sym_concatenation] = STATE(123),
    [sym_string] = STATE(121),
    [sym_simple_expansion] = STATE(121),
    [sym_expansion] = STATE(121),
    [sym_command_substitution] = STATE(121),
    [sym_process_substitution] = STATE(121),
    [aux_sym_for_statement_repeat1] = STATE(1248),
    [aux_sym_command_repeat2] = STATE(1249),
    [sym_file_descriptor] = ACTIONS(2724),
    [anon_sym_PIPE] = ACTIONS(597),
    [anon_sym_RPAREN] = ACTIONS(597),
    [anon_sym_SEMI_SEMI] = ACTIONS(597),
    [anon_sym_PIPE_AMP] = ACTIONS(597),
    [anon_sym_AMP_AMP] = ACTIONS(597),
    [anon_sym_PIPE_PIPE] = ACTIONS(597),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT_GT] = ACTIONS(2729),
    [anon_sym_LT_AMP] = ACTIONS(2729),
    [anon_sym_GT_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2731),
    [anon_sym_LT_LT_DASH] = ACTIONS(2731),
    [anon_sym_DQUOTE] = ACTIONS(285),
    [sym_raw_string] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(291),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [anon_sym_BQUOTE] = ACTIONS(3184),
    [anon_sym_LT_LPAREN] = ACTIONS(297),
    [anon_sym_GT_LPAREN] = ACTIONS(297),
    [sym_word] = ACTIONS(287),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(597),
    [anon_sym_LF] = ACTIONS(597),
    [anon_sym_AMP] = ACTIONS(597),
  },
  [1147] = {
    [sym_file_descriptor] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_RPAREN] = ACTIONS(1015),
    [anon_sym_SEMI_SEMI] = ACTIONS(1015),
    [anon_sym_PIPE_AMP] = ACTIONS(1015),
    [anon_sym_AMP_AMP] = ACTIONS(1015),
    [anon_sym_PIPE_PIPE] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(1015),
    [anon_sym_GT] = ACTIONS(1015),
    [anon_sym_GT_GT] = ACTIONS(1015),
    [anon_sym_AMP_GT] = ACTIONS(1015),
    [anon_sym_AMP_GT_GT] = ACTIONS(1015),
    [anon_sym_LT_AMP] = ACTIONS(1015),
    [anon_sym_GT_AMP] = ACTIONS(1015),
    [anon_sym_LT_LT] = ACTIONS(1015),
    [anon_sym_LT_LT_DASH] = ACTIONS(1015),
    [anon_sym_BQUOTE] = ACTIONS(1015),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1015),
    [anon_sym_LF] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1015),
  },
  [1148] = {
    [sym_file_descriptor] = ACTIONS(1763),
    [anon_sym_PIPE] = ACTIONS(1765),
    [anon_sym_RPAREN] = ACTIONS(1765),
    [anon_sym_SEMI_SEMI] = ACTIONS(1765),
    [anon_sym_PIPE_AMP] = ACTIONS(1765),
    [anon_sym_AMP_AMP] = ACTIONS(1765),
    [anon_sym_PIPE_PIPE] = ACTIONS(1765),
    [anon_sym_LT] = ACTIONS(1765),
    [anon_sym_GT] = ACTIONS(1765),
    [anon_sym_GT_GT] = ACTIONS(1765),
    [anon_sym_AMP_GT] = ACTIONS(1765),
    [anon_sym_AMP_GT_GT] = ACTIONS(1765),
    [anon_sym_LT_AMP] = ACTIONS(1765),
    [anon_sym_GT_AMP] = ACTIONS(1765),
    [anon_sym_LT_LT] = ACTIONS(1765),
    [anon_sym_LT_LT_DASH] = ACTIONS(1765),
    [anon_sym_BQUOTE] = ACTIONS(1765),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1765),
    [anon_sym_LF] = ACTIONS(1765),
    [anon_sym_AMP] = ACTIONS(1765),
  },
  [1149] = {
    [sym_string] = STATE(1250),
    [sym_simple_expansion] = STATE(1250),
    [sym_expansion] = STATE(1250),
    [sym_command_substitution] = STATE(1250),
    [sym_process_substitution] = STATE(1250),
    [anon_sym_DQUOTE] = ACTIONS(2655),
    [sym_raw_string] = ACTIONS(3187),
    [anon_sym_DOLLAR] = ACTIONS(2659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2661),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2663),
    [anon_sym_BQUOTE] = ACTIONS(2665),
    [anon_sym_LT_LPAREN] = ACTIONS(2667),
    [anon_sym_GT_LPAREN] = ACTIONS(2667),
    [sym_word] = ACTIONS(3189),
    [sym_comment] = ACTIONS(133),
  },
  [1150] = {
    [sym_file_descriptor] = ACTIONS(821),
    [sym__concat] = ACTIONS(821),
    [sym_variable_name] = ACTIONS(821),
    [anon_sym_in] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(823),
    [anon_sym_SEMI_SEMI] = ACTIONS(823),
    [anon_sym_RBRACE] = ACTIONS(823),
    [anon_sym_PIPE_AMP] = ACTIONS(823),
    [anon_sym_AMP_AMP] = ACTIONS(823),
    [anon_sym_PIPE_PIPE] = ACTIONS(823),
    [anon_sym_RBRACK] = ACTIONS(823),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(823),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(823),
    [anon_sym_GT_GT] = ACTIONS(823),
    [anon_sym_AMP_GT] = ACTIONS(823),
    [anon_sym_AMP_GT_GT] = ACTIONS(823),
    [anon_sym_LT_AMP] = ACTIONS(823),
    [anon_sym_GT_AMP] = ACTIONS(823),
    [anon_sym_LT_LT] = ACTIONS(823),
    [anon_sym_LT_LT_DASH] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(823),
    [sym_raw_string] = ACTIONS(823),
    [anon_sym_DOLLAR] = ACTIONS(823),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(823),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(823),
    [anon_sym_BQUOTE] = ACTIONS(823),
    [anon_sym_LT_LPAREN] = ACTIONS(823),
    [anon_sym_GT_LPAREN] = ACTIONS(823),
    [sym_word] = ACTIONS(823),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_LF] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
  },
  [1151] = {
    [sym_concatenation] = STATE(344),
    [sym_string] = STATE(338),
    [sym_simple_expansion] = STATE(338),
    [sym_expansion] = STATE(338),
    [sym_command_substitution] = STATE(338),
    [sym_process_substitution] = STATE(338),
    [aux_sym_for_statement_repeat1] = STATE(1029),
    [anon_sym_DQUOTE] = ACTIONS(655),
    [sym_raw_string] = ACTIONS(657),
    [anon_sym_DOLLAR] = ACTIONS(659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(661),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(663),
    [anon_sym_BQUOTE] = ACTIONS(665),
    [anon_sym_LT_LPAREN] = ACTIONS(667),
    [anon_sym_GT_LPAREN] = ACTIONS(667),
    [sym_word] = ACTIONS(669),
    [sym_comment] = ACTIONS(133),
  },
  [1152] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_elif_clause] = STATE(351),
    [sym_else_clause] = STATE(1035),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1251),
    [aux_sym_if_statement_repeat1] = STATE(1037),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_fi] = ACTIONS(3191),
    [anon_sym_elif] = ACTIONS(677),
    [anon_sym_else] = ACTIONS(679),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [1153] = {
    [sym_concatenation] = STATE(194),
    [sym_string] = STATE(193),
    [sym_simple_expansion] = STATE(193),
    [sym_expansion] = STATE(193),
    [sym_command_substitution] = STATE(193),
    [sym_process_substitution] = STATE(193),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2981),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(405),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(407),
    [sym_comment] = ACTIONS(133),
  },
  [1154] = {
    [anon_sym_RPAREN] = ACTIONS(3193),
    [sym_comment] = ACTIONS(133),
  },
  [1155] = {
    [sym_file_redirect] = STATE(1119),
    [sym_heredoc_redirect] = STATE(1119),
    [sym_concatenation] = STATE(297),
    [sym_string] = STATE(296),
    [sym_simple_expansion] = STATE(296),
    [sym_expansion] = STATE(296),
    [sym_command_substitution] = STATE(296),
    [sym_process_substitution] = STATE(296),
    [aux_sym_command_repeat2] = STATE(1249),
    [sym_file_descriptor] = ACTIONS(2724),
    [anon_sym_PIPE] = ACTIONS(597),
    [anon_sym_RPAREN] = ACTIONS(597),
    [anon_sym_SEMI_SEMI] = ACTIONS(597),
    [anon_sym_PIPE_AMP] = ACTIONS(597),
    [anon_sym_AMP_AMP] = ACTIONS(597),
    [anon_sym_PIPE_PIPE] = ACTIONS(597),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT_GT] = ACTIONS(2729),
    [anon_sym_LT_AMP] = ACTIONS(2729),
    [anon_sym_GT_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2731),
    [anon_sym_LT_LT_DASH] = ACTIONS(2731),
    [anon_sym_DQUOTE] = ACTIONS(285),
    [sym_raw_string] = ACTIONS(599),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(291),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [anon_sym_BQUOTE] = ACTIONS(3184),
    [anon_sym_LT_LPAREN] = ACTIONS(297),
    [anon_sym_GT_LPAREN] = ACTIONS(297),
    [sym_word] = ACTIONS(599),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(597),
    [anon_sym_LF] = ACTIONS(597),
    [anon_sym_AMP] = ACTIONS(597),
  },
  [1156] = {
    [sym_file_redirect] = STATE(1147),
    [sym_heredoc_redirect] = STATE(1147),
    [sym_file_descriptor] = ACTIONS(2724),
    [anon_sym_PIPE] = ACTIONS(601),
    [anon_sym_RPAREN] = ACTIONS(601),
    [anon_sym_SEMI_SEMI] = ACTIONS(601),
    [anon_sym_PIPE_AMP] = ACTIONS(601),
    [anon_sym_AMP_AMP] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(601),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT_GT] = ACTIONS(2729),
    [anon_sym_LT_AMP] = ACTIONS(2729),
    [anon_sym_GT_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2731),
    [anon_sym_LT_LT_DASH] = ACTIONS(2731),
    [anon_sym_BQUOTE] = ACTIONS(601),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(601),
    [anon_sym_LF] = ACTIONS(601),
    [anon_sym_AMP] = ACTIONS(601),
  },
  [1157] = {
    [anon_sym_RPAREN] = ACTIONS(3195),
    [sym_comment] = ACTIONS(133),
  },
  [1158] = {
    [anon_sym_PIPE] = ACTIONS(717),
    [anon_sym_RPAREN] = ACTIONS(717),
    [anon_sym_SEMI_SEMI] = ACTIONS(717),
    [anon_sym_PIPE_AMP] = ACTIONS(717),
    [anon_sym_AMP_AMP] = ACTIONS(717),
    [anon_sym_PIPE_PIPE] = ACTIONS(717),
    [anon_sym_BQUOTE] = ACTIONS(717),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(717),
    [anon_sym_LF] = ACTIONS(717),
    [anon_sym_AMP] = ACTIONS(717),
  },
  [1159] = {
    [sym_file_descriptor] = ACTIONS(563),
    [sym_variable_name] = ACTIONS(563),
    [anon_sym_for] = ACTIONS(565),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(3197),
    [anon_sym_function] = ACTIONS(565),
    [anon_sym_LPAREN] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(565),
    [anon_sym_GT] = ACTIONS(565),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_AMP_GT] = ACTIONS(565),
    [anon_sym_AMP_GT_GT] = ACTIONS(563),
    [anon_sym_LT_AMP] = ACTIONS(563),
    [anon_sym_GT_AMP] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(563),
    [sym_raw_string] = ACTIONS(563),
    [anon_sym_DOLLAR] = ACTIONS(565),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(563),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(563),
    [anon_sym_BQUOTE] = ACTIONS(563),
    [anon_sym_LT_LPAREN] = ACTIONS(563),
    [anon_sym_GT_LPAREN] = ACTIONS(563),
    [sym_word] = ACTIONS(567),
    [sym_comment] = ACTIONS(133),
  },
  [1160] = {
    [sym_file_descriptor] = ACTIONS(427),
    [sym__concat] = ACTIONS(427),
    [sym_variable_name] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(429),
    [anon_sym_SEMI_SEMI] = ACTIONS(429),
    [anon_sym_RBRACE] = ACTIONS(429),
    [anon_sym_PIPE_AMP] = ACTIONS(429),
    [anon_sym_AMP_AMP] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_GT] = ACTIONS(429),
    [anon_sym_AMP_GT] = ACTIONS(429),
    [anon_sym_AMP_GT_GT] = ACTIONS(429),
    [anon_sym_LT_AMP] = ACTIONS(429),
    [anon_sym_GT_AMP] = ACTIONS(429),
    [anon_sym_DQUOTE] = ACTIONS(429),
    [sym_raw_string] = ACTIONS(429),
    [anon_sym_DOLLAR] = ACTIONS(429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(429),
    [anon_sym_BQUOTE] = ACTIONS(429),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [sym_word] = ACTIONS(429),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(429),
    [anon_sym_LF] = ACTIONS(429),
    [anon_sym_AMP] = ACTIONS(429),
  },
  [1161] = {
    [sym_simple_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [anon_sym_DQUOTE] = ACTIONS(3199),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(447),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [1162] = {
    [sym_string] = STATE(1255),
    [sym_simple_expansion] = STATE(1255),
    [sym_expansion] = STATE(1255),
    [sym_command_substitution] = STATE(1255),
    [sym_process_substitution] = STATE(1255),
    [anon_sym_DQUOTE] = ACTIONS(2401),
    [sym_raw_string] = ACTIONS(3201),
    [anon_sym_DOLLAR] = ACTIONS(2405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2409),
    [anon_sym_BQUOTE] = ACTIONS(2411),
    [anon_sym_LT_LPAREN] = ACTIONS(2413),
    [anon_sym_GT_LPAREN] = ACTIONS(2413),
    [sym_word] = ACTIONS(3203),
    [sym_comment] = ACTIONS(133),
  },
  [1163] = {
    [sym_file_descriptor] = ACTIONS(453),
    [sym__concat] = ACTIONS(3205),
    [sym_variable_name] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(457),
    [anon_sym_RPAREN] = ACTIONS(457),
    [anon_sym_SEMI_SEMI] = ACTIONS(457),
    [anon_sym_RBRACE] = ACTIONS(457),
    [anon_sym_PIPE_AMP] = ACTIONS(457),
    [anon_sym_AMP_AMP] = ACTIONS(457),
    [anon_sym_PIPE_PIPE] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(457),
    [anon_sym_AMP_GT] = ACTIONS(457),
    [anon_sym_AMP_GT_GT] = ACTIONS(457),
    [anon_sym_LT_AMP] = ACTIONS(457),
    [anon_sym_GT_AMP] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(457),
    [sym_raw_string] = ACTIONS(457),
    [anon_sym_DOLLAR] = ACTIONS(457),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(457),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(457),
    [anon_sym_BQUOTE] = ACTIONS(457),
    [anon_sym_LT_LPAREN] = ACTIONS(457),
    [anon_sym_GT_LPAREN] = ACTIONS(457),
    [sym_word] = ACTIONS(457),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(457),
    [anon_sym_LF] = ACTIONS(457),
    [anon_sym_AMP] = ACTIONS(457),
  },
  [1164] = {
    [sym_file_descriptor] = ACTIONS(459),
    [sym__concat] = ACTIONS(459),
    [sym_variable_name] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(461),
    [anon_sym_RPAREN] = ACTIONS(461),
    [anon_sym_SEMI_SEMI] = ACTIONS(461),
    [anon_sym_RBRACE] = ACTIONS(461),
    [anon_sym_PIPE_AMP] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(461),
    [anon_sym_AMP_GT] = ACTIONS(461),
    [anon_sym_AMP_GT_GT] = ACTIONS(461),
    [anon_sym_LT_AMP] = ACTIONS(461),
    [anon_sym_GT_AMP] = ACTIONS(461),
    [anon_sym_DQUOTE] = ACTIONS(461),
    [sym_raw_string] = ACTIONS(461),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(461),
    [anon_sym_BQUOTE] = ACTIONS(461),
    [anon_sym_LT_LPAREN] = ACTIONS(461),
    [anon_sym_GT_LPAREN] = ACTIONS(461),
    [sym_word] = ACTIONS(461),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_LF] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(461),
  },
  [1165] = {
    [sym_file_descriptor] = ACTIONS(463),
    [sym__concat] = ACTIONS(463),
    [sym_variable_name] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_SEMI_SEMI] = ACTIONS(465),
    [anon_sym_RBRACE] = ACTIONS(465),
    [anon_sym_PIPE_AMP] = ACTIONS(465),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE_PIPE] = ACTIONS(465),
    [anon_sym_LT] = ACTIONS(465),
    [anon_sym_GT] = ACTIONS(465),
    [anon_sym_GT_GT] = ACTIONS(465),
    [anon_sym_AMP_GT] = ACTIONS(465),
    [anon_sym_AMP_GT_GT] = ACTIONS(465),
    [anon_sym_LT_AMP] = ACTIONS(465),
    [anon_sym_GT_AMP] = ACTIONS(465),
    [anon_sym_DQUOTE] = ACTIONS(465),
    [sym_raw_string] = ACTIONS(465),
    [anon_sym_DOLLAR] = ACTIONS(465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(465),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(465),
    [anon_sym_BQUOTE] = ACTIONS(465),
    [anon_sym_LT_LPAREN] = ACTIONS(465),
    [anon_sym_GT_LPAREN] = ACTIONS(465),
    [sym_word] = ACTIONS(465),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(465),
    [anon_sym_LF] = ACTIONS(465),
    [anon_sym_AMP] = ACTIONS(465),
  },
  [1166] = {
    [sym_file_descriptor] = ACTIONS(467),
    [sym__concat] = ACTIONS(467),
    [sym_variable_name] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_RPAREN] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_RBRACE] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
  },
  [1167] = {
    [sym_special_variable_name] = STATE(1258),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(225),
    [anon_sym_AT] = ACTIONS(219),
    [anon_sym_COLON] = ACTIONS(471),
    [anon_sym_COLON_QMARK] = ACTIONS(459),
    [anon_sym_COLON_DASH] = ACTIONS(459),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(3207),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [1168] = {
    [anon_sym_RBRACE] = ACTIONS(3209),
    [anon_sym_LBRACK] = ACTIONS(3211),
    [anon_sym_EQ] = ACTIONS(3213),
    [anon_sym_COLON] = ACTIONS(3215),
    [anon_sym_COLON_QMARK] = ACTIONS(3213),
    [anon_sym_COLON_DASH] = ACTIONS(3213),
    [anon_sym_PERCENT] = ACTIONS(3213),
    [anon_sym_SLASH] = ACTIONS(3213),
    [sym_comment] = ACTIONS(133),
  },
  [1169] = {
    [anon_sym_RBRACE] = ACTIONS(3217),
    [anon_sym_LBRACK] = ACTIONS(3219),
    [anon_sym_EQ] = ACTIONS(3221),
    [anon_sym_COLON] = ACTIONS(3223),
    [anon_sym_COLON_QMARK] = ACTIONS(3221),
    [anon_sym_COLON_DASH] = ACTIONS(3221),
    [anon_sym_PERCENT] = ACTIONS(3221),
    [anon_sym_SLASH] = ACTIONS(3221),
    [sym_comment] = ACTIONS(133),
  },
  [1170] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(3225),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [1171] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(3225),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [1172] = {
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(3225),
    [sym_comment] = ACTIONS(133),
  },
  [1173] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(3227),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [1174] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(3230),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [1175] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(3230),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [1176] = {
    [sym_file_descriptor] = ACTIONS(427),
    [sym__concat] = ACTIONS(427),
    [sym_variable_name] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(429),
    [anon_sym_SEMI_SEMI] = ACTIONS(429),
    [anon_sym_PIPE_AMP] = ACTIONS(429),
    [anon_sym_AMP_AMP] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_GT] = ACTIONS(429),
    [anon_sym_AMP_GT] = ACTIONS(429),
    [anon_sym_AMP_GT_GT] = ACTIONS(429),
    [anon_sym_LT_AMP] = ACTIONS(429),
    [anon_sym_GT_AMP] = ACTIONS(429),
    [anon_sym_LT_LT] = ACTIONS(429),
    [anon_sym_LT_LT_DASH] = ACTIONS(429),
    [anon_sym_DQUOTE] = ACTIONS(429),
    [sym_raw_string] = ACTIONS(429),
    [anon_sym_DOLLAR] = ACTIONS(429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(429),
    [anon_sym_BQUOTE] = ACTIONS(429),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [sym_word] = ACTIONS(429),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(429),
    [anon_sym_LF] = ACTIONS(429),
    [anon_sym_AMP] = ACTIONS(429),
  },
  [1177] = {
    [sym_simple_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [anon_sym_DQUOTE] = ACTIONS(3232),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(447),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [1178] = {
    [sym_string] = STATE(1268),
    [sym_simple_expansion] = STATE(1268),
    [sym_expansion] = STATE(1268),
    [sym_command_substitution] = STATE(1268),
    [sym_process_substitution] = STATE(1268),
    [anon_sym_DQUOTE] = ACTIONS(2417),
    [sym_raw_string] = ACTIONS(3234),
    [anon_sym_DOLLAR] = ACTIONS(2421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2423),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2425),
    [anon_sym_BQUOTE] = ACTIONS(2427),
    [anon_sym_LT_LPAREN] = ACTIONS(2429),
    [anon_sym_GT_LPAREN] = ACTIONS(2429),
    [sym_word] = ACTIONS(3236),
    [sym_comment] = ACTIONS(133),
  },
  [1179] = {
    [sym_file_descriptor] = ACTIONS(453),
    [sym__concat] = ACTIONS(3238),
    [sym_variable_name] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(457),
    [anon_sym_RPAREN] = ACTIONS(457),
    [anon_sym_SEMI_SEMI] = ACTIONS(457),
    [anon_sym_PIPE_AMP] = ACTIONS(457),
    [anon_sym_AMP_AMP] = ACTIONS(457),
    [anon_sym_PIPE_PIPE] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(457),
    [anon_sym_AMP_GT] = ACTIONS(457),
    [anon_sym_AMP_GT_GT] = ACTIONS(457),
    [anon_sym_LT_AMP] = ACTIONS(457),
    [anon_sym_GT_AMP] = ACTIONS(457),
    [anon_sym_LT_LT] = ACTIONS(457),
    [anon_sym_LT_LT_DASH] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(457),
    [sym_raw_string] = ACTIONS(457),
    [anon_sym_DOLLAR] = ACTIONS(457),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(457),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(457),
    [anon_sym_BQUOTE] = ACTIONS(457),
    [anon_sym_LT_LPAREN] = ACTIONS(457),
    [anon_sym_GT_LPAREN] = ACTIONS(457),
    [sym_word] = ACTIONS(457),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(457),
    [anon_sym_LF] = ACTIONS(457),
    [anon_sym_AMP] = ACTIONS(457),
  },
  [1180] = {
    [sym_file_descriptor] = ACTIONS(459),
    [sym__concat] = ACTIONS(459),
    [sym_variable_name] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(461),
    [anon_sym_RPAREN] = ACTIONS(461),
    [anon_sym_SEMI_SEMI] = ACTIONS(461),
    [anon_sym_PIPE_AMP] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(461),
    [anon_sym_AMP_GT] = ACTIONS(461),
    [anon_sym_AMP_GT_GT] = ACTIONS(461),
    [anon_sym_LT_AMP] = ACTIONS(461),
    [anon_sym_GT_AMP] = ACTIONS(461),
    [anon_sym_LT_LT] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_DQUOTE] = ACTIONS(461),
    [sym_raw_string] = ACTIONS(461),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(461),
    [anon_sym_BQUOTE] = ACTIONS(461),
    [anon_sym_LT_LPAREN] = ACTIONS(461),
    [anon_sym_GT_LPAREN] = ACTIONS(461),
    [sym_word] = ACTIONS(461),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_LF] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(461),
  },
  [1181] = {
    [sym_file_descriptor] = ACTIONS(463),
    [sym__concat] = ACTIONS(463),
    [sym_variable_name] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_SEMI_SEMI] = ACTIONS(465),
    [anon_sym_PIPE_AMP] = ACTIONS(465),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE_PIPE] = ACTIONS(465),
    [anon_sym_LT] = ACTIONS(465),
    [anon_sym_GT] = ACTIONS(465),
    [anon_sym_GT_GT] = ACTIONS(465),
    [anon_sym_AMP_GT] = ACTIONS(465),
    [anon_sym_AMP_GT_GT] = ACTIONS(465),
    [anon_sym_LT_AMP] = ACTIONS(465),
    [anon_sym_GT_AMP] = ACTIONS(465),
    [anon_sym_LT_LT] = ACTIONS(465),
    [anon_sym_LT_LT_DASH] = ACTIONS(465),
    [anon_sym_DQUOTE] = ACTIONS(465),
    [sym_raw_string] = ACTIONS(465),
    [anon_sym_DOLLAR] = ACTIONS(465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(465),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(465),
    [anon_sym_BQUOTE] = ACTIONS(465),
    [anon_sym_LT_LPAREN] = ACTIONS(465),
    [anon_sym_GT_LPAREN] = ACTIONS(465),
    [sym_word] = ACTIONS(465),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(465),
    [anon_sym_LF] = ACTIONS(465),
    [anon_sym_AMP] = ACTIONS(465),
  },
  [1182] = {
    [sym_file_descriptor] = ACTIONS(467),
    [sym__concat] = ACTIONS(467),
    [sym_variable_name] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_RPAREN] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
  },
  [1183] = {
    [sym_special_variable_name] = STATE(1271),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(225),
    [anon_sym_AT] = ACTIONS(219),
    [anon_sym_COLON] = ACTIONS(471),
    [anon_sym_COLON_QMARK] = ACTIONS(459),
    [anon_sym_COLON_DASH] = ACTIONS(459),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(3240),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [1184] = {
    [anon_sym_RBRACE] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3244),
    [anon_sym_EQ] = ACTIONS(3246),
    [anon_sym_COLON] = ACTIONS(3248),
    [anon_sym_COLON_QMARK] = ACTIONS(3246),
    [anon_sym_COLON_DASH] = ACTIONS(3246),
    [anon_sym_PERCENT] = ACTIONS(3246),
    [anon_sym_SLASH] = ACTIONS(3246),
    [sym_comment] = ACTIONS(133),
  },
  [1185] = {
    [anon_sym_RBRACE] = ACTIONS(3250),
    [anon_sym_LBRACK] = ACTIONS(3252),
    [anon_sym_EQ] = ACTIONS(3254),
    [anon_sym_COLON] = ACTIONS(3256),
    [anon_sym_COLON_QMARK] = ACTIONS(3254),
    [anon_sym_COLON_DASH] = ACTIONS(3254),
    [anon_sym_PERCENT] = ACTIONS(3254),
    [anon_sym_SLASH] = ACTIONS(3254),
    [sym_comment] = ACTIONS(133),
  },
  [1186] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(3258),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [1187] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(3258),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [1188] = {
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(3258),
    [sym_comment] = ACTIONS(133),
  },
  [1189] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(3260),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [1190] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(3263),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [1191] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(3263),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [1192] = {
    [sym_file_descriptor] = ACTIONS(829),
    [sym__concat] = ACTIONS(829),
    [sym_variable_name] = ACTIONS(829),
    [anon_sym_in] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(831),
    [anon_sym_RPAREN] = ACTIONS(831),
    [anon_sym_SEMI_SEMI] = ACTIONS(831),
    [anon_sym_RBRACE] = ACTIONS(831),
    [anon_sym_PIPE_AMP] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_RBRACK] = ACTIONS(831),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(831),
    [anon_sym_GT_GT] = ACTIONS(831),
    [anon_sym_AMP_GT] = ACTIONS(831),
    [anon_sym_AMP_GT_GT] = ACTIONS(831),
    [anon_sym_LT_AMP] = ACTIONS(831),
    [anon_sym_GT_AMP] = ACTIONS(831),
    [anon_sym_LT_LT] = ACTIONS(831),
    [anon_sym_LT_LT_DASH] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(831),
    [sym_raw_string] = ACTIONS(831),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(831),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(831),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [anon_sym_LT_LPAREN] = ACTIONS(831),
    [anon_sym_GT_LPAREN] = ACTIONS(831),
    [sym_word] = ACTIONS(831),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(831),
    [anon_sym_LF] = ACTIONS(831),
    [anon_sym_AMP] = ACTIONS(831),
  },
  [1193] = {
    [sym_case_item] = STATE(555),
    [sym_concatenation] = STATE(556),
    [sym_string] = STATE(554),
    [sym_simple_expansion] = STATE(554),
    [sym_expansion] = STATE(554),
    [sym_command_substitution] = STATE(554),
    [sym_process_substitution] = STATE(554),
    [aux_sym_case_statement_repeat1] = STATE(1281),
    [anon_sym_esac] = ACTIONS(3265),
    [anon_sym_DQUOTE] = ACTIONS(315),
    [sym_raw_string] = ACTIONS(1143),
    [anon_sym_DOLLAR] = ACTIONS(319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(327),
    [anon_sym_GT_LPAREN] = ACTIONS(327),
    [sym_word] = ACTIONS(1145),
    [sym_comment] = ACTIONS(133),
  },
  [1194] = {
    [sym__heredoc_middle] = ACTIONS(1261),
    [sym__heredoc_end] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1261),
    [sym_variable_name] = ACTIONS(1261),
    [anon_sym_in] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1263),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_PIPE_AMP] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1263),
    [anon_sym_RBRACK] = ACTIONS(1263),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1263),
    [anon_sym_LT_AMP] = ACTIONS(1263),
    [anon_sym_GT_AMP] = ACTIONS(1263),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1263),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1263),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1263),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [anon_sym_LT_LPAREN] = ACTIONS(1263),
    [anon_sym_GT_LPAREN] = ACTIONS(1263),
    [sym_word] = ACTIONS(1263),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [1195] = {
    [anon_sym_AT] = ACTIONS(3267),
    [sym_comment] = ACTIONS(133),
  },
  [1196] = {
    [sym__heredoc_middle] = ACTIONS(1267),
    [sym__heredoc_end] = ACTIONS(1267),
    [sym_file_descriptor] = ACTIONS(1267),
    [sym__concat] = ACTIONS(1267),
    [sym_variable_name] = ACTIONS(1267),
    [anon_sym_in] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_RPAREN] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1269),
    [anon_sym_RBRACE] = ACTIONS(1269),
    [anon_sym_PIPE_AMP] = ACTIONS(1269),
    [anon_sym_AMP_AMP] = ACTIONS(1269),
    [anon_sym_PIPE_PIPE] = ACTIONS(1269),
    [anon_sym_RBRACK] = ACTIONS(1269),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1269),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1269),
    [anon_sym_LT_AMP] = ACTIONS(1269),
    [anon_sym_GT_AMP] = ACTIONS(1269),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1269),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(1269),
    [sym_raw_string] = ACTIONS(1269),
    [anon_sym_DOLLAR] = ACTIONS(1269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1269),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1269),
    [anon_sym_BQUOTE] = ACTIONS(1269),
    [anon_sym_LT_LPAREN] = ACTIONS(1269),
    [anon_sym_GT_LPAREN] = ACTIONS(1269),
    [sym_word] = ACTIONS(1269),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_LF] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [1197] = {
    [anon_sym_AT] = ACTIONS(3269),
    [sym_comment] = ACTIONS(133),
  },
  [1198] = {
    [sym_file_descriptor] = ACTIONS(965),
    [sym__concat] = ACTIONS(965),
    [sym_variable_name] = ACTIONS(965),
    [anon_sym_in] = ACTIONS(967),
    [anon_sym_PIPE] = ACTIONS(967),
    [anon_sym_RPAREN] = ACTIONS(967),
    [anon_sym_SEMI_SEMI] = ACTIONS(967),
    [anon_sym_RBRACE] = ACTIONS(967),
    [anon_sym_PIPE_AMP] = ACTIONS(967),
    [anon_sym_AMP_AMP] = ACTIONS(967),
    [anon_sym_PIPE_PIPE] = ACTIONS(967),
    [anon_sym_RBRACK] = ACTIONS(967),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(967),
    [anon_sym_LT] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(967),
    [anon_sym_GT_GT] = ACTIONS(967),
    [anon_sym_AMP_GT] = ACTIONS(967),
    [anon_sym_AMP_GT_GT] = ACTIONS(967),
    [anon_sym_LT_AMP] = ACTIONS(967),
    [anon_sym_GT_AMP] = ACTIONS(967),
    [anon_sym_LT_LT] = ACTIONS(967),
    [anon_sym_LT_LT_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(967),
    [sym_raw_string] = ACTIONS(967),
    [anon_sym_DOLLAR] = ACTIONS(967),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(967),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(967),
    [anon_sym_BQUOTE] = ACTIONS(967),
    [anon_sym_LT_LPAREN] = ACTIONS(967),
    [anon_sym_GT_LPAREN] = ACTIONS(967),
    [sym_word] = ACTIONS(967),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_LF] = ACTIONS(967),
    [anon_sym_AMP] = ACTIONS(967),
  },
  [1199] = {
    [sym_case_item] = STATE(555),
    [sym_concatenation] = STATE(556),
    [sym_string] = STATE(554),
    [sym_simple_expansion] = STATE(554),
    [sym_expansion] = STATE(554),
    [sym_command_substitution] = STATE(554),
    [sym_process_substitution] = STATE(554),
    [aux_sym_case_statement_repeat1] = STATE(1285),
    [anon_sym_esac] = ACTIONS(3271),
    [anon_sym_DQUOTE] = ACTIONS(315),
    [sym_raw_string] = ACTIONS(1143),
    [anon_sym_DOLLAR] = ACTIONS(319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(327),
    [anon_sym_GT_LPAREN] = ACTIONS(327),
    [sym_word] = ACTIONS(1145),
    [sym_comment] = ACTIONS(133),
  },
  [1200] = {
    [aux_sym_concatenation_repeat1] = STATE(1179),
    [sym_file_descriptor] = ACTIONS(613),
    [sym__concat] = ACTIONS(3012),
    [sym_variable_name] = ACTIONS(613),
    [anon_sym_PIPE] = ACTIONS(1385),
    [anon_sym_RPAREN] = ACTIONS(1385),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1385),
    [anon_sym_GT] = ACTIONS(1385),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1385),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_word] = ACTIONS(1385),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1385),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1385),
  },
  [1201] = {
    [sym_file_descriptor] = ACTIONS(613),
    [sym_variable_name] = ACTIONS(613),
    [anon_sym_PIPE] = ACTIONS(1385),
    [anon_sym_RPAREN] = ACTIONS(1385),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1385),
    [anon_sym_GT] = ACTIONS(1385),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1385),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [sym_raw_string] = ACTIONS(1385),
    [anon_sym_DOLLAR] = ACTIONS(1385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [anon_sym_LT_LPAREN] = ACTIONS(1385),
    [anon_sym_GT_LPAREN] = ACTIONS(1385),
    [sym_word] = ACTIONS(1385),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1385),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1385),
  },
  [1202] = {
    [sym_file_descriptor] = ACTIONS(459),
    [sym__concat] = ACTIONS(459),
    [sym_variable_name] = ACTIONS(459),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(461),
    [anon_sym_RPAREN] = ACTIONS(461),
    [anon_sym_SEMI_SEMI] = ACTIONS(461),
    [anon_sym_RBRACE] = ACTIONS(461),
    [anon_sym_PIPE_AMP] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_RBRACK] = ACTIONS(461),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(461),
    [anon_sym_AMP_GT] = ACTIONS(461),
    [anon_sym_AMP_GT_GT] = ACTIONS(461),
    [anon_sym_LT_AMP] = ACTIONS(461),
    [anon_sym_GT_AMP] = ACTIONS(461),
    [anon_sym_LT_LT] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_DQUOTE] = ACTIONS(461),
    [sym_raw_string] = ACTIONS(461),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(461),
    [anon_sym_BQUOTE] = ACTIONS(461),
    [anon_sym_LT_LPAREN] = ACTIONS(461),
    [anon_sym_GT_LPAREN] = ACTIONS(461),
    [sym_word] = ACTIONS(461),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_LF] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(461),
  },
  [1203] = {
    [sym_file_descriptor] = ACTIONS(463),
    [sym__concat] = ACTIONS(463),
    [sym_variable_name] = ACTIONS(463),
    [anon_sym_in] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_SEMI_SEMI] = ACTIONS(465),
    [anon_sym_RBRACE] = ACTIONS(465),
    [anon_sym_PIPE_AMP] = ACTIONS(465),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE_PIPE] = ACTIONS(465),
    [anon_sym_RBRACK] = ACTIONS(465),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(465),
    [anon_sym_LT] = ACTIONS(465),
    [anon_sym_GT] = ACTIONS(465),
    [anon_sym_GT_GT] = ACTIONS(465),
    [anon_sym_AMP_GT] = ACTIONS(465),
    [anon_sym_AMP_GT_GT] = ACTIONS(465),
    [anon_sym_LT_AMP] = ACTIONS(465),
    [anon_sym_GT_AMP] = ACTIONS(465),
    [anon_sym_LT_LT] = ACTIONS(465),
    [anon_sym_LT_LT_DASH] = ACTIONS(465),
    [anon_sym_DQUOTE] = ACTIONS(465),
    [sym_raw_string] = ACTIONS(465),
    [anon_sym_DOLLAR] = ACTIONS(465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(465),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(465),
    [anon_sym_BQUOTE] = ACTIONS(465),
    [anon_sym_LT_LPAREN] = ACTIONS(465),
    [anon_sym_GT_LPAREN] = ACTIONS(465),
    [sym_word] = ACTIONS(465),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(465),
    [anon_sym_LF] = ACTIONS(465),
    [anon_sym_AMP] = ACTIONS(465),
  },
  [1204] = {
    [sym_file_descriptor] = ACTIONS(467),
    [sym__concat] = ACTIONS(467),
    [sym_variable_name] = ACTIONS(467),
    [anon_sym_in] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_RPAREN] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_RBRACE] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [anon_sym_RBRACK] = ACTIONS(469),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
  },
  [1205] = {
    [sym_special_variable_name] = STATE(1287),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(225),
    [anon_sym_AT] = ACTIONS(219),
    [anon_sym_COLON] = ACTIONS(471),
    [anon_sym_COLON_QMARK] = ACTIONS(459),
    [anon_sym_COLON_DASH] = ACTIONS(459),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(3273),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [1206] = {
    [anon_sym_RBRACE] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(3277),
    [anon_sym_EQ] = ACTIONS(3279),
    [anon_sym_COLON] = ACTIONS(3281),
    [anon_sym_COLON_QMARK] = ACTIONS(3279),
    [anon_sym_COLON_DASH] = ACTIONS(3279),
    [anon_sym_PERCENT] = ACTIONS(3279),
    [anon_sym_SLASH] = ACTIONS(3279),
    [sym_comment] = ACTIONS(133),
  },
  [1207] = {
    [anon_sym_RBRACE] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3289),
    [anon_sym_COLON_QMARK] = ACTIONS(3287),
    [anon_sym_COLON_DASH] = ACTIONS(3287),
    [anon_sym_PERCENT] = ACTIONS(3287),
    [anon_sym_SLASH] = ACTIONS(3287),
    [sym_comment] = ACTIONS(133),
  },
  [1208] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(3291),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [1209] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(3291),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [1210] = {
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(3291),
    [sym_comment] = ACTIONS(133),
  },
  [1211] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(3293),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [1212] = {
    [aux_sym_concatenation_repeat1] = STATE(77),
    [sym_file_descriptor] = ACTIONS(207),
    [sym__concat] = ACTIONS(209),
    [anon_sym_PIPE] = ACTIONS(211),
    [anon_sym_RPAREN] = ACTIONS(211),
    [anon_sym_SEMI_SEMI] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(2944),
    [anon_sym_PIPE_AMP] = ACTIONS(211),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(211),
    [anon_sym_GT] = ACTIONS(211),
    [anon_sym_GT_GT] = ACTIONS(211),
    [anon_sym_AMP_GT] = ACTIONS(211),
    [anon_sym_AMP_GT_GT] = ACTIONS(211),
    [anon_sym_LT_AMP] = ACTIONS(211),
    [anon_sym_GT_AMP] = ACTIONS(211),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LT_LT_DASH] = ACTIONS(211),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(211),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_LT_LPAREN] = ACTIONS(211),
    [anon_sym_GT_LPAREN] = ACTIONS(211),
    [sym_word] = ACTIONS(211),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_LF] = ACTIONS(211),
    [anon_sym_AMP] = ACTIONS(211),
  },
  [1213] = {
    [anon_sym_PIPE] = ACTIONS(3296),
    [anon_sym_RPAREN] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(973),
    [anon_sym_PIPE_AMP] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3299),
    [anon_sym_PIPE_PIPE] = ACTIONS(3299),
    [anon_sym_BQUOTE] = ACTIONS(973),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_LF] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [1214] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(3296),
    [anon_sym_RPAREN] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(973),
    [anon_sym_PIPE_AMP] = ACTIONS(3296),
    [anon_sym_AMP_AMP] = ACTIONS(3299),
    [anon_sym_PIPE_PIPE] = ACTIONS(3299),
    [anon_sym_LT] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(301),
    [anon_sym_GT_GT] = ACTIONS(301),
    [anon_sym_AMP_GT] = ACTIONS(301),
    [anon_sym_AMP_GT_GT] = ACTIONS(301),
    [anon_sym_LT_AMP] = ACTIONS(301),
    [anon_sym_GT_AMP] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(301),
    [sym_raw_string] = ACTIONS(301),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(301),
    [anon_sym_BQUOTE] = ACTIONS(3302),
    [anon_sym_LT_LPAREN] = ACTIONS(301),
    [anon_sym_GT_LPAREN] = ACTIONS(301),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_LF] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [1215] = {
    [sym_concatenation] = STATE(1296),
    [sym_string] = STATE(1295),
    [sym_simple_expansion] = STATE(1295),
    [sym_expansion] = STATE(1295),
    [sym_command_substitution] = STATE(1295),
    [sym_process_substitution] = STATE(1295),
    [anon_sym_DQUOTE] = ACTIONS(3105),
    [sym_raw_string] = ACTIONS(3305),
    [anon_sym_DOLLAR] = ACTIONS(3109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3113),
    [anon_sym_BQUOTE] = ACTIONS(3115),
    [anon_sym_LT_LPAREN] = ACTIONS(3117),
    [anon_sym_GT_LPAREN] = ACTIONS(3117),
    [sym_word] = ACTIONS(3307),
    [sym_comment] = ACTIONS(133),
  },
  [1216] = {
    [sym_simple_expansion] = STATE(70),
    [sym_expansion] = STATE(70),
    [sym_command_substitution] = STATE(70),
    [aux_sym_string_repeat1] = STATE(1298),
    [anon_sym_DQUOTE] = ACTIONS(3309),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(197),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [1217] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym_file_descriptor] = ACTIONS(411),
    [sym__concat] = ACTIONS(3311),
    [anon_sym_PIPE] = ACTIONS(983),
    [anon_sym_RPAREN] = ACTIONS(983),
    [anon_sym_SEMI_SEMI] = ACTIONS(983),
    [anon_sym_PIPE_AMP] = ACTIONS(983),
    [anon_sym_AMP_AMP] = ACTIONS(983),
    [anon_sym_PIPE_PIPE] = ACTIONS(983),
    [anon_sym_LT] = ACTIONS(983),
    [anon_sym_GT] = ACTIONS(983),
    [anon_sym_GT_GT] = ACTIONS(983),
    [anon_sym_AMP_GT] = ACTIONS(983),
    [anon_sym_AMP_GT_GT] = ACTIONS(983),
    [anon_sym_LT_AMP] = ACTIONS(983),
    [anon_sym_GT_AMP] = ACTIONS(983),
    [anon_sym_LT_LT] = ACTIONS(983),
    [anon_sym_LT_LT_DASH] = ACTIONS(983),
    [anon_sym_BQUOTE] = ACTIONS(983),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_LF] = ACTIONS(983),
    [anon_sym_AMP] = ACTIONS(983),
  },
  [1218] = {
    [sym_special_variable_name] = STATE(1303),
    [anon_sym_DOLLAR] = ACTIONS(3313),
    [anon_sym_POUND] = ACTIONS(3315),
    [anon_sym_AT] = ACTIONS(3313),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(3317),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_QMARK] = ACTIONS(3313),
    [anon_sym_DASH] = ACTIONS(3313),
    [anon_sym_BANG] = ACTIONS(3313),
    [anon_sym_0] = ACTIONS(3315),
    [anon_sym__] = ACTIONS(3315),
  },
  [1219] = {
    [sym_special_variable_name] = STATE(1306),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(3319),
    [anon_sym_AT] = ACTIONS(219),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(3321),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [1220] = {
    [sym_for_statement] = STATE(1307),
    [sym_while_statement] = STATE(1307),
    [sym_if_statement] = STATE(1307),
    [sym_case_statement] = STATE(1307),
    [sym_function_definition] = STATE(1307),
    [sym_subshell] = STATE(1307),
    [sym_pipeline] = STATE(1307),
    [sym_list] = STATE(1307),
    [sym_bracket_command] = STATE(1307),
    [sym_command] = STATE(1307),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(1308),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [1221] = {
    [sym_for_statement] = STATE(1309),
    [sym_while_statement] = STATE(1309),
    [sym_if_statement] = STATE(1309),
    [sym_case_statement] = STATE(1309),
    [sym_function_definition] = STATE(1309),
    [sym_subshell] = STATE(1309),
    [sym_pipeline] = STATE(1309),
    [sym_list] = STATE(1309),
    [sym_bracket_command] = STATE(1309),
    [sym_command] = STATE(1309),
    [sym_command_name] = STATE(109),
    [sym_environment_variable_assignment] = STATE(1310),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [1222] = {
    [sym_for_statement] = STATE(1311),
    [sym_while_statement] = STATE(1311),
    [sym_if_statement] = STATE(1311),
    [sym_case_statement] = STATE(1311),
    [sym_function_definition] = STATE(1311),
    [sym_subshell] = STATE(1311),
    [sym_pipeline] = STATE(1311),
    [sym_list] = STATE(1311),
    [sym_bracket_command] = STATE(1311),
    [sym_command] = STATE(1311),
    [sym_command_name] = STATE(103),
    [sym_environment_variable_assignment] = STATE(1312),
    [sym_subscript] = STATE(105),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(106),
    [sym_string] = STATE(95),
    [sym_simple_expansion] = STATE(95),
    [sym_expansion] = STATE(95),
    [sym_command_substitution] = STATE(95),
    [sym_process_substitution] = STATE(95),
    [aux_sym_command_repeat1] = STATE(107),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(227),
    [anon_sym_for] = ACTIONS(229),
    [anon_sym_while] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_case] = ACTIONS(235),
    [anon_sym_function] = ACTIONS(237),
    [anon_sym_LPAREN] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [sym_raw_string] = ACTIONS(247),
    [anon_sym_DOLLAR] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_BQUOTE] = ACTIONS(255),
    [anon_sym_LT_LPAREN] = ACTIONS(257),
    [anon_sym_GT_LPAREN] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_comment] = ACTIONS(133),
  },
  [1223] = {
    [sym_file_descriptor] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(983),
    [anon_sym_RPAREN] = ACTIONS(983),
    [anon_sym_SEMI_SEMI] = ACTIONS(983),
    [anon_sym_PIPE_AMP] = ACTIONS(983),
    [anon_sym_AMP_AMP] = ACTIONS(983),
    [anon_sym_PIPE_PIPE] = ACTIONS(983),
    [anon_sym_LT] = ACTIONS(983),
    [anon_sym_GT] = ACTIONS(983),
    [anon_sym_GT_GT] = ACTIONS(983),
    [anon_sym_AMP_GT] = ACTIONS(983),
    [anon_sym_AMP_GT_GT] = ACTIONS(983),
    [anon_sym_LT_AMP] = ACTIONS(983),
    [anon_sym_GT_AMP] = ACTIONS(983),
    [anon_sym_LT_LT] = ACTIONS(983),
    [anon_sym_LT_LT_DASH] = ACTIONS(983),
    [anon_sym_BQUOTE] = ACTIONS(983),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_LF] = ACTIONS(983),
    [anon_sym_AMP] = ACTIONS(983),
  },
  [1224] = {
    [anon_sym_RBRACK] = ACTIONS(3323),
    [sym_comment] = ACTIONS(133),
  },
  [1225] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(3325),
    [sym_comment] = ACTIONS(133),
  },
  [1226] = {
    [anon_sym_RBRACE] = ACTIONS(3325),
    [sym_comment] = ACTIONS(133),
  },
  [1227] = {
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_RPAREN] = ACTIONS(1173),
    [anon_sym_SEMI_SEMI] = ACTIONS(1173),
    [anon_sym_PIPE_AMP] = ACTIONS(1173),
    [anon_sym_AMP_AMP] = ACTIONS(1173),
    [anon_sym_PIPE_PIPE] = ACTIONS(1173),
    [anon_sym_BQUOTE] = ACTIONS(1173),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1173),
    [anon_sym_LF] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1173),
  },
  [1228] = {
    [sym_file_descriptor] = ACTIONS(563),
    [sym_variable_name] = ACTIONS(563),
    [ts_builtin_sym_end] = ACTIONS(563),
    [anon_sym_for] = ACTIONS(565),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_done] = ACTIONS(565),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_fi] = ACTIONS(565),
    [anon_sym_elif] = ACTIONS(565),
    [anon_sym_else] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(3327),
    [anon_sym_SEMI_SEMI] = ACTIONS(563),
    [anon_sym_function] = ACTIONS(565),
    [anon_sym_LPAREN] = ACTIONS(563),
    [anon_sym_RBRACE] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(565),
    [anon_sym_GT] = ACTIONS(565),
    [anon_sym_GT_GT] = ACTIONS(563),
    [anon_sym_AMP_GT] = ACTIONS(565),
    [anon_sym_AMP_GT_GT] = ACTIONS(563),
    [anon_sym_LT_AMP] = ACTIONS(563),
    [anon_sym_GT_AMP] = ACTIONS(563),
    [anon_sym_DQUOTE] = ACTIONS(563),
    [sym_raw_string] = ACTIONS(563),
    [anon_sym_DOLLAR] = ACTIONS(565),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(563),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(563),
    [anon_sym_BQUOTE] = ACTIONS(563),
    [anon_sym_LT_LPAREN] = ACTIONS(563),
    [anon_sym_GT_LPAREN] = ACTIONS(563),
    [sym_word] = ACTIONS(567),
    [sym_comment] = ACTIONS(133),
  },
  [1229] = {
    [anon_sym_PIPE] = ACTIONS(1819),
    [anon_sym_RPAREN] = ACTIONS(1819),
    [anon_sym_SEMI_SEMI] = ACTIONS(1819),
    [anon_sym_PIPE_AMP] = ACTIONS(1819),
    [anon_sym_AMP_AMP] = ACTIONS(1819),
    [anon_sym_PIPE_PIPE] = ACTIONS(1819),
    [anon_sym_BQUOTE] = ACTIONS(1819),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1819),
    [anon_sym_LF] = ACTIONS(1819),
    [anon_sym_AMP] = ACTIONS(1819),
  },
  [1230] = {
    [anon_sym_fi] = ACTIONS(3329),
    [sym_comment] = ACTIONS(133),
  },
  [1231] = {
    [sym_file_descriptor] = ACTIONS(427),
    [sym__concat] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(429),
    [anon_sym_SEMI_SEMI] = ACTIONS(429),
    [anon_sym_PIPE_AMP] = ACTIONS(429),
    [anon_sym_AMP_AMP] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(429),
    [anon_sym_RBRACK] = ACTIONS(429),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_GT] = ACTIONS(429),
    [anon_sym_AMP_GT] = ACTIONS(429),
    [anon_sym_AMP_GT_GT] = ACTIONS(429),
    [anon_sym_LT_AMP] = ACTIONS(429),
    [anon_sym_GT_AMP] = ACTIONS(429),
    [anon_sym_LT_LT] = ACTIONS(429),
    [anon_sym_LT_LT_DASH] = ACTIONS(429),
    [anon_sym_DQUOTE] = ACTIONS(429),
    [sym_raw_string] = ACTIONS(429),
    [anon_sym_DOLLAR] = ACTIONS(429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(429),
    [anon_sym_BQUOTE] = ACTIONS(429),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [sym_word] = ACTIONS(429),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(429),
    [anon_sym_LF] = ACTIONS(429),
    [anon_sym_AMP] = ACTIONS(429),
  },
  [1232] = {
    [sym_simple_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [anon_sym_DQUOTE] = ACTIONS(3331),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(447),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [1233] = {
    [sym_string] = STATE(1318),
    [sym_simple_expansion] = STATE(1318),
    [sym_expansion] = STATE(1318),
    [sym_command_substitution] = STATE(1318),
    [sym_process_substitution] = STATE(1318),
    [anon_sym_DQUOTE] = ACTIONS(3333),
    [sym_raw_string] = ACTIONS(3335),
    [anon_sym_DOLLAR] = ACTIONS(3337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3341),
    [anon_sym_BQUOTE] = ACTIONS(3343),
    [anon_sym_LT_LPAREN] = ACTIONS(3345),
    [anon_sym_GT_LPAREN] = ACTIONS(3345),
    [sym_word] = ACTIONS(3347),
    [sym_comment] = ACTIONS(133),
  },
  [1234] = {
    [sym_file_descriptor] = ACTIONS(453),
    [sym__concat] = ACTIONS(3349),
    [anon_sym_PIPE] = ACTIONS(457),
    [anon_sym_RPAREN] = ACTIONS(457),
    [anon_sym_SEMI_SEMI] = ACTIONS(457),
    [anon_sym_PIPE_AMP] = ACTIONS(457),
    [anon_sym_AMP_AMP] = ACTIONS(457),
    [anon_sym_PIPE_PIPE] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(457),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(457),
    [anon_sym_AMP_GT] = ACTIONS(457),
    [anon_sym_AMP_GT_GT] = ACTIONS(457),
    [anon_sym_LT_AMP] = ACTIONS(457),
    [anon_sym_GT_AMP] = ACTIONS(457),
    [anon_sym_LT_LT] = ACTIONS(457),
    [anon_sym_LT_LT_DASH] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(457),
    [sym_raw_string] = ACTIONS(457),
    [anon_sym_DOLLAR] = ACTIONS(457),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(457),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(457),
    [anon_sym_BQUOTE] = ACTIONS(457),
    [anon_sym_LT_LPAREN] = ACTIONS(457),
    [anon_sym_GT_LPAREN] = ACTIONS(457),
    [sym_word] = ACTIONS(457),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(457),
    [anon_sym_LF] = ACTIONS(457),
    [anon_sym_AMP] = ACTIONS(457),
  },
  [1235] = {
    [sym_file_descriptor] = ACTIONS(459),
    [sym__concat] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(461),
    [anon_sym_RPAREN] = ACTIONS(461),
    [anon_sym_SEMI_SEMI] = ACTIONS(461),
    [anon_sym_PIPE_AMP] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_RBRACK] = ACTIONS(461),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(461),
    [anon_sym_AMP_GT] = ACTIONS(461),
    [anon_sym_AMP_GT_GT] = ACTIONS(461),
    [anon_sym_LT_AMP] = ACTIONS(461),
    [anon_sym_GT_AMP] = ACTIONS(461),
    [anon_sym_LT_LT] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_DQUOTE] = ACTIONS(461),
    [sym_raw_string] = ACTIONS(461),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(461),
    [anon_sym_BQUOTE] = ACTIONS(461),
    [anon_sym_LT_LPAREN] = ACTIONS(461),
    [anon_sym_GT_LPAREN] = ACTIONS(461),
    [sym_word] = ACTIONS(461),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_LF] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(461),
  },
  [1236] = {
    [sym_file_descriptor] = ACTIONS(463),
    [sym__concat] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_SEMI_SEMI] = ACTIONS(465),
    [anon_sym_PIPE_AMP] = ACTIONS(465),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE_PIPE] = ACTIONS(465),
    [anon_sym_RBRACK] = ACTIONS(465),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(465),
    [anon_sym_LT] = ACTIONS(465),
    [anon_sym_GT] = ACTIONS(465),
    [anon_sym_GT_GT] = ACTIONS(465),
    [anon_sym_AMP_GT] = ACTIONS(465),
    [anon_sym_AMP_GT_GT] = ACTIONS(465),
    [anon_sym_LT_AMP] = ACTIONS(465),
    [anon_sym_GT_AMP] = ACTIONS(465),
    [anon_sym_LT_LT] = ACTIONS(465),
    [anon_sym_LT_LT_DASH] = ACTIONS(465),
    [anon_sym_DQUOTE] = ACTIONS(465),
    [sym_raw_string] = ACTIONS(465),
    [anon_sym_DOLLAR] = ACTIONS(465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(465),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(465),
    [anon_sym_BQUOTE] = ACTIONS(465),
    [anon_sym_LT_LPAREN] = ACTIONS(465),
    [anon_sym_GT_LPAREN] = ACTIONS(465),
    [sym_word] = ACTIONS(465),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(465),
    [anon_sym_LF] = ACTIONS(465),
    [anon_sym_AMP] = ACTIONS(465),
  },
  [1237] = {
    [sym_file_descriptor] = ACTIONS(467),
    [sym__concat] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_RPAREN] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [anon_sym_RBRACK] = ACTIONS(469),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
  },
  [1238] = {
    [sym_special_variable_name] = STATE(1321),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(225),
    [anon_sym_AT] = ACTIONS(219),
    [anon_sym_COLON] = ACTIONS(471),
    [anon_sym_COLON_QMARK] = ACTIONS(459),
    [anon_sym_COLON_DASH] = ACTIONS(459),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(3351),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [1239] = {
    [anon_sym_RBRACE] = ACTIONS(3353),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_EQ] = ACTIONS(3357),
    [anon_sym_COLON] = ACTIONS(3359),
    [anon_sym_COLON_QMARK] = ACTIONS(3357),
    [anon_sym_COLON_DASH] = ACTIONS(3357),
    [anon_sym_PERCENT] = ACTIONS(3357),
    [anon_sym_SLASH] = ACTIONS(3357),
    [sym_comment] = ACTIONS(133),
  },
  [1240] = {
    [anon_sym_RBRACE] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3363),
    [anon_sym_EQ] = ACTIONS(3365),
    [anon_sym_COLON] = ACTIONS(3367),
    [anon_sym_COLON_QMARK] = ACTIONS(3365),
    [anon_sym_COLON_DASH] = ACTIONS(3365),
    [anon_sym_PERCENT] = ACTIONS(3365),
    [anon_sym_SLASH] = ACTIONS(3365),
    [sym_comment] = ACTIONS(133),
  },
  [1241] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(3369),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [1242] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(3369),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [1243] = {
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(3369),
    [sym_comment] = ACTIONS(133),
  },
  [1244] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(3371),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [1245] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(3374),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [1246] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(3374),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [1247] = {
    [anon_sym_PIPE] = ACTIONS(3376),
    [anon_sym_RPAREN] = ACTIONS(3376),
    [anon_sym_SEMI_SEMI] = ACTIONS(3376),
    [anon_sym_PIPE_AMP] = ACTIONS(3376),
    [anon_sym_AMP_AMP] = ACTIONS(3376),
    [anon_sym_PIPE_PIPE] = ACTIONS(3376),
    [anon_sym_BQUOTE] = ACTIONS(3376),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(3376),
    [anon_sym_LF] = ACTIONS(3376),
    [anon_sym_AMP] = ACTIONS(3376),
  },
  [1248] = {
    [sym_file_redirect] = STATE(1119),
    [sym_heredoc_redirect] = STATE(1119),
    [sym_concatenation] = STATE(297),
    [sym_string] = STATE(296),
    [sym_simple_expansion] = STATE(296),
    [sym_expansion] = STATE(296),
    [sym_command_substitution] = STATE(296),
    [sym_process_substitution] = STATE(296),
    [aux_sym_command_repeat2] = STATE(1330),
    [sym_file_descriptor] = ACTIONS(2724),
    [anon_sym_PIPE] = ACTIONS(1017),
    [anon_sym_RPAREN] = ACTIONS(1017),
    [anon_sym_SEMI_SEMI] = ACTIONS(1017),
    [anon_sym_PIPE_AMP] = ACTIONS(1017),
    [anon_sym_AMP_AMP] = ACTIONS(1017),
    [anon_sym_PIPE_PIPE] = ACTIONS(1017),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT_GT] = ACTIONS(2729),
    [anon_sym_LT_AMP] = ACTIONS(2729),
    [anon_sym_GT_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2731),
    [anon_sym_LT_LT_DASH] = ACTIONS(2731),
    [anon_sym_DQUOTE] = ACTIONS(285),
    [sym_raw_string] = ACTIONS(599),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(291),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [anon_sym_BQUOTE] = ACTIONS(3379),
    [anon_sym_LT_LPAREN] = ACTIONS(297),
    [anon_sym_GT_LPAREN] = ACTIONS(297),
    [sym_word] = ACTIONS(599),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1017),
    [anon_sym_LF] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(1017),
  },
  [1249] = {
    [sym_file_redirect] = STATE(1147),
    [sym_heredoc_redirect] = STATE(1147),
    [sym_file_descriptor] = ACTIONS(2724),
    [anon_sym_PIPE] = ACTIONS(1011),
    [anon_sym_RPAREN] = ACTIONS(1011),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT_GT] = ACTIONS(2729),
    [anon_sym_LT_AMP] = ACTIONS(2729),
    [anon_sym_GT_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2731),
    [anon_sym_LT_LT_DASH] = ACTIONS(2731),
    [anon_sym_BQUOTE] = ACTIONS(1011),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1011),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1011),
  },
  [1250] = {
    [sym_file_descriptor] = ACTIONS(1257),
    [sym__concat] = ACTIONS(1257),
    [sym_variable_name] = ACTIONS(1257),
    [anon_sym_in] = ACTIONS(1259),
    [anon_sym_PIPE] = ACTIONS(1259),
    [anon_sym_RPAREN] = ACTIONS(1259),
    [anon_sym_SEMI_SEMI] = ACTIONS(1259),
    [anon_sym_RBRACE] = ACTIONS(1259),
    [anon_sym_PIPE_AMP] = ACTIONS(1259),
    [anon_sym_AMP_AMP] = ACTIONS(1259),
    [anon_sym_PIPE_PIPE] = ACTIONS(1259),
    [anon_sym_RBRACK] = ACTIONS(1259),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1259),
    [anon_sym_LT] = ACTIONS(1259),
    [anon_sym_GT] = ACTIONS(1259),
    [anon_sym_GT_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT_GT] = ACTIONS(1259),
    [anon_sym_LT_AMP] = ACTIONS(1259),
    [anon_sym_GT_AMP] = ACTIONS(1259),
    [anon_sym_LT_LT] = ACTIONS(1259),
    [anon_sym_LT_LT_DASH] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1259),
    [sym_raw_string] = ACTIONS(1259),
    [anon_sym_DOLLAR] = ACTIONS(1259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1259),
    [anon_sym_BQUOTE] = ACTIONS(1259),
    [anon_sym_LT_LPAREN] = ACTIONS(1259),
    [anon_sym_GT_LPAREN] = ACTIONS(1259),
    [sym_word] = ACTIONS(1259),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_LF] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1259),
  },
  [1251] = {
    [sym__terminated_statement] = STATE(126),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_elif_clause] = STATE(351),
    [sym_else_clause] = STATE(1130),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_if_statement_repeat1] = STATE(1132),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(91),
    [sym_variable_name] = ACTIONS(93),
    [anon_sym_for] = ACTIONS(97),
    [anon_sym_while] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_fi] = ACTIONS(3382),
    [anon_sym_elif] = ACTIONS(677),
    [anon_sym_else] = ACTIONS(679),
    [anon_sym_case] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(113),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_raw_string] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(125),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [anon_sym_LT_LPAREN] = ACTIONS(129),
    [anon_sym_GT_LPAREN] = ACTIONS(129),
    [sym_word] = ACTIONS(131),
    [sym_comment] = ACTIONS(133),
  },
  [1252] = {
    [sym_compound_statement] = STATE(1331),
    [anon_sym_LBRACE] = ACTIONS(3384),
    [sym_comment] = ACTIONS(133),
  },
  [1253] = {
    [sym_compound_statement] = STATE(1332),
    [anon_sym_LBRACE] = ACTIONS(3384),
    [sym_comment] = ACTIONS(133),
  },
  [1254] = {
    [sym_file_descriptor] = ACTIONS(821),
    [sym__concat] = ACTIONS(821),
    [sym_variable_name] = ACTIONS(821),
    [anon_sym_PIPE] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(823),
    [anon_sym_SEMI_SEMI] = ACTIONS(823),
    [anon_sym_RBRACE] = ACTIONS(823),
    [anon_sym_PIPE_AMP] = ACTIONS(823),
    [anon_sym_AMP_AMP] = ACTIONS(823),
    [anon_sym_PIPE_PIPE] = ACTIONS(823),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(823),
    [anon_sym_GT_GT] = ACTIONS(823),
    [anon_sym_AMP_GT] = ACTIONS(823),
    [anon_sym_AMP_GT_GT] = ACTIONS(823),
    [anon_sym_LT_AMP] = ACTIONS(823),
    [anon_sym_GT_AMP] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(823),
    [sym_raw_string] = ACTIONS(823),
    [anon_sym_DOLLAR] = ACTIONS(823),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(823),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(823),
    [anon_sym_BQUOTE] = ACTIONS(823),
    [anon_sym_LT_LPAREN] = ACTIONS(823),
    [anon_sym_GT_LPAREN] = ACTIONS(823),
    [sym_word] = ACTIONS(823),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_LF] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
  },
  [1255] = {
    [sym_file_descriptor] = ACTIONS(829),
    [sym__concat] = ACTIONS(829),
    [sym_variable_name] = ACTIONS(829),
    [anon_sym_PIPE] = ACTIONS(831),
    [anon_sym_RPAREN] = ACTIONS(831),
    [anon_sym_SEMI_SEMI] = ACTIONS(831),
    [anon_sym_RBRACE] = ACTIONS(831),
    [anon_sym_PIPE_AMP] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(831),
    [anon_sym_GT_GT] = ACTIONS(831),
    [anon_sym_AMP_GT] = ACTIONS(831),
    [anon_sym_AMP_GT_GT] = ACTIONS(831),
    [anon_sym_LT_AMP] = ACTIONS(831),
    [anon_sym_GT_AMP] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(831),
    [sym_raw_string] = ACTIONS(831),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(831),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(831),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [anon_sym_LT_LPAREN] = ACTIONS(831),
    [anon_sym_GT_LPAREN] = ACTIONS(831),
    [sym_word] = ACTIONS(831),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(831),
    [anon_sym_LF] = ACTIONS(831),
    [anon_sym_AMP] = ACTIONS(831),
  },
  [1256] = {
    [sym_string] = STATE(1333),
    [sym_simple_expansion] = STATE(1333),
    [sym_expansion] = STATE(1333),
    [sym_command_substitution] = STATE(1333),
    [sym_process_substitution] = STATE(1333),
    [anon_sym_DQUOTE] = ACTIONS(2401),
    [sym_raw_string] = ACTIONS(3386),
    [anon_sym_DOLLAR] = ACTIONS(2405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2409),
    [anon_sym_BQUOTE] = ACTIONS(2411),
    [anon_sym_LT_LPAREN] = ACTIONS(2413),
    [anon_sym_GT_LPAREN] = ACTIONS(2413),
    [sym_word] = ACTIONS(3388),
    [sym_comment] = ACTIONS(133),
  },
  [1257] = {
    [anon_sym_RBRACE] = ACTIONS(3390),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [sym_comment] = ACTIONS(133),
  },
  [1258] = {
    [anon_sym_RBRACE] = ACTIONS(3394),
    [anon_sym_LBRACK] = ACTIONS(3396),
    [sym_comment] = ACTIONS(133),
  },
  [1259] = {
    [sym_file_descriptor] = ACTIONS(845),
    [sym__concat] = ACTIONS(845),
    [sym_variable_name] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(847),
    [anon_sym_SEMI_SEMI] = ACTIONS(847),
    [anon_sym_RBRACE] = ACTIONS(847),
    [anon_sym_PIPE_AMP] = ACTIONS(847),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_PIPE_PIPE] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(847),
    [anon_sym_AMP_GT] = ACTIONS(847),
    [anon_sym_AMP_GT_GT] = ACTIONS(847),
    [anon_sym_LT_AMP] = ACTIONS(847),
    [anon_sym_GT_AMP] = ACTIONS(847),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [sym_raw_string] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(847),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(847),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(847),
    [anon_sym_GT_LPAREN] = ACTIONS(847),
    [sym_word] = ACTIONS(847),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(847),
    [anon_sym_LF] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(847),
  },
  [1260] = {
    [anon_sym_AT] = ACTIONS(3398),
    [sym_comment] = ACTIONS(133),
  },
  [1261] = {
    [sym_concatenation] = STATE(1340),
    [sym_string] = STATE(1339),
    [sym_simple_expansion] = STATE(1339),
    [sym_expansion] = STATE(1339),
    [sym_command_substitution] = STATE(1339),
    [sym_process_substitution] = STATE(1339),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(3400),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(3402),
    [sym_comment] = ACTIONS(133),
  },
  [1262] = {
    [sym_file_descriptor] = ACTIONS(855),
    [sym__concat] = ACTIONS(855),
    [sym_variable_name] = ACTIONS(855),
    [anon_sym_PIPE] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [anon_sym_RBRACE] = ACTIONS(857),
    [anon_sym_PIPE_AMP] = ACTIONS(857),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_AMP_GT] = ACTIONS(857),
    [anon_sym_AMP_GT_GT] = ACTIONS(857),
    [anon_sym_LT_AMP] = ACTIONS(857),
    [anon_sym_GT_AMP] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(857),
    [sym_raw_string] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(857),
    [anon_sym_LT_LPAREN] = ACTIONS(857),
    [anon_sym_GT_LPAREN] = ACTIONS(857),
    [sym_word] = ACTIONS(857),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
  },
  [1263] = {
    [anon_sym_AT] = ACTIONS(3404),
    [sym_comment] = ACTIONS(133),
  },
  [1264] = {
    [sym_concatenation] = STATE(1343),
    [sym_string] = STATE(1342),
    [sym_simple_expansion] = STATE(1342),
    [sym_expansion] = STATE(1342),
    [sym_command_substitution] = STATE(1342),
    [sym_process_substitution] = STATE(1342),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(3406),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(3408),
    [sym_comment] = ACTIONS(133),
  },
  [1265] = {
    [sym_file_descriptor] = ACTIONS(923),
    [sym__concat] = ACTIONS(923),
    [sym_variable_name] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_RPAREN] = ACTIONS(925),
    [anon_sym_SEMI_SEMI] = ACTIONS(925),
    [anon_sym_RBRACE] = ACTIONS(925),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(925),
    [anon_sym_PIPE_PIPE] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_GT] = ACTIONS(925),
    [anon_sym_AMP_GT] = ACTIONS(925),
    [anon_sym_AMP_GT_GT] = ACTIONS(925),
    [anon_sym_LT_AMP] = ACTIONS(925),
    [anon_sym_GT_AMP] = ACTIONS(925),
    [anon_sym_DQUOTE] = ACTIONS(925),
    [sym_raw_string] = ACTIONS(925),
    [anon_sym_DOLLAR] = ACTIONS(925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(925),
    [anon_sym_BQUOTE] = ACTIONS(925),
    [anon_sym_LT_LPAREN] = ACTIONS(925),
    [anon_sym_GT_LPAREN] = ACTIONS(925),
    [sym_word] = ACTIONS(925),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(925),
    [anon_sym_LF] = ACTIONS(925),
    [anon_sym_AMP] = ACTIONS(925),
  },
  [1266] = {
    [sym_file_descriptor] = ACTIONS(965),
    [sym__concat] = ACTIONS(965),
    [sym_variable_name] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(967),
    [anon_sym_RPAREN] = ACTIONS(967),
    [anon_sym_SEMI_SEMI] = ACTIONS(967),
    [anon_sym_RBRACE] = ACTIONS(967),
    [anon_sym_PIPE_AMP] = ACTIONS(967),
    [anon_sym_AMP_AMP] = ACTIONS(967),
    [anon_sym_PIPE_PIPE] = ACTIONS(967),
    [anon_sym_LT] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(967),
    [anon_sym_GT_GT] = ACTIONS(967),
    [anon_sym_AMP_GT] = ACTIONS(967),
    [anon_sym_AMP_GT_GT] = ACTIONS(967),
    [anon_sym_LT_AMP] = ACTIONS(967),
    [anon_sym_GT_AMP] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(967),
    [sym_raw_string] = ACTIONS(967),
    [anon_sym_DOLLAR] = ACTIONS(967),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(967),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(967),
    [anon_sym_BQUOTE] = ACTIONS(967),
    [anon_sym_LT_LPAREN] = ACTIONS(967),
    [anon_sym_GT_LPAREN] = ACTIONS(967),
    [sym_word] = ACTIONS(967),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_LF] = ACTIONS(967),
    [anon_sym_AMP] = ACTIONS(967),
  },
  [1267] = {
    [sym_file_descriptor] = ACTIONS(821),
    [sym__concat] = ACTIONS(821),
    [sym_variable_name] = ACTIONS(821),
    [anon_sym_PIPE] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(823),
    [anon_sym_SEMI_SEMI] = ACTIONS(823),
    [anon_sym_PIPE_AMP] = ACTIONS(823),
    [anon_sym_AMP_AMP] = ACTIONS(823),
    [anon_sym_PIPE_PIPE] = ACTIONS(823),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(823),
    [anon_sym_GT_GT] = ACTIONS(823),
    [anon_sym_AMP_GT] = ACTIONS(823),
    [anon_sym_AMP_GT_GT] = ACTIONS(823),
    [anon_sym_LT_AMP] = ACTIONS(823),
    [anon_sym_GT_AMP] = ACTIONS(823),
    [anon_sym_LT_LT] = ACTIONS(823),
    [anon_sym_LT_LT_DASH] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(823),
    [sym_raw_string] = ACTIONS(823),
    [anon_sym_DOLLAR] = ACTIONS(823),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(823),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(823),
    [anon_sym_BQUOTE] = ACTIONS(823),
    [anon_sym_LT_LPAREN] = ACTIONS(823),
    [anon_sym_GT_LPAREN] = ACTIONS(823),
    [sym_word] = ACTIONS(823),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_LF] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
  },
  [1268] = {
    [sym_file_descriptor] = ACTIONS(829),
    [sym__concat] = ACTIONS(829),
    [sym_variable_name] = ACTIONS(829),
    [anon_sym_PIPE] = ACTIONS(831),
    [anon_sym_RPAREN] = ACTIONS(831),
    [anon_sym_SEMI_SEMI] = ACTIONS(831),
    [anon_sym_PIPE_AMP] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(831),
    [anon_sym_GT_GT] = ACTIONS(831),
    [anon_sym_AMP_GT] = ACTIONS(831),
    [anon_sym_AMP_GT_GT] = ACTIONS(831),
    [anon_sym_LT_AMP] = ACTIONS(831),
    [anon_sym_GT_AMP] = ACTIONS(831),
    [anon_sym_LT_LT] = ACTIONS(831),
    [anon_sym_LT_LT_DASH] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(831),
    [sym_raw_string] = ACTIONS(831),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(831),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(831),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [anon_sym_LT_LPAREN] = ACTIONS(831),
    [anon_sym_GT_LPAREN] = ACTIONS(831),
    [sym_word] = ACTIONS(831),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(831),
    [anon_sym_LF] = ACTIONS(831),
    [anon_sym_AMP] = ACTIONS(831),
  },
  [1269] = {
    [sym_string] = STATE(1344),
    [sym_simple_expansion] = STATE(1344),
    [sym_expansion] = STATE(1344),
    [sym_command_substitution] = STATE(1344),
    [sym_process_substitution] = STATE(1344),
    [anon_sym_DQUOTE] = ACTIONS(2417),
    [sym_raw_string] = ACTIONS(3410),
    [anon_sym_DOLLAR] = ACTIONS(2421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2423),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2425),
    [anon_sym_BQUOTE] = ACTIONS(2427),
    [anon_sym_LT_LPAREN] = ACTIONS(2429),
    [anon_sym_GT_LPAREN] = ACTIONS(2429),
    [sym_word] = ACTIONS(3412),
    [sym_comment] = ACTIONS(133),
  },
  [1270] = {
    [anon_sym_RBRACE] = ACTIONS(3414),
    [anon_sym_LBRACK] = ACTIONS(3416),
    [sym_comment] = ACTIONS(133),
  },
  [1271] = {
    [anon_sym_RBRACE] = ACTIONS(3418),
    [anon_sym_LBRACK] = ACTIONS(3420),
    [sym_comment] = ACTIONS(133),
  },
  [1272] = {
    [sym_file_descriptor] = ACTIONS(845),
    [sym__concat] = ACTIONS(845),
    [sym_variable_name] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(847),
    [anon_sym_SEMI_SEMI] = ACTIONS(847),
    [anon_sym_PIPE_AMP] = ACTIONS(847),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_PIPE_PIPE] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(847),
    [anon_sym_AMP_GT] = ACTIONS(847),
    [anon_sym_AMP_GT_GT] = ACTIONS(847),
    [anon_sym_LT_AMP] = ACTIONS(847),
    [anon_sym_GT_AMP] = ACTIONS(847),
    [anon_sym_LT_LT] = ACTIONS(847),
    [anon_sym_LT_LT_DASH] = ACTIONS(847),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [sym_raw_string] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(847),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(847),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(847),
    [anon_sym_GT_LPAREN] = ACTIONS(847),
    [sym_word] = ACTIONS(847),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(847),
    [anon_sym_LF] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(847),
  },
  [1273] = {
    [anon_sym_AT] = ACTIONS(3422),
    [sym_comment] = ACTIONS(133),
  },
  [1274] = {
    [sym_concatenation] = STATE(1351),
    [sym_string] = STATE(1350),
    [sym_simple_expansion] = STATE(1350),
    [sym_expansion] = STATE(1350),
    [sym_command_substitution] = STATE(1350),
    [sym_process_substitution] = STATE(1350),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(3424),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(3426),
    [sym_comment] = ACTIONS(133),
  },
  [1275] = {
    [sym_file_descriptor] = ACTIONS(855),
    [sym__concat] = ACTIONS(855),
    [sym_variable_name] = ACTIONS(855),
    [anon_sym_PIPE] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [anon_sym_PIPE_AMP] = ACTIONS(857),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_AMP_GT] = ACTIONS(857),
    [anon_sym_AMP_GT_GT] = ACTIONS(857),
    [anon_sym_LT_AMP] = ACTIONS(857),
    [anon_sym_GT_AMP] = ACTIONS(857),
    [anon_sym_LT_LT] = ACTIONS(857),
    [anon_sym_LT_LT_DASH] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(857),
    [sym_raw_string] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(857),
    [anon_sym_LT_LPAREN] = ACTIONS(857),
    [anon_sym_GT_LPAREN] = ACTIONS(857),
    [sym_word] = ACTIONS(857),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
  },
  [1276] = {
    [anon_sym_AT] = ACTIONS(3428),
    [sym_comment] = ACTIONS(133),
  },
  [1277] = {
    [sym_concatenation] = STATE(1354),
    [sym_string] = STATE(1353),
    [sym_simple_expansion] = STATE(1353),
    [sym_expansion] = STATE(1353),
    [sym_command_substitution] = STATE(1353),
    [sym_process_substitution] = STATE(1353),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(3430),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(3432),
    [sym_comment] = ACTIONS(133),
  },
  [1278] = {
    [sym_file_descriptor] = ACTIONS(923),
    [sym__concat] = ACTIONS(923),
    [sym_variable_name] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_RPAREN] = ACTIONS(925),
    [anon_sym_SEMI_SEMI] = ACTIONS(925),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(925),
    [anon_sym_PIPE_PIPE] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_GT] = ACTIONS(925),
    [anon_sym_AMP_GT] = ACTIONS(925),
    [anon_sym_AMP_GT_GT] = ACTIONS(925),
    [anon_sym_LT_AMP] = ACTIONS(925),
    [anon_sym_GT_AMP] = ACTIONS(925),
    [anon_sym_LT_LT] = ACTIONS(925),
    [anon_sym_LT_LT_DASH] = ACTIONS(925),
    [anon_sym_DQUOTE] = ACTIONS(925),
    [sym_raw_string] = ACTIONS(925),
    [anon_sym_DOLLAR] = ACTIONS(925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(925),
    [anon_sym_BQUOTE] = ACTIONS(925),
    [anon_sym_LT_LPAREN] = ACTIONS(925),
    [anon_sym_GT_LPAREN] = ACTIONS(925),
    [sym_word] = ACTIONS(925),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(925),
    [anon_sym_LF] = ACTIONS(925),
    [anon_sym_AMP] = ACTIONS(925),
  },
  [1279] = {
    [sym_file_descriptor] = ACTIONS(965),
    [sym__concat] = ACTIONS(965),
    [sym_variable_name] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(967),
    [anon_sym_RPAREN] = ACTIONS(967),
    [anon_sym_SEMI_SEMI] = ACTIONS(967),
    [anon_sym_PIPE_AMP] = ACTIONS(967),
    [anon_sym_AMP_AMP] = ACTIONS(967),
    [anon_sym_PIPE_PIPE] = ACTIONS(967),
    [anon_sym_LT] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(967),
    [anon_sym_GT_GT] = ACTIONS(967),
    [anon_sym_AMP_GT] = ACTIONS(967),
    [anon_sym_AMP_GT_GT] = ACTIONS(967),
    [anon_sym_LT_AMP] = ACTIONS(967),
    [anon_sym_GT_AMP] = ACTIONS(967),
    [anon_sym_LT_LT] = ACTIONS(967),
    [anon_sym_LT_LT_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(967),
    [sym_raw_string] = ACTIONS(967),
    [anon_sym_DOLLAR] = ACTIONS(967),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(967),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(967),
    [anon_sym_BQUOTE] = ACTIONS(967),
    [anon_sym_LT_LPAREN] = ACTIONS(967),
    [anon_sym_GT_LPAREN] = ACTIONS(967),
    [sym_word] = ACTIONS(967),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_LF] = ACTIONS(967),
    [anon_sym_AMP] = ACTIONS(967),
  },
  [1280] = {
    [anon_sym_PIPE] = ACTIONS(1539),
    [anon_sym_RPAREN] = ACTIONS(1539),
    [anon_sym_SEMI_SEMI] = ACTIONS(1539),
    [anon_sym_PIPE_AMP] = ACTIONS(1539),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1539),
    [anon_sym_LF] = ACTIONS(1539),
    [anon_sym_AMP] = ACTIONS(1539),
  },
  [1281] = {
    [sym_case_item] = STATE(724),
    [sym_concatenation] = STATE(556),
    [sym_string] = STATE(554),
    [sym_simple_expansion] = STATE(554),
    [sym_expansion] = STATE(554),
    [sym_command_substitution] = STATE(554),
    [sym_process_substitution] = STATE(554),
    [anon_sym_esac] = ACTIONS(3271),
    [anon_sym_DQUOTE] = ACTIONS(315),
    [sym_raw_string] = ACTIONS(1143),
    [anon_sym_DOLLAR] = ACTIONS(319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(327),
    [anon_sym_GT_LPAREN] = ACTIONS(327),
    [sym_word] = ACTIONS(1145),
    [sym_comment] = ACTIONS(133),
  },
  [1282] = {
    [anon_sym_RBRACK] = ACTIONS(3434),
    [sym_comment] = ACTIONS(133),
  },
  [1283] = {
    [anon_sym_RBRACK] = ACTIONS(3436),
    [sym_comment] = ACTIONS(133),
  },
  [1284] = {
    [anon_sym_PIPE] = ACTIONS(1833),
    [anon_sym_RPAREN] = ACTIONS(1833),
    [anon_sym_SEMI_SEMI] = ACTIONS(1833),
    [anon_sym_PIPE_AMP] = ACTIONS(1833),
    [anon_sym_AMP_AMP] = ACTIONS(1833),
    [anon_sym_PIPE_PIPE] = ACTIONS(1833),
    [anon_sym_BQUOTE] = ACTIONS(1833),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1833),
    [anon_sym_LF] = ACTIONS(1833),
    [anon_sym_AMP] = ACTIONS(1833),
  },
  [1285] = {
    [sym_case_item] = STATE(724),
    [sym_concatenation] = STATE(556),
    [sym_string] = STATE(554),
    [sym_simple_expansion] = STATE(554),
    [sym_expansion] = STATE(554),
    [sym_command_substitution] = STATE(554),
    [sym_process_substitution] = STATE(554),
    [anon_sym_esac] = ACTIONS(3438),
    [anon_sym_DQUOTE] = ACTIONS(315),
    [sym_raw_string] = ACTIONS(1143),
    [anon_sym_DOLLAR] = ACTIONS(319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(327),
    [anon_sym_GT_LPAREN] = ACTIONS(327),
    [sym_word] = ACTIONS(1145),
    [sym_comment] = ACTIONS(133),
  },
  [1286] = {
    [anon_sym_RBRACE] = ACTIONS(3440),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [sym_comment] = ACTIONS(133),
  },
  [1287] = {
    [anon_sym_RBRACE] = ACTIONS(3444),
    [anon_sym_LBRACK] = ACTIONS(3446),
    [sym_comment] = ACTIONS(133),
  },
  [1288] = {
    [sym_file_descriptor] = ACTIONS(845),
    [sym__concat] = ACTIONS(845),
    [sym_variable_name] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_PIPE] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(847),
    [anon_sym_SEMI_SEMI] = ACTIONS(847),
    [anon_sym_RBRACE] = ACTIONS(847),
    [anon_sym_PIPE_AMP] = ACTIONS(847),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_PIPE_PIPE] = ACTIONS(847),
    [anon_sym_RBRACK] = ACTIONS(847),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(847),
    [anon_sym_AMP_GT] = ACTIONS(847),
    [anon_sym_AMP_GT_GT] = ACTIONS(847),
    [anon_sym_LT_AMP] = ACTIONS(847),
    [anon_sym_GT_AMP] = ACTIONS(847),
    [anon_sym_LT_LT] = ACTIONS(847),
    [anon_sym_LT_LT_DASH] = ACTIONS(847),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [sym_raw_string] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(847),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(847),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(847),
    [anon_sym_GT_LPAREN] = ACTIONS(847),
    [sym_word] = ACTIONS(847),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(847),
    [anon_sym_LF] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(847),
  },
  [1289] = {
    [anon_sym_AT] = ACTIONS(3448),
    [sym_comment] = ACTIONS(133),
  },
  [1290] = {
    [sym_concatenation] = STATE(1364),
    [sym_string] = STATE(1363),
    [sym_simple_expansion] = STATE(1363),
    [sym_expansion] = STATE(1363),
    [sym_command_substitution] = STATE(1363),
    [sym_process_substitution] = STATE(1363),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(3450),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(3452),
    [sym_comment] = ACTIONS(133),
  },
  [1291] = {
    [sym_file_descriptor] = ACTIONS(855),
    [sym__concat] = ACTIONS(855),
    [sym_variable_name] = ACTIONS(855),
    [anon_sym_in] = ACTIONS(857),
    [anon_sym_PIPE] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [anon_sym_RBRACE] = ACTIONS(857),
    [anon_sym_PIPE_AMP] = ACTIONS(857),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(857),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_AMP_GT] = ACTIONS(857),
    [anon_sym_AMP_GT_GT] = ACTIONS(857),
    [anon_sym_LT_AMP] = ACTIONS(857),
    [anon_sym_GT_AMP] = ACTIONS(857),
    [anon_sym_LT_LT] = ACTIONS(857),
    [anon_sym_LT_LT_DASH] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(857),
    [sym_raw_string] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(857),
    [anon_sym_LT_LPAREN] = ACTIONS(857),
    [anon_sym_GT_LPAREN] = ACTIONS(857),
    [sym_word] = ACTIONS(857),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
  },
  [1292] = {
    [anon_sym_AT] = ACTIONS(3454),
    [sym_comment] = ACTIONS(133),
  },
  [1293] = {
    [sym_concatenation] = STATE(1367),
    [sym_string] = STATE(1366),
    [sym_simple_expansion] = STATE(1366),
    [sym_expansion] = STATE(1366),
    [sym_command_substitution] = STATE(1366),
    [sym_process_substitution] = STATE(1366),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(3456),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(3458),
    [sym_comment] = ACTIONS(133),
  },
  [1294] = {
    [sym_file_descriptor] = ACTIONS(923),
    [sym__concat] = ACTIONS(923),
    [sym_variable_name] = ACTIONS(923),
    [anon_sym_in] = ACTIONS(925),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_RPAREN] = ACTIONS(925),
    [anon_sym_SEMI_SEMI] = ACTIONS(925),
    [anon_sym_RBRACE] = ACTIONS(925),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(925),
    [anon_sym_PIPE_PIPE] = ACTIONS(925),
    [anon_sym_RBRACK] = ACTIONS(925),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_GT] = ACTIONS(925),
    [anon_sym_AMP_GT] = ACTIONS(925),
    [anon_sym_AMP_GT_GT] = ACTIONS(925),
    [anon_sym_LT_AMP] = ACTIONS(925),
    [anon_sym_GT_AMP] = ACTIONS(925),
    [anon_sym_LT_LT] = ACTIONS(925),
    [anon_sym_LT_LT_DASH] = ACTIONS(925),
    [anon_sym_DQUOTE] = ACTIONS(925),
    [sym_raw_string] = ACTIONS(925),
    [anon_sym_DOLLAR] = ACTIONS(925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(925),
    [anon_sym_BQUOTE] = ACTIONS(925),
    [anon_sym_LT_LPAREN] = ACTIONS(925),
    [anon_sym_GT_LPAREN] = ACTIONS(925),
    [sym_word] = ACTIONS(925),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(925),
    [anon_sym_LF] = ACTIONS(925),
    [anon_sym_AMP] = ACTIONS(925),
  },
  [1295] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [sym_file_descriptor] = ACTIONS(613),
    [sym__concat] = ACTIONS(3311),
    [anon_sym_PIPE] = ACTIONS(1385),
    [anon_sym_RPAREN] = ACTIONS(1385),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1385),
    [anon_sym_GT] = ACTIONS(1385),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1385),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1385),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1385),
  },
  [1296] = {
    [sym_file_descriptor] = ACTIONS(613),
    [anon_sym_PIPE] = ACTIONS(1385),
    [anon_sym_RPAREN] = ACTIONS(1385),
    [anon_sym_SEMI_SEMI] = ACTIONS(1385),
    [anon_sym_PIPE_AMP] = ACTIONS(1385),
    [anon_sym_AMP_AMP] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1385),
    [anon_sym_GT] = ACTIONS(1385),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT] = ACTIONS(1385),
    [anon_sym_AMP_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_AMP] = ACTIONS(1385),
    [anon_sym_GT_AMP] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1385),
    [anon_sym_LT_LT_DASH] = ACTIONS(1385),
    [anon_sym_BQUOTE] = ACTIONS(1385),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1385),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1385),
  },
  [1297] = {
    [sym_file_descriptor] = ACTIONS(427),
    [sym__concat] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_RPAREN] = ACTIONS(429),
    [anon_sym_SEMI_SEMI] = ACTIONS(429),
    [anon_sym_PIPE_AMP] = ACTIONS(429),
    [anon_sym_AMP_AMP] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_GT] = ACTIONS(429),
    [anon_sym_AMP_GT] = ACTIONS(429),
    [anon_sym_AMP_GT_GT] = ACTIONS(429),
    [anon_sym_LT_AMP] = ACTIONS(429),
    [anon_sym_GT_AMP] = ACTIONS(429),
    [anon_sym_LT_LT] = ACTIONS(429),
    [anon_sym_LT_LT_DASH] = ACTIONS(429),
    [anon_sym_BQUOTE] = ACTIONS(429),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(429),
    [anon_sym_LF] = ACTIONS(429),
    [anon_sym_AMP] = ACTIONS(429),
  },
  [1298] = {
    [sym_simple_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [anon_sym_DQUOTE] = ACTIONS(3460),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(447),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(203),
    [anon_sym_BQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(85),
  },
  [1299] = {
    [sym_string] = STATE(1369),
    [sym_simple_expansion] = STATE(1369),
    [sym_expansion] = STATE(1369),
    [sym_command_substitution] = STATE(1369),
    [sym_process_substitution] = STATE(1369),
    [anon_sym_DQUOTE] = ACTIONS(3105),
    [sym_raw_string] = ACTIONS(3462),
    [anon_sym_DOLLAR] = ACTIONS(3109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3113),
    [anon_sym_BQUOTE] = ACTIONS(3115),
    [anon_sym_LT_LPAREN] = ACTIONS(3117),
    [anon_sym_GT_LPAREN] = ACTIONS(3117),
    [sym_word] = ACTIONS(3464),
    [sym_comment] = ACTIONS(133),
  },
  [1300] = {
    [sym_file_descriptor] = ACTIONS(453),
    [sym__concat] = ACTIONS(3466),
    [anon_sym_PIPE] = ACTIONS(457),
    [anon_sym_RPAREN] = ACTIONS(457),
    [anon_sym_SEMI_SEMI] = ACTIONS(457),
    [anon_sym_PIPE_AMP] = ACTIONS(457),
    [anon_sym_AMP_AMP] = ACTIONS(457),
    [anon_sym_PIPE_PIPE] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(457),
    [anon_sym_AMP_GT] = ACTIONS(457),
    [anon_sym_AMP_GT_GT] = ACTIONS(457),
    [anon_sym_LT_AMP] = ACTIONS(457),
    [anon_sym_GT_AMP] = ACTIONS(457),
    [anon_sym_LT_LT] = ACTIONS(457),
    [anon_sym_LT_LT_DASH] = ACTIONS(457),
    [anon_sym_BQUOTE] = ACTIONS(457),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(457),
    [anon_sym_LF] = ACTIONS(457),
    [anon_sym_AMP] = ACTIONS(457),
  },
  [1301] = {
    [sym_file_descriptor] = ACTIONS(459),
    [sym__concat] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(461),
    [anon_sym_RPAREN] = ACTIONS(461),
    [anon_sym_SEMI_SEMI] = ACTIONS(461),
    [anon_sym_PIPE_AMP] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(461),
    [anon_sym_AMP_GT] = ACTIONS(461),
    [anon_sym_AMP_GT_GT] = ACTIONS(461),
    [anon_sym_LT_AMP] = ACTIONS(461),
    [anon_sym_GT_AMP] = ACTIONS(461),
    [anon_sym_LT_LT] = ACTIONS(461),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_BQUOTE] = ACTIONS(461),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_LF] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(461),
  },
  [1302] = {
    [sym_file_descriptor] = ACTIONS(463),
    [sym__concat] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_SEMI_SEMI] = ACTIONS(465),
    [anon_sym_PIPE_AMP] = ACTIONS(465),
    [anon_sym_AMP_AMP] = ACTIONS(465),
    [anon_sym_PIPE_PIPE] = ACTIONS(465),
    [anon_sym_LT] = ACTIONS(465),
    [anon_sym_GT] = ACTIONS(465),
    [anon_sym_GT_GT] = ACTIONS(465),
    [anon_sym_AMP_GT] = ACTIONS(465),
    [anon_sym_AMP_GT_GT] = ACTIONS(465),
    [anon_sym_LT_AMP] = ACTIONS(465),
    [anon_sym_GT_AMP] = ACTIONS(465),
    [anon_sym_LT_LT] = ACTIONS(465),
    [anon_sym_LT_LT_DASH] = ACTIONS(465),
    [anon_sym_BQUOTE] = ACTIONS(465),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(465),
    [anon_sym_LF] = ACTIONS(465),
    [anon_sym_AMP] = ACTIONS(465),
  },
  [1303] = {
    [sym_file_descriptor] = ACTIONS(467),
    [sym__concat] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_RPAREN] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
  },
  [1304] = {
    [sym_special_variable_name] = STATE(1372),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(459),
    [anon_sym_EQ] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_POUND] = ACTIONS(225),
    [anon_sym_AT] = ACTIONS(219),
    [anon_sym_COLON] = ACTIONS(471),
    [anon_sym_COLON_QMARK] = ACTIONS(459),
    [anon_sym_COLON_DASH] = ACTIONS(459),
    [anon_sym_PERCENT] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(459),
    [sym_comment] = ACTIONS(85),
    [sym_simple_variable_name] = ACTIONS(3468),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_0] = ACTIONS(225),
    [anon_sym__] = ACTIONS(225),
  },
  [1305] = {
    [anon_sym_RBRACE] = ACTIONS(3470),
    [anon_sym_LBRACK] = ACTIONS(3472),
    [anon_sym_EQ] = ACTIONS(3474),
    [anon_sym_COLON] = ACTIONS(3476),
    [anon_sym_COLON_QMARK] = ACTIONS(3474),
    [anon_sym_COLON_DASH] = ACTIONS(3474),
    [anon_sym_PERCENT] = ACTIONS(3474),
    [anon_sym_SLASH] = ACTIONS(3474),
    [sym_comment] = ACTIONS(133),
  },
  [1306] = {
    [anon_sym_RBRACE] = ACTIONS(3478),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3482),
    [anon_sym_COLON] = ACTIONS(3484),
    [anon_sym_COLON_QMARK] = ACTIONS(3482),
    [anon_sym_COLON_DASH] = ACTIONS(3482),
    [anon_sym_PERCENT] = ACTIONS(3482),
    [anon_sym_SLASH] = ACTIONS(3482),
    [sym_comment] = ACTIONS(133),
  },
  [1307] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(3486),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [1308] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(3486),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [1309] = {
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(3486),
    [sym_comment] = ACTIONS(133),
  },
  [1310] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(3488),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [1311] = {
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(3491),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [sym_comment] = ACTIONS(133),
  },
  [1312] = {
    [sym_file_descriptor] = ACTIONS(299),
    [sym_variable_name] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(3491),
    [anon_sym_PIPE_AMP] = ACTIONS(523),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(547),
    [anon_sym_GT] = ACTIONS(547),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(547),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [sym_word] = ACTIONS(301),
    [sym_comment] = ACTIONS(133),
  },
  [1313] = {
    [anon_sym_RBRACE] = ACTIONS(3493),
    [sym_comment] = ACTIONS(133),
  },
  [1314] = {
    [sym__heredoc_middle] = ACTIONS(1623),
    [sym__heredoc_end] = ACTIONS(1623),
    [sym_file_descriptor] = ACTIONS(1623),
    [sym__concat] = ACTIONS(1623),
    [sym_variable_name] = ACTIONS(1623),
    [anon_sym_in] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(1625),
    [anon_sym_RPAREN] = ACTIONS(1625),
    [anon_sym_SEMI_SEMI] = ACTIONS(1625),
    [anon_sym_RBRACE] = ACTIONS(1625),
    [anon_sym_PIPE_AMP] = ACTIONS(1625),
    [anon_sym_AMP_AMP] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(1625),
    [anon_sym_RBRACK] = ACTIONS(1625),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1625),
    [anon_sym_GT] = ACTIONS(1625),
    [anon_sym_GT_GT] = ACTIONS(1625),
    [anon_sym_AMP_GT] = ACTIONS(1625),
    [anon_sym_AMP_GT_GT] = ACTIONS(1625),
    [anon_sym_LT_AMP] = ACTIONS(1625),
    [anon_sym_GT_AMP] = ACTIONS(1625),
    [anon_sym_LT_LT] = ACTIONS(1625),
    [anon_sym_LT_LT_DASH] = ACTIONS(1625),
    [anon_sym_DQUOTE] = ACTIONS(1625),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(1625),
    [sym_raw_string] = ACTIONS(1625),
    [anon_sym_DOLLAR] = ACTIONS(1625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1625),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1625),
    [anon_sym_BQUOTE] = ACTIONS(1625),
    [anon_sym_LT_LPAREN] = ACTIONS(1625),
    [anon_sym_GT_LPAREN] = ACTIONS(1625),
    [sym_word] = ACTIONS(1625),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_LF] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
  },
  [1315] = {
    [anon_sym_PIPE] = ACTIONS(1567),
    [anon_sym_RPAREN] = ACTIONS(1567),
    [anon_sym_SEMI_SEMI] = ACTIONS(1567),
    [anon_sym_PIPE_AMP] = ACTIONS(1567),
    [anon_sym_AMP_AMP] = ACTIONS(1567),
    [anon_sym_PIPE_PIPE] = ACTIONS(1567),
    [anon_sym_BQUOTE] = ACTIONS(1567),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1567),
    [anon_sym_LF] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
  },
  [1316] = {
    [anon_sym_PIPE] = ACTIONS(2021),
    [anon_sym_RPAREN] = ACTIONS(2021),
    [anon_sym_SEMI_SEMI] = ACTIONS(2021),
    [anon_sym_PIPE_AMP] = ACTIONS(2021),
    [anon_sym_AMP_AMP] = ACTIONS(2021),
    [anon_sym_PIPE_PIPE] = ACTIONS(2021),
    [anon_sym_BQUOTE] = ACTIONS(2021),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2021),
    [anon_sym_LF] = ACTIONS(2021),
    [anon_sym_AMP] = ACTIONS(2021),
  },
  [1317] = {
    [sym_file_descriptor] = ACTIONS(821),
    [sym__concat] = ACTIONS(821),
    [anon_sym_PIPE] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(823),
    [anon_sym_SEMI_SEMI] = ACTIONS(823),
    [anon_sym_PIPE_AMP] = ACTIONS(823),
    [anon_sym_AMP_AMP] = ACTIONS(823),
    [anon_sym_PIPE_PIPE] = ACTIONS(823),
    [anon_sym_RBRACK] = ACTIONS(823),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(823),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(823),
    [anon_sym_GT_GT] = ACTIONS(823),
    [anon_sym_AMP_GT] = ACTIONS(823),
    [anon_sym_AMP_GT_GT] = ACTIONS(823),
    [anon_sym_LT_AMP] = ACTIONS(823),
    [anon_sym_GT_AMP] = ACTIONS(823),
    [anon_sym_LT_LT] = ACTIONS(823),
    [anon_sym_LT_LT_DASH] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(823),
    [sym_raw_string] = ACTIONS(823),
    [anon_sym_DOLLAR] = ACTIONS(823),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(823),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(823),
    [anon_sym_BQUOTE] = ACTIONS(823),
    [anon_sym_LT_LPAREN] = ACTIONS(823),
    [anon_sym_GT_LPAREN] = ACTIONS(823),
    [sym_word] = ACTIONS(823),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_LF] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
  },
  [1318] = {
    [sym_file_descriptor] = ACTIONS(829),
    [sym__concat] = ACTIONS(829),
    [anon_sym_PIPE] = ACTIONS(831),
    [anon_sym_RPAREN] = ACTIONS(831),
    [anon_sym_SEMI_SEMI] = ACTIONS(831),
    [anon_sym_PIPE_AMP] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_RBRACK] = ACTIONS(831),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(831),
    [anon_sym_GT_GT] = ACTIONS(831),
    [anon_sym_AMP_GT] = ACTIONS(831),
    [anon_sym_AMP_GT_GT] = ACTIONS(831),
    [anon_sym_LT_AMP] = ACTIONS(831),
    [anon_sym_GT_AMP] = ACTIONS(831),
    [anon_sym_LT_LT] = ACTIONS(831),
    [anon_sym_LT_LT_DASH] = ACTIONS(831),
    [anon_sym_DQUOTE] = ACTIONS(831),
    [sym_raw_string] = ACTIONS(831),
    [anon_sym_DOLLAR] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(831),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(831),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [anon_sym_LT_LPAREN] = ACTIONS(831),
    [anon_sym_GT_LPAREN] = ACTIONS(831),
    [sym_word] = ACTIONS(831),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(831),
    [anon_sym_LF] = ACTIONS(831),
    [anon_sym_AMP] = ACTIONS(831),
  },
  [1319] = {
    [sym_string] = STATE(1382),
    [sym_simple_expansion] = STATE(1382),
    [sym_expansion] = STATE(1382),
    [sym_command_substitution] = STATE(1382),
    [sym_process_substitution] = STATE(1382),
    [anon_sym_DQUOTE] = ACTIONS(3333),
    [sym_raw_string] = ACTIONS(3495),
    [anon_sym_DOLLAR] = ACTIONS(3337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3341),
    [anon_sym_BQUOTE] = ACTIONS(3343),
    [anon_sym_LT_LPAREN] = ACTIONS(3345),
    [anon_sym_GT_LPAREN] = ACTIONS(3345),
    [sym_word] = ACTIONS(3497),
    [sym_comment] = ACTIONS(133),
  },
  [1320] = {
    [anon_sym_RBRACE] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(3501),
    [sym_comment] = ACTIONS(133),
  },
  [1321] = {
    [anon_sym_RBRACE] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [sym_comment] = ACTIONS(133),
  },
  [1322] = {
    [sym_file_descriptor] = ACTIONS(845),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(847),
    [anon_sym_SEMI_SEMI] = ACTIONS(847),
    [anon_sym_PIPE_AMP] = ACTIONS(847),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_PIPE_PIPE] = ACTIONS(847),
    [anon_sym_RBRACK] = ACTIONS(847),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(847),
    [anon_sym_AMP_GT] = ACTIONS(847),
    [anon_sym_AMP_GT_GT] = ACTIONS(847),
    [anon_sym_LT_AMP] = ACTIONS(847),
    [anon_sym_GT_AMP] = ACTIONS(847),
    [anon_sym_LT_LT] = ACTIONS(847),
    [anon_sym_LT_LT_DASH] = ACTIONS(847),
    [anon_sym_DQUOTE] = ACTIONS(847),
    [sym_raw_string] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(847),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(847),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [anon_sym_LT_LPAREN] = ACTIONS(847),
    [anon_sym_GT_LPAREN] = ACTIONS(847),
    [sym_word] = ACTIONS(847),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(847),
    [anon_sym_LF] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(847),
  },
  [1323] = {
    [anon_sym_AT] = ACTIONS(3507),
    [sym_comment] = ACTIONS(133),
  },
  [1324] = {
    [sym_concatenation] = STATE(1389),
    [sym_string] = STATE(1388),
    [sym_simple_expansion] = STATE(1388),
    [sym_expansion] = STATE(1388),
    [sym_command_substitution] = STATE(1388),
    [sym_process_substitution] = STATE(1388),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(3511),
    [sym_comment] = ACTIONS(133),
  },
  [1325] = {
    [sym_file_descriptor] = ACTIONS(855),
    [sym__concat] = ACTIONS(855),
    [anon_sym_PIPE] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [anon_sym_PIPE_AMP] = ACTIONS(857),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(857),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_AMP_GT] = ACTIONS(857),
    [anon_sym_AMP_GT_GT] = ACTIONS(857),
    [anon_sym_LT_AMP] = ACTIONS(857),
    [anon_sym_GT_AMP] = ACTIONS(857),
    [anon_sym_LT_LT] = ACTIONS(857),
    [anon_sym_LT_LT_DASH] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(857),
    [sym_raw_string] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(857),
    [anon_sym_LT_LPAREN] = ACTIONS(857),
    [anon_sym_GT_LPAREN] = ACTIONS(857),
    [sym_word] = ACTIONS(857),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
  },
  [1326] = {
    [anon_sym_AT] = ACTIONS(3513),
    [sym_comment] = ACTIONS(133),
  },
  [1327] = {
    [sym_concatenation] = STATE(1392),
    [sym_string] = STATE(1391),
    [sym_simple_expansion] = STATE(1391),
    [sym_expansion] = STATE(1391),
    [sym_command_substitution] = STATE(1391),
    [sym_process_substitution] = STATE(1391),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(3515),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(3517),
    [sym_comment] = ACTIONS(133),
  },
  [1328] = {
    [sym_file_descriptor] = ACTIONS(923),
    [sym__concat] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_RPAREN] = ACTIONS(925),
    [anon_sym_SEMI_SEMI] = ACTIONS(925),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(925),
    [anon_sym_PIPE_PIPE] = ACTIONS(925),
    [anon_sym_RBRACK] = ACTIONS(925),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_GT] = ACTIONS(925),
    [anon_sym_AMP_GT] = ACTIONS(925),
    [anon_sym_AMP_GT_GT] = ACTIONS(925),
    [anon_sym_LT_AMP] = ACTIONS(925),
    [anon_sym_GT_AMP] = ACTIONS(925),
    [anon_sym_LT_LT] = ACTIONS(925),
    [anon_sym_LT_LT_DASH] = ACTIONS(925),
    [anon_sym_DQUOTE] = ACTIONS(925),
    [sym_raw_string] = ACTIONS(925),
    [anon_sym_DOLLAR] = ACTIONS(925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(925),
    [anon_sym_BQUOTE] = ACTIONS(925),
    [anon_sym_LT_LPAREN] = ACTIONS(925),
    [anon_sym_GT_LPAREN] = ACTIONS(925),
    [sym_word] = ACTIONS(925),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(925),
    [anon_sym_LF] = ACTIONS(925),
    [anon_sym_AMP] = ACTIONS(925),
  },
  [1329] = {
    [sym_file_descriptor] = ACTIONS(965),
    [sym__concat] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(967),
    [anon_sym_RPAREN] = ACTIONS(967),
    [anon_sym_SEMI_SEMI] = ACTIONS(967),
    [anon_sym_PIPE_AMP] = ACTIONS(967),
    [anon_sym_AMP_AMP] = ACTIONS(967),
    [anon_sym_PIPE_PIPE] = ACTIONS(967),
    [anon_sym_RBRACK] = ACTIONS(967),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(967),
    [anon_sym_LT] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(967),
    [anon_sym_GT_GT] = ACTIONS(967),
    [anon_sym_AMP_GT] = ACTIONS(967),
    [anon_sym_AMP_GT_GT] = ACTIONS(967),
    [anon_sym_LT_AMP] = ACTIONS(967),
    [anon_sym_GT_AMP] = ACTIONS(967),
    [anon_sym_LT_LT] = ACTIONS(967),
    [anon_sym_LT_LT_DASH] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(967),
    [sym_raw_string] = ACTIONS(967),
    [anon_sym_DOLLAR] = ACTIONS(967),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(967),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(967),
    [anon_sym_BQUOTE] = ACTIONS(967),
    [anon_sym_LT_LPAREN] = ACTIONS(967),
    [anon_sym_GT_LPAREN] = ACTIONS(967),
    [sym_word] = ACTIONS(967),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_LF] = ACTIONS(967),
    [anon_sym_AMP] = ACTIONS(967),
  },
  [1330] = {
    [sym_file_redirect] = STATE(1147),
    [sym_heredoc_redirect] = STATE(1147),
    [sym_file_descriptor] = ACTIONS(2724),
    [anon_sym_PIPE] = ACTIONS(1439),
    [anon_sym_RPAREN] = ACTIONS(1439),
    [anon_sym_SEMI_SEMI] = ACTIONS(1439),
    [anon_sym_PIPE_AMP] = ACTIONS(1439),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_PIPE_PIPE] = ACTIONS(1439),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT] = ACTIONS(2729),
    [anon_sym_AMP_GT_GT] = ACTIONS(2729),
    [anon_sym_LT_AMP] = ACTIONS(2729),
    [anon_sym_GT_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2731),
    [anon_sym_LT_LT_DASH] = ACTIONS(2731),
    [anon_sym_BQUOTE] = ACTIONS(1439),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1439),
    [anon_sym_LF] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
  },
  [1331] = {
    [anon_sym_PIPE] = ACTIONS(1383),
    [anon_sym_RPAREN] = ACTIONS(1383),
    [anon_sym_SEMI_SEMI] = ACTIONS(1383),
    [anon_sym_PIPE_AMP] = ACTIONS(1383),
    [anon_sym_AMP_AMP] = ACTIONS(1383),
    [anon_sym_PIPE_PIPE] = ACTIONS(1383),
    [anon_sym_BQUOTE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1383),
    [anon_sym_LF] = ACTIONS(1383),
    [anon_sym_AMP] = ACTIONS(1383),
  },
  [1332] = {
    [anon_sym_PIPE] = ACTIONS(1565),
    [anon_sym_RPAREN] = ACTIONS(1565),
    [anon_sym_SEMI_SEMI] = ACTIONS(1565),
    [anon_sym_PIPE_AMP] = ACTIONS(1565),
    [anon_sym_AMP_AMP] = ACTIONS(1565),
    [anon_sym_PIPE_PIPE] = ACTIONS(1565),
    [anon_sym_BQUOTE] = ACTIONS(1565),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1565),
    [anon_sym_LF] = ACTIONS(1565),
    [anon_sym_AMP] = ACTIONS(1565),
  },
  [1333] = {
    [sym_file_descriptor] = ACTIONS(1257),
    [sym__concat] = ACTIONS(1257),
    [sym_variable_name] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1259),
    [anon_sym_RPAREN] = ACTIONS(1259),
    [anon_sym_SEMI_SEMI] = ACTIONS(1259),
    [anon_sym_RBRACE] = ACTIONS(1259),
    [anon_sym_PIPE_AMP] = ACTIONS(1259),
    [anon_sym_AMP_AMP] = ACTIONS(1259),
    [anon_sym_PIPE_PIPE] = ACTIONS(1259),
    [anon_sym_LT] = ACTIONS(1259),
    [anon_sym_GT] = ACTIONS(1259),
    [anon_sym_GT_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT_GT] = ACTIONS(1259),
    [anon_sym_LT_AMP] = ACTIONS(1259),
    [anon_sym_GT_AMP] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1259),
    [sym_raw_string] = ACTIONS(1259),
    [anon_sym_DOLLAR] = ACTIONS(1259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1259),
    [anon_sym_BQUOTE] = ACTIONS(1259),
    [anon_sym_LT_LPAREN] = ACTIONS(1259),
    [anon_sym_GT_LPAREN] = ACTIONS(1259),
    [sym_word] = ACTIONS(1259),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_LF] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1259),
  },
  [1334] = {
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1261),
    [sym_variable_name] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1263),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_PIPE_AMP] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1263),
    [anon_sym_LT_AMP] = ACTIONS(1263),
    [anon_sym_GT_AMP] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1263),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1263),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1263),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [anon_sym_LT_LPAREN] = ACTIONS(1263),
    [anon_sym_GT_LPAREN] = ACTIONS(1263),
    [sym_word] = ACTIONS(1263),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [1335] = {
    [anon_sym_AT] = ACTIONS(3519),
    [sym_comment] = ACTIONS(133),
  },
  [1336] = {
    [sym_file_descriptor] = ACTIONS(1267),
    [sym__concat] = ACTIONS(1267),
    [sym_variable_name] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_RPAREN] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1269),
    [anon_sym_RBRACE] = ACTIONS(1269),
    [anon_sym_PIPE_AMP] = ACTIONS(1269),
    [anon_sym_AMP_AMP] = ACTIONS(1269),
    [anon_sym_PIPE_PIPE] = ACTIONS(1269),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1269),
    [anon_sym_LT_AMP] = ACTIONS(1269),
    [anon_sym_GT_AMP] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1269),
    [sym_raw_string] = ACTIONS(1269),
    [anon_sym_DOLLAR] = ACTIONS(1269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1269),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1269),
    [anon_sym_BQUOTE] = ACTIONS(1269),
    [anon_sym_LT_LPAREN] = ACTIONS(1269),
    [anon_sym_GT_LPAREN] = ACTIONS(1269),
    [sym_word] = ACTIONS(1269),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_LF] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [1337] = {
    [anon_sym_AT] = ACTIONS(3521),
    [sym_comment] = ACTIONS(133),
  },
  [1338] = {
    [anon_sym_RBRACK] = ACTIONS(3523),
    [sym_comment] = ACTIONS(133),
  },
  [1339] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(3525),
    [sym_comment] = ACTIONS(133),
  },
  [1340] = {
    [anon_sym_RBRACE] = ACTIONS(3525),
    [sym_comment] = ACTIONS(133),
  },
  [1341] = {
    [anon_sym_RBRACK] = ACTIONS(3527),
    [sym_comment] = ACTIONS(133),
  },
  [1342] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(3529),
    [sym_comment] = ACTIONS(133),
  },
  [1343] = {
    [anon_sym_RBRACE] = ACTIONS(3529),
    [sym_comment] = ACTIONS(133),
  },
  [1344] = {
    [sym_file_descriptor] = ACTIONS(1257),
    [sym__concat] = ACTIONS(1257),
    [sym_variable_name] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1259),
    [anon_sym_RPAREN] = ACTIONS(1259),
    [anon_sym_SEMI_SEMI] = ACTIONS(1259),
    [anon_sym_PIPE_AMP] = ACTIONS(1259),
    [anon_sym_AMP_AMP] = ACTIONS(1259),
    [anon_sym_PIPE_PIPE] = ACTIONS(1259),
    [anon_sym_LT] = ACTIONS(1259),
    [anon_sym_GT] = ACTIONS(1259),
    [anon_sym_GT_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT_GT] = ACTIONS(1259),
    [anon_sym_LT_AMP] = ACTIONS(1259),
    [anon_sym_GT_AMP] = ACTIONS(1259),
    [anon_sym_LT_LT] = ACTIONS(1259),
    [anon_sym_LT_LT_DASH] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1259),
    [sym_raw_string] = ACTIONS(1259),
    [anon_sym_DOLLAR] = ACTIONS(1259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1259),
    [anon_sym_BQUOTE] = ACTIONS(1259),
    [anon_sym_LT_LPAREN] = ACTIONS(1259),
    [anon_sym_GT_LPAREN] = ACTIONS(1259),
    [sym_word] = ACTIONS(1259),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_LF] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1259),
  },
  [1345] = {
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1261),
    [sym_variable_name] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE_AMP] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1263),
    [anon_sym_LT_AMP] = ACTIONS(1263),
    [anon_sym_GT_AMP] = ACTIONS(1263),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1263),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1263),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1263),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [anon_sym_LT_LPAREN] = ACTIONS(1263),
    [anon_sym_GT_LPAREN] = ACTIONS(1263),
    [sym_word] = ACTIONS(1263),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [1346] = {
    [anon_sym_AT] = ACTIONS(3531),
    [sym_comment] = ACTIONS(133),
  },
  [1347] = {
    [sym_file_descriptor] = ACTIONS(1267),
    [sym__concat] = ACTIONS(1267),
    [sym_variable_name] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_RPAREN] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE_AMP] = ACTIONS(1269),
    [anon_sym_AMP_AMP] = ACTIONS(1269),
    [anon_sym_PIPE_PIPE] = ACTIONS(1269),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1269),
    [anon_sym_LT_AMP] = ACTIONS(1269),
    [anon_sym_GT_AMP] = ACTIONS(1269),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1269),
    [sym_raw_string] = ACTIONS(1269),
    [anon_sym_DOLLAR] = ACTIONS(1269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1269),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1269),
    [anon_sym_BQUOTE] = ACTIONS(1269),
    [anon_sym_LT_LPAREN] = ACTIONS(1269),
    [anon_sym_GT_LPAREN] = ACTIONS(1269),
    [sym_word] = ACTIONS(1269),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_LF] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [1348] = {
    [anon_sym_AT] = ACTIONS(3533),
    [sym_comment] = ACTIONS(133),
  },
  [1349] = {
    [anon_sym_RBRACK] = ACTIONS(3535),
    [sym_comment] = ACTIONS(133),
  },
  [1350] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [sym_comment] = ACTIONS(133),
  },
  [1351] = {
    [anon_sym_RBRACE] = ACTIONS(3537),
    [sym_comment] = ACTIONS(133),
  },
  [1352] = {
    [anon_sym_RBRACK] = ACTIONS(3539),
    [sym_comment] = ACTIONS(133),
  },
  [1353] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(3541),
    [sym_comment] = ACTIONS(133),
  },
  [1354] = {
    [anon_sym_RBRACE] = ACTIONS(3541),
    [sym_comment] = ACTIONS(133),
  },
  [1355] = {
    [anon_sym_RBRACE] = ACTIONS(3543),
    [sym_comment] = ACTIONS(133),
  },
  [1356] = {
    [anon_sym_RBRACE] = ACTIONS(3545),
    [sym_comment] = ACTIONS(133),
  },
  [1357] = {
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_RPAREN] = ACTIONS(2037),
    [anon_sym_SEMI_SEMI] = ACTIONS(2037),
    [anon_sym_PIPE_AMP] = ACTIONS(2037),
    [anon_sym_AMP_AMP] = ACTIONS(2037),
    [anon_sym_PIPE_PIPE] = ACTIONS(2037),
    [anon_sym_BQUOTE] = ACTIONS(2037),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2037),
    [anon_sym_LF] = ACTIONS(2037),
    [anon_sym_AMP] = ACTIONS(2037),
  },
  [1358] = {
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1261),
    [sym_variable_name] = ACTIONS(1261),
    [anon_sym_in] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1263),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_PIPE_AMP] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1263),
    [anon_sym_RBRACK] = ACTIONS(1263),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1263),
    [anon_sym_LT_AMP] = ACTIONS(1263),
    [anon_sym_GT_AMP] = ACTIONS(1263),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1263),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1263),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1263),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [anon_sym_LT_LPAREN] = ACTIONS(1263),
    [anon_sym_GT_LPAREN] = ACTIONS(1263),
    [sym_word] = ACTIONS(1263),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [1359] = {
    [anon_sym_AT] = ACTIONS(3547),
    [sym_comment] = ACTIONS(133),
  },
  [1360] = {
    [sym_file_descriptor] = ACTIONS(1267),
    [sym__concat] = ACTIONS(1267),
    [sym_variable_name] = ACTIONS(1267),
    [anon_sym_in] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_RPAREN] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1269),
    [anon_sym_RBRACE] = ACTIONS(1269),
    [anon_sym_PIPE_AMP] = ACTIONS(1269),
    [anon_sym_AMP_AMP] = ACTIONS(1269),
    [anon_sym_PIPE_PIPE] = ACTIONS(1269),
    [anon_sym_RBRACK] = ACTIONS(1269),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1269),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1269),
    [anon_sym_LT_AMP] = ACTIONS(1269),
    [anon_sym_GT_AMP] = ACTIONS(1269),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1269),
    [sym_raw_string] = ACTIONS(1269),
    [anon_sym_DOLLAR] = ACTIONS(1269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1269),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1269),
    [anon_sym_BQUOTE] = ACTIONS(1269),
    [anon_sym_LT_LPAREN] = ACTIONS(1269),
    [anon_sym_GT_LPAREN] = ACTIONS(1269),
    [sym_word] = ACTIONS(1269),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_LF] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [1361] = {
    [anon_sym_AT] = ACTIONS(3549),
    [sym_comment] = ACTIONS(133),
  },
  [1362] = {
    [anon_sym_RBRACK] = ACTIONS(3551),
    [sym_comment] = ACTIONS(133),
  },
  [1363] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(3553),
    [sym_comment] = ACTIONS(133),
  },
  [1364] = {
    [anon_sym_RBRACE] = ACTIONS(3553),
    [sym_comment] = ACTIONS(133),
  },
  [1365] = {
    [anon_sym_RBRACK] = ACTIONS(3555),
    [sym_comment] = ACTIONS(133),
  },
  [1366] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(3557),
    [sym_comment] = ACTIONS(133),
  },
  [1367] = {
    [anon_sym_RBRACE] = ACTIONS(3557),
    [sym_comment] = ACTIONS(133),
  },
  [1368] = {
    [sym_file_descriptor] = ACTIONS(821),
    [sym__concat] = ACTIONS(821),
    [anon_sym_PIPE] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(823),
    [anon_sym_SEMI_SEMI] = ACTIONS(823),
    [anon_sym_PIPE_AMP] = ACTIONS(823),
    [anon_sym_AMP_AMP] = ACTIONS(823),
    [anon_sym_PIPE_PIPE] = ACTIONS(823),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(823),
    [anon_sym_GT_GT] = ACTIONS(823),
    [anon_sym_AMP_GT] = ACTIONS(823),
    [anon_sym_AMP_GT_GT] = ACTIONS(823),
    [anon_sym_LT_AMP] = ACTIONS(823),
    [anon_sym_GT_AMP] = ACTIONS(823),
    [anon_sym_LT_LT] = ACTIONS(823),
    [anon_sym_LT_LT_DASH] = ACTIONS(823),
    [anon_sym_BQUOTE] = ACTIONS(823),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_LF] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
  },
  [1369] = {
    [sym_file_descriptor] = ACTIONS(829),
    [sym__concat] = ACTIONS(829),
    [anon_sym_PIPE] = ACTIONS(831),
    [anon_sym_RPAREN] = ACTIONS(831),
    [anon_sym_SEMI_SEMI] = ACTIONS(831),
    [anon_sym_PIPE_AMP] = ACTIONS(831),
    [anon_sym_AMP_AMP] = ACTIONS(831),
    [anon_sym_PIPE_PIPE] = ACTIONS(831),
    [anon_sym_LT] = ACTIONS(831),
    [anon_sym_GT] = ACTIONS(831),
    [anon_sym_GT_GT] = ACTIONS(831),
    [anon_sym_AMP_GT] = ACTIONS(831),
    [anon_sym_AMP_GT_GT] = ACTIONS(831),
    [anon_sym_LT_AMP] = ACTIONS(831),
    [anon_sym_GT_AMP] = ACTIONS(831),
    [anon_sym_LT_LT] = ACTIONS(831),
    [anon_sym_LT_LT_DASH] = ACTIONS(831),
    [anon_sym_BQUOTE] = ACTIONS(831),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(831),
    [anon_sym_LF] = ACTIONS(831),
    [anon_sym_AMP] = ACTIONS(831),
  },
  [1370] = {
    [sym_string] = STATE(1413),
    [sym_simple_expansion] = STATE(1413),
    [sym_expansion] = STATE(1413),
    [sym_command_substitution] = STATE(1413),
    [sym_process_substitution] = STATE(1413),
    [anon_sym_DQUOTE] = ACTIONS(3105),
    [sym_raw_string] = ACTIONS(3559),
    [anon_sym_DOLLAR] = ACTIONS(3109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3113),
    [anon_sym_BQUOTE] = ACTIONS(3115),
    [anon_sym_LT_LPAREN] = ACTIONS(3117),
    [anon_sym_GT_LPAREN] = ACTIONS(3117),
    [sym_word] = ACTIONS(3561),
    [sym_comment] = ACTIONS(133),
  },
  [1371] = {
    [anon_sym_RBRACE] = ACTIONS(3563),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [sym_comment] = ACTIONS(133),
  },
  [1372] = {
    [anon_sym_RBRACE] = ACTIONS(3567),
    [anon_sym_LBRACK] = ACTIONS(3569),
    [sym_comment] = ACTIONS(133),
  },
  [1373] = {
    [sym_file_descriptor] = ACTIONS(845),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(847),
    [anon_sym_SEMI_SEMI] = ACTIONS(847),
    [anon_sym_PIPE_AMP] = ACTIONS(847),
    [anon_sym_AMP_AMP] = ACTIONS(847),
    [anon_sym_PIPE_PIPE] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(847),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(847),
    [anon_sym_AMP_GT] = ACTIONS(847),
    [anon_sym_AMP_GT_GT] = ACTIONS(847),
    [anon_sym_LT_AMP] = ACTIONS(847),
    [anon_sym_GT_AMP] = ACTIONS(847),
    [anon_sym_LT_LT] = ACTIONS(847),
    [anon_sym_LT_LT_DASH] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(847),
    [anon_sym_LF] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(847),
  },
  [1374] = {
    [anon_sym_AT] = ACTIONS(3571),
    [sym_comment] = ACTIONS(133),
  },
  [1375] = {
    [sym_concatenation] = STATE(1420),
    [sym_string] = STATE(1419),
    [sym_simple_expansion] = STATE(1419),
    [sym_expansion] = STATE(1419),
    [sym_command_substitution] = STATE(1419),
    [sym_process_substitution] = STATE(1419),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(3573),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(3575),
    [sym_comment] = ACTIONS(133),
  },
  [1376] = {
    [sym_file_descriptor] = ACTIONS(855),
    [sym__concat] = ACTIONS(855),
    [anon_sym_PIPE] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [anon_sym_PIPE_AMP] = ACTIONS(857),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_AMP_GT] = ACTIONS(857),
    [anon_sym_AMP_GT_GT] = ACTIONS(857),
    [anon_sym_LT_AMP] = ACTIONS(857),
    [anon_sym_GT_AMP] = ACTIONS(857),
    [anon_sym_LT_LT] = ACTIONS(857),
    [anon_sym_LT_LT_DASH] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(857),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
  },
  [1377] = {
    [anon_sym_AT] = ACTIONS(3577),
    [sym_comment] = ACTIONS(133),
  },
  [1378] = {
    [sym_concatenation] = STATE(1423),
    [sym_string] = STATE(1422),
    [sym_simple_expansion] = STATE(1422),
    [sym_expansion] = STATE(1422),
    [sym_command_substitution] = STATE(1422),
    [sym_process_substitution] = STATE(1422),
    [anon_sym_DQUOTE] = ACTIONS(163),
    [sym_raw_string] = ACTIONS(3579),
    [anon_sym_DOLLAR] = ACTIONS(167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [anon_sym_LT_LPAREN] = ACTIONS(175),
    [anon_sym_GT_LPAREN] = ACTIONS(175),
    [sym_word] = ACTIONS(3581),
    [sym_comment] = ACTIONS(133),
  },
  [1379] = {
    [sym_file_descriptor] = ACTIONS(923),
    [sym__concat] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_RPAREN] = ACTIONS(925),
    [anon_sym_SEMI_SEMI] = ACTIONS(925),
    [anon_sym_PIPE_AMP] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(925),
    [anon_sym_PIPE_PIPE] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_GT] = ACTIONS(925),
    [anon_sym_AMP_GT] = ACTIONS(925),
    [anon_sym_AMP_GT_GT] = ACTIONS(925),
    [anon_sym_LT_AMP] = ACTIONS(925),
    [anon_sym_GT_AMP] = ACTIONS(925),
    [anon_sym_LT_LT] = ACTIONS(925),
    [anon_sym_LT_LT_DASH] = ACTIONS(925),
    [anon_sym_BQUOTE] = ACTIONS(925),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(925),
    [anon_sym_LF] = ACTIONS(925),
    [anon_sym_AMP] = ACTIONS(925),
  },
  [1380] = {
    [sym_file_descriptor] = ACTIONS(965),
    [sym__concat] = ACTIONS(965),
    [anon_sym_PIPE] = ACTIONS(967),
    [anon_sym_RPAREN] = ACTIONS(967),
    [anon_sym_SEMI_SEMI] = ACTIONS(967),
    [anon_sym_PIPE_AMP] = ACTIONS(967),
    [anon_sym_AMP_AMP] = ACTIONS(967),
    [anon_sym_PIPE_PIPE] = ACTIONS(967),
    [anon_sym_LT] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(967),
    [anon_sym_GT_GT] = ACTIONS(967),
    [anon_sym_AMP_GT] = ACTIONS(967),
    [anon_sym_AMP_GT_GT] = ACTIONS(967),
    [anon_sym_LT_AMP] = ACTIONS(967),
    [anon_sym_GT_AMP] = ACTIONS(967),
    [anon_sym_LT_LT] = ACTIONS(967),
    [anon_sym_LT_LT_DASH] = ACTIONS(967),
    [anon_sym_BQUOTE] = ACTIONS(967),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_LF] = ACTIONS(967),
    [anon_sym_AMP] = ACTIONS(967),
  },
  [1381] = {
    [sym__heredoc_middle] = ACTIONS(3583),
    [sym__heredoc_end] = ACTIONS(3583),
    [sym_file_descriptor] = ACTIONS(3583),
    [sym__concat] = ACTIONS(3583),
    [sym_variable_name] = ACTIONS(3583),
    [anon_sym_in] = ACTIONS(3586),
    [anon_sym_PIPE] = ACTIONS(3586),
    [anon_sym_RPAREN] = ACTIONS(3586),
    [anon_sym_SEMI_SEMI] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(3586),
    [anon_sym_PIPE_AMP] = ACTIONS(3586),
    [anon_sym_AMP_AMP] = ACTIONS(3586),
    [anon_sym_PIPE_PIPE] = ACTIONS(3586),
    [anon_sym_RBRACK] = ACTIONS(3586),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3586),
    [anon_sym_LT] = ACTIONS(3586),
    [anon_sym_GT] = ACTIONS(3586),
    [anon_sym_GT_GT] = ACTIONS(3586),
    [anon_sym_AMP_GT] = ACTIONS(3586),
    [anon_sym_AMP_GT_GT] = ACTIONS(3586),
    [anon_sym_LT_AMP] = ACTIONS(3586),
    [anon_sym_GT_AMP] = ACTIONS(3586),
    [anon_sym_LT_LT] = ACTIONS(3586),
    [anon_sym_LT_LT_DASH] = ACTIONS(3586),
    [anon_sym_DQUOTE] = ACTIONS(3586),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(3586),
    [sym_raw_string] = ACTIONS(3586),
    [anon_sym_DOLLAR] = ACTIONS(3586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3586),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3586),
    [anon_sym_BQUOTE] = ACTIONS(3586),
    [anon_sym_LT_LPAREN] = ACTIONS(3586),
    [anon_sym_GT_LPAREN] = ACTIONS(3586),
    [sym_word] = ACTIONS(3586),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(3586),
    [anon_sym_LF] = ACTIONS(3586),
    [anon_sym_AMP] = ACTIONS(3586),
  },
  [1382] = {
    [sym_file_descriptor] = ACTIONS(1257),
    [sym__concat] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1259),
    [anon_sym_RPAREN] = ACTIONS(1259),
    [anon_sym_SEMI_SEMI] = ACTIONS(1259),
    [anon_sym_PIPE_AMP] = ACTIONS(1259),
    [anon_sym_AMP_AMP] = ACTIONS(1259),
    [anon_sym_PIPE_PIPE] = ACTIONS(1259),
    [anon_sym_RBRACK] = ACTIONS(1259),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1259),
    [anon_sym_LT] = ACTIONS(1259),
    [anon_sym_GT] = ACTIONS(1259),
    [anon_sym_GT_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT_GT] = ACTIONS(1259),
    [anon_sym_LT_AMP] = ACTIONS(1259),
    [anon_sym_GT_AMP] = ACTIONS(1259),
    [anon_sym_LT_LT] = ACTIONS(1259),
    [anon_sym_LT_LT_DASH] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1259),
    [sym_raw_string] = ACTIONS(1259),
    [anon_sym_DOLLAR] = ACTIONS(1259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1259),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1259),
    [anon_sym_BQUOTE] = ACTIONS(1259),
    [anon_sym_LT_LPAREN] = ACTIONS(1259),
    [anon_sym_GT_LPAREN] = ACTIONS(1259),
    [sym_word] = ACTIONS(1259),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_LF] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1259),
  },
  [1383] = {
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE_AMP] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1263),
    [anon_sym_RBRACK] = ACTIONS(1263),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1263),
    [anon_sym_LT_AMP] = ACTIONS(1263),
    [anon_sym_GT_AMP] = ACTIONS(1263),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1263),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1263),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1263),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [anon_sym_LT_LPAREN] = ACTIONS(1263),
    [anon_sym_GT_LPAREN] = ACTIONS(1263),
    [sym_word] = ACTIONS(1263),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [1384] = {
    [anon_sym_AT] = ACTIONS(3589),
    [sym_comment] = ACTIONS(133),
  },
  [1385] = {
    [sym_file_descriptor] = ACTIONS(1267),
    [sym__concat] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_RPAREN] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE_AMP] = ACTIONS(1269),
    [anon_sym_AMP_AMP] = ACTIONS(1269),
    [anon_sym_PIPE_PIPE] = ACTIONS(1269),
    [anon_sym_RBRACK] = ACTIONS(1269),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1269),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1269),
    [anon_sym_LT_AMP] = ACTIONS(1269),
    [anon_sym_GT_AMP] = ACTIONS(1269),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(1269),
    [sym_raw_string] = ACTIONS(1269),
    [anon_sym_DOLLAR] = ACTIONS(1269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1269),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1269),
    [anon_sym_BQUOTE] = ACTIONS(1269),
    [anon_sym_LT_LPAREN] = ACTIONS(1269),
    [anon_sym_GT_LPAREN] = ACTIONS(1269),
    [sym_word] = ACTIONS(1269),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_LF] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [1386] = {
    [anon_sym_AT] = ACTIONS(3591),
    [sym_comment] = ACTIONS(133),
  },
  [1387] = {
    [anon_sym_RBRACK] = ACTIONS(3593),
    [sym_comment] = ACTIONS(133),
  },
  [1388] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(3595),
    [sym_comment] = ACTIONS(133),
  },
  [1389] = {
    [anon_sym_RBRACE] = ACTIONS(3595),
    [sym_comment] = ACTIONS(133),
  },
  [1390] = {
    [anon_sym_RBRACK] = ACTIONS(3597),
    [sym_comment] = ACTIONS(133),
  },
  [1391] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(3599),
    [sym_comment] = ACTIONS(133),
  },
  [1392] = {
    [anon_sym_RBRACE] = ACTIONS(3599),
    [sym_comment] = ACTIONS(133),
  },
  [1393] = {
    [anon_sym_RBRACK] = ACTIONS(3601),
    [sym_comment] = ACTIONS(133),
  },
  [1394] = {
    [anon_sym_RBRACK] = ACTIONS(3603),
    [sym_comment] = ACTIONS(133),
  },
  [1395] = {
    [anon_sym_RBRACE] = ACTIONS(3605),
    [sym_comment] = ACTIONS(133),
  },
  [1396] = {
    [sym_file_descriptor] = ACTIONS(1617),
    [sym__concat] = ACTIONS(1617),
    [sym_variable_name] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1619),
    [anon_sym_RPAREN] = ACTIONS(1619),
    [anon_sym_SEMI_SEMI] = ACTIONS(1619),
    [anon_sym_RBRACE] = ACTIONS(1619),
    [anon_sym_PIPE_AMP] = ACTIONS(1619),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE_PIPE] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(1619),
    [anon_sym_GT_GT] = ACTIONS(1619),
    [anon_sym_AMP_GT] = ACTIONS(1619),
    [anon_sym_AMP_GT_GT] = ACTIONS(1619),
    [anon_sym_LT_AMP] = ACTIONS(1619),
    [anon_sym_GT_AMP] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1619),
    [sym_raw_string] = ACTIONS(1619),
    [anon_sym_DOLLAR] = ACTIONS(1619),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1619),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1619),
    [anon_sym_BQUOTE] = ACTIONS(1619),
    [anon_sym_LT_LPAREN] = ACTIONS(1619),
    [anon_sym_GT_LPAREN] = ACTIONS(1619),
    [sym_word] = ACTIONS(1619),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1619),
    [anon_sym_LF] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
  },
  [1397] = {
    [anon_sym_RBRACE] = ACTIONS(3607),
    [sym_comment] = ACTIONS(133),
  },
  [1398] = {
    [sym_file_descriptor] = ACTIONS(1623),
    [sym__concat] = ACTIONS(1623),
    [sym_variable_name] = ACTIONS(1623),
    [anon_sym_PIPE] = ACTIONS(1625),
    [anon_sym_RPAREN] = ACTIONS(1625),
    [anon_sym_SEMI_SEMI] = ACTIONS(1625),
    [anon_sym_RBRACE] = ACTIONS(1625),
    [anon_sym_PIPE_AMP] = ACTIONS(1625),
    [anon_sym_AMP_AMP] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1625),
    [anon_sym_GT] = ACTIONS(1625),
    [anon_sym_GT_GT] = ACTIONS(1625),
    [anon_sym_AMP_GT] = ACTIONS(1625),
    [anon_sym_AMP_GT_GT] = ACTIONS(1625),
    [anon_sym_LT_AMP] = ACTIONS(1625),
    [anon_sym_GT_AMP] = ACTIONS(1625),
    [anon_sym_DQUOTE] = ACTIONS(1625),
    [sym_raw_string] = ACTIONS(1625),
    [anon_sym_DOLLAR] = ACTIONS(1625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1625),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1625),
    [anon_sym_BQUOTE] = ACTIONS(1625),
    [anon_sym_LT_LPAREN] = ACTIONS(1625),
    [anon_sym_GT_LPAREN] = ACTIONS(1625),
    [sym_word] = ACTIONS(1625),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_LF] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
  },
  [1399] = {
    [anon_sym_RBRACK] = ACTIONS(3609),
    [sym_comment] = ACTIONS(133),
  },
  [1400] = {
    [anon_sym_RBRACK] = ACTIONS(3611),
    [sym_comment] = ACTIONS(133),
  },
  [1401] = {
    [anon_sym_RBRACE] = ACTIONS(3613),
    [sym_comment] = ACTIONS(133),
  },
  [1402] = {
    [sym_file_descriptor] = ACTIONS(1617),
    [sym__concat] = ACTIONS(1617),
    [sym_variable_name] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1619),
    [anon_sym_RPAREN] = ACTIONS(1619),
    [anon_sym_SEMI_SEMI] = ACTIONS(1619),
    [anon_sym_PIPE_AMP] = ACTIONS(1619),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE_PIPE] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(1619),
    [anon_sym_GT_GT] = ACTIONS(1619),
    [anon_sym_AMP_GT] = ACTIONS(1619),
    [anon_sym_AMP_GT_GT] = ACTIONS(1619),
    [anon_sym_LT_AMP] = ACTIONS(1619),
    [anon_sym_GT_AMP] = ACTIONS(1619),
    [anon_sym_LT_LT] = ACTIONS(1619),
    [anon_sym_LT_LT_DASH] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1619),
    [sym_raw_string] = ACTIONS(1619),
    [anon_sym_DOLLAR] = ACTIONS(1619),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1619),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1619),
    [anon_sym_BQUOTE] = ACTIONS(1619),
    [anon_sym_LT_LPAREN] = ACTIONS(1619),
    [anon_sym_GT_LPAREN] = ACTIONS(1619),
    [sym_word] = ACTIONS(1619),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1619),
    [anon_sym_LF] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
  },
  [1403] = {
    [anon_sym_RBRACE] = ACTIONS(3615),
    [sym_comment] = ACTIONS(133),
  },
  [1404] = {
    [sym_file_descriptor] = ACTIONS(1623),
    [sym__concat] = ACTIONS(1623),
    [sym_variable_name] = ACTIONS(1623),
    [anon_sym_PIPE] = ACTIONS(1625),
    [anon_sym_RPAREN] = ACTIONS(1625),
    [anon_sym_SEMI_SEMI] = ACTIONS(1625),
    [anon_sym_PIPE_AMP] = ACTIONS(1625),
    [anon_sym_AMP_AMP] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1625),
    [anon_sym_GT] = ACTIONS(1625),
    [anon_sym_GT_GT] = ACTIONS(1625),
    [anon_sym_AMP_GT] = ACTIONS(1625),
    [anon_sym_AMP_GT_GT] = ACTIONS(1625),
    [anon_sym_LT_AMP] = ACTIONS(1625),
    [anon_sym_GT_AMP] = ACTIONS(1625),
    [anon_sym_LT_LT] = ACTIONS(1625),
    [anon_sym_LT_LT_DASH] = ACTIONS(1625),
    [anon_sym_DQUOTE] = ACTIONS(1625),
    [sym_raw_string] = ACTIONS(1625),
    [anon_sym_DOLLAR] = ACTIONS(1625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1625),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1625),
    [anon_sym_BQUOTE] = ACTIONS(1625),
    [anon_sym_LT_LPAREN] = ACTIONS(1625),
    [anon_sym_GT_LPAREN] = ACTIONS(1625),
    [sym_word] = ACTIONS(1625),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_LF] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
  },
  [1405] = {
    [sym__heredoc_middle] = ACTIONS(2059),
    [sym__heredoc_end] = ACTIONS(2059),
    [sym_file_descriptor] = ACTIONS(2059),
    [sym__concat] = ACTIONS(2059),
    [sym_variable_name] = ACTIONS(2059),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_SEMI_SEMI] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [anon_sym_PIPE_AMP] = ACTIONS(2061),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(2061),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_AMP_GT] = ACTIONS(2061),
    [anon_sym_AMP_GT_GT] = ACTIONS(2061),
    [anon_sym_LT_AMP] = ACTIONS(2061),
    [anon_sym_GT_AMP] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT_LT_DASH] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(2061),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2061),
    [sym_raw_string] = ACTIONS(2061),
    [anon_sym_DOLLAR] = ACTIONS(2061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2061),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [anon_sym_LT_LPAREN] = ACTIONS(2061),
    [anon_sym_GT_LPAREN] = ACTIONS(2061),
    [sym_word] = ACTIONS(2061),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_LF] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
  },
  [1406] = {
    [sym__heredoc_middle] = ACTIONS(2063),
    [sym__heredoc_end] = ACTIONS(2063),
    [sym_file_descriptor] = ACTIONS(2063),
    [sym__concat] = ACTIONS(2063),
    [sym_variable_name] = ACTIONS(2063),
    [anon_sym_in] = ACTIONS(2065),
    [anon_sym_PIPE] = ACTIONS(2065),
    [anon_sym_RPAREN] = ACTIONS(2065),
    [anon_sym_SEMI_SEMI] = ACTIONS(2065),
    [anon_sym_RBRACE] = ACTIONS(2065),
    [anon_sym_PIPE_AMP] = ACTIONS(2065),
    [anon_sym_AMP_AMP] = ACTIONS(2065),
    [anon_sym_PIPE_PIPE] = ACTIONS(2065),
    [anon_sym_RBRACK] = ACTIONS(2065),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2065),
    [anon_sym_LT] = ACTIONS(2065),
    [anon_sym_GT] = ACTIONS(2065),
    [anon_sym_GT_GT] = ACTIONS(2065),
    [anon_sym_AMP_GT] = ACTIONS(2065),
    [anon_sym_AMP_GT_GT] = ACTIONS(2065),
    [anon_sym_LT_AMP] = ACTIONS(2065),
    [anon_sym_GT_AMP] = ACTIONS(2065),
    [anon_sym_LT_LT] = ACTIONS(2065),
    [anon_sym_LT_LT_DASH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2065),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2065),
    [sym_raw_string] = ACTIONS(2065),
    [anon_sym_DOLLAR] = ACTIONS(2065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2065),
    [anon_sym_BQUOTE] = ACTIONS(2065),
    [anon_sym_LT_LPAREN] = ACTIONS(2065),
    [anon_sym_GT_LPAREN] = ACTIONS(2065),
    [sym_word] = ACTIONS(2065),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_LF] = ACTIONS(2065),
    [anon_sym_AMP] = ACTIONS(2065),
  },
  [1407] = {
    [anon_sym_RBRACK] = ACTIONS(3617),
    [sym_comment] = ACTIONS(133),
  },
  [1408] = {
    [anon_sym_RBRACK] = ACTIONS(3619),
    [sym_comment] = ACTIONS(133),
  },
  [1409] = {
    [anon_sym_RBRACE] = ACTIONS(3621),
    [sym_comment] = ACTIONS(133),
  },
  [1410] = {
    [sym_file_descriptor] = ACTIONS(1617),
    [sym__concat] = ACTIONS(1617),
    [sym_variable_name] = ACTIONS(1617),
    [anon_sym_in] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1619),
    [anon_sym_RPAREN] = ACTIONS(1619),
    [anon_sym_SEMI_SEMI] = ACTIONS(1619),
    [anon_sym_RBRACE] = ACTIONS(1619),
    [anon_sym_PIPE_AMP] = ACTIONS(1619),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE_PIPE] = ACTIONS(1619),
    [anon_sym_RBRACK] = ACTIONS(1619),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(1619),
    [anon_sym_GT_GT] = ACTIONS(1619),
    [anon_sym_AMP_GT] = ACTIONS(1619),
    [anon_sym_AMP_GT_GT] = ACTIONS(1619),
    [anon_sym_LT_AMP] = ACTIONS(1619),
    [anon_sym_GT_AMP] = ACTIONS(1619),
    [anon_sym_LT_LT] = ACTIONS(1619),
    [anon_sym_LT_LT_DASH] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1619),
    [sym_raw_string] = ACTIONS(1619),
    [anon_sym_DOLLAR] = ACTIONS(1619),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1619),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1619),
    [anon_sym_BQUOTE] = ACTIONS(1619),
    [anon_sym_LT_LPAREN] = ACTIONS(1619),
    [anon_sym_GT_LPAREN] = ACTIONS(1619),
    [sym_word] = ACTIONS(1619),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1619),
    [anon_sym_LF] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
  },
  [1411] = {
    [anon_sym_RBRACE] = ACTIONS(3623),
    [sym_comment] = ACTIONS(133),
  },
  [1412] = {
    [sym_file_descriptor] = ACTIONS(1623),
    [sym__concat] = ACTIONS(1623),
    [sym_variable_name] = ACTIONS(1623),
    [anon_sym_in] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(1625),
    [anon_sym_RPAREN] = ACTIONS(1625),
    [anon_sym_SEMI_SEMI] = ACTIONS(1625),
    [anon_sym_RBRACE] = ACTIONS(1625),
    [anon_sym_PIPE_AMP] = ACTIONS(1625),
    [anon_sym_AMP_AMP] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(1625),
    [anon_sym_RBRACK] = ACTIONS(1625),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1625),
    [anon_sym_GT] = ACTIONS(1625),
    [anon_sym_GT_GT] = ACTIONS(1625),
    [anon_sym_AMP_GT] = ACTIONS(1625),
    [anon_sym_AMP_GT_GT] = ACTIONS(1625),
    [anon_sym_LT_AMP] = ACTIONS(1625),
    [anon_sym_GT_AMP] = ACTIONS(1625),
    [anon_sym_LT_LT] = ACTIONS(1625),
    [anon_sym_LT_LT_DASH] = ACTIONS(1625),
    [anon_sym_DQUOTE] = ACTIONS(1625),
    [sym_raw_string] = ACTIONS(1625),
    [anon_sym_DOLLAR] = ACTIONS(1625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1625),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1625),
    [anon_sym_BQUOTE] = ACTIONS(1625),
    [anon_sym_LT_LPAREN] = ACTIONS(1625),
    [anon_sym_GT_LPAREN] = ACTIONS(1625),
    [sym_word] = ACTIONS(1625),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_LF] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
  },
  [1413] = {
    [sym_file_descriptor] = ACTIONS(1257),
    [sym__concat] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1259),
    [anon_sym_RPAREN] = ACTIONS(1259),
    [anon_sym_SEMI_SEMI] = ACTIONS(1259),
    [anon_sym_PIPE_AMP] = ACTIONS(1259),
    [anon_sym_AMP_AMP] = ACTIONS(1259),
    [anon_sym_PIPE_PIPE] = ACTIONS(1259),
    [anon_sym_LT] = ACTIONS(1259),
    [anon_sym_GT] = ACTIONS(1259),
    [anon_sym_GT_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT] = ACTIONS(1259),
    [anon_sym_AMP_GT_GT] = ACTIONS(1259),
    [anon_sym_LT_AMP] = ACTIONS(1259),
    [anon_sym_GT_AMP] = ACTIONS(1259),
    [anon_sym_LT_LT] = ACTIONS(1259),
    [anon_sym_LT_LT_DASH] = ACTIONS(1259),
    [anon_sym_BQUOTE] = ACTIONS(1259),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_LF] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1259),
  },
  [1414] = {
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE_AMP] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1263),
    [anon_sym_LT_AMP] = ACTIONS(1263),
    [anon_sym_GT_AMP] = ACTIONS(1263),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1263),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [1415] = {
    [anon_sym_AT] = ACTIONS(3625),
    [sym_comment] = ACTIONS(133),
  },
  [1416] = {
    [sym_file_descriptor] = ACTIONS(1267),
    [sym__concat] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_RPAREN] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE_AMP] = ACTIONS(1269),
    [anon_sym_AMP_AMP] = ACTIONS(1269),
    [anon_sym_PIPE_PIPE] = ACTIONS(1269),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1269),
    [anon_sym_LT_AMP] = ACTIONS(1269),
    [anon_sym_GT_AMP] = ACTIONS(1269),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1269),
    [anon_sym_BQUOTE] = ACTIONS(1269),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_LF] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [1417] = {
    [anon_sym_AT] = ACTIONS(3627),
    [sym_comment] = ACTIONS(133),
  },
  [1418] = {
    [anon_sym_RBRACK] = ACTIONS(3629),
    [sym_comment] = ACTIONS(133),
  },
  [1419] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(3631),
    [sym_comment] = ACTIONS(133),
  },
  [1420] = {
    [anon_sym_RBRACE] = ACTIONS(3631),
    [sym_comment] = ACTIONS(133),
  },
  [1421] = {
    [anon_sym_RBRACK] = ACTIONS(3633),
    [sym_comment] = ACTIONS(133),
  },
  [1422] = {
    [aux_sym_concatenation_repeat1] = STATE(179),
    [sym__concat] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(3635),
    [sym_comment] = ACTIONS(133),
  },
  [1423] = {
    [anon_sym_RBRACE] = ACTIONS(3635),
    [sym_comment] = ACTIONS(133),
  },
  [1424] = {
    [anon_sym_RBRACK] = ACTIONS(3637),
    [sym_comment] = ACTIONS(133),
  },
  [1425] = {
    [anon_sym_RBRACK] = ACTIONS(3639),
    [sym_comment] = ACTIONS(133),
  },
  [1426] = {
    [anon_sym_RBRACE] = ACTIONS(3641),
    [sym_comment] = ACTIONS(133),
  },
  [1427] = {
    [sym_file_descriptor] = ACTIONS(1617),
    [sym__concat] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1619),
    [anon_sym_RPAREN] = ACTIONS(1619),
    [anon_sym_SEMI_SEMI] = ACTIONS(1619),
    [anon_sym_PIPE_AMP] = ACTIONS(1619),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE_PIPE] = ACTIONS(1619),
    [anon_sym_RBRACK] = ACTIONS(1619),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(1619),
    [anon_sym_GT_GT] = ACTIONS(1619),
    [anon_sym_AMP_GT] = ACTIONS(1619),
    [anon_sym_AMP_GT_GT] = ACTIONS(1619),
    [anon_sym_LT_AMP] = ACTIONS(1619),
    [anon_sym_GT_AMP] = ACTIONS(1619),
    [anon_sym_LT_LT] = ACTIONS(1619),
    [anon_sym_LT_LT_DASH] = ACTIONS(1619),
    [anon_sym_DQUOTE] = ACTIONS(1619),
    [sym_raw_string] = ACTIONS(1619),
    [anon_sym_DOLLAR] = ACTIONS(1619),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1619),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1619),
    [anon_sym_BQUOTE] = ACTIONS(1619),
    [anon_sym_LT_LPAREN] = ACTIONS(1619),
    [anon_sym_GT_LPAREN] = ACTIONS(1619),
    [sym_word] = ACTIONS(1619),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1619),
    [anon_sym_LF] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
  },
  [1428] = {
    [anon_sym_RBRACE] = ACTIONS(3643),
    [sym_comment] = ACTIONS(133),
  },
  [1429] = {
    [sym_file_descriptor] = ACTIONS(1623),
    [sym__concat] = ACTIONS(1623),
    [anon_sym_PIPE] = ACTIONS(1625),
    [anon_sym_RPAREN] = ACTIONS(1625),
    [anon_sym_SEMI_SEMI] = ACTIONS(1625),
    [anon_sym_PIPE_AMP] = ACTIONS(1625),
    [anon_sym_AMP_AMP] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(1625),
    [anon_sym_RBRACK] = ACTIONS(1625),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1625),
    [anon_sym_GT] = ACTIONS(1625),
    [anon_sym_GT_GT] = ACTIONS(1625),
    [anon_sym_AMP_GT] = ACTIONS(1625),
    [anon_sym_AMP_GT_GT] = ACTIONS(1625),
    [anon_sym_LT_AMP] = ACTIONS(1625),
    [anon_sym_GT_AMP] = ACTIONS(1625),
    [anon_sym_LT_LT] = ACTIONS(1625),
    [anon_sym_LT_LT_DASH] = ACTIONS(1625),
    [anon_sym_DQUOTE] = ACTIONS(1625),
    [sym_raw_string] = ACTIONS(1625),
    [anon_sym_DOLLAR] = ACTIONS(1625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1625),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1625),
    [anon_sym_BQUOTE] = ACTIONS(1625),
    [anon_sym_LT_LPAREN] = ACTIONS(1625),
    [anon_sym_GT_LPAREN] = ACTIONS(1625),
    [sym_word] = ACTIONS(1625),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_LF] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
  },
  [1430] = {
    [anon_sym_RBRACE] = ACTIONS(3645),
    [sym_comment] = ACTIONS(133),
  },
  [1431] = {
    [anon_sym_RBRACE] = ACTIONS(3647),
    [sym_comment] = ACTIONS(133),
  },
  [1432] = {
    [sym_file_descriptor] = ACTIONS(1883),
    [sym__concat] = ACTIONS(1883),
    [sym_variable_name] = ACTIONS(1883),
    [anon_sym_PIPE] = ACTIONS(1885),
    [anon_sym_RPAREN] = ACTIONS(1885),
    [anon_sym_SEMI_SEMI] = ACTIONS(1885),
    [anon_sym_RBRACE] = ACTIONS(1885),
    [anon_sym_PIPE_AMP] = ACTIONS(1885),
    [anon_sym_AMP_AMP] = ACTIONS(1885),
    [anon_sym_PIPE_PIPE] = ACTIONS(1885),
    [anon_sym_LT] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1885),
    [anon_sym_GT_GT] = ACTIONS(1885),
    [anon_sym_AMP_GT] = ACTIONS(1885),
    [anon_sym_AMP_GT_GT] = ACTIONS(1885),
    [anon_sym_LT_AMP] = ACTIONS(1885),
    [anon_sym_GT_AMP] = ACTIONS(1885),
    [anon_sym_DQUOTE] = ACTIONS(1885),
    [sym_raw_string] = ACTIONS(1885),
    [anon_sym_DOLLAR] = ACTIONS(1885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1885),
    [anon_sym_BQUOTE] = ACTIONS(1885),
    [anon_sym_LT_LPAREN] = ACTIONS(1885),
    [anon_sym_GT_LPAREN] = ACTIONS(1885),
    [sym_word] = ACTIONS(1885),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1885),
    [anon_sym_LF] = ACTIONS(1885),
    [anon_sym_AMP] = ACTIONS(1885),
  },
  [1433] = {
    [sym_file_descriptor] = ACTIONS(1887),
    [sym__concat] = ACTIONS(1887),
    [sym_variable_name] = ACTIONS(1887),
    [anon_sym_PIPE] = ACTIONS(1889),
    [anon_sym_RPAREN] = ACTIONS(1889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1889),
    [anon_sym_RBRACE] = ACTIONS(1889),
    [anon_sym_PIPE_AMP] = ACTIONS(1889),
    [anon_sym_AMP_AMP] = ACTIONS(1889),
    [anon_sym_PIPE_PIPE] = ACTIONS(1889),
    [anon_sym_LT] = ACTIONS(1889),
    [anon_sym_GT] = ACTIONS(1889),
    [anon_sym_GT_GT] = ACTIONS(1889),
    [anon_sym_AMP_GT] = ACTIONS(1889),
    [anon_sym_AMP_GT_GT] = ACTIONS(1889),
    [anon_sym_LT_AMP] = ACTIONS(1889),
    [anon_sym_GT_AMP] = ACTIONS(1889),
    [anon_sym_DQUOTE] = ACTIONS(1889),
    [sym_raw_string] = ACTIONS(1889),
    [anon_sym_DOLLAR] = ACTIONS(1889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1889),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [anon_sym_LT_LPAREN] = ACTIONS(1889),
    [anon_sym_GT_LPAREN] = ACTIONS(1889),
    [sym_word] = ACTIONS(1889),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1889),
    [anon_sym_LF] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
  },
  [1434] = {
    [anon_sym_RBRACE] = ACTIONS(3649),
    [sym_comment] = ACTIONS(133),
  },
  [1435] = {
    [anon_sym_RBRACE] = ACTIONS(3651),
    [sym_comment] = ACTIONS(133),
  },
  [1436] = {
    [sym_file_descriptor] = ACTIONS(1883),
    [sym__concat] = ACTIONS(1883),
    [sym_variable_name] = ACTIONS(1883),
    [anon_sym_PIPE] = ACTIONS(1885),
    [anon_sym_RPAREN] = ACTIONS(1885),
    [anon_sym_SEMI_SEMI] = ACTIONS(1885),
    [anon_sym_PIPE_AMP] = ACTIONS(1885),
    [anon_sym_AMP_AMP] = ACTIONS(1885),
    [anon_sym_PIPE_PIPE] = ACTIONS(1885),
    [anon_sym_LT] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1885),
    [anon_sym_GT_GT] = ACTIONS(1885),
    [anon_sym_AMP_GT] = ACTIONS(1885),
    [anon_sym_AMP_GT_GT] = ACTIONS(1885),
    [anon_sym_LT_AMP] = ACTIONS(1885),
    [anon_sym_GT_AMP] = ACTIONS(1885),
    [anon_sym_LT_LT] = ACTIONS(1885),
    [anon_sym_LT_LT_DASH] = ACTIONS(1885),
    [anon_sym_DQUOTE] = ACTIONS(1885),
    [sym_raw_string] = ACTIONS(1885),
    [anon_sym_DOLLAR] = ACTIONS(1885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1885),
    [anon_sym_BQUOTE] = ACTIONS(1885),
    [anon_sym_LT_LPAREN] = ACTIONS(1885),
    [anon_sym_GT_LPAREN] = ACTIONS(1885),
    [sym_word] = ACTIONS(1885),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1885),
    [anon_sym_LF] = ACTIONS(1885),
    [anon_sym_AMP] = ACTIONS(1885),
  },
  [1437] = {
    [sym_file_descriptor] = ACTIONS(1887),
    [sym__concat] = ACTIONS(1887),
    [sym_variable_name] = ACTIONS(1887),
    [anon_sym_PIPE] = ACTIONS(1889),
    [anon_sym_RPAREN] = ACTIONS(1889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1889),
    [anon_sym_PIPE_AMP] = ACTIONS(1889),
    [anon_sym_AMP_AMP] = ACTIONS(1889),
    [anon_sym_PIPE_PIPE] = ACTIONS(1889),
    [anon_sym_LT] = ACTIONS(1889),
    [anon_sym_GT] = ACTIONS(1889),
    [anon_sym_GT_GT] = ACTIONS(1889),
    [anon_sym_AMP_GT] = ACTIONS(1889),
    [anon_sym_AMP_GT_GT] = ACTIONS(1889),
    [anon_sym_LT_AMP] = ACTIONS(1889),
    [anon_sym_GT_AMP] = ACTIONS(1889),
    [anon_sym_LT_LT] = ACTIONS(1889),
    [anon_sym_LT_LT_DASH] = ACTIONS(1889),
    [anon_sym_DQUOTE] = ACTIONS(1889),
    [sym_raw_string] = ACTIONS(1889),
    [anon_sym_DOLLAR] = ACTIONS(1889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1889),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [anon_sym_LT_LPAREN] = ACTIONS(1889),
    [anon_sym_GT_LPAREN] = ACTIONS(1889),
    [sym_word] = ACTIONS(1889),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1889),
    [anon_sym_LF] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
  },
  [1438] = {
    [anon_sym_RBRACE] = ACTIONS(3653),
    [sym_comment] = ACTIONS(133),
  },
  [1439] = {
    [anon_sym_RBRACE] = ACTIONS(3655),
    [sym_comment] = ACTIONS(133),
  },
  [1440] = {
    [sym_file_descriptor] = ACTIONS(1883),
    [sym__concat] = ACTIONS(1883),
    [sym_variable_name] = ACTIONS(1883),
    [anon_sym_in] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1885),
    [anon_sym_RPAREN] = ACTIONS(1885),
    [anon_sym_SEMI_SEMI] = ACTIONS(1885),
    [anon_sym_RBRACE] = ACTIONS(1885),
    [anon_sym_PIPE_AMP] = ACTIONS(1885),
    [anon_sym_AMP_AMP] = ACTIONS(1885),
    [anon_sym_PIPE_PIPE] = ACTIONS(1885),
    [anon_sym_RBRACK] = ACTIONS(1885),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1885),
    [anon_sym_LT] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1885),
    [anon_sym_GT_GT] = ACTIONS(1885),
    [anon_sym_AMP_GT] = ACTIONS(1885),
    [anon_sym_AMP_GT_GT] = ACTIONS(1885),
    [anon_sym_LT_AMP] = ACTIONS(1885),
    [anon_sym_GT_AMP] = ACTIONS(1885),
    [anon_sym_LT_LT] = ACTIONS(1885),
    [anon_sym_LT_LT_DASH] = ACTIONS(1885),
    [anon_sym_DQUOTE] = ACTIONS(1885),
    [sym_raw_string] = ACTIONS(1885),
    [anon_sym_DOLLAR] = ACTIONS(1885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1885),
    [anon_sym_BQUOTE] = ACTIONS(1885),
    [anon_sym_LT_LPAREN] = ACTIONS(1885),
    [anon_sym_GT_LPAREN] = ACTIONS(1885),
    [sym_word] = ACTIONS(1885),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1885),
    [anon_sym_LF] = ACTIONS(1885),
    [anon_sym_AMP] = ACTIONS(1885),
  },
  [1441] = {
    [sym_file_descriptor] = ACTIONS(1887),
    [sym__concat] = ACTIONS(1887),
    [sym_variable_name] = ACTIONS(1887),
    [anon_sym_in] = ACTIONS(1889),
    [anon_sym_PIPE] = ACTIONS(1889),
    [anon_sym_RPAREN] = ACTIONS(1889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1889),
    [anon_sym_RBRACE] = ACTIONS(1889),
    [anon_sym_PIPE_AMP] = ACTIONS(1889),
    [anon_sym_AMP_AMP] = ACTIONS(1889),
    [anon_sym_PIPE_PIPE] = ACTIONS(1889),
    [anon_sym_RBRACK] = ACTIONS(1889),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1889),
    [anon_sym_LT] = ACTIONS(1889),
    [anon_sym_GT] = ACTIONS(1889),
    [anon_sym_GT_GT] = ACTIONS(1889),
    [anon_sym_AMP_GT] = ACTIONS(1889),
    [anon_sym_AMP_GT_GT] = ACTIONS(1889),
    [anon_sym_LT_AMP] = ACTIONS(1889),
    [anon_sym_GT_AMP] = ACTIONS(1889),
    [anon_sym_LT_LT] = ACTIONS(1889),
    [anon_sym_LT_LT_DASH] = ACTIONS(1889),
    [anon_sym_DQUOTE] = ACTIONS(1889),
    [sym_raw_string] = ACTIONS(1889),
    [anon_sym_DOLLAR] = ACTIONS(1889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1889),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [anon_sym_LT_LPAREN] = ACTIONS(1889),
    [anon_sym_GT_LPAREN] = ACTIONS(1889),
    [sym_word] = ACTIONS(1889),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1889),
    [anon_sym_LF] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
  },
  [1442] = {
    [anon_sym_RBRACK] = ACTIONS(3657),
    [sym_comment] = ACTIONS(133),
  },
  [1443] = {
    [anon_sym_RBRACK] = ACTIONS(3659),
    [sym_comment] = ACTIONS(133),
  },
  [1444] = {
    [anon_sym_RBRACE] = ACTIONS(3661),
    [sym_comment] = ACTIONS(133),
  },
  [1445] = {
    [sym_file_descriptor] = ACTIONS(1617),
    [sym__concat] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1619),
    [anon_sym_RPAREN] = ACTIONS(1619),
    [anon_sym_SEMI_SEMI] = ACTIONS(1619),
    [anon_sym_PIPE_AMP] = ACTIONS(1619),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE_PIPE] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(1619),
    [anon_sym_GT_GT] = ACTIONS(1619),
    [anon_sym_AMP_GT] = ACTIONS(1619),
    [anon_sym_AMP_GT_GT] = ACTIONS(1619),
    [anon_sym_LT_AMP] = ACTIONS(1619),
    [anon_sym_GT_AMP] = ACTIONS(1619),
    [anon_sym_LT_LT] = ACTIONS(1619),
    [anon_sym_LT_LT_DASH] = ACTIONS(1619),
    [anon_sym_BQUOTE] = ACTIONS(1619),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1619),
    [anon_sym_LF] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
  },
  [1446] = {
    [anon_sym_RBRACE] = ACTIONS(3663),
    [sym_comment] = ACTIONS(133),
  },
  [1447] = {
    [sym_file_descriptor] = ACTIONS(1623),
    [sym__concat] = ACTIONS(1623),
    [anon_sym_PIPE] = ACTIONS(1625),
    [anon_sym_RPAREN] = ACTIONS(1625),
    [anon_sym_SEMI_SEMI] = ACTIONS(1625),
    [anon_sym_PIPE_AMP] = ACTIONS(1625),
    [anon_sym_AMP_AMP] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1625),
    [anon_sym_GT] = ACTIONS(1625),
    [anon_sym_GT_GT] = ACTIONS(1625),
    [anon_sym_AMP_GT] = ACTIONS(1625),
    [anon_sym_AMP_GT_GT] = ACTIONS(1625),
    [anon_sym_LT_AMP] = ACTIONS(1625),
    [anon_sym_GT_AMP] = ACTIONS(1625),
    [anon_sym_LT_LT] = ACTIONS(1625),
    [anon_sym_LT_LT_DASH] = ACTIONS(1625),
    [anon_sym_BQUOTE] = ACTIONS(1625),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_LF] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
  },
  [1448] = {
    [anon_sym_RBRACE] = ACTIONS(3665),
    [sym_comment] = ACTIONS(133),
  },
  [1449] = {
    [anon_sym_RBRACE] = ACTIONS(3667),
    [sym_comment] = ACTIONS(133),
  },
  [1450] = {
    [sym_file_descriptor] = ACTIONS(1883),
    [sym__concat] = ACTIONS(1883),
    [anon_sym_PIPE] = ACTIONS(1885),
    [anon_sym_RPAREN] = ACTIONS(1885),
    [anon_sym_SEMI_SEMI] = ACTIONS(1885),
    [anon_sym_PIPE_AMP] = ACTIONS(1885),
    [anon_sym_AMP_AMP] = ACTIONS(1885),
    [anon_sym_PIPE_PIPE] = ACTIONS(1885),
    [anon_sym_RBRACK] = ACTIONS(1885),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1885),
    [anon_sym_LT] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1885),
    [anon_sym_GT_GT] = ACTIONS(1885),
    [anon_sym_AMP_GT] = ACTIONS(1885),
    [anon_sym_AMP_GT_GT] = ACTIONS(1885),
    [anon_sym_LT_AMP] = ACTIONS(1885),
    [anon_sym_GT_AMP] = ACTIONS(1885),
    [anon_sym_LT_LT] = ACTIONS(1885),
    [anon_sym_LT_LT_DASH] = ACTIONS(1885),
    [anon_sym_DQUOTE] = ACTIONS(1885),
    [sym_raw_string] = ACTIONS(1885),
    [anon_sym_DOLLAR] = ACTIONS(1885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1885),
    [anon_sym_BQUOTE] = ACTIONS(1885),
    [anon_sym_LT_LPAREN] = ACTIONS(1885),
    [anon_sym_GT_LPAREN] = ACTIONS(1885),
    [sym_word] = ACTIONS(1885),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1885),
    [anon_sym_LF] = ACTIONS(1885),
    [anon_sym_AMP] = ACTIONS(1885),
  },
  [1451] = {
    [sym_file_descriptor] = ACTIONS(1887),
    [sym__concat] = ACTIONS(1887),
    [anon_sym_PIPE] = ACTIONS(1889),
    [anon_sym_RPAREN] = ACTIONS(1889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1889),
    [anon_sym_PIPE_AMP] = ACTIONS(1889),
    [anon_sym_AMP_AMP] = ACTIONS(1889),
    [anon_sym_PIPE_PIPE] = ACTIONS(1889),
    [anon_sym_RBRACK] = ACTIONS(1889),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1889),
    [anon_sym_LT] = ACTIONS(1889),
    [anon_sym_GT] = ACTIONS(1889),
    [anon_sym_GT_GT] = ACTIONS(1889),
    [anon_sym_AMP_GT] = ACTIONS(1889),
    [anon_sym_AMP_GT_GT] = ACTIONS(1889),
    [anon_sym_LT_AMP] = ACTIONS(1889),
    [anon_sym_GT_AMP] = ACTIONS(1889),
    [anon_sym_LT_LT] = ACTIONS(1889),
    [anon_sym_LT_LT_DASH] = ACTIONS(1889),
    [anon_sym_DQUOTE] = ACTIONS(1889),
    [sym_raw_string] = ACTIONS(1889),
    [anon_sym_DOLLAR] = ACTIONS(1889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1889),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [anon_sym_LT_LPAREN] = ACTIONS(1889),
    [anon_sym_GT_LPAREN] = ACTIONS(1889),
    [sym_word] = ACTIONS(1889),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1889),
    [anon_sym_LF] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
  },
  [1452] = {
    [sym_file_descriptor] = ACTIONS(2059),
    [sym__concat] = ACTIONS(2059),
    [sym_variable_name] = ACTIONS(2059),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_SEMI_SEMI] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [anon_sym_PIPE_AMP] = ACTIONS(2061),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_AMP_GT] = ACTIONS(2061),
    [anon_sym_AMP_GT_GT] = ACTIONS(2061),
    [anon_sym_LT_AMP] = ACTIONS(2061),
    [anon_sym_GT_AMP] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(2061),
    [sym_raw_string] = ACTIONS(2061),
    [anon_sym_DOLLAR] = ACTIONS(2061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2061),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [anon_sym_LT_LPAREN] = ACTIONS(2061),
    [anon_sym_GT_LPAREN] = ACTIONS(2061),
    [sym_word] = ACTIONS(2061),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_LF] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
  },
  [1453] = {
    [sym_file_descriptor] = ACTIONS(2063),
    [sym__concat] = ACTIONS(2063),
    [sym_variable_name] = ACTIONS(2063),
    [anon_sym_PIPE] = ACTIONS(2065),
    [anon_sym_RPAREN] = ACTIONS(2065),
    [anon_sym_SEMI_SEMI] = ACTIONS(2065),
    [anon_sym_RBRACE] = ACTIONS(2065),
    [anon_sym_PIPE_AMP] = ACTIONS(2065),
    [anon_sym_AMP_AMP] = ACTIONS(2065),
    [anon_sym_PIPE_PIPE] = ACTIONS(2065),
    [anon_sym_LT] = ACTIONS(2065),
    [anon_sym_GT] = ACTIONS(2065),
    [anon_sym_GT_GT] = ACTIONS(2065),
    [anon_sym_AMP_GT] = ACTIONS(2065),
    [anon_sym_AMP_GT_GT] = ACTIONS(2065),
    [anon_sym_LT_AMP] = ACTIONS(2065),
    [anon_sym_GT_AMP] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2065),
    [sym_raw_string] = ACTIONS(2065),
    [anon_sym_DOLLAR] = ACTIONS(2065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2065),
    [anon_sym_BQUOTE] = ACTIONS(2065),
    [anon_sym_LT_LPAREN] = ACTIONS(2065),
    [anon_sym_GT_LPAREN] = ACTIONS(2065),
    [sym_word] = ACTIONS(2065),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_LF] = ACTIONS(2065),
    [anon_sym_AMP] = ACTIONS(2065),
  },
  [1454] = {
    [sym_file_descriptor] = ACTIONS(2059),
    [sym__concat] = ACTIONS(2059),
    [sym_variable_name] = ACTIONS(2059),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_SEMI_SEMI] = ACTIONS(2061),
    [anon_sym_PIPE_AMP] = ACTIONS(2061),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_AMP_GT] = ACTIONS(2061),
    [anon_sym_AMP_GT_GT] = ACTIONS(2061),
    [anon_sym_LT_AMP] = ACTIONS(2061),
    [anon_sym_GT_AMP] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT_LT_DASH] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(2061),
    [sym_raw_string] = ACTIONS(2061),
    [anon_sym_DOLLAR] = ACTIONS(2061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2061),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [anon_sym_LT_LPAREN] = ACTIONS(2061),
    [anon_sym_GT_LPAREN] = ACTIONS(2061),
    [sym_word] = ACTIONS(2061),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_LF] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
  },
  [1455] = {
    [sym_file_descriptor] = ACTIONS(2063),
    [sym__concat] = ACTIONS(2063),
    [sym_variable_name] = ACTIONS(2063),
    [anon_sym_PIPE] = ACTIONS(2065),
    [anon_sym_RPAREN] = ACTIONS(2065),
    [anon_sym_SEMI_SEMI] = ACTIONS(2065),
    [anon_sym_PIPE_AMP] = ACTIONS(2065),
    [anon_sym_AMP_AMP] = ACTIONS(2065),
    [anon_sym_PIPE_PIPE] = ACTIONS(2065),
    [anon_sym_LT] = ACTIONS(2065),
    [anon_sym_GT] = ACTIONS(2065),
    [anon_sym_GT_GT] = ACTIONS(2065),
    [anon_sym_AMP_GT] = ACTIONS(2065),
    [anon_sym_AMP_GT_GT] = ACTIONS(2065),
    [anon_sym_LT_AMP] = ACTIONS(2065),
    [anon_sym_GT_AMP] = ACTIONS(2065),
    [anon_sym_LT_LT] = ACTIONS(2065),
    [anon_sym_LT_LT_DASH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2065),
    [sym_raw_string] = ACTIONS(2065),
    [anon_sym_DOLLAR] = ACTIONS(2065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2065),
    [anon_sym_BQUOTE] = ACTIONS(2065),
    [anon_sym_LT_LPAREN] = ACTIONS(2065),
    [anon_sym_GT_LPAREN] = ACTIONS(2065),
    [sym_word] = ACTIONS(2065),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_LF] = ACTIONS(2065),
    [anon_sym_AMP] = ACTIONS(2065),
  },
  [1456] = {
    [sym_file_descriptor] = ACTIONS(2059),
    [sym__concat] = ACTIONS(2059),
    [sym_variable_name] = ACTIONS(2059),
    [anon_sym_in] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_SEMI_SEMI] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [anon_sym_PIPE_AMP] = ACTIONS(2061),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(2061),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_AMP_GT] = ACTIONS(2061),
    [anon_sym_AMP_GT_GT] = ACTIONS(2061),
    [anon_sym_LT_AMP] = ACTIONS(2061),
    [anon_sym_GT_AMP] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT_LT_DASH] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(2061),
    [sym_raw_string] = ACTIONS(2061),
    [anon_sym_DOLLAR] = ACTIONS(2061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2061),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [anon_sym_LT_LPAREN] = ACTIONS(2061),
    [anon_sym_GT_LPAREN] = ACTIONS(2061),
    [sym_word] = ACTIONS(2061),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_LF] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
  },
  [1457] = {
    [sym_file_descriptor] = ACTIONS(2063),
    [sym__concat] = ACTIONS(2063),
    [sym_variable_name] = ACTIONS(2063),
    [anon_sym_in] = ACTIONS(2065),
    [anon_sym_PIPE] = ACTIONS(2065),
    [anon_sym_RPAREN] = ACTIONS(2065),
    [anon_sym_SEMI_SEMI] = ACTIONS(2065),
    [anon_sym_RBRACE] = ACTIONS(2065),
    [anon_sym_PIPE_AMP] = ACTIONS(2065),
    [anon_sym_AMP_AMP] = ACTIONS(2065),
    [anon_sym_PIPE_PIPE] = ACTIONS(2065),
    [anon_sym_RBRACK] = ACTIONS(2065),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2065),
    [anon_sym_LT] = ACTIONS(2065),
    [anon_sym_GT] = ACTIONS(2065),
    [anon_sym_GT_GT] = ACTIONS(2065),
    [anon_sym_AMP_GT] = ACTIONS(2065),
    [anon_sym_AMP_GT_GT] = ACTIONS(2065),
    [anon_sym_LT_AMP] = ACTIONS(2065),
    [anon_sym_GT_AMP] = ACTIONS(2065),
    [anon_sym_LT_LT] = ACTIONS(2065),
    [anon_sym_LT_LT_DASH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2065),
    [sym_raw_string] = ACTIONS(2065),
    [anon_sym_DOLLAR] = ACTIONS(2065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2065),
    [anon_sym_BQUOTE] = ACTIONS(2065),
    [anon_sym_LT_LPAREN] = ACTIONS(2065),
    [anon_sym_GT_LPAREN] = ACTIONS(2065),
    [sym_word] = ACTIONS(2065),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_LF] = ACTIONS(2065),
    [anon_sym_AMP] = ACTIONS(2065),
  },
  [1458] = {
    [anon_sym_RBRACE] = ACTIONS(3669),
    [sym_comment] = ACTIONS(133),
  },
  [1459] = {
    [anon_sym_RBRACE] = ACTIONS(3671),
    [sym_comment] = ACTIONS(133),
  },
  [1460] = {
    [sym_file_descriptor] = ACTIONS(1883),
    [sym__concat] = ACTIONS(1883),
    [anon_sym_PIPE] = ACTIONS(1885),
    [anon_sym_RPAREN] = ACTIONS(1885),
    [anon_sym_SEMI_SEMI] = ACTIONS(1885),
    [anon_sym_PIPE_AMP] = ACTIONS(1885),
    [anon_sym_AMP_AMP] = ACTIONS(1885),
    [anon_sym_PIPE_PIPE] = ACTIONS(1885),
    [anon_sym_LT] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1885),
    [anon_sym_GT_GT] = ACTIONS(1885),
    [anon_sym_AMP_GT] = ACTIONS(1885),
    [anon_sym_AMP_GT_GT] = ACTIONS(1885),
    [anon_sym_LT_AMP] = ACTIONS(1885),
    [anon_sym_GT_AMP] = ACTIONS(1885),
    [anon_sym_LT_LT] = ACTIONS(1885),
    [anon_sym_LT_LT_DASH] = ACTIONS(1885),
    [anon_sym_BQUOTE] = ACTIONS(1885),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1885),
    [anon_sym_LF] = ACTIONS(1885),
    [anon_sym_AMP] = ACTIONS(1885),
  },
  [1461] = {
    [sym_file_descriptor] = ACTIONS(1887),
    [sym__concat] = ACTIONS(1887),
    [anon_sym_PIPE] = ACTIONS(1889),
    [anon_sym_RPAREN] = ACTIONS(1889),
    [anon_sym_SEMI_SEMI] = ACTIONS(1889),
    [anon_sym_PIPE_AMP] = ACTIONS(1889),
    [anon_sym_AMP_AMP] = ACTIONS(1889),
    [anon_sym_PIPE_PIPE] = ACTIONS(1889),
    [anon_sym_LT] = ACTIONS(1889),
    [anon_sym_GT] = ACTIONS(1889),
    [anon_sym_GT_GT] = ACTIONS(1889),
    [anon_sym_AMP_GT] = ACTIONS(1889),
    [anon_sym_AMP_GT_GT] = ACTIONS(1889),
    [anon_sym_LT_AMP] = ACTIONS(1889),
    [anon_sym_GT_AMP] = ACTIONS(1889),
    [anon_sym_LT_LT] = ACTIONS(1889),
    [anon_sym_LT_LT_DASH] = ACTIONS(1889),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(1889),
    [anon_sym_LF] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
  },
  [1462] = {
    [sym_file_descriptor] = ACTIONS(2059),
    [sym__concat] = ACTIONS(2059),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_SEMI_SEMI] = ACTIONS(2061),
    [anon_sym_PIPE_AMP] = ACTIONS(2061),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(2061),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_AMP_GT] = ACTIONS(2061),
    [anon_sym_AMP_GT_GT] = ACTIONS(2061),
    [anon_sym_LT_AMP] = ACTIONS(2061),
    [anon_sym_GT_AMP] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT_LT_DASH] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(2061),
    [sym_raw_string] = ACTIONS(2061),
    [anon_sym_DOLLAR] = ACTIONS(2061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2061),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [anon_sym_LT_LPAREN] = ACTIONS(2061),
    [anon_sym_GT_LPAREN] = ACTIONS(2061),
    [sym_word] = ACTIONS(2061),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_LF] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
  },
  [1463] = {
    [sym_file_descriptor] = ACTIONS(2063),
    [sym__concat] = ACTIONS(2063),
    [anon_sym_PIPE] = ACTIONS(2065),
    [anon_sym_RPAREN] = ACTIONS(2065),
    [anon_sym_SEMI_SEMI] = ACTIONS(2065),
    [anon_sym_PIPE_AMP] = ACTIONS(2065),
    [anon_sym_AMP_AMP] = ACTIONS(2065),
    [anon_sym_PIPE_PIPE] = ACTIONS(2065),
    [anon_sym_RBRACK] = ACTIONS(2065),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2065),
    [anon_sym_LT] = ACTIONS(2065),
    [anon_sym_GT] = ACTIONS(2065),
    [anon_sym_GT_GT] = ACTIONS(2065),
    [anon_sym_AMP_GT] = ACTIONS(2065),
    [anon_sym_AMP_GT_GT] = ACTIONS(2065),
    [anon_sym_LT_AMP] = ACTIONS(2065),
    [anon_sym_GT_AMP] = ACTIONS(2065),
    [anon_sym_LT_LT] = ACTIONS(2065),
    [anon_sym_LT_LT_DASH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2065),
    [sym_raw_string] = ACTIONS(2065),
    [anon_sym_DOLLAR] = ACTIONS(2065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2065),
    [anon_sym_BQUOTE] = ACTIONS(2065),
    [anon_sym_LT_LPAREN] = ACTIONS(2065),
    [anon_sym_GT_LPAREN] = ACTIONS(2065),
    [sym_word] = ACTIONS(2065),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_LF] = ACTIONS(2065),
    [anon_sym_AMP] = ACTIONS(2065),
  },
  [1464] = {
    [sym_file_descriptor] = ACTIONS(2059),
    [sym__concat] = ACTIONS(2059),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_SEMI_SEMI] = ACTIONS(2061),
    [anon_sym_PIPE_AMP] = ACTIONS(2061),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_GT_GT] = ACTIONS(2061),
    [anon_sym_AMP_GT] = ACTIONS(2061),
    [anon_sym_AMP_GT_GT] = ACTIONS(2061),
    [anon_sym_LT_AMP] = ACTIONS(2061),
    [anon_sym_GT_AMP] = ACTIONS(2061),
    [anon_sym_LT_LT] = ACTIONS(2061),
    [anon_sym_LT_LT_DASH] = ACTIONS(2061),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_LF] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
  },
  [1465] = {
    [sym_file_descriptor] = ACTIONS(2063),
    [sym__concat] = ACTIONS(2063),
    [anon_sym_PIPE] = ACTIONS(2065),
    [anon_sym_RPAREN] = ACTIONS(2065),
    [anon_sym_SEMI_SEMI] = ACTIONS(2065),
    [anon_sym_PIPE_AMP] = ACTIONS(2065),
    [anon_sym_AMP_AMP] = ACTIONS(2065),
    [anon_sym_PIPE_PIPE] = ACTIONS(2065),
    [anon_sym_LT] = ACTIONS(2065),
    [anon_sym_GT] = ACTIONS(2065),
    [anon_sym_GT_GT] = ACTIONS(2065),
    [anon_sym_AMP_GT] = ACTIONS(2065),
    [anon_sym_AMP_GT_GT] = ACTIONS(2065),
    [anon_sym_LT_AMP] = ACTIONS(2065),
    [anon_sym_GT_AMP] = ACTIONS(2065),
    [anon_sym_LT_LT] = ACTIONS(2065),
    [anon_sym_LT_LT_DASH] = ACTIONS(2065),
    [anon_sym_BQUOTE] = ACTIONS(2065),
    [sym_comment] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_LF] = ACTIONS(2065),
    [anon_sym_AMP] = ACTIONS(2065),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false, .depends_on_lookahead = false},
  [1] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(996),
  [3] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(997),
  [5] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(998),
  [7] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(999),
  [9] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(1000),
  [11] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(139),
  [13] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(1001),
  [15] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(3),
  [17] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(0),
  [19] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(965),
  [21] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(966),
  [23] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(967),
  [25] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, RECOVER(968),
  [27] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(969),
  [29] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(970),
  [31] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(971),
  [33] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(972),
  [35] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(349),
  [37] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(350),
  [39] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(973),
  [41] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(974),
  [43] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(975),
  [45] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(976),
  [47] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(977),
  [49] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(978),
  [51] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(979),
  [53] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(980),
  [55] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(981),
  [57] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, RECOVER(982),
  [59] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(983),
  [61] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(984),
  [63] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, RECOVER(985),
  [65] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(985),
  [67] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(986),
  [69] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(987),
  [71] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(988),
  [73] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, RECOVER(989),
  [75] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(990),
  [77] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, RECOVER(991),
  [79] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(991),
  [81] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(992),
  [83] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(993),
  [85] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT_EXTRA(),
  [87] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(994),
  [89] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(995),
  [91] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2),
  [93] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(3),
  [95] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_program, 0),
  [97] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(4),
  [99] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(5),
  [101] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(6),
  [103] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(7),
  [105] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(8),
  [107] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(9),
  [109] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(10),
  [111] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(11),
  [113] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(12),
  [115] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(12),
  [117] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(13),
  [119] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(14),
  [121] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(15),
  [123] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(16),
  [125] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(17),
  [127] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(18),
  [129] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(19),
  [131] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(20),
  [133] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT_EXTRA(),
  [135] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(31),
  [137] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(31),
  [139] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(32),
  [141] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(33),
  [143] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(34),
  [145] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(39),
  [147] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(40),
  [149] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(41),
  [151] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(42),
  [153] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(43),
  [155] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(44),
  [157] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(45),
  [159] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(40),
  [161] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(47),
  [163] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(51),
  [165] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(52),
  [167] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(53),
  [169] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(54),
  [171] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(55),
  [173] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(56),
  [175] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(57),
  [177] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(52),
  [179] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(61),
  [181] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(62),
  [183] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(63),
  [185] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(64),
  [187] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(65),
  [189] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(66),
  [191] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(67),
  [193] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(62),
  [195] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(69),
  [197] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(70),
  [199] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(71),
  [201] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(72),
  [203] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(73),
  [205] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(74),
  [207] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1),
  [209] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(76),
  [211] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1),
  [213] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(78),
  [215] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(78),
  [217] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(79),
  [219] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(81),
  [221] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(82),
  [223] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(83),
  [225] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(81),
  [227] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(85),
  [229] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(86),
  [231] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(87),
  [233] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(88),
  [235] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(89),
  [237] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(90),
  [239] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(91),
  [241] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(92),
  [243] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(93),
  [245] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(94),
  [247] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(95),
  [249] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(96),
  [251] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(97),
  [253] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(98),
  [255] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(99),
  [257] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(100),
  [259] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(101),
  [261] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(114),
  [263] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, ACCEPT_INPUT(),
  [265] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 1),
  [267] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 1),
  [269] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 1),
  [271] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(115),
  [273] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(116),
  [275] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(117),
  [277] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(118),
  [279] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 1, .fragile = true),
  [281] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(119),
  [283] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(120),
  [285] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(13),
  [287] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(121),
  [289] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(15),
  [291] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(16),
  [293] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(17),
  [295] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(18),
  [297] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(19),
  [299] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true),
  [301] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true),
  [303] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1),
  [305] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat1, 1),
  [307] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_program, 1),
  [309] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(14),
  [311] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(129),
  [313] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(129),
  [315] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(131),
  [317] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(132),
  [319] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(133),
  [321] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(134),
  [323] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(135),
  [325] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(136),
  [327] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(137),
  [329] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(132),
  [331] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(139),
  [333] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(140),
  [335] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(141),
  [337] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(142),
  [339] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(143),
  [341] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(144),
  [343] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(145),
  [345] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(146),
  [347] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(147),
  [349] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(142),
  [351] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(148),
  [353] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(149),
  [355] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(151),
  [357] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(152),
  [359] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(153),
  [361] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(155),
  [363] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(156),
  [365] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(157),
  [367] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(159),
  [369] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(159),
  [371] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(160),
  [373] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(162),
  [375] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(163),
  [377] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(171),
  [379] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(172),
  [381] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(173),
  [383] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(176),
  [385] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(178),
  [387] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [389] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [391] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [393] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(180),
  [395] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(180),
  [397] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(181),
  [399] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(183),
  [401] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(184),
  [403] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(192),
  [405] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(193),
  [407] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(193),
  [409] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(195),
  [411] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2),
  [413] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(197),
  [415] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_file_redirect, 2),
  [417] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(199),
  [419] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(199),
  [421] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(200),
  [423] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(202),
  [425] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(203),
  [427] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_string, 2),
  [429] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 2),
  [431] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 1),
  [433] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_string_repeat1, 1),
  [435] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(211),
  [437] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(211),
  [439] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(212),
  [441] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(214),
  [443] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(215),
  [445] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(221),
  [447] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(222),
  [449] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(223),
  [451] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(223),
  [453] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_concatenation, 2),
  [455] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(224),
  [457] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_concatenation, 2),
  [459] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_special_variable_name, 1),
  [461] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_special_variable_name, 1),
  [463] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2, .rename_sequence_id = 1),
  [465] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2, .rename_sequence_id = 1),
  [467] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2),
  [469] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2),
  [471] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_special_variable_name, 1),
  [473] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(225),
  [475] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(227),
  [477] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(228),
  [479] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(229),
  [481] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(229),
  [483] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(230),
  [485] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(231),
  [487] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(232),
  [489] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(232),
  [491] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(233),
  [493] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(234),
  [495] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(237),
  [497] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(237),
  [499] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(239),
  [501] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(245),
  [503] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(247),
  [505] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command_name, 1),
  [507] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(249),
  [509] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(249),
  [511] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(250),
  [513] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(252),
  [515] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(253),
  [517] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(261),
  [519] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(262),
  [521] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(263),
  [523] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(262),
  [525] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(264),
  [527] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(265),
  [529] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 1, .fragile = true),
  [531] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 1, .fragile = true),
  [533] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(266),
  [535] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(266),
  [537] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(267),
  [539] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(267),
  [541] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(268),
  [543] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(268),
  [545] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(264),
  [547] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true),
  [549] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(95),
  [551] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(274),
  [553] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(274),
  [555] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(275),
  [557] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(275),
  [559] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(278),
  [561] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(279),
  [563] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym__terminated_statement, 2),
  [565] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym__terminated_statement, 2),
  [567] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym__terminated_statement, 2),
  [569] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(284),
  [571] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(284),
  [573] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(285),
  [575] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(286),
  [577] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(287),
  [579] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(288),
  [581] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(289),
  [583] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(290),
  [585] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(291),
  [587] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(286),
  [589] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(293),
  [591] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(294),
  [593] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 1),
  [595] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 1),
  [597] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 2, .fragile = true),
  [599] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(296),
  [601] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 2),
  [603] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2),
  [605] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2),
  [607] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2),
  [609] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 2),
  [611] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat1, 2),
  [613] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 3),
  [615] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_file_redirect, 3),
  [617] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(301),
  [619] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(303),
  [621] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(304),
  [623] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(306),
  [625] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(306),
  [627] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(307),
  [629] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(309),
  [631] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(310),
  [633] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_environment_variable_assignment, 3),
  [635] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_environment_variable_assignment, 3),
  [637] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(318),
  [639] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(319),
  [641] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(321),
  [643] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(323),
  [645] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(325),
  [647] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(325),
  [649] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(326),
  [651] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(328),
  [653] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(329),
  [655] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(337),
  [657] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(338),
  [659] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(339),
  [661] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(340),
  [663] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(341),
  [665] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(342),
  [667] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(343),
  [669] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(338),
  [671] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(346),
  [673] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_while_statement, 3),
  [675] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(348),
  [677] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(349),
  [679] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(350),
  [681] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(355),
  [683] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(356),
  [685] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(356),
  [687] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(357),
  [689] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(358),
  [691] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(359),
  [693] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(360),
  [695] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(362),
  [697] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(363),
  [699] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(364),
  [701] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(364),
  [703] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(365),
  [705] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(366),
  [707] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(367),
  [709] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(367),
  [711] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(368),
  [713] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(369),
  [715] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(370),
  [717] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subshell, 3),
  [719] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(371),
  [721] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(371),
  [723] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(372),
  [725] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_string, 2),
  [727] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(373),
  [729] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(374),
  [731] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(374),
  [733] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(375),
  [735] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_concatenation, 2),
  [737] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_simple_expansion, 2, .rename_sequence_id = 1),
  [739] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_simple_expansion, 2),
  [741] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(376),
  [743] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(378),
  [745] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(379),
  [747] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(380),
  [749] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(380),
  [751] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(381),
  [753] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(382),
  [755] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(383),
  [757] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(383),
  [759] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(384),
  [761] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(385),
  [763] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_bracket_command, 3),
  [765] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [767] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [769] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [771] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(386),
  [773] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(387),
  [775] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(387),
  [777] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(388),
  [779] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(389),
  [781] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(391),
  [783] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(392),
  [785] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(393),
  [787] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(393),
  [789] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(394),
  [791] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(395),
  [793] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(396),
  [795] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(396),
  [797] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(397),
  [799] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(398),
  [801] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(399),
  [803] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(401),
  [805] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(402),
  [807] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(403),
  [809] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(403),
  [811] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(404),
  [813] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(405),
  [815] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(406),
  [817] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(406),
  [819] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(407),
  [821] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_string, 3),
  [823] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 3),
  [825] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2),
  [827] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_string_repeat1, 2),
  [829] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [831] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [833] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(408),
  [835] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(408),
  [837] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(409),
  [839] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(410),
  [841] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(411),
  [843] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(412),
  [845] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3, .rename_sequence_id = 2),
  [847] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3, .rename_sequence_id = 2),
  [849] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(413),
  [851] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(414),
  [853] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(414),
  [855] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3),
  [857] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3),
  [859] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(416),
  [861] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(417),
  [863] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(417),
  [865] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(419),
  [867] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(420),
  [869] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(421),
  [871] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(421),
  [873] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(422),
  [875] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(423),
  [877] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(425),
  [879] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(426),
  [881] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(427),
  [883] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(428),
  [885] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(429),
  [887] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(430),
  [889] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(433),
  [891] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(434),
  [893] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(435),
  [895] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(435),
  [897] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(436),
  [899] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(437),
  [901] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(439),
  [903] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(440),
  [905] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(441),
  [907] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(441),
  [909] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(442),
  [911] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(443),
  [913] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(444),
  [915] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(444),
  [917] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(445),
  [919] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(446),
  [921] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(447),
  [923] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3),
  [925] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3),
  [927] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(452),
  [929] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(452),
  [931] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(453),
  [933] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(454),
  [935] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(455),
  [937] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(456),
  [939] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(457),
  [941] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(458),
  [943] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(459),
  [945] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(454),
  [947] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(461),
  [949] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(462),
  [951] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat2, 1),
  [953] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 2, .fragile = true),
  [955] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 2, .fragile = true),
  [957] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(464),
  [959] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(464),
  [961] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 2),
  [963] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 2),
  [965] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_process_substitution, 3),
  [967] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_process_substitution, 3),
  [969] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(473),
  [971] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3, .fragile = true),
  [973] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_list, 3, .fragile = true),
  [975] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(475),
  [977] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(475),
  [979] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(477),
  [981] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(479),
  [983] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2),
  [985] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(481),
  [987] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(481),
  [989] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(482),
  [991] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(484),
  [993] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(485),
  [995] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 1),
  [997] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 1),
  [999] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(493),
  [1001] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(494),
  [1003] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(495),
  [1005] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(496),
  [1007] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc_redirect, 2),
  [1009] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc_redirect, 2),
  [1011] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 3),
  [1013] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2),
  [1015] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2),
  [1017] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 3, .fragile = true),
  [1019] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(499),
  [1021] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(500),
  [1023] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(500),
  [1025] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subscript, 4),
  [1027] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(501),
  [1029] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(502),
  [1031] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(504),
  [1033] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(505),
  [1035] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(506),
  [1037] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(506),
  [1039] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(507),
  [1041] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(508),
  [1043] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(509),
  [1045] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(509),
  [1047] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(510),
  [1049] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(511),
  [1051] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_array, 2),
  [1053] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_array, 2),
  [1055] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_array_repeat1, 1),
  [1057] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_array_repeat1, 1),
  [1059] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(512),
  [1061] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(513),
  [1063] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(514),
  [1065] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(515),
  [1067] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(515),
  [1069] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(516),
  [1071] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(517),
  [1073] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(519),
  [1075] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(520),
  [1077] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(521),
  [1079] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(521),
  [1081] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(522),
  [1083] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(523),
  [1085] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(524),
  [1087] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(524),
  [1089] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(525),
  [1091] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(526),
  [1093] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(527),
  [1095] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(529),
  [1097] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(531),
  [1099] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(531),
  [1101] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(532),
  [1103] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(534),
  [1105] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(535),
  [1107] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(543),
  [1109] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(337),
  [1111] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(544),
  [1113] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(339),
  [1115] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(340),
  [1117] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(341),
  [1119] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(342),
  [1121] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(343),
  [1123] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_do_group, 2),
  [1125] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(546),
  [1127] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 4),
  [1129] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_else_clause, 1),
  [1131] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_if_statement_repeat1, 1),
  [1133] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(549),
  [1135] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(549),
  [1137] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(349),
  [1139] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(350),
  [1141] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(553),
  [1143] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(554),
  [1145] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(554),
  [1147] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(558),
  [1149] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(559),
  [1151] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(559),
  [1153] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(560),
  [1155] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(561),
  [1157] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(562),
  [1159] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(563),
  [1161] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(564),
  [1163] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(565),
  [1165] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(565),
  [1167] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(567),
  [1169] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(568),
  [1171] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(568),
  [1173] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subshell, 4),
  [1175] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(571),
  [1177] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_string, 3),
  [1179] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1181] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(572),
  [1183] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(572),
  [1185] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(573),
  [1187] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(574),
  [1189] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(575),
  [1191] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(576),
  [1193] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 3, .rename_sequence_id = 2),
  [1195] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(577),
  [1197] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(578),
  [1199] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(578),
  [1201] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 3),
  [1203] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(580),
  [1205] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(581),
  [1207] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(581),
  [1209] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command_substitution, 3),
  [1211] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_process_substitution, 3),
  [1213] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(583),
  [1215] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(583),
  [1217] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(584),
  [1219] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(585),
  [1221] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(586),
  [1223] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(587),
  [1225] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(588),
  [1227] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(589),
  [1229] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(589),
  [1231] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(591),
  [1233] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(592),
  [1235] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(592),
  [1237] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(594),
  [1239] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(595),
  [1241] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(596),
  [1243] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(597),
  [1245] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(598),
  [1247] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(599),
  [1249] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(599),
  [1251] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(601),
  [1253] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(602),
  [1255] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(602),
  [1257] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 3),
  [1259] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 3),
  [1261] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .rename_sequence_id = 3),
  [1263] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .rename_sequence_id = 3),
  [1265] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(604),
  [1267] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4),
  [1269] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4),
  [1271] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(605),
  [1273] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(606),
  [1275] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(607),
  [1277] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(608),
  [1279] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(609),
  [1281] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_environment_variable_assignment, 3),
  [1283] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(610),
  [1285] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(613),
  [1287] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_while_statement, 3),
  [1289] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_while_statement, 3),
  [1291] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(615),
  [1293] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(619),
  [1295] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(620),
  [1297] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(621),
  [1299] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subshell, 3),
  [1301] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subshell, 3),
  [1303] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(622),
  [1305] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(622),
  [1307] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(623),
  [1309] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_bracket_command, 3),
  [1311] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_bracket_command, 3),
  [1313] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(624),
  [1315] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(624),
  [1317] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(625),
  [1319] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(626),
  [1321] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(627),
  [1323] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(628),
  [1325] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(629),
  [1327] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(630),
  [1329] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(630),
  [1331] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(632),
  [1333] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(633),
  [1335] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(633),
  [1337] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(635),
  [1339] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_pipeline, 3, .fragile = true),
  [1341] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3, .fragile = true),
  [1343] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_list, 3, .fragile = true),
  [1345] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_list, 3, .fragile = true),
  [1347] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(637),
  [1349] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(637),
  [1351] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(639),
  [1353] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(641),
  [1355] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(643),
  [1357] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(643),
  [1359] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(644),
  [1361] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(646),
  [1363] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(647),
  [1365] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc, 1),
  [1367] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(655),
  [1369] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc_redirect, 2),
  [1371] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 3),
  [1373] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 3),
  [1375] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat2, 2),
  [1377] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 3, .fragile = true),
  [1379] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 3, .fragile = true),
  [1381] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(658),
  [1383] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 4),
  [1385] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 3),
  [1387] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(660),
  [1389] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(661),
  [1391] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(661),
  [1393] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(662),
  [1395] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(663),
  [1397] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(665),
  [1399] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(666),
  [1401] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(667),
  [1403] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(667),
  [1405] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(668),
  [1407] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(669),
  [1409] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(670),
  [1411] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(670),
  [1413] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(671),
  [1415] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(672),
  [1417] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 1),
  [1419] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_heredoc_repeat1, 1),
  [1421] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 2),
  [1423] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 2),
  [1425] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(673),
  [1427] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(673),
  [1429] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(674),
  [1431] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(676),
  [1433] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(677),
  [1435] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(679),
  [1437] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(680),
  [1439] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 4),
  [1441] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(681),
  [1443] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(681),
  [1445] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(682),
  [1447] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(683),
  [1449] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(684),
  [1451] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(685),
  [1453] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(686),
  [1455] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(687),
  [1457] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(687),
  [1459] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(689),
  [1461] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(690),
  [1463] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(690),
  [1465] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_array, 3),
  [1467] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_array, 3),
  [1469] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_array_repeat1, 2),
  [1471] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_array_repeat1, 2),
  [1473] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(692),
  [1475] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(692),
  [1477] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(693),
  [1479] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(694),
  [1481] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(695),
  [1483] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(696),
  [1485] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(697),
  [1487] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(698),
  [1489] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(698),
  [1491] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(700),
  [1493] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(701),
  [1495] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(701),
  [1497] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(703),
  [1499] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(704),
  [1501] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(704),
  [1503] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(705),
  [1505] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(706),
  [1507] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(708),
  [1509] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(709),
  [1511] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(710),
  [1513] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(710),
  [1515] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(711),
  [1517] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(712),
  [1519] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(713),
  [1521] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(713),
  [1523] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(714),
  [1525] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(715),
  [1527] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_do_group, 3),
  [1529] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(717),
  [1531] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_else_clause, 2),
  [1533] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 5),
  [1535] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(718),
  [1537] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [1539] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 5),
  [1541] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(720),
  [1543] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(721),
  [1545] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_case_statement_repeat1, 1),
  [1547] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 1),
  [1549] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 1),
  [1551] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(723),
  [1553] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(726),
  [1555] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(727),
  [1557] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(728),
  [1559] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(729),
  [1561] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(730),
  [1563] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(731),
  [1565] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 5),
  [1567] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subshell, 5),
  [1569] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_concatenation_repeat1, 3),
  [1571] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 4, .rename_sequence_id = 3),
  [1573] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(732),
  [1575] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 4),
  [1577] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(733),
  [1579] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(734),
  [1581] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(735),
  [1583] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(736),
  [1585] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(737),
  [1587] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(738),
  [1589] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(739),
  [1591] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(740),
  [1593] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(741),
  [1595] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(742),
  [1597] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(743),
  [1599] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(744),
  [1601] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(745),
  [1603] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(746),
  [1605] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(747),
  [1607] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(748),
  [1609] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(749),
  [1611] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(750),
  [1613] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(751),
  [1615] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(752),
  [1617] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .rename_sequence_id = 4),
  [1619] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .rename_sequence_id = 4),
  [1621] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(753),
  [1623] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5),
  [1625] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5),
  [1627] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_array, 2),
  [1629] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(754),
  [1631] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(755),
  [1633] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_do_group, 2),
  [1635] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_do_group, 2),
  [1637] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(756),
  [1639] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 4),
  [1641] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 4),
  [1643] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(757),
  [1645] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(757),
  [1647] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(760),
  [1649] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(762),
  [1651] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subshell, 4),
  [1653] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subshell, 4),
  [1655] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(764),
  [1657] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(765),
  [1659] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(766),
  [1661] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(767),
  [1663] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(768),
  [1665] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(769),
  [1667] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(770),
  [1669] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(771),
  [1671] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 4),
  [1673] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 4),
  [1675] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(773),
  [1677] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(774),
  [1679] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(774),
  [1681] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(775),
  [1683] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(776),
  [1685] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(778),
  [1687] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(779),
  [1689] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(780),
  [1691] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(780),
  [1693] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(781),
  [1695] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(782),
  [1697] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(783),
  [1699] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(783),
  [1701] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(784),
  [1703] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(785),
  [1705] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc, 2),
  [1707] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(786),
  [1709] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 4),
  [1711] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 4),
  [1713] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 2),
  [1715] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(787),
  [1717] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(788),
  [1719] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(788),
  [1721] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(789),
  [1723] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(790),
  [1725] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(791),
  [1727] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(792),
  [1729] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(793),
  [1731] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(794),
  [1733] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(794),
  [1735] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(796),
  [1737] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(797),
  [1739] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(797),
  [1741] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(799),
  [1743] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(801),
  [1745] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(802),
  [1747] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(803),
  [1749] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(803),
  [1751] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(804),
  [1753] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(805),
  [1755] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(806),
  [1757] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(806),
  [1759] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 2),
  [1761] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_heredoc_repeat1, 2),
  [1763] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 3),
  [1765] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 3),
  [1767] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(807),
  [1769] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(808),
  [1771] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(809),
  [1773] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(810),
  [1775] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(811),
  [1777] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(812),
  [1779] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(813),
  [1781] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(814),
  [1783] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(815),
  [1785] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(816),
  [1787] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(817),
  [1789] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(818),
  [1791] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(819),
  [1793] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(819),
  [1795] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(820),
  [1797] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(821),
  [1799] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(822),
  [1801] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(823),
  [1803] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(824),
  [1805] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(825),
  [1807] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(825),
  [1809] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(827),
  [1811] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(828),
  [1813] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(828),
  [1815] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_for_statement, 6),
  [1817] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 3),
  [1819] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 6),
  [1821] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(831),
  [1823] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(832),
  [1825] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(832),
  [1827] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(834),
  [1829] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(836),
  [1831] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(837),
  [1833] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6),
  [1835] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_case_statement_repeat1, 2),
  [1837] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2),
  [1839] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2),
  [1841] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(838),
  [1843] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(839),
  [1845] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(840),
  [1847] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(841),
  [1849] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(842),
  [1851] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(843),
  [1853] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(844),
  [1855] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(845),
  [1857] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 5, .rename_sequence_id = 4),
  [1859] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(846),
  [1861] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 5),
  [1863] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(847),
  [1865] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(848),
  [1867] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(849),
  [1869] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(850),
  [1871] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(851),
  [1873] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(852),
  [1875] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(853),
  [1877] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(854),
  [1879] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(855),
  [1881] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(856),
  [1883] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6, .rename_sequence_id = 5),
  [1885] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6, .rename_sequence_id = 5),
  [1887] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6),
  [1889] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6),
  [1891] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_array, 3),
  [1893] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_do_group, 3),
  [1895] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_do_group, 3),
  [1897] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 5),
  [1899] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 5),
  [1901] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(858),
  [1903] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 5),
  [1905] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 5),
  [1907] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(860),
  [1909] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 5),
  [1911] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 5),
  [1913] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subshell, 5),
  [1915] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subshell, 5),
  [1917] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(862),
  [1919] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(863),
  [1921] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(864),
  [1923] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(865),
  [1925] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_compound_statement, 2),
  [1927] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 2),
  [1929] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(866),
  [1931] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(867),
  [1933] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(867),
  [1935] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(868),
  [1937] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(869),
  [1939] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(870),
  [1941] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(871),
  [1943] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(872),
  [1945] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(873),
  [1947] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(873),
  [1949] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(875),
  [1951] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(876),
  [1953] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(876),
  [1955] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc, 3),
  [1957] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 3),
  [1959] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(878),
  [1961] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(879),
  [1963] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(880),
  [1965] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(881),
  [1967] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(882),
  [1969] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(883),
  [1971] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(884),
  [1973] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(885),
  [1975] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(886),
  [1977] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(887),
  [1979] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(888),
  [1981] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(889),
  [1983] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(889),
  [1985] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(891),
  [1987] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(892),
  [1989] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(892),
  [1991] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(894),
  [1993] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(895),
  [1995] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(896),
  [1997] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(897),
  [1999] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(898),
  [2001] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(899),
  [2003] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(900),
  [2005] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(901),
  [2007] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(902),
  [2009] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(903),
  [2011] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(904),
  [2013] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(905),
  [2015] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(906),
  [2017] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(907),
  [2019] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 4),
  [2021] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 7),
  [2023] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_item_repeat1, 2),
  [2025] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 3),
  [2027] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 3),
  [2029] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 3),
  [2031] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(908),
  [2033] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(909),
  [2035] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(909),
  [2037] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 7),
  [2039] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(912),
  [2041] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(913),
  [2043] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(914),
  [2045] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(915),
  [2047] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 6, .rename_sequence_id = 5),
  [2049] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 6),
  [2051] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(916),
  [2053] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(917),
  [2055] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(918),
  [2057] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(919),
  [2059] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 7, .rename_sequence_id = 6),
  [2061] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 7, .rename_sequence_id = 6),
  [2063] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 7),
  [2065] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 7),
  [2067] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_for_statement, 6),
  [2069] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_for_statement, 6),
  [2071] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 6),
  [2073] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 6),
  [2075] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(920),
  [2077] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 6),
  [2079] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6),
  [2081] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(921),
  [2083] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(922),
  [2085] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(923),
  [2087] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_compound_statement, 3),
  [2089] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 3),
  [2091] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(924),
  [2093] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(925),
  [2095] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(926),
  [2097] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(927),
  [2099] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(928),
  [2101] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(929),
  [2103] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(930),
  [2105] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(931),
  [2107] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(932),
  [2109] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(933),
  [2111] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(934),
  [2113] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(935),
  [2115] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(936),
  [2117] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(937),
  [2119] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(938),
  [2121] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(939),
  [2123] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(940),
  [2125] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(941),
  [2127] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(942),
  [2129] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(943),
  [2131] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(944),
  [2133] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(945),
  [2135] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(946),
  [2137] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(947),
  [2139] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 4),
  [2141] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 4),
  [2143] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 4),
  [2145] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_item_repeat1, 3),
  [2147] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(948),
  [2149] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 7, .rename_sequence_id = 6),
  [2151] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 7),
  [2153] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 7),
  [2155] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 7),
  [2157] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 7),
  [2159] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 7),
  [2161] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(949),
  [2163] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(950),
  [2165] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(951),
  [2167] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(952),
  [2169] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(953),
  [2171] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(954),
  [2173] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(955),
  [2175] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(956),
  [2177] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(957),
  [2179] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(958),
  [2181] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(959),
  [2183] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(960),
  [2185] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 5),
  [2187] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 5),
  [2189] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 5),
  [2191] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(961),
  [2193] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(962),
  [2195] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(963),
  [2197] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(964),
  [2199] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1027),
  [2201] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1028),
  [2203] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(338),
  [2205] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1031),
  [2207] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_do_group, 2), REDUCE(sym_do_group, 3),
  [2210] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 3), SHIFT(1034),
  [2213] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 3), SHIFT(349),
  [2216] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 3), SHIFT(350),
  [2219] = {.count = 4, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 4), REDUCE(sym_if_statement, 5), REDUCE(sym_if_statement, 6), REDUCE(sym_if_statement, 7),
  [2224] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1038),
  [2226] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1038),
  [2228] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 5), REDUCE(sym_case_statement, 6), REDUCE(sym_case_statement, 7),
  [2232] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(965),
  [2234] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(967),
  [2236] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(970),
  [2238] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(973),
  [2240] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(977),
  [2242] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1040),
  [2244] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1041),
  [2246] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1042),
  [2248] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1043),
  [2250] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1044),
  [2252] = {.count = 5, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_array, 2), REDUCE(sym_array, 3), REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 3), SHIFT(2),
  [2258] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 3),
  [2261] = {.count = 5, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_array, 2), REDUCE(sym_array, 3), REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 3), SHIFT(3),
  [2267] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 3),
  [2270] = {.count = 7, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_array, 2), REDUCE(sym_subshell, 3), REDUCE(sym_array, 3), REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 3), REDUCE(sym_subshell, 4), REDUCE(sym_subshell, 5),
  [2278] = {.count = 8, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_array, 2), REDUCE(sym_subshell, 3), REDUCE(sym_array, 3), REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 3), REDUCE(sym_subshell, 4), REDUCE(sym_subshell, 5), SHIFT(1049),
  [2287] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(9),
  [2289] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(979),
  [2291] = {.count = 5, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_array, 2), REDUCE(sym_array, 3), REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 3), SHIFT(12),
  [2297] = {.count = 5, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_array, 2), REDUCE(sym_array, 3), REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 3), SHIFT(13),
  [2303] = {.count = 5, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_array, 2), REDUCE(sym_array, 3), REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 3), SHIFT(14),
  [2309] = {.count = 5, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_array, 2), REDUCE(sym_array, 3), REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 3), SHIFT(15),
  [2315] = {.count = 5, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_array, 2), REDUCE(sym_array, 3), REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 3), SHIFT(16),
  [2321] = {.count = 5, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_array, 2), REDUCE(sym_array, 3), REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 3), SHIFT(17),
  [2327] = {.count = 8, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_array, 2), REDUCE(sym_subshell, 3), REDUCE(sym_array, 3), REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 3), REDUCE(sym_subshell, 4), REDUCE(sym_subshell, 5), SHIFT(18),
  [2336] = {.count = 5, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_array, 2), REDUCE(sym_array, 3), REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 3), SHIFT(19),
  [2342] = {.count = 5, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_array, 2), REDUCE(sym_array, 3), REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 3), SHIFT(20),
  [2348] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1051),
  [2350] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1052),
  [2352] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1053),
  [2354] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1057),
  [2356] = {.count = 10, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3), REDUCE(sym_expansion, 3, .rename_sequence_id = 2), REDUCE(sym_expansion, 4), REDUCE(sym_expansion, 4, .rename_sequence_id = 3), REDUCE(sym_expansion, 5), REDUCE(sym_expansion, 5, .rename_sequence_id = 4), REDUCE(sym_expansion, 6), REDUCE(sym_expansion, 6, .rename_sequence_id = 5), REDUCE(sym_expansion, 7), REDUCE(sym_expansion, 7, .rename_sequence_id = 6),
  [2367] = {.count = 10, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3), REDUCE(sym_expansion, 3, .rename_sequence_id = 2), REDUCE(sym_expansion, 4), REDUCE(sym_expansion, 4, .rename_sequence_id = 3), REDUCE(sym_expansion, 5), REDUCE(sym_expansion, 5, .rename_sequence_id = 4), REDUCE(sym_expansion, 6), REDUCE(sym_expansion, 6, .rename_sequence_id = 5), REDUCE(sym_expansion, 7), REDUCE(sym_expansion, 7, .rename_sequence_id = 6),
  [2378] = {.count = 12, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 2), REDUCE(sym_compound_statement, 3), REDUCE(sym_expansion, 3), REDUCE(sym_expansion, 3, .rename_sequence_id = 2), REDUCE(sym_expansion, 4), REDUCE(sym_expansion, 4, .rename_sequence_id = 3), REDUCE(sym_expansion, 5), REDUCE(sym_expansion, 5, .rename_sequence_id = 4), REDUCE(sym_expansion, 6), REDUCE(sym_expansion, 6, .rename_sequence_id = 5), REDUCE(sym_expansion, 7), REDUCE(sym_expansion, 7, .rename_sequence_id = 6),
  [2391] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1059),
  [2393] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1060),
  [2395] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1059),
  [2397] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1063),
  [2399] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subscript, 4),
  [2401] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1064),
  [2403] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1065),
  [2405] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1066),
  [2407] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1067),
  [2409] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1068),
  [2411] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1069),
  [2413] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1070),
  [2415] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1065),
  [2417] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1072),
  [2419] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1073),
  [2421] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1074),
  [2423] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1075),
  [2425] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1076),
  [2427] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1077),
  [2429] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1078),
  [2431] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1073),
  [2433] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_string, 2), REDUCE(sym_string, 3),
  [2436] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 2), REDUCE(sym_string, 3),
  [2439] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 2), REDUCE(sym_string, 3), SHIFT(1080),
  [2443] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(70),
  [2445] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 2), REDUCE(sym_string, 3), SHIFT(71),
  [2449] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 2), REDUCE(sym_string, 3), SHIFT(72),
  [2453] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 2), REDUCE(sym_string, 3), SHIFT(73),
  [2457] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 2), REDUCE(sym_string, 3), SHIFT(74),
  [2461] = {.count = 8, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1), REDUCE(aux_sym_for_statement_repeat1, 1), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_for_statement_repeat1, 2), REDUCE(aux_sym_concatenation_repeat1, 2), REDUCE(sym_environment_variable_assignment, 3), REDUCE(sym_file_redirect, 3), REDUCE(aux_sym_concatenation_repeat1, 3),
  [2470] = {.count = 3, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), REDUCE(aux_sym_concatenation_repeat1, 3), SHIFT(1081),
  [2474] = {.count = 5, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_concatenation_repeat1, 2), REDUCE(sym_environment_variable_assignment, 3), REDUCE(sym_file_redirect, 3), REDUCE(aux_sym_concatenation_repeat1, 3),
  [2480] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), REDUCE(aux_sym_concatenation_repeat1, 3), SHIFT(1082),
  [2484] = {.count = 11, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1), REDUCE(aux_sym_for_statement_repeat1, 1), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_for_statement_repeat1, 2), REDUCE(aux_sym_case_item_repeat1, 2), REDUCE(aux_sym_concatenation_repeat1, 2), REDUCE(sym_environment_variable_assignment, 3), REDUCE(sym_file_redirect, 3), REDUCE(aux_sym_case_item_repeat1, 3), REDUCE(aux_sym_concatenation_repeat1, 3), SHIFT(720),
  [2496] = {.count = 11, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1), REDUCE(aux_sym_for_statement_repeat1, 1), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_for_statement_repeat1, 2), REDUCE(aux_sym_case_item_repeat1, 2), REDUCE(aux_sym_concatenation_repeat1, 2), REDUCE(sym_environment_variable_assignment, 3), REDUCE(sym_file_redirect, 3), REDUCE(aux_sym_case_item_repeat1, 3), REDUCE(aux_sym_concatenation_repeat1, 3), SHIFT(721),
  [2508] = {.count = 9, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1), REDUCE(aux_sym_for_statement_repeat1, 1), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_for_statement_repeat1, 2), REDUCE(aux_sym_concatenation_repeat1, 2), REDUCE(sym_environment_variable_assignment, 3), REDUCE(sym_file_redirect, 3), REDUCE(aux_sym_concatenation_repeat1, 3), SHIFT(1083),
  [2518] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), REDUCE(aux_sym_concatenation_repeat1, 3), SHIFT(1084),
  [2522] = {.count = 8, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1), REDUCE(aux_sym_for_statement_repeat1, 1), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_for_statement_repeat1, 2), REDUCE(aux_sym_concatenation_repeat1, 2), REDUCE(sym_environment_variable_assignment, 3), REDUCE(sym_file_redirect, 3), REDUCE(aux_sym_concatenation_repeat1, 3),
  [2531] = {.count = 5, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 1), REDUCE(aux_sym_for_statement_repeat1, 2), REDUCE(aux_sym_concatenation_repeat1, 2), REDUCE(aux_sym_concatenation_repeat1, 3), SHIFT(304),
  [2537] = {.count = 4, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 1), REDUCE(aux_sym_for_statement_repeat1, 2), REDUCE(aux_sym_concatenation_repeat1, 2), REDUCE(aux_sym_concatenation_repeat1, 3),
  [2542] = {.count = 7, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1), REDUCE(aux_sym_for_statement_repeat1, 1), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_for_statement_repeat1, 2), REDUCE(aux_sym_concatenation_repeat1, 2), REDUCE(sym_file_redirect, 3), REDUCE(aux_sym_concatenation_repeat1, 3),
  [2550] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_special_variable_name, 1), SHIFT(1085),
  [2553] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1085),
  [2555] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1086),
  [2557] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_special_variable_name, 1), SHIFT(81),
  [2560] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1088),
  [2562] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_special_variable_name, 1), SHIFT(1090),
  [2565] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1091),
  [2567] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1091),
  [2569] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), SHIFT(2),
  [2572] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), SHIFT(85),
  [2575] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(91),
  [2577] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), SHIFT(12),
  [2580] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), SHIFT(94),
  [2583] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), SHIFT(95),
  [2586] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), SHIFT(96),
  [2589] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), SHIFT(97),
  [2592] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), SHIFT(98),
  [2595] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), SHIFT(99),
  [2598] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), SHIFT(100),
  [2601] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3), SHIFT(101),
  [2604] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1097),
  [2606] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym__terminated_statement, 2), SHIFT(968),
  [2609] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1098),
  [2611] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1099),
  [2613] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym__terminated_statement, 2), SHIFT(131),
  [2616] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym__terminated_statement, 2), SHIFT(554),
  [2619] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym__terminated_statement, 2), SHIFT(133),
  [2622] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym__terminated_statement, 2), SHIFT(134),
  [2625] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym__terminated_statement, 2), SHIFT(135),
  [2628] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym__terminated_statement, 2), SHIFT(136),
  [2631] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym__terminated_statement, 2), SHIFT(137),
  [2634] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym__terminated_statement, 2), SHIFT(554),
  [2637] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1101),
  [2639] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 1), REDUCE(aux_sym_heredoc_repeat1, 2),
  [2642] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_heredoc_repeat1, 1), REDUCE(aux_sym_heredoc_repeat1, 2),
  [2645] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 2), REDUCE(sym_heredoc, 3),
  [2648] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 2), REDUCE(sym_heredoc, 3),
  [2651] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1102),
  [2653] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1102),
  [2655] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1103),
  [2657] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1104),
  [2659] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1105),
  [2661] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1106),
  [2663] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1107),
  [2665] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1108),
  [2667] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(993),
  [2669] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1104),
  [2671] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 1), REDUCE(aux_sym_program_repeat1, 2),
  [2674] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 1), REDUCE(aux_sym_program_repeat1, 2),
  [2677] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(968),
  [2679] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(971),
  [2681] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 1), REDUCE(aux_sym_program_repeat1, 2),
  [2684] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3, .fragile = true), REDUCE(sym_list, 3, .fragile = true), SHIFT(1110),
  [2688] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3, .fragile = true), REDUCE(sym_list, 3, .fragile = true), SHIFT(1111),
  [2692] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3, .fragile = true), REDUCE(sym_list, 3, .fragile = true), SHIFT(1112),
  [2696] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3, .fragile = true), REDUCE(sym_list, 3, .fragile = true), SHIFT(1113),
  [2700] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3, .fragile = true), REDUCE(sym_list, 3, .fragile = true), SHIFT(1114),
  [2704] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_while_statement, 3), REDUCE(sym_for_statement, 6),
  [2707] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_if_statement_repeat1, 1), REDUCE(aux_sym_if_statement_repeat1, 2),
  [2710] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1115),
  [2712] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_case_statement_repeat1, 1), REDUCE(aux_sym_case_statement_repeat1, 2),
  [2715] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 1), REDUCE(aux_sym_case_statement_repeat1, 2),
  [2718] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 1), REDUCE(aux_sym_case_statement_repeat1, 2),
  [2721] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 4), REDUCE(sym_function_definition, 5),
  [2724] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1116),
  [2726] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 1, .fragile = true), REDUCE(sym_command, 2, .fragile = true),
  [2729] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1117),
  [2731] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1118),
  [2733] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 1, .fragile = true), REDUCE(sym_command, 2, .fragile = true), SHIFT(18),
  [2737] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true), REDUCE(aux_sym_command_repeat1, 2),
  [2740] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true), REDUCE(aux_sym_command_repeat1, 2),
  [2743] = {.count = 5, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true), REDUCE(aux_sym_command_repeat1, 2), REDUCE(sym_pipeline, 3, .fragile = true), REDUCE(sym_list, 3, .fragile = true), SHIFT(1114),
  [2749] = {.count = 4, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1), REDUCE(aux_sym_command_repeat2, 1), REDUCE(aux_sym_command_repeat1, 2), REDUCE(aux_sym_command_repeat2, 2),
  [2754] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1), REDUCE(aux_sym_command_repeat1, 2),
  [2757] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 1), REDUCE(aux_sym_command_repeat2, 2),
  [2760] = {.count = 4, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1), REDUCE(aux_sym_command_repeat2, 1), REDUCE(aux_sym_command_repeat1, 2), REDUCE(aux_sym_command_repeat2, 2),
  [2765] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1), REDUCE(aux_sym_command_repeat1, 2),
  [2768] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 1), REDUCE(aux_sym_command_repeat2, 2),
  [2771] = {.count = 6, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1), REDUCE(aux_sym_for_statement_repeat1, 1), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_for_statement_repeat1, 2), REDUCE(sym_environment_variable_assignment, 3), REDUCE(sym_file_redirect, 3),
  [2778] = {.count = 3, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2), REDUCE(sym_environment_variable_assignment, 3), REDUCE(sym_file_redirect, 3),
  [2782] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1082),
  [2784] = {.count = 9, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1), REDUCE(aux_sym_for_statement_repeat1, 1), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_for_statement_repeat1, 2), REDUCE(aux_sym_case_item_repeat1, 2), REDUCE(sym_environment_variable_assignment, 3), REDUCE(sym_file_redirect, 3), REDUCE(aux_sym_case_item_repeat1, 3), SHIFT(720),
  [2794] = {.count = 9, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1), REDUCE(aux_sym_for_statement_repeat1, 1), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_for_statement_repeat1, 2), REDUCE(aux_sym_case_item_repeat1, 2), REDUCE(sym_environment_variable_assignment, 3), REDUCE(sym_file_redirect, 3), REDUCE(aux_sym_case_item_repeat1, 3), SHIFT(721),
  [2804] = {.count = 7, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1), REDUCE(aux_sym_for_statement_repeat1, 1), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_for_statement_repeat1, 2), REDUCE(sym_environment_variable_assignment, 3), REDUCE(sym_file_redirect, 3), SHIFT(1083),
  [2812] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1084),
  [2814] = {.count = 6, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1), REDUCE(aux_sym_for_statement_repeat1, 1), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_for_statement_repeat1, 2), REDUCE(sym_environment_variable_assignment, 3), REDUCE(sym_file_redirect, 3),
  [2821] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 1), REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT(304),
  [2825] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 1), REDUCE(aux_sym_for_statement_repeat1, 2),
  [2828] = {.count = 5, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1), REDUCE(aux_sym_for_statement_repeat1, 1), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_for_statement_repeat1, 2), REDUCE(sym_file_redirect, 3),
  [2834] = {.count = 10, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1), REDUCE(aux_sym_for_statement_repeat1, 1), REDUCE(aux_sym_string_repeat1, 1), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_for_statement_repeat1, 2), REDUCE(aux_sym_concatenation_repeat1, 2), REDUCE(aux_sym_string_repeat1, 2), REDUCE(sym_environment_variable_assignment, 3), REDUCE(sym_file_redirect, 3), REDUCE(aux_sym_concatenation_repeat1, 3),
  [2845] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 1), REDUCE(aux_sym_string_repeat1, 2),
  [2848] = {.count = 12, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1), REDUCE(aux_sym_for_statement_repeat1, 1), REDUCE(aux_sym_heredoc_repeat1, 1), REDUCE(aux_sym_string_repeat1, 1), REDUCE(sym_file_redirect, 2), REDUCE(aux_sym_for_statement_repeat1, 2), REDUCE(aux_sym_heredoc_repeat1, 2), REDUCE(aux_sym_concatenation_repeat1, 2), REDUCE(aux_sym_string_repeat1, 2), REDUCE(sym_environment_variable_assignment, 3), REDUCE(sym_file_redirect, 3), REDUCE(aux_sym_concatenation_repeat1, 3),
  [2861] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2), SHIFT(1122),
  [2864] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1123),
  [2866] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1124),
  [2868] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1124),
  [2870] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1125),
  [2872] = {.count = 3, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_else_clause, 2), REDUCE(sym_elif_clause, 4), SHIFT(1126),
  [2876] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 4), SHIFT(349),
  [2879] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 4), SHIFT(350),
  [2882] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1127),
  [2884] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1128),
  [2886] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 2, .fragile = true), REDUCE(sym_command, 3, .fragile = true),
  [2889] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 2, .fragile = true), REDUCE(sym_command, 3, .fragile = true), SHIFT(1133),
  [2893] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(983),
  [2895] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1134),
  [2897] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1135),
  [2899] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1136),
  [2901] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1137),
  [2903] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1138),
  [2905] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 2, .fragile = true), REDUCE(sym_command, 3, .fragile = true), SHIFT(1139),
  [2909] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1140),
  [2911] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1143),
  [2913] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1145),
  [2915] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 2), REDUCE(sym_command, 3), REDUCE(sym_command, 4),
  [2919] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1148),
  [2921] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1149),
  [2923] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1150),
  [2925] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1151),
  [2927] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1133),
  [2929] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(968),
  [2931] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1152),
  [2933] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1126),
  [2935] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 4), SHIFT(1126),
  [2938] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1083),
  [2940] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1), REDUCE(aux_sym_case_item_repeat1, 2), REDUCE(aux_sym_case_item_repeat1, 3),
  [2944] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1154),
  [2946] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3, .fragile = true), SHIFT(1110),
  [2949] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3, .fragile = true), SHIFT(1113),
  [2952] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 1, .fragile = true), SHIFT(18),
  [2955] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true), REDUCE(sym_pipeline, 3, .fragile = true),
  [2958] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 3), REDUCE(sym_case_item, 4),
  [2961] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 3), REDUCE(sym_case_item, 4),
  [2964] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 3), REDUCE(sym_case_item, 4),
  [2967] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1157),
  [2969] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1), REDUCE(aux_sym_array_repeat1, 1),
  [2972] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1158),
  [2974] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1159),
  [2976] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 1), SHIFT(304),
  [2979] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1090),
  [2981] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(983),
  [2983] = {.count = 4, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6), REDUCE(sym_expansion, 6, .rename_sequence_id = 5), REDUCE(sym_expansion, 7), REDUCE(sym_expansion, 7, .rename_sequence_id = 6),
  [2988] = {.count = 4, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6), REDUCE(sym_expansion, 6, .rename_sequence_id = 5), REDUCE(sym_expansion, 7), REDUCE(sym_expansion, 7, .rename_sequence_id = 6),
  [2993] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1160),
  [2995] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1162),
  [2997] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1164),
  [2999] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1164),
  [3001] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1165),
  [3003] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1167),
  [3005] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1168),
  [3007] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1176),
  [3009] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2), REDUCE(sym_file_redirect, 3),
  [3012] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1178),
  [3014] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2), REDUCE(sym_file_redirect, 3),
  [3017] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1180),
  [3019] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1180),
  [3021] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1181),
  [3023] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1183),
  [3025] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1184),
  [3027] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1192),
  [3029] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1192),
  [3031] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1193),
  [3033] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1097),
  [3035] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5), REDUCE(sym_expansion, 5, .rename_sequence_id = 4),
  [3038] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5), REDUCE(sym_expansion, 5, .rename_sequence_id = 4),
  [3041] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1194),
  [3043] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1195),
  [3045] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1196),
  [3047] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1197),
  [3049] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1063),
  [3051] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1084),
  [3053] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1114),
  [3055] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true), SHIFT(1114),
  [3058] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1198),
  [3060] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1199),
  [3062] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 5), REDUCE(sym_case_statement, 6),
  [3065] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subshell, 4), REDUCE(sym_subshell, 5),
  [3068] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1200),
  [3070] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1200),
  [3072] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1080),
  [3074] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), REDUCE(aux_sym_concatenation_repeat1, 3),
  [3077] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), REDUCE(aux_sym_concatenation_repeat1, 3),
  [3080] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1202),
  [3082] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1202),
  [3084] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1203),
  [3086] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1205),
  [3088] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1206),
  [3090] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1212),
  [3092] = {.count = 4, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subshell, 3), REDUCE(sym_command_substitution, 3), REDUCE(sym_process_substitution, 3), REDUCE(sym_subshell, 4),
  [3097] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 5), REDUCE(sym_if_statement, 6), REDUCE(sym_if_statement, 7),
  [3101] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1215),
  [3103] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1215),
  [3105] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1216),
  [3107] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1217),
  [3109] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1218),
  [3111] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1219),
  [3113] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1220),
  [3115] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1221),
  [3117] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1222),
  [3119] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1217),
  [3121] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(996),
  [3123] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(997),
  [3125] = {.count = 3, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 2, .fragile = true), REDUCE(sym_command, 3, .fragile = true), SHIFT(18),
  [3129] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 2), REDUCE(sym_command, 3),
  [3132] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3), REDUCE(sym_expansion, 4),
  [3135] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3), REDUCE(sym_expansion, 4),
  [3138] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1224),
  [3140] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1225),
  [3142] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1225),
  [3144] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 4), REDUCE(sym_case_item, 5),
  [3147] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 4), REDUCE(sym_case_item, 5),
  [3150] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 4), REDUCE(sym_case_item, 5),
  [3153] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1227),
  [3155] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1228),
  [3157] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1229),
  [3159] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1231),
  [3161] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1233),
  [3163] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1235),
  [3165] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1235),
  [3167] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1236),
  [3169] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1238),
  [3171] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1239),
  [3173] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 3), REDUCE(sym_command, 4),
  [3176] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 5), REDUCE(sym_if_statement, 6),
  [3179] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1247),
  [3181] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6), REDUCE(sym_case_statement, 7),
  [3184] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 2, .fragile = true), SHIFT(18),
  [3187] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1250),
  [3189] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1250),
  [3191] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1034),
  [3193] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1252),
  [3195] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1253),
  [3197] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1227),
  [3199] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1254),
  [3201] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1255),
  [3203] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1255),
  [3205] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1256),
  [3207] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1257),
  [3209] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1259),
  [3211] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1260),
  [3213] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1261),
  [3215] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1261),
  [3217] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1262),
  [3219] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1263),
  [3221] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1264),
  [3223] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1264),
  [3225] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1265),
  [3227] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true), SHIFT(1265),
  [3230] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1266),
  [3232] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1267),
  [3234] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1268),
  [3236] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1268),
  [3238] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1269),
  [3240] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1270),
  [3242] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1272),
  [3244] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1273),
  [3246] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1274),
  [3248] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1274),
  [3250] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1275),
  [3252] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1276),
  [3254] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1277),
  [3256] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1277),
  [3258] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1278),
  [3260] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true), SHIFT(1278),
  [3263] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1279),
  [3265] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1280),
  [3267] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1282),
  [3269] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1283),
  [3271] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1284),
  [3273] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1286),
  [3275] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1288),
  [3277] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1289),
  [3279] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1290),
  [3281] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1290),
  [3283] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1291),
  [3285] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1292),
  [3287] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1293),
  [3289] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1293),
  [3291] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1294),
  [3293] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true), SHIFT(1294),
  [3296] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_list, 3, .fragile = true), SHIFT(1110),
  [3299] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_list, 3, .fragile = true), SHIFT(1113),
  [3302] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true), REDUCE(sym_list, 3, .fragile = true),
  [3305] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1295),
  [3307] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1295),
  [3309] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1297),
  [3311] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1299),
  [3313] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1301),
  [3315] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1301),
  [3317] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1302),
  [3319] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1304),
  [3321] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1305),
  [3323] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1313),
  [3325] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1314),
  [3327] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1315),
  [3329] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1316),
  [3331] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1317),
  [3333] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1134),
  [3335] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1318),
  [3337] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1136),
  [3339] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1137),
  [3341] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1138),
  [3343] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1139),
  [3345] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1140),
  [3347] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1318),
  [3349] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1319),
  [3351] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1320),
  [3353] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1322),
  [3355] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1323),
  [3357] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1324),
  [3359] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1324),
  [3361] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1325),
  [3363] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1326),
  [3365] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1327),
  [3367] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1327),
  [3369] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1328),
  [3371] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true), SHIFT(1328),
  [3374] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1329),
  [3376] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 6), REDUCE(sym_if_statement, 7),
  [3379] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 3, .fragile = true), SHIFT(18),
  [3382] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1126),
  [3384] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(979),
  [3386] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1333),
  [3388] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1333),
  [3390] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1334),
  [3392] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1335),
  [3394] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1336),
  [3396] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1337),
  [3398] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1338),
  [3400] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1339),
  [3402] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1339),
  [3404] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1341),
  [3406] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1342),
  [3408] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1342),
  [3410] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1344),
  [3412] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1344),
  [3414] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1345),
  [3416] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1346),
  [3418] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1347),
  [3420] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1348),
  [3422] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1349),
  [3424] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1350),
  [3426] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1350),
  [3428] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1352),
  [3430] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1353),
  [3432] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1353),
  [3434] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1355),
  [3436] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1356),
  [3438] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1357),
  [3440] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1358),
  [3442] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1359),
  [3444] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1360),
  [3446] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1361),
  [3448] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1362),
  [3450] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1363),
  [3452] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1363),
  [3454] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1365),
  [3456] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1366),
  [3458] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1366),
  [3460] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1368),
  [3462] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1369),
  [3464] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1369),
  [3466] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1370),
  [3468] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1371),
  [3470] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1373),
  [3472] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1374),
  [3474] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1375),
  [3476] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1375),
  [3478] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1376),
  [3480] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1377),
  [3482] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1378),
  [3484] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1378),
  [3486] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1379),
  [3488] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true), SHIFT(1379),
  [3491] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1380),
  [3493] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1381),
  [3495] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1382),
  [3497] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1382),
  [3499] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1383),
  [3501] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1384),
  [3503] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1385),
  [3505] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1386),
  [3507] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1387),
  [3509] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1388),
  [3511] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1388),
  [3513] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1390),
  [3515] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1391),
  [3517] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1391),
  [3519] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1393),
  [3521] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1394),
  [3523] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1395),
  [3525] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1396),
  [3527] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1397),
  [3529] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1398),
  [3531] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1399),
  [3533] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1400),
  [3535] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1401),
  [3537] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1402),
  [3539] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1403),
  [3541] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1404),
  [3543] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1405),
  [3545] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1406),
  [3547] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1407),
  [3549] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1408),
  [3551] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1409),
  [3553] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1410),
  [3555] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1411),
  [3557] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1412),
  [3559] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1413),
  [3561] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1413),
  [3563] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1414),
  [3565] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1415),
  [3567] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1416),
  [3569] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1417),
  [3571] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1418),
  [3573] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1419),
  [3575] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1419),
  [3577] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1421),
  [3579] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1422),
  [3581] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1422),
  [3583] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6), REDUCE(sym_expansion, 7),
  [3586] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6), REDUCE(sym_expansion, 7),
  [3589] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1424),
  [3591] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1425),
  [3593] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1426),
  [3595] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1427),
  [3597] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1428),
  [3599] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1429),
  [3601] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1430),
  [3603] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1431),
  [3605] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1432),
  [3607] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1433),
  [3609] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1434),
  [3611] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1435),
  [3613] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1436),
  [3615] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1437),
  [3617] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1438),
  [3619] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1439),
  [3621] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1440),
  [3623] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1441),
  [3625] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1442),
  [3627] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1443),
  [3629] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1444),
  [3631] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1445),
  [3633] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1446),
  [3635] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1447),
  [3637] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1448),
  [3639] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1449),
  [3641] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1450),
  [3643] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1451),
  [3645] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1452),
  [3647] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1453),
  [3649] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1454),
  [3651] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1455),
  [3653] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1456),
  [3655] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1457),
  [3657] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1458),
  [3659] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1459),
  [3661] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1460),
  [3663] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1461),
  [3665] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1462),
  [3667] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1463),
  [3669] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1464),
  [3671] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1465),
};

void *tree_sitter_bash_external_scanner_create();
void tree_sitter_bash_external_scanner_destroy();
void tree_sitter_bash_external_scanner_reset(void *);
bool tree_sitter_bash_external_scanner_scan(void *, TSLexer *, const bool *);
bool tree_sitter_bash_external_scanner_serialize(void *, TSExternalTokenState);
void tree_sitter_bash_external_scanner_deserialize(void *, const TSExternalTokenState);

const TSLanguage *tree_sitter_bash() {
  GET_LANGUAGE(
    (const bool *)ts_external_scanner_states,
    ts_external_scanner_symbol_map,
    tree_sitter_bash_external_scanner_create,
    tree_sitter_bash_external_scanner_destroy,
    tree_sitter_bash_external_scanner_reset,
    tree_sitter_bash_external_scanner_scan,
    tree_sitter_bash_external_scanner_serialize,
    tree_sitter_bash_external_scanner_deserialize,
  );
}
